# dtFFT - DataTyped Fast Fourier Transform

[![Status](https://img.shields.io/badge/status-stable-brightgreen.svg)](https://github.com/ShatrovOA/dtFFT/releases)
[![codecov](https://codecov.io/gh/ShatrovOA/dtFFT/graph/badge.svg?token=6BI4AQVH7Z)](https://codecov.io/gh/ShatrovOA/dtFFT)
[![License](https://img.shields.io/github/license/ShatrovOA/dtFFT?color=brightgreen&logo=License)](https://github.com/ShatrovOA/dtFFT/blob/main/LICENSE)
[![Linux GNU tests](https://github.com/ShatrovOA/dtFFT/actions/workflows/gnu_linux.yml/badge.svg)](https://github.com/ShatrovOA/dtFFT/actions/workflows/gnu_linux.yml)
[![Macos GNU tests](https://github.com/ShatrovOA/dtFFT/actions/workflows/gnu_macos.yml/badge.svg)](https://github.com/ShatrovOA/dtFFT/actions/workflows/gnu_macos.yml)
[![HPC-SDK tests](https://github.com/ShatrovOA/dtFFT/actions/workflows/hpc_sdk_linux.yml/badge.svg)](https://github.com/ShatrovOA/dtFFT/actions/workflows/hpc_sdk_linux.yml)
[![Intel tests](https://github.com/ShatrovOA/dtFFT/actions/workflows/intel_linux.yml/badge.svg)](https://github.com/ShatrovOA/dtFFT/actions/workflows/intel_linux.yml)
[![Build and Deploy Documentation](https://github.com/ShatrovOA/dtFFT/actions/workflows/gh-pages.yml/badge.svg)](https://github.com/ShatrovOA/dtFFT/actions/workflows/gh-pages.yml)
[![Documentation Status](https://readthedocs.org/projects/dtfft/badge/?version=latest)](https://dtfft.readthedocs.io/latest/?badge=latest)
[![PyPI](https://img.shields.io/pypi/v/dtfft)](https://pypi.org/project/dtfft/)
![PyPI - Python Version](https://img.shields.io/pypi/pyversions/dtfft)

![Pencils](docs/images/pencils.png)

dtFFT is a high-performance library for parallel data transpositions and optional Fast Fourier Transforms (FFTs) in multidimensional computing environments. It minimizes memory overhead in distributed systems by using custom MPI datatypes for CPU clusters and runtime-compiled CUDA kernels for GPU workflows. Supports integration with FFT libraries like FFTW3, MKL, cuFFT, and VkFFT, or transpose-only mode.

Key benefits: Zero-copy transpositions, GPU acceleration, and seamless MPI/CUDA integration for scientific computing.

dtFFT aims to optimize following cycles of transformations (forward and backward):

```math
\dfrac{X}{P_0} \times \dfrac{Y}{P_1} \to X \times \dfrac{Y}{P_0P_1} \to  Y \times \dfrac{X}{P_0P_1} \to \dfrac{Y}{P_1} \times \dfrac{X}{P_0}
```
for 2D case, and
```math
\dfrac{X}{P_0} \times \dfrac{Y}{P_1} \times \dfrac{Z}{P_2} \to X \times \dfrac{Y}{Q_1} \times \dfrac{Z}{Q_2} \to Y \times \dfrac{Z}{Q_2} \times \dfrac{X}{Q_1} \to Z \times \dfrac{X}{Q_1} \times \dfrac{Y}{Q_2} \to \dfrac{Z}{P_2} \times \dfrac{X}{Q_1} \times \dfrac{Y}{Q_2'}
```
for 3D case. Where $X, Y, Z$ are the spatial dimensions of the data, $X$ being the fastest varying index and $P_0, P_1, P_2, Q_1, Q_2, Q_2'$ are the number of processes in the appropriate direction.

## Features
- **Transform Types**: R2C, C2C, and R2R transforms
- **Precision**: Single and double precision support
- **Interfaces**: Fortran, C, C++ and Python APIs
- **Decompositions**: 2D and 3D transposition plans with Bricks, Pencils and Slab decompositions support
- **Transpositions**: Custom MPI datatypes enhanced with standard host-based transpositions
- **OpenMP Support**: Host-based transpositions can be accelerated using OpenMP
- **GPU Support**: CUDA acceleration with runtime kernel compilation
- **FFT Libraries**: built-in support:
  - [FFTW3](https://www.fftw.org/)
  - [MKL DFTI](https://www.intel.com/content/www/us/en/docs/onemkl/developer-reference-fortran/2024-2/fourier-transform-functions.html)
  - [cuFFT](https://docs.nvidia.com/cuda/cufft/)
  - [VkFFT](https://github.com/DTolm/VkFFT)
- **CUDA Backends**: MPI, NCCL, cuFFTMp for data exchange
- **Highly customizable**: Lots of options and runtime autotuning
- **Runtime compression**: Some backends support buffer compression before sending it to another process

## Limitations
- Memory is assumed to be contiguous. Ghost boundaries are not allowed.
- Maximum number of elements per process/GPU cannot exceed $2^{31} - 1$ - max value of int32

## Requirements
- Fortran/C/C++ compilers (GCC, Intel and NVHPC-SDK are tested)
- MPI (OpenMPI, MPICH and Intel MPI are tested)

## Installation
1. Clone the repository: `git clone https://github.com/ShatrovOA/dtFFT.git`
2. Configure with CMake: `mkdir build && cd build && cmake ..`
3. Build: `make`
4. Install: `make install`

For detailed instructions, see the [Building the Library](https://dtfft.readthedocs.io/latest/build.html).

## Quick Start
```fortran
use dtfft
use mpi
use iso_fortran_env
type(dtfft_plan_c2c_t) :: plan
complex(real64), pointer :: real_buffer(:,:)
complex(real64), pointer :: fourier_buffer(:,:)
integer(int32) :: in_counts(2), out_counts(2)
integer(int64) :: alloc_size ! Can be bigger then `product(in_counts)` and `product(out_counts)`

! Create plan
call plan%create([100, 100], comm=MPI_COMM_WORLD)
! Get memory requirements
call plan%get_local_sizes(in_counts=in_counts, out_counts=out_counts, alloc_size=alloc_size)
! Allocate memory
call plan%mem_alloc(alloc_size, real_buffer, in_counts)
call plan%mem_alloc(alloc_size, fourier_buffer, out_counts)

! Execute plan
call plan%execute(real_buffer, fourier_buffer, DTFFT_EXECUTE_FORWARD)
! Now data is aligned in Y direction
! Execute backwards
call plan%execute(fourier_buffer, real_buffer, DTFFT_EXECUTE_BACKWARD)
! Free all memory
call plan%mem_free(real_buffer)
call plan%mem_free(fourier_buffer)
! Destroy plan
call plan%destroy()
```
**More examples** can be found in the `tests` folder of the repository.

## Documentation

The documentation consists of two parts:

**User Documentation**:
Available at [dtFFT User Documentation](https://dtfft.readthedocs.io/latest/index.html), this section provides instructions on how to compile and use the library, as well as the public API documentation for C, C++, and Fortran. It is generated using [Sphinx](https://www.sphinx-doc.org/) and hosted on [Read the Docs](https://readthedocs.org/).

**Internal Documentation**:
Available at [dtFFT Internal Documentation](https://shatrovoa.github.io/dtFFT/index.html), this section describes the internal structure of the library, including call graphs and detailed implementation insights. It is generated using [FORD](https://forddocs.readthedocs.io/en/latest/index.html).

## API Reference
- [C API](https://dtfft.readthedocs.io/latest/api_c.html)
- [C++ API](https://dtfft.readthedocs.io/latest/api_cxx.html)
- [Fortran API](https://dtfft.readthedocs.io/latest/api_fortran.html)
- [Python API](https://dtfft.readthedocs.io/latest/api_python.html)

## Roadmap
The following is an ambitious list of features to implement. The items are in no particular order.

- nvSHMEM-based backends
- HIP platform
- Ghost boundaries and support for halo exchange
- long double/quad precision

## Contributing
We welcome contributions! Report issues or suggest improvements via the [issue tracker](https://github.com/ShatrovOA/dtFFT/issues). For code contributions, please follow standard GitHub workflows (fork, branch, PR).

## Licensing
Licensed under GPL v3. See [LICENSE](LICENSE) for details.

# {PACKAGE_TITLE}

[![License](https://img.shields.io/github/license/ShatrovOA/dtFFT?color=brightgreen)](https://github.com/ShatrovOA/dtFFT/blob/master/LICENSE)
[![Documentation](https://readthedocs.org/projects/dtfft/badge/?version=latest)](https://dtfft.readthedocs.io/latest/?badge=latest)
[![PyPI](https://img.shields.io/pypi/v/{PACKAGE_NAME})](https://pypi.org/project/{PACKAGE_NAME}/)
[![Python](https://img.shields.io/pypi/pyversions/{PACKAGE_NAME})](https://pypi.org/project/{PACKAGE_NAME}/)

Python bindings for **[dtFFT](https://github.com/ShatrovOA/dtFFT)** — a high-performance library for parallel data transpositions and Fast Fourier Transforms via MPI.

> This is the **`{PACKAGE_NAME}`** variant.
{VARIANT_DESCRIPTION}

## Included backends

{BACKENDS_TABLE}

## Installation

```bash
pip install {PACKAGE_NAME}
```

{EXTRA_INSTALL_NOTE}

### Requirements

- MPI runtime (OpenMPI or MPICH)
- Python ≥ 3.9
{EXTRA_REQUIREMENTS}

## Quick start

```python
import numpy as np
from mpi4py import MPI
import dtfft

# Create a 3-D complex-to-complex plan
plan = dtfft.PlanC2C([256, 256, 256], comm=MPI.COMM_WORLD)

# Allocate MPI-decomposed buffers
x = plan.get_ndarray(plan.alloc_size)
y = plan.get_ndarray(plan.alloc_size)

x[...] = np.random.random(x.shape) + 1j * np.random.random(x.shape)

# Forward transform  (pencil decomposition applied automatically)
plan.execute(x, y, dtfft.Execute.FORWARD)

# Backward transform
plan.execute(y, x, dtfft.Execute.BACKWARD)
```

## Package variants

Multiple PyPI distributions are provided so you can declare an exact,
conflict-free dependency for your environment:

| PyPI package | FFT backend | MPI | Platform | Extra deps |
|---|---|---|---|---|
| `dtfft-openmpi` | none (transpose-only) | OpenMPI | CPU | — |
| `dtfft-mpich` | none (transpose-only) | MPICH | CPU | — |
| `dtfft-fftw-openmpi` | FFTW3 | OpenMPI | CPU | system libfftw3 |
| `dtfft-fftw-mpich` | FFTW3 | MPICH | CPU | system libfftw3 |
| `dtfft-cuda12x-openmpi` | cuFFT | OpenMPI | CPU + NVIDIA GPU (CUDA 12) | `cupy-cuda12x` |
| `dtfft-cuda12x-mpich` | cuFFT | MPICH | CPU + NVIDIA GPU (CUDA 12) | `cupy-cuda12x` |

All packages share the same importable namespace: `import dtfft`.

## Documentation

- [API reference](https://dtfft.readthedocs.io/latest/api_python.html)
- [Building from source](https://dtfft.readthedocs.io/latest/build.html)
- [Examples](https://github.com/ShatrovOA/dtFFT/tree/master/tests/python)

## License

GPL v3 — see [LICENSE](https://github.com/ShatrovOA/dtFFT/blob/master/LICENSE).

# dtfft

[![License](https://img.shields.io/github/license/ShatrovOA/dtFFT?color=brightgreen)](https://github.com/ShatrovOA/dtFFT/blob/master/LICENSE)
[![Documentation](https://readthedocs.org/projects/dtfft/badge/?version=latest)](https://dtfft.readthedocs.io/latest/?badge=latest)
[![PyPI](https://img.shields.io/pypi/v/dtfft)](https://pypi.org/project/dtfft/)
![PyPI - Python Version](https://img.shields.io/pypi/pyversions/dtfft)

Python bindings for **[dtFFT](https://github.com/ShatrovOA/dtFFT)** — a high-performance library for parallel data transpositions and Fast Fourier Transforms via MPI.

This package is distributed as a **source distribution (sdist)** and is compiled locally during installation.
It gives you full control over all build options via CMake flags.

> If you need a pre-built wheel (no compiler required), use one of the variant packages:
> `dtfft-openmpi`, `dtfft-mpich`, `dtfft-fftw-openmpi`, `dtfft-cuda12x-openmpi`, etc.
> See the [full list on PyPI](https://pypi.org/search/?q=dtfft) or the
> [documentation](https://dtfft.readthedocs.io/latest/build.html#installing-from-pypi).

## Installation

Building from source requires a Fortran compiler (GCC ≥ 10, Intel, or NVHPC), CMake ≥ 3.25,
and an MPI implementation with development headers.
Build-time Python dependencies (`scikit-build`, `cmake`, `ninja`, `pybind11`) are installed
automatically by pip.

> **Important**: `mpi4py` in your environment must be compiled against the same MPI implementation
> that dtFFT will be linked with. Install it from source:
>
> ```bash
> pip install --no-binary mpi4py mpi4py
> ```

**Transpose-only (no FFT backend)**:

```bash
pip install dtfft
```

**With FFTW3**:

```bash
CMAKE_ARGS="-DDTFFT_WITH_FFTW=ON" pip install dtfft
```

**With cuFFT (CUDA)**:

> Also install `cupy` matching your CUDA toolkit version first, e.g. `pip install cupy-cuda12x`.

```bash
CMAKE_ARGS="-DDTFFT_WITH_CUDA=ON -DDTFFT_WITH_CUFFT=ON" pip install dtfft
```

Any CMake option documented on the
[build page](https://dtfft.readthedocs.io/latest/build.html#configuration-options)
can be passed via `CMAKE_ARGS`.

## Quick start

```python
import numpy as np
from mpi4py import MPI
import dtfft

# Create a 3-D complex-to-complex plan
plan = dtfft.PlanC2C([256, 256, 256], comm=MPI.COMM_WORLD)

# Allocate MPI-decomposed buffers
x = plan.get_ndarray(plan.alloc_size)
y = plan.get_ndarray(plan.alloc_size)

x[...] = np.random.random(x.shape) + 1j * np.random.random(x.shape)

# Forward transform  (pencil decomposition applied automatically)
plan.execute(x, y, dtfft.Execute.FORWARD)

# Backward transform
plan.execute(y, x, dtfft.Execute.BACKWARD)
```

## Documentation

- [API reference](https://dtfft.readthedocs.io/latest/api_python.html)
- [Building from source](https://dtfft.readthedocs.io/latest/build.html)
- [Examples](https://github.com/ShatrovOA/dtFFT/tree/master/tests/python)

## License

GPL v3 — see [LICENSE](https://github.com/ShatrovOA/dtFFT/blob/master/LICENSE).

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_utils
!! All Utilities functions are located here
use iso_c_binding
use iso_fortran_env
use dtfft_errors
use dtfft_parameters
#include "_dtfft_mpi.h"
#include "_dtfft_cuda.h"
#include "_dtfft_private.h"
implicit none
private
public :: string_f2c
public :: to_str
public :: write_message
public :: get_env

public :: get_inverse_kind
public :: is_same_ptr, is_null_ptr, ptr_offset
public :: mem_alloc_host, mem_free_host
public :: create_subcomm_include_all, create_subcomm
public :: string
public :: destroy_strings

#if defined(DTFFT_WITH_CUDA) || defined(DTFFT_WITH_MKL)
public :: string_c2f
#endif
#ifdef DTFFT_WITH_CUDA
public :: astring_f2c
public :: count_unique
public :: Comm_f2c
public :: is_device_ptr
public :: dynamic_load, unload_library
#endif

  interface to_str
  !! Convert various types to string
    module procedure int8_to_string
    module procedure int32_to_string
    module procedure int64_to_string
    module procedure double_to_string
    module procedure float_to_string
  end interface to_str

  interface is_null_ptr
  !! Checks if pointer is NULL
    module procedure is_null_ptr
#ifdef DTFFT_WITH_CUDA
    module procedure is_null_funptr
#endif
  end interface is_null_ptr

#if defined(DTFFT_USE_MPI)
public :: all_reduce_inplace
  interface all_reduce_inplace
  !! MPI Allreduce inplace workaround
    module procedure :: all_reduce_inplace_i32
    module procedure :: all_reduce_inplace_i64
  end interface all_reduce_inplace
#endif

#ifdef DTFFT_WITH_CUDA
  integer(c_int), parameter :: RTLD_LAZY = 1_c_int
    !! Each external function reference is bound the first time the function is called.
  integer(c_int), parameter :: RTLD_NOW  = 2_c_int
    !! All external function references are bound when the library is loaded.

  interface
    function dlopen(filename, mode) bind(C)
    !! Load and link a dynamic library
    import
      type(c_ptr)           :: dlopen       !! Handle to the library
      character(c_char)     :: filename(*)  !! Name of the library
      integer(c_int), value :: mode         !! Options to dlopen
    end function dlopen
  end interface

  interface
    function dlsym(handle, name) bind(C)
    !! Get address of a symbol from a dynamic library
    import
      type(c_funptr)      :: dlsym          !! Address of the symbol
      type(c_ptr),  value :: handle         !! Handle to the library
      character(c_char)   :: name(*)        !! Name of the symbol
    end function dlsym
  end interface

  interface
    function dlclose(handle) bind(C)
    !! Close a dynamic library
    import
      integer(c_int)      :: dlclose        !! Result of the operation
      type(c_ptr), value  :: handle         !! Handle to the library
    end function dlclose
  end interface

  interface
    function dlerror() bind(C)
    !! Get diagnostic information
    import
      type(c_ptr)  :: dlerror !! Error message
    end function dlerror
  end interface
#endif

  interface
    function aligned_alloc(alignment, alloc_size) result(ptr) bind(C)
    !! Allocates memory using C11 Standard alloc_align with 16 bytes alignment
    import
      integer(c_size_t),  value :: alignment    !! Alignment in bytes (16 bytes by default)
      integer(c_size_t),  value :: alloc_size   !! Number of bytes to allocate
      type(c_ptr)               :: ptr          !! Pointer to allocate
    end function aligned_alloc
  end interface

  interface
    subroutine mem_free_host(ptr) bind(C, name="free")
    !! Frees memory allocated with [[aligned_alloc]]
    import
      type(c_ptr),        value :: ptr          !! Pointer to free
    end subroutine mem_free_host
  end interface

#ifdef DTFFT_WITH_CUDA
  interface
    type(c_ptr) function Comm_f2c(fcomm) bind(C, name="Comm_f2c")
    !! Converts Fortran communicator to C
      import
      integer(c_int), value :: fcomm            !! Fortran communicator
    end function Comm_f2c
  end interface
# ifndef DTFFT_WITH_MOCK_ENABLED
  interface
    function is_device_ptr(ptr) result(bool) bind(C)
    !! Checks if pointer can be accessed from device
    import
      type(c_ptr),    value :: ptr    !! Device pointer
      logical(c_bool)       :: bool   !! Result
    end function is_device_ptr
  end interface
# endif
#endif

  type :: string
  !! Class used to create array of strings
    character(len=:), allocatable :: raw  !! String
  contains
    procedure, pass(self) :: destroy => destroy_string
  end type string

  interface string
  !! Creates [[string]] object
    module procedure :: string_constructor
  end interface string

  integer(int32), save :: write_rank = -1

  interface get_env
  !! Obtains environment variable
    module procedure :: get_env_base    !! Base procedure
    module procedure :: get_env_string  !! For string values
    module procedure :: get_env_int32   !! For integer(int32) values
    module procedure :: get_env_int8    !! For integer(int8) values
    module procedure :: get_env_logical !! For logical values
  end interface get_env

  character(len=26), parameter :: UPPER_ALPHABET = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
    !! Upper case alphabet.
  character(len=26), parameter :: LOWER_ALPHABET = 'abcdefghijklmnopqrstuvwxyz'
    !! Lower case alphabet.

contains

  type(string) function string_constructor(str)
  !! Creates [[string]] object
    character(len=*), intent(in)  :: str  !! String
    allocate( string_constructor%raw, source=str )
  end function string_constructor

  subroutine destroy_string(self)
    class(string),  intent(inout) :: self
    if ( allocated(self%raw) ) deallocate( self%raw )
  end subroutine destroy_string

  subroutine destroy_strings(strings)
  !! Destroys array of [[string]] objects
    type(string), intent(inout), allocatable :: strings(:)  !! Array of strings
    integer(int32) :: i

    if ( .not. allocated(strings) ) return
    do i = 1, size(strings)
      call strings(i)%destroy()
    end do
    deallocate( strings )
  end subroutine destroy_strings

  subroutine string_f2c(fstring, cstring, string_size)
  !! Convert Fortran string to C string
    character(len=*),           intent(in)    :: fstring        !! Fortran string
    character(kind=c_char),     intent(inout) :: cstring(*)     !! C string
    integer(int64),  optional,  intent(out)   :: string_size    !! Size of the C string
    integer                                   :: i, j           !! Loop indices
    logical                                   :: met_non_blank  !! Have we met a non-blank character?

    j = 1
    met_non_blank = .false.
    do i = 1, len_trim(fstring)
      if (met_non_blank) then
        cstring(j) = fstring(i:i)
        j = j + 1
      else if (fstring(i:i) /= ' ') then
        met_non_blank = .true.
        cstring(j) = fstring(i:i)
        j = j + 1
      end if
    end do

    cstring(j) = c_null_char
    if(present( string_size )) string_size = j
  end subroutine string_f2c

#if defined(DTFFT_WITH_CUDA) || defined(DTFFT_WITH_MKL)
  subroutine string_c2f(cstring, fstring)
  !! Convert C string to Fortran string
    type(c_ptr)                     :: cstring    !! C string
    character(len=:),   allocatable :: fstring    !! Fortran string
    character(c_char),  pointer     :: cstring_(:)
    character(len=4096)             :: fstring_  !! Temporary Fortran string
    integer(int32) :: l

    if ( is_null_ptr(cstring) ) then
      allocate(fstring, source="")
      return
    endif

    call c_f_pointer(cstring, cstring_, [len(fstring_)])
    l = 0
    do while (.true.)
      l = l + 1
      if ( cstring_(l) == c_null_char ) exit
      if ( l == len(fstring_) - 1 ) exit
      fstring_(l:l) = cstring_(l)
    enddo
    allocate( fstring, source=fstring_(1:l) )
  end subroutine string_c2f
#endif

#ifdef DTFFT_WITH_CUDA
  subroutine astring_f2c(fstring, cstring, string_size)
  !! Convert Fortran string to C allocatable string
    character(len=*),                     intent(in)  :: fstring      !! Fortran string
    character(kind=c_char), allocatable,  intent(out) :: cstring(:)   !! C string
    integer(int64),         optional,     intent(out) :: string_size  !! Size of the C string

    allocate(cstring( len_trim(fstring) + 1 ))
    call string_f2c(fstring, cstring, string_size)
  end subroutine astring_f2c

  subroutine dl_error(message)
  !! Writes error message to the error unit
    character(len=*), intent(in)  :: message      !! Message to write
    character(len=:), allocatable :: err_msg      !! Error string

    call string_c2f(dlerror(), err_msg)
    WRITE_ERROR(message//": "//err_msg)
    deallocate( err_msg )
  end subroutine dl_error

  function load_library(name) result(lib_handle)
  !! Dynamically loads library
    character(len=*), intent(in)  :: name         !! Name of library to load
    type(c_ptr)                   :: lib_handle   !! Loaded handle
    character(c_char),  allocatable :: cname(:)   !! Temporary string

    call astring_f2c(name//c_null_char, cname)
    lib_handle = dlopen(cname, RTLD_LAZY)
    deallocate( cname )
    if (is_null_ptr(lib_handle)) then
      call dl_error("Failed to load library '"//name//"'")
    endif
  end function load_library

  function load_symbol(handle, name) result(symbol_handle)
  !! Dynamically loads symbol from library
    type(c_ptr),      intent(in)  :: handle         !! Loaded handle
    character(len=*), intent(in)  :: name           !! Name of function to load
    type(c_funptr)                :: symbol_handle  !! Function pointer
    character(c_char),  allocatable :: cname(:)     !! Temporary string

    if ( is_null_ptr(handle) ) then
      INTERNAL_ERROR("is_null_ptr(handle)")
    endif

    call astring_f2c(name//c_null_char, cname)
    symbol_handle = dlsym(handle, cname)
    deallocate(cname)
    if (is_null_ptr(symbol_handle)) then
      call dl_error("Failed to load symbol '"//name//"'")
    endif
  end function load_symbol

  subroutine unload_library(handle)
  !! Unloads library
    type(c_ptr),      intent(in)  :: handle         !! Loaded handle
    integer(int32)  :: ierr                         !! Error code

    ierr = dlclose(handle)
    if ( ierr /= 0 ) then
      call dl_error("Failed to unload library")
    endif
  end subroutine unload_library

  function dynamic_load(name, symbol_names, handle, symbols) result(error_code)
  !! Dynamically loads library and its symbols
    character(len=*), intent(in)  :: name             !! Name of library to load
    type(string),     intent(in)  :: symbol_names(:)  !! Names of functions to load
    type(c_ptr),      intent(out) :: handle           !! Loaded handle
    type(c_funptr),   intent(out) :: symbols(:)       !! Function pointers
    integer(int32)                :: error_code       !! Error code
    integer(int32)                :: i                !! Loop index

    error_code = DTFFT_SUCCESS

    handle = load_library(name)
    if ( is_null_ptr(handle) ) then
      error_code = DTFFT_ERROR_DLOPEN_FAILED
      return
    endif

    do i = 1, size(symbol_names)
      symbols(i) = load_symbol(handle, symbol_names(i)%raw)
      if ( is_null_ptr(symbols(i)) ) then
        call unload_library(handle)
        symbols(1:i) = c_null_funptr
        error_code = DTFFT_ERROR_DLSYM_FAILED
        return
      endif
    end do
  end function dynamic_load
#endif

  function int8_to_string(n) result(str)
  !! Convert 8-bit integer to string
    integer(int8),    intent(in)  :: n            !! Integer to convert
    character(len=:), allocatable :: str          !! Resulting string
    character(len=3)              :: temp         !! Temporary string

    write(temp, '(I3)') n
    allocate( str, source=trim(adjustl(temp)) )
  end function int8_to_string

  function int32_to_string(n) result(str)
  !! Convert 32-bit integer to string
    integer(int32),   intent(in)  :: n            !! Integer to convert
    character(len=:), allocatable :: str          !! Resulting string
    character(len=11)             :: temp         !! Temporary string

    write(temp, '(I11)') n
    allocate( str, source=trim(adjustl(temp)) )
  end function int32_to_string

  function int64_to_string(n) result(str)
  !! Convert 64-bit integer to string
    integer(int64),   intent(in)  :: n            !! Integer to convert
    character(len=:), allocatable :: str          !! Resulting string
    character(len=20)             :: temp         !! Temporary string

    write(temp, '(I20)') n
    allocate( str, source=trim(adjustl(temp)) )
  end function int64_to_string

  function double_to_string(n) result(str)
  !! Convert double to string
    real(real64),     intent(in)  :: n            !! Double to convert
    character(len=:), allocatable :: str          !! Resulting string
    character(len=23)             :: temp         !! Temporary string

    write(temp, '(F15.5)') n
    allocate( str, source=trim(adjustl(temp)) )
  end function double_to_string

  function float_to_string(n) result(str)
  !! Convert double to string
    real(real32),     intent(in)  :: n            !! Double to convert
    character(len=:), allocatable :: str          !! Resulting string
    character(len=15)             :: temp         !! Temporary string

    write(temp, '(F10.2)') n
    allocate( str, source=trim(adjustl(temp)) )
  end function float_to_string

  subroutine write_message(unit, message, prefix, is_fatal)
  !! Write message to the specified unit
    integer(int32),   intent(in)            :: unit         !! Unit number
    character(len=*), intent(in)            :: message      !! Message to write
    character(len=*), intent(in), optional  :: prefix       !! Prefix to the message
    logical,          intent(in), optional  :: is_fatal     !! If true, only rank 0 will print the message, otherwise all ranks will print it
    character(len=:), allocatable           :: prefix_      !! Dummy prefix
    logical                                 :: is_fatal_
    integer(int32)                          :: ierr         !! Error code
    logical                                 :: is_finalized !! Is MPI Already finalized?

    is_fatal_ = .false.; if ( present(is_fatal) ) is_fatal_ = is_fatal

    if ( .not. is_fatal_ ) then
      if ( write_rank < 0 ) then
        call MPI_Finalized(is_finalized, ierr)
        if ( is_finalized ) then
          write_rank = 0
        else
          call MPI_Comm_rank(MPI_COMM_WORLD, write_rank, ierr)
        endif
      endif
      if ( write_rank /= 0 ) return
    endif

    if ( present( prefix ) ) then
      allocate( prefix_, source=prefix )
    else
      allocate( prefix_, source="" )
    endif

    write(unit, '(a)') prefix_//trim(message)
    flush(unit)

    deallocate( prefix_ )
  end subroutine write_message

  elemental function get_inverse_kind(r2r_kind) result(result_kind)
  !! Get the inverse R2R kind of transform for the given R2R kind
    type(dtfft_r2r_kind_t), intent(in)  :: r2r_kind        !! R2R kind
    type(dtfft_r2r_kind_t)              :: result_kind

    result_kind = dtfft_r2r_kind_t(-1)
    select case (r2r_kind%val)
    case ( DTFFT_DCT_1%val )
      result_kind = DTFFT_DCT_1
    case ( DTFFT_DCT_2%val )
      result_kind = DTFFT_DCT_3
    case ( DTFFT_DCT_3%val )
      result_kind = DTFFT_DCT_2
    case ( DTFFT_DCT_4%val )
      result_kind = DTFFT_DCT_4
    case ( DTFFT_DST_1%val )
      result_kind = DTFFT_DST_1
    case ( DTFFT_DST_2%val )
      result_kind = DTFFT_DST_3
    case ( DTFFT_DST_3%val )
      result_kind = DTFFT_DST_2
    case ( DTFFT_DST_4%val )
      result_kind = DTFFT_DST_4
    endselect
  end function get_inverse_kind

  elemental logical function is_null_ptr(ptr)
  !! Checks if pointer is NULL
    type(c_ptr),  intent(in) :: ptr   !! Pointer to check
    is_null_ptr = .not.c_associated(ptr)
  end function is_null_ptr

#ifdef DTFFT_WITH_CUDA
  elemental logical function is_null_funptr(ptr)
  !! Checks if pointer is NULL
    type(c_funptr),  intent(in) :: ptr   !! Pointer to check
    is_null_funptr = .not.c_associated(ptr)
  end function is_null_funptr
#endif

  elemental logical function is_same_ptr(ptr1, ptr2)
  !! Checks if two pointer are the same
    type(c_ptr),  intent(in):: ptr1   !! First pointer
    type(c_ptr),  intent(in):: ptr2   !! Second pointer
    is_same_ptr = c_associated(ptr1, ptr2)
  end function is_same_ptr

#ifdef DTFFT_WITH_CUDA
  integer(int32) function count_unique(x) result(n)
  !! Count the number of unique elements in the array
    integer(int32), intent(in)  :: x(:)   !! Array of integers
    integer(int32), allocatable :: y(:)   !! Array of unique integers

    allocate(y, source=x)
    n = 0
    do while (size(y) > 0)
        n = n + 1
        y = pack(y,mask=(y(:) /= y(1))) ! drops all elements that are
                                        ! equals to the 1st one (included)
    end do
    deallocate(y)
  end function count_unique
#endif

  function mem_alloc_host(alloc_size) result(ptr)
  !! Allocates memory using C11 Standard alloc_align with 16 bytes alignment
    integer(int64), intent(in)  :: alloc_size   !! Number of bytes to allocate
    type(c_ptr)                 :: ptr          !! Pointer to allocate
    integer(int64) :: displ, alloc_size_

    displ = mod(alloc_size, int(ALLOC_ALIGNMENT, int64))
    alloc_size_ = alloc_size
    if ( displ > 0 ) then
      alloc_size_ = alloc_size_ + (ALLOC_ALIGNMENT - displ)
    endif
    ptr = aligned_alloc(int(ALLOC_ALIGNMENT, c_size_t), alloc_size_)
  end function mem_alloc_host

  subroutine create_subcomm_include_all(old_comm, new_comm)
  !! Creates communicator including all processes from `old_comm`
    TYPE_MPI_COMM,        intent(in)    :: old_comm     !! Communicator to create group from
    TYPE_MPI_COMM,        intent(out)   :: new_comm     !! New communicator
    integer(int32), allocatable :: ranks(:)
    integer(int32) :: i, comm_size, ierr

    call MPI_Comm_size(old_comm, comm_size, ierr)
    allocate(ranks(0:comm_size - 1))
    do i = 0, comm_size - 1_int32
      ranks(i) = i
    enddo
    call create_subcomm(old_comm, ranks, new_comm)
    deallocate(ranks)
  end subroutine create_subcomm_include_all

  subroutine create_subcomm(old_comm, processes, new_comm)
  !! Creates communicator with selected processes from `old_comm`
    TYPE_MPI_COMM,        intent(in)    :: old_comm     !! Communicator to create group from
    integer(int32),       intent(in)    :: processes(:) !! Ranks of processes in `old_comm` to include in new group
    TYPE_MPI_COMM,        intent(out)   :: new_comm     !! New communicator
    TYPE_MPI_GROUP :: group, new_group
    integer(int32) :: ierr

    call MPI_Comm_group(old_comm, group, ierr)
    call MPI_Group_incl(group, size(processes), processes, new_group, ierr)
    call MPI_Comm_create(old_comm, new_group, new_comm, ierr)
    call MPI_Group_free(group, ierr)
    call MPI_Group_free(new_group, ierr)
  end subroutine create_subcomm

  pure function ptr_offset(ptr, n_bytes) result(new_ptr)
  !! Returns pointer offset by n_bytes
    type(c_ptr),    intent(in)  :: ptr        !! Original pointer
    integer(int64), intent(in)  :: n_bytes    !! Number of bytes to offset
    type(c_ptr)                 :: new_ptr    !! New pointer
    integer(c_intptr_t) :: addr

    addr = transfer(ptr, addr) + n_bytes
    new_ptr = transfer(addr, new_ptr)
  end function ptr_offset

#if defined(DTFFT_USE_MPI)
! Some bug was noticed in mpich for macos
! For some reason MPI_IN_PLACE has not been recognized.
! This is some stupid workaround
  subroutine all_reduce_inplace_i64(buffer, op, comm, ierr)
    integer(int64), intent(inout) :: buffer
    integer(int32), intent(in)    :: op, comm
    integer(int32), intent(out)   :: ierr
    integer(int64) :: tmp

    call MPI_Allreduce(buffer, tmp, 1, MPI_INTEGER8, op, comm, ierr)
    buffer = tmp
  end subroutine all_reduce_inplace_i64

  subroutine all_reduce_inplace_i32(buffer, op, comm, ierr)
    integer(int32), intent(inout) :: buffer
    integer(int32), intent(in)    :: op, comm
    integer(int32), intent(out)   :: ierr
    integer(int32) :: tmp

    call MPI_Allreduce(buffer, tmp, 1, MPI_INTEGER4, op, comm, ierr)
    buffer = tmp
  end subroutine all_reduce_inplace_i32
#endif

#ifdef DTFFT_WITH_MOCK_ENABLED
  logical function is_device_ptr(ptr) result(bool)
  !! Mock version of is_device_ptr. Always returns true
    type(c_ptr),    intent(in) :: ptr   !! Device pointer
    bool = .true.
  end function is_device_ptr
#endif

type(string) function get_env_base(name) result(env)
  !! Base function of obtaining dtFFT environment variable
    character(len=*), intent(in)    :: name         !! Name of environment variable without prefix
    type(string)                    :: full_name    !! Prefixed environment variable name
    integer(int32)                  :: env_val_len  !! Length of the environment variable
    integer(int32) :: ierr

    full_name = string("DTFFT_"//name)

    call get_environment_variable(full_name%raw, length=env_val_len)
    call MPI_Bcast(env_val_len, 1, MPI_INTEGER4, 0, MPI_COMM_WORLD, ierr)
    allocate(character(env_val_len) :: env%raw)
    if ( env_val_len == 0 ) then
      call full_name%destroy()
      return
    endif
    call get_environment_variable(full_name%raw, env%raw)
    call MPI_Bcast(env%raw, env_val_len, MPI_CHARACTER, 0, MPI_COMM_WORLD, ierr)
    call full_name%destroy()
  end function get_env_base

  type(string) function get_env_string(name, default, valid_values) result(env)
  !! Obtains string environment variable
    character(len=*), intent(in)            :: name                 !! Name of environment variable without prefix
    character(len=*), intent(in)            :: default              !! Name of environment variable without prefix
    type(string),     intent(in)            :: valid_values(:)      !! List of valid variable values
    logical                                 :: is_correct           !! Is env value is correct
    integer(int32)    :: i            !! Index in string
    integer(int32)    :: j            !! Index in alphabet
    type(string)      :: env_val_str  !! String value of the environment variable

    env_val_str = get_env(name)
    if ( len(env_val_str%raw) == 0 ) then
      call env_val_str%destroy()
      env = string(default)
      return
    endif

    ! Converting to lowercase
    do i=1, len(env_val_str%raw)
      j = index(UPPER_ALPHABET, env_val_str%raw(i:i))
      if (j>0) env_val_str%raw(i:i) = LOWER_ALPHABET(j:j)
    enddo

    is_correct = any([(env_val_str%raw == valid_values(i)%raw, i=1,size(valid_values))])

    if ( is_correct ) then
      env = string(env_val_str%raw)
      call env_val_str%destroy()
      return
    endif
    WRITE_ERROR("Invalid environment variable: `DTFFT_"//name//"`, it has been ignored")
    call env_val_str%destroy()
    env = string(default)
  end function get_env_string

  integer(int32) function get_env_int32(name, default, valid_values, min_valid_value) result(env)
  !! Base Integer function of obtaining dtFFT environment variable
    character(len=*), intent(in)            :: name               !! Name of environment variable without prefix
    integer(int32),   intent(in)            :: default            !! Default value in case env is not set or it has wrong value
    integer(int32),   intent(in), optional  :: valid_values(:)    !! List of valid values
    integer(int32),   intent(in), optional  :: min_valid_value    !! Mininum valid value. Usually 0 or 1
    type(string)                            :: env_val_str        !! String value of the environment variable
    logical                                 :: is_correct         !! Is env value is correct
    integer(int32)                          :: env_val_passed     !! Value of the environment variable
    integer(int32)                          :: io_status          !! IO status of reading env variable

#ifdef DTFFT_DEBUG
    if ( ( present(valid_values).and.present(min_valid_value) )           &
      .or.(.not.present(valid_values).and..not.present(min_valid_value))  &
    ) then
      INTERNAL_ERROR("`get_env_int32`")
    endif
#endif

    env_val_str = get_env(name)
    if ( len(env_val_str%raw) == 0 ) then
      deallocate(env_val_str%raw)
      env = default
      return
    endif
    read(env_val_str%raw, *, iostat=io_status) env_val_passed
    if (io_status /= 0) then
      WRITE_ERROR("Invalid integer value for environment variable: `DTFFT_"//name//"`=<"//env_val_str%raw//">, it has been ignored")
      env = default
      deallocate(env_val_str%raw)
      return
    endif
    is_correct = .false.
    if ( present( valid_values ) ) then
      is_correct = any(env_val_passed == valid_values)
    endif
    if ( present( min_valid_value ) ) then
      is_correct = env_val_passed >= min_valid_value
    endif
    if ( is_correct ) then
      env = env_val_passed
      deallocate(env_val_str%raw)
      return
    endif
    WRITE_ERROR("Invalid integer value for environment variable: `DTFFT_"//name//"`=<"//env_val_str%raw//">, it has been ignored")
    env = default
    deallocate(env_val_str%raw)
  end function get_env_int32

  integer(int8) function get_env_int8(name, default, valid_values) result(env)
  !! Obtains int8 environment variable
    character(len=*), intent(in)  :: name               !! Name of environment variable without prefix
    integer(int8),    intent(in)  :: default            !! Default value in case env is not set or it has wrong value
    integer(int32),   intent(in)  :: valid_values(:)    !! List of valid values
    integer(int32)                :: val                !! Value of the environment variable

    val = get_env(name, int(default, int32), valid_values)
    env = int(val, int8)
  end function get_env_int8

  logical function get_env_logical(name, default) result(env)
  !! Obtains logical environment variable
    character(len=*), intent(in) :: name                !! Name of environment variable without prefix
    logical,          intent(in) :: default             !! Default value in case env is not set or it has wrong value
    integer(int32) :: def, val

    if ( default ) then
      def = 1
    else
      def = 0
    endif
    val = get_env(name, def, [0, 1])
    env = val == 1
  end function get_env_logical
end module dtfft_utils

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_kernel_host
!! This module defines `kernel_host` type and its type bound procedures.
!! The host kernel is an implementation of the `abstract_kernel` type
!! that runs on the host CPU.
use iso_c_binding
use iso_fortran_env
use dtfft_abstract_kernel
use dtfft_config
use dtfft_parameters
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
#include "_dtfft_profile.h"
implicit none
private
public :: kernel_host

! Exporting internal kernels for testing purposes
public :: unpack_f32
public :: permute_forward_write_f32, permute_backward_write_f32
public :: permute_backward_start_write_f32
public :: permute_forward_write_f32_block_4, permute_backward_write_f32_block_4
public :: permute_backward_start_write_f32_block_4
public :: permute_forward_write_f32_block_8, permute_backward_write_f32_block_8
public :: permute_backward_start_write_f32_block_8
public :: permute_forward_write_f32_block_16, permute_backward_write_f32_block_16
public :: permute_backward_start_write_f32_block_16
public :: permute_forward_write_f32_block_32, permute_backward_write_f32_block_32
public :: permute_backward_start_write_f32_block_32
public :: permute_forward_write_f32_block_64, permute_backward_write_f32_block_64
public :: permute_backward_start_write_f32_block_64
public :: permute_forward_read_f32, permute_backward_read_f32
public :: permute_backward_start_read_f32
public :: permute_forward_read_f32_block_4, permute_backward_read_f32_block_4
public :: permute_backward_start_read_f32_block_4
public :: permute_forward_read_f32_block_8, permute_backward_read_f32_block_8
public :: permute_backward_start_read_f32_block_8
public :: permute_forward_read_f32_block_16, permute_backward_read_f32_block_16
public :: permute_backward_start_read_f32_block_16
public :: permute_forward_read_f32_block_32, permute_backward_read_f32_block_32
public :: permute_backward_start_read_f32_block_32
public :: permute_forward_read_f32_block_64, permute_backward_read_f32_block_64
public :: permute_backward_start_read_f32_block_64
public :: permute_backward_end_write_f32, permute_backward_end_read_f32
public :: permute_backward_end_write_f32_block_4
public :: permute_backward_end_write_f32_block_8
public :: permute_backward_end_write_f32_block_16
public :: permute_backward_end_write_f32_block_32
public :: permute_backward_end_write_f32_block_64
public :: permute_backward_end_read_f32_block_4
public :: permute_backward_end_read_f32_block_8
public :: permute_backward_end_read_f32_block_16
public :: permute_backward_end_read_f32_block_32
public :: permute_backward_end_read_f32_block_64
public :: unpack_f32_block_4
public :: unpack_f32_block_8
public :: unpack_f32_block_16
public :: unpack_f32_block_32
public :: unpack_f32_block_64

public :: pack_forward_write_f32, pack_backward_write_f32
public :: pack_forward_write_f32_block_4, pack_backward_write_f32_block_4
public :: pack_forward_write_f32_block_8, pack_backward_write_f32_block_8
public :: pack_forward_write_f32_block_16, pack_backward_write_f32_block_16
public :: pack_forward_write_f32_block_32, pack_backward_write_f32_block_32
public :: pack_forward_write_f32_block_64, pack_backward_write_f32_block_64
public :: pack_forward_read_f32, pack_backward_read_f32
public :: pack_forward_read_f32_block_4, pack_backward_read_f32_block_4
public :: pack_forward_read_f32_block_8, pack_backward_read_f32_block_8
public :: pack_forward_read_f32_block_16, pack_backward_read_f32_block_16
public :: pack_forward_read_f32_block_32, pack_backward_read_f32_block_32
public :: pack_forward_read_f32_block_64, pack_backward_read_f32_block_64

public :: unpack_forward_write_f32, unpack_forward_read_f32
public :: unpack_forward_write_f32_block_4, unpack_forward_read_f32_block_4
public :: unpack_forward_write_f32_block_8, unpack_forward_read_f32_block_8
public :: unpack_forward_write_f32_block_16, unpack_forward_read_f32_block_16
public :: unpack_forward_write_f32_block_32, unpack_forward_read_f32_block_32
public :: unpack_forward_write_f32_block_64, unpack_forward_read_f32_block_64

public :: unpack_backward_write_f32, unpack_backward_read_f32
public :: unpack_backward_write_f32_block_4, unpack_backward_read_f32_block_4
public :: unpack_backward_write_f32_block_8, unpack_backward_read_f32_block_8
public :: unpack_backward_write_f32_block_16, unpack_backward_read_f32_block_16
public :: unpack_backward_write_f32_block_32, unpack_backward_read_f32_block_32
public :: unpack_backward_write_f32_block_64, unpack_backward_read_f32_block_64

public :: pack_f32
public :: pack_f32_block_4, pack_f32_block_8
public :: pack_f32_block_16
public :: pack_f32_block_32, pack_f32_block_64

#ifdef DTFFT_WITH_MOCK_ENABLED
public :: permute_forward_write_f64, permute_forward_write_f128
public :: permute_backward_end_pipelined_write_f32, permute_backward_write_f64, permute_backward_write_f128
public :: permute_backward_start_write_f64, permute_backward_start_write_f128
public :: permute_backward_end_pipelined_write_f64, permute_backward_end_pipelined_write_f128
public :: permute_backward_end_write_f64, permute_backward_end_write_f128
public :: unpack_pipelined_f32, unpack_pipelined_f64, unpack_pipelined_f128
public :: pack_pipelined_f32, pack_pipelined_f64, pack_pipelined_f128
public :: pack_forward_write_f64, pack_forward_write_f128
public :: pack_backward_write_f64, pack_backward_write_f128
public :: copy_f32, copy_f64, copy_f128
#endif

    type :: host_kernel_t
        integer(int8) :: val
    end type host_kernel_t

    type(host_kernel_t), parameter, public :: HOST_KERNEL_UNSET = host_kernel_t(-1_int8)

    type(host_kernel_t), parameter, public :: HOST_KERNEL_BASE = host_kernel_t(1_int8)
    !! Base host kernel type
    type(host_kernel_t), parameter, public :: HOST_KERNEL_BLOCK_4 = host_kernel_t(2_int8)
    !! Host kernel with block size of 4
    type(host_kernel_t), parameter, public :: HOST_KERNEL_BLOCK_8 = host_kernel_t(3_int8)
    !! Host kernel with block size of 8
    type(host_kernel_t), parameter, public :: HOST_KERNEL_BLOCK_16 = host_kernel_t(4_int8)
    !! Host kernel with block size of 16
    type(host_kernel_t), parameter, public :: HOST_KERNEL_BLOCK_32 = host_kernel_t(5_int8)
    !! Host kernel with block size of 32
    type(host_kernel_t), parameter, public :: HOST_KERNEL_BLOCK_64 = host_kernel_t(6_int8)
    !! Host kernel with block size of 64

    interface operator(==)
        module procedure host_kernel_eq
    end interface

    type, extends(abstract_kernel) :: kernel_host
    !! Host kernel implementation
    private
        type(dtfft_access_mode_t) :: access_mode
        !! Access mode for kernel execution
        procedure(execute_host_interface), pointer :: execute_impl => null()
        !! Pointer to the execute implementation
    contains
        procedure :: create_private => create_host    !! Creates kernel
        procedure :: execute_private => execute_host  !! Executes kernel
        procedure :: destroy_private => destroy_host  !! Destroys kernel
        procedure :: execute_benchmark
        procedure :: select_access_mode_f32
        procedure :: select_access_mode_f64
        procedure :: select_access_mode_f128
    end type kernel_host

    abstract interface
        subroutine execute_host_interface(self, in, out, neighbor)
        !! Executes the given kernel on host
            import
            class(kernel_host),         intent(in)      :: self     !! Host kernel class
            type(c_ptr),                intent(in)      :: in       !! Source host-allocated buffer
            type(c_ptr),                intent(in)      :: out      !! Target host-allocated buffer
            integer(int32), optional,   intent(in)      :: neighbor !! Source rank for pipelined unpacking
        end subroutine execute_host_interface
    end interface

contains

    subroutine create_host(self, effort, base_storage, force_effort)
    !! Creates host kernel
        class(kernel_host),     intent(inout)   :: self         !! Host kernel class
        type(dtfft_effort_t),   intent(in)      :: effort       !! Effort level for generating transpose kernels
        integer(int64),         intent(in)      :: base_storage !! Number of bytes needed to store single element
        logical,    optional,   intent(in)      :: force_effort !! Should effort be forced or not
        logical                         :: force_effort_    !! Local copy of force_effort
        integer(int32)                  :: n_iters          !! Number of iterations to perform when testing kernel
        integer(int32)                  :: n_warmup_iters   !! Number of warmup iterations to perform before testing kernel
        real(real32)                    :: best_time        !! Best execution time
        real(real64)                    :: execution_time   !! Execution time
        integer(int8)                   :: test_id          !! Current test configuration id
        type(host_kernel_t)             :: current_kernel   !! Current test configuration
        type(host_kernel_t)             :: best_kernel      !! Best kernel type
        character(len=:),   allocatable :: global_phase     !! Global phase name for profiling
        character(len=:),   allocatable :: local_phase      !! Local phase name for profiling
        real(real32)                    :: bandwidth        !! Bandwidth for kernel execution
        integer(int32)                  :: ndims            !! Number of dimensions
        integer(int32),     allocatable :: fixed_dims(:)    !! Fixed dimensions for bandwidth calculation
        ! real(real32),       allocatable :: in(:), out(:)    !! Host buffers for benchmarking
        type(c_ptr) :: in, out
        type(kernel_type_t)             :: temp_kernel_type !! Temporary storage for kernel type

        self%access_mode = get_conf_access_mode()

        force_effort_ = .false.; if (present(force_effort)) force_effort_ = force_effort
        if ((effort == DTFFT_ESTIMATE .and. force_effort_) &
            .or. .not. ( effort == DTFFT_EXHAUSTIVE .or. get_conf_kernel_autotune_enabled()) &
            .or. any(self%kernel_type == [KERNEL_COPY, KERNEL_COPY_PIPELINED]) ) then
            self%execute_impl => select_kernel(HOST_KERNEL_BASE, base_storage)
            return
        end if

        n_warmup_iters = get_conf_measure_warmup_iters()
        n_iters = get_conf_measure_iters()
        best_time = MAX_REAL32

        ndims = size(self%dims)
        allocate (fixed_dims(ndims))
        fixed_dims(1:ndims) = self%dims(1:ndims)
        if (is_unpack_kernel(self%kernel_type) .or. is_pack_kernel(self%kernel_type)) fixed_dims(1:ndims) = self%neighbor_data(1:ndims, 1)

        in = mem_alloc_host(base_storage * product(self%dims))
        out = mem_alloc_host(base_storage * product(self%dims))

        temp_kernel_type = self%kernel_type
        select case ( self%kernel_type%val )
        case ( KERNEL_PERMUTE_BACKWARD_END%val )
            self%kernel_type = KERNEL_PERMUTE_BACKWARD_END_PIPELINED
        case ( KERNEL_UNPACK%val )
            self%kernel_type = KERNEL_UNPACK_PIPELINED
        case ( KERNEL_PACK%val )
            self%kernel_type = KERNEL_PACK_PIPELINED
        case ( KERNEL_UNPACK_FORWARD%val )
            self%kernel_type = KERNEL_UNPACK_FORWARD_PIPELINED
        case ( KERNEL_UNPACK_BACKWARD%val )
            self%kernel_type = KERNEL_UNPACK_BACKWARD_PIPELINED
        endselect

        allocate( global_phase, source="Benchmarking kernel: '"//self%kernel_string%raw//"'" )
        PHASE_BEGIN(global_phase, COLOR_STEEL_BLUE)
        WRITE_INFO(global_phase)

        do test_id = HOST_KERNEL_BASE%val, HOST_KERNEL_BLOCK_64%val
            current_kernel = host_kernel_t(test_id)

            self%execute_impl => select_kernel(current_kernel, base_storage)

            if (current_kernel == HOST_KERNEL_BASE .and. .not. (any(self%kernel_type == [KERNEL_PACK_PIPELINED, KERNEL_UNPACK_PIPELINED]))) then
                allocate( local_phase, source="Selecting access mode" )
                REGION_BEGIN(local_phase, COLOR_ORCHID)
                WRITE_INFO("    "//local_phase)

                select case (base_storage)
                case (FLOAT_STORAGE_SIZE)
                    call self%select_access_mode_f32(in, out, n_warmup_iters, n_iters, execution_time)
                case (DOUBLE_STORAGE_SIZE)
                    call self%select_access_mode_f64(in, out, n_warmup_iters, n_iters, execution_time)
                case (DOUBLE_COMPLEX_STORAGE_SIZE)
                    call self%select_access_mode_f128(in, out, n_warmup_iters, n_iters, execution_time)
                end select
            else
                allocate( local_phase, source="Testing kernel "//get_host_kernel_string(current_kernel) )
                REGION_BEGIN(local_phase, COLOR_AUTOTUNE2)
                WRITE_INFO("    "//local_phase)

                call self%execute_benchmark(in, out, n_warmup_iters, n_iters, execution_time)
            end if

            WRITE_INFO("        Average execution time = "//to_str(execution_time)//" [ms]")
            if (execution_time > 0._real64) then
                bandwidth = 2._real32 * 1000._real32 * real(base_storage * product(fixed_dims), real32) / real(1024 * 1024 * 1024, real32) / real(execution_time, real32)
                WRITE_INFO("        Bandwidth = "//to_str(bandwidth)//" [GB/s]")
            end if

            if (execution_time < best_time) then
                best_time = real(execution_time, real32)
                best_kernel = current_kernel
            end if

            REGION_END(local_phase)
            deallocate( local_phase )
        end do
        WRITE_INFO("  Selected kernel: "//get_host_kernel_string(best_kernel))

        self%kernel_type = temp_kernel_type
        self%execute_impl => select_kernel(best_kernel, base_storage)

        PHASE_END(global_phase)
        deallocate (fixed_dims)
        call mem_free_host(in)
        call mem_free_host(out)
        deallocate (global_phase)
    end subroutine create_host

    subroutine execute_benchmark(self, in, out, n_warmup_iters, n_iters, execution_time)
    !! Executes benchmark for the given kernel
        class(kernel_host), intent(inout)   :: self             !! Host kernel class
        type(c_ptr),        intent(in)      :: in               !! Source host-allocated buffer
        type(c_ptr),        intent(in)      :: out              !! Target host-allocated buffer
        integer(int32),     intent(in)      :: n_warmup_iters   !! Number of warmup iterations to perform before testing kernel
        integer(int32),     intent(in)      :: n_iters          !! Number of iterations to perform when testing kernel
        real(real64),       intent(out)     :: execution_time   !! Execution time of the selected access
        integer(int32) :: iter
        real(real64) :: start_time, end_time

#ifdef DTFFT_DEBUG
        if (.not. associated(self%execute_impl)) then
            INTERNAL_ERROR("kernel_host%execute_benchmark: Kernel execute implementation is not associated!")
        end if
#endif

        REGION_BEGIN("Warmup", COLOR_VIOLET)
        do iter = 1, n_warmup_iters
            call self%execute_impl(in, out, 1)
        end do
        REGION_END("Warmup")

        REGION_BEGIN("Measure", COLOR_DODGER_BLUE)
        start_time = MPI_Wtime()
        do iter = 1, n_iters
            call self%execute_impl(in, out, 1)
        end do
        end_time = MPI_Wtime()
        execution_time = 1000._real64 * (end_time - start_time) / real(n_iters, real64)
        REGION_END("Measure")
    end subroutine execute_benchmark

    subroutine execute_host(self, in, out, stream, sync, neighbor)
    !! Executes host kernel
        class(kernel_host),         intent(inout)   :: self         !! Host kernel class
        type(c_ptr),                intent(in)      :: in           !! Source host-allocated buffer
        type(c_ptr),                intent(in)      :: out          !! Target host-allocated buffer
        type(dtfft_stream_t),       intent(in)      :: stream       !! Stream to execute on, unused here
        logical,                    intent(in)      :: sync         !! Sync stream after kernel execution, unused here
        integer(int32), optional,   intent(in)      :: neighbor     !! Source rank for pipelined unpacking

#ifdef DTFFT_DEBUG
        if (.not. associated(self%execute_impl)) then
            INTERNAL_ERROR("kernel_host%execute_host: Kernel execute implementation is not associated!")
        end if
#endif

        call self%execute_impl(in, out, neighbor)
    end subroutine execute_host

    subroutine destroy_host(self)
    !! Destroys host kernel
        class(kernel_host), intent(inout) :: self !! Host kernel class

        nullify (self%execute_impl)
    end subroutine destroy_host

    function select_kernel(kernel, base_storage) result(fun)
    !! Selects the kernel implementation based on the given id and base storage size
        type(host_kernel_t), intent(in) :: kernel           !! Kernel id
        integer(int64),      intent(in) :: base_storage     !! Size of single element in bytes
        procedure(execute_host_interface), pointer :: fun   !! Selected kernel implementation

        fun => null()
        select case (kernel%val)
        case (HOST_KERNEL_BASE%val)
            select case (base_storage)
            case (FLOAT_STORAGE_SIZE)
                fun => execute_f32
            case (DOUBLE_STORAGE_SIZE)
                fun => execute_f64
            case (DOUBLE_COMPLEX_STORAGE_SIZE)
                fun => execute_f128
            case default
                INTERNAL_ERROR("select_kernel: Unknown kernel "//to_str(kernel%val)//" "//to_str(base_storage))
            end select
        case (HOST_KERNEL_BLOCK_4%val)
            select case (base_storage)
            case (FLOAT_STORAGE_SIZE)
                fun => execute_f32_block_4
            case (DOUBLE_STORAGE_SIZE)
                fun => execute_f64_block_4
            case (DOUBLE_COMPLEX_STORAGE_SIZE)
                fun => execute_f128_block_4
            case default
                INTERNAL_ERROR("select_kernel: Unknown kernel "//to_str(kernel%val)//" "//to_str(base_storage))
            end select
        case (HOST_KERNEL_BLOCK_8%val)
            select case (base_storage)
            case (FLOAT_STORAGE_SIZE)
                fun => execute_f32_block_8
            case (DOUBLE_STORAGE_SIZE)
                fun => execute_f64_block_8
            case (DOUBLE_COMPLEX_STORAGE_SIZE)
                fun => execute_f128_block_8
            case default
                INTERNAL_ERROR("select_kernel: Unknown kernel "//to_str(kernel%val)//" "//to_str(base_storage))
            end select
        case (HOST_KERNEL_BLOCK_16%val)
            select case (base_storage)
            case (FLOAT_STORAGE_SIZE)
                fun => execute_f32_block_16
            case (DOUBLE_STORAGE_SIZE)
                fun => execute_f64_block_16
            case (DOUBLE_COMPLEX_STORAGE_SIZE)
                fun => execute_f128_block_16
            case default
                INTERNAL_ERROR("select_kernel: Unknown kernel "//to_str(kernel%val)//" "//to_str(base_storage))
            end select
        case (HOST_KERNEL_BLOCK_32%val)
            select case (base_storage)
            case (FLOAT_STORAGE_SIZE)
                fun => execute_f32_block_32
            case (DOUBLE_STORAGE_SIZE)
                fun => execute_f64_block_32
            case (DOUBLE_COMPLEX_STORAGE_SIZE)
                fun => execute_f128_block_32
            case default
                INTERNAL_ERROR("select_kernel: Unknown kernel "//to_str(kernel%val)//" "//to_str(base_storage))
            end select
        case (HOST_KERNEL_BLOCK_64%val)
            select case (base_storage)
            case (FLOAT_STORAGE_SIZE)
                fun => execute_f32_block_64
            case (DOUBLE_STORAGE_SIZE)
                fun => execute_f64_block_64
            case (DOUBLE_COMPLEX_STORAGE_SIZE)
                fun => execute_f128_block_64
            case default
                INTERNAL_ERROR("select_kernel: Unknown kernel "//to_str(kernel%val)//" "//to_str(base_storage))
            end select
        case default
            INTERNAL_ERROR("select_kernel: Unknown kernel "//to_str(kernel%val)//" "//to_str(base_storage))
        end select
    end function select_kernel

    function get_host_kernel_string(kernel) result(kernel_string)
    !! Returns string representation of the given host kernel type
        type(host_kernel_t), intent(in) :: kernel       !! Host kernel type
        character(len=:),   allocatable :: kernel_string !! String representation of the kernel

        select case (kernel%val)
        case (HOST_KERNEL_BASE%val)
            allocate( kernel_string, source="BASE" )
        case (HOST_KERNEL_BLOCK_4%val)
            allocate( kernel_string, source="BLOCK_4" )
        case (HOST_KERNEL_BLOCK_8%val)
            allocate( kernel_string, source="BLOCK_8" )
        case (HOST_KERNEL_BLOCK_16%val)
            allocate( kernel_string, source="BLOCK_16" )
        case (HOST_KERNEL_BLOCK_32%val)
            allocate( kernel_string, source="BLOCK_32" )
        case (HOST_KERNEL_BLOCK_64%val)
            allocate( kernel_string, source="BLOCK_64" )
        case default
            allocate( kernel_string, source="UNKNOWN" )
        end select
    end function get_host_kernel_string

    MAKE_EQ_FUN(host_kernel_t, host_kernel_eq)

#define PREC _f128
#define BUFFER_TYPE complex(real64)
#define STORAGE_BYTES DOUBLE_COMPLEX_STORAGE_SIZE
#include "_dtfft_kernel_host_routines.inc"

#define PREC _f64
#define BUFFER_TYPE real(real64)
#define STORAGE_BYTES DOUBLE_STORAGE_SIZE
#include "_dtfft_kernel_host_routines.inc"

#define PREC _f32
#define BUFFER_TYPE real(real32)
#define STORAGE_BYTES FLOAT_STORAGE_SIZE
#include "_dtfft_kernel_host_routines.inc"
end module dtfft_kernel_host

#include "dtfft_config.h"
module test_utils
use iso_fortran_env
use iso_c_binding
use dtfft
use dtfft_parameters, only: COMPLEX_STORAGE_SIZE, DOUBLE_COMPLEX_STORAGE_SIZE, DOUBLE_STORAGE_SIZE, FLOAT_STORAGE_SIZE
use dtfft_utils, only: to_str, mem_alloc_host, mem_free_host
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
#if defined(DTFFT_WITH_CUDA)
use dtfft_parameters, only: NULL_STREAM
use dtfft_interface_cuda_runtime
#include "_dtfft_cuda.h"
#endif
implicit none
private
public :: COMPLEX_STORAGE_SIZE, DOUBLE_COMPLEX_STORAGE_SIZE, DOUBLE_STORAGE_SIZE, FLOAT_STORAGE_SIZE
public :: to_str
#if defined(DTFFT_WITH_CUDA)
public :: NULL_STREAM
#endif
public :: mem_alloc_host, mem_free_host
public :: attach_gpu_to_process
public :: scaleComplexDouble, &
          scaleComplexFloat,  &
          scaleDouble,        &
          scaleFloat

public :: checkAndReportComplexDouble,  &
          checkAndReportComplexFloat,   &
          checkAndReportDouble,         &
          checkAndReportFloat

public :: setTestValuesComplexDouble,   &
          setTestValuesComplexFloat,    &
          setTestValuesDouble,          &
          setTestValuesFloat

public :: complexDoubleH2D,         &
          complexFloatH2D,          &
          doubleH2D,                &
          floatH2D

public :: createGridDims

  interface report
    module procedure :: reportSingle
    module procedure :: reportDouble
  end interface report

#if defined(DTFFT_WITH_CUDA) && !defined(DTFFT_WITH_MOCK_ENABLED)
  interface
    subroutine scaleComplexFloatCUDA(buffer, count, scale, stream) bind(C, name="scaleComplexFloatCUDA")
    import
      type(c_ptr),          value :: buffer
      integer(c_size_t),    value :: count
      integer(c_size_t),    value :: scale
      type(dtfft_stream_t), value :: stream
    end subroutine scaleComplexFloatCUDA

    subroutine scaleComplexDoubleCUDA(buffer, count, scale, stream) bind(C, name="scaleComplexDoubleCUDA")
    import
      type(c_ptr),          value :: buffer
      integer(c_size_t),    value :: count
      integer(c_size_t),    value :: scale
      type(dtfft_stream_t), value :: stream
    end subroutine scaleComplexDoubleCUDA

    subroutine scaleFloatCUDA(buffer, count, scale, stream) bind(C, name="scaleFloatCUDA")
    import
      type(c_ptr),          value :: buffer
      integer(c_size_t),    value :: count
      integer(c_size_t),    value :: scale
      type(dtfft_stream_t), value :: stream
    end subroutine scaleFloatCUDA

    subroutine scaleDoubleCUDA(buffer, count, scale, stream) bind(C, name="scaleDoubleCUDA")
    import
      type(c_ptr),          value :: buffer
      integer(c_size_t),    value :: count
      integer(c_size_t),    value :: scale
      type(dtfft_stream_t), value :: stream
    end subroutine scaleDoubleCUDA
  end interface
#endif

contains

  subroutine reportSingle(tf, tb, local_error, n_global)
    real(real64),       intent(in)  :: tf
    real(real64),       intent(in)  :: tb
    real(real32),       intent(in)  :: local_error
    integer(int64),     intent(in)  :: n_global
    real(real32)        :: errthr

    errthr = 5.0_real32 * log( real(n_global, real32) ) / log(real(2.0, real32)) * (nearest(1._real32, 1._real32) - nearest(1._real32,-1._real32))
    call report_internal(tf, tb, real(local_error, real64), real(errthr, real64))
  end subroutine reportSingle

  subroutine reportDouble(tf, tb, local_error, n_global)
    real(real64),       intent(in)  :: tf
    real(real64),       intent(in)  :: tb
    real(real64),       intent(in)  :: local_error
    integer(int64),     intent(in)  :: n_global
    real(real64)        :: errthr

    errthr = 5.0_real64 * log( real(n_global, real64) ) / log(real(2.0, real64)) * (nearest(1._real64, 1._real64) - nearest(1._real64,-1._real64))
    call report_internal(tf, tb, local_error, errthr)
  end subroutine reportDouble

  subroutine report_internal(tf, tb, local_error, error_threshold)
    real(real64),       intent(in)  :: tf
    real(real64),       intent(in)  :: tb
    real(real64),       intent(in)  :: local_error
    real(real64),       intent(in)  :: error_threshold
    integer(int32)                  :: comm_rank, comm_size, ierr
    real(real64) :: global_error

    call MPI_Comm_size(MPI_COMM_WORLD, comm_size, ierr)
    call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)

    call MPI_Allreduce(local_error, global_error, 1, MPI_REAL8, MPI_MAX, MPI_COMM_WORLD, ierr)
    if(comm_rank == 0) then
      write(output_unit, '(a)') repeat("*", 40)
      if(global_error <= error_threshold .and. global_error >= 0._real64) then
        write(output_unit, '(a)') "            Test PASSED!"
      else
        write(output_unit, '(a, d16.5, a, d16.5)') "Test FAILED... error = ", global_error, ' threshold = ', error_threshold
        call MPI_Abort(MPI_COMM_WORLD, -1, ierr)
      endif
      write(output_unit, '(a)') repeat("*", 40)
    endif
    call write_timers("Forward", tf, comm_rank, comm_size)
    if(comm_rank == 0) write(output_unit, '(a)') repeat("-", 40)
    call write_timers("Backward", tb, comm_rank, comm_size)
    if(comm_rank == 0) write(output_unit, '(a)') repeat("*", 40)
  end subroutine report_internal

  subroutine write_timers(direction, execution_time, comm_rank, comm_size)
    character(len=*), intent(in)  :: direction
    real(real64),     intent(in)  :: execution_time
    integer(int32),   intent(in)  :: comm_rank
    integer(int32),   intent(in)  :: comm_size
    real(real64) :: max_time, min_time, avg_time
    integer(int32) :: ierr

    call MPI_Allreduce(execution_time, max_time, 1, MPI_REAL8, MPI_MAX, MPI_COMM_WORLD, ierr)
    call MPI_Allreduce(execution_time, min_time, 1, MPI_REAL8, MPI_MIN, MPI_COMM_WORLD, ierr)
    call MPI_Allreduce(execution_time, avg_time, 1, MPI_REAL8, MPI_SUM, MPI_COMM_WORLD, ierr)
    avg_time = avg_time / real(comm_size, real64)

    if ( comm_rank == 0 ) then
      write(output_unit, '(a)') direction//" execution time"
      write(output_unit, '(a)') "  max: "//to_str(max_time)//" [s]"
      write(output_unit, '(a)') "  min: "//to_str(min_time)//" [s]"
      write(output_unit, '(a)') "  avg: "//to_str(avg_time)//" [s]"
    endif
  end subroutine write_timers

  subroutine attach_gpu_to_process() bind(C)
#if defined(DTFFT_WITH_CUDA)
    integer(int32) :: comm_rank, ierr, host_rank, host_size, num_devices
    TYPE_MPI_COMM  :: host_comm
    character(len=5) :: platform_env

    call get_environment_variable("DTFFT_PLATFORM", platform_env)
    ! Default execution on device
    if ( trim(adjustl(platform_env)) == "host" ) return

    CUDA_CALL( cudaGetDeviceCount(num_devices) )
    if ( num_devices == 0 ) return

    call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)
    call MPI_Comm_split_type(MPI_COMM_WORLD, MPI_COMM_TYPE_SHARED, comm_rank, MPI_INFO_NULL, host_comm, ierr)
    call MPI_Comm_rank(host_comm, host_rank, ierr)
    call MPI_Comm_size(host_comm, host_size, ierr)
    call MPI_Comm_free(host_comm, ierr)

    if ( host_size > num_devices ) return
    CUDA_CALL( cudaSetDevice(host_rank) )
#endif
  end subroutine attach_gpu_to_process

  subroutine setTestValuesDouble(buffer, buf_size) bind(C, name="setTestValuesDouble")
    type(c_ptr),        intent(in), value :: buffer
    integer(c_size_t),  intent(in), value :: buf_size
    real(real64), pointer :: buf(:)
    real(real64) :: rnd
    integer(int64) :: i

    call c_f_pointer(buffer, buf, [buf_size])
    do i = 1, buf_size
      call random_number(rnd)
      buf(i) = rnd
    enddo
  end subroutine setTestValuesDouble

  subroutine setTestValuesFloat(buffer, buf_size) bind(C, name="setTestValuesFloat")
    type(c_ptr),        intent(in), value :: buffer
    integer(c_size_t),  intent(in), value :: buf_size
    real(real32), pointer :: buf(:)
    real(real32) :: rnd
    integer(int64) :: i
    ! integer :: rank, ierr

    ! call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierr)

    call c_f_pointer(buffer, buf, [buf_size])
    do i = 1, buf_size
      call random_number(rnd)
      buf(i) = rnd
      ! buf(i) = real(rank * 1000 + i, real32) !rnd
    enddo
  end subroutine setTestValuesFloat

  subroutine setTestValuesComplexDouble(buffer, buf_size) bind(C, name="setTestValuesComplexDouble")
    type(c_ptr),        intent(in), value :: buffer
    integer(c_size_t),  intent(in), value :: buf_size
    call setTestValuesDouble(buffer, 2 * buf_size)
  end subroutine setTestValuesComplexDouble

  subroutine setTestValuesComplexFloat(buffer, buf_size) bind(C, name="setTestValuesComplexFloat")
    type(c_ptr),        intent(in), value :: buffer
    integer(c_size_t),  intent(in), value :: buf_size
    call setTestValuesFloat(buffer, 2 * buf_size)
  end subroutine setTestValuesComplexFloat

#define FUNC_NAME doubleH2D
#define FUNC_NAME_STR "doubleH2D"
#define DTYPE real(real64)
#define STORAGE_BYTES DOUBLE_STORAGE_SIZE
#include "h2d.inc"

#define FUNC_NAME floatH2D
#define FUNC_NAME_STR "floatH2D"
#define DTYPE real(real32)
#define STORAGE_BYTES FLOAT_STORAGE_SIZE
#include "h2d.inc"

#define FUNC_NAME complexDoubleH2D
#define FUNC_NAME_STR "complexDoubleH2D"
#define DTYPE complex(real64)
#define STORAGE_BYTES DOUBLE_COMPLEX_STORAGE_SIZE
#include "h2d.inc"

#define FUNC_NAME complexFloatH2D
#define FUNC_NAME_STR "complexFloatH2D"
#define DTYPE complex(real32)
#define STORAGE_BYTES COMPLEX_STORAGE_SIZE
#include "h2d.inc"

  subroutine scaleFloatHost(buffer, buf_size, scale) bind(C, name="scaleFloatHost")
    type(c_ptr),        value :: buffer
    integer(c_size_t),  value :: buf_size
    integer(c_size_t),  value :: scale
    real(real32), pointer :: buf(:)

    call c_f_pointer(buffer, buf, [buf_size])
    buf(:) = buf(:) / real(scale, real32)
  end subroutine scaleFloatHost

  subroutine scaleDoubleHost(buffer, buf_size, scale) bind(C, name="scaleDoubleHost")
    type(c_ptr),        value :: buffer
    integer(c_size_t),  value :: buf_size
    integer(c_size_t),  value :: scale
    real(real64), pointer :: buf(:)

    call c_f_pointer(buffer, buf, [buf_size])
    buf(:) = buf(:) / real(scale, real64)
  end subroutine scaleDoubleHost

  subroutine scaleComplexFloatHost(buffer, buf_size, scale) bind(C, name="scaleComplexFloatHost")
    type(c_ptr),        value :: buffer
    integer(c_size_t),  value :: buf_size
    integer(c_size_t),  value :: scale
    call scaleFloatHost(buffer, 2 * buf_size, scale)
  end subroutine scaleComplexFloatHost

  subroutine scaleComplexDoubleHost(buffer, buf_size, scale) bind(C, name="scaleComplexDoubleHost")
    type(c_ptr),        value :: buffer
    integer(c_size_t),  value :: buf_size
    integer(c_size_t),  value :: scale
    call scaleDoubleHost(buffer, 2 * buf_size, scale)
  end subroutine scaleComplexDoubleHost

#if defined(DTFFT_WITH_MOCK_ENABLED)
  subroutine scaleComplexFloatCUDA(buffer, count, scale, stream) bind(C, name="scaleComplexFloatCUDA")
    type(c_ptr),          value :: buffer
    integer(c_size_t),    value :: count
    integer(c_size_t),    value :: scale
    type(dtfft_stream_t), value :: stream
    call scaleComplexFloatHost(buffer, count, scale)
  end subroutine scaleComplexFloatCUDA

  subroutine scaleComplexDoubleCUDA(buffer, count, scale, stream) bind(C, name="scaleComplexDoubleCUDA")
    type(c_ptr),          value :: buffer
    integer(c_size_t),    value :: count
    integer(c_size_t),    value :: scale
    type(dtfft_stream_t), value :: stream
    call scaleComplexDoubleHost(buffer, count, scale)
  end subroutine scaleComplexDoubleCUDA

  subroutine scaleFloatCUDA(buffer, count, scale, stream) bind(C, name="scaleFloatCUDA")
    type(c_ptr),          value :: buffer
    integer(c_size_t),    value :: count
    integer(c_size_t),    value :: scale
    type(dtfft_stream_t), value :: stream
    call scaleFloatHost(buffer, count, scale)
  end subroutine scaleFloatCUDA

  subroutine scaleDoubleCUDA(buffer, count, scale, stream) bind(C, name="scaleDoubleCUDA")
    type(c_ptr),          value :: buffer
    integer(c_size_t),    value :: count
    integer(c_size_t),    value :: scale
    type(dtfft_stream_t), value :: stream
    call scaleDoubleHost(buffer, count, scale)
  end subroutine scaleDoubleCUDA
#endif

  function checkFloat(check, buf, buf_size) result(err)
    type(c_ptr)         :: check
    type(c_ptr)         :: buf
    integer(c_size_t)   :: buf_size
    real(c_float)       :: err
    real(real32),  pointer :: check_(:)
    real(real32),  pointer :: buf_(:)
    integer :: i

    call c_f_pointer(check, check_, [buf_size])
    call c_f_pointer(buf, buf_, [buf_size])
    err = maxval(abs(check_ - buf_))
    do i = 1, buf_size
      if ( abs(check_(i) - buf_(i)) > 1e-3 ) then
        print*,'i = ',i,check_(i),buf_(i)
        stop
      endif
    enddo
  end function checkFloat

  function checkDouble(check, buf, buf_size) result(err)
    type(c_ptr)         :: check
    type(c_ptr)         :: buf
    integer(c_size_t)  :: buf_size
    real(c_double)     :: err
    real(real64),  pointer :: check_(:)
    real(real64),  pointer :: buf_(:)

    call c_f_pointer(check, check_, [buf_size])
    call c_f_pointer(buf, buf_, [buf_size])
    err = maxval(abs(check_ - buf_))
  end function checkDouble

  function checkComplexFloat(check, buf, buf_size) result(err)
    type(c_ptr)         :: check
    type(c_ptr)         :: buf
    integer(c_size_t)  :: buf_size
    real(c_float)      :: err
    err = checkFloat(check, buf, 2 * buf_size)
  end function checkComplexFloat

  function checkComplexDouble(check, buf, buf_size) result(err)
    type(c_ptr)         :: check
    type(c_ptr)         :: buf
    integer(c_size_t)  :: buf_size
    real(c_double)     :: err
    err = checkDouble(check, buf, 2 * buf_size)
  end function checkComplexDouble

  subroutine createGridDims(ndims, dims, grid, starts, counts) bind(C, name="createGridDims")
    integer(c_int32_t), intent(in), value :: ndims
    integer(c_int32_t), intent(in)    :: dims(*)
    integer(c_int32_t), intent(inout) :: grid(*)
    integer(c_int32_t), intent(out)   :: starts(*)
    integer(c_int32_t), intent(out)   :: counts(*)
    integer(int32) :: comm_size, comm_rank, temp_rank, i, ierr
    integer(int32) :: coords(ndims)

    call MPI_Comm_size(MPI_COMM_WORLD, comm_size, ierr)
    call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)
    call MPI_Dims_create(comm_size, ndims, grid, ierr)

    coords(:) = 0
    temp_rank = comm_rank

    do i = 1, ndims
      coords(i) = mod(temp_rank, grid(i))
      temp_rank = temp_rank / grid(i)
    end do

    do i = 1, ndims
      counts(i) = dims(i) / grid(i)
      starts(i) = coords(i) * counts(i)

      if (coords(i) == grid(i) - 1) then
        counts(i) = counts(i) + mod(dims(i), grid(i))
      end if
    end do
  end subroutine createGridDims


#define FUNC_NAME scaleComplexDouble
#define FUNC_NAME_STR "scaleComplexDouble"
#include "scale.inc"

#define FUNC_NAME scaleComplexFloat
#define FUNC_NAME_STR "scaleComplexFloat"
#include "scale.inc"

#define FUNC_NAME scaleDouble
#define FUNC_NAME_STR "scaleDouble"
#include "scale.inc"

#define FUNC_NAME scaleFloat
#define FUNC_NAME_STR "scaleFloat"
#include "scale.inc"


#define STORAGE_BYTES DOUBLE_COMPLEX_STORAGE_SIZE
#define FUNC_NAME checkAndReportComplexDouble
#define FUNC_NAME_STR "checkAndReportComplexDouble"
#define CHECK_FUNC checkComplexDouble
#define ERROR_PRECISION c_double
#include "check_and_report.inc"

#define STORAGE_BYTES COMPLEX_STORAGE_SIZE
#define FUNC_NAME checkAndReportComplexFloat
#define FUNC_NAME_STR "checkAndReportComplexFloat"
#define CHECK_FUNC checkComplexFloat
#define ERROR_PRECISION c_float
#include "check_and_report.inc"

#define STORAGE_BYTES DOUBLE_STORAGE_SIZE
#define FUNC_NAME checkAndReportDouble
#define FUNC_NAME_STR "checkAndReportDouble"
#define CHECK_FUNC checkDouble
#define ERROR_PRECISION c_double
#include "check_and_report.inc"

#define STORAGE_BYTES FLOAT_STORAGE_SIZE
#define FUNC_NAME checkAndReportFloat
#define FUNC_NAME_STR "checkAndReportFloat"
#define CHECK_FUNC checkFloat
#define ERROR_PRECISION c_float
#include "check_and_report.inc"
end module test_utils

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
program test_r2c_3d_float
use iso_fortran_env
use iso_c_binding, only: c_loc, c_ptr
use dtfft
use test_utils
#include "_dtfft_mpi.h"
#if defined(DTFFT_WITH_CUDA)
use dtfft_interface_cuda_runtime
#if defined(__NVCOMPILER)
use cudafor, only: cuda_stream_kind
#endif
#endif
#include "_dtfft_cuda.h"
#include "dtfft.f03"
implicit none
#ifndef DTFFT_TRANSPOSE_ONLY
  type(c_ptr) :: check
  real(real32),     allocatable, target :: in(:,:,:)
  complex(real32),  allocatable, target :: out(:)
#if defined(DTFFT_WITH_CUDA)
  integer(int32), parameter :: nx = 513, ny = 711, nz = 33
#else
  integer(int32), parameter :: nx = 57, ny = 8, nz = 4
#endif
  integer(int32) :: comm_size, comm_rank, ierr
  type(dtfft_executor_t) :: executor
  type(dtfft_plan_r2c_t) :: plan
  integer(int32) :: in_counts(3), out_counts(3)
  integer(int64) :: alloc_size, in_size, out_size
  real(real64) :: tf, tb
  type(dtfft_config_t) :: conf
#if defined(DTFFT_WITH_CUDA) && defined(__NVCOMPILER)
  integer(cuda_stream_kind) :: cuda_stream
#endif
#if defined(DTFFT_WITH_CUDA)
  type(dtfft_stream_t) :: dtfft_stream
  type(dtfft_platform_t) :: platform
#endif

  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, comm_size, ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)

  if(comm_rank == 0) then
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a)') "|       dtFFT test: r2c_3d_float       |"
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a, i0, a, i0, a, i0)') 'Nx = ',nx, ', Ny = ',ny, ', Nz = ', nz
    write(output_unit, '(a, i0)') 'Number of processors: ', comm_size
    write(output_unit, '(a)') "----------------------------------------"
  endif
#ifdef DTFFT_TRANSPOSE_ONLY
  if ( comm_rank == 0 ) &
    write(output_unit, '(a)') "R2C Transpose plan not supported, skipping it"

  call MPI_Finalize(ierr)
  stop
#endif

  call attach_gpu_to_process()
  call dtfft_create_config(conf)

  executor = DTFFT_EXECUTOR_NONE

#if defined (DTFFT_WITH_FFTW)
  executor = DTFFT_EXECUTOR_FFTW3
#elif defined (DTFFT_WITH_MKL)
  executor = DTFFT_EXECUTOR_MKL
#endif

#if defined(DTFFT_WITH_CUDA)
  block
    character(len=5) :: platform_env
    integer(int32) :: env_len

    call get_environment_variable("DTFFT_PLATFORM", platform_env, env_len)

    if ( env_len == 0 .or. trim(adjustl(platform_env)) == "cuda" ) then
#if !defined(__NVCOMPILER)
      if ( comm_rank == 0 ) &
        write(output_unit, '(a)') "This test requires NVFortran in order to run on GPU"
      call MPI_Finalize(ierr)
      stop
#endif
#ifdef DTFFT_WITH_NCCL
      conf%backend = DTFFT_BACKEND_NCCL
#else
      conf%backend = DTFFT_BACKEND_MPI_P2P
#endif
# if defined( DTFFT_WITH_VKFFT )
      executor = DTFFT_EXECUTOR_VKFFT
      conf%enable_z_slab = .false.
# elif defined( DTFFT_WITH_CUFFT )
      executor = DTFFT_EXECUTOR_CUFFT
# endif
    endif
  endblock
#endif

  if ( executor == DTFFT_EXECUTOR_NONE ) then
    if ( comm_rank == 0 ) &
      write(output_unit, '(a)') "Could not find valid R2C FFT executor, skipping test"
    call MPI_Finalize(ierr)
    stop
  endif

  call dtfft_set_config(conf)

  call plan%create([nx, ny, nz], precision=DTFFT_SINGLE, executor=executor, error_code=ierr); DTFFT_CHECK(ierr)
  call plan%get_local_sizes(in_counts=in_counts, out_counts=out_counts, alloc_size=alloc_size, error_code=ierr); DTFFT_CHECK(ierr)
  call plan%report()

#if defined(DTFFT_WITH_CUDA)
  platform = plan%get_platform(error_code=ierr); DTFFT_CHECK(ierr)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    call plan%get_stream(dtfft_stream, error_code=ierr); DTFFT_CHECK(ierr)
#if defined(__NVCOMPILER)
    ! cuda_stream can be used in CUDA API provided with nvhpc-sdk
    cuda_stream = dtfft_get_cuda_stream(dtfft_stream)
#endif
  endif
#endif

  allocate(in(in_counts(1),in_counts(2), in_counts(3)))
  allocate(out(alloc_size))
!$acc enter data create(in, out) if ( platform == DTFFT_PLATFORM_CUDA )

  in_size = product(in_counts)
  out_size = product(out_counts)

  check = mem_alloc_host(in_size * FLOAT_STORAGE_SIZE)
  call setTestValuesFloat(check, in_size)

#if defined(DTFFT_WITH_CUDA)
!$acc host_data use_device(in) if ( platform == DTFFT_PLATFORM_CUDA )
  call floatH2D(check, c_loc(in), in_size, platform%val)
!$acc end host_data
#else
  call floatH2D(check, c_loc(in), in_size)
#endif


  tf = 0.0_real64 - MPI_Wtime()
!$acc host_data use_device(in, out) if ( platform == DTFFT_PLATFORM_CUDA )
  call plan%execute(in, out, DTFFT_EXECUTE_FORWARD, error_code=ierr)
!$acc end host_data
  DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    CUDA_CALL( cudaStreamSynchronize(dtfft_stream) )
  endif
#endif
  tf = tf + MPI_Wtime()

#if defined(DTFFT_WITH_CUDA)
!$acc host_data use_device(out) if ( platform == DTFFT_PLATFORM_CUDA )
  call scaleComplexFloat(executor%val, c_loc(out), out_size, int(nx * ny * nz, int64), platform%val, dtfft_stream)
!$acc end host_data
#else
  call scaleComplexFloat(executor%val, c_loc(out), out_size, int(nx * ny * nz, int64))
#endif

  tb = 0.0_real64 - MPI_Wtime()
!$acc host_data use_device(in, out) if ( platform == DTFFT_PLATFORM_CUDA )
  call plan%execute(out, in, DTFFT_EXECUTE_BACKWARD, error_code=ierr)
!$acc end host_data
  DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    CUDA_CALL( cudaStreamSynchronize(dtfft_stream) )
  endif
#endif
  tb = tb + MPI_Wtime()

#if defined(DTFFT_WITH_CUDA) && !defined(DTFFT_WITH_MOCK_ENABLED)
!$acc host_data use_device(in) if ( platform == DTFFT_PLATFORM_CUDA )
  call checkAndReportFloat(int(nx * ny * nz, int64), tf, tb, c_loc(in), in_size, check, platform%val)
!$acc end host_data
#else
  call checkAndReportFloat(int(nx * ny * nz, int64), tf, tb, c_loc(in), in_size, check)
#endif

!$acc exit data delete(in, out) if ( platform == DTFFT_PLATFORM_CUDA )

  deallocate(in)
  deallocate(out)
  call mem_free_host(check)

  call plan%destroy()
  call MPI_Finalize(ierr)
#endif
end program test_r2c_3d_float

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_backend_nccl_m
!! NCCL Based GPU Backends [[backend_nccl]]
use iso_fortran_env
use iso_c_binding, only: c_ptr, c_f_pointer, c_loc
use dtfft_abstract_backend, only: abstract_backend, backend_helper
use dtfft_interface_cuda_runtime
use dtfft_interface_nccl
use dtfft_errors
use dtfft_parameters
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_cuda.h"
#include "_dtfft_private.h"
implicit none
private
public :: backend_nccl

    type, extends(abstract_backend) :: backend_nccl
    !! NCCL backend
    private
        type(ncclComm) :: nccl_comm     !! NCCL Communicator
    contains
        procedure :: create_private => create_nccl        !! Creates NCCL backend
        procedure :: execute_private => execute_nccl      !! Executes NCCL backend
        procedure :: destroy_private => destroy_nccl      !! Destroys NCCL backend
    end type backend_nccl

contains

    subroutine create_nccl(self, helper, base_storage)
    !! Creates NCCL backend
        class(backend_nccl),    intent(inout)   :: self               !! NCCL backend
        type(backend_helper),   intent(in)      :: helper             !! Backend helper
        integer(int64),         intent(in)      :: base_storage       !! Number of bytes to store single element (unused)
#ifdef DTFFT_DEBUG
        if (.not. is_backend_nccl(self%backend)) then
            INTERNAL_ERROR(".not. is_backend_nccl")
        endif
        if (.not. helper%is_nccl_created) then
            INTERNAL_ERROR(".not. helper%is_nccl_created")
        endif
#endif
        self%nccl_comm = helper%nccl_comm
    end subroutine create_nccl

    subroutine execute_nccl(self, in, out, stream, aux, error_code)
    !! Executes NCCL backend
        class(backend_nccl),                intent(inout)   :: self       !! NCCL backend
        real(real32),   target, contiguous, intent(inout)   :: in(:)      !! Send pointer
        real(real32),   target, contiguous, intent(inout)   :: out(:)     !! Recv pointer
        type(dtfft_stream_t),               intent(in)      :: stream     !! Main execution CUDA stream
        real(real32),   target, contiguous, intent(inout)   :: aux(:)     !! Aux pointer
        integer(int32),         intent(out)                 :: error_code !! Error code
        integer(int32) :: i        !! Counter
        integer(int32) :: rnk      !! Rank to send-recv
        integer(int32) :: ierr
        real(real32), pointer :: pin(:), pout(:)

        if (self%is_pipelined) then
            pin => in(:)
            pout => aux(:)
        else
            pin => in(:)
            pout => out(:)
        end if

#ifdef DTFFT_WITH_COMPRESSION
        if ( self%backend == DTFFT_BACKEND_NCCL_COMPRESSED ) then
        ! pack: in -> out: in is free
        ! compress: out -> in
        ! send: in -> aux
        ! decompress: aux -> in
        ! unpack: in -> out
        block
            integer(int32), allocatable :: csends(:), crecvs(:)

            allocate(csends(self%comm_size), crecvs(self%comm_size), source=0_int32)
            call self%pack_kernel%execute(c_loc(in), c_loc(pin), stream, aux=c_loc(out), csizes=csends, skip_rank=self%comm_rank + 1)
            call self%execute_self_copy(out, pout, stream)
            call self%unpack_kernel%execute(c_loc(pout), c_loc(out), self%copy_stream, self%comm_rank + 1, aux=c_loc(in), skip_compression=.true.)
            call MPI_Alltoall(csends, 1, MPI_INTEGER, crecvs, 1, MPI_INTEGER, self%comm, ierr)
            self%send_floats(:) = int(csends, int64)
            self%recv_floats(:) = int(crecvs, int64)
            deallocate(csends, crecvs)
        endblock
        endif
#endif

        NCCL_CALL( ncclGroupStart() )
        do i = 0, self%comm_size - 1
            if (i == self%comm_rank .and. self%is_pipelined) cycle
            rnk = self%comm_mapping(i)
            if (self%send_floats(i) > 0) then
                NCCL_CALL( ncclSend(pin(self%send_displs(i)), self%send_floats(i), ncclFloat, rnk, self%nccl_comm, stream) )
            end if
            if (self%recv_floats(i) > 0) then
                NCCL_CALL( ncclRecv(pout(self%recv_displs(i)), self%recv_floats(i), ncclFloat, rnk, self%nccl_comm, stream) )
            end if
        end do
        NCCL_CALL( ncclGroupEnd() )

#ifdef DTFFT_WITH_COMPRESSION
        if ( self%backend == DTFFT_BACKEND_NCCL_COMPRESSED ) then
            call self%wait(stream)
        endif
#endif
        if (self%is_pipelined) then
            do i = 0, self%comm_size - 1
                if (self%recv_floats(i) > 0) then
                    call self%unpack_kernel%execute(c_loc(pout), c_loc(out), stream, i + 1, aux=c_loc(in))
                end if
            end do
        end if
        error_code = DTFFT_SUCCESS
    end subroutine execute_nccl

    subroutine destroy_nccl(self)
    !! Destroys NCCL backend
        class(backend_nccl), intent(inout) :: self       !! NCCL backend

    end subroutine destroy_nccl
end module dtfft_backend_nccl_m

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_parameters
!! This module defines common ``dtFFT`` parameters
use iso_c_binding,    only: c_int32_t, c_null_ptr, c_ptr
use iso_fortran_env,  only: int8, int32, int64, real32, real64
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
implicit none
private
public :: dtfft_execute_t, dtfft_transpose_t, dtfft_reshape_t
public :: dtfft_executor_t, dtfft_effort_t, dtfft_layout_t
public :: dtfft_precision_t, dtfft_r2r_kind_t
public :: is_valid_execute_type, is_valid_transpose_type, is_valid_reshape_type
public :: is_valid_executor, is_valid_effort, is_valid_layout
public :: is_valid_precision, is_valid_r2r_kind
public :: is_valid_dimension, is_valid_comm_type
public :: is_valid_transpose_mode, is_valid_access_mode
public :: dtfft_get_version
public :: dtfft_get_precision_string, dtfft_get_executor_string
public :: dtfft_backend_t, dtfft_stream_t
public :: dtfft_get_backend_string
public :: is_backend_pipelined, is_backend_mpi, is_backend_fused, is_backend_rma
public :: is_valid_backend, is_backend_nccl, is_backend_cufftmp, is_backend_nvshmem
public :: is_backend_compressed
public :: dtfft_get_backend_pipelined
#ifdef DTFFT_WITH_CUDA
public :: is_valid_platform
public :: is_host_executor, is_cuda_executor
public :: dtfft_get_cuda_stream
#endif

  integer(int32), parameter, public :: DTFFT_VERSION_MAJOR = CONF_DTFFT_VERSION_MAJOR
    !! dtFFT Major Version
  integer(int32), parameter, public :: DTFFT_VERSION_MINOR = CONF_DTFFT_VERSION_MINOR
    !! dtFFT Minor Version
  integer(int32), parameter, public :: DTFFT_VERSION_PATCH = CONF_DTFFT_VERSION_PATCH
    !! dtFFT Patch Version
  integer(int32), parameter, public :: DTFFT_VERSION_CODE  = CONF_DTFFT_VERSION_CODE
    !! dtFFT Version Code. Can be used in Version comparison

  interface dtfft_get_version
  !! Get dtFFT version
    module procedure :: dtfft_get_version_current  !! Get current version
    module procedure :: dtfft_get_version_required !! Get required version
  end interface dtfft_get_version

  real(real32),   parameter,  public :: MAX_REAL32  =  huge(1._real32)
    !! Maximum value of real32
  integer(int32), parameter,  public :: MAX_INT32 = huge(1_int32)
    !! Maximum value of int32

!------------------------------------------------------------------------------------------------
! Execute types
!------------------------------------------------------------------------------------------------
  type, bind(C) :: dtfft_execute_t
  !! Type that is used during call to `execute` method
    integer(c_int32_t) :: val !! Internal value
  end type dtfft_execute_t

  type(dtfft_execute_t), parameter, public :: DTFFT_EXECUTE_FORWARD = dtfft_execute_t(CONF_DTFFT_EXECUTE_FORWARD)
    !! Perform XYZ --> YZX --> ZXY plan execution (Forward)
  type(dtfft_execute_t), parameter, public :: DTFFT_EXECUTE_BACKWARD  = dtfft_execute_t(CONF_DTFFT_EXECUTE_BACKWARD)
    !! Perform ZXY --> YZX --> XYZ plan execution (Backward)
  type(dtfft_execute_t), parameter :: VALID_EXECUTE_TYPES(*) = [DTFFT_EXECUTE_FORWARD, DTFFT_EXECUTE_BACKWARD]
    !! Valid execute types

!------------------------------------------------------------------------------------------------
! Transpose types
!------------------------------------------------------------------------------------------------
  type, bind(C) :: dtfft_transpose_t
  !! Type that is used during call to [[dtfft_plan_t(type):transpose]] method
    integer(c_int32_t) :: val !! Internal value
  end type dtfft_transpose_t

  type(dtfft_transpose_t), parameter,  public :: DTFFT_TRANSPOSE_X_TO_Y = dtfft_transpose_t(CONF_DTFFT_TRANSPOSE_X_TO_Y)
    !! Perform single transposition, from X aligned to Y aligned
  type(dtfft_transpose_t), parameter,  public :: DTFFT_TRANSPOSE_Y_TO_X = dtfft_transpose_t(CONF_DTFFT_TRANSPOSE_Y_TO_X)
    !! Perform single transposition, from Y aligned to X aligned
  type(dtfft_transpose_t), parameter,  public :: DTFFT_TRANSPOSE_X_TO_Z = dtfft_transpose_t(CONF_DTFFT_TRANSPOSE_X_TO_Z)
    !! Perform single transposition, from X aligned to Z aligned
  type(dtfft_transpose_t), parameter,  public :: DTFFT_TRANSPOSE_Y_TO_Z = dtfft_transpose_t(CONF_DTFFT_TRANSPOSE_Y_TO_Z)
    !! Perform single transposition, from Y aligned to Z aligned
  type(dtfft_transpose_t), parameter,  public :: DTFFT_TRANSPOSE_Z_TO_Y = dtfft_transpose_t(CONF_DTFFT_TRANSPOSE_Z_TO_Y)
    !! Perform single transposition, from Z aligned to Y aligned
  type(dtfft_transpose_t), parameter,  public :: DTFFT_TRANSPOSE_Z_TO_X = dtfft_transpose_t(CONF_DTFFT_TRANSPOSE_Z_TO_X)
    !! Perform single transposition, from Z aligned to X aligned
  type(dtfft_transpose_t), parameter :: VALID_TRANSPOSE_TYPES(*) = [DTFFT_TRANSPOSE_X_TO_Y, DTFFT_TRANSPOSE_Y_TO_X, DTFFT_TRANSPOSE_Y_TO_Z, DTFFT_TRANSPOSE_Z_TO_Y, DTFFT_TRANSPOSE_X_TO_Z, DTFFT_TRANSPOSE_Z_TO_X]
    !! Types of transpose that are valid to pass to `transpose` method
  character(len=*), parameter,  public :: TRANSPOSE_NAMES(-3:3) = ["Z_TO_X", "Z_TO_Y", "Y_TO_X", " NULL ", "X_TO_Y", "Y_TO_Z", "X_TO_Z"]
    !! String representation of `dtfft_transpose_t`

  type, bind(C) :: dtfft_reshape_t
  !! Type that is used during call to [[dtfft_plan_t(type):reshape]] method
    integer(c_int32_t) :: val !! Internal value
  end type dtfft_reshape_t

  type(dtfft_reshape_t), parameter,  public :: DTFFT_RESHAPE_X_BRICKS_TO_PENCILS  = dtfft_reshape_t(CONF_DTFFT_RESHAPE_X_BRICKS_TO_PENCILS)
    !! Perform reshape to X-aligned pencils (forward) from X-aligned bricks
  type(dtfft_reshape_t), parameter,  public :: DTFFT_RESHAPE_X_PENCILS_TO_BRICKS = dtfft_reshape_t(CONF_DTFFT_RESHAPE_X_PENCILS_TO_BRICKS)
    !! Perform reshape to X-aligned bricks (backward) from X-aligned pencils
  type(dtfft_reshape_t), parameter,  public :: DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS  = dtfft_reshape_t(CONF_DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS)
    !! Perform reshape to Z-aligned bricks (forward) from Z-aligned pencils
  type(dtfft_reshape_t), parameter,  public :: DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS = dtfft_reshape_t(CONF_DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS)
    !! Perform reshape to Z-aligned pencils (backward) from Z-aligned bricks
  type(dtfft_reshape_t), parameter,  public :: DTFFT_RESHAPE_Y_BRICKS_TO_PENCILS = dtfft_reshape_t(CONF_DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS)
    !! Reshape from Y-bricks to Y-pencils
    !! This is to be used in 2D Plans.
  type(dtfft_reshape_t), parameter,  public :: DTFFT_RESHAPE_Y_PENCILS_TO_BRICKS = dtfft_reshape_t(CONF_DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS)
    !! Reshape from Y-pencils to Y-bricks
    !! This is to be used in 2D Plans.
  type(dtfft_reshape_t), parameter :: VALID_RESHAPE_TYPES(*) = [DTFFT_RESHAPE_X_BRICKS_TO_PENCILS, DTFFT_RESHAPE_X_PENCILS_TO_BRICKS, DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS, DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS]
    !! Types of reshape that are valid to pass to `reshape` method
  character(len=*), parameter,  public :: RESHAPE_NAMES(CONF_DTFFT_RESHAPE_X_BRICKS_TO_PENCILS:CONF_DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS) = ["X_BRICKS_TO_PENCILS", "X_PENCILS_TO_BRICKS", "Z_PENCILS_TO_BRICKS", "Z_BRICKS_TO_PENCILS"]
    !! String representations of `dtfft_reshape_t`

  type, bind(C) :: dtfft_layout_t
  !! Type that specifies data layout in distributed array
    integer(c_int32_t) :: val !! Internal value
  end type dtfft_layout_t

  type(dtfft_layout_t),  parameter,  public :: DTFFT_LAYOUT_X_BRICKS = dtfft_layout_t(CONF_DTFFT_LAYOUT_X_BRICKS)
    !! X-brick layout: data is distributed along all dimensions
  type(dtfft_layout_t),  parameter,  public :: DTFFT_LAYOUT_Z_BRICKS = dtfft_layout_t(CONF_DTFFT_LAYOUT_Z_BRICKS)
    !! Z-brick layout: data is distributed along all dimensions
  type(dtfft_layout_t),  parameter,  public :: DTFFT_LAYOUT_X_PENCILS = dtfft_layout_t(CONF_DTFFT_LAYOUT_X_PENCILS)
    !! X-pencil layout: data is distributed along Y and Z dimensions
  type(dtfft_layout_t),  parameter,  public :: DTFFT_LAYOUT_X_PENCILS_FOURIER = dtfft_layout_t(CONF_DTFFT_LAYOUT_X_PENCILS_FOURIER)
    !! X-pencil layout obtained after executing FFT for R2C plan: data is distributed along Y and Z dimensions
  type(dtfft_layout_t),  parameter,  public :: DTFFT_LAYOUT_Y_PENCILS = dtfft_layout_t(CONF_DTFFT_LAYOUT_Y_PENCILS)
    !! Y-pencil layout: data is distributed along X and Z dimensions
  type(dtfft_layout_t),  parameter,  public :: DTFFT_LAYOUT_Z_PENCILS = dtfft_layout_t(CONF_DTFFT_LAYOUT_Z_PENCILS)
    !! Z-pencil layout: data is distributed along X and Y dimensions
  type(dtfft_layout_t),  parameter :: VALID_LAYOUTS(*) = [DTFFT_LAYOUT_X_BRICKS, DTFFT_LAYOUT_Z_BRICKS, DTFFT_LAYOUT_X_PENCILS, DTFFT_LAYOUT_X_PENCILS_FOURIER, DTFFT_LAYOUT_Y_PENCILS, DTFFT_LAYOUT_Z_PENCILS]
    !! Valid layouts

!------------------------------------------------------------------------------------------------
! External FFT executor types
!------------------------------------------------------------------------------------------------
  type, bind(C) :: dtfft_executor_t
  !! Type that specifies external FFT executor
    integer(c_int32_t) :: val !! Internal value
  end type dtfft_executor_t

  type(dtfft_executor_t),  parameter,  public :: DTFFT_EXECUTOR_NONE   = dtfft_executor_t(CONF_DTFFT_EXECUTOR_NONE)
    !! Do not setup any executor. If this type is provided, then `execute` method should not be called.
    !! Use `transpose` method instead
  type(dtfft_executor_t),  parameter,  public :: DTFFT_EXECUTOR_FFTW3 = dtfft_executor_t(CONF_DTFFT_EXECUTOR_FFTW3)
    !! FFTW3 executor
  type(dtfft_executor_t),  parameter,  public :: DTFFT_EXECUTOR_MKL   = dtfft_executor_t(CONF_DTFFT_EXECUTOR_MKL)
    !! MKL executor
  type(dtfft_executor_t),  parameter,  public :: DTFFT_EXECUTOR_CUFFT = dtfft_executor_t(CONF_DTFFT_EXECUTOR_CUFFT)
    !! cuFFT GPU executor
  type(dtfft_executor_t),  parameter,  public :: DTFFT_EXECUTOR_VKFFT = dtfft_executor_t(CONF_DTFFT_EXECUTOR_VKFFT)
    !! VkFFT GPU executor
  type(dtfft_executor_t),  parameter  :: VALID_EXECUTORS(*) = [DTFFT_EXECUTOR_NONE    &
#ifdef DTFFT_WITH_FFTW
    ,DTFFT_EXECUTOR_FFTW3                                                             &
#endif
#ifdef DTFFT_WITH_MKL
    ,DTFFT_EXECUTOR_MKL                                                               &
#endif
#ifdef DTFFT_WITH_CUFFT
    ,DTFFT_EXECUTOR_CUFFT                                                             &
#endif
#ifdef DTFFT_WITH_VKFFT
    ,DTFFT_EXECUTOR_VKFFT                                                             &
#endif
  ]
  !! List of valid executors
#ifdef DTFFT_WITH_CUDA
  type(dtfft_executor_t),  parameter        :: HOST_EXECUTORS(*) = [DTFFT_EXECUTOR_NONE, DTFFT_EXECUTOR_FFTW3, DTFFT_EXECUTOR_MKL]
    !! List of host executors
  type(dtfft_executor_t),  parameter        :: CUDA_EXECUTORS(*) = [DTFFT_EXECUTOR_NONE, DTFFT_EXECUTOR_CUFFT, DTFFT_EXECUTOR_VKFFT]
    !! List of CUDA executors
#endif
!------------------------------------------------------------------------------------------------
! FFT Execution directions
!------------------------------------------------------------------------------------------------
  integer(int8),  parameter,  public :: FFT_FORWARD   = CONF_FFT_FORWARD
    !! Forward c2c transform
  integer(int8),  parameter,  public :: FFT_BACKWARD  = CONF_FFT_BACKWARD
    !! Backward c2c transform

!------------------------------------------------------------------------------------------------
! Effort flags.
!------------------------------------------------------------------------------------------------
  type, bind(C) :: dtfft_effort_t
  !! Type that specifies effort that dtFFT should use when creating plan
    integer(c_int32_t) :: val !! Internal value
  end type dtfft_effort_t

  type(dtfft_effort_t), parameter,  public :: DTFFT_ESTIMATE = dtfft_effort_t(CONF_DTFFT_ESTIMATE)
    !! Estimate flag. ``dtFFT`` will use default decomposition provided by MPI_Dims_create
  type(dtfft_effort_t), parameter,  public :: DTFFT_MEASURE  = dtfft_effort_t(CONF_DTFFT_MEASURE)
    !! Measure flag. ``dtFFT`` will run transpose routines to find the best grid decomposition.
    !! Passing this flag and MPI Communicator with Cartesian topology to `plan%create` makes dtFFT do nothing.
  type(dtfft_effort_t), parameter,  public :: DTFFT_PATIENT  = dtfft_effort_t(CONF_DTFFT_PATIENT)
    !! Patient flag. Same as `DTFFT_MEASURE`, but different MPI datatypes will also be tested
  type(dtfft_effort_t), parameter,  public :: DTFFT_EXHAUSTIVE  = dtfft_effort_t(CONF_DTFFT_EXHAUSTIVE)
    !! Exhaustive flag. Same as `DTFFT_PATIENT`, but all possible backends and reshape backends will be tested to find the best plan.
  type(dtfft_effort_t), parameter :: VALID_EFFORTS(*) = [DTFFT_ESTIMATE, DTFFT_MEASURE, DTFFT_PATIENT, DTFFT_EXHAUSTIVE]
    !! Valid effort flags

!------------------------------------------------------------------------------------------------
! Precision flags
!------------------------------------------------------------------------------------------------
  type, bind(C) :: dtfft_precision_t
  !! Type that specifies precision of dtFFT plan
    integer(c_int32_t) :: val !! Internal value
  end type dtfft_precision_t

  type(dtfft_precision_t),  parameter,  public :: DTFFT_SINGLE = dtfft_precision_t(CONF_DTFFT_SINGLE)
    !! Use single precision
  type(dtfft_precision_t),  parameter,  public :: DTFFT_DOUBLE = dtfft_precision_t(CONF_DTFFT_DOUBLE)
    !! Use double precision
  type(dtfft_precision_t),  parameter :: VALID_PRECISIONS(*) = [DTFFT_SINGLE, DTFFT_DOUBLE]
    !! Valid precision flags

!------------------------------------------------------------------------------------------------
! R2R Transform kinds
! This parameters matches FFTW definitions. Hope they will never change there.
!------------------------------------------------------------------------------------------------
  type, bind(C) :: dtfft_r2r_kind_t
  !! Type that specifies various kinds of R2R FFTs
    integer(c_int32_t) :: val !! Internal value
  end type dtfft_r2r_kind_t

  type(dtfft_r2r_kind_t),   parameter,  public :: DTFFT_DCT_1 = dtfft_r2r_kind_t(CONF_DTFFT_DCT_1)
    !! DCT-I (Logical N=2*(n-1), inverse is `DTFFT_DCT_1`)
  type(dtfft_r2r_kind_t),   parameter,  public :: DTFFT_DCT_2 = dtfft_r2r_kind_t(CONF_DTFFT_DCT_2)
    !! DCT-II (Logical N=2*n, inverse is `DTFFT_DCT_3`)
  type(dtfft_r2r_kind_t),   parameter,  public :: DTFFT_DCT_3 = dtfft_r2r_kind_t(CONF_DTFFT_DCT_3)
    !! DCT-III (Logical N=2*n, inverse is `DTFFT_DCT_2`)
  type(dtfft_r2r_kind_t),   parameter,  public :: DTFFT_DCT_4 = dtfft_r2r_kind_t(CONF_DTFFT_DCT_4)
    !! DCT-IV (Logical N=2*n, inverse is `DTFFT_DCT_4`)
  type(dtfft_r2r_kind_t),   parameter,  public :: DTFFT_DST_1 = dtfft_r2r_kind_t(CONF_DTFFT_DST_1)
    !! DST-I (Logical N=2*(n+1), inverse is `DTFFT_DST_1`)
  type(dtfft_r2r_kind_t),   parameter,  public :: DTFFT_DST_2 = dtfft_r2r_kind_t(CONF_DTFFT_DST_2)
    !! DST-II (Logical N=2*n, inverse is `DTFFT_DST_3`)
  type(dtfft_r2r_kind_t),   parameter,  public :: DTFFT_DST_3 = dtfft_r2r_kind_t(CONF_DTFFT_DST_3)
    !! DST-III (Logical N=2*n, inverse is `DTFFT_DST_2`)
  type(dtfft_r2r_kind_t),   parameter,  public :: DTFFT_DST_4 = dtfft_r2r_kind_t(CONF_DTFFT_DST_4)
    !! DST-IV (Logical N=2*n, inverse is `DTFFT_DST_4`)
  type(dtfft_r2r_kind_t),   parameter :: VALID_R2R_KINDS(*) = [DTFFT_DCT_1, DTFFT_DCT_2, DTFFT_DCT_3, DTFFT_DCT_4, DTFFT_DST_1, DTFFT_DST_2, DTFFT_DST_3, DTFFT_DST_4]
    !! Array of valid R2R kinds

public :: operator(==)
  interface operator(==)
    module procedure execute_type_eq    !! Check if two `dtfft_execute_t` are equal
    module procedure transpose_type_eq  !! Check if two `dtfft_transpose_t` are equal
    module procedure reshape_type_eq    !! Check if two `dtfft_reshape_t` are equal
    module procedure executor_eq        !! Check if two `dtfft_executor_t` are equal
    module procedure effort_eq          !! Check if two `dtfft_effort_t` are equal
    module procedure precision_eq       !! Check if two `dtfft_precision_t` are equal
    module procedure r2r_kind_eq        !! Check if two `dtfft_r2r_kind_t` are equal
    module procedure platform_eq        !! Check if two `dtfft_platform_t` are equal
    module procedure exec_eq            !! Check if two `async_exec_t` are equal
    module procedure backend_eq         !! Check if two `dtfft_backend_t` are equal
    module procedure layout_eq          !! Check if two `dtfft_layout_t` are equal
    module procedure transpose_mode_eq  !! Check if two `dtfft_transpose_mode_t` are equal
    module procedure access_mode_eq     !! Check if two `dtfft_access_mode_t` are equal
  end interface

public :: operator(/=)
  interface operator(/=)
    module procedure execute_type_ne    !! Check if two `dtfft_execute_t` are not equal
    module procedure transpose_type_ne  !! Check if two `dtfft_transpose_t` are not equal
    module procedure reshape_type_ne    !! Check if two `dtfft_reshape_t` are not equal
    module procedure executor_ne        !! Check if two `dtfft_executor_t` are not equal
    module procedure effort_ne          !! Check if two `dtfft_effort_t` are not equal
    module procedure precision_ne       !! Check if two `dtfft_precision_t` are not equal
    module procedure r2r_kind_ne        !! Check if two `dtfft_r2r_kind_t` are not equal
    module procedure platform_ne        !! Check if two `dtfft_platform_t` are not equal
    module procedure backend_ne         !! Check if two `dtfft_backend_t` are not equal
    module procedure layout_ne          !! Check if two `dtfft_layout_t` are not equal
    module procedure transpose_mode_ne  !! Check if two `dtfft_transpose_mode_t` are not equal
    module procedure access_mode_ne     !! Check if two `dtfft_access_mode_t` are not equal
  end interface

!------------------------------------------------------------------------------------------------
! Storage sizes
!------------------------------------------------------------------------------------------------
  integer(int64), parameter,  public :: DOUBLE_COMPLEX_STORAGE_SIZE   = storage_size((1._real64, 1._real64)) / 8_int64
    !! Number of bytes to store single double precision complex element
  integer(int64), parameter,  public :: COMPLEX_STORAGE_SIZE          = storage_size((1._real32, 1._real32)) / 8_int64
    !! Number of bytes to store single float precision complex element
  integer(int64), parameter,  public :: DOUBLE_STORAGE_SIZE           = storage_size(1._real64) / 8_int64
    !! Number of bytes to store single double precision real element
  integer(int64), parameter,  public :: FLOAT_STORAGE_SIZE            = storage_size(1._real32) / 8_int64
    !! Number of bytes to store single single precision real element


  integer(int8),    parameter :: VALID_DIMENSIONS(*) = [2_int8, 3_int8]
    !! Valid dimensions for `plan.create`
  integer(int32),   parameter :: VALID_COMM_TYPES(*) = [MPI_UNDEFINED, MPI_CART]
    !! Valid communicator types for `plan.create`


  integer(int32), parameter,  public :: COLOR_CREATE        = int(Z'00FAB53C')
    !! Color for `plan.create`
  integer(int32), parameter,  public :: COLOR_EXECUTE       = int(Z'00E25DFC')
    !! Color for `plan.execute`
  integer(int32), parameter,  public :: COLOR_TRANSPOSE     = int(Z'00B175BD')
    !! Color for `plan.transpose`
  integer(int32), parameter,  public :: COLOR_TRANSPOSE_XY  = int(Z'005DFCCA')
    !! Color for `DTFFT_TRANSPOSE_X_TO_Y`
  integer(int32), parameter,  public :: COLOR_TRANSPOSE_YX  = int(Z'0076A797')
    !! Color for `DTFFT_TRANSPOSE_Y_TO_X`
  integer(int32), parameter,  public :: COLOR_TRANSPOSE_YZ  = int(Z'00E3CF9F')
    !! Color for `DTFFT_TRANSPOSE_Y_TO_Z`
  integer(int32), parameter,  public :: COLOR_TRANSPOSE_ZY  = int(Z'008C826A')
    !! Color for `DTFFT_TRANSPOSE_Z_TO_Y`
  integer(int32), parameter,  public :: COLOR_TRANSPOSE_XZ  = int(Z'00546F66')
    !! Color for `DTFFT_TRANSPOSE_X_TO_Z`
  integer(int32), parameter,  public :: COLOR_TRANSPOSE_ZX  = int(Z'007A6D7D')
    !! Color for `DTFFT_TRANSPOSE_Z_TO_X`
  integer(int32), parameter,  public :: COLOR_FFT           = int(Z'00FCD05D')
    !! Color for FFT
  integer(int32), parameter,  public :: COLOR_AUTOTUNE      = int(Z'006075FF')
    !! Color for Autotune
  integer(int32), parameter,  public :: COLOR_AUTOTUNE2     = int(Z'0056E874')
    !! Color for Autotune2
  integer(int32), parameter,  public :: COLOR_DESTROY       = int(Z'00000000')
    !! Color for `plan.destroy`
  integer(int32), parameter,  public :: COLOR_TRANSPOSE_PALLETTE(-3:3) = [COLOR_TRANSPOSE_ZX, COLOR_TRANSPOSE_ZY, COLOR_TRANSPOSE_YX, 0, COLOR_TRANSPOSE_XY, COLOR_TRANSPOSE_YZ, COLOR_TRANSPOSE_XZ]
    !! Color pallete for `plan.transpose`

    ! Extended color palette for profiling
  integer(int32), parameter,  public :: COLOR_CORAL         = int(Z'00FF7F50')
    !! Coral
  integer(int32), parameter,  public :: COLOR_TOMATO        = int(Z'00FF6347')
    !! Tomato
  integer(int32), parameter,  public :: COLOR_SALMON        = int(Z'00FA8072')
    !! Salmon
  integer(int32), parameter,  public :: COLOR_LIME          = int(Z'0000FF00')
    !! Lime
  integer(int32), parameter,  public :: COLOR_CHARTREUSE    = int(Z'007FFF00')
    !! Chartreuse
  integer(int32), parameter,  public :: COLOR_CYAN          = int(Z'0000FFFF')
    !! Cyan
  integer(int32), parameter,  public :: COLOR_DODGER_BLUE   = int(Z'001E90FF')
    !! Dodger Blue
  integer(int32), parameter,  public :: COLOR_STEEL_BLUE    = int(Z'004682B4')
    !! Steel Blue
  integer(int32), parameter,  public :: COLOR_ORCHID        = int(Z'00DA70D6')
    !! Orchid
  integer(int32), parameter,  public :: COLOR_VIOLET        = int(Z'00EE82EE')
    !! Violet
  integer(int32), parameter,  public :: COLOR_MAGENTA       = int(Z'00FF00FF')
    !! Magenta
  integer(int32), parameter,  public :: COLOR_INDIGO        = int(Z'004B0082')
    !! Indigo
  integer(int32), parameter,  public :: COLOR_MAROON        = int(Z'00800000')
    !! Maroon
  integer(int32), parameter,  public :: COLOR_OLIVE         = int(Z'00808000')
    !! Olive
  integer(int32), parameter,  public :: COLOR_TEAL          = int(Z'00008080')
    !! Teal
  integer(int32), parameter,  public :: COLOR_NAVY          = int(Z'00000080')
    !! Navy
  integer(int32), parameter,  public :: COLOR_SIENNA        = int(Z'00A0522D')
    !! Sienna
  integer(int32), parameter,  public :: COLOR_PERU          = int(Z'00CD853F')
    !! Peru
  integer(int32), parameter,  public :: COLOR_KHAKI         = int(Z'00F0E68C')
    !! Khaki
  integer(int32), parameter,  public :: COLOR_PLUM          = int(Z'00DDA0DD')
    !! Plum
  integer(int32), parameter,  public :: COLOR_LAVENDER      = int(Z'00E6E6FA')
    !! Lavender
  integer(int32), parameter,  public :: COLOR_MINT          = int(Z'0098FF98')
    !! Mint
  integer(int32), parameter,  public :: COLOR_PEACH         = int(Z'00FFDAB9')
    !! Peach Puff
  integer(int32), parameter,  public :: COLOR_SKY_BLUE      = int(Z'0087CEEB')
    !! Sky Blue
  integer(int32), parameter,  public :: COLOR_SLATE_BLUE    = int(Z'006A5ACD')
    !! Slate Blue
  integer(int32), parameter,  public :: COLOR_SEA_GREEN     = int(Z'002E8B57')
    !! Sea Green
  integer(int32), parameter,  public :: COLOR_FOREST_GREEN  = int(Z'00228B22')
    !! Forest Green
  integer(int32), parameter,  public :: COLOR_YELLOW_GREEN  = int(Z'009ACD32')
    !! Yellow Green
  integer(int32), parameter,  public :: COLOR_ORANGE        = int(Z'00FFA500')
    !! Orange
  integer(int32), parameter,  public :: COLOR_RESHAPE_PALLETTE(CONF_DTFFT_RESHAPE_X_BRICKS_TO_PENCILS:CONF_DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS) = [COLOR_LIME, COLOR_MAGENTA, COLOR_INDIGO, COLOR_PERU]


  integer(int32),  parameter,  public  :: VARIABLE_NOT_SET = -111
  !! Default value when environ is not set

!------------------------------------------------------------------------------------------------
! Backends that are responsible for transfering data between processes
!------------------------------------------------------------------------------------------------
  type, bind(C) :: dtfft_backend_t
  !! Type that specifies various backends present in dtFFT
    integer(c_int32_t) :: val !! Internal value
  end type dtfft_backend_t


  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_MPI_DATATYPE = dtfft_backend_t(CONF_DTFFT_BACKEND_MPI_DATATYPE)
    !! Backend that uses MPI datatypes
    !! This is default backend for Host build.
    !! Not really recommended to use for GPU usage, since it is a 'million' times slower than other backends.
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_MPI_P2P = dtfft_backend_t(CONF_DTFFT_BACKEND_MPI_P2P)
    !! MPI peer-to-peer algorithm
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_MPI_A2A = dtfft_backend_t(CONF_DTFFT_BACKEND_MPI_A2A)
    !! MPI backend using MPI_Alltoallv
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_MPI_RMA = dtfft_backend_t(CONF_DTFFT_BACKEND_MPI_RMA)
    !! MPI RMA backend
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_MPI_RMA_PIPELINED = dtfft_backend_t(CONF_DTFFT_BACKEND_MPI_RMA_PIPELINED)
    !! MPI Pipelined RMA backend
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_MPI_P2P_PIPELINED = dtfft_backend_t(CONF_DTFFT_BACKEND_MPI_P2P_PIPELINED)
    !! MPI peer-to-peer algorithm with overlapping data exchange and unpacking
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_MPI_P2P_SCHEDULED = dtfft_backend_t(CONF_DTFFT_BACKEND_MPI_P2P_SCHEDULED)
    !! MPI peer-to-peer algorithm with scheduled communication
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_MPI_P2P_FUSED = dtfft_backend_t(CONF_DTFFT_BACKEND_MPI_P2P_FUSED)
    !! MPI peer-to-peer pipelined algorithm with overlapping packing, exchange and unpacking with scheduled communication
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_MPI_RMA_FUSED = dtfft_backend_t(CONF_DTFFT_BACKEND_MPI_RMA_FUSED)
    !! MPI RMA pipelined algorithm with overlapping packing, exchange and unpacking with scheduled communication
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_MPI_P2P_COMPRESSED = dtfft_backend_t(CONF_DTFFT_BACKEND_MPI_P2P_COMPRESSED)
    !! Extension of ``DTFFT_BACKEND_MPI_P2P_FUSED``. Performs compression before sending and decomporession after recieving.
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_MPI_RMA_COMPRESSED = dtfft_backend_t(CONF_DTFFT_BACKEND_MPI_RMA_COMPRESSED)
    !! Extension of ``DTFFT_BACKEND_MPI_RMA_FUSED``. Performs compression before sending and decomporession after recieving.
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_NCCL = dtfft_backend_t(CONF_DTFFT_BACKEND_NCCL)
    !! NCCL backend
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_NCCL_PIPELINED = dtfft_backend_t(CONF_DTFFT_BACKEND_NCCL_PIPELINED)
    !! NCCL backend with overlapping data exchange and unpacking
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_NCCL_COMPRESSED = dtfft_backend_t(CONF_DTFFT_BACKEND_NCCL_COMPRESSED)
    !! Extension of ``DTFFT_BACKEND_NCCL``. Performs compression before sending and decomporession after recieving.
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_CUFFTMP = dtfft_backend_t(CONF_DTFFT_BACKEND_CUFFTMP)
    !! cuFFTMp backend
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_CUFFTMP_PIPELINED = dtfft_backend_t(CONF_DTFFT_BACKEND_CUFFTMP_PIPELINED)
    !! cuFFTMp backend that uses extra buffer to gain performance
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_ADAPTIVE = dtfft_backend_t(CONF_DTFFT_BACKEND_ADAPTIVE)
    !! Adaptive backend that selects best available backend at runtime
    !! Currently only available for HOST execution platform
  type(dtfft_backend_t),  parameter,  public  :: DTFFT_BACKEND_NONE = dtfft_backend_t(VARIABLE_NOT_SET)
    !! Backend is not used
  type(dtfft_backend_t),  parameter,  public  :: BACKEND_DUMMY = dtfft_backend_t(2 * VARIABLE_NOT_SET)
  type(dtfft_backend_t),  parameter :: PIPELINED_BACKENDS(*) = [DTFFT_BACKEND_MPI_P2P_PIPELINED, DTFFT_BACKEND_NCCL_PIPELINED, DTFFT_BACKEND_CUFFTMP_PIPELINED, DTFFT_BACKEND_MPI_RMA_PIPELINED]
    !! List of pipelined backends
  type(dtfft_backend_t),  parameter :: FUSED_BACKENDS(*) = [DTFFT_BACKEND_MPI_P2P_FUSED, DTFFT_BACKEND_MPI_RMA_FUSED]
    !! List of fused backends
  type(dtfft_backend_t),  parameter :: RMA_BACKENDS(*) = [DTFFT_BACKEND_MPI_RMA, DTFFT_BACKEND_MPI_RMA_PIPELINED, DTFFT_BACKEND_MPI_RMA_FUSED, DTFFT_BACKEND_MPI_RMA_COMPRESSED]
    !! List of RMA backends
  type(dtfft_backend_t),  parameter :: COMPRESSED_BACKENDS(*) = [DTFFT_BACKEND_MPI_P2P_COMPRESSED, DTFFT_BACKEND_MPI_RMA_COMPRESSED, DTFFT_BACKEND_NCCL_COMPRESSED]
    !! List of backends that support compression
  type(dtfft_backend_t),  parameter :: MPI_BACKENDS(*) = [DTFFT_BACKEND_MPI_DATATYPE, DTFFT_BACKEND_MPI_P2P, DTFFT_BACKEND_MPI_A2A, DTFFT_BACKEND_MPI_P2P_PIPELINED, DTFFT_BACKEND_MPI_RMA, DTFFT_BACKEND_MPI_RMA_PIPELINED, DTFFT_BACKEND_MPI_P2P_SCHEDULED, DTFFT_BACKEND_MPI_P2P_FUSED, DTFFT_BACKEND_MPI_RMA_FUSED, DTFFT_BACKEND_MPI_P2P_COMPRESSED, DTFFT_BACKEND_MPI_RMA_COMPRESSED]
    !! List of MPI backends
  type(dtfft_backend_t),  parameter :: NCCL_BACKENDS(*) = [DTFFT_BACKEND_NCCL, DTFFT_BACKEND_NCCL_PIPELINED, DTFFT_BACKEND_NCCL_COMPRESSED]
    !! List of NCCL backends
  type(dtfft_backend_t),  parameter :: CUFFTMP_BACKENDS(*) = [DTFFT_BACKEND_CUFFTMP, DTFFT_BACKEND_CUFFTMP_PIPELINED]
    !! List of cuFFTMp backends
  type(dtfft_backend_t),  parameter :: NVSHMEM_BACKENDS(*) = [DTFFT_BACKEND_CUFFTMP, DTFFT_BACKEND_CUFFTMP_PIPELINED]
    !! List of NVSHMEM-based backends
  type(dtfft_backend_t),  parameter,  public :: VALID_BACKENDS(*) = [DTFFT_BACKEND_MPI_DATATYPE         &
                                                                    ,DTFFT_BACKEND_MPI_P2P              &
                                                                    ,DTFFT_BACKEND_MPI_A2A              &
                                                                    ,DTFFT_BACKEND_MPI_P2P_PIPELINED    &
                                                                    ,DTFFT_BACKEND_MPI_P2P_SCHEDULED    &
                                                                    ,DTFFT_BACKEND_MPI_P2P_FUSED        &
#ifdef DTFFT_WITH_COMPRESSION
                                                                    ,DTFFT_BACKEND_MPI_P2P_COMPRESSED   &
#endif
#ifdef DTFFT_WITH_RMA
                                                                    ,DTFFT_BACKEND_MPI_RMA              &
                                                                    ,DTFFT_BACKEND_MPI_RMA_PIPELINED    &
                                                                    ,DTFFT_BACKEND_MPI_RMA_FUSED        &
# ifdef DTFFT_WITH_COMPRESSION
                                                                    ,DTFFT_BACKEND_MPI_RMA_COMPRESSED   &
# endif
#endif
#ifdef DTFFT_WITH_NCCL
                                                                    ,DTFFT_BACKEND_NCCL_PIPELINED       &
                                                                    ,DTFFT_BACKEND_NCCL                 &
# ifdef DTFFT_WITH_COMPRESSION
                                                                    ,DTFFT_BACKEND_NCCL_COMPRESSED      &
# endif
#endif
#ifdef DTFFT_WITH_NVSHMEM
                                                                    ,DTFFT_BACKEND_CUFFTMP              &
                                                                    ,DTFFT_BACKEND_CUFFTMP_PIPELINED    &
#endif
                                                                    ,DTFFT_BACKEND_ADAPTIVE             &
                                                                    ]
    !! List of valid backends that `dtFFT` was compiled for

  type, bind(C) :: dtfft_stream_t
  !! `dtFFT` stream representation.
    type(c_ptr) :: stream !! Actual stream
  end type dtfft_stream_t

  type(dtfft_stream_t), parameter,  public :: NULL_STREAM = dtfft_stream_t(c_null_ptr)

#ifdef DTFFT_WITH_CUDA
  interface dtfft_stream_t
  !! Creates [[dtfft_stream_t]] from integer(cuda_stream_kind)
    module procedure stream_from_int64
  end interface dtfft_stream_t
#endif

public :: dtfft_platform_t
  type, bind(C) :: dtfft_platform_t
  !! Type that specifies runtime platform, e.g. Host, CUDA, HIP
    integer(c_int32_t) :: val !! Internal value
  end type dtfft_platform_t

  type(dtfft_platform_t), public, parameter :: DTFFT_PLATFORM_HOST = dtfft_platform_t(CONF_DTFFT_PLATFORM_HOST)
    !! Host platform
  type(dtfft_platform_t), public, parameter :: DTFFT_PLATFORM_CUDA = dtfft_platform_t(CONF_DTFFT_PLATFORM_CUDA)
    !! CUDA platform
#ifdef DTFFT_WITH_CUDA
  type(dtfft_platform_t),         parameter :: VALID_PLATFORMS(*) = [DTFFT_PLATFORM_HOST, DTFFT_PLATFORM_CUDA]
    !! Valid platforms
#endif
  ! type(dtfft_platform_t), public, parameter :: DTFFT_PLATFORM_HIP = dtfft_platform_t(3)

  type(dtfft_platform_t), public, parameter :: PLATFORM_NOT_SET = dtfft_platform_t(VARIABLE_NOT_SET)

public :: dtfft_request_t
  type, bind(C) :: dtfft_request_t
    type(c_ptr) :: val = c_null_ptr
  end type dtfft_request_t

public :: async_exec_t
  type :: async_exec_t
    integer(int32) :: val
  end type async_exec_t

  type(async_exec_t), parameter, public :: EXEC_BLOCKING = async_exec_t(1)
    !! Blocking execution
  type(async_exec_t), parameter, public :: EXEC_NONBLOCKING = async_exec_t(2)
    !! Non-blocking execution

  integer(int32),     parameter, public :: DEF_TILE_SIZE = 32
    !! Default tile size for CUDA kernels

public :: dtfft_transpose_mode_t
  type, bind(C) :: dtfft_transpose_mode_t
  !! This type specifies at which stage the local transposition is performed during global exchange.
    integer(c_int32_t) :: val !! Internal value
  end type dtfft_transpose_mode_t

  type(dtfft_transpose_mode_t), parameter, public :: DTFFT_TRANSPOSE_MODE_PACK = dtfft_transpose_mode_t(CONF_DTFFT_TRANSPOSE_MODE_PACK)
    !! Perform transposition during the packing stage (Sender side).
  type(dtfft_transpose_mode_t), parameter, public :: DTFFT_TRANSPOSE_MODE_UNPACK = dtfft_transpose_mode_t(CONF_DTFFT_TRANSPOSE_MODE_UNPACK)
    !! Perform transposition during the unpacking stage (Receiver side).
  type(dtfft_transpose_mode_t), parameter :: VALID_TRANSPOSE_MODES(*) = [DTFFT_TRANSPOSE_MODE_PACK, DTFFT_TRANSPOSE_MODE_UNPACK]
    !! Valid transpose modes

  type(dtfft_transpose_mode_t), parameter, public :: TRANSPOSE_MODE_NOT_SET = dtfft_transpose_mode_t(VARIABLE_NOT_SET)
    !! Transpose mode not set
  character(len=*), parameter,  public :: TRANSPOSE_MODE_NAMES(CONF_DTFFT_TRANSPOSE_MODE_PACK:CONF_DTFFT_TRANSPOSE_MODE_UNPACK) = ["PACK  ", "UNPACK"]
    !! String representations of `dtfft_transpose_mode_t`

public :: dtfft_access_mode_t
  type, bind(C) :: dtfft_access_mode_t
  !! This type specifies which access pattern should be used for host kernels.
    integer(c_int32_t) :: val !! Internal value
  end type dtfft_access_mode_t

  type(dtfft_access_mode_t), parameter, public :: DTFFT_ACCESS_MODE_WRITE = dtfft_access_mode_t(CONF_DTFFT_ACCESS_MODE_WRITE)
    !! Optimize for write access (Aligned writing)
  type(dtfft_access_mode_t), parameter, public :: DTFFT_ACCESS_MODE_READ = dtfft_access_mode_t(CONF_DTFFT_ACCESS_MODE_READ)
    !! Optimize for read access (Aligned reading)
  type(dtfft_access_mode_t), parameter :: VALID_ACCESS_MODES(*) = [DTFFT_ACCESS_MODE_WRITE, DTFFT_ACCESS_MODE_READ]
    !! Valid access modes

  type(dtfft_access_mode_t), parameter, public :: ACCESS_MODE_NOT_SET = dtfft_access_mode_t(VARIABLE_NOT_SET)
    !! Access mode not set


  integer(int32), parameter,  public  :: DIMS_PERMUTE_FORWARD = -1
    !! For backward permutation
  integer(int32), parameter,  public  :: DIMS_PERMUTE_BACKWARD = +1
    !! For forward permutation
  integer(int32), parameter,  public  :: DIMS_PERMUTE_NONE = 0
    !! For reshape

contains

MAKE_EQ_FUN(dtfft_execute_t, execute_type_eq)
MAKE_EQ_FUN(dtfft_transpose_t, transpose_type_eq)
MAKE_EQ_FUN(dtfft_reshape_t, reshape_type_eq)
MAKE_EQ_FUN(dtfft_executor_t, executor_eq)
MAKE_EQ_FUN(dtfft_effort_t, effort_eq)
MAKE_EQ_FUN(dtfft_precision_t, precision_eq)
MAKE_EQ_FUN(dtfft_r2r_kind_t, r2r_kind_eq)
MAKE_EQ_FUN(dtfft_platform_t, platform_eq)
MAKE_EQ_FUN(async_exec_t, exec_eq)
MAKE_EQ_FUN(dtfft_layout_t, layout_eq)
MAKE_EQ_FUN(dtfft_transpose_mode_t, transpose_mode_eq)
MAKE_EQ_FUN(dtfft_access_mode_t, access_mode_eq)

MAKE_NE_FUN(dtfft_execute_t, execute_type_ne)
MAKE_NE_FUN(dtfft_transpose_t, transpose_type_ne)
MAKE_NE_FUN(dtfft_reshape_t, reshape_type_ne)
MAKE_NE_FUN(dtfft_executor_t, executor_ne)
MAKE_NE_FUN(dtfft_effort_t, effort_ne)
MAKE_NE_FUN(dtfft_precision_t, precision_ne)
MAKE_NE_FUN(dtfft_r2r_kind_t, r2r_kind_ne)
MAKE_NE_FUN(dtfft_platform_t, platform_ne)
MAKE_NE_FUN(dtfft_layout_t, layout_ne)
MAKE_NE_FUN(dtfft_transpose_mode_t, transpose_mode_ne)
MAKE_NE_FUN(dtfft_access_mode_t, access_mode_ne)

MAKE_VALID_FUN_DTYPE(dtfft_execute_t, is_valid_execute_type, VALID_EXECUTE_TYPES)
MAKE_VALID_FUN_DTYPE(dtfft_transpose_t, is_valid_transpose_type, VALID_TRANSPOSE_TYPES)
MAKE_VALID_FUN_DTYPE(dtfft_reshape_t, is_valid_reshape_type, VALID_RESHAPE_TYPES)
MAKE_VALID_FUN_DTYPE(dtfft_executor_t, is_valid_executor, VALID_EXECUTORS)
MAKE_VALID_FUN_DTYPE(dtfft_effort_t, is_valid_effort, VALID_EFFORTS)
MAKE_VALID_FUN_DTYPE(dtfft_precision_t, is_valid_precision, VALID_PRECISIONS)
MAKE_VALID_FUN_DTYPE(dtfft_r2r_kind_t, is_valid_r2r_kind, VALID_R2R_KINDS)
MAKE_VALID_FUN_DTYPE(dtfft_layout_t, is_valid_layout, VALID_LAYOUTS)
MAKE_VALID_FUN_DTYPE(dtfft_transpose_mode_t, is_valid_transpose_mode, VALID_TRANSPOSE_MODES)
MAKE_VALID_FUN_DTYPE(dtfft_access_mode_t, is_valid_access_mode, VALID_ACCESS_MODES)

MAKE_VALID_FUN(integer(int8), is_valid_dimension, VALID_DIMENSIONS)
MAKE_VALID_FUN(integer(int32), is_valid_comm_type, VALID_COMM_TYPES)

  integer(c_int32_t) function dtfft_get_version_current() bind(C)
  !! Returns the current version code
    dtfft_get_version_current = DTFFT_VERSION_CODE
  end function dtfft_get_version_current

  integer(int32) function dtfft_get_version_required(major, minor, patch)
  !! Returns the version code required by the user
    integer(int32), intent(in) :: major !! Major version
    integer(int32), intent(in) :: minor !! Minor version
    integer(int32), intent(in) :: patch !! Patch version

    dtfft_get_version_required = CONF_DTFFT_VERSION(major,minor,patch)
  end function dtfft_get_version_required

  function dtfft_get_precision_string(precision) result(string)
  !! Gets the string description of a precision
    type(dtfft_precision_t), intent(in) :: precision !! Precision type
    character(len=:), allocatable :: string !! Precision string

    select case ( precision%val )
    case ( DTFFT_SINGLE%val )
      allocate(string, source="Single")
    case ( DTFFT_DOUBLE%val )
      allocate(string, source="Double")
    case default
      allocate(string, source="Unknown precision")
    endselect
  end function dtfft_get_precision_string

  function dtfft_get_executor_string(executor) result(string)
  !! Gets the string description of an executor
    type(dtfft_executor_t), intent(in) :: executor !! Executor type
    character(len=:), allocatable :: string !! Executor string

    select case ( executor%val )
    case ( DTFFT_EXECUTOR_NONE%val )
      allocate(string, source="None")
    case ( DTFFT_EXECUTOR_FFTW3%val )
      allocate(string, source="FFTW3")
    case ( DTFFT_EXECUTOR_MKL%val )
      allocate(string, source="MKL")
    case ( DTFFT_EXECUTOR_CUFFT%val )
      allocate(string, source="CUFFT")
    case ( DTFFT_EXECUTOR_VKFFT%val )
      allocate(string, source="VKFFT")
    case default
      allocate(string, source="Unknown executor")
    endselect
  end function dtfft_get_executor_string

  function dtfft_get_backend_string(backend) result(string)
  !! Gets the string description of a backend
    type(dtfft_backend_t),  intent(in)  :: backend    !! Backend ID
    character(len=:),       allocatable :: string     !! Backend string

    select case ( backend%val )
    case ( DTFFT_BACKEND_MPI_DATATYPE%val )
      allocate(string, source="MPI_DATATYPE")
    case ( DTFFT_BACKEND_MPI_P2P%val )
      allocate(string, source="MPI_P2P")
    case ( DTFFT_BACKEND_MPI_A2A%val )
      allocate(string, source="MPI_A2A")
    case ( DTFFT_BACKEND_MPI_RMA%val )
      allocate(string, source="MPI_RMA")
    case ( DTFFT_BACKEND_MPI_RMA_PIPELINED%val )
      allocate(string, source="MPI_RMA_PIPELINED")
    case ( DTFFT_BACKEND_MPI_P2P_SCHEDULED%val )
      allocate(string, source="MPI_P2P_SCHEDULED")
    case ( DTFFT_BACKEND_NCCL%val )
      allocate(string, source="NCCL")
    case ( DTFFT_BACKEND_CUFFTMP%val )
      allocate(string, source="CUFFTMP")
    case ( DTFFT_BACKEND_MPI_P2P_PIPELINED%val )
      allocate(string, source="MPI_P2P_PIPELINED")
    case ( DTFFT_BACKEND_NCCL_PIPELINED%val )
      allocate(string, source="NCCL_PIPELINED")
    case ( DTFFT_BACKEND_CUFFTMP_PIPELINED%val )
      allocate(string, source="CUFFTMP_PIPELINED")
    case ( DTFFT_BACKEND_MPI_P2P_FUSED%val )
      allocate(string, source="MPI_P2P_FUSED")
    case ( DTFFT_BACKEND_MPI_RMA_FUSED%val )
      allocate(string, source="MPI_RMA_FUSED")
    case ( DTFFT_BACKEND_MPI_P2P_COMPRESSED%val )
      allocate(string, source="MPI_P2P_COMPRESSED")
    case ( DTFFT_BACKEND_MPI_RMA_COMPRESSED%val )
      allocate(string, source="MPI_RMA_COMPRESSED")
    case ( DTFFT_BACKEND_NCCL_COMPRESSED%val )
      allocate(string, source="NCCL_COMPRESSED")
    case ( DTFFT_BACKEND_ADAPTIVE%val )
      allocate(string, source="ADAPTIVE")
    case ( DTFFT_BACKEND_NONE%val )
      allocate(string, source="None")
    case default
      allocate(string, source="Unknown backend")
    endselect
  end function dtfft_get_backend_string

  MAKE_EQ_FUN(dtfft_backend_t, backend_eq)
  MAKE_NE_FUN(dtfft_backend_t, backend_ne)

  MAKE_VALID_FUN_DTYPE(dtfft_backend_t, dtfft_get_backend_pipelined, PIPELINED_BACKENDS)
  MAKE_VALID_FUN_DTYPE(dtfft_backend_t, is_backend_pipelined, PIPELINED_BACKENDS)
  MAKE_VALID_FUN_DTYPE(dtfft_backend_t, is_backend_mpi, MPI_BACKENDS)
  MAKE_VALID_FUN_DTYPE(dtfft_backend_t, is_backend_fused, FUSED_BACKENDS)
  MAKE_VALID_FUN_DTYPE(dtfft_backend_t, is_backend_rma, RMA_BACKENDS)
  MAKE_VALID_FUN_DTYPE(dtfft_backend_t, is_backend_compressed, COMPRESSED_BACKENDS)

  MAKE_VALID_FUN_DTYPE(dtfft_backend_t, is_valid_backend, VALID_BACKENDS)

  MAKE_VALID_FUN_DTYPE(dtfft_backend_t, is_backend_nccl, NCCL_BACKENDS)
  MAKE_VALID_FUN_DTYPE(dtfft_backend_t, is_backend_cufftmp, CUFFTMP_BACKENDS)
  MAKE_VALID_FUN_DTYPE(dtfft_backend_t, is_backend_nvshmem, NVSHMEM_BACKENDS)

#ifdef DTFFT_WITH_CUDA
  MAKE_VALID_FUN_DTYPE(dtfft_executor_t, is_host_executor, HOST_EXECUTORS)
  MAKE_VALID_FUN_DTYPE(dtfft_executor_t, is_cuda_executor, CUDA_EXECUTORS)
  MAKE_VALID_FUN_DTYPE(dtfft_platform_t, is_valid_platform, VALID_PLATFORMS)

  function stream_from_int64(cuda_stream) result(stream)
  !! Creates [[dtfft_stream_t]] from integer(cuda_stream_kind)
    integer(int64), intent(in)  :: cuda_stream  !! CUDA stream
    type(dtfft_stream_t)        :: stream       !! dtfft Stream

    stream = transfer(cuda_stream, stream)
  end function stream_from_int64

  function dtfft_get_cuda_stream(stream) result(cuda_stream)
  !! Returns the CUDA stream from [[dtfft_stream_t]]
    type(dtfft_stream_t), intent(in) :: stream      !! dtfft stream
    integer(int64)                   :: cuda_stream !! CUDA stream

    cuda_stream = transfer(stream, int64)
  end function dtfft_get_cuda_stream
#endif
end module dtfft_parameters

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_kernel_device
!! This module defines [[kernel_device]] type and its type bound procedures.
!! It extends [[abstract_kernel]] type and implements its type bound procedures.
use iso_c_binding
use iso_fortran_env
use dtfft_abstract_kernel
use dtfft_config
use dtfft_interface_cuda,         only: MAX_KERNEL_ARGS, dim3, CUfunction, cuLaunchKernel
use dtfft_interface_cuda_runtime
use dtfft_nvrtc_block_optimizer,  only: N_CANDIDATES,                       &
                                        kernel_config,                      &
                                        generate_candidates,                &
                                        evaluate_analytical_performance,    &
                                        sort_candidates_by_score
use dtfft_nvrtc_module_cache
use dtfft_parameters
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_cuda.h"
#include "_dtfft_profile.h"
#include "_dtfft_private.h"
implicit none
private
public :: kernel_device

    type, extends(abstract_kernel) :: kernel_device
    !! Device kernel class
    private
        type(kernel_type_t)   :: internal_kernel_type     !! Actual kernel type used for execution, can be different from `kernel_type`
        type(CUfunction)      :: cuda_kernel              !! Pointer to CUDA kernel.
        integer(int32)        :: tile_size                !! Tile size used for this kernel
        integer(int32)        :: block_rows               !! Number of rows in each block processed by each thread
        integer(int64)        :: copy_bytes               !! Number of bytes to copy for `KERNEL_COPY` kernel
    contains
        procedure :: create_private => create   !! Creates kernel
        procedure :: execute_private => execute !! Executes kernel
        procedure :: destroy_private => destroy !! Destroys kernel
    end type kernel_device

contains

    subroutine create(self, effort, base_storage, force_effort)
    !! Creates kernel
        class(kernel_device),     intent(inout) :: self             !! Device kernel class
        type(dtfft_effort_t),     intent(in)    :: effort           !! Effort level for generating transpose kernels
        integer(int64),           intent(in)    :: base_storage     !! Number of bytes needed to store single element
        logical,        optional, intent(in)    :: force_effort     !! Should effort be forced or not
        type(device_props)                      :: props              !! GPU architecture properties
        integer(int32)                          :: device_id          !! Device ID

        call self%destroy()
#ifdef DTFFT_DEBUG
        if ( any(self%kernel_type == [KERNEL_UNPACK_FORWARD, KERNEL_UNPACK_FORWARD_PIPELINED, KERNEL_UNPACK_BACKWARD, KERNEL_UNPACK_BACKWARD_PIPELINED]) ) then
            INTERNAL_ERROR("Invalid kernel type for CUDA: "//self%kernel_string%raw)
        endif
#endif
        self%base_storage = base_storage
        if ( self%kernel_type == KERNEL_COPY .or. self%kernel_type == KERNEL_COPY_PIPELINED) then
            self%is_created = .true.
            self%copy_bytes = base_storage * product(self%dims)
            return
        endif

        self%internal_kernel_type = self%kernel_type
        select case ( self%kernel_type%val )
            case ( KERNEL_PACK%val )
                self%internal_kernel_type = KERNEL_PACK_PIPELINED
            case ( KERNEL_UNPACK%val )
                self%internal_kernel_type = KERNEL_UNPACK_PIPELINED
            case ( KERNEL_PERMUTE_BACKWARD_END%val )
                self%internal_kernel_type = KERNEL_PERMUTE_BACKWARD_END_PIPELINED
        end select

        CUDA_CALL( cudaGetDevice(device_id) )
        call get_device_props(device_id, props)
        if ( allocated( self%neighbor_data ) ) then
            call get_kernel(self%dims, self%internal_kernel_type, self%kernel_string, effort, base_storage, props,    &
                            self%tile_size, self%block_rows, self%cuda_kernel, force_effort=force_effort, neighbor_data=self%neighbor_data(:, 1))
        else
            call get_kernel(self%dims, self%internal_kernel_type, self%kernel_string, effort, base_storage, props,    &
                            self%tile_size, self%block_rows, self%cuda_kernel, force_effort=force_effort)
        endif
    end subroutine create

    subroutine execute(self, in, out, stream, sync, neighbor)
    !! Executes kernel on stream
        class(kernel_device),       intent(inout)   :: self         !! Device kernel class
        type(c_ptr),                intent(in)      :: in           !! Source buffer, can be device or host pointer
        type(c_ptr),                intent(in)      :: out          !! Target buffer, can be device or host pointer
        type(dtfft_stream_t),       intent(in)      :: stream       !! Stream to execute on
        logical,                    intent(in)      :: sync         !! Sync stream after kernel execution, unused here
        integer(int32),   optional, intent(in)      :: neighbor     !! Source rank for pipelined unpacking
        integer(int32) :: nargs, n
        integer(int32) :: args(MAX_KERNEL_ARGS)
        type(dim3) :: blocks, threads
        type(c_ptr) :: in_ptr, out_ptr

        if ( self%kernel_type == KERNEL_COPY ) then
            CUDA_CALL( cudaMemcpyAsync(out, in, self%copy_bytes, cudaMemcpyDeviceToDevice, stream) )
#ifdef DTFFT_DEBUG
            CUDA_CALL( cudaStreamSynchronize(stream) )
#endif
            if ( sync ) then
                CUDA_CALL( cudaStreamSynchronize(stream) )
            endif
            return
        endif

        if ( self%kernel_type == KERNEL_COPY_PIPELINED ) then
            out_ptr = ptr_offset(out, self%base_storage * self%neighbor_data(5, neighbor))
            in_ptr = ptr_offset(in, self%base_storage * self%neighbor_data(4, neighbor))
            CUDA_CALL( cudaMemcpyAsync(out_ptr, in_ptr, self%base_storage * product(self%neighbor_data(1:3, neighbor)), cudaMemcpyDeviceToDevice, stream) )
#ifdef DTFFT_DEBUG
            CUDA_CALL( cudaStreamSynchronize(stream) )
#endif
            if ( sync ) then
                CUDA_CALL( cudaStreamSynchronize(stream) )
            endif
            return
        endif

        if( any(self%kernel_type == [KERNEL_PERMUTE_FORWARD, KERNEL_PERMUTE_BACKWARD, KERNEL_PERMUTE_BACKWARD_START]) ) then
            call get_kernel_launch_params(self%kernel_type, self%dims, self%tile_size, self%block_rows, blocks, threads)
            call get_kernel_args(self%kernel_type, self%dims, nargs, args)
            CUDA_CALL( cuLaunchKernel(self%cuda_kernel, in, out, blocks, threads, stream, nargs, args) )
#ifdef DTFFT_DEBUG
            CUDA_CALL( cudaStreamSynchronize(stream) )
#endif
            if ( sync ) then
                CUDA_CALL( cudaStreamSynchronize(stream) )
            endif
            return
        endif

        if ( any(self%kernel_type == [KERNEL_UNPACK_PIPELINED, KERNEL_PERMUTE_BACKWARD_END_PIPELINED, KERNEL_PACK_FORWARD, KERNEL_PACK_BACKWARD]) ) then
            call get_kernel_launch_params(self%kernel_type, self%neighbor_data(1:3, neighbor), self%tile_size, self%block_rows, blocks, threads )
            call get_kernel_args(self%kernel_type, self%dims, nargs, args, self%neighbor_data(:, neighbor))
            CUDA_CALL( cuLaunchKernel(self%cuda_kernel, in, out, blocks, threads, stream, nargs, args) )
#ifdef DTFFT_DEBUG
            CUDA_CALL( cudaStreamSynchronize(stream) )
#endif
            if ( sync ) then
                CUDA_CALL( cudaStreamSynchronize(stream) )
            endif
            return
        endif

        do n = 1, size(self%neighbor_data, dim=2)
            call get_kernel_launch_params(self%internal_kernel_type, self%neighbor_data(1:3, n), self%tile_size, self%block_rows, blocks, threads )
            call get_kernel_args(self%internal_kernel_type, self%dims, nargs, args, self%neighbor_data(:, n))
            CUDA_CALL( cuLaunchKernel(self%cuda_kernel, in, out, blocks, threads, stream, nargs, args) )
#ifdef DTFFT_DEBUG
            CUDA_CALL( cudaStreamSynchronize(stream) )
#endif
        enddo
        if ( sync ) then
            CUDA_CALL( cudaStreamSynchronize(stream) )
        endif
  end subroutine execute

  subroutine destroy(self)
  !! Destroys kernel
    class(kernel_device), intent(inout) :: self !! Device kernel class

    if ( .not. self%is_created ) return
    if ( self%is_dummy .or. self%kernel_type == KERNEL_COPY ) return
  end subroutine destroy

  subroutine get_kernel_args(kernel_type, dims, nargs, args, neighbor_data)
  !! Populates kernel arguments based on kernel type
    type(kernel_type_t),      intent(in)    :: kernel_type        !! Type of kernel
    integer(int32),           intent(in)    :: dims(:)            !! Local dimensions to process
    integer(int32),           intent(out)   :: nargs              !! Number of arguments set by this subroutine
    integer(int32),           intent(out)   :: args(MAX_KERNEL_ARGS)  !! Kernel arguments
    integer(int32), optional, intent(in)    :: neighbor_data(:)   !! Neighbor data for pipelined kernels

    nargs = 0
    nargs = nargs + 1;  args(nargs) = dims(1)
    nargs = nargs + 1;  args(nargs) = dims(2)
    nargs = nargs + 1
    if ( size(dims) == 2 ) then
      args(nargs) = 1
    else
      args(nargs) = dims(3)
    endif

    if ( is_pack_kernel(kernel_type) .or. is_unpack_kernel(kernel_type) ) then
      nargs = nargs + 1;  args(nargs) = neighbor_data(1)
      nargs = nargs + 1;  args(nargs) = neighbor_data(2)
      nargs = nargs + 1;  args(nargs) = neighbor_data(3)
      nargs = nargs + 1;  args(nargs) = neighbor_data(4)
      nargs = nargs + 1;  args(nargs) = neighbor_data(5)
    endif
    ! if ( size(dims) == 2 .or. kernel_type == KERNEL_UNPACK_PIPELINED .or. kernel_type == KERNEL_PACK ) return

    ! if ( any(kernel_type == [KERNEL_PERMUTE_FORWARD, KERNEL_PERMUTE_BACKWARD, KERNEL_PERMUTE_BACKWARD_START]) ) then
    !   nargs = nargs + 1; args(nargs) = dims(3)
    !   return
    ! endif

    ! nargs = nargs + 1; args(nargs) = neighbor_data(1)
    ! nargs = nargs + 1; args(nargs) = neighbor_data(2)
    ! nargs = nargs + 1; args(nargs) = neighbor_data(3)
    ! nargs = nargs + 1; args(nargs) = neighbor_data(4)
    ! nargs = nargs + 1; args(nargs) = neighbor_data(5)
  end subroutine get_kernel_args

  subroutine get_kernel_launch_params(kernel_type, dims, tile_size, block_rows, blocks, threads)
  !! Computes kernel launch parameters based on kernel type and dimensions
    type(kernel_type_t),      intent(in)    :: kernel_type        !! Type of kernel
    integer(int32),           intent(in)    :: dims(:)            !! Local dimensions to process
    integer(int32),           intent(in)    :: tile_size          !! Size of the tile in shared memory
    integer(int32),           intent(in)    :: block_rows         !! Number of rows in each block
    type(dim3),               intent(out)   :: blocks             !! Number of blocks to launch
    type(dim3),               intent(out)   :: threads            !! Number of threads per block
    integer(int32) :: tile_dim, other_dim

    threads%x = tile_size
    threads%y = block_rows
    threads%z = 1

    if ( any(kernel_type == [KERNEL_PERMUTE_FORWARD, KERNEL_PACK_FORWARD, KERNEL_PERMUTE_BACKWARD_END_PIPELINED, KERNEL_UNPACK_PIPELINED, KERNEL_PACK_PIPELINED]) ) then
      tile_dim = 2
      other_dim = 3
    else
      ! KERNEL_PERMUTE_BACKWARD_START or KERNEL_PERMUTE_BACKWARD
      tile_dim = 3
      other_dim = 2
    endif

    blocks%x = (dims(1) + tile_size - 1) / tile_size
    blocks%y = (dims(tile_dim) + tile_size - 1) / tile_size
    if ( size(dims) == 2 ) then
      blocks%z = 1
    else
      blocks%z = dims(other_dim)
    endif
  end subroutine get_kernel_launch_params

  subroutine get_kernel(dims, kernel_type, kernel_string, effort, base_storage, props, tile_size, block_rows, kernel, force_effort, neighbor_data)
  !! Compiles kernel and caches it. Returns compiled kernel.
    integer(int32),           intent(in)    :: dims(:)            !! Local dimensions to process
    type(kernel_type_t),      intent(in)    :: kernel_type        !! Type of kernel to build
    type(string),             intent(in)    :: kernel_string      !! Kernel string
    type(dtfft_effort_t),     intent(in)    :: effort             !! How thoroughly `dtFFT` searches for the optimal transpose kernel
    integer(int64),           intent(in)    :: base_storage       !! Number of bytes needed to store single element
    type(device_props),       intent(in)    :: props              !! GPU architecture properties
    integer(int32),           intent(out)   :: tile_size          !! Size of the tile in shared memory
    integer(int32),           intent(out)   :: block_rows         !! Number of rows in each block processed by each thread
    type(CUfunction),         intent(out)   :: kernel             !! Compiled kernel to return
    logical,        optional, intent(in)    :: force_effort       !! Should effort be forced or not
    integer(int32), optional, intent(in)    :: neighbor_data(:)   !! Neighbor data for pipelined kernels
    type(kernel_config)           :: candidates(N_CANDIDATES) !! Candidate kernel configurations
    type(kernel_config)           :: config                   !! Current candidate
    integer(int32)                :: num_candidates           !! Number of candidate configurations generated
    integer(int32)                :: i                        !! Loop index
    real(real32),     allocatable :: scores(:)                !! Scores for each candidate configuration
    integer(int32),   allocatable :: sorted(:)                !! Sorted indices of candidate configurations
    integer(int32)                :: tile_dim                 !! Tile dimension
    integer(int32)                :: other_dim                !! Dimension that is not part of shared memory
    integer(int32)                :: fixed_dims(3)            !! Dimensions fixed to the shared memory
    integer(int32)                :: ndims                    !! Number of dimensions
    integer(int32)                :: test_id                  !! Current test configuration ID
    integer(int32)                :: iter                     !! Loop index
    integer(int32)                :: best_kernel_id           !! Best kernel configuration ID
    type(c_ptr)                   :: in                       !! Input buffer
    type(c_ptr)                   :: out                      !! Output buffer
    type(dim3)                    :: blocks                   !! Blocks configuration
    type(dim3)                    :: threads                  !! Threads configuration
    type(cudaEvent)               :: timer_start              !! Timer start event
    type(cudaEvent)               :: timer_stop               !! Timer stop event
    real(real32)                  :: execution_time           !! Execution time
    real(real32)                  :: best_time                !! Best execution time
    type(dtfft_stream_t)          :: stream                   !! CUDA stream for kernel execution
    real(real32)                  :: bandwidth                !! Bandwidth for kernel execution
    integer(int32)                :: n_iters                  !! Number of iterations to perform when testing kernel
    integer(int32)                :: n_warmup_iters           !! Number of warmup iterations to perform before testing kernel
    logical                       :: force_effort_            !! Should effort be forced or not
    character(len=:), allocatable :: global_phase             !! Global phase name for profiling
    character(len=:), allocatable :: local_phase              !! Local phase name for profiling
    integer(int32)                :: nargs                    !! Number of kernel arguments
    integer(int32)                :: args(MAX_KERNEL_ARGS)    !! Kernel arguments


    if ( any(kernel_type == [KERNEL_PERMUTE_FORWARD, KERNEL_PERMUTE_BACKWARD_END_PIPELINED, KERNEL_UNPACK_PIPELINED, KERNEL_PACK_PIPELINED]) ) then
      tile_dim = 2
      other_dim = 3
    else
      ! KERNEL_PERMUTE_BACKWARD_START or KERNEL_PERMUTE_BACKWARD
      tile_dim = 3
      other_dim = 2
    endif

    ndims = size(dims)
    fixed_dims(:) = 1
    fixed_dims(1:ndims) = dims(1:ndims)
    if ( is_unpack_kernel(kernel_type) .or. is_pack_kernel(kernel_type)) fixed_dims(1:ndims) = neighbor_data(1:ndims)
    call generate_candidates(fixed_dims, tile_dim, other_dim, base_storage, props, candidates, num_candidates)
    allocate(scores(num_candidates), sorted(num_candidates))
    do i = 1, num_candidates
      scores(i) = evaluate_analytical_performance(fixed_dims, tile_dim, other_dim, kernel_type, candidates(i), props, base_storage, neighbor_data)
    enddo
    call sort_candidates_by_score(scores, num_candidates, sorted)

    call create_nvrtc_module(ndims, kernel_type, base_storage, candidates(1:num_candidates), props)

    force_effort_ = .false.; if( present(force_effort) ) force_effort_ = force_effort

    if ((effort == DTFFT_ESTIMATE .and. force_effort_) .or. &
          .not. ( effort == DTFFT_EXHAUSTIVE .or. get_conf_kernel_autotune_enabled()) ) then
      config = candidates(sorted(1))
      tile_size = config%tile_size
      block_rows = config%block_rows
      kernel = get_kernel_instance(ndims, kernel_type, base_storage, tile_size, block_rows)
      deallocate(scores, sorted)
      return
    endif

    CUDA_CALL( cudaMalloc(in, base_storage * product(dims)) )
    CUDA_CALL( cudaMalloc(out, base_storage * product(dims)) )
    CUDA_CALL( cudaEventCreate(timer_start) )
    CUDA_CALL( cudaEventCreate(timer_stop) )
    stream = get_conf_stream()

    allocate( global_phase, source="Testing nvRTC kernel: '"//kernel_string%raw//"' perfomances..." )
    PHASE_BEGIN(global_phase, COLOR_STEEL_BLUE)
    WRITE_INFO(global_phase)

    n_warmup_iters = get_conf_measure_warmup_iters()
    n_iters = get_conf_measure_iters()

    best_time = MAX_REAL32

    do test_id = 1, num_candidates
      config = candidates(sorted(test_id))
      tile_size = config%tile_size
      block_rows = config%block_rows

      call get_kernel_launch_params(kernel_type, fixed_dims, tile_size, block_rows, blocks, threads)
      call get_kernel_args(kernel_type, dims, nargs, args, neighbor_data)

      kernel = get_kernel_instance(ndims, kernel_type, base_storage, tile_size, block_rows)

      allocate( local_phase, source="Testing block: "//to_str(tile_size)//"x"//to_str(block_rows) )
      REGION_BEGIN(local_phase, COLOR_ORCHID)
      WRITE_INFO("    "//local_phase)

      REGION_BEGIN("Warmup", COLOR_VIOLET)
      do iter = 1, n_warmup_iters
        CUDA_CALL( cuLaunchKernel(kernel, in, out, blocks, threads, stream, nargs, args) )
      enddo
      CUDA_CALL( cudaStreamSynchronize(stream) )
      REGION_END("Warmup")

      REGION_BEGIN("Measure", COLOR_DODGER_BLUE)
      CUDA_CALL( cudaEventRecord(timer_start, stream) )
      do iter = 1, n_iters
        CUDA_CALL( cuLaunchKernel(kernel, in, out, blocks, threads, stream, nargs, args) )
      enddo

      CUDA_CALL( cudaEventRecord(timer_stop, stream) )
      CUDA_CALL( cudaEventSynchronize(timer_stop) )
      REGION_END("Measure")
      CUDA_CALL( cudaEventElapsedTime(execution_time, timer_start, timer_stop) )
      execution_time = execution_time / real(n_iters, real32)
      WRITE_INFO("        Average execution time = "//to_str(real(execution_time, real64))//" [ms]")
      if ( execution_time > 0._real32 ) then
        bandwidth = 2.0 * 1000.0 * real(base_storage * product(fixed_dims), real32) / real(1024 * 1024 * 1024, real32) / execution_time
        WRITE_INFO("        Bandwidth = "//to_str(bandwidth)//" [GB/s]")
      endif

      if ( execution_time < best_time ) then
        best_time = execution_time
        best_kernel_id = test_id
      endif
      REGION_END(local_phase)
      deallocate(local_phase)
    enddo
    config = candidates(sorted(best_kernel_id))
    PHASE_END(global_phase)
    tile_size = config%tile_size
    block_rows = config%block_rows
    kernel = get_kernel_instance(ndims, kernel_type, base_storage, tile_size, block_rows)
    WRITE_INFO("  Best configuration is: "//to_str(tile_size)//"x"//to_str(block_rows))

    CUDA_CALL( cudaEventDestroy(timer_start) )
    CUDA_CALL( cudaEventDestroy(timer_stop) )
    CUDA_CALL( cudaFree(in) )
    CUDA_CALL( cudaFree(out) )
    deallocate(scores, sorted)
    deallocate(global_phase)
  end subroutine get_kernel
end module dtfft_kernel_device

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_abstract_compressor
!! Abstract base class for compression implementations [[abstract_compressor]]
use iso_c_binding
use iso_fortran_env
use dtfft_errors
use dtfft_parameters
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
#include "_dtfft_profile.h"
implicit none
private
public :: abstract_compressor
public :: check_compression_config


    type, abstract :: abstract_compressor
    !! Abstract base class for compression implementations
        integer(int8)   :: ndims             !! Number of dimensions
        integer(int64)  :: storage_size      !! Size of storage per element
        real(real64)    :: compressed_rate   !! Accumulated compression rate
        integer(int64)  :: execution_count   !! Number of compression executions
        integer(int32)  :: dims_permutation  !! Dimension permutation flag
    contains
        procedure,  non_overridable,    public,                 pass(self)  :: create             !! Initializes the compressor with given parameters
        procedure,  non_overridable,    public,                 pass(self)  :: compress           !! Compresses the input data and returns the compressed size
        procedure,  non_overridable,    public,                 pass(self)  :: decompress         !! Decompresses the input data into the output buffer
        procedure,  non_overridable,    public,                 pass(self)  :: get_average_rate   !! Returns the average compression rate over all executions
        procedure(sync_interface),                  deferred,   pass(self)  :: pre_sync           !!
        procedure(sync_interface),                  deferred,   pass(self)  :: post_sync
        procedure(sync_interface),                  deferred,   pass(self)  :: sync
        procedure(create_private_interface),        deferred,   pass(self)  :: create_private    !! Creates the compressor implementation
        procedure(compress_private_interface),      deferred,   pass(self)  :: compress_private  !! Performs compression using the implementation
        procedure(decompress_private_interface),    deferred,   pass(self)  :: decompress_private !! Performs decompression using the implementation
        procedure(destroy_interface),               deferred,   pass(self)  :: destroy           !! Destroys the compressor implementation
    end type abstract_compressor

public :: dtfft_compression_mode_t
    type, bind(C) :: dtfft_compression_mode_t
    !! Type that specifies compression mode
        integer(c_int32_t) :: val !! Internal value
    end type dtfft_compression_mode_t

    type(dtfft_compression_mode_t), parameter,  public :: DTFFT_COMPRESSION_MODE_LOSSLESS = dtfft_compression_mode_t(CONF_DTFFT_COMPRESSION_MODE_LOSSLESS)
    !! Lossless compression mode

    type(dtfft_compression_mode_t), parameter,  public :: DTFFT_COMPRESSION_MODE_FIXED_RATE = dtfft_compression_mode_t(CONF_DTFFT_COMPRESSION_MODE_FIXED_RATE)
    !! Fixed rate compression mode

    type(dtfft_compression_mode_t), parameter,  public :: DTFFT_COMPRESSION_MODE_FIXED_PRECISION = dtfft_compression_mode_t(CONF_DTFFT_COMPRESSION_MODE_FIXED_PRECISION)
    !! Fixed precision compression mode

    type(dtfft_compression_mode_t), parameter,  public :: DTFFT_COMPRESSION_MODE_FIXED_ACCURACY = dtfft_compression_mode_t(CONF_DTFFT_COMPRESSION_MODE_FIXED_ACCURACY)
    !! Fixed accuracy compression mode

    type(dtfft_compression_mode_t), parameter  :: VALID_COMPRESSION_MODES(*) = [    DTFFT_COMPRESSION_MODE_LOSSLESS,        &
                                                                                    DTFFT_COMPRESSION_MODE_FIXED_RATE,      &
                                                                                    DTFFT_COMPRESSION_MODE_FIXED_PRECISION, &
                                                                                    DTFFT_COMPRESSION_MODE_FIXED_ACCURACY ]

public :: dtfft_compression_lib_t
    type, bind(C) :: dtfft_compression_lib_t
    !! Type that specifies compression library
        integer(c_int32_t) :: val !! Internal value
    end type dtfft_compression_lib_t

    type(dtfft_compression_lib_t),  parameter,  public :: DTFFT_COMPRESSION_LIB_ZFP = dtfft_compression_lib_t(CONF_DTFFT_COMPRESSION_LIB_ZFP)
    !! ZFP compression library

    type(dtfft_compression_lib_t),  parameter  :: VALID_COMPRESSION_LIBS(*) = [ DTFFT_COMPRESSION_LIB_ZFP]
    !! List of valid compression libraries


public :: dtfft_compression_config_t
    type, bind(C) :: dtfft_compression_config_t
        type(dtfft_compression_lib_t)   :: compression_lib
        !! Library to use. Currently only support ZFP

        type(dtfft_compression_mode_t)  :: compression_mode
        !! Compression mode to use

        real(c_double)                  :: rate
        !! Rate for `DTFFT_COMPRESSION_MODE_FIXED_RATE`

        integer(c_int32_t)              :: precision
        !! Precision for `DTFFT_COMPRESSION_MODE_FIXED_PRECISION`

        real(c_double)                  :: tolerance
        !! Tolerance for `DTFFT_COMPRESSION_MODE_FIXED_ACCURACY`
    end type dtfft_compression_config_t

    interface dtfft_compression_config_t
    !! Type bound constuctor for dtfft_compression_config_t
        module procedure create_compression_config_t    !! Creates config object
    end interface dtfft_compression_config_t

    type(dtfft_compression_config_t), parameter, public :: DEFAULT_COMPRESSION_CONFIG = dtfft_compression_config_t(DTFFT_COMPRESSION_LIB_ZFP, DTFFT_COMPRESSION_MODE_LOSSLESS, -1.0, -1, -1.0)
    !! Default compression configuration

    abstract interface
        integer(int32) function create_private_interface(self, config, platform, base_type)
        !! Creates the compressor implementation
        import
            class(abstract_compressor),         intent(inout)   :: self         !! Compressor instance
            type(dtfft_compression_config_t),   intent(in)      :: config       !! Compression configuration
            type(dtfft_platform_t),             intent(in)      :: platform     !! Target platform
            TYPE_MPI_DATATYPE,                  intent(in)      :: base_type    !! MPI data type
        end function create_private_interface

        integer(int64) function compress_private_interface(self, dims, in, out, stream)
        !! Performs compression using the implementation
        import
            class(abstract_compressor), intent(inout)   :: self     !! Compressor instance
            integer(int32),             intent(in)      :: dims(:)  !! Array dimensions
            type(c_ptr),                intent(in)      :: in       !! Pointer to uncompressed data
            type(c_ptr),                intent(in)      :: out      !! Pointer to compressed buffer
            type(dtfft_stream_t),       intent(in)      :: stream   !! Stream handle
        end function compress_private_interface

        subroutine decompress_private_interface(self, dims, in, out, stream)
        !! Performs decompression using the implementation
        import
            class(abstract_compressor), intent(inout)   :: self             !! Compressor instance
            integer(int32),             intent(in)      :: dims(:)          !! Array dimensions
            type(c_ptr),                intent(in)      :: in               !! Pointer to compressed data
            type(c_ptr),                intent(in)      :: out              !! Pointer to uncompressed buffer
            type(dtfft_stream_t),       intent(in)      :: stream           !! Stream handle
        end subroutine decompress_private_interface

        subroutine destroy_interface(self)
        !! Destroys the compressor implementation
        import
            class(abstract_compressor), intent(inout)   :: self !! Compressor instance
        end subroutine destroy_interface

        subroutine sync_interface(self, stream)
        import
            class(abstract_compressor), intent(inout)   :: self                 !! Abstract kernel
            type(dtfft_stream_t),       intent(in)      :: stream
        end subroutine sync_interface
    end interface

public :: operator(==)
    interface operator(==)
        module procedure compression_mode_eq    !! Check if two `dtfft_compression_mode_t` are equal
        module procedure compression_lib_eq     !! Check if two `dtfft_compression_lib_t` are equal
    end interface

public :: operator(/=)
    interface operator(/=)
        module procedure compression_mode_ne    !! Check if two `dtfft_compression_mode_t` are not equal
        module procedure compression_lib_ne     !! Check if two `dtfft_compression_lib_t` are not equal
    end interface

contains

    pure type(dtfft_compression_config_t) function create_compression_config_t(lib, mode, rate, precision, tolerance) result(config)
    !! Creates a compression configuration object
        type(dtfft_compression_lib_t),  intent(in)  :: lib        !! Compression library to use
        type(dtfft_compression_mode_t), intent(in)  :: mode       !! Compression mode
        real(c_double),     optional,   intent(in)  :: rate       !! Compression rate (for fixed rate mode)
        integer(c_int32_t), optional,   intent(in)  :: precision  !! Precision (for fixed precision mode)
        real(c_double),     optional,   intent(in)  :: tolerance  !! Tolerance (for fixed accuracy mode)

        config%compression_lib = lib
        config%compression_mode = mode
        config%rate = -1._c_double;         if ( present(rate) ) config%rate = rate
        config%precision = -1;              if ( present(precision) ) config%precision = precision
        config%tolerance = -1._c_double;    if ( present(tolerance) ) config%tolerance = tolerance
    end function create_compression_config_t

    integer(int32) function create(self, ndims, config, platform, base_type, storage_size, dims_permutation)
    !! Initializes the compressor with given parameters
        class(abstract_compressor),         intent(inout)   :: self             !! Compressor instance
        integer(int8),                      intent(in)      :: ndims            !! Number of dimensions
        type(dtfft_compression_config_t),   intent(in)      :: config           !! Compression configuration
        type(dtfft_platform_t),             intent(in)      :: platform         !! Target platform
        TYPE_MPI_DATATYPE,                  intent(in)      :: base_type        !! MPI data type
        integer(int64),                     intent(in)      :: storage_size     !! Storage size per element
        integer(int32),                     intent(in)      :: dims_permutation !! Dimension permutation flag

        self%ndims = ndims
        self%storage_size = storage_size
        self%compressed_rate = 0._real64
        self%execution_count = 0
        self%dims_permutation = dims_permutation
        CHECK_CALL( self%create_private(config, platform, base_type), create )
    end function create

    integer(int64) function compress(self, dims, displ, in, out, stream)
    !! Compresses the input data and returns the compressed size
        class(abstract_compressor), intent(inout)   :: self     !! Compressor instance
        integer(int32),             intent(in)      :: dims(:)  !! Array dimensions
        integer(int32),             intent(in)      :: displ    !! Displacement in arrays
        type(c_ptr),                intent(in)      :: in       !! Pointer to uncompressed data
        type(c_ptr),                intent(in)      :: out      !! Pointer to compressed buffer
        type(dtfft_stream_t),       intent(in)      :: stream   !! Stream handle
        type(c_ptr) :: inptr, outptr
        real(real64) :: compressed_rate
        integer(int64)  :: uncompressed_size

        if ( product(dims(1:self%ndims)) == 0 ) then
            compress = 0
            return
        endif

        REGION_BEGIN("Compressing", COLOR_SALMON)

        inptr = ptr_offset(in, self%storage_size * displ)
        outptr = ptr_offset(out, self%storage_size * displ)
#ifdef DTFFT_DEBUG
        if ( is_same_ptr(inptr, outptr) ) then
            INTERNAL_ERROR("compress: is_same_ptr(inptr, outptr)")
        endif
#endif

        compress = self%compress_private(dims(1:self%ndims), inptr, outptr, stream)

        uncompressed_size = self%storage_size * product(dims(1:self%ndims))
        if ( compress >= uncompressed_size ) then
            INTERNAL_ERROR("abstract_compressor.compress: compress >= uncompressed_size: "//to_str(compress)//" >= "//to_str(uncompressed_size))
        endif
        if ( compress == 0 ) then
            INTERNAL_ERROR("Compression failed")
        endif

        ! Aggregate compression stats
        compressed_rate = real(uncompressed_size, real64) / real(compress, real64)
        self%compressed_rate = self%compressed_rate + compressed_rate
        self%execution_count = self%execution_count + 1
        REGION_END("Compressing")
    end function compress

    subroutine decompress(self, dims, displ, in, out, stream)
    !! Decompresses the input data into the output buffer
        class(abstract_compressor), intent(inout)   :: self     !! Compressor instance
        integer(int32),             intent(in)      :: dims(:)  !! Array dimensions
        integer(int32),             intent(in)      :: displ    !! Displacement in arrays
        type(c_ptr),                intent(in)      :: in       !! Pointer to compressed data
        type(c_ptr),                intent(in)      :: out      !! Pointer to uncompressed buffer
        type(dtfft_stream_t),       intent(in)      :: stream   !! Stream handle
        type(c_ptr) :: inptr, outptr
        integer(int32) :: permuted_dims(3)

        if ( product(dims(1:self%ndims)) == 0 ) then
            return
        endif
        REGION_BEGIN("Decompressing", COLOR_CORAL)

        inptr = ptr_offset(in, self%storage_size * displ)
        outptr = ptr_offset(out, self%storage_size * displ)
#ifdef DTFFT_DEBUG
        if ( is_same_ptr(inptr, outptr) ) then
            INTERNAL_ERROR("decompress: is_same_ptr(inptr, outptr)")
        endif
#endif
        permuted_dims(1:self%ndims) = dims(1:self%ndims)
        if ( self%dims_permutation == DIMS_PERMUTE_FORWARD ) then
            permuted_dims(1) = dims(2)
            if ( self%ndims == 2 ) then
                permuted_dims(2) = dims(1)
            else
                permuted_dims(2) = dims(3)
                permuted_dims(3) = dims(1)
            endif
        else if ( self%dims_permutation == DIMS_PERMUTE_BACKWARD) then
            if ( self%ndims == 2 ) then
                permuted_dims(1) = dims(2)
                permuted_dims(2) = dims(1)
            else
                permuted_dims(1) = dims(3)
                permuted_dims(2) = dims(1)
                permuted_dims(3) = dims(2)
            endif
        endif
        call self%decompress_private(permuted_dims(1:self%ndims), inptr, outptr, stream)
    REGION_END("Decompressing")
    end subroutine decompress

    pure real(real64) function get_average_rate(self)
    !! Returns the average compression rate over all executions
        class(abstract_compressor), intent(in)      :: self !! Compressor instance
        get_average_rate = self%compressed_rate / real(self%execution_count, real64)
    end function get_average_rate

MAKE_EQ_FUN(dtfft_compression_mode_t, compression_mode_eq)
MAKE_NE_FUN(dtfft_compression_mode_t, compression_mode_ne)

MAKE_EQ_FUN(dtfft_compression_lib_t, compression_lib_eq)
MAKE_NE_FUN(dtfft_compression_lib_t, compression_lib_ne)

MAKE_VALID_FUN_DTYPE(dtfft_compression_mode_t, is_valid_compression_mode, VALID_COMPRESSION_MODES)
MAKE_VALID_FUN_DTYPE(dtfft_compression_lib_t, is_valid_compression_lib, VALID_COMPRESSION_LIBS)

    pure function check_compression_config(config) result(error_code)
    !! Checks if the given compression configuration is valid
        type(dtfft_compression_config_t), intent(in)    :: config !! Compression configuration to check
        integer(int32)                                  :: error_code

        error_code = DTFFT_SUCCESS
        if ( .not. is_valid_compression_lib(config%compression_lib) ) then
            error_code = DTFFT_ERROR_COMPRESSION_INVALID_LIBRARY
            return
        endif
        if ( .not. is_valid_compression_mode(config%compression_mode) ) then
            error_code = DTFFT_ERROR_COMPRESSION_INVALID_MODE
            return
        endif
    end function check_compression_config

end module dtfft_abstract_compressor

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
module dtfft_interface_fftw_m
!! This module creates interface with fftw3 library
use iso_c_binding,                 only: c_ptr, c_int
use dtfft_interface_fftw_native_m, only: C_FFTW_R2R_KIND, FFTW_MEASURE, FFTW_DESTROY_INPUT
use dtfft_interface_fftw_native_m, only: fftw_destroy_plan, fftwf_destroy_plan
use dtfft_interface_fftw_native_m, only: fftw_malloc, fftw_free
#ifdef DTFFT_WITH_OPENMP
use dtfft_interface_fftw_native_m, only: fftw_init_threads, fftw_plan_with_nthreads
# ifdef FFTW_HAS_PLANNER_NTHREADS
use dtfft_interface_fftw_native_m, only: fftw_planner_nthreads
# endif
#endif
implicit none
private
public :: C_FFTW_R2R_KIND, FFTW_MEASURE, FFTW_DESTROY_INPUT
public :: fftw_destroy_plan, fftwf_destroy_plan
public :: fftw_execute_dft, fftwf_execute_dft
public :: fftw_execute_dft_r2c, fftwf_execute_dft_r2c
public :: fftw_execute_dft_c2r, fftwf_execute_dft_c2r
public :: fftw_execute_r2r, fftwf_execute_r2r
public :: fftw_plan_many_dft, fftwf_plan_many_dft
public :: fftw_plan_many_dft_r2c, fftwf_plan_many_dft_r2c
public :: fftw_plan_many_dft_c2r, fftwf_plan_many_dft_c2r
public :: fftw_plan_many_r2r, fftwf_plan_many_r2r
public :: fftw_malloc, fftw_free
#ifdef DTFFT_WITH_OPENMP
public :: fftw_init_threads, fftw_plan_with_nthreads
# ifdef FFTW_HAS_PLANNER_NTHREADS
public :: fftw_planner_nthreads
# endif
#endif

  interface
    subroutine fftw_execute_dft(plan, in, out) bind(C)
    !! Executes C2C plan, double precision.
#include "args_execute.i90"
    end subroutine fftw_execute_dft

    subroutine fftwf_execute_dft(plan, in, out) bind(C)
    !! Executes C2C plan, single precision.
#include "args_execute.i90"
    end subroutine fftwf_execute_dft

    subroutine fftw_execute_dft_r2c(plan, in, out) bind(C)
    !! Executes R2C plan, double precision.
#include "args_execute.i90"
    end subroutine fftw_execute_dft_r2c

    subroutine fftwf_execute_dft_r2c(plan, in, out) bind(C)
    !! Executes R2C plan, single precision.
#include "args_execute.i90"
    end subroutine fftwf_execute_dft_r2c

    subroutine fftw_execute_dft_c2r(plan, in, out) bind(C)
    !! Executes C2R plan, double precision.
#include "args_execute.i90"
    end subroutine fftw_execute_dft_c2r

    subroutine fftwf_execute_dft_c2r(plan, in, out) bind(C)
    !! Executes C2R plan, single precision.
#include "args_execute.i90"
    end subroutine fftwf_execute_dft_c2r

    subroutine fftw_execute_r2r(plan, in, out) bind(C)
    !! Executes R2R plan, double precision.
#include "args_execute.i90"
    end subroutine fftw_execute_r2r

    subroutine fftwf_execute_r2r(plan, in, out) bind(C)
    !! Executes R2R plan, single precision.
#include "args_execute.i90"
    end subroutine fftwf_execute_r2r

    type(c_ptr) function fftw_plan_many_dft(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,sign,flags) bind(C)
    !! Creates C2C plan, double precision.
#include "args_create.i90"
      integer(C_INT), value :: sign
    end function fftw_plan_many_dft

    type(c_ptr) function fftwf_plan_many_dft(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,sign,flags) bind(C)
    !! Creates C2C plan, single precision.
#include "args_create.i90"
      integer(C_INT), value :: sign
    end function fftwf_plan_many_dft

    type(c_ptr) function fftw_plan_many_dft_r2c(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,flags) bind(C)
    !! Creates R2C plan, double precision.
#include "args_create.i90"
    end function fftw_plan_many_dft_r2c

    type(c_ptr) function fftwf_plan_many_dft_r2c(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,flags) bind(C)
    !! Creates R2C plan, single precision.
#include "args_create.i90"
    end function fftwf_plan_many_dft_r2c

    type(c_ptr) function fftw_plan_many_dft_c2r(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,flags) bind(C)
    !! Creates C2R plan, double precision.
#include "args_create.i90"
    end function fftw_plan_many_dft_c2r

    type(c_ptr) function fftwf_plan_many_dft_c2r(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,flags) bind(C)
    !! Creates C2R plan, single precision.
#include "args_create.i90"
    end function fftwf_plan_many_dft_c2r

    type(c_ptr) function fftw_plan_many_r2r(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,kind,flags) bind(C)
    !! Creates R2R plan, double precision.
#include "args_create.i90"
      integer(C_FFTW_R2R_KIND), intent(in) :: kind(*)
    end function fftw_plan_many_r2r

    type(c_ptr) function fftwf_plan_many_r2r(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,kind,flags) bind(C)
    !! Creates R2R plan, single precision.
#include "args_create.i90"
      integer(C_FFTW_R2R_KIND), intent(in) :: kind(*)
    end function fftwf_plan_many_r2r
  end interface
end module dtfft_interface_fftw_m

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
module dtfft_executor_mkl_m
!! This module describes MKL based FFT Executor: [[mkl_executor]]
!!
!! https://software.intel.com/content/www/us/en/develop/documentation/onemkl-developer-reference-fortran/top/fourier-transform-functions/fft-functions.html
use iso_fortran_env,              only: int8, int32, int64, error_unit
use iso_c_binding,                only: c_int, c_long, c_ptr
#ifdef DTFFT_WITH_OPENMP
use omp_lib
#endif
use dtfft_abstract_executor,      only: abstract_executor, FFT_C2C, FFT_R2C, FFT_R2R
use dtfft_errors
use dtfft_interface_mkl_m
use dtfft_interface_mkl_native_m
use dtfft_parameters
use dtfft_utils,                  only: to_str
#include "_dtfft_mpi.h"
implicit none
private
public :: mkl_executor

#define MKL_DFTI_CALL(name, func)                                                                                                                                     \
  block;                                                                                                                                                              \
    integer(c_long) :: ierr;                                                                                                                                          \
    integer(int32)  :: mpi_err;                                                                                                                                       \
    ierr = func;                                                                                                                                                      \
    if( ierr /= DFTI_NO_ERROR ) then;                                                                                                                                 \
      write(error_unit, '(a)') "Error occured during call to MKL DFTI function '"//name//"': "//DftiErrorMessage(ierr)//" at "//__FILE__//":"//to_str(__LINE__);  \
      call MPI_Abort(MPI_COMM_WORLD, int(ierr, c_int), mpi_err);                                                                                                      \
    endif;                                                                                                                                                            \
  endblock

  type, extends(abstract_executor)  :: mkl_executor
  !! MKL FFT Executor
  private
    logical                       :: need_reconfigure     !! Needed for R2C plans
    integer(c_long), allocatable  :: istrides(:)          !! Input strides. Needed for R2C plans to reconfigure plan
    integer(c_long), allocatable  :: ostrides(:)          !! Output strides. Needed for R2C plans to reconfigure plan
    integer(int32)                :: idist                !! Input distance between the first data elements of consecutive data sets
    integer(int32)                :: odist                !! Output distance between the first data elements of consecutive data sets
  contains
    procedure :: create_private => create     !! Creates FFT plan via MKL DFTI Interface
    procedure :: execute_private => execute   !! Executes MKL plan
    procedure :: destroy_private => destroy   !! Destroys MKL plan
    procedure, nopass :: mem_alloc            !! Allocates MKL memory
    procedure, nopass :: mem_free             !! Frees MKL aligned memory
  endtype mkl_executor

contains

  subroutine make_plan(fft_rank, fft_sizes, mkl_precision, forward_domain, how_many, idist, odist, plan)
  !! Creates general MKL plan
    integer(int8),              intent(in)    :: fft_rank           !! Rank of fft: 1 or 2
    integer(c_long),            intent(in)    :: fft_sizes(:)       !! Dimensions of transform
    integer(int32),             intent(in)    :: mkl_precision      !! MKL Precision
    integer(int32),             intent(in)    :: forward_domain     !! C2C or R2C flag
    integer(int32),             intent(in)    :: how_many           !! Sets DFTI_NUMBER_OF_TRANSFORMS
    integer(int32),             intent(in)    :: idist              !! Sets DFTI_INPUT_DISTANCE
    integer(int32),             intent(in)    :: odist              !! Sets DFTI_OUTPUT_DISTANCE
    type(c_ptr),                intent(inout) :: plan               !! Resulting plan

    MKL_DFTI_CALL( "DftiCreateDescriptor", mkl_dfti_create_desc(mkl_precision, forward_domain, int(fft_rank, c_long), fft_sizes, plan) )
    MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(plan, DFTI_NUMBER_OF_TRANSFORMS, how_many) )
    MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(plan, DFTI_PLACEMENT, DFTI_NOT_INPLACE) )
    MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(plan, DFTI_INPUT_DISTANCE, idist) )
    MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(plan, DFTI_OUTPUT_DISTANCE, odist) )
    MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(plan, DFTI_CONJUGATE_EVEN_STORAGE, DFTI_COMPLEX_COMPLEX) )
#ifdef DTFFT_WITH_OPENMP
    MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(plan, DFTI_THREAD_LIMIT, omp_get_max_threads()) )
#endif
    MKL_DFTI_CALL( "DftiCommitDescriptor", mkl_dfti_commit_desc(plan) )
  end subroutine make_plan

  subroutine create(self, fft_rank, fft_type, precision, idist, odist, how_many, fft_sizes, inembed, onembed, error_code, r2r_kinds)
  !! Creates FFT plan via MKL DFTI Interface
    class(mkl_executor),              intent(inout) :: self           !! MKL FFT Executor
    integer(int8),                    intent(in)    :: fft_rank       !! Rank of fft: 1 or 2
    integer(int8),                    intent(in)    :: fft_type       !! Type of fft: r2r, r2c, c2c
    type(dtfft_precision_t),          intent(in)    :: precision      !! Precision of fft: DTFFT_SINGLE or DTFFT_DOUBLE
    integer(int32),                   intent(in)    :: idist          !! Distance between the first element of two consecutive signals in a batch of the input data.
    integer(int32),                   intent(in)    :: odist          !! Distance between the first element of two consecutive signals in a batch of the output data.
    integer(int32),                   intent(in)    :: how_many       !! Number of transforms to create
    integer(int32),                   intent(in)    :: fft_sizes(:)   !! Dimensions of transform
    integer(int32),                   intent(in)    :: inembed(:)     !! Storage dimensions of the input data in memory.
    integer(int32),                   intent(in)    :: onembed(:)     !! Storage dimensions of the output data in memory.
    integer(int32),                   intent(inout) :: error_code     !! Error code to be returned to user
    type(dtfft_r2r_kind_t), optional, intent(in)    :: r2r_kinds(:)   !! Kinds of r2r transform
    integer(int32)  :: forward_domain   !! Forward domain
    integer(int32)  :: mkl_precision    !! MKL Precision
    integer(int32)  :: i                !! Loop counter
    integer(int32)  :: idx              !! Index
    integer(c_long) :: iprod            !! Input product
    integer(c_long) :: oprod            !! Output product
    integer(c_long) :: sizes(fft_rank)  !! Sizes of FFT

    if ( present(r2r_kinds) ) then
    endif

    error_code = DTFFT_SUCCESS

    self%is_inverse_copied = .true.
    self%need_reconfigure = .false.

    select case (fft_type)
    case (FFT_C2C)
      forward_domain = DFTI_COMPLEX
    case (FFT_R2C)
      forward_domain = DFTI_REAL
      self%need_reconfigure = .true.
      self%idist = idist
      self%odist = odist
      allocate( self%istrides( size(inembed) + 1), source=0_c_long )
      allocate( self%ostrides( size(onembed) + 1), source=0_c_long )
      iprod = 1; oprod = 1
      self%istrides( size(inembed) + 1 ) = iprod
      self%ostrides( size(onembed) + 1 ) = oprod
      do i = 1, size(inembed) - 1
        idx = size(inembed) + 1 - i
        iprod = iprod * inembed( idx )
        oprod = oprod * onembed( idx )
        self%istrides(idx) = iprod
        self%ostrides(idx) = oprod
      enddo
    case (FFT_R2R)
      error_code = DTFFT_ERROR_R2R_FFT_NOT_SUPPORTED
      return
    endselect
    if(precision == DTFFT_DOUBLE) then
      mkl_precision = DFTI_DOUBLE
    else
      mkl_precision = DFTI_SINGLE
    endif

    sizes(:) = fft_sizes(:)
    call make_plan(fft_rank, sizes, mkl_precision, forward_domain, how_many, idist, odist, self%plan_forward)
    self%plan_backward = self%plan_forward
  end subroutine create

  subroutine execute(self, a, b, sign)
  !! Executes MKL plan
    class(mkl_executor),  intent(in)  :: self                 !! MKL FFT Executor
    type(c_ptr),          intent(in)  :: a                    !! Source pointer
    type(c_ptr),          intent(in)  :: b                    !! Target pointer
    integer(int8),        intent(in)  :: sign                 !! Sign of transform

    if ( self%need_reconfigure ) then
      if ( sign == FFT_FORWARD ) then
        MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(self%plan_forward, DFTI_INPUT_DISTANCE, self%idist) )
        MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(self%plan_forward, DFTI_OUTPUT_DISTANCE, self%odist) )
        MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(self%plan_forward, DFTI_INPUT_STRIDES, self%istrides) )
        MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(self%plan_forward, DFTI_OUTPUT_STRIDES, self%ostrides) )
      else
        MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(self%plan_forward, DFTI_INPUT_DISTANCE, self%odist) )
        MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(self%plan_forward, DFTI_OUTPUT_DISTANCE, self%idist) )
        MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(self%plan_forward, DFTI_INPUT_STRIDES, self%ostrides) )
        MKL_DFTI_CALL( "DftiSetValue", mkl_dfti_set_value(self%plan_forward, DFTI_OUTPUT_STRIDES, self%istrides) )
      endif
      MKL_DFTI_CALL( "DftiCommitDescriptor", mkl_dfti_commit_desc(self%plan_forward) )
    endif

    MKL_DFTI_CALL( "DftiCompute", mkl_dfti_execute(self%plan_forward, a, b, int(sign, c_int)) )
  end subroutine execute

  subroutine destroy(self)
  !! Destroys MKL plan
    class(mkl_executor),  intent(inout)  :: self              !! MKL FFT Executor

    MKL_DFTI_CALL( "DftiFreeDescriptor", mkl_dfti_free_desc(self%plan_forward) )
  end subroutine destroy

  subroutine mem_alloc(alloc_bytes, ptr)
  !! Allocates MKL memory
    integer(int64),           intent(in)  :: alloc_bytes      !! Number of bytes to allocate
    type(c_ptr),              intent(out) :: ptr              !! Allocated pointer

    MKL_DFTI_CALL( "mkl_malloc", mkl_dfti_mem_alloc(alloc_bytes, ptr) )
  end subroutine mem_alloc

  subroutine mem_free(ptr)
  !! Frees MKL aligned memory
    type(c_ptr),               intent(in)   :: ptr            !! Pointer to free

    MKL_DFTI_CALL( "mkl_free", mkl_dfti_mem_free(ptr) )
  end subroutine mem_free
end module dtfft_executor_mkl_m

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
module dtfft_executor_fftw_m
!! This module describes FFTW3 based FFT Executor: [[fftw_executor]]
!!
!! http://www.fftw.org
use iso_c_binding,              only: c_ptr, c_loc, c_null_ptr, c_int
use iso_fortran_env,            only: int8, int32, int64, real32
#ifdef DTFFT_WITH_OPENMP
use omp_lib
#endif
use dtfft_abstract_executor,    only: abstract_executor, FFT_C2C, FFT_R2C, FFT_R2R
use dtfft_errors
use dtfft_pencil,               only: pencil
use dtfft_interface_fftw_m
use dtfft_parameters
use dtfft_utils,                only: get_inverse_kind, is_null_ptr
implicit none
private
public :: fftw_executor

    integer(int32), parameter :: FFTW3_FLAGS = FFTW_MEASURE + FFTW_DESTROY_INPUT
    !! FFTW3 planner flags

    type, extends(abstract_executor) :: fftw_executor
    !! FFTW3 FFT Executor
    private
        procedure(apply_interface), nopass, pointer :: apply => NULL()          !! Pointer to FFTW3 function that executes FFT plan
        procedure(free_interface),  nopass, pointer :: free => NULL()           !! Pointer to FFTW3 function that destroys FFT plan
        procedure(apply_interface), nopass, pointer :: apply_inverse => NULL()  !! Pointer to FFTW3 function that executes inverse FFT plan
                                                                                !! Used in R2C only
    contains
        procedure :: create_private => create       !! Creates FFT plan via FFTW3 Interface
        procedure :: execute_private => execute     !! Executes FFTW3 plan
        procedure :: destroy_private => destroy     !! Destroys FFTW3 plan
        procedure, nopass :: mem_alloc              !! Allocates FFTW3 memory
        procedure, nopass :: mem_free               !! Frees FFTW3 aligned memory
    end type fftw_executor

    abstract interface
        subroutine apply_interface(plan, in, out) bind(C)
        !! Executes FFTW3 Plan
#include "args_execute.i90"
        end subroutine apply_interface

        subroutine free_interface(plan) bind(C)
        !! Destroys FFTW3 Plan
        import
            type(c_ptr), value :: plan
        end subroutine free_interface

        type(c_ptr) function create_c2c_plan(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,sign,flags) bind(C)
        !! Creates C2C FFTW3 Plan
#include "args_create.i90"
            integer(C_INT), value :: sign
        end function create_c2c_plan

        type(c_ptr) function create_r2c_plan(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,flags) bind(C)
        !! Creates R2C FFTW3 Plan
#include "args_create.i90"
        end function create_r2c_plan

        type(c_ptr) function create_r2r_plan(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,kinds,flags) bind(C)
        !! Creates R2R FFTW3 Plan
#include "args_create.i90"
            integer(C_FFTW_R2R_KIND), intent(in) :: kinds(*)
        end function create_r2r_plan
    end interface

#ifdef DTFFT_WITH_OPENMP
    logical, save :: CREATED_WITH_THREADS = .false.
#endif

contains
    subroutine create(self, fft_rank, fft_type, precision, idist, odist, how_many, fft_sizes, inembed, onembed, error_code, r2r_kinds)
    !! Creates FFT plan via FFTW3 Interface
        class(fftw_executor),             intent(inout) :: self           !! FFTW FFT Executor
        integer(int8),                    intent(in)    :: fft_rank       !! Rank of fft: 1 or 2
        integer(int8),                    intent(in)    :: fft_type       !! Type of fft: r2r, r2c, c2c
        type(dtfft_precision_t),          intent(in)    :: precision      !! Precision of fft: DTFFT_SINGLE or DTFFT_DOUBLE
        integer(int32),                   intent(in)    :: idist          !! Distance between the first element of two consecutive signals in a batch of the input data.
        integer(int32),                   intent(in)    :: odist          !! Distance between the first element of two consecutive signals in a batch of the output data.
        integer(int32),                   intent(in)    :: how_many       !! Number of transforms to create
        integer(int32),                   intent(in)    :: fft_sizes(:)   !! Dimensions of transform
        integer(int32),                   intent(in)    :: inembed(:)     !! Storage dimensions of the input data in memory.
        integer(int32),                   intent(in)    :: onembed(:)     !! Storage dimensions of the output data in memory.
        integer(int32),                   intent(inout) :: error_code     !! Error code to be returned to user
        type(dtfft_r2r_kind_t), optional, intent(in)    :: r2r_kinds(:)   !! Kinds of r2r transform
        integer(int32)                                  :: n_elements     !! Number of elements in `buf`
        type(c_ptr)                                     :: ptr            !! C pointer to `buf`

#ifdef DTFFT_WITH_OPENMP
        if ( .not. CREATED_WITH_THREADS ) then
            error_code = fftw_init_threads()
            if ( error_code == 0 ) then
                ! It has been called by user
                ! Check if number of threads is configured
                block
                    integer(c_int) :: n_threads
# ifdef FFTW_HAS_PLANNER_NTHREADS
                    n_threads = fftw_planner_nthreads()
#else
                    n_threads = 1_c_int
#endif
                    if ( n_threads == 1 ) then ! 1 is default
                        call fftw_plan_with_nthreads(omp_get_max_threads())
                    endif
                endblock
            else
                call fftw_plan_with_nthreads(omp_get_max_threads())
            endif
            CREATED_WITH_THREADS = .true.
        endif
#endif
        error_code = DTFFT_SUCCESS

        n_elements = product(fft_sizes) * how_many
        if ( fft_type == FFT_C2C .or. fft_type == FFT_R2C ) then
            n_elements = n_elements * 2
        endif
        if ( precision == DTFFT_DOUBLE ) then
            n_elements = n_elements * 2
        endif

        call self%mem_alloc(FLOAT_STORAGE_SIZE * n_elements, ptr)

        if ( precision == DTFFT_SINGLE ) then
            self%free => fftwf_destroy_plan
        else
            self%free => fftw_destroy_plan
        endif

        select case (fft_type)
        case (FFT_C2C)
            block
                procedure(create_c2c_plan), pointer  :: constructor

                if ( precision == DTFFT_SINGLE ) then
                    constructor => fftwf_plan_many_dft
                    self%apply => fftwf_execute_dft
                else
                    constructor => fftw_plan_many_dft
                    self%apply => fftw_execute_dft
                endif
                self%apply_inverse => NULL()
                self%plan_forward = constructor(int(fft_rank, int32), fft_sizes, how_many, ptr, inembed, 1, idist, ptr, onembed, 1, odist, int(FFT_FORWARD, int32), FFTW3_FLAGS)
                self%plan_backward = constructor(int(fft_rank, int32), fft_sizes, how_many, ptr, inembed, 1, idist, ptr, onembed, 1, odist, int(FFT_BACKWARD, int32), FFTW3_FLAGS)

                nullify(constructor)
            endblock
        case (FFT_R2C)
            block
                procedure(create_r2c_plan), pointer  :: constructor, constructor_inverse
                type(c_ptr) :: r_ptr

                if ( precision == DTFFT_SINGLE ) then
                    constructor => fftwf_plan_many_dft_r2c
                    self%apply => fftwf_execute_dft_r2c
                    constructor_inverse => fftwf_plan_many_dft_c2r
                    self%apply_inverse => fftwf_execute_dft_c2r
                else
                    constructor => fftw_plan_many_dft_r2c
                    self%apply => fftw_execute_dft_r2c
                    constructor_inverse => fftw_plan_many_dft_c2r
                    self%apply_inverse => fftw_execute_dft_c2r
                endif
                call self%mem_alloc(FLOAT_STORAGE_SIZE * n_elements / 2, r_ptr)
                self%plan_forward = constructor(int(fft_rank, int32), fft_sizes, how_many, r_ptr, inembed, 1, idist, ptr, onembed, 1, odist, FFTW3_FLAGS)
                self%plan_backward = constructor_inverse(int(fft_rank, int32), fft_sizes, how_many, ptr, onembed, 1, odist, r_ptr, inembed, 1, idist, FFTW3_FLAGS)

                call self%mem_free(r_ptr)

                nullify( constructor, constructor_inverse )
            endblock
        case (FFT_R2R)
            block
                procedure(create_r2r_plan), pointer :: constructor
                type(dtfft_r2r_kind_t),   allocatable :: inverse_kinds(:)
                integer(C_FFTW_R2R_KIND), allocatable :: knds(:)

                if ( precision == DTFFT_SINGLE ) then
                    constructor => fftwf_plan_many_r2r
                    self%apply => fftwf_execute_r2r
                else
                    constructor => fftw_plan_many_r2r
                    self%apply => fftw_execute_r2r
                endif
                self%apply_inverse => NULL()

                allocate( knds(size(r2r_kinds)) )
                knds(:) = int(r2r_kinds(:)%val, C_FFTW_R2R_KIND)

                self%plan_forward = constructor(int(fft_rank, int32), fft_sizes, how_many, ptr, inembed, 1, idist, ptr, onembed, 1, odist, knds, FFTW3_FLAGS)

                allocate( inverse_kinds( size(r2r_kinds) ) )
                inverse_kinds(:) = get_inverse_kind(r2r_kinds)
                if ( all( inverse_kinds == r2r_kinds ) ) then
                    self%plan_backward = self%plan_forward
                    self%is_inverse_copied = .true.
                else
                    knds(:) = int(inverse_kinds(:)%val, C_FFTW_R2R_KIND)
                    self%plan_backward = constructor(int(fft_rank, int32), fft_sizes, how_many, ptr, inembed, 1, idist, ptr, onembed, 1, odist, knds, FFTW3_FLAGS)
                endif
                deallocate( inverse_kinds, knds )
                nullify(constructor)
            endblock
        endselect

        call self%mem_free(ptr)
    end subroutine create

    subroutine execute(self, a, b, sign)
    !! Executes FFTW3 plan
        class(fftw_executor), intent(in)  :: self                 !! FFTW FFT Executor
        type(c_ptr),          intent(in)  :: a                    !! Source pointer
        type(c_ptr),          intent(in)  :: b                    !! Target pointer
        integer(int8),        intent(in)  :: sign                 !! Sign of transform

        if ( sign == FFT_FORWARD ) then
            call self%apply(self%plan_forward, a, b)
        else
            if ( associated( self%apply_inverse ) ) then
                call self%apply_inverse(self%plan_backward, a, b)
            else
                call self%apply(self%plan_backward, a, b)
            endif
        endif
    end subroutine execute

    subroutine destroy(self)
    !! Destroys FFTW3 plan
        class(fftw_executor), intent(inout) :: self               !! FFTW FFT Executor

        call self%free(self%plan_forward)
        if( .not. self%is_inverse_copied ) call self%free(self%plan_backward)
        self%apply => NULL()
        self%apply_inverse => NULL()
        self%free  => NULL()
    end subroutine destroy

    subroutine mem_alloc(alloc_bytes, ptr)
    !! Allocates FFTW3 memory
        integer(int64),           intent(in)  :: alloc_bytes      !! Number of bytes to allocate
        type(c_ptr),              intent(out) :: ptr              !! Allocated pointer
        ptr = fftw_malloc(alloc_bytes)
    end subroutine mem_alloc

    subroutine mem_free(ptr)
    !! Frees FFTW3 aligned memory
        type(c_ptr),               intent(in)   :: ptr            !! Pointer to free
        call fftw_free(ptr)
    end subroutine mem_free
end module dtfft_executor_fftw_m

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
program test_r2r_2d
use iso_fortran_env
use dtfft
use test_utils, only: attach_gpu_to_process
#include "_dtfft_cuda.h"
#include "_dtfft_mpi.h"
#include "dtfft.f03"
implicit none
  integer(int32) :: comm_size, comm_rank, ierr
  type(dtfft_plan_r2r_t) :: plan
  integer(int32) :: lbounds(3), sizes(3)
  type(dtfft_pencil_t) :: pencil
  type(dtfft_pencil_t) :: test, test2
  integer(int32), pointer :: dims(:)


  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, comm_size, ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)
  call attach_gpu_to_process()

  if ( comm_size /= 4 ) then
    if ( comm_rank == 0 ) write(output_unit, "(a)") "This test requires 4 MPI processes..."
    call MPI_Finalize(ierr)
    stop
  endif

  if ( comm_rank == 0 ) then
    lbounds = [-1, 0, 0]
    sizes = [4, 8, 12]
  elseif ( comm_rank == 1 ) then
    lbounds = [0, 0, 0]
    sizes = [4, 8, 12]
  else if ( comm_rank == 2 ) then
    lbounds = [0, 0, 8]
    sizes = [4, 8, 12]
  else
    lbounds = [0, 0, 8]
    sizes = [4, 8, 12]
  endif

  allocate( pencil%counts, source=sizes )
  allocate( pencil%starts, source=lbounds )

  call plan%create(pencil, effort=DTFFT_PATIENT, error_code=ierr)
  if ( ierr /= DTFFT_ERROR_PENCIL_NOT_INITIALIZED ) then
    print*,"ierr /= DTFFT_ERROR_PENCIL_NOT_INITIALIZED"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif

  pencil = dtfft_pencil_t(lbounds, sizes)
  call plan%create(pencil, effort=DTFFT_PATIENT, error_code=ierr)
  if ( ierr /= DTFFT_ERROR_PENCIL_INVALID_STARTS ) then
    print*,"ierr /= DTFFT_ERROR_PENCIL_INVALID_STARTS"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif

  if ( comm_rank == 0 ) then
    lbounds = [0, 0, 0]
  endif
  pencil = dtfft_pencil_t(lbounds, sizes)
  call plan%create(pencil, effort=DTFFT_PATIENT, error_code=ierr)
  if ( ierr /= DTFFT_ERROR_PENCIL_OVERLAP ) then
    print*,"ierr /= DTFFT_ERROR_PENCIL_OVERLAP"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif

  if ( comm_rank == 0 ) then
    lbounds = [0, 0, 0]
    sizes = [4, 8, 12]
  elseif ( comm_rank == 1 ) then
    lbounds = [0, 0, 0]
    sizes = [4, 8, 12]
  else if ( comm_rank == 2 ) then
    lbounds = [0, 0, 12]
    sizes = [4, 8, 12]
  else
    lbounds = [0, 0, 13]
    sizes = [4, 8, 12]
  endif
  pencil = dtfft_pencil_t(lbounds, sizes)
  call plan%create(pencil, effort=DTFFT_PATIENT, error_code=ierr)
  if ( ierr /= DTFFT_ERROR_PENCIL_OVERLAP ) then
    print*,"ierr /= DTFFT_ERROR_PENCIL_OVERLAP"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif

  if ( comm_rank == 0 ) then
    lbounds = [0, 0, 0]
    sizes = [4, 12, 12]
  elseif ( comm_rank == 1 ) then
    lbounds = [0, 8, 0]
    sizes = [4, 8, 12]
  else if ( comm_rank == 2 ) then
    lbounds = [0, 8, 12]
    sizes = [4, 8, 12]
  else
    lbounds = [0, 0, 12]
    sizes = [4, 8, 12]
  endif
  pencil = dtfft_pencil_t(lbounds, sizes)
  call plan%create(pencil, effort=DTFFT_PATIENT, error_code=ierr)
  if ( ierr /= DTFFT_ERROR_PENCIL_SHAPE_MISMATCH ) then
    print*,"ierr /= DTFFT_ERROR_PENCIL_SHAPE_MISMATCH"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif

  if ( comm_rank == 0 ) then
    lbounds = [0, 0, 0]
    sizes = [4, 8, 12]
  elseif ( comm_rank == 1 ) then
    lbounds = [0, 10, 0]
    sizes = [4, 8, 12]
  else if ( comm_rank == 2 ) then
    lbounds = [0, 10, 12]
    sizes = [4, 8, 12]
  else
    lbounds = [0, 0, 12]
    sizes = [4, 8, 12]
  endif
  pencil = dtfft_pencil_t(lbounds, sizes)
  call plan%create(pencil, effort=DTFFT_PATIENT, error_code=ierr)
  if ( ierr /= DTFFT_ERROR_PENCIL_NOT_CONTINUOUS ) then
    print*,"ierr /= DTFFT_ERROR_PENCIL_NOT_CONTINUOUS"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif

  ! Allowed since 3.0.0
  !
  ! if ( comm_rank == 0 ) then
  !   lbounds = [0, 0, 0]
  !   sizes = [4, 8, 12]
  ! elseif ( comm_rank == 1 ) then
  !   lbounds = [4, 0, 0]
  !   sizes = [4, 8, 12]
  ! else if ( comm_rank == 2 ) then
  !   lbounds = [8, 0, 0]
  !   sizes = [4, 8, 12]
  ! else
  !   lbounds = [12, 0, 0]
  !   sizes = [4, 8, 12]
  ! endif
  ! pencil = dtfft_pencil_t(lbounds, sizes)
  ! call plan%create(pencil, effort=DTFFT_PATIENT, error_code=ierr)
  ! if ( ierr /= DTFFT_ERROR_INVALID_COMM_FAST_DIM ) then
  !   print*,"ierr /= DTFFT_ERROR_INVALID_COMM_FAST_DIM"
  ! endif

  if ( comm_rank == 0 ) then
    lbounds = [0, 0, 0]
    sizes = [4, 8, 12]
  elseif ( comm_rank == 1 ) then
    lbounds = [0, 8, 0]
    sizes = [4, 8, 12]
  else if ( comm_rank == 2 ) then
    lbounds = [0, 8, 12]
    sizes = [4, 8, 12]
  else
    lbounds = [0, 0, 12]
    sizes = [4, 8, 12]
  endif
  pencil = dtfft_pencil_t(lbounds, sizes)
  call plan%create(pencil, effort=DTFFT_PATIENT, error_code=ierr)
  if ( ierr /= DTFFT_SUCCESS ) then
    print*,"ierr /= DTFFT_SUCCESS"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif

  test = plan%get_pencil(DTFFT_LAYOUT_X_PENCILS, error_code=ierr); DTFFT_CHECK(ierr)
  if ( any( lbounds /= test%starts ) ) then
    print*,"any( lbounds /= test%starts )"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif
  if ( any( sizes /= test%counts ) ) then
    print*," any( sizes /= test%counts )"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif

  test = plan%get_pencil(DTFFT_LAYOUT_Y_PENCILS, error_code=ierr); DTFFT_CHECK(ierr)
  if ( test%starts(2) /= lbounds(3) ) then
    print*,"test%starts(2) /= lbounds(3)"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif
  if ( test%counts(2) /= sizes(3) ) then
    print*,"test%counts(2) /= sizes(3)"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif

  test2 = plan%get_pencil(DTFFT_LAYOUT_Z_PENCILS, error_code=ierr); DTFFT_CHECK(ierr)
  if ( test2%starts(2) /= test%starts(3) ) then
    print*,"test2%starts(2) /= test%starts(2)"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif
  if ( test2%counts(2) /= test%counts(3) ) then
    print*,"test2%counts(2) /= test%counts(2)"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif


  call plan%get_dims(dims, error_code=ierr); DTFFT_CHECK(ierr)
  if ( any( dims /= [4, 16, 24] ) ) then
    print*,"any( dims /= [4, 16, 24] )"
    call MPI_Abort(MPI_COMM_WORLD, 1, ierr)
  endif

  call plan%destroy()
  call MPI_Finalize(ierr)
end program test_r2r_2d

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
module dtfft_interface_nvshmem
!! NVSHMEM Interfaces
use iso_c_binding
use iso_fortran_env
use dtfft_parameters
use dtfft_utils
#include "_dtfft_mpi.h"
implicit none
private
public :: nvshmem_team_t
public :: is_nvshmem_ptr
! public :: nvshmem_init, nvshmem_finalize
! public :: load_nvshmem


  type, bind(C) :: nvshmem_team_t
  !! NVSHMEM team.
    integer(c_int32_t) :: val  !! Internal representation of the NVSHMEM team.
  end type nvshmem_team_t

  type(nvshmem_team_t), parameter, public :: NVSHMEM_TEAM_WORLD = nvshmem_team_t(0)
  !! Global NVSHMEM team.

public :: nvshmem_malloc
public :: nvshmem_free
public :: nvshmemx_sync_all_on_stream
public :: nvshmemx_float_alltoall_on_stream
public :: nvshmem_ptr
public :: nvshmem_my_pe
! public :: nvshmemx_init_status

  interface
    function nvshmem_malloc(size) result(ptr) bind(C)
    !! Allocates symmetric memory in the NVSHMEM heap.
      import
      type(c_ptr)               :: ptr  !! Pointer to the allocated memory.
      integer(c_size_t), value  :: size            !! Size of the allocation in bytes.
    end function nvshmem_malloc
  end interface

  interface nvshmem_free
    subroutine nvshmem_free(ptr) bind(C)
    !! Frees symmetric memory allocated by nvshmem_malloc.
      import
      type(c_ptr), value :: ptr  !! Pointer to the memory to free.
    end subroutine nvshmem_free
  end interface

  interface
    subroutine nvshmemx_sync_all_on_stream(stream) bind(C)
    !! Synchronizes all PEs (Processing Elements) on the specified stream.
      import
      type(dtfft_stream_t), intent(in), value :: stream  !! CUDA stream for synchronization.
    end subroutine nvshmemx_sync_all_on_stream
  end interface

  interface
    function nvshmemx_float_alltoall_on_stream(team, dest, source, nelems, stream) result(ierr) bind(C)
    !! Performs an all-to-all exchange of floating-point data on the specified stream.
      import
      integer(c_int)                          :: ierr  !! Completion status.
      type(nvshmem_team_t), intent(in), value :: team   !! NVSHMEM team.
      type(c_ptr),                      value :: dest   !! Destination buffer.
      type(c_ptr),                      value :: source !! Source buffer.
      integer(c_size_t),    intent(in), value :: nelems !! Number of elements to exchange.
      type(dtfft_stream_t), intent(in), value :: stream !! CUDA stream for the operation.
    end function nvshmemx_float_alltoall_on_stream
  end interface

  interface
    function nvshmem_ptr(ptr, pe) result(pe_ptr) bind(C)
    !! Returns a pointer to a symmetric memory location on a specified PE.
      import
      type(c_ptr)               :: pe_ptr  !! Pointer to the symmetric memory on the specified PE.
      type(c_ptr),    value     :: ptr          !! Local pointer to the symmetric memory.
      integer(c_int), value     :: pe           !! PE (Processing Element) number.
    end function nvshmem_ptr
  end interface

  interface
    function nvshmem_my_pe() result(pe) bind(C)
    !! Returns the PE (Processing Element) number of the calling thread.
      import
      integer(c_int) :: pe  !! PE number of the calling thread.
    end function nvshmem_my_pe
  end interface

  interface
    function nvshmemx_init_status() result(status) bind(C)
      import
      integer(c_int)                          :: status  !! Completion status.
    end function nvshmemx_init_status
  end interface

  interface
    subroutine init_nvshmem(comm) bind(C)
      import
      integer(c_int), value :: comm  !! MPI communicator (C handle)
    end subroutine init_nvshmem
  end interface

  interface
    subroutine nvshmem_finalize_() bind(C, name="nvshmemi_finalize")
    !! Finalizes the NVSHMEM library.
    end subroutine nvshmem_finalize_
  end interface

  logical, save :: is_init = .false.
    !! Flag indicating whether NVSHMEM is initialized
  logical, save :: is_external_init = .false.
    !! Flag indicating whether NVSHMEM was initialized externally

  ! logical, save :: is_loaded = .false.
  !   !! Flag indicating whether the library is loaded
  ! type(c_ptr), save :: libnvshmem
  !   !! Handle to the loaded library
  ! type(c_funptr), save :: nvshmemFunctions(7)
  !   !! Array of pointers to the NVSHMEM functions

  ! procedure(nvshmem_malloc_interface),              pointer, public :: nvshmem_malloc
  !   !! Fortran pointer to the nvshmem_malloc function
  ! procedure(nvshmem_free_interface),                pointer, public :: nvshmem_free
  !   !! Fortran pointer to the nvshmem_free function
  ! procedure(nvshmemx_sync_all_on_stream_interface), pointer, public :: nvshmemx_sync_all_on_stream
  !   !! Fortran pointer to the nvshmemx_sync_all_on_stream function
  ! procedure(nvshmemx_float_alltoall_on_stream_interface), pointer, public :: nvshmemx_float_alltoall_on_stream
  !   !! Fortran pointer to the nvshmemx_float_alltoall_on_stream function
  ! procedure(nvshmem_ptr_interface),                 pointer, public :: nvshmem_ptr
  !   !! Fortran pointer to the nvshmem_ptr function
  ! procedure(nvshmem_my_pe_interface),               pointer, public :: nvshmem_my_pe
  !   !! Fortran pointer to the nvshmem_my_pe function
  ! procedure(nvshmemx_init_status_interface),                pointer,  public  :: nvshmemx_init_status

contains

  ! function load_nvshmem(cufftmp_handle) result(error_code)
  ! !! Loads the NVSHMEM library and needed symbols
  !   type(c_ptr),  intent(in)  :: cufftmp_handle
  !   integer(int32)  :: error_code !! Error code
  !   type(string), allocatable :: func_names(:)
  !   integer(int32) :: i

  !   error_code = DTFFT_SUCCESS
    ! if ( is_loaded ) return

    ! allocate(func_names(7))
    ! func_names(1) = string("nvshmem_malloc")
    ! func_names(2) = string("nvshmem_free")
    ! func_names(3) = string("nvshmemx_sync_all_on_stream")
    ! func_names(4) = string("nvshmemx_float_alltoall_on_stream")
    ! func_names(5) = string("nvshmem_ptr")
    ! func_names(6) = string("nvshmem_my_pe")
    ! func_names(7) = string("nvshmemx_init_status")

    ! ! error_code = dynamic_load(NVSHMEM_HOST_LIB, func_names, libnvshmem, nvshmemFunctions)
    ! ! call destroy_strings(func_names)
    ! ! if ( error_code /= DTFFT_SUCCESS ) return
    ! do i = 1, size(func_names)
    !   nvshmemFunctions(i) = load_symbol(cufftmp_handle, func_names(i)%raw)
    ! enddo

    ! call c_f_procpointer(nvshmemFunctions(1), nvshmem_malloc)
    ! call c_f_procpointer(nvshmemFunctions(2), nvshmem_free)
    ! call c_f_procpointer(nvshmemFunctions(3), nvshmemx_sync_all_on_stream)
    ! call c_f_procpointer(nvshmemFunctions(4), nvshmemx_float_alltoall_on_stream)
    ! call c_f_procpointer(nvshmemFunctions(5), nvshmem_ptr)
    ! call c_f_procpointer(nvshmemFunctions(6), nvshmem_my_pe)
    ! call c_f_procpointer(nvshmemFunctions(7), nvshmemx_init_status)

    ! print*, 'nvshmemx_init_status after load = ', nvshmemx_init_status()

    ! is_loaded = .true.
  ! end function load_nvshmem

  function is_nvshmem_ptr(ptr) result(bool)
  !! Checks if pointer is a symmetric nvshmem allocated pointer
    type(c_ptr)   :: ptr    !! Device pointer
    logical       :: bool   !! Result

    bool = .not.is_null_ptr( nvshmem_ptr(ptr, nvshmem_my_pe()) )
  end function is_nvshmem_ptr

  ! subroutine nvshmem_init(comm)
  ! !! Initializes NVSHMEM with the given MPI communicator
  !   TYPE_MPI_COMM, intent(in) :: comm  !! MPI communicator (Fortran handle)
  !   integer(c_int) :: status

  !   if ( is_init ) return
  !   status = nvshmemx_init_status()
  !   if( status == 0 ) then
  !     call init_nvshmem(GET_MPI_VALUE(comm))
  !   else
  !     is_external_init = .true.
  !   endif
  !   is_init = .true.
  ! end subroutine nvshmem_init

  ! subroutine nvshmem_finalize()
  ! !! Finalizes NVSHMEM if it was initialized internally
  !   if ( is_init .and. .not.is_external_init ) then
  !     call nvshmem_finalize_()
  !     is_init = .false.
  !   endif
  ! end subroutine nvshmem_finalize
end module dtfft_interface_nvshmem

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_abstract_kernel
!! This module defines [[abstract_kernel]] type and its type bound procedures.
!!
!! The abstract kernel is used in `reshape_handle_generic` type and
!! is resposible for packing/unpacking/permute operations.
!! The actual implementation of the kernel is deferred to the
!! `create_private`, `execute_private` and `destroy_private` procedures.
use iso_fortran_env
use iso_c_binding
#ifdef DTFFT_WITH_COMPRESSION
use dtfft_abstract_compressor
#endif
use dtfft_config
use dtfft_parameters
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
#include "_dtfft_profile.h"
implicit none
private
public :: abstract_kernel
public :: kernel_type_t, get_kernel_string, get_fused
public :: is_unpack_kernel, is_pack_kernel, is_transpose_kernel

public :: operator(==)
    interface operator(==)
        module procedure kernel_type_eq     !! Check if two `kernel_type_t` are equal
    end interface

public :: operator(/=)
    interface operator(/=)
        module procedure kernel_type_ne     !! Check if two `kernel_type_t` are not equal
    end interface

    type :: kernel_type_t
    !! Type of kernel
        integer(int32) :: val
    end type kernel_type_t

    type(kernel_type_t), parameter, public  :: KERNEL_COMPRESSION         = kernel_type_t(-2)
    !! Only compression/decompression kernel
    type(kernel_type_t), parameter, public  :: KERNEL_DUMMY               = kernel_type_t(-1)
    !! Dummy kernel, does nothing
    type(kernel_type_t), parameter, public  :: KERNEL_PACK                = kernel_type_t(1)
    !! Packs local buffer into contiguous memory
    type(kernel_type_t), parameter, public  :: KERNEL_COPY_PIPELINED      = kernel_type_t(2)
    !! Performs partial buffer copy
    type(kernel_type_t), parameter, public  :: KERNEL_UNPACK              = kernel_type_t(3)
    !! Unpacks contiguous buffer into strided layout
    type(kernel_type_t), parameter, public  :: KERNEL_COPY                = kernel_type_t(4)
    !! Performs buffer copy
    type(kernel_type_t), parameter, public  :: KERNEL_UNPACK_PIPELINED    = kernel_type_t(5)
    !! Unpacks only single part of contiguous buffer into strided layout
    type(kernel_type_t), parameter, public  :: KERNEL_PACK_PIPELINED      = kernel_type_t(6)
    !! Packs only single part of local buffer into contiguous memory
    type(kernel_type_t), parameter, public  :: KERNEL_PERMUTE_FORWARD     = kernel_type_t(7)
    !! Local permutation forward: XYZ -> YZX
    type(kernel_type_t), parameter, public  :: KERNEL_PERMUTE_BACKWARD    = kernel_type_t(8)
    !! Local permutation backward: ZXY -> YZX
    type(kernel_type_t), parameter, public  :: KERNEL_PERMUTE_BACKWARD_START    = kernel_type_t(9)
    !! Starts Local permutation backward: ZXY -> YXZ
    type(kernel_type_t), parameter, public  :: KERNEL_PERMUTE_BACKWARD_END    = kernel_type_t(10)
    !! Ends Local permutation backward: YXZ -> YZX
    type(kernel_type_t), parameter, public  :: KERNEL_PERMUTE_BACKWARD_END_PIPELINED   = kernel_type_t(11)
    !! Ends Local permutation backward: YXZ -> YZX. only partial permutation is performed
    type(kernel_type_t), parameter, public  :: KERNEL_PACK_FORWARD     = kernel_type_t(12)
    !! Partial forward permutation
    type(kernel_type_t), parameter, public  :: KERNEL_PACK_BACKWARD     = kernel_type_t(13)
    !! Partial backward permutation
    ! type(kernel_type_t), parameter, public  :: KERNEL_PACK_BACKWARD_START     = kernel_type_t(14)
    ! !! Starts of Partial backward permutation
    type(kernel_type_t), parameter, public  :: KERNEL_UNPACK_FORWARD = kernel_type_t(15)
    !! Unpacks contiguous buffer into strided layout and perform forward permutation
    type(kernel_type_t), parameter, public  :: KERNEL_UNPACK_FORWARD_PIPELINED = kernel_type_t(16)
    !! Unpacks only single part of contiguous buffer into strided layout and perform forward permutation
    type(kernel_type_t), parameter, public  :: KERNEL_UNPACK_BACKWARD = kernel_type_t(17)
    !! Unpacks contiguous buffer into strided layout and perform backward permutation
    type(kernel_type_t), parameter, public  :: KERNEL_UNPACK_BACKWARD_PIPELINED = kernel_type_t(18)
    !! Unpacks only single part of contiguous buffer into strided layout and perform backward permutation

    type(kernel_type_t), parameter          :: TRANSPOSE_KERNELS(*) = [KERNEL_PERMUTE_FORWARD, KERNEL_PERMUTE_BACKWARD, KERNEL_PERMUTE_BACKWARD_START, KERNEL_PACK_FORWARD, KERNEL_PACK_BACKWARD, KERNEL_UNPACK_FORWARD_PIPELINED, KERNEL_UNPACK_BACKWARD_PIPELINED]
    type(kernel_type_t), parameter          :: UNPACK_KERNELS(*) = [KERNEL_PERMUTE_BACKWARD_END, KERNEL_PERMUTE_BACKWARD_END_PIPELINED, KERNEL_UNPACK, KERNEL_UNPACK_PIPELINED, KERNEL_UNPACK_FORWARD, KERNEL_UNPACK_FORWARD_PIPELINED, KERNEL_UNPACK_BACKWARD, KERNEL_UNPACK_BACKWARD_PIPELINED]
    !! List of all unpack kernel types
    type(kernel_type_t), parameter          :: PACK_KERNELS(*) = [KERNEL_PACK, KERNEL_COPY_PIPELINED, KERNEL_PACK_PIPELINED, KERNEL_PACK_FORWARD, KERNEL_PACK_BACKWARD]
    !! List of all pack kernel types

    type, abstract :: abstract_kernel
    !! Abstract kernel type
    !!
    !! This kernel type is used in `reshape_handle_generic` type and
    !! is resposible for packing/unpacking/permute operations.
        logical                                 :: is_created = .false.     !! Kernel is created flag.
        logical                                 :: is_dummy = .false.       !! If kernel should do anything or not.
        logical                                 :: is_dummy_kernel = .false.    !! If kernel is of type KERNEL_DUMMY
        logical                                 :: is_dummy_compressed = .false.
        type(kernel_type_t)                     :: kernel_type              !! Type of the kernel
        type(string)                            :: kernel_string            
        integer(int32),             allocatable :: neighbor_data(:,:)       !! Neighbor data for pipelined unpacking
        integer(int32),             allocatable :: dims(:)                  !! Local dimensions to process
#ifdef DTFFT_WITH_COMPRESSION
        class(abstract_compressor), pointer     :: compressor               !! Compressor pointer. Compressor itself is created by generic handle and passed here
#endif
        logical                                 :: is_compress              !! Enable compression
        logical                                 :: is_decompress            !! Enable decompression
        integer(int64)                          :: base_storage             !! 
    contains
        procedure,                    pass(self)  :: create           !! Creates kernel
        procedure,                    pass(self)  :: execute          !! Executes kernel
        procedure,                    pass(self)  :: destroy          !! Destroys kernel
#ifdef DTFFT_WITH_COMPRESSION
        procedure,                    pass(self)  :: set_compressor
#endif
        procedure(create_interface),  deferred    :: create_private   !! Creates underlying kernel
        procedure(execute_interface), deferred    :: execute_private  !! Executes underlying kernel
        procedure(destroy_interface), deferred    :: destroy_private  !! Destroys underlying kernel
    end type abstract_kernel

    abstract interface
        subroutine create_interface(self, effort, base_storage, force_effort)
        import
        !! Creates underlying kernel
            class(abstract_kernel),         intent(inout) :: self             !! Abstract kernel
            type(dtfft_effort_t),           intent(in)    :: effort           !! Effort level for generating transpose kernels
            integer(int64),                 intent(in)    :: base_storage     !! Number of bytes needed to store single element
            logical,              optional, intent(in)    :: force_effort     !! Should effort be forced or not
        end subroutine create_interface

        subroutine execute_interface(self, in, out, stream, sync, neighbor)
        import
        !! Executes underlying kernel
            class(abstract_kernel),     intent(inout)   :: self         !! Abstract kernel
            type(c_ptr),                intent(in)      :: in           !! Source buffer, can be device or host pointer
            type(c_ptr),                intent(in)      :: out          !! Target buffer, can be device or host pointer
            type(dtfft_stream_t),       intent(in)      :: stream       !! Stream to execute on, used only for device pointers
            logical,                    intent(in)      :: sync         !! Sync stream after kernel execution
            integer(int32),   optional, intent(in)      :: neighbor     !! Source rank for pipelined unpacking
        end subroutine execute_interface

        subroutine destroy_interface(self)
        import
        !! Destroys underlying kernel
            class(abstract_kernel), intent(inout) :: self               !! Abstract kernel
        end subroutine destroy_interface
    end interface

contains

    function get_kernel_string(kernel) result(str)
    !! Gets the string description of a kernel
        type(kernel_type_t), intent(in) :: kernel !! kernel type
        type(string)                    :: str !! kernel string

        select case ( kernel%val )
        case ( KERNEL_PACK%val, KERNEL_PACK_PIPELINED%val )
            str = string("pack")
        case ( KERNEL_COPY%val, KERNEL_COPY_PIPELINED%val )
            str = string("copy")
        case ( KERNEL_UNPACK%val, KERNEL_UNPACK_PIPELINED%val )
            str = string("unpack")
        case ( KERNEL_PERMUTE_FORWARD%val )
            str = string("forward")
        case ( KERNEL_PERMUTE_BACKWARD%val )
            str = string("backward")
        case ( KERNEL_PERMUTE_BACKWARD_START%val )
            str = string("backward_start")
        case ( KERNEL_PERMUTE_BACKWARD_END%val, KERNEL_PERMUTE_BACKWARD_END_PIPELINED%val )
            str = string("backward_end")
        case ( KERNEL_UNPACK_FORWARD%val, KERNEL_UNPACK_FORWARD_PIPELINED%val )
            str = string("unpack_forward")
        case ( KERNEL_UNPACK_BACKWARD%val, KERNEL_UNPACK_BACKWARD_PIPELINED%val )
            str = string("unpack_backward")
        case ( KERNEL_PACK_FORWARD%val )
            str = string("pack_forward")
        case ( KERNEL_PACK_BACKWARD%val )
            str = string("pack_backward")
        case ( KERNEL_COMPRESSION%val )
            str = string("compression")
        case default
            str = string("unknown")
        endselect
    end function get_kernel_string

    function get_fused(kernel) result(fused)
    !! Converts kernel to its fused version if applicable
        type(kernel_type_t),  intent(in)  :: kernel !! kernel type
        type(kernel_type_t)               :: fused  !! fused kernel type

        select case ( kernel%val )
        case ( KERNEL_PACK%val )
            fused = KERNEL_PACK_PIPELINED
        case ( KERNEL_PERMUTE_FORWARD%val )
            fused = KERNEL_PACK_FORWARD
        case ( KERNEL_PERMUTE_BACKWARD%val )
            fused = KERNEL_PACK_BACKWARD
        case default
            fused = kernel
        endselect
    end function get_fused

    subroutine create(self, dims, effort, base_storage, kernel_type, neighbor_data, force_effort, with_compression, with_decompression)
    !! Creates kernel
        class(abstract_kernel),         intent(inout) :: self               !! Abstract kernel
        integer(int32),                 intent(in)    :: dims(:)            !! Local dimensions to process
        type(dtfft_effort_t),           intent(in)    :: effort             !! Effort level for generating transpose kernels
        integer(int64),                 intent(in)    :: base_storage       !! Number of bytes needed to store single element
        type(kernel_type_t),            intent(in)    :: kernel_type        !! Type of kernel to build
        integer(int32),       optional, intent(in)    :: neighbor_data(:,:) !! Optional pointers for unpack kernels
        logical,              optional, intent(in)    :: force_effort       !! Should effort be forced or not
        logical,              optional, intent(in)    :: with_compression   !! Enable compression after executing kernel
        logical,              optional, intent(in)    :: with_decompression !! Enable decompression before executing kernel

        call self%destroy()
        self%is_compress = .false.;   if ( present(with_compression) ) self%is_compress = with_compression
        self%is_decompress = .false.; if ( present(with_decompression) ) self%is_decompress = with_decompression
        self%is_dummy = .false.
        self%is_dummy_kernel = .false.
        if ( any(dims == 0) ) then
            self%is_created = .true.
            self%is_dummy = .true.
            return
        endif
        if ( kernel_type == KERNEL_DUMMY .and. .not.(self%is_compress .or. self%is_decompress) ) then
            self%is_created = .true.
            self%is_dummy_kernel = .true.
            return
        endif

        self%is_dummy_compressed = .false.
        if ( kernel_type == KERNEL_DUMMY .and. (self%is_compress .or. self%is_decompress) ) then
            self%is_dummy_compressed = .true.
            self%kernel_type = KERNEL_COMPRESSION
        else
            self%kernel_type = kernel_type
        endif
        self%base_storage = base_storage

#ifdef DTFFT_DEBUG
        if ( any(kernel_type == [KERNEL_PERMUTE_BACKWARD_START, KERNEL_PERMUTE_BACKWARD_END, KERNEL_PERMUTE_BACKWARD_END_PIPELINED]) ) then
            if ( size(dims) /= 3 ) then
                INTERNAL_ERROR("2-step permutation is only valid for 3d grid")
            endif
        endif
#endif
        if ( is_unpack_kernel(kernel_type) .or. is_pack_kernel(kernel_type) .or. self%is_compress .or. self%is_decompress ) then
#ifdef DTFFT_DEBUG
            if ( .not. present(neighbor_data) ) then
                INTERNAL_ERROR("Neighbor data required")
            endif
#endif
            allocate( self%neighbor_data, source=neighbor_data )
        endif
        allocate( self%dims, source=dims )
        if ( size(dims) == 2 ) then
            select case ( kernel_type%val )
            case ( KERNEL_PACK_BACKWARD%val )
                self%kernel_type = KERNEL_PACK_FORWARD
            case (KERNEL_PERMUTE_BACKWARD%val)
                self%kernel_type = KERNEL_PERMUTE_FORWARD
            case (KERNEL_UNPACK_BACKWARD%val)
                self%kernel_type = KERNEL_UNPACK_FORWARD
            case (KERNEL_UNPACK_BACKWARD_PIPELINED%val)
                self%kernel_type = KERNEL_UNPACK_FORWARD_PIPELINED
            endselect
        endif
        self%kernel_string = get_kernel_string(self%kernel_type)

        if ( .not. self%is_dummy_compressed ) call self%create_private(effort, base_storage, force_effort)
        self%is_created = .true.
    end subroutine create

    subroutine execute(self, in, out, stream, neighbor, aux, csize, csizes, skip_compression, skip_rank, sync)
    !! Executes kernel
        class(abstract_kernel),     intent(inout) :: self             !! Abstract kernel
        type(c_ptr),                intent(in)    :: in               !! Source buffer, can be device or host pointer
        type(c_ptr),                intent(in)    :: out              !! Target buffer, can be device or host pointer
        type(dtfft_stream_t),       intent(in)    :: stream           !! Stream to execute on, used only for device pointers
        integer(int32),   optional, intent(in)    :: neighbor         !! Source rank for pipelined unpacking
        type(c_ptr),      optional, intent(in)    :: aux              !! Target buffer, can be device or host pointer
        integer(int32),   optional, intent(inout) :: csize            !! Compressed buffer size
        integer(int32),   optional, intent(inout) :: csizes(:)        !! Multiple compression sizes. This should only be used with CUDA backends
        logical,          optional, intent(in)    :: skip_compression !! Skip compression/decompression stage. Should be used when packing/unpacking from itself.
        integer(int32),   optional, intent(in)    :: skip_rank        !! Skip compression/decompression for specific rank when neighbor is not specified.
        logical,          optional, intent(in)    :: sync             !! Sync stream after packing/compression. Should be used only for fused backends
        logical :: skip_compression_, with_compression, sync_
        integer :: batch_id
        integer(int32) :: skip_rank_
#ifdef DTFFT_WITH_COMPRESSION
        integer(int64)  :: compressed_bytes
#endif

        if ( self%is_dummy .or. self%is_dummy_kernel ) return
        skip_compression_ = .false.; if( present(skip_compression) ) skip_compression_ = skip_compression
        with_compression = self%is_compress .or. self%is_decompress
        if ( self%is_dummy_compressed .and. skip_compression_ ) return
        skip_rank_ = -1; if ( present(skip_rank) ) skip_rank_ = skip_rank
        sync_ = .false.; if ( present(sync) ) sync_ = sync

#ifdef DTFFT_DEBUG
        if ( .not. self%is_created ) then
            INTERNAL_ERROR("abstract_kernel.execute: kernel not created")
        endif
        ! WRITE_DEBUG("executing "//self%kernel_string%raw)
        if ( any(self%kernel_type == [KERNEL_UNPACK_PIPELINED, KERNEL_PERMUTE_BACKWARD_END_PIPELINED, KERNEL_COPY_PIPELINED, KERNEL_PACK_BACKWARD, KERNEL_PACK_FORWARD, KERNEL_PACK_PIPELINED]) ) then
            if ( .not.present(neighbor) ) then
                INTERNAL_ERROR("abstract_kernel.execute: Neighbor is not passed")
            endif
            if ( neighbor < 1 .or. neighbor > size(self%neighbor_data, dim=2) ) then
                INTERNAL_ERROR("abstract_kernel.execute: Neighbor index out of bounds")
            endif
        endif
# ifdef DTFFT_WITH_COMPRESSION
        if ( with_compression .and. .not.associated(self%compressor) ) then
            INTERNAL_ERROR("abstract_kernel.execute: .not.associated(self%compressor)")
        endif
        if ( with_compression .and. .not.skip_compression_ .and..not.present(aux) ) then
            INTERNAL_ERROR("abstract_kernel.execute: compression missing workspace")
        endif
        if ( self%is_compress .and. .not.skip_compression_ .and. present(csize) .and. present(csizes) ) then
            INTERNAL_ERROR("abstract_kernel.execute: present(csize) .and. present(csizes)")
        endif
        if ( self%is_compress .and. .not.skip_compression_ .and. .not.present(csize) .and. .not.present(csizes) ) then
            INTERNAL_ERROR("abstract_kernel.execute: .not.present(csize) .and. .not.present(csizes)")
        endif
        if ( self%is_compress .and. .not.skip_compression_ .and. present(csize) .and. .not. present(neighbor) ) then
            INTERNAL_ERROR("abstract_kernel.execute: present(csize) .and. .not. present(neighbor)")
        endif
# endif
#endif

        REGION_BEGIN(self%kernel_string%raw, COLOR_CHARTREUSE)
        block
        type(c_ptr) :: work
#ifdef DTFFT_WITH_COMPRESSION
            if ( self%is_decompress .and. .not.skip_compression_ ) then
                work = out; if ( .not. self%is_dummy_compressed ) work = aux
                call self%compressor%pre_sync(stream)
                if ( present(neighbor) ) then
                    call self%compressor%decompress(self%neighbor_data(:, neighbor), self%neighbor_data(4, neighbor), in, work, stream)
                else
                    do batch_id = 1, size(self%neighbor_data, dim=2)
                        call self%compressor%decompress(self%neighbor_data(:, batch_id), self%neighbor_data(4, batch_id), in, work, stream)
                    enddo
                endif
                call self%compressor%post_sync(stream)
                if ( .not. self%is_dummy_compressed ) call self%execute_private(work, out, stream, .false., neighbor)
            else if ( self%is_compress .and. .not.skip_compression_ ) then
                if ( self%is_dummy_compressed ) then
                    work = in
                else
                    work = aux
                    call self%execute_private(in, work, stream, .false., neighbor)
                endif
                call self%compressor%pre_sync(stream)
                if ( present(neighbor) ) then
                    compressed_bytes = self%compressor%compress(self%neighbor_data(:, neighbor), self%neighbor_data(5, neighbor), work, out, stream)
                    csize = bytes_to_floats(compressed_bytes)
                else
                    do batch_id = 1, size(self%neighbor_data, dim=2)
                        if ( skip_rank_ == batch_id ) cycle
                        compressed_bytes = self%compressor%compress(self%neighbor_data(:, batch_id), self%neighbor_data(5, batch_id), work, out, stream)
                        csizes(batch_id) = bytes_to_floats(compressed_bytes)
                    enddo
                endif
                call self%compressor%post_sync(stream)
                if ( sync_ ) call self%compressor%sync(stream)
            else
#endif
                call self%execute_private(in, out, stream, sync_, neighbor)
                if ( allocated( self%neighbor_data ) ) then
                    if ( present(csize) ) then
                        csize = product( self%neighbor_data(1:3, neighbor) ) * int( self%base_storage / FLOAT_STORAGE_SIZE, int32 )
                    endif
                    if ( present(csizes) ) then
                        do batch_id = 1, size(self%neighbor_data, dim=2)
                            csizes(batch_id) = product( self%neighbor_data(1:3, batch_id) ) * int( self%base_storage / FLOAT_STORAGE_SIZE, int32 )
                        enddo
                    endif
                endif
#ifdef DTFFT_WITH_COMPRESSION
            endif
#endif
        endblock
        REGION_END(self%kernel_string%raw)
    end subroutine execute

#ifdef DTFFT_WITH_COMPRESSION
    subroutine set_compressor(self, compressor)
    !! Sets created compressor for the kernel
        class(abstract_kernel),             intent(inout) :: self       !! Abstract kernel
        class(abstract_compressor), target, intent(in)    :: compressor !! Compressor to set
        self%compressor => compressor
    end subroutine set_compressor

    elemental function bytes_to_floats(bytes) result(floats)
    !! Converts number of bytes to number of floats needed to store them
        integer(int64), intent(in)  :: bytes    !! Number of bytes
        integer(int32)              :: floats   !! Number of floats
        integer(int64) :: padding, n_floats

        if (bytes <= 0_int64) then
            floats = 0_int32
            return
        end if

        padding = mod(bytes, FLOAT_STORAGE_SIZE)
        if (padding == 0_int64) then
            n_floats = bytes / FLOAT_STORAGE_SIZE
        else
            n_floats = ( bytes + (FLOAT_STORAGE_SIZE - padding) ) / FLOAT_STORAGE_SIZE
        end if
        floats = int(n_floats, int32)
    end function bytes_to_floats
#endif

    subroutine destroy(self)
    !! Destroys kernel
        class(abstract_kernel), intent(inout) :: self                 !! Abstract kernel

        if ( .not. self%is_created ) return
        if ( self%is_dummy ) then
            self%is_created = .false.
            return
        endif
        call self%destroy_private()
        if ( allocated(self%dims) ) deallocate(self%dims)
        if ( allocated(self%neighbor_data) ) deallocate(self%neighbor_data)
        call self%kernel_string%destroy()
        self%is_dummy_compressed = .false.
        self%is_created = .false.
    end subroutine destroy

    MAKE_EQ_FUN(kernel_type_t, kernel_type_eq)
    MAKE_NE_FUN(kernel_type_t, kernel_type_ne)
    MAKE_VALID_FUN_DTYPE(kernel_type_t, is_transpose_kernel, TRANSPOSE_KERNELS)
    MAKE_VALID_FUN_DTYPE(kernel_type_t, is_unpack_kernel, UNPACK_KERNELS)
    MAKE_VALID_FUN_DTYPE(kernel_type_t, is_pack_kernel, PACK_KERNELS)
end module dtfft_abstract_kernel

program test_device_kernels
use iso_c_binding
use iso_fortran_env
use dtfft_abstract_kernel
use dtfft_interface_cuda_runtime
use dtfft_interface_cuda
use dtfft_interface_nvrtc
use dtfft_config
use dtfft_kernel_device
use dtfft_kernel_host
use dtfft_parameters
use dtfft_utils
#include "_dtfft_cuda.h"
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
implicit none
integer(int32) :: ierror
type(dtfft_stream_t) :: stream
 
    call MPI_Init(ierror)
    ierror = init_internal()
    ierror = load_cuda()
    ierror = load_nvrtc()

    CUDA_CALL( cudaStreamCreate(stream) )

    call execute_test([18, 155], KERNEL_PERMUTE_FORWARD)
    call execute_test([18, 155], KERNEL_PACK)
    call execute_test([18, 155], KERNEL_UNPACK)
    call execute_test([18, 155], KERNEL_PACK_FORWARD)


    call execute_test([18, 33, 155], KERNEL_PERMUTE_FORWARD)
    call execute_test([18, 33, 155], KERNEL_PERMUTE_BACKWARD)
    call execute_test([18, 33, 155], KERNEL_PERMUTE_BACKWARD_START)
    call execute_test([18, 33, 155], KERNEL_PERMUTE_BACKWARD_END)
    call execute_test([18, 33, 155], KERNEL_PACK)
    call execute_test([18, 33, 155], KERNEL_UNPACK)
    call execute_test([18, 33, 155], KERNEL_PACK_FORWARD)
    call execute_test([18, 33, 155], KERNEL_PACK_BACKWARD)

    CUDA_CALL( cudaStreamDestroy(stream) )

    call MPI_Finalize(ierror)
contains

    subroutine execute_test(dims, kernel_type)
        integer(int32),         intent(in) :: dims(:)
        type(kernel_type_t),    intent(in) :: kernel_type
        type(c_ptr) :: p1, p2, p2_host, p3, gold
        integer(int32) :: locals(5, 1)
        type(kernel_device) :: dev
        type(kernel_host) :: host
        real(real32), pointer, contiguous :: p2_host_(:), p3_(:), gold_(:)
        integer(int32) :: i
        real(real32) :: rnd
        type(string) :: kernel_string

        locals(1:size(dims), 1) = dims(:)
        if ( size(dims) == 2 ) locals(3, 1) = 1
        locals(4, 1) = 0
        locals(5, 1) = 0

        kernel_string = get_kernel_string(kernel_type)
        print*,'Testing kernel '//kernel_string%raw//', ndims = '//to_str(size(dims))

        call dev%create(dims, DTFFT_ESTIMATE, FLOAT_STORAGE_SIZE, kernel_type, locals)
        call host%create(dims, DTFFT_ESTIMATE, FLOAT_STORAGE_SIZE, kernel_type, locals)

        CUDA_CALL( cudaMalloc(p1, FLOAT_STORAGE_SIZE * product(dims)) )
        CUDA_CALL( cudaMalloc(p2, FLOAT_STORAGE_SIZE * product(dims)) )
        p2_host = mem_alloc_host(FLOAT_STORAGE_SIZE * product(dims))
        p3 = mem_alloc_host(FLOAT_STORAGE_SIZE * product(dims))
        gold = mem_alloc_host(FLOAT_STORAGE_SIZE * product(dims))

        call c_f_pointer(p3, p3_, [product(dims)])
        call c_f_pointer(gold, gold_, [product(dims)])
        do i = 1, product(dims)
            call random_number(rnd)
            p3_(i) = rnd * real(i, real32)
        enddo

        CUDA_CALL( cudaMemcpy(p1, p3, FLOAT_STORAGE_SIZE * product(dims), cudaMemcpyHostToDevice) )
        CUDA_CALL( cudaDeviceSynchronize() )

        call host%execute(p3, gold, stream, 1)
        call dev%execute(p1, p2, stream, 1)

        CUDA_CALL( cudaDeviceSynchronize() )
        CUDA_CALL( cudaMemcpy(p2_host, p2, FLOAT_STORAGE_SIZE * product(dims), cudaMemcpyDeviceToHost) )

        call c_f_pointer(p2_host, p2_host_, [product(dims)])
        do i = 1, product(dims)
            if (abs(p2_host_(i) - gold_(i)) > 1e-6) then
                print*,'i = ',i, 'gold = ',gold_(i), 'dev = ',p2_host_(i)
                INTERNAL_ERROR("Mismatch between device and host results")
            end if
        enddo
        call mem_free_host(p2_host)
        call mem_free_host(p3)
        call mem_free_host(gold)
        CUDA_CALL( cudaFree(p1) )
        CUDA_CALL( cudaFree(p2) )
        call dev%destroy()
        call host%destroy()
        print*,'SUCCESS'
    end subroutine execute_test
end program test_device_kernels

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
module dtfft_interface_cufft
!! cuFFT Interfaces
use iso_c_binding
use iso_fortran_env
use dtfft_parameters
! #ifdef DTFFT_WITH_NVSHMEM
! use dtfft_interface_nvshmem,              only: load_nvshmem
! #endif
use dtfft_utils
implicit none
private
public :: CUFFT_R2C, CUFFT_C2R, CUFFT_C2C
public :: CUFFT_D2Z, CUFFT_Z2D, CUFFT_Z2Z
public :: cufftGetErrorString
! public :: load_cufft


  integer(c_int), parameter,  public :: CUFFT_COMM_MPI = 0

  enum, bind(C)
    enumerator :: CUFFT_R2C = 42
    enumerator :: CUFFT_C2R = 44
    enumerator :: CUFFT_C2C = 41
    enumerator :: CUFFT_D2Z = 106
    enumerator :: CUFFT_Z2D = 108
    enumerator :: CUFFT_Z2Z = 105
  end enum

  enum, bind(C)
    enumerator :: CUFFT_SUCCESS = 0
    enumerator :: CUFFT_INVALID_PLAN = 1
    enumerator :: CUFFT_ALLOC_FAILED = 2
    enumerator :: CUFFT_INVALID_TYPE = 3
    enumerator :: CUFFT_INVALID_VALUE = 4
    enumerator :: CUFFT_INTERNAL_ERROR = 5
    enumerator :: CUFFT_EXEC_FAILED = 6
    enumerator :: CUFFT_SETUP_FAILED = 7
    enumerator :: CUFFT_INVALID_SIZE = 8
    enumerator :: CUFFT_UNALIGNED_DATA = 9
    enumerator :: CUFFT_INCOMPLETE_PARAMETER_LIST = 10
    enumerator :: CUFFT_INVALID_DEVICE = 11
    enumerator :: CUFFT_PARSE_ERROR = 12
    enumerator :: CUFFT_NO_WORKSPACE = 13
    enumerator :: CUFFT_NOT_IMPLEMENTED = 14
    enumerator :: CUFFT_LICENSE_ERROR = 15
    enumerator :: CUFFT_NOT_SUPPORTED = 16
  end enum

public :: cufftReshapeHandle
  type, bind(C) :: cufftReshapeHandle
  !! An opaque handle to a reshape operation.
    type(c_ptr) :: cptr
  end type cufftReshapeHandle

public :: cufftPlanMany
  interface
  !! Creates a FFT plan configuration of dimension rank, with sizes specified in the array n.
    function cufftPlanMany(plan, rank, n, inembed, istride, idist, onembed, ostride, odist, ffttype, batch)     &
      result(cufftResult)                                                                                       &
      bind(C, name="cufftPlanMany")
    import
      type(c_ptr)                       :: plan
        !! Pointer to an uninitialized cufftHandle object.
      integer(c_int),             value :: rank
        !! Dimensionality of the transform (1, 2, or 3).
      integer(c_int)                    :: n(*)
        !! Array of size rank, describing the size of each dimension,
        !! n[0] being the size of the outermost
        !! and n[rank-1] innermost (contiguous) dimension of a transform.
      integer(c_int)                    :: inembed(*)
        !! Pointer of size rank that indicates the storage dimensions of the input data in memory.
        !! If set to NULL, all other advanced data layout parameters are ignored.
      integer(c_int),             value :: istride
        !! Indicates the distance between two successive input elements in the least
        !! significant (i.e., innermost) dimension.
      integer(c_int),             value :: idist
        !! Indicates the distance between the first element of two consecutive signals
        !! in a batch of the input data.
      integer(c_int)                    :: onembed(*)
        !! Pointer of size rank that indicates the storage dimensions of the output data in memory.
        !! If set to NULL, all other advanced data layout parameters are ignored.
      integer(c_int),             value :: ostride
        !! Indicates the distance between two successive output elements in the output array
        !! in the least significant (i.e., innermost) dimension.
      integer(c_int),             value :: odist
        !! Indicates the distance between the first element of two consecutive signals
        !! in a batch of the output data.
      integer(c_int),             value :: ffttype
        !! The transform data type (e.g., CUFFT_R2C for single precision real to complex).
      integer(c_int),             value :: batch
        !! Batch size for this transform.
      integer(c_int)                    :: cufftResult
        !! The enumerated type cufftResult defines API call result codes.
    end function cufftPlanMany
  end interface

public :: cufftXtExec
  interface
  !! Executes any cuFFT transform regardless of precision and type.
  !! In case of complex-to-real and real-to-complex transforms, the direction parameter is ignored.
    function cufftXtExec(plan, input, output, direction)                                                        &
      result(cufftResult)                                                                                       &
      bind(C, name="cufftXtExec")
    import
      type(c_ptr),                value :: plan
        !! cufftHandle returned by cufftCreate.
      type(c_ptr),                value :: input
        !! Pointer to the input data (in GPU memory) to transform.
      type(c_ptr),                value :: output
        !! Pointer to the output data (in GPU memory).
      integer(c_int),             value :: direction
        !! The transform direction: CUFFT_FORWARD or CUFFT_INVERSE.
        !! Ignored for complex-to-real and real-to-complex transforms.
      integer(c_int)                    :: cufftResult
        !! The enumerated type cufftResult defines API call result codes.
    end function cufftXtExec
  end interface

public :: cufftDestroy
  interface
  !! Frees all GPU resources associated with a cuFFT plan and destroys the internal plan data structure.
    function cufftDestroy(plan)                                                                                 &
      result(cufftResult)                                                                                       &
      bind(C, name="cufftDestroy")
    import
      type(c_ptr), value :: plan         !! Object of the plan to be destroyed.
      integer(c_int)     :: cufftResult  !! The enumerated type cufftResult defines API call result codes.
    end function cufftDestroy
  end interface

public :: cufftSetStream
  interface
  !! Associates a CUDA stream with a cuFFT plan.
    function cufftSetStream(plan, stream) &
      result(cufftResult) &
      bind(C, name="cufftSetStream")
    import
      type(c_ptr),          value :: plan
        !! Object to associate with the stream.
      type(dtfft_stream_t), value :: stream
        !! A valid CUDA stream.
      integer(c_int)              :: cufftResult
        !! The enumerated type cufftResult defines API call result codes.
    end function cufftSetStream
  end interface

public :: cufftMpCreateReshape
  interface
  !! Initializes a reshape handle for future use. This function is not collective.
    function cufftMpCreateReshape(reshapeHandle)                                                                &
      result(cufftResult)                                                                                       &
      bind(C, name="cufftMpCreateReshape")
    import
      type(cufftReshapeHandle) :: reshapeHandle
        !! The reshape handle.
      integer(c_int)           :: cufftResult
        !! The enumerated type cufftResult defines API call result codes.
    end function cufftMpCreateReshape
  end interface

public :: cufftMpAttachReshapeComm
  interface
  !! Attaches a communication handle to a reshape. This function is not collective.
    function cufftMpAttachReshapeComm(reshapeHandle, commType, comm)                                            &
      result(cufftResult)                                                                                       &
      bind(C, name="cufftMpAttachReshapeComm")
    import
      type(cufftReshapeHandle), value :: reshapeHandle
        !! The reshape handle.
      integer(c_int),           value :: commType
        !! An enum describing the communication type of the handle.
      type(c_ptr)                     :: comm
        !! If commType is CUFFT_COMM_MPI, this should be a pointer to an MPI communicator.
        !! The pointer should remain valid until destruction of the handle.
        !! Otherwise, this should be NULL.
      integer(c_int)                  :: cufftResult
        !! The enumerated type cufftResult defines API call result codes.
    end function cufftMpAttachReshapeComm
  end interface

public :: cufftMpGetReshapeSize
  interface
  !! Returns the amount (in bytes) of workspace required to execute the handle.
    function cufftMpGetReshapeSize(reshapeHandle, workSize)                                                     &
      result(cufftResult)                                                                                       &
      bind(C, name="cufftMpGetReshapeSize")
    import
      type(cufftReshapeHandle), value :: reshapeHandle
        !! The reshape handle.
      integer(c_size_t)               :: workSize
        !! The size, in bytes, of the workspace required during reshape execution.
      integer(c_int)                  :: cufftResult
        !! The enumerated type cufftResult defines API call result codes.
    end function cufftMpGetReshapeSize
  end interface

public :: cufftMpMakeReshape
  interface
  !! Creates a reshape intended to re-distribute a global array of 3D data.
    function cufftMpMakeReshape(reshapeHandle, elementSize, rank, lower_input, upper_input,                     &
                                                                  lower_output, upper_output,                   &
                                                                  strides_input, strides_output)                &
      result(cufftResult)                                                                                       &
      bind(C, name="cufftMpMakeReshape")
    import
      type(cufftReshapeHandle), value :: reshapeHandle
        !! The reshape handle.
      integer(c_long_long),     value :: elementSize
        !! The size of the individual elements, in bytes. Allowed values are 4, 8, and 16.
      integer(c_int),           value :: rank
        !! The length of the lower_input, upper_input, lower_output, upper_output, strides_input, and strides_output arrays. rank should be 3.
      integer(c_long_long)            :: lower_input(*)
        !! An array of length rank, representing the lower-corner of the portion of the global nx * ny * nz array owned by the current process in the input descriptor.
      integer(c_long_long)            :: upper_input(*)
        !! An array of length rank, representing the upper-corner of the portion of the global nx * ny * nz array owned by the current process in the input descriptor.
      integer(c_long_long)            :: lower_output(*)
        !! An array of length rank, representing the lower-corner of the portion of the global nx * ny * nz array owned by the current process in the output descriptor.
      integer(c_long_long)            :: upper_output(*)
        !! An array of length rank, representing the upper-corner of the portion of the global nx * ny * nz array owned by the current process in the output descriptor.
      integer(c_long_long)            :: strides_input(*)
        !! An array of length rank, representing the local data layout of the input descriptor in memory. All entries must be decreasing and positive.
      integer(c_long_long)            :: strides_output(*)
        !! An array of length rank, representing the local data layout of the output descriptor in memory. All entries must be decreasing and positive.
      integer(c_int)                  :: cufftResult
        !! The enumerated type cufftResult defines API call result codes.
    end function cufftMpMakeReshape
  end interface

public :: cufftMpExecReshapeAsync
  interface
  !! Executes the reshape, redistributing data_in into data_out using the workspace in workspace.
    function cufftMpExecReshapeAsync(reshapeHandle, dataOut, dataIn, workSpace, stream)                         &
      result(cufftResult)                                                                                       &
      bind(C, name="cufftMpExecReshapeAsync")
    import
      type(cufftReshapeHandle), value :: reshapeHandle
        !! The reshape handle.
      type(c_ptr),              value :: dataOut
        !! A symmetric-heap pointer to the output data. This memory should be NVSHMEM allocated and identical on all processes.
      type(c_ptr),              value :: dataIn
        !! A symmetric-heap pointer to the input data. This memory should be NVSHMEM allocated and identical on all processes.
      type(c_ptr),              value :: workSpace
        !! A symmetric-heap pointer to the workspace data. This memory should be NVSHMEM allocated and identical on all processes.
      type(dtfft_stream_t),     value :: stream
        !! The CUDA stream in which to run the reshape operation.
      integer(c_int)                  :: cufftResult
        !! The enumerated type cufftResult defines API call result codes.
    end function cufftMpExecReshapeAsync
  end interface

public :: cufftMpDestroyReshape
  interface
  !! Destroys a reshape and all its associated data.
    function cufftMpDestroyReshape(reshapeHandle)                                                               &
      result(cufftResult)                                                                                       &
      bind(C, name="cufftMpDestroyReshape")
    import
      type(cufftReshapeHandle), value :: reshapeHandle  !! The reshape handle.
      integer(c_int)                  :: cufftResult    !! The enumerated type cufftResult defines API call result codes.
    end function cufftMpDestroyReshape
  end interface

!   logical, save :: is_loaded = .false.
!     !! Flag indicating whether the library is loaded
!   type(c_ptr), save :: libcufft
!     !! Handle to the loaded library

! #ifdef DTFFT_WITH_NVSHMEM
!   character(len=*), parameter :: LIB_NAME = "libcufftMp.so"
!   integer(c_int),   parameter :: CUFFT_MAX_FUNCTIONS = 10
! #else
!   character(len=*), parameter :: LIB_NAME = "libcufft.so"
!   integer(c_int),   parameter :: CUFFT_MAX_FUNCTIONS = 4
! #endif

!   type(c_funptr), save :: cufftFunctions(CUFFT_MAX_FUNCTIONS)
!     !! Array of pointers to the cuFFT functions

!   procedure(cufftPlanMany_interface),             pointer, public :: cufftPlanMany
!     !! Fortran pointer to the cufftPlanMany function
!   procedure(cufftXtExec_interface),               pointer, public :: cufftXtExec
!     !! Fortran pointer to the cufftXtExec function
!   procedure(cufftDestroy_interface),              pointer, public :: cufftDestroy
!     !! Fortran pointer to the cufftDestroy function
!   procedure(cufftSetStream_interface),            pointer, public :: cufftSetStream
!     !! Fortran pointer to the cufftSetStream function
!   procedure(cufftMpCreateReshape_interface),      pointer, public :: cufftMpCreateReshape
!     !! Fortran pointer to the cufftMpCreateReshape function
!   procedure(cufftMpAttachReshapeComm_interface),  pointer, public :: cufftMpAttachReshapeComm
!     !! Fortran pointer to the cufftMpAttachReshapeComm function
!   procedure(cufftMpGetReshapeSize_interface),     pointer, public :: cufftMpGetReshapeSize
!     !! Fortran pointer to the cufftMpGetReshapeSize function
!   procedure(cufftMpMakeReshape_interface),        pointer, public :: cufftMpMakeReshape
!     !! Fortran pointer to the cufftMpMakeReshape function
!   procedure(cufftMpExecReshapeAsync_interface),   pointer, public :: cufftMpExecReshapeAsync
!     !! Fortran pointer to the cufftMpExecReshapeAsync function
!   procedure(cufftMpDestroyReshape_interface),     pointer, public :: cufftMpDestroyReshape
!     !! Fortran pointer to the cufftMpDestroyReshape function

contains

!   function load_cufft() result(error_code)
!   !! Loads the cuFFT library and needed symbols
!     integer(int32)  :: error_code !! Error code
!     type(string), allocatable :: func_names(:)

!     error_code = DTFFT_SUCCESS
! !     if ( is_loaded ) return

! !     allocate(func_names(CUFFT_MAX_FUNCTIONS))
! !     func_names(1) = string("cufftPlanMany")
! !     func_names(2) = string("cufftXtExec")
! !     func_names(3) = string("cufftDestroy")
! !     func_names(4) = string("cufftSetStream")
! ! #ifdef DTFFT_WITH_NVSHMEM
! !     func_names(5) = string("cufftMpCreateReshape")
! !     func_names(6) = string("cufftMpAttachReshapeComm")
! !     func_names(7) = string("cufftMpGetReshapeSize")
! !     func_names(8) = string("cufftMpMakeReshape")
! !     func_names(9) = string("cufftMpExecReshapeAsync")
! !     func_names(10) = string("cufftMpDestroyReshape")
! ! #endif

! !     error_code = dynamic_load(LIB_NAME, func_names, libcufft, cufftFunctions)
! !     call destroy_strings(func_names)
! !     if ( error_code /= DTFFT_SUCCESS ) return

! !     call c_f_procpointer(cufftFunctions(1), cufftPlanMany)
! !     call c_f_procpointer(cufftFunctions(2), cufftXtExec)
! !     call c_f_procpointer(cufftFunctions(3), cufftDestroy)
! !     call c_f_procpointer(cufftFunctions(4), cufftSetStream)
! ! #ifdef DTFFT_WITH_NVSHMEM
! !     call c_f_procpointer(cufftFunctions(5), cufftMpCreateReshape)
! !     call c_f_procpointer(cufftFunctions(6), cufftMpAttachReshapeComm)
! !     call c_f_procpointer(cufftFunctions(7), cufftMpGetReshapeSize)
! !     call c_f_procpointer(cufftFunctions(8), cufftMpMakeReshape)
! !     call c_f_procpointer(cufftFunctions(9), cufftMpExecReshapeAsync)
! !     call c_f_procpointer(cufftFunctions(10), cufftMpDestroyReshape)

! !     error_code = load_nvshmem(libcufft)
! ! #endif

! !     is_loaded = .true.
!   end function load_cufft



  function cufftGetErrorString(error_code) result(string)
  !! Returns a string representation of the cuFFT error code.
    integer(c_int32_t), intent(in)  :: error_code   !! cuFFT error code
    character(len=:),   allocatable :: string       !! String representation of the cuFFT error code

    select case (error_code)
    case (CUFFT_SUCCESS)
      allocate(string, source="CUFFT_SUCCESS")
    case (CUFFT_INVALID_PLAN)
      allocate(string, source="CUFFT_INVALID_PLAN")
    case (CUFFT_ALLOC_FAILED)
      allocate(string, source="CUFFT_ALLOC_FAILED")
    case (CUFFT_INVALID_TYPE)
      allocate(string, source="CUFFT_INVALID_TYPE")
    case (CUFFT_INVALID_VALUE)
      allocate(string, source="CUFFT_INVALID_VALUE")
    case (CUFFT_INTERNAL_ERROR)
      allocate(string, source="CUFFT_INTERNAL_ERROR")
    case (CUFFT_EXEC_FAILED)
      allocate(string, source="CUFFT_EXEC_FAILED")
    case (CUFFT_SETUP_FAILED)
      allocate(string, source="CUFFT_SETUP_FAILED")
    case (CUFFT_INVALID_SIZE)
      allocate(string, source="CUFFT_INVALID_SIZE")
    case (CUFFT_UNALIGNED_DATA)
      allocate(string, source="CUFFT_UNALIGNED_DATA")
    case (CUFFT_INCOMPLETE_PARAMETER_LIST)
      allocate(string, source="CUFFT_INCOMPLETE_PARAMETER_LIST")
    case (CUFFT_INVALID_DEVICE)
      allocate(string, source="CUFFT_INVALID_DEVICE")
    case (CUFFT_PARSE_ERROR)
      allocate(string, source="CUFFT_PARSE_ERROR")
    case (CUFFT_NO_WORKSPACE)
      allocate(string, source="CUFFT_NO_WORKSPACE")
    case (CUFFT_NOT_IMPLEMENTED)
      allocate(string, source="CUFFT_NOT_IMPLEMENTED")
    case (CUFFT_LICENSE_ERROR)
      allocate(string, source="CUFFT_LICENSE_ERROR")
    case (CUFFT_NOT_SUPPORTED)
      allocate(string, source="CUFFT_NOT_SUPPORTED")
    case default
      allocate(string, source="Unknown CUFFT error code")
  end select
  end function cufftGetErrorString
end module dtfft_interface_cufft

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
#if defined (DTFFT_WITH_CUDA) && !defined(__NVCOMPILER) && !defined(DTFFT_WITH_MOCK_ENABLED)
! #error "nvcompiler is required or mock build"
#endif
program test_r2r_3d_float
use iso_fortran_env
use iso_c_binding, only: c_loc, c_ptr, c_f_pointer, c_int
use dtfft
use dtfft_utils
use test_utils
#if defined(DTFFT_WITH_CUDA)
# if defined(__NVCOMPILER)
use cudafor, only: cuda_stream_kind, cudaStreamCreate, cudaStreamDestroy, cudaStreamSynchronize, cudaSuccess, cudaGetErrorString
# elif defined (DTFFT_WITH_MOCK_ENABLED)
use dtfft_interface_cuda_runtime
# endif
#endif
#include "_dtfft_mpi.h"
#include "_dtfft_cuda.h"
#include "dtfft.f03"
implicit none
  type(c_ptr) :: check
  real(real32),  allocatable, target :: r(:), f(:)
  real(real32), pointer :: check_(:)
#if defined(DTFFT_WITH_CUDA) && defined(__NVCOMPILER)
  real(real32), managed, allocatable :: r_m(:), f_m(:)
#endif
  integer(int32), parameter :: nx = 512, ny = 64, nz = 32
  integer(int32) :: comm_size, comm_rank, ierr, in_counts(3), in_starts(3), comm_dims(3), out_counts(3), iter
  type(dtfft_executor_t) :: executor
  type(dtfft_plan_r2r_t) :: plan
  real(real64) :: tf, tb
  integer(int64)  :: alloc_size, in_size
  type(dtfft_backend_t) :: backend_to_use
  type(dtfft_backend_t) :: reshape_backend_to_use
  type(dtfft_backend_t) :: actual_backend_used
#if defined(DTFFT_WITH_CUDA)
  type(dtfft_platform_t) :: platform
# if defined(__NVCOMPILER)
  integer(cuda_stream_kind) :: stream
# elif defined (DTFFT_WITH_MOCK_ENABLED)
  type(dtfft_stream_t) :: stream
# endif
#endif
  type(dtfft_config_t) :: conf
  type(dtfft_pencil_t) :: pencil
  TYPE_MPI_COMM :: comm
  integer(int32), pointer :: dims(:) => null()
  type(dtfft_request_t) :: request
  ! interface
  !   subroutine cali_flush(val) bind(C)
  !     import
  !     integer(c_int), intent(in), value :: val
  !   end subroutine cali_flush
  ! end interface


  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, comm_size, ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)

  if(comm_rank == 0) then
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a)') "|       dtFFT test: r2r_3d_float       |"
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a, i0, a, i0, a, i0)') 'Nx = ',nx, ', Ny = ',ny, ', Nz = ',nz
    write(output_unit, '(a, i0)') 'Number of processors: ', comm_size
  endif

  executor = DTFFT_EXECUTOR_NONE

  call attach_gpu_to_process()

  call dtfft_create_config(conf)

  backend_to_use = DTFFT_BACKEND_MPI_P2P_FUSED
  reshape_backend_to_use = DTFFT_BACKEND_MPI_P2P_FUSED

#if defined(DTFFT_WITH_CUDA)
  block
    character(len=5) :: platform_env
    integer(int32) :: env_len

    call get_environment_variable("DTFFT_PLATFORM", platform_env, env_len)

    if ( env_len == 0 .or. trim(adjustl(platform_env)) == "cuda" ) then
# if defined (DTFFT_WITH_NCCL)
      backend_to_use = DTFFT_BACKEND_NCCL_PIPELINED
# endif

# if defined(__NVCOMPILER)
      CUDA_CALL( cudaStreamCreate(stream) )
      conf%stream = dtfft_stream_t(stream)
# elif defined (DTFFT_WITH_MOCK_ENABLED)
      CUDA_CALL( cudaStreamCreate(stream) )
      conf%stream = stream
# else
      if ( comm_rank == 0 ) &
        write(output_unit, '(a)') "This test requires NVFortran or MOCK build in order to run on GPU"
      call MPI_Finalize(ierr)
      stop
# endif
    endif
  endblock
#endif

  conf%backend = backend_to_use
  conf%reshape_backend = reshape_backend_to_use
  conf%enable_y_slab = .true.
! #ifdef DTFFT_WITH_COMPRESSION
!   conf%backend = DTFFT_BACKEND_ADAPTIVE
!   conf%reshape_backend = DTFFT_BACKEND_ADAPTIVE
!   conf%compression_config_transpose%compression_mode = DTFFT_COMPRESSION_MODE_FIXED_ACCURACY
!   conf%compression_config_transpose%tolerance = 1.e-6_real64
!   conf%compression_config_reshape%compression_mode = DTFFT_COMPRESSION_MODE_FIXED_PRECISION
!   conf%compression_config_reshape%precision = 20
! #endif


  call dtfft_set_config(conf, error_code=ierr); DTFFT_CHECK(ierr)
  do iter = 2, 4
    comm_dims(:) = 0
    if ( iter < 4 ) comm_dims(iter) = 1
    call createGridDims(3, [nx, ny, nz], comm_dims, in_starts, in_counts)
    pencil = dtfft_pencil_t(in_starts, in_counts)

    comm = MPI_COMM_WORLD
    if ( iter == 4 ) then
      block
        logical :: periods(3)
        integer(int32) :: temp_dims(3)

        temp_dims(:) = comm_dims(:)
        ! Would like that number of processes in X direction be redistributed into Y direction
        temp_dims(2) = temp_dims(2) * temp_dims(1)
        temp_dims(1) = 1
        periods = .false.
        call MPI_Cart_create(MPI_COMM_WORLD, 3, temp_dims, periods, .false., comm, ierr)
      endblock
    endif

  call plan%create(pencil, comm=comm, effort=DTFFT_ESTIMATE, precision=DTFFT_SINGLE, executor=executor, error_code=ierr); DTFFT_CHECK(ierr)
  alloc_size = plan%get_alloc_size(error_code=ierr); DTFFT_CHECK(ierr)
  call plan%get_local_sizes(out_counts=out_counts, error_code=ierr); DTFFT_CHECK(ierr)
  call plan%report(error_code=ierr); DTFFT_CHECK(ierr)

  actual_backend_used = plan%get_backend(error_code=ierr);  DTFFT_CHECK(ierr)
  if(comm_rank == 0) then
    write(output_unit, '(a)') "Using backend: "//dtfft_get_backend_string(actual_backend_used)
  endif
  if ( comm_dims(1) > 1 ) then
    actual_backend_used = plan%get_reshape_backend(error_code=ierr);  DTFFT_CHECK(ierr)
    if(comm_rank == 0) then
      write(output_unit, '(a)') "Using reshape backend: "//dtfft_get_backend_string(actual_backend_used)
    endif
  endif

#if defined(DTFFT_WITH_CUDA) && defined(__NVCOMPILER)
  platform = plan%get_platform()
#endif

  in_size = product(in_counts)
  allocate(r(alloc_size), f(alloc_size))
  check = mem_alloc_host(alloc_size * FLOAT_STORAGE_SIZE)
  call setTestValuesFloat(check, in_size)

  call c_f_pointer(check, check_, [in_size])

#if defined(DTFFT_WITH_CUDA) && defined(__NVCOMPILER)
  allocate(r_m(alloc_size), f_m(alloc_size))
  r_m(:) = check_(:)
#else
  r(:in_size) = check_(:)
#endif

  tf = 0.0_real64 - MPI_Wtime()
#if defined(DTFFT_WITH_CUDA) && defined(__NVCOMPILER)
  if ( comm_dims(1) > 1 ) then
    call plan%reshape(r_m, f_m, DTFFT_RESHAPE_X_BRICKS_TO_PENCILS, error_code=ierr);  DTFFT_CHECK(ierr)
    call plan%transpose(f_m, r_m, DTFFT_TRANSPOSE_X_TO_Y, error_code=ierr);  DTFFT_CHECK(ierr)
    call plan%transpose(r_m, f_m, DTFFT_TRANSPOSE_Y_TO_Z, error_code=ierr);  DTFFT_CHECK(ierr)
    call plan%reshape(f_m, r_m, DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS, error_code=ierr);  DTFFT_CHECK(ierr)
  else
    call plan%transpose(r_m, f_m, DTFFT_TRANSPOSE_X_TO_Y, error_code=ierr);  DTFFT_CHECK(ierr)
    call plan%transpose(f_m, r_m, DTFFT_TRANSPOSE_Y_TO_Z, error_code=ierr);  DTFFT_CHECK(ierr)
  endif
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    CUDA_CALL( cudaStreamSynchronize(stream) )
  endif
#else
  if ( comm_dims(1) > 1 ) then
    call plan%reshape(r, f, DTFFT_RESHAPE_X_BRICKS_TO_PENCILS, error_code=ierr);  DTFFT_CHECK(ierr)
    call plan%transpose(f, r, DTFFT_TRANSPOSE_X_TO_Y, error_code=ierr);  DTFFT_CHECK(ierr)
    call plan%transpose(r, f, DTFFT_TRANSPOSE_Y_TO_Z, error_code=ierr);  DTFFT_CHECK(ierr)
    call plan%reshape(f, r, DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS, error_code=ierr);  DTFFT_CHECK(ierr)
  else
    call plan%transpose(r, f, DTFFT_TRANSPOSE_X_TO_Y, error_code=ierr);  DTFFT_CHECK(ierr)
    call plan%transpose(f, r, DTFFT_TRANSPOSE_Y_TO_Z, error_code=ierr);  DTFFT_CHECK(ierr)
  endif
#endif
  DTFFT_CHECK(ierr)
  tf = tf + MPI_Wtime()

  tb = 0.0_real64 - MPI_Wtime()
#if defined(DTFFT_WITH_CUDA) && defined(__NVCOMPILER)
  if ( comm_dims(1) > 1 ) then
    call plan%reshape(r_m, f_m, DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS, error_code=ierr); DTFFT_CHECK(ierr)
    call plan%transpose(f_m, r_m, DTFFT_TRANSPOSE_Z_TO_Y, error_code=ierr); DTFFT_CHECK(ierr)
    call plan%transpose(r_m, f_m, DTFFT_TRANSPOSE_Y_TO_X, error_code=ierr); DTFFT_CHECK(ierr)
    call plan%reshape(f_m, r_m, DTFFT_RESHAPE_X_PENCILS_TO_BRICKS, error_code=ierr); DTFFT_CHECK(ierr)
  else
    call plan%transpose(r_m, f_m, DTFFT_TRANSPOSE_Z_TO_Y, error_code=ierr); DTFFT_CHECK(ierr)
    call plan%transpose(f_m, r_m, DTFFT_TRANSPOSE_Y_TO_X, error_code=ierr); DTFFT_CHECK(ierr)
  endif
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    CUDA_CALL( cudaStreamSynchronize(stream) )
  endif
  r(:) = r_m(:)
#else
  if ( comm_dims(1) > 1 ) then
    request = plan%reshape_start(r, f, DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS, error_code=ierr); DTFFT_CHECK(ierr)
    call plan%reshape_end(request, error_code=ierr); DTFFT_CHECK(ierr)
    request = plan%transpose_start(f, r, DTFFT_TRANSPOSE_Z_TO_Y, error_code=ierr); DTFFT_CHECK(ierr)
    call plan%transpose_end(request, error_code=ierr); DTFFT_CHECK(ierr)
    request = plan%transpose_start(r, f, DTFFT_TRANSPOSE_Y_TO_X, error_code=ierr); DTFFT_CHECK(ierr)
    call plan%transpose_end(request, error_code=ierr); DTFFT_CHECK(ierr)
    request = plan%reshape_start(f, r, DTFFT_RESHAPE_X_PENCILS_TO_BRICKS, error_code=ierr); DTFFT_CHECK(ierr)
    call plan%reshape_end(request, error_code=ierr); DTFFT_CHECK(ierr)
  else
    call plan%transpose(r, f, DTFFT_TRANSPOSE_Z_TO_Y, error_code=ierr); DTFFT_CHECK(ierr)
    call plan%transpose(f, r, DTFFT_TRANSPOSE_Y_TO_X, error_code=ierr); DTFFT_CHECK(ierr)
  endif
#endif

  DTFFT_CHECK(ierr)
  tb = tb + MPI_Wtime()

  call plan%get_dims(dims, error_code=ierr); DTFFT_CHECK(ierr)

#ifdef DTFFT_WITH_COMPRESSION
  call plan%report_compression()
#endif

#if defined(DTFFT_WITH_CUDA) && defined(__NVCOMPILER)
  call checkAndReportFloat(int(product(dims), int64), tf, tb, c_loc(r_m), in_size, check, DTFFT_PLATFORM_HOST%val)
#elif defined(DTFFT_WITH_CUDA) && !defined(DTFFT_WITH_MOCK_ENABLED)
  call checkAndReportFloat(int(product(dims), int64), tf, tb, c_loc(r), in_size, check, DTFFT_PLATFORM_HOST%val)
#else
  call checkAndReportFloat(int(product(dims), int64), tf, tb, c_loc(r), in_size, check)
#endif

  deallocate(r, f)
  call mem_free_host(check)
  nullify(check_)

#if defined(DTFFT_WITH_CUDA) && defined(__NVCOMPILER)
  deallocate(r_m, f_m)
#endif

  call plan%destroy()

  if ( iter == 4 ) then
    call MPI_Comm_free(comm, ierr)
  endif

  enddo

#if defined(DTFFT_WITH_CUDA) && defined(__NVCOMPILER)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    CUDA_CALL( cudaStreamDestroy(stream) )
  endif
#endif

  call MPI_Finalize(ierr)
end program test_r2r_3d_float

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_abstract_backend
!! This module describes Abstraction for all Backends: [[abstract_backend]]
use iso_c_binding
use iso_fortran_env
use dtfft_abstract_kernel, only: abstract_kernel
use dtfft_errors
#ifdef DTFFT_WITH_CUDA
use dtfft_interface_cuda_runtime
#endif
#ifdef DTFFT_WITH_NCCL
use dtfft_interface_nccl
#endif
use dtfft_parameters
use dtfft_pencil, only: pencil
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_cuda.h"
#include "_dtfft_private.h"
#include "_dtfft_profile.h"
implicit none
private
public :: abstract_backend, backend_helper

#ifdef NCCL_HAVE_COMMREGISTER
    integer(int32), parameter, public :: NCCL_REGISTER_PREALLOC_SIZE = 8
    !! Number of register elements to preallocate
#endif

    type :: backend_helper
    !! Helper with nccl, mpi and nvshmem communicators
        logical                     :: is_nccl_created = .false.   !! Flag is `nccl_comm` has been created
#ifdef DTFFT_WITH_NCCL
        type(ncclComm)              :: nccl_comm                   !! NCCL communicator
#endif
#ifdef NCCL_HAVE_COMMREGISTER
        logical                     :: should_register             !! If NCCL buffer should be registered
        type(c_ptr),    allocatable :: nccl_register(:, :)         !! NCCL register cache
        integer(int32)              :: nccl_register_size          !! Number of elements in `nccl_register`
#endif
        TYPE_MPI_COMM,  allocatable :: comms(:)                    !! MPI communicators
        integer(int32), allocatable :: comm_mappings(:, :)         !! Mapping of 1d comm ranks to global comm
        type(dtfft_transpose_t)     :: transpose_type              !! Type of transpose to create
        type(dtfft_reshape_t)       :: reshape_type                !! Type of reshape to create
        type(pencil),   pointer     :: pencils(:)                  !! Pencils
    contains
        procedure, pass(self) :: create => create_helper           !! Creates helper
        procedure, pass(self) :: destroy => destroy_helper         !! Destroys helper
    end type backend_helper

    type, abstract :: abstract_backend
    !! The most Abstract Backend
        type(dtfft_backend_t)           :: backend                  !! Backend type
        type(dtfft_platform_t)          :: platform                 !! Platform to use
        logical                         :: is_selfcopy              !! If backend is self-copying
        logical                         :: is_pipelined             !! If backend is pipelined
        logical                         :: is_fused                 !! If backend is fused
        logical                         :: is_even                  !! If all processes send/recv same amount of memory
        integer(int64)                  :: aux_bytes                !! Number of bytes required by aux buffer
        integer(int64)                  :: buffer_size              !! 
        TYPE_MPI_COMM                   :: comm                     !! MPI Communicator
        integer(int32),     allocatable :: comm_mapping(:)          !! Mapping of 1d comm ranks to global comm
        integer(int32)                  :: comm_size                !! Size of MPI Comm
        integer(int32)                  :: comm_rank                !! Rank in MPI Comm
        integer(int64),     allocatable :: send_displs(:)           !! Send data displacements, in float elements
        integer(int64),     allocatable :: send_floats(:)           !! Send data elements, in float elements
        integer(int64),     allocatable :: recv_displs(:)           !! Recv data displacements, in float elements
        integer(int64),     allocatable :: recv_floats(:)           !! Recv data elements, in float elements
        ! Self copy params
#ifdef DTFFT_WITH_CUDA
        type(cudaEvent)                 :: execution_event          !! Event for main execution stream
        type(cudaEvent)                 :: copy_event               !! Event for copy stream
#endif
        type(dtfft_stream_t)            :: copy_stream              !! Stream for copy operations
        integer(int64)                  :: self_copy_bytes          !! Number of bytes to copy it itself
        integer(int64)                  :: self_send_displ          !! Displacement for send buffer
        integer(int64)                  :: self_recv_displ          !! Displacement for recv buffer
        class(abstract_kernel), pointer :: pack_kernel              !! Kernel for packing data
        class(abstract_kernel), pointer :: unpack_kernel            !! Kernel for unpacking data
    contains
        procedure,  non_overridable,                pass(self) :: create           !! Creates Abstract Backend
        procedure,  non_overridable,                pass(self) :: execute          !! Executes Backend
        procedure,  non_overridable,                pass(self) :: destroy          !! Destroys Abstract Backend
        procedure,  non_overridable,                pass(self) :: get_aux_bytes    !! Returns number of bytes required by aux buffer
        procedure,  non_overridable,                pass(self) :: set_pack_kernel  !! Sets pack kernel for fused backend
        procedure,  non_overridable,                pass(self) :: set_unpack_kernel!! Sets unpack kernel for pipelined backend
        procedure,  non_overridable,                pass(self) :: wait
        procedure,                                  pass(self) :: execute_end      !! Ends execution of Backend
        procedure,                                  pass(self) :: execute_self_copy
        procedure,                                  pass(self) :: get_async_active !! Returns if async execution is active
        procedure(create_interface),    deferred,   pass(self) :: create_private   !! Creates overriding class
        procedure(execute_interface),   deferred,   pass(self) :: execute_private  !! Executes Backend
        procedure(destroy_interface),   deferred,   pass(self) :: destroy_private  !! Destroys overriding class
    end type abstract_backend

    abstract interface
        subroutine create_interface(self, helper, base_storage)
        !! Creates overriding class
            import
            class(abstract_backend),    intent(inout)   :: self           !! Abstract Backend
            type(backend_helper),       intent(in)      :: helper         !! Backend helper
            integer(int64),             intent(in)      :: base_storage   !! Number of bytes to store single element
        end subroutine create_interface

        subroutine execute_interface(self, in, out, stream, aux, error_code)
        !! Executes Backend
            import
            class(abstract_backend),            intent(inout)   :: self       !! Abstract Backend
            real(real32),   target, contiguous, intent(inout)   :: in(:)      !! Send pointer
            real(real32),   target, contiguous, intent(inout)   :: out(:)     !! Recv pointer
            type(dtfft_stream_t),               intent(in)      :: stream     !! Main execution CUDA stream
            real(real32),   target, contiguous, intent(inout)   :: aux(:)     !! Aux pointer
            integer(int32),                     intent(out)     :: error_code !! Error code
        end subroutine execute_interface

        subroutine destroy_interface(self)
        !! Destroys overriding class
            import
            class(abstract_backend), intent(inout) :: self       !! Abstract Backend
        end subroutine destroy_interface
    end interface

contains

    subroutine create(self, backend, helper, platform, comm_id, send_displs, send_counts, recv_displs, recv_counts, base_storage)
    !! Creates Abstract Backend
        class(abstract_backend),    intent(inout)   :: self           !! Abstract Backend
        type(dtfft_backend_t),      intent(in)      :: backend        !! Backend type
        type(backend_helper),       intent(in)      :: helper         !! Backend helper
        type(dtfft_platform_t),     intent(in)      :: platform       !! Platform to use
        integer(int8),              intent(in)      :: comm_id        !! Id of communicator to use
        integer(int32),             intent(in)      :: send_displs(:) !! Send data displacements, in original elements
        integer(int32),             intent(in)      :: send_counts(:) !! Send data elements, in float elements
        integer(int32),             intent(in)      :: recv_displs(:) !! Recv data displacements, in float elements
        integer(int32),             intent(in)      :: recv_counts(:) !! Recv data elements, in float elements
        integer(int64),             intent(in)      :: base_storage   !! Number of bytes to store single element
        integer(int64) :: send_size      !! Total number of floats to send
        integer(int64) :: recv_size      !! Total number of floats to recv
        integer(int32) :: ierr           !! MPI Error code
        integer(int64) :: scaler         !! Scaling data amount to float size

        scaler = base_storage / FLOAT_STORAGE_SIZE

        self%platform = platform

        self%comm = helper%comms(comm_id)

        call MPI_Comm_size(self%comm, self%comm_size, ierr)
        call MPI_Comm_rank(self%comm, self%comm_rank, ierr)

        if (allocated(helper%comm_mappings)) then
            allocate (self%comm_mapping(0:self%comm_size - 1), source=helper%comm_mappings(0:self%comm_size - 1, comm_id))
        end if

        allocate (self%send_displs(0:self%comm_size - 1))
        allocate (self%send_floats(0:self%comm_size - 1))
        self%send_displs(:) = int(send_displs(:), int64) * scaler
        self%send_displs(:) = self%send_displs(:) + 1
        self%send_floats(:) = int(send_counts(:), int64) * scaler

        allocate (self%recv_displs(0:self%comm_size - 1))
        allocate (self%recv_floats(0:self%comm_size - 1))
        self%recv_displs(:) = int(recv_displs(:), int64) * scaler
        self%recv_displs(:) = self%recv_displs(:) + 1
        self%recv_floats(:) = int(recv_counts(:), int64) * scaler

        self%buffer_size = max(sum(self%send_floats), sum(self%recv_floats))

        self%backend = backend
        self%is_fused = is_backend_fused(backend) .or. is_backend_compressed(backend)
        self%is_pipelined = is_backend_pipelined(backend) .or. self%is_fused
        self%is_selfcopy = (self%is_pipelined .or. is_backend_mpi(backend)) .and. backend /= DTFFT_BACKEND_CUFFTMP_PIPELINED .and. backend /= DTFFT_BACKEND_NCCL_COMPRESSED .and. .not.self%is_fused
        self%is_even = all(send_counts(1) == send_counts(:)) .and. all(recv_counts(1) == recv_counts(:))
        if (self%is_selfcopy .and. self%is_even .and. backend == DTFFT_BACKEND_MPI_A2A .and. platform == DTFFT_PLATFORM_HOST) then
            self%is_selfcopy = .false.
        endif

        self%aux_bytes = 0_int64
        if (self%is_pipelined) then
            send_size = sum(send_counts) * scaler
            recv_size = sum(recv_counts) * scaler
            self%aux_bytes = max(send_size, recv_size) * FLOAT_STORAGE_SIZE
        end if
        if ( self%is_fused .and. backend /= DTFFT_BACKEND_NCCL_COMPRESSED) self%aux_bytes = self%aux_bytes * 2

        self%self_copy_bytes = 0_int64
        if (self%is_selfcopy .or. backend == DTFFT_BACKEND_NCCL_COMPRESSED .or. self%is_fused) then
            self%self_send_displ = self%send_displs(self%comm_rank)
            self%self_recv_displ = self%recv_displs(self%comm_rank)
            self%self_copy_bytes = self%send_floats(self%comm_rank) * FLOAT_STORAGE_SIZE
            self%send_floats(self%comm_rank) = 0
            self%recv_floats(self%comm_rank) = 0
#ifdef DTFFT_WITH_CUDA
            if (platform == DTFFT_PLATFORM_CUDA) then
                CUDA_CALL( cudaEventCreateWithFlags(self%execution_event, cudaEventDisableTiming) )
                CUDA_CALL( cudaEventCreateWithFlags(self%copy_event, cudaEventDisableTiming) )
                CUDA_CALL( cudaStreamCreate(self%copy_stream) )
            end if
#endif
        end if

        call self%create_private(helper, base_storage)
    end subroutine create

    subroutine execute(self, in, out, stream, aux, exec_type, error_code)
    !! Executes Backend
        class(abstract_backend),    intent(inout)   :: self         !! Self-copying backend
        type(c_ptr),                intent(in)      :: in           !! Send pointer
        type(c_ptr),                intent(in)      :: out          !! Recv pointer
        type(dtfft_stream_t),       intent(in)      :: stream       !! CUDA stream
        type(c_ptr),                intent(in)      :: aux          !! Aux pointer
        type(async_exec_t),         intent(in)      :: exec_type    !! Type of async execution
        integer(int32),             intent(out)     :: error_code   !! Error code
        integer(int32) :: dummy
        real(real32), pointer, contiguous :: pin(:), pout(:), paux(:)
        integer(int64) :: aux_size

#if defined(DTFFT_DEBUG)
        if ( self%is_fused .and. ( .not.associated(self%pack_kernel) .or. .not.associated(self%unpack_kernel)) ) then
            INTERNAL_ERROR("abstract_backend: .not.associated kernel")
        endif
        if ( self%is_pipelined .and. is_null_ptr(aux) ) then
            INTERNAL_ERROR("abstract_backend: self%is_pipelined .and. is_null_ptr(aux)")
        endif
#endif

        call c_f_pointer(in, pin, [self%buffer_size])
        call c_f_pointer(out, pout, [self%buffer_size])
        if ( is_null_ptr(aux) ) then
            paux => pin
        else
            aux_size = self%buffer_size;    if( self%is_fused ) aux_size = aux_size * 2
            call c_f_pointer(aux, paux, [aux_size])
        endif

        if (.not. self%is_selfcopy) then
            call self%execute_private(pin, pout, stream, paux, error_code)
            if ( error_code /= DTFFT_SUCCESS ) return

            if ( exec_type == EXEC_BLOCKING .or. self%platform == DTFFT_PLATFORM_CUDA) then
                call self%execute_end(error_code)
            endif
#if defined(DTFFT_DEBUG) && defined(DTFFT_WITH_CUDA)
            if (self%platform == DTFFT_PLATFORM_CUDA) then
                CUDA_CALL( cudaStreamSynchronize(stream) )
            end if
#endif
            return
        end if

#ifdef DTFFT_WITH_CUDA
        if ( self%self_copy_bytes > 0 .and. self%platform == DTFFT_PLATFORM_CUDA ) then
            if ( self%is_pipelined ) then
                call self%execute_self_copy(pin, paux, stream)
                call self%unpack_kernel%execute(aux, out, self%copy_stream, self%comm_rank + 1)
            else
                call self%execute_self_copy(pin, pout, stream)
            endif
        endif
#endif

        call self%execute_private(pin, pout, stream, paux, error_code)
        if ( error_code /= DTFFT_SUCCESS ) return

        if ( exec_type == EXEC_BLOCKING .or. self%platform == DTFFT_PLATFORM_CUDA) then
            ! Do not want to return error in case execution is not active, like in mpi scheduled
            call self%execute_end(dummy)
        endif
        call self%wait(stream)
#if defined(DTFFT_DEBUG) && defined(DTFFT_WITH_CUDA)
        if ( self%platform == DTFFT_PLATFORM_CUDA ) then
            CUDA_CALL( cudaStreamSynchronize(stream) )
        end if
#endif
    end subroutine execute

    subroutine execute_end(self, error_code)
    !! Ends execution of Backend
        class(abstract_backend),    intent(inout)   :: self       !! Abstract backend
        integer(int32),             intent(out)     :: error_code !! Error code
        error_code = DTFFT_SUCCESS
        if (self%platform == DTFFT_PLATFORM_HOST) return
    end subroutine execute_end

    subroutine execute_self_copy(self, in, out, stream)
    !! Executes self copy
        class(abstract_backend),    intent(inout)   :: self             !! Abstract backend
        real(real32),               intent(in)      :: in(BUFFER_SPEC)  !! Send pointer
        real(real32),               intent(inout)   :: out(BUFFER_SPEC) !! Recv pointer
        type(dtfft_stream_t),       intent(in)      :: stream           !! CUDA stream
        integer(int32) :: float_count, i

        if (self%self_copy_bytes == 0) return

        REGION_BEGIN("self_copy", COLOR_TOMATO)
        if (self%platform == DTFFT_PLATFORM_HOST) then
            float_count = int(self%self_copy_bytes / FLOAT_STORAGE_SIZE, int32)
        !$omp parallel do simd
            do i = 0, float_count - 1
                out(self%self_recv_displ + i) = in(self%self_send_displ + i)
            enddo
        !$omp end parallel do simd
#ifdef DTFFT_WITH_CUDA
        else
            CUDA_CALL( cudaEventRecord(self%execution_event, stream) )
            ! Waiting for transpose kernel to finish execution on stream `stream`
            CUDA_CALL( cudaStreamWaitEvent(self%copy_stream, self%execution_event, 0) )

            CUDA_CALL( cudaMemcpyAsync(out( self%self_recv_displ ), in( self%self_send_displ ), self%self_copy_bytes, cudaMemcpyDeviceToDevice, self%copy_stream) )
#endif
        endif
        REGION_END("self_copy")
    end subroutine execute_self_copy

    subroutine wait(self, stream)
        class(abstract_backend),    intent(inout)   :: self       !! Abstract backend
        type(dtfft_stream_t),       intent(in)      :: stream     !! CUDA stream

        if ( self%platform == DTFFT_PLATFORM_HOST ) return
#ifdef DTFFT_WITH_CUDA
        ! Making future events, like FFT, on `stream` to wait for `copy_event`
        CUDA_CALL( cudaEventRecord(self%copy_event, self%copy_stream) )
        CUDA_CALL( cudaStreamWaitEvent(stream, self%copy_event, 0) )
#endif
    end subroutine wait

    elemental logical function get_async_active(self)
    !! Returns if async execution is active
        class(abstract_backend),    intent(in)      :: self       !! Abstract backend
        get_async_active = .false.
    end function get_async_active

    subroutine destroy(self)
    !! Destroys Abstract Backend
        class(abstract_backend),    intent(inout)   :: self       !! Abstract backend

        if (allocated(self%send_displs))    deallocate (self%send_displs)
        if (allocated(self%send_floats))    deallocate (self%send_floats)
        if (allocated(self%recv_displs))    deallocate (self%recv_displs)
        if (allocated(self%recv_floats))    deallocate (self%recv_floats)
        if (allocated(self%comm_mapping))   deallocate (self%comm_mapping)
        self%comm = MPI_COMM_NULL
#ifdef DTFFT_WITH_CUDA
        if ((self%is_selfcopy .or. self%backend == DTFFT_BACKEND_NCCL_COMPRESSED) .and. self%platform == DTFFT_PLATFORM_CUDA) then
            CUDA_CALL( cudaEventDestroy(self%execution_event) )
            CUDA_CALL( cudaEventDestroy(self%copy_event) )
            CUDA_CALL( cudaStreamDestroy(self%copy_stream) )
        end if
#endif
        nullify (self%unpack_kernel)
        self%is_pipelined = .false.
        self%is_fused = .false.
        self%is_selfcopy = .false.
        call self%destroy_private()
    end subroutine destroy

    pure integer(int64) function get_aux_bytes(self)
    !! Returns number of bytes required by aux buffer
        class(abstract_backend),    intent(in)      :: self     !! Abstract backend
        get_aux_bytes = self%aux_bytes
    end function get_aux_bytes

    subroutine set_unpack_kernel(self, unpack_kernel)
    !! Sets unpack kernel for pipelined backend
        class(abstract_backend),        intent(inout)   :: self           !! Pipelined backend
        class(abstract_kernel), target, intent(in)      :: unpack_kernel  !! Kernel for unpacking data
        self%unpack_kernel => unpack_kernel
    end subroutine set_unpack_kernel

    subroutine set_pack_kernel(self, pack_kernel)
    !! Sets unpack kernel for pipelined backend
        class(abstract_backend),        intent(inout)   :: self           !! Pipelined backend
        class(abstract_kernel), target, intent(in)      :: pack_kernel    !! Kernel for packing data
        self%pack_kernel => pack_kernel
    end subroutine set_pack_kernel

    subroutine create_helper(self, platform, base_comm, comms, is_nccl_needed, pencils)
    !! Creates helper
        class(backend_helper),  intent(inout)   :: self                 !! Backend helper
        type(dtfft_platform_t), intent(in)      :: platform             !! Platform to use
        TYPE_MPI_COMM,          intent(in)      :: base_comm            !! MPI communicator
        TYPE_MPI_COMM,          intent(in)      :: comms(:)             !! 1D Communicators
        logical,                intent(in)      :: is_nccl_needed       !! If nccl communicator will be needed
        type(pencil), target,   intent(in)      :: pencils(:)           !! Pencils
        integer(int32) :: i, n_comms

        call self%destroy()

        self%pencils => pencils(:)

        n_comms = size(comms)
        allocate (self%comms(n_comms))

        self%comms(1) = base_comm
        do i = 2, n_comms
            self%comms(i) = comms(i)
        end do
        self%is_nccl_created = .false.
        if (.not. is_nccl_needed) return
        if (platform == DTFFT_PLATFORM_HOST) return

#ifdef DTFFT_WITH_NCCL
        block
            type(ncclUniqueId) :: id           ! NCCL unique id
            integer(int32) :: max_size, comm_size, comm_rank, ierr

            max_size = -1
            do i = 1, n_comms
                call MPI_Comm_size(self%comms(i), comm_size, ierr)
                max_size = max(max_size, comm_size)
            end do
            call MPI_Comm_rank(base_comm, comm_rank, ierr)

            allocate (self%comm_mappings(0:max_size - 1, n_comms), source=-1)
            do i = 1, n_comms
                call MPI_Allgather(comm_rank, 1, MPI_INTEGER, self%comm_mappings(:, i), 1, MPI_INTEGER, self%comms(i), ierr)
            end do

            if (comm_rank == 0) then
                NCCL_CALL( ncclGetUniqueId(id) )
            end if
            call MPI_Bcast(id, int(c_sizeof(id)), MPI_BYTE, 0, base_comm, ierr)
            NCCL_CALL( ncclCommInitRank(self%nccl_comm, max_size, id, comm_rank) )
            self%is_nccl_created = .true.
        end block

# ifdef NCCL_HAVE_COMMREGISTER
        self%should_register = get_env("NCCL_BUFFER_REGISTER", .true.)
        self%nccl_register_size = 0
        if (self%should_register) then
            allocate (self%nccl_register(2, NCCL_REGISTER_PREALLOC_SIZE))
            do i = 1, NCCL_REGISTER_PREALLOC_SIZE
                self%nccl_register(1, i) = c_null_ptr
                self%nccl_register(2, i) = c_null_ptr
            end do
        end if
# endif
#endif
    end subroutine create_helper

    subroutine destroy_helper(self)
    !! Destroys helper
        class(backend_helper),  intent(inout)   :: self         !! Backend helper

        if (allocated(self%comms)) deallocate (self%comms)
        if (allocated(self%comm_mappings)) deallocate (self%comm_mappings)
        nullify (self%pencils)
#ifdef DTFFT_WITH_NCCL
        if (self%is_nccl_created) then
            NCCL_CALL( ncclCommDestroy(self%nccl_comm) )
        end if
        self%is_nccl_created = .false.
#endif
#ifdef NCCL_HAVE_COMMREGISTER
# ifdef DTFFT_DEBUG
        if (self%nccl_register_size > 0) then
            WRITE_ERROR("NCCL register is not empty")
        end if
# endif
        if (allocated(self%nccl_register)) deallocate (self%nccl_register)
        self%nccl_register_size = 0
#endif
    end subroutine destroy_helper

end module dtfft_abstract_backend

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_interface_cuda_runtime
!! CUDA Runtime Interfaces
use iso_c_binding
use iso_fortran_env
use dtfft_parameters
use dtfft_utils
#ifdef DTFFT_WITH_MOCK_ENABLED
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
#endif
implicit none
private
public :: cudaGetErrorString
public :: cudaStreamQuery, cudaStreamCreate, cudaStreamDestroy, cudaStreamSynchronize
public :: cudaMalloc, cudaFree, cudaMemset
public :: cudaEventCreateWithFlags, cudaEventRecord, cudaStreamWaitEvent
public :: cudaEventDestroy, cudaEventCreate, cudaEventSynchronize, cudaEventElapsedTime
public :: cudaMemcpyAsync, cudaMemcpy
public :: cudaGetDevice, cudaGetDeviceCount, cudaSetDevice
public :: cudaMemGetInfo, cudaDeviceSynchronize, cudaGetLastError
public :: get_device_props

public :: cudaSuccess, cudaErrorNotReady
    enum, bind(c)
        enumerator :: cudaSuccess = 0
        enumerator :: cudaErrorInvalidValue = 1
        enumerator :: cudaErrorMemoryAllocation = 2
        enumerator :: cudaErrorInitializationError = 3
        enumerator :: cudaErrorCudartUnloading = 4
        enumerator :: cudaErrorProfilerDisabled = 5
        enumerator :: cudaErrorProfilerNotInitialized = 6
        enumerator :: cudaErrorProfilerAlreadyStarted = 7
        enumerator :: cudaErrorProfilerAlreadyStopped = 8
        enumerator :: cudaErrorInvalidConfiguration = 9
        enumerator :: cudaErrorInvalidPitchValue = 12
        enumerator :: cudaErrorInvalidSymbol = 13
        enumerator :: cudaErrorInvalidHostPointer = 16
        enumerator :: cudaErrorInvalidDevicePointer = 17
        enumerator :: cudaErrorInvalidTexture = 18
        enumerator :: cudaErrorInvalidTextureBinding = 19
        enumerator :: cudaErrorInvalidChannelDescriptor = 20
        enumerator :: cudaErrorInvalidMemcpyDirection = 21
        enumerator :: cudaErrorAddressOfConstant = 22
        enumerator :: cudaErrorTextureFetchFailed = 23
        enumerator :: cudaErrorTextureNotBound = 24
        enumerator :: cudaErrorSynchronizationError = 25
        enumerator :: cudaErrorInvalidFilterSetting = 26
        enumerator :: cudaErrorInvalidNormSetting = 27
        enumerator :: cudaErrorMixedDeviceExecution = 28
        enumerator :: cudaErrorNotYetImplemented = 31
        enumerator :: cudaErrorMemoryValueTooLarge = 32
        enumerator :: cudaErrorInsufficientDriver = 35
        enumerator :: cudaErrorInvalidSurface = 37
        enumerator :: cudaErrorDuplicateVariableName = 43
        enumerator :: cudaErrorDuplicateTextureName = 44
        enumerator :: cudaErrorDuplicateSurfaceName = 45
        enumerator :: cudaErrorDevicesUnavailable = 46
        enumerator :: cudaErrorIncompatibleDriverContext = 49
        enumerator :: cudaErrorMissingConfiguration = 52
        enumerator :: cudaErrorPriorLaunchFailure = 53
        enumerator :: cudaErrorLaunchMaxDepthExceeded = 65
        enumerator :: cudaErrorLaunchFileScopedTex = 66
        enumerator :: cudaErrorLaunchFileScopedSurf = 67
        enumerator :: cudaErrorSyncDepthExceeded = 68
        enumerator :: cudaErrorLaunchPendingCountExceeded = 69
        enumerator :: cudaErrorInvalidDeviceFunction = 98
        enumerator :: cudaErrorNoDevice = 100
        enumerator :: cudaErrorInvalidDevice = 101
        enumerator :: cudaErrorStartupFailure = 127
        enumerator :: cudaErrorInvalidKernelImage = 200
        enumerator :: cudaErrorDeviceUninitialized = 201
        enumerator :: cudaErrorMapBufferObjectFailed = 205
        enumerator :: cudaErrorUnmapBufferObjectFailed = 206
        enumerator :: cudaErrorArrayIsMapped = 207
        enumerator :: cudaErrorAlreadyMapped = 208
        enumerator :: cudaErrorNoKernelImageForDevice = 209
        enumerator :: cudaErrorAlreadyAcquired = 210
        enumerator :: cudaErrorNotMapped = 211
        enumerator :: cudaErrorNotMappedAsArray = 212
        enumerator :: cudaErrorNotMappedAsPointer = 213
        enumerator :: cudaErrorECCUncorrectable = 214
        enumerator :: cudaErrorUnsupportedLimit = 215
        enumerator :: cudaErrorDeviceAlreadyInUse = 216
        enumerator :: cudaErrorPeerAccessUnsupported = 217
        enumerator :: cudaErrorInvalidPtx = 218
        enumerator :: cudaErrorInvalidGraphicsContext = 219
        enumerator :: cudaErrorNvlinkUncorrectable = 220
        enumerator :: cudaErrorJitCompilerNotFound = 221
        enumerator :: cudaErrorInvalidSource = 300
        enumerator :: cudaErrorFileNotFound = 301
        enumerator :: cudaErrorSharedObjectSymbolNotFound = 302
        enumerator :: cudaErrorSharedObjectInitFailed = 303
        enumerator :: cudaErrorOperatingSystem = 304
        enumerator :: cudaErrorInvalidResourceHandle = 400
        enumerator :: cudaErrorIllegalState = 401
        enumerator :: cudaErrorSymbolNotFound = 500
        enumerator :: cudaErrorNotReady = 600
        enumerator :: cudaErrorIllegalAddress = 700
        enumerator :: cudaErrorLaunchOutOfResources = 701
        enumerator :: cudaErrorLaunchTimeout = 702
        enumerator :: cudaErrorLaunchIncompatibleTexturing = 703
        enumerator :: cudaErrorPeerAccessAlreadyEnabled = 704
        enumerator :: cudaErrorPeerAccessNotEnabled = 705
        enumerator :: cudaErrorSetOnActiveProcess = 708
        enumerator :: cudaErrorContextIsDestroyed = 709
        enumerator :: cudaErrorAssert = 710
        enumerator :: cudaErrorTooManyPeers = 711
        enumerator :: cudaErrorHostMemoryAlreadyRegistered = 712
        enumerator :: cudaErrorHostMemoryNotRegistered = 713
        enumerator :: cudaErrorHardwareStackError = 714
        enumerator :: cudaErrorIllegalInstruction = 715
        enumerator :: cudaErrorMisalignedAddress = 716
        enumerator :: cudaErrorInvalidAddressSpace = 717
        enumerator :: cudaErrorInvalidPc = 718
        enumerator :: cudaErrorLaunchFailure = 719
        enumerator :: cudaErrorCooperativeLaunchTooLarge = 720
        enumerator :: cudaErrorNotPermitted = 800
        enumerator :: cudaErrorNotSupported = 801
        enumerator :: cudaErrorSystemNotReady = 802
        enumerator :: cudaErrorSystemDriverMismatch = 803
        enumerator :: cudaErrorCompatNotSupportedOnDevice = 804
        enumerator :: cudaErrorStreamCaptureUnsupported = 900
        enumerator :: cudaErrorStreamCaptureInvalidated = 901
        enumerator :: cudaErrorStreamCaptureMerge = 902
        enumerator :: cudaErrorStreamCaptureUnmatched = 903
        enumerator :: cudaErrorStreamCaptureUnjoined = 904
        enumerator :: cudaErrorStreamCaptureIsolation = 905
        enumerator :: cudaErrorStreamCaptureImplicit = 906
        enumerator :: cudaErrorCapturedEvent = 907
        enumerator :: cudaErrorStreamCaptureWrongThread = 908
        enumerator :: cudaErrorTimeout = 909
        enumerator :: cudaErrorGraphExecUpdateFailure = 910
        enumerator :: cudaErrorUnknown = 999
        enumerator :: cudaErrorApiFailureBase = 10000
    end enum

public :: cudaMemcpyHostToHost,     &
          cudaMemcpyHostToDevice,   &
          cudaMemcpyDeviceToHost,   &
          cudaMemcpyDeviceToDevice, &
          cudaMemcpyDefault
    enum, bind(C)
        enumerator :: cudaMemcpyHostToHost = 0
        enumerator :: cudaMemcpyHostToDevice = 1
        enumerator :: cudaMemcpyDeviceToHost = 2
        enumerator :: cudaMemcpyDeviceToDevice = 3
        enumerator :: cudaMemcpyDefault = 4
    end enum



public :: cudaEvent
#ifdef DTFFT_WITH_MOCK_ENABLED
    type :: cudaEvent
        real(real64) :: t
    end type cudaEvent
#else
    type, bind(C) :: cudaEvent
    !! CUDA event types
        type(c_ptr) :: event  !! Handle
    end type cudaEvent
#endif

    integer(c_int), parameter, public :: cudaEventDisableTiming = 2

public :: device_props
    type, bind(C) :: device_props
    !! GPU device properties obtained from cudaDeviceProp
        integer(c_int)    :: sm_count                   !! Number of multiprocessors on device (cudaDeviceProp.multiProcessorCount)
        integer(c_int)    :: max_threads_per_sm         !! Maximum resident threads per multiprocessor (cudaDeviceProp.maxThreadsPerMultiProcessor)
        integer(c_int)    :: max_blocks_per_sm          !! Maximum number of resident blocks per multiprocessor (cudaDeviceProp.maxBlocksPerMultiProcessor)
        integer(c_size_t) :: shared_mem_per_sm          !! Shared memory per multiprocessor (cudaDeviceProp.sharedMemPerMultiprocessor)
        integer(c_int)    :: max_threads_per_block      !! Maximum number of threads per block (cudaDeviceProp.maxThreadsPerBlock)
        integer(c_size_t) :: shared_mem_per_block       !! Shared memory available per block in bytes (cudaDeviceProp.sharedMemPerBlock)
        integer(c_int)    :: l2_cache_size              !! Size of L2 cache in bytes (cudaDeviceProp.l2CacheSize)
        integer(c_int)    :: compute_capability_major   !! Major compute capability (cudaDeviceProp.major)
        integer(c_int)    :: compute_capability_minor   !! Minor compute capability (cudaDeviceProp.minor)
    end type device_props

#ifndef DTFFT_WITH_MOCK_ENABLED
! Real CUDA Runtime interfaces

    interface
        function cudaStreamQuery(stream)                                    &
            result(cudaError_t)                                             &
            bind(C, name="cudaStreamQuery")
        !! Queries an asynchronous stream for completion status.
        import
            type(dtfft_stream_t), value :: stream       !! Stream identifier
            integer(c_int)              :: cudaError_t  !! Returns `cudaSuccess` if all operations in stream have completed,
                                                        !! or `cudaErrorNotReady` if not.
        end function cudaStreamQuery
    endinterface

    interface
        function cudaStreamCreate(stream)                                   &
            result(cudaError_t)                                             &
            bind(C, name="cudaStreamCreate")
        !! Creates an asynchronous stream.
        import
            type(dtfft_stream_t)        :: stream       !! Pointer to the created stream
            integer(c_int)              :: cudaError_t  !! Returns `cudaSuccess` if the stream was created successfully,
                                                        !! or an error code if there was an issue.
        end function cudaStreamCreate
    end interface

    interface
        function cudaStreamDestroy(stream)                                  &
            result(cudaError_t)                                             &
            bind(C, name="cudaStreamDestroy")
        !! Destroys an asynchronous stream.
        import
            type(dtfft_stream_t), value :: stream       !! Stream identifier
            integer(c_int)              :: cudaError_t  !! Returns `cudaSuccess` if the stream was destroyed successfully,
                                                        !! or an error code if there was an issue.
        end function cudaStreamDestroy
    end interface

    interface
        function cudaStreamSynchronize(stream)                              &
            result(cudaError_t)                                             &
            bind(C, name="cudaStreamSynchronize")
        !! Waits for stream tasks to complete.
        import
            type(dtfft_stream_t), value :: stream       !! Stream identifier
            integer(c_int)              :: cudaError_t  !! Returns `cudaSuccess` if the stream tasks completed successfully,
                                                        !! or an error code if there was an issue.
        end function cudaStreamSynchronize
    end interface

    interface
        function cudaGetErrorString_c(errcode)                              &
            result(string)                                                  &
            bind(C, name="cudaGetErrorString")
        !! Returns the string representation of an error code.
        import
            integer(c_int), value :: errcode  !! Error code
            type(c_ptr)           :: string   !! Pointer to the error string
        end function cudaGetErrorString_c
    end interface

    interface
        function cudaMalloc(ptr, count)                                     &
            result(cudaError_t)                                             &
            bind(C, name="cudaMalloc")
        !! Allocates memory on the device.
        import
            type(c_ptr)               :: ptr          !! Pointer to allocated device memory
            integer(c_size_t), value  :: count        !! Requested allocation size in bytes
            integer(c_int)            :: cudaError_t  !! Returns `cudaSuccess` if memory was allocated successfully,
                                                        !! or `cudaErrorMemoryAllocation` if the memory could not be allocated.
        end function cudaMalloc
    end interface

    interface
        function cudaFree(ptr)                                              &
            result(cudaError_t)                                             &
            bind(C, name="cudaFree")
        !! Frees memory on the device.
        import
            type(c_ptr), value :: ptr         !! Pointer to memory to free
            integer(c_int)     :: cudaError_t !! Returns `cudaSuccess` if memory was freed successfully,
                                                !! or an error code if there was an issue.
        end function cudaFree
    end interface

    interface
        function cudaMemset(ptr, val, count)                                &
            result(cudaError_t)                                             &
            bind(C, name="cudaMemset")
        !! Initializes or sets device memory to a value.
        import
            type(c_ptr),        value :: ptr          !! Pointer to device memory
            integer(c_int),     value :: val          !! Value to set
            integer(c_size_t),  value :: count        !! Size in bytes to set
            integer(c_int)            :: cudaError_t  !! Returns `cudaSuccess` if the memory was set successfully,
                                                        !! or an error code if there was an issue.
        end function cudaMemset
    end interface

    interface
        function cudaEventCreateWithFlags(event, flags)                     &
            result(cudaError_t)                                             &
            bind(C, name="cudaEventCreateWithFlags")
        !! Creates an event with the specified flags.
        import
            type(cudaEvent)             :: event        !! Event identifier
            integer(c_int),   value     :: flags        !! Flags for event creation
            integer(c_int)              :: cudaError_t  !! Returns `cudaSuccess` if the event was created successfully,
                                                        !! or an error code if there was an issue.
        end function cudaEventCreateWithFlags
    end interface

    interface
        function cudaEventRecord(event, stream)                             &
            result(cudaError_t)                                             &
            bind(C, name="cudaEventRecord")
        !! Records an event in a stream.
        import
            type(cudaEvent),      value :: event        !! Event identifier
            type(dtfft_stream_t), value :: stream       !! Stream identifier
            integer(c_int)              :: cudaError_t  !! Returns `cudaSuccess` if the event was recorded successfully,
                                                        !! or an error code if there was an issue.
        end function cudaEventRecord
    end interface

    interface
        function cudaStreamWaitEvent(stream, event, flags)                  &
            result(cudaError_t)                                             &
            bind(C, name="cudaStreamWaitEvent")
        !! Makes a stream wait on an event.
        import
            type(dtfft_stream_t), value :: stream       !! Stream identifier
            type(cudaEvent),      value :: event        !! Event identifier
            integer(c_int),       value :: flags        !! Flags for the wait operation
            integer(c_int)              :: cudaError_t  !! Returns `cudaSuccess` if the stream is waiting successfully,
                                                        !! or an error code if there was an issue.
        end function cudaStreamWaitEvent
    end interface

    interface
        function cudaEventDestroy(event)                                    &
            result(cudaError_t)                                             &
            bind(C, name="cudaEventDestroy")
        !! Destroys an event.
        import
            type(cudaEvent), value :: event       !! Event identifier
            integer(c_int)         :: cudaError_t !! Returns `cudaSuccess` if the event was destroyed successfully,
                                                    !! or an error code if there was an issue.
        end function cudaEventDestroy
    end interface

    interface
        function cudaEventCreate(event)                                     &
            result(cudaError_t)                                             &
            bind(C, name="cudaEventCreate")
        !! Creates an event.
        import
            type(cudaEvent) :: event        !! Event identifier
            integer(c_int)  :: cudaError_t  !! Returns `cudaSuccess` if the event was created successfully,
                                            !! or an error code if there was an issue.
        end function cudaEventCreate
    end interface

    interface
        function cudaEventSynchronize(event)                                &
            result(cudaError_t)                                             &
            bind(C, name="cudaEventSynchronize")
        !! Waits for an event to complete.
        import
            type(cudaEvent), value :: event         !! Event identifier
            integer(c_int)         :: cudaError_t   !! Returns `cudaSuccess` if the event completed successfully,
                                                    !! or an error code if there was an issue.
        end function cudaEventSynchronize
    end interface

    interface
        function cudaEventElapsedTime(time, start, end)                     &
            result(cudaError_t)                                             &
            bind(C, name="cudaEventElapsedTime")
        !! Computes the elapsed time between two events.
        import
            real(c_float)          :: time        !! Elapsed time in milliseconds
            type(cudaEvent), value :: start       !! Starting event
            type(cudaEvent), value :: end         !! Ending event
            integer(c_int)         :: cudaError_t !! Returns `cudaSuccess` if the elapsed time was computed successfully,
                                                    !! or an error code if there was an issue.
        end function cudaEventElapsedTime
    end interface

    interface cudaMemcpyAsync
        !! Copies data asynchronously between host and device.
        function cudaMemcpyAsync_ptr(dst, src, count, kdir, stream)         &
            result(cudaError_t)                                             &
            bind(C, name="cudaMemcpyAsync")
        import
            type(c_ptr),          value :: dst          !! Destination pointer
            type(c_ptr),          value :: src          !! Source pointer
            integer(c_size_t),    value :: count        !! Size in bytes to copy
            integer(c_int),       value :: kdir         !! Direction of copy (host-to-device, device-to-host, etc.)
            type(dtfft_stream_t), value :: stream       !! Stream identifier
            integer(c_int)              :: cudaError_t  !! Returns `cudaSuccess` if the copy was initiated successfully,
                                                        !! or an error code if there was an issue.
        end function cudaMemcpyAsync_ptr

        function cudaMemcpyAsync_r32(dst, src, count, kdir, stream)         &
            result(cudaError_t)                                             &
            bind(C, name="cudaMemcpyAsync")
        import
            real(c_float)               :: dst          !! Destination array (32-bit float)
            real(c_float)               :: src          !! Source array (32-bit float)
            integer(c_size_t),    value :: count        !! Number of elements to copy
            integer(c_int),       value :: kdir         !! Direction of copy
            type(dtfft_stream_t), value :: stream       !! Stream identifier
            integer(c_int)              :: cudaError_t  !! Returns `cudaSuccess` if the copy was initiated successfully,
                                                        !! or an error code if there was an issue.
        end function cudaMemcpyAsync_r32
    end interface

    interface cudaMemcpy
        !! Copies data synchronously between host and device.
        function cudaMemcpy_ptr(dst, src, count, kdir)                      &
            result(cudaError_t)                                             &
            bind(C, name="cudaMemcpy")
        import
            type(c_ptr),          value :: dst          !! Destination pointer
            type(c_ptr),          value :: src          !! Source pointer
            integer(c_size_t),    value :: count        !! Size in bytes to copy
            integer(c_int),       value :: kdir         !! Direction of copy
            integer(c_int)              :: cudaError_t  !! Returns `cudaSuccess` if the copy was completed successfully,
                                                        !! or an error code if there was an issue.
        end function cudaMemcpy_ptr

        function cudaMemcpy_r64(dst, src, count, kdir)                      &
            result(cudaError_t)                                             &
            bind(C, name="cudaMemcpy")
        import
            real(c_double)              :: dst(*)       !! Destination array (64-bit float)
            real(c_double)              :: src(*)       !! Source array (64-bit float)
            integer(c_size_t),    value :: count        !! Number of bytes to copy
            integer(c_int),       value :: kdir         !! Direction of copy
            integer(c_int)              :: cudaError_t  !! Returns `cudaSuccess` if the copy was completed successfully,
                                                        !! or an error code if there was an issue.
        end function cudaMemcpy_r64

        function cudaMemcpy_r32(dst, src, count, kdir)                      &
            result(cudaError_t)                                             &
            bind(C, name="cudaMemcpy")
        import
            real(c_float)               :: dst(*)       !! Destination array (32-bit float)
            real(c_float)               :: src(*)       !! Source array (32-bit float)
            integer(c_size_t),    value :: count        !! Number of bytes to copy
            integer(c_int),       value :: kdir         !! Direction of copy
            integer(c_int)              :: cudaError_t  !! Returns `cudaSuccess` if the copy was completed successfully,
                                                        !! or an error code if there was an issue.
        end function cudaMemcpy_r32
    end interface

    interface
        function cudaGetDevice(num)                                         &
            result(cudaError_t)                                             &
            bind(C, name="cudaGetDevice")
        !! Returns the current device.
        import
            integer(c_int) :: num         !! Device number
            integer(c_int) :: cudaError_t !! Returns `cudaSuccess` if the device was retrieved successfully,
                                            !! or an error code if there was an issue.
        end function cudaGetDevice
    end interface

    interface
        function cudaGetDeviceCount(num)                                    &
            result(cudaError_t)                                             &
            bind(C, name="cudaGetDeviceCount")
        !! Returns the number of available devices.
        import
            integer(c_int) :: num         !! Number of devices
            integer(c_int) :: cudaError_t !! Returns `cudaSuccess` if the device count was retrieved successfully,
                                            !! or an error code if there was an issue.
        end function cudaGetDeviceCount
    end interface

    interface
        function cudaSetDevice(num)                                         &
            result(cudaError_t)                                             &
            bind(C, name="cudaSetDevice")
        !! Sets the current device.
        import
            integer(c_int), value :: num          !! Device number
            integer(c_int)        :: cudaError_t  !! Returns `cudaSuccess` if the device was set successfully,
                                                    !! or an error code if there was an issue.
        end function cudaSetDevice
    end interface

    interface
        function cudaMemGetInfo(free, total)                                &
            result(cudaError_t)                                             &
            bind(C, name="cudaMemGetInfo")
        !! Returns the amount of free and total memory on the device.
        import
            integer(c_size_t)   :: free         !! Free memory in bytes
            integer(c_size_t)   :: total        !! Total memory in bytes
            integer(c_int)      :: cudaError_t  !! Returns `cudaSuccess` if the memory information was retrieved successfully,
                                                !! or an error code if there was an issue.
        end function cudaMemGetInfo
    end interface

    interface
        function cudaDeviceSynchronize()                                    &
            result(cudaError_t)                                             &
            bind(C, name="cudaDeviceSynchronize")
        !! Synchronizes the device, blocking until all preceding tasks in all streams have completed.
        import
            integer(c_int)    :: cudaError_t  !! Returns `cudaSuccess` if syncronization was
                                                !! or an error code if there was an issue.
        end function cudaDeviceSynchronize
    end interface

    interface
        function cudaGetLastError()                                         &
            result(cudaError_t)                                             &
            bind(C, name="cudaGetLastError")
        !! Returns the last error from a runtime call.
        import
            integer(c_int)    :: cudaError_t  !! Returns `cudaSuccess` if no error was detected
                                                !! or an error code if there was an issue.
        end function cudaGetLastError
    end interface

    interface
        subroutine get_device_props(device, props)                          &
            bind(C, name="get_device_props_cuda")
        !! Returns the CUDA device properties for a given device number.
        import
            integer(c_int), value   :: device   !! Device number
            type(device_props)      :: props    !! GPU Properties
        end subroutine get_device_props
    end interface

#else
! Mock CUDA Runtime interfaces for CPU testing

    interface cudaMemcpyAsync
        module procedure cudaMemcpyAsync_ptr
        module procedure cudaMemcpyAsync_r32
    end interface cudaMemcpyAsync

    interface cudaMemcpy
        module procedure cudaMemcpy_ptr
        module procedure cudaMemcpy_r64
        module procedure cudaMemcpy_r32
    end interface cudaMemcpy

    ! C-wrappers for mock functions (public for C interoperability)
    public :: cudaDeviceSynchronize_c
    public :: cudaStreamCreate_c
    public :: cudaStreamSynchronize_c
    public :: cudaStreamDestroy_c
    public :: cudaMallocManaged_c
    public :: cudaFree_c
    public :: cudaMemset_c
    public :: cudaGetErrorString_c_wrapper

#endif


contains

#ifdef DTFFT_WITH_MOCK_ENABLED
  ! Mock implementations for CPU testing
  
    function cudaStreamQuery(stream) result(cudaError_t)
    !! Mock: Always returns cudaSuccess
        type(dtfft_stream_t), value :: stream
        integer(c_int)              :: cudaError_t
        cudaError_t = cudaSuccess
    end function cudaStreamQuery

    function cudaStreamCreate(stream) result(cudaError_t)
    !! Mock: Creates a dummy stream
        type(dtfft_stream_t)        :: stream
        integer(c_int)              :: cudaError_t
        stream%stream = c_null_ptr
        cudaError_t = cudaSuccess
    end function cudaStreamCreate

    function cudaStreamDestroy(stream) result(cudaError_t)
    !! Mock: Does nothing
        type(dtfft_stream_t), intent(in) :: stream
        integer(c_int)                   :: cudaError_t
        cudaError_t = cudaSuccess
    end function cudaStreamDestroy

    function cudaStreamSynchronize(stream) result(cudaError_t)
    !! Mock: Does nothing, just returns success
        type(dtfft_stream_t), intent(in) :: stream
        integer(c_int)                   :: cudaError_t
        cudaError_t = cudaSuccess
    end function cudaStreamSynchronize

    function cudaGetErrorString_c(errcode) result(string)
    !! Mock: Returns error string
        integer(c_int), intent(in) :: errcode
        type(c_ptr)                :: string
        character(len=20), target, save :: error_msg = "Mock CUDA Error"
        string = c_loc(error_msg)
    end function cudaGetErrorString_c

    function cudaMalloc(ptr, count) result(cudaError_t)
    !! Mock: Allocates memory on CPU using allocate
        use, intrinsic :: iso_c_binding
        type(c_ptr)                  :: ptr
        integer(c_size_t), intent(in) :: count
        integer(c_int)               :: cudaError_t

        ptr = mem_alloc_host(count)
        if( is_null_ptr(ptr) ) then
        cudaError_t = cudaErrorMemoryAllocation
        else
        cudaError_t = cudaSuccess
        end if
    end function cudaMalloc

    function cudaFree(ptr) result(cudaError_t)
    !! Mock: Frees memory allocated on CPU
        type(c_ptr), intent(in) :: ptr
        integer(c_int)          :: cudaError_t

        if ( is_null_ptr(ptr) ) then
        cudaError_t = cudaErrorInvalidValue
        return
        end if
        call mem_free_host(ptr)
        cudaError_t = cudaSuccess
    end function cudaFree

    function cudaMemset(ptr, val, count) result(cudaError_t)
    !! Mock: Sets memory on CPU
        type(c_ptr),        intent(in) :: ptr
        integer(c_int),     intent(in) :: val
        integer(c_size_t),  intent(in) :: count
        integer(c_int)                 :: cudaError_t
        integer(c_int8_t), pointer :: temp_array(:)
        integer(c_size_t) :: i

        if ( is_null_ptr(ptr) ) then
            cudaError_t = cudaErrorInvalidValue
            return
        end if

        call c_f_pointer(ptr, temp_array, [count])
        do i = 1, count
            temp_array(i) = int(val, c_int8_t)
        end do
        cudaError_t = cudaSuccess
    end function cudaMemset

    function cudaEventCreateWithFlags(event, flags) result(cudaError_t)
    !! Mock: Creates dummy event
        type(cudaEvent)            :: event
        integer(c_int), intent(in) :: flags
        integer(c_int)             :: cudaError_t
        event%t = 0.0_real64
        cudaError_t = cudaSuccess
    end function cudaEventCreateWithFlags

    function cudaEventRecord(event, stream) result(cudaError_t)
    !! Mock: Does nothing
        type(cudaEvent),      intent(inout) :: event
        type(dtfft_stream_t), intent(in)    :: stream
        integer(c_int)                      :: cudaError_t

        event%t = MPI_Wtime()
        cudaError_t = cudaSuccess
    end function cudaEventRecord

    function cudaStreamWaitEvent(stream, event, flags) result(cudaError_t)
    !! Mock: Does nothing
        type(dtfft_stream_t), intent(in) :: stream
        type(cudaEvent),      intent(in) :: event
        integer(c_int),       intent(in) :: flags
        integer(c_int)                   :: cudaError_t
        cudaError_t = cudaSuccess
    end function cudaStreamWaitEvent

    function cudaEventDestroy(event) result(cudaError_t)
    !! Mock: Does nothing
        type(cudaEvent), intent(in) :: event
        integer(c_int)              :: cudaError_t
        cudaError_t = cudaSuccess
    end function cudaEventDestroy

    function cudaEventCreate(event) result(cudaError_t)
    !! Mock: Creates dummy event
        type(cudaEvent) :: event
        integer(c_int)  :: cudaError_t
        event%t = 0.0_real64
        cudaError_t = cudaSuccess
    end function cudaEventCreate

    function cudaEventSynchronize(event) result(cudaError_t)
    !! Mock: Does nothing
        type(cudaEvent), intent(in) :: event
        integer(c_int)              :: cudaError_t
        cudaError_t = cudaSuccess
    end function cudaEventSynchronize

    function cudaEventElapsedTime(time, start, end) result(cudaError_t)
    !! Mock: Returns zero time
        real(c_float),   intent(out) :: time
        type(cudaEvent), intent(in)  :: start
        type(cudaEvent), intent(in)  :: end
        integer(c_int)               :: cudaError_t
        time = 1000.0_c_float * real(end%t - start%t, real32)
        cudaError_t = cudaSuccess
    end function cudaEventElapsedTime

    function cudaMemcpyAsync_ptr(dst, src, count, kdir, stream) result(cudaError_t)
    !! Mock: Synchronous copy on CPU
        type(c_ptr),          intent(in) :: dst
        type(c_ptr),          intent(in) :: src
        integer(c_size_t),    intent(in) :: count
        integer(c_int),       intent(in) :: kdir
        type(dtfft_stream_t), intent(in) :: stream
        integer(c_int)                   :: cudaError_t
        integer(c_int8_t), pointer :: src_array(:), dst_array(:)

        if ( is_null_ptr(src) .or. is_null_ptr(dst)) then
            cudaError_t = cudaErrorInvalidValue
            return
        endif

        call c_f_pointer(src, src_array, [count])
        call c_f_pointer(dst, dst_array, [count])
        dst_array(:) = src_array(:)
        cudaError_t = cudaSuccess
    end function cudaMemcpyAsync_ptr

    function cudaMemcpyAsync_r32(dst, src, count, kdir, stream) result(cudaError_t)
    !! Mock: Synchronous copy on CPU for r32
        real(c_float), target,  intent(out) :: dst
        real(c_float), target,  intent(in)  :: src
        integer(c_size_t),      intent(in)  :: count
        integer(c_int),         intent(in)  :: kdir
        type(dtfft_stream_t),   intent(in)  :: stream
        integer(c_int)                    :: cudaError_t

        cudaError_t = cudaMemcpyAsync(c_loc(dst), c_loc(src), count, kdir, stream)
    end function cudaMemcpyAsync_r32

    function cudaMemcpy_ptr(dst, src, count, kdir) result(cudaError_t)
    !! Mock: Synchronous copy on CPU
        type(c_ptr),       intent(in) :: dst
        type(c_ptr),       intent(in) :: src
        integer(c_size_t), intent(in) :: count
        integer(c_int),    intent(in) :: kdir
        integer(c_int)                :: cudaError_t

        cudaError_t = cudaMemcpyAsync(dst, src, count, kdir, NULL_STREAM)
    end function cudaMemcpy_ptr

    function cudaMemcpy_r64(dst, src, count, kdir) result(cudaError_t)
    !! Mock: Synchronous copy on CPU for r64
        real(c_double),    target,  intent(out) :: dst(*)
        real(c_double),    target,  intent(in)  :: src(*)
        integer(c_size_t),          intent(in)  :: count
        integer(c_int),             intent(in)  :: kdir
        integer(c_int)                          :: cudaError_t

        cudaError_t = cudaMemcpy(c_loc(dst), c_loc(src), count, kdir)
    end function cudaMemcpy_r64

    function cudaMemcpy_r32(dst, src, count, kdir) result(cudaError_t)
    !! Mock: Synchronous copy on CPU for r32
        real(c_float),    target,   intent(out) :: dst(*)
        real(c_float),    target,   intent(in)  :: src(*)
        integer(c_size_t),          intent(in)  :: count
        integer(c_int),             intent(in)  :: kdir
        integer(c_int)                          :: cudaError_t

        cudaError_t = cudaMemcpy(c_loc(dst), c_loc(src), count, kdir)
    end function cudaMemcpy_r32

    function cudaGetDevice(num) result(cudaError_t)
    !! Mock: Returns rank of MPI_COMM_WORLD
        integer(c_int), intent(out) :: num
        integer(c_int)              :: cudaError_t
        integer(int32) :: mpi_err

        call MPI_Comm_rank(MPI_COMM_WORLD, num, mpi_err)
        cudaError_t = cudaSuccess
    end function cudaGetDevice

    function cudaGetDeviceCount(num) result(cudaError_t)
    !! Mock: Returns size of MPI_COMM_TYPE_SHARED
        integer(c_int), intent(out) :: num
        integer(c_int)              :: cudaError_t
        TYPE_MPI_COMM  :: local_comm
        integer(int32) :: ierr

        call MPI_Comm_split_type(MPI_COMM_WORLD, MPI_COMM_TYPE_SHARED, 0, MPI_INFO_NULL, local_comm, ierr)
        call MPI_Comm_size(local_comm, num, ierr)
        call MPI_Comm_free(local_comm, ierr)
        cudaError_t = cudaSuccess
    end function cudaGetDeviceCount

    function cudaSetDevice(num) result(cudaError_t)
    !! Mock: Does nothing
        integer(c_int), intent(in) :: num
        integer(c_int)             :: cudaError_t
        cudaError_t = cudaSuccess
    end function cudaSetDevice

    function cudaMemGetInfo(free, total) result(cudaError_t)
    !! Mock: Returns dummy memory info
        integer(c_size_t)   :: free, total
        integer(c_int)      :: cudaError_t
        total = 8_c_size_t * 1024_c_size_t * 1024_c_size_t * 1024_c_size_t  ! 8 GB
        free = 4_c_size_t * 1024_c_size_t * 1024_c_size_t * 1024_c_size_t   ! 4 GB
        cudaError_t = cudaSuccess
    end function cudaMemGetInfo

    function cudaDeviceSynchronize() result(cudaError_t)
    !! Mock: Does nothing
        integer(c_int)    :: cudaError_t
        cudaError_t = cudaSuccess
    end function cudaDeviceSynchronize

    function cudaGetLastError() result(cudaError_t)
    !! Mock: Returns success
        integer(c_int)    :: cudaError_t
        cudaError_t = cudaSuccess
    end function cudaGetLastError

    subroutine get_device_props(device, props)
    !! Mock: Returns dummy device properties
        integer(c_int),    intent(in)  :: device
        type(device_props), intent(out) :: props

        props%sm_count                   = 108
        props%max_threads_per_sm         = 2048
        props%max_blocks_per_sm          = 32
        props%shared_mem_per_sm          = 164 * 1024
        props%max_threads_per_block      = 1024
        props%shared_mem_per_block       = 48 * 1024
        props%l2_cache_size              = 40960 * 1024
        props%compute_capability_major   = 8
        props%compute_capability_minor   = 0
    end subroutine get_device_props

#endif

    function cudaGetErrorString(errcode) result(string)
    !! Helper function that returns a string describing the given nvrtcResult code
    !! If the error code is not recognized, "unrecognized error code" is returned.
        integer(c_int),   intent(in)  :: errcode        !! CUDA Runtime Compilation API result code.
        character(len=:), allocatable :: string         !! Result string

#ifndef DTFFT_WITH_MOCK_ENABLED
        call string_c2f(cudaGetErrorString_c(errcode), string)
#else
        if (errcode == cudaSuccess) then
            allocate(string, source="cudaSuccess (mock)")
        else
            allocate(string, source="cudaError (mock)")
        end if
#endif
    end function cudaGetErrorString

#ifdef DTFFT_WITH_MOCK_ENABLED
    ! C-wrapper functions for mock CUDA functions
    function cudaDeviceSynchronize_c() result(cudaError_t) bind(C, name="cudaDeviceSynchronize")
        integer(c_int) :: cudaError_t
        cudaError_t = cudaDeviceSynchronize()
    end function cudaDeviceSynchronize_c

    function cudaStreamCreate_c(stream) result(cudaError_t) bind(C, name="cudaStreamCreate")
        type(dtfft_stream_t) :: stream
        integer(c_int)       :: cudaError_t
        cudaError_t = cudaStreamCreate(stream)
    end function cudaStreamCreate_c

    function cudaStreamSynchronize_c(stream) result(cudaError_t) bind(C, name="cudaStreamSynchronize")
        type(dtfft_stream_t), value :: stream
        integer(c_int)              :: cudaError_t
        cudaError_t = cudaStreamSynchronize(stream)
    end function cudaStreamSynchronize_c

    function cudaStreamDestroy_c(stream) result(cudaError_t) bind(C, name="cudaStreamDestroy")
        type(dtfft_stream_t), value :: stream
        integer(c_int)              :: cudaError_t
        cudaError_t = cudaStreamDestroy(stream)
    end function cudaStreamDestroy_c

    function cudaMallocManaged_c(ptr, count, flags) result(cudaError_t) bind(C, name="cudaMallocManaged")
        type(c_ptr)              :: ptr
        integer(c_size_t), value :: count
        integer(c_int), value    :: flags
        integer(c_int)           :: cudaError_t
        ! For mock version, just call regular cudaMalloc (ignore flags)
        cudaError_t = cudaMalloc(ptr, count)
    end function cudaMallocManaged_c

    function cudaFree_c(ptr) result(cudaError_t) bind(C, name="cudaFree")
        type(c_ptr), value :: ptr
        integer(c_int)     :: cudaError_t
        cudaError_t = cudaFree(ptr)
    end function cudaFree_c

    function cudaMemset_c(ptr, val, count) result(cudaError_t) bind(C, name="cudaMemset")
        type(c_ptr), value       :: ptr
        integer(c_int), value    :: val
        integer(c_size_t), value :: count
        integer(c_int)           :: cudaError_t
        cudaError_t = cudaMemset(ptr, val, count)
    end function cudaMemset_c

    function cudaGetErrorString_c_wrapper(errcode) result(string) bind(C, name="cudaGetErrorString")
        integer(c_int), value :: errcode
        type(c_ptr)           :: string
        character(len=50), target, save :: error_msg

        if (errcode == cudaSuccess) then
            error_msg = "cudaSuccess (mock)" // c_null_char
        else
            error_msg = "cudaError (mock)" // c_null_char
        end if
        string = c_loc(error_msg)
    end function cudaGetErrorString_c_wrapper
#endif

end module dtfft_interface_cuda_runtime

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
#include "dtfft.f03"
module dtfft_reshape_plan
!! This module describes [[reshape_plan]] class
use iso_fortran_env
use dtfft_abstract_backend,               only: backend_helper
#ifdef DTFFT_WITH_COMPRESSION
use dtfft_abstract_compressor
#endif
use dtfft_abstract_reshape_handle,        only: abstract_reshape_handle, reshape_container, create_args
use dtfft_config
use dtfft_errors
use dtfft_parameters
use dtfft_pencil,                         only: dtfft_pencil_t, pencil, pencil_init, get_local_sizes
use dtfft_reshape_plan_base,              only: reshape_plan_base, allocate_plans, destroy_plans, execute_autotune
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_profile.h"
#include "_dtfft_cuda.h"
#include "_dtfft_private.h"
implicit none
private
public :: reshape_plan

#define SIDX CONF_DTFFT_RESHAPE_X_BRICKS_TO_PENCILS
#define EIDX CONF_DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS


  integer(int32), parameter :: NEIGHBOR_GROUP = 1
  integer(int32), parameter :: STRIDED_GROUP = 2


    type, extends(reshape_plan_base) :: reshape_plan
    !! Reshape Plan class
    !! This class is a container for transposition plans
    private
        integer(int32), allocatable :: init_grid(:)
        integer(int32), allocatable :: final_grid(:)
        TYPE_MPI_COMM,  allocatable :: comms(:)
    contains
    private
        procedure,  non_overridable,  pass(self), public :: create            !! Creates transpose plan
        procedure,  non_overridable,  pass(self), public :: get_grid          !! Returns grid for specified reshape
        procedure,  non_overridable,  pass(self), public :: destroy
    end type reshape_plan

contains

    subroutine destroy(self)
        class(reshape_plan),            intent(inout) :: self
        integer(int32) :: d, ierr

        if ( allocated(self%init_grid) ) deallocate(self%init_grid)
        if ( allocated(self%final_grid) ) deallocate(self%final_grid)
        call self%reshape_plan_base%destroy()
        if ( allocated(self%comms) ) then
            do d = 2, 3
                call MPI_Comm_free(self%comms(d), ierr)
            enddo
            deallocate(self%comms)
        endif
    end subroutine destroy

    subroutine get_grid(self, dim, grid)
    !! Returns grid decomposition for specified dimension
        class(reshape_plan),  target, intent(in)  :: self
        !! Reshape plan
        integer(int8),                intent(in)  :: dim
        !! Dimension: 1 for initial grid, other values for final grid
        integer(int32),     pointer,  intent(out) :: grid(:)
        !! Pointer to grid array

        if ( dim == 1 ) then
            grid => self%init_grid
        else
            grid => self%final_grid
        endif
    end subroutine get_grid

    function create(self, platform, ipencil, pencils, comm, local_comms, base_dtype, base_storage, effort, backend, base_init_dtype, base_init_storage, bricks, is_final_enabled) result(error_code)
    !! Creates reshape plan
    !!
    !! This function initializes the reshape plan by creating communicators for brick layouts,
    !! setting up grid decompositions, and allocating reshape operation plans.
        class(reshape_plan),            intent(inout) :: self
        !! Reshape plan to be initialized
        type(dtfft_platform_t),         intent(in)    :: platform
        !! Platform to create plan for (HOST or CUDA)
        type(pencil_init),              intent(in)    :: ipencil
        !! Pencil decomposition passed by user
        type(pencil),                   intent(in)    :: pencils(:)
        !! Array of pencil decompositions for different layouts
        TYPE_MPI_COMM,                  intent(in)    :: comm
        !! Global MPI communicator
        TYPE_MPI_COMM,                  intent(in)    :: local_comms(:)
        !! Local MPI communicators for each dimension
        TYPE_MPI_DATATYPE,              intent(in)    :: base_dtype
        !! Base MPI datatype for complex data
        integer(int64),                 intent(in)    :: base_storage
        !! Number of bytes needed to store single complex element
        type(dtfft_effort_t),           intent(in)    :: effort
        !! dtFFT planner effort level (ESTIMATE, MEASURE, PATIENT, EXHAUSTIVE)
        type(dtfft_backend_t),          intent(in)    :: backend
        !! Communication backend used for transpose plans
        TYPE_MPI_DATATYPE,              intent(in)    :: base_init_dtype
        !! Base MPI datatype for real data
        integer(int64),                 intent(in)    :: base_init_storage
        !! Number of bytes needed to store single real element
        type(pencil),                   intent(out)   :: bricks(:)
        !! Pencils describing brick data distribution
        logical,                        intent(out)   :: is_final_enabled
        !! Flag indicating if final reshape in Fourier space is enabled
        integer(int32)                                :: error_code
        !! Error code: DTFFT_SUCCESS on success
        integer(int8)     :: ndims      !! Number of dimensions
        integer(int8)     :: d
        integer(int32)    :: c_size, ierr
        integer(int32)    :: bsize
        TYPE_MPI_COMM, allocatable     :: temp_comms(:)
        integer(int64) :: min_buffer_size_real, min_buffer_size_complex
        real(real64) :: ts, te
        type(dtfft_backend_t) :: backends(4)

        error_code = DTFFT_SUCCESS
#ifdef DTFFT_WITH_COMPRESSION
        CHECK_CALL( self%init(platform, effort, get_conf_reshape_backend(), DTFFT_EXHAUSTIVE, get_conf_reshape(), base_dtype, base_storage), error_code )
#else
        CHECK_CALL( self%init(platform, effort, get_conf_reshape_backend(), DTFFT_EXHAUSTIVE ), error_code )
#endif

        if ( .not. is_backend_compatible(backend, self%backend) .and. effort%val < DTFFT_EXHAUSTIVE%val .and. backend /= DTFFT_BACKEND_ADAPTIVE ) then
            WRITE_WARN("Incompatible reshape backend detected, it has been ignored")
            self%backend = get_compatible(backend, platform)
        endif

        ndims = size(ipencil%dims, kind=int8)
        call bricks(1)%create(ndims, 1_int8, ipencil%dims, ipencil%comms, lstarts=ipencil%starts, lcounts=ipencil%counts)

        call MPI_Comm_size(ipencil%comms(ndims), c_size, ierr)

        allocate( self%init_grid(ndims), self%final_grid(ndims) )
        do d = 1, ndims
            call MPI_Comm_size(ipencil%comms(d), self%init_grid(d), ierr)
        enddo

        allocate( temp_comms(ndims), self%comms(3) )

        ! call MPI_Comm_dup(ipencil%comms(1), self%comms(2), ierr)
        if ( ndims == 2 ) then
            bsize = pencils(1)%starts(2)
        else
            bsize = pencils(1)%starts(2) + pencils(1)%starts(3) * pencils(1)%counts(2) * self%init_grid(2)
        endif
        call MPI_Comm_split(ipencil%comms(1), 0, bsize, self%comms(2), ierr)

         call MPI_Comm_rank(self%comms(2), bsize, ierr)

        call create_custom_comm(local_comms(ndims), c_size, NEIGHBOR_GROUP, self%comms(3))
        call create_custom_comm(local_comms(ndims), c_size, STRIDED_GROUP, temp_comms(ndims))

        if ( ndims == 3 ) then
            temp_comms(2) = local_comms(2)
        endif

        block
            integer(int32) :: slow_count, min_start
            TYPE_MPI_COMM :: final_comms(ndims)
            integer(int32) :: final_sizes(ndims)

            call MPI_Allreduce(pencils(ndims)%counts(ndims), slow_count, 1, MPI_INTEGER, MPI_SUM, self%comms(3), ierr)

            final_comms(1) = self%comms(3)
            final_sizes(1) = ipencil%dims(ndims)
            if ( ndims == 2 ) then
                final_comms(2) = MPI_COMM_SELF
                final_sizes(2) = slow_count
            else
                final_comms(2) = MPI_COMM_SELF
                final_comms(3) = MPI_COMM_SELF

                final_sizes(2) = pencils(ndims)%counts(2)
                final_sizes(3) = slow_count
            endif

            call bricks(2)%create(ndims, ndims, final_sizes, final_comms, pencils(ndims)%starts, pencils(ndims)%counts, .true.)

            call MPI_Allreduce(pencils(ndims)%starts(ndims), min_start, 1, MPI_INTEGER, MPI_MIN, self%comms(3), ierr)
            bricks(2)%starts(ndims) = bricks(2)%starts(ndims) + min_start

            if ( ndims == 3 ) then
                bricks(2)%starts(2) = pencils(ndims)%starts(2)
            endif
        end block

        temp_comms(1) = self%comms(3)
        call MPI_Comm_size(temp_comms(1), self%final_grid(ndims), ierr)
        call MPI_Comm_size(temp_comms(2), self%final_grid(1), ierr)

        if ( ndims == 3 ) then
            call MPI_Comm_size(temp_comms(3), self%final_grid(2), ierr)
        endif
        is_final_enabled = .false.
        if ( self%final_grid(ndims) > 1 .and. get_conf_fourier_reshape_enabled() ) is_final_enabled = .true.

        call MPI_Comm_free(temp_comms(ndims), ierr)
        deallocate( temp_comms )

        call get_local_sizes([bricks(1), pencils(1)], alloc_size=min_buffer_size_real)
        call get_local_sizes([bricks(2), pencils(ndims)], alloc_size=min_buffer_size_complex)

        min_buffer_size_real = min_buffer_size_real * (base_init_storage / FLOAT_STORAGE_SIZE)
        min_buffer_size_complex = min_buffer_size_complex * (base_storage / FLOAT_STORAGE_SIZE)
        self%min_buffer_size = max(min_buffer_size_real, min_buffer_size_complex)

        if ( effort == DTFFT_EXHAUSTIVE ) then
            ts = MPI_Wtime()

            PHASE_BEGIN("Autotune reshape plan", COLOR_AUTOTUNE)
            WRITE_INFO("Starting autotune of reshape plans...")
            call autotune_reshape_plan(platform, comm, self%comms, base_init_dtype, base_init_storage, base_dtype, base_init_storage, &
                bricks, pencils, self%stream, self%min_buffer_size * FLOAT_STORAGE_SIZE, backend, self%backend, backends)
            PHASE_END("Autotune reshape plan")
            WRITE_INFO("DTFFT_EXHAUSTIVE: Selected reshape backend is "//dtfft_get_backend_string(self%backend))

            te = MPI_Wtime()
            WRITE_INFO("Time spent on autotune: "//to_str(te - ts)//" [s]")
        endif

        ts = MPI_Wtime()
        call self%helper%create(platform, comm, self%comms, is_backend_nccl(self%backend), [bricks(1), bricks(2), pencils(1), pencils(ndims)])
        call create_reshape_plans(self%plans, self%backend, platform, self%helper, effort, .false., &
            base_init_dtype, base_init_storage, base_dtype, base_storage, bricks, pencils, backends)

        te = MPI_Wtime()
        WRITE_INFO("Time spent on creating final reshape plans: "//to_str(te - ts)//" [s]")

        allocate( self%names(CONF_DTFFT_RESHAPE_X_BRICKS_TO_PENCILS:CONF_DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS), self%colors(CONF_DTFFT_RESHAPE_X_BRICKS_TO_PENCILS:CONF_DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS) )
        do d = CONF_DTFFT_RESHAPE_X_BRICKS_TO_PENCILS, CONF_DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS
            self%names(d) = string("Reshape "//RESHAPE_NAMES(d))
            self%colors(d) = COLOR_RESHAPE_PALLETTE(d)
        end do
    end function create

    subroutine create_custom_comm(old_comm, new_size, group_type, new_comm)
    !! Creates custom MPI communicator by splitting processes into groups
    !!
    !! This subroutine divides processes from an existing communicator into groups
    !! based on the specified group type: neighbor groups or strided groups.
        TYPE_MPI_COMM,  intent(in)  :: old_comm
        !! Original MPI communicator to split
        integer(int32), intent(in)  :: new_size
        !! Size of each group in the new communicator
        integer(int32), intent(in)  :: group_type
        !! Type of grouping: NEIGHBOR_GROUP (consecutive ranks) or STRIDED_GROUP (interleaved ranks)
        TYPE_MPI_COMM,  intent(out) :: new_comm
        !! Newly created MPI communicator
        integer(int32)  :: ierror
        integer(int32) :: old_rank, old_size, color

        call MPI_Comm_rank(old_comm, old_rank, ierror)
        call MPI_Comm_size(old_comm, old_size, ierror)

        select case(group_type)
        case(NEIGHBOR_GROUP)
            color = old_rank / new_size
        case(STRIDED_GROUP)
            color = mod(old_rank, new_size)
        end select
        call MPI_Comm_split(old_comm, color, old_rank, new_comm, ierror)
    end subroutine create_custom_comm

    pure logical function is_backend_compatible(backend1, backend2)
    !! Checks if two communication backends are compatible
    !!
    !! Backends are compatible if they belong to the same family:
    !! MPI backends are compatible with each other, NCCL with NCCL, NVSHMEM with NVSHMEM.
    !!
    !! @return .true. if backends are compatible, .false. otherwise
        type(dtfft_backend_t), intent(in) :: backend1
        !! First backend to compare
        type(dtfft_backend_t), intent(in) :: backend2
        !! Second backend to compare

        is_backend_compatible = .true.
        if ( is_backend_mpi(backend1) .and. is_backend_mpi(backend2) ) return
        if ( is_backend_nccl(backend1) .and. is_backend_nccl(backend2) ) return
        if ( is_backend_nvshmem(backend1) .and. is_backend_nvshmem(backend2) ) return
        is_backend_compatible = .false.
    end function is_backend_compatible

    pure type(dtfft_backend_t) function get_compatible(backend, platform)
    !! Returns a compatible reshape backend for the given main backend and platform
    !!
    !! Selects an appropriate reshape backend based on the main backend family:
    !! - For MPI backends: returns MPI_P2P (GPU) or MPI_DATATYPE (CPU)
    !! - For NCCL backends: returns NCCL
    !! - For NVSHMEM backends: returns CUFFTMP
    !!
    !! @return Compatible backend for reshape operations
        type(dtfft_backend_t),  intent(in) :: backend
        !! Input backend from main FFT plan
        type(dtfft_platform_t), intent(in) :: platform
        !! Execution platform (HOST or CUDA)

        if ( is_backend_mpi(backend) ) then
            if ( platform == DTFFT_PLATFORM_CUDA ) then
                get_compatible = DTFFT_BACKEND_MPI_P2P
            else
                get_compatible = DTFFT_BACKEND_MPI_DATATYPE
            endif
        else if ( is_backend_nccl(backend) ) then
            get_compatible = DTFFT_BACKEND_NCCL
        else if ( is_backend_nvshmem(backend) ) then
            get_compatible = DTFFT_BACKEND_CUFFTMP
        endif
    end function get_compatible

    subroutine create_reshape_plans(plans, backend, platform, helper, effort, force_effort, base_init_dtype, base_init_storage, &
        base_dtype, base_storage, bricks, pencils, backends, plan_id)
    !! Creates and allocates all reshape operation plans
    !!
    !! This subroutine allocates and initializes plans for all four reshape operations:
    !! - X_BRICKS_TO_PENCILS: brick to pencil in X dimension (real space)
    !! - X_PENCILS_TO_BRICKS: pencil to brick in X dimension (real space)
    !! - Z_PENCILS_TO_BRICKS: pencil to brick in Z dimension (Fourier space)
    !! - Z_BRICKS_TO_PENCILS: brick to pencil in Z dimension (Fourier space)
        type(reshape_container),  allocatable,  intent(inout) :: plans(:)
            !! Array of reshape plan containers to be allocated and initialized
        type(dtfft_backend_t),                  intent(in)    :: backend
            !! Communication backend to use for reshape operations
        type(dtfft_platform_t),                 intent(in)    :: platform
            !! Execution platform (HOST or CUDA)
        type(backend_helper),                   intent(inout) :: helper
            !! Backend helper for communication setup
        type(dtfft_effort_t),                   intent(in)    :: effort
            !! dtFFT planner effort level
        logical,                                intent(in)    :: force_effort
            !! 
        TYPE_MPI_DATATYPE,                      intent(in)    :: base_init_dtype
            !! Base MPI datatype for real space data
        integer(int64),                         intent(in)    :: base_init_storage
            !! Number of bytes needed to store single real element
        TYPE_MPI_DATATYPE,                      intent(in)    :: base_dtype
            !! Base MPI datatype for Fourier space data
        integer(int64),                         intent(in)    :: base_storage
            !! Number of bytes needed to store single complex element
        type(pencil),          target,          intent(in)    :: bricks(:)
            !! Pencils describing brick data distribution
        type(pencil),          target,          intent(in)    :: pencils(:)
            !! Array of pencil decompositions
        type(dtfft_backend_t),  optional,       intent(in)    :: backends(SIDX:EIDX)
            !! Adaptive backends
        integer(int8),          optional,       intent(in)    :: plan_id
            !! Single plan id to create
        type(create_args) :: args
        logical :: is_adaptive
        type(pencil), pointer :: p1, p2

        if ( present(plan_id) ) then
            allocate( plans(plan_id:plan_id) )
        else
            allocate( plans(SIDX:EIDX) )
        endif

        is_adaptive = backend == DTFFT_BACKEND_ADAPTIVE

#ifdef DTFFT_DEBUG
        if ( is_adaptive .and. .not. present(backends) ) then
            INTERNAL_ERROR("is_adaptive .and. .not. present(backends)")
        endif
#endif
        if ( is_adaptive ) then
            call allocate_plans(plans, backends=backends)
        else
            call allocate_plans(plans, backend)
        endif

        args%platform = platform
        args%helper = helper
        args%effort = effort
        args%backend = backend
        args%force_effort = force_effort
        args%transpose_mode = TRANSPOSE_MODE_NOT_SET
#ifdef DTFFT_WITH_COMPRESSION
        args%compression_config = get_conf_reshape()
#endif
        args%base_type = base_init_dtype
        args%base_storage = base_init_storage
        if ( present(plan_id) ) then
            if ( plan_id == CONF_DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS .or. plan_id == CONF_DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS ) then
                args%base_type = base_dtype
                args%base_storage = base_storage
            endif
            select case ( plan_id )
            case ( CONF_DTFFT_RESHAPE_X_BRICKS_TO_PENCILS )
                p1 => bricks(1)
                p2 => pencils(1)
            case ( CONF_DTFFT_RESHAPE_X_PENCILS_TO_BRICKS )
                p1 => pencils(1)
                p2 => bricks(1)
            case ( CONF_DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS )
                p1 => pencils(size(pencils))
                p2 => bricks(2)
            case ( CONF_DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS )
                p1 => bricks(2)
                p2 => pencils(size(pencils))
            endselect
            call plans(plan_id)%p%create(p1, p2, args)
        else
            if ( is_adaptive ) args%backend = backends(CONF_DTFFT_RESHAPE_X_BRICKS_TO_PENCILS)
            call plans(CONF_DTFFT_RESHAPE_X_BRICKS_TO_PENCILS)%p%create(bricks(1), pencils(1), args)
            if ( is_adaptive ) args%backend = backends(CONF_DTFFT_RESHAPE_X_PENCILS_TO_BRICKS)
            call plans(CONF_DTFFT_RESHAPE_X_PENCILS_TO_BRICKS)%p%create(pencils(1), bricks(1), args)

            args%base_type = base_dtype
            args%base_storage = base_storage
            if ( is_adaptive ) args%backend = backends(CONF_DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS)
            call plans(CONF_DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS)%p%create(pencils(size(pencils)), bricks(2), args)
            if ( is_adaptive ) args%backend = backends(CONF_DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS)
            call plans(CONF_DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS)%p%create(bricks(2), pencils(size(pencils)), args)
        endif
    end subroutine create_reshape_plans

    subroutine autotune_reshape_plan(                                                                &
        platform, base_comm, comms, base_init_dtype, base_init_storage, base_dtype, base_storage, bricks, pencils, stream,     &
        buffer_size, transpose_backend, best_backend, backends)
    !! Runs autotune for all backends
        type(dtfft_platform_t), intent(in)      :: platform         !! Platform to create plan for
        TYPE_MPI_COMM,          intent(in)      :: base_comm        !! 3D Cartesian comm
        TYPE_MPI_COMM,          intent(in)      :: comms(:)         !! 1D comms
        TYPE_MPI_DATATYPE,      intent(in)      :: base_init_dtype  !! Base MPI datatype for real space data
        integer(int64),         intent(in)      :: base_init_storage!! Number of bytes needed to store single real element
        TYPE_MPI_DATATYPE,      intent(in)      :: base_dtype       !! Base MPI datatype for Fourier space data
        integer(int64),         intent(in)      :: base_storage     !! Number of bytes needed to store single complex element
        type(pencil),           intent(in)      :: bricks(:)        !! Pencils describing brick data distribution
        type(pencil),           intent(in)      :: pencils(:)       !! Array of pencil decompositions
        type(dtfft_stream_t),   intent(in)      :: stream           !! Stream to use
        integer(int64),         intent(in)      :: buffer_size      !! Size of the buffer to use during autotune (in bytes)
        type(dtfft_backend_t),  intent(in)      :: transpose_backend!! Backend used in transpose plans
        type(dtfft_backend_t),  intent(inout)   :: best_backend     !! Best backend selected
        type(dtfft_backend_t),  intent(out)     :: backends(SIDX:EIDX)        !! Forward backends
        type(dtfft_backend_t),  allocatable :: backends_to_run(:)
        type(dtfft_backend_t) :: current_backend_id
        real(real32) :: execution_time, best_time_
        integer(int32) :: b
        integer(int8)  :: r
        type(reshape_container), allocatable :: plans(:)
        logical :: nccl_enabled
#ifdef DTFFT_WITH_CUDA
        logical :: nvshmem_enabled
#endif
        character(len=:), allocatable :: testing_phase
        type(backend_helper)                      :: helper
        logical :: pipe_enabled, mpi_enabled, dtype_enabled, rma_enabled, fused_enabled
        logical :: compressed_enabled
#ifdef DTFFT_WITH_COMPRESSION
        type(dtfft_compression_config_t) :: conf
#endif
        logical :: is_adaptive
        real(real32) :: timers(SIDX:EIDX)

        allocate( backends_to_run, source=VALID_BACKENDS )

        nccl_enabled = .false.
#ifdef DTFFT_WITH_CUDA
        nccl_enabled = platform == DTFFT_PLATFORM_CUDA .and. get_conf_nccl_enabled()
        nvshmem_enabled = get_conf_nvshmem_enabled()
#endif

        call helper%create(platform, base_comm, comms, nccl_enabled, [bricks(1), bricks(2), pencils(1), pencils(size(pencils))])

        pipe_enabled = get_conf_pipelined_enabled()
        dtype_enabled = get_conf_datatype_enabled()
        mpi_enabled = get_conf_mpi_enabled()
        rma_enabled = get_conf_rma_enabled()
        fused_enabled = get_conf_fused_enabled()

        compressed_enabled = .false.

#ifdef DTFFT_WITH_COMPRESSION
        conf = get_conf_reshape()
        compressed_enabled = get_conf_compression_enabled() .and. conf%compression_mode == DTFFT_COMPRESSION_MODE_FIXED_RATE
#endif

        is_adaptive = best_backend == DTFFT_BACKEND_ADAPTIVE

        best_time_ = MAX_REAL32
        timers(:) = MAX_REAL32

        do b = 1, size(backends_to_run)
            current_backend_id = backends_to_run(b)
            if ( .not. is_backend_compatible(transpose_backend, current_backend_id) .and. transpose_backend /= DTFFT_BACKEND_ADAPTIVE ) cycle
            if ( is_backend_pipelined(current_backend_id) .and. .not.pipe_enabled ) cycle
            if ( is_backend_mpi(current_backend_id) .and. .not.mpi_enabled .and. .not.current_backend_id == DTFFT_BACKEND_MPI_DATATYPE ) cycle
            if ( current_backend_id == DTFFT_BACKEND_MPI_DATATYPE .and. .not.dtype_enabled ) cycle
            if ( is_backend_rma(current_backend_id) .and. .not.rma_enabled ) cycle
            if ( is_backend_fused(current_backend_id) .and. .not. fused_enabled) cycle
            if ( is_backend_compressed(current_backend_id) .and. .not. compressed_enabled ) cycle
            if ( current_backend_id == DTFFT_BACKEND_ADAPTIVE ) cycle
#ifdef DTFFT_WITH_CUDA
            if ( platform == DTFFT_PLATFORM_CUDA ) then
                if ( current_backend_id == DTFFT_BACKEND_MPI_DATATYPE ) cycle
                if ( is_backend_nvshmem(current_backend_id) .and. .not.nvshmem_enabled ) cycle
                if ( is_backend_nccl(current_backend_id) .and. .not.nccl_enabled) cycle
                ! DTFFT_BACKEND_CUFFTMP == DTFFT_BACKEND_CUFFTMP_PIPELINED for this plan
                if ( current_backend_id == DTFFT_BACKEND_CUFFTMP_PIPELINED ) cycle
            else
                if ( is_backend_nccl(current_backend_id) .or. is_backend_nvshmem(current_backend_id) ) cycle
            endif
#endif

            allocate( testing_phase, source="Testing backend "//dtfft_get_backend_string(current_backend_id) )
            REGION_BEGIN(testing_phase, COLOR_AUTOTUNE2)
            WRITE_INFO(testing_phase)

            if ( is_adaptive ) then
                do r = SIDX, EIDX
                    execution_time = autotune_adaptive(platform, current_backend_id, base_comm, comms, base_init_dtype, base_init_storage, base_dtype,  &
                        base_storage, bricks, pencils, stream, buffer_size, helper, r)
                    if ( execution_time < timers(r) ) then
                        timers(r) = execution_time
                        backends(r) = current_backend_id
                    endif
                enddo
            else
                call create_reshape_plans(plans, current_backend_id, platform, helper, DTFFT_ESTIMATE, .true., base_init_dtype, base_init_storage, base_dtype, base_storage, bricks, pencils)

                execution_time = execute_autotune(plans, base_comm, current_backend_id, platform, helper, stream, buffer_size, 4)
                if ( execution_time < best_time_ ) then
                    best_time_ = execution_time
                    best_backend = current_backend_id
                endif
                call destroy_plans(plans)
                deallocate( plans )
            endif

            REGION_END(testing_phase)
            deallocate(testing_phase)
        enddo

        call helper%destroy()

    end subroutine autotune_reshape_plan

    real(real32) function autotune_adaptive(platform, backend, base_comm, comms, base_init_dtype, base_init_storage, base_dtype, base_storage, bricks, pencils, stream,     &
        buffer_size, helper, plan_id) result(execution_time)

        type(dtfft_platform_t), intent(in)      :: platform         !! Platform to create plan for
        type(dtfft_backend_t),  intent(in)      :: backend
        TYPE_MPI_COMM,          intent(in)      :: base_comm        !! 3D Cartesian comm
        TYPE_MPI_COMM,          intent(in)      :: comms(:)         !! 1D comms
        TYPE_MPI_DATATYPE,      intent(in)      :: base_init_dtype  !! Base MPI datatype for real space data
        integer(int64),         intent(in)      :: base_init_storage!! Number of bytes needed to store single real element
        TYPE_MPI_DATATYPE,      intent(in)      :: base_dtype       !! Base MPI datatype for Fourier space data
        integer(int64),         intent(in)      :: base_storage     !! Number of bytes needed to store single complex element
        type(pencil),           intent(in)      :: bricks(:)        !! Pencils describing brick data distribution
        type(pencil),           intent(in)      :: pencils(:)       !! Array of pencil decompositions
        type(dtfft_stream_t),   intent(in)      :: stream           !! Stream to use
        integer(int64),         intent(in)      :: buffer_size      !! Size of the buffer to use during autotune (in bytes)
        type(backend_helper),   intent(inout)   :: helper
        integer(int8),          intent(in)      :: plan_id
        type(string) :: reshape
        type(reshape_container), allocatable :: plans(:)

        reshape = string("Reshape "//RESHAPE_NAMES(plan_id))
        REGION_BEGIN(reshape%raw, COLOR_AUTOTUNE)
        WRITE_INFO("  "//reshape%raw)
        call create_reshape_plans(plans, backend, platform, helper, DTFFT_ESTIMATE, .true., base_init_dtype, base_init_storage, &
            base_dtype, base_storage, bricks, pencils, plan_id=plan_id)

        execution_time = execute_autotune(plans, base_comm, backend, platform, helper, stream, buffer_size, 4)
        call destroy_plans(plans)
        REGION_END(reshape%raw)
        deallocate( plans )
        call reshape%destroy()
    end function autotune_adaptive
end module dtfft_reshape_plan

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_nvrtc_module_cache
!! Module that implements a cache for nvrtc modules
!! Cache is used to avoid recompilation of kernels with the same parameters
use iso_fortran_env
use iso_c_binding,                only: c_null_ptr
use dtfft_abstract_kernel,        only: kernel_type_t, get_kernel_string
use dtfft_errors
use dtfft_config
use dtfft_interface_cuda,         only: CUfunction
use dtfft_interface_cuda_runtime, only: device_props
use dtfft_nvrtc_block_optimizer,  only: kernel_config
use dtfft_nvrtc_module
use dtfft_utils
#include "_dtfft_private.h"
#include "_dtfft_mpi.h"
implicit none
private
public :: create_nvrtc_module, get_kernel_instance


  integer(int32), parameter         :: CACHE_PREALLOC_SIZE = 10
  !! Number of preallocated cache entries

  type :: nvrtc_module_cache
  !! Cache for nvrtc modules
  !!
  !! This type is used internally by the module and is not exposed to the user
  !! It maintains a list of compiled nvrtc modules and provides methods to add new modules
  !! and retrieve existing ones
  !!
  !! The cache automatically grows as needed
  private
    logical                         :: is_created = .false.     !! Flag that indicates if cache is created
    type(nvrtc_module), allocatable :: cache(:)                 !! Array of cached modules
    integer(int32)                  :: size                     !! Number of entries in cache
  contains
  private
    procedure,  pass(self) :: create    !! Creates cache
    procedure,  pass(self) :: add       !! Adds new entry to cache
  end type nvrtc_module_cache

  type(nvrtc_module_cache), save :: cache
  !! Cache instance

contains

  subroutine create(self)
  !! Creates cache
    class(nvrtc_module_cache),  intent(inout) :: self   !! Cache instance

    if (self%is_created) return
    allocate(self%cache(CACHE_PREALLOC_SIZE))
    self%size = 0
    self%is_created = .true.
  end subroutine create

  subroutine add(self, m)
  !! Adds new entry to cache
    class(nvrtc_module_cache),  intent(inout) :: self   !! Cache instance
    type(nvrtc_module),         intent(in)    :: m      !! Module to add
    type(nvrtc_module),  allocatable  :: temp(:)        !! Temporary cache

    call cache%create()

    if ( self%size == size(self%cache) ) then
      allocate( temp(self%size + CACHE_PREALLOC_SIZE) )
      temp(1:self%size) = self%cache(1:cache%size)
      deallocate( self%cache )
      call move_alloc(temp, self%cache)
    endif

    self%size = self%size + 1
    self%cache(self%size) = m
    WRITE_DEBUG('Added to cache: size = '//to_str(self%size))
  end subroutine add

  subroutine create_nvrtc_module(ndims, kernel_type, base_storage, configs, props)
  !! Creates and adds a new nvrtc module to the cache if it does not already exist
    integer(int32),       intent(in)    :: ndims              !! Number of dimensions (2 or 3)
    type(kernel_type_t),  intent(in)    :: kernel_type        !! Type of kernel to build
    integer(int64),       intent(in)    :: base_storage       !! Number of bytes needed to store single element
    type(kernel_config),  intent(in)    :: configs(:)         !! Array of kernel configurations to build
    type(device_props),   intent(in)    :: props              !! GPU architecture properties
    integer(int32)                    :: i                  !! Loop counter
    integer(int32)                    :: j                  !! Loop counter
    integer(int32)                    :: k                  !! Loop counter for number of new configs to add
    logical                           :: is_found           !! Flag that indicates if module with required kernel_type was found
    logical                           :: is_instance_found  !! Flag that indicates if specific kernel instance was found
    type(nvrtc_module)                :: m                  !! New module to create
    type(kernel_config), allocatable  :: configs_to_add(:)  !! Configurations that need to be added
    type(string) :: str

    is_found = .false.
    do i = 1, cache%size
      is_found = cache%cache(i)%check(ndims, kernel_type, base_storage)
      if ( is_found ) exit
    enddo

    str = get_kernel_string(kernel_type)

    k = 0
    if ( is_found ) then
      ! Found at least one module with required kernel_type
      ! Now need to loop over all modules once again and check if required configs are present in any of them
      allocate( configs_to_add(size( configs )) )

      do j = 1, size(configs)
        is_instance_found = .false.
        do i = 1, cache%size
          is_instance_found = cache%cache(i)%check(ndims, kernel_type, base_storage, configs(j)%tile_size, configs(j)%block_rows)
          if ( is_instance_found ) exit
        enddo
        if ( .not. is_instance_found ) then
          k = k + 1
          configs_to_add(k)%tile_size = configs(j)%tile_size
          configs_to_add(k)%block_rows = configs(j)%block_rows
          configs_to_add(k)%padding = configs(j)%padding
          WRITE_DEBUG("Adding new: "//to_str(configs(j)%tile_size)//"x"//to_str(configs(j)%block_rows)//": "//to_str(configs(j)%padding))
        endif
      enddo
      if ( k > 0 ) then
        WRITE_DEBUG("Adding "//to_str(k)//" new kernel configurations for module '"//str%raw//"'")
        call m%create(ndims, kernel_type, base_storage, configs_to_add(1:k), props)
      endif
      deallocate( configs_to_add )
    else
      WRITE_DEBUG("Adding new module with following configs for '"//str%raw//"'")
      do j = 1, size(configs)
        WRITE_DEBUG(to_str(configs(j)%tile_size)//"x"//to_str(configs(j)%block_rows)//": "//to_str(configs(j)%padding))
      enddo
      call m%create(ndims, kernel_type, base_storage, configs, props)
    endif

    call str%destroy()
    if ( k == 0 .and. is_found ) return
    call cache%add(m)
  end subroutine create_nvrtc_module

  function get_kernel_instance(ndims, kernel_type, base_storage, tile_size, block_rows) result(fun)
  !! Retrieves a kernel instance from the cache
  !! If the instance is not found, an error is raised
    integer(int32),       intent(in)    :: ndims              !! Number of dimensions (2 or 3)
    type(kernel_type_t),  intent(in)    :: kernel_type        !! Type of kernel to build
    integer(int64),       intent(in)    :: base_storage       !! Number of bytes needed to store single element
    integer(int32),       intent(in)    :: tile_size          !! Tile size (number of columns)
    integer(int32),       intent(in)    :: block_rows         !! Block rows
    type(CUfunction)                    :: fun                !! Retrieved kernel instance
    integer(int32)  :: ierr
    logical         :: is_found !! Flag that indicates if instance was found
    integer(int32)  :: i        !! Loop counter
    type(string) :: str

    if ( .not. cache%is_created ) then
      INTERNAL_ERROR("get_kernel_instance: cache not created")
    endif
    is_found = .false.
    do i = 1, cache%size
      ierr = cache%cache(i)%get(ndims, kernel_type, base_storage, tile_size, block_rows, fun)
      if ( ierr == DTFFT_SUCCESS ) return
    enddo
    str = get_kernel_string(kernel_type)
    WRITE_DEBUG("Kernel = "//str%raw//": "//to_str(tile_size)//"x"//to_str(block_rows))
    INTERNAL_ERROR("get_kernel_instance: unable to retrive function from cache")
  end function get_kernel_instance
end module dtfft_nvrtc_module_cache

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
program test_c2c_3d
use iso_fortran_env
use iso_c_binding
use dtfft
use iso_c_binding
use test_utils
#if defined(DTFFT_WITH_CUDA)
use dtfft_interface_cuda_runtime
#endif
#include "_dtfft_cuda.h"
#include "_dtfft_mpi.h"
#include "dtfft.f03"
implicit none
  complex(real64),  pointer :: inout(:,:,:), aux(:)
  type(c_ptr) :: check
#if defined(DTFFT_WITH_CUDA) && !defined(DTFFT_RUNNING_CICD) && !defined(DTFFT_WITH_MOCK_ENABLED)
  integer(int32), parameter :: nx = 255, ny = 333, nz = 135
#else
  integer(int32), parameter :: nx = 129, ny = 99, nz = 33
#endif
  integer(int32) :: comm_size, comm_rank, ierr
  type(dtfft_executor_t) :: executor
  type(dtfft_plan_c2c_t) :: plan
  integer(int32) :: in_counts(3), out_counts(3), iter
  integer(int64)  :: alloc_size, aux_size, element_size, in_size, out_size
  real(real64) :: ts, tf, tb
#if defined(DTFFT_WITH_CUDA)
  type(dtfft_stream_t)  :: stream
  type(dtfft_platform_t) :: platform
#endif
  type(dtfft_backend_t) :: selected_backend
  type(dtfft_config_t) :: conf

  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, comm_size, ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)

  if(comm_rank == 0) then
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a)') "|       dtFFT test: c2c_3d             |"
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a, i0, a, i0, a, i0)') 'Nx = ',nx, ', Ny = ',ny, ', Nz = ',nz
    write(output_unit, '(a, i0)') 'Number of processors: ', comm_size
    write(output_unit, '(a)') "----------------------------------------"
  endif

#if defined(DTFFT_WITH_MKL)
  executor = DTFFT_EXECUTOR_MKL
#elif defined (DTFFT_WITH_FFTW)
  executor = DTFFT_EXECUTOR_FFTW3
#else
  executor = DTFFT_EXECUTOR_NONE
#endif

#ifdef DTFFT_WITH_CUDA
  block
    character(len=5) :: platform_env
    integer(int32) :: env_len

    call get_environment_variable("DTFFT_PLATFORM", platform_env, env_len)

    if ( env_len == 0 .or. trim(adjustl(platform_env)) == "cuda" ) then
# if defined( DTFFT_WITH_VKFFT )
      executor = DTFFT_EXECUTOR_VKFFT
# elif defined( DTFFT_WITH_CUFFT )
      executor = DTFFT_EXECUTOR_CUFFT
# else
      executor = DTFFT_EXECUTOR_NONE
# endif
    endif
  endblock
#endif

  call attach_gpu_to_process()

  conf = dtfft_config_t()

#if defined(DTFFT_WITH_CUDA)
  conf%platform = DTFFT_PLATFORM_CUDA
#endif

  conf%enable_datatype_backend = .false.
  conf%enable_mpi_backends = .true.
! #ifdef DTFFT_WITH_COMPRESSION
!   conf%backend = DTFFT_BACKEND_MPI_P2P_COMPRESSED
!   conf%compression_config_transpose%compression_mode = DTFFT_COMPRESSION_MODE_FIXED_RATE
!   conf%compression_config_transpose%rate = 50.0
! #endif
  call dtfft_set_config(conf, error_code=ierr); DTFFT_CHECK(ierr)

  ! Setting effort=DTFFT_PATIENT will ignore value of `conf%backend` and will run autotune to find best backend
  ! Fastest backend will be selected
  call plan%create([nx, ny, nz], executor=executor, effort=DTFFT_EXHAUSTIVE, error_code=ierr); DTFFT_CHECK(ierr)
  call plan%get_local_sizes(in_counts=in_counts, out_counts=out_counts, error_code=ierr); DTFFT_CHECK(ierr)
  alloc_size = plan%get_alloc_size(ierr); DTFFT_CHECK(ierr)
  aux_size = plan%get_aux_size(ierr); DTFFT_CHECK(ierr)
  element_size = plan%get_element_size(ierr); DTFFT_CHECK(ierr)
  in_size = product(in_counts)
  out_size = product(out_counts)

  call plan%report()

  if ( element_size /= 16_int64 ) error stop "element_size /= 16_int64"

#if defined(DTFFT_WITH_CUDA)
  platform = plan%get_platform(ierr); DTFFT_CHECK(ierr)

  if ( platform == DTFFT_PLATFORM_CUDA ) then
    call plan%get_stream(stream, error_code=ierr); DTFFT_CHECK(ierr)
  endif
#endif

  selected_backend = plan%get_backend(error_code=ierr); DTFFT_CHECK(ierr)
  if(comm_rank == 0) then
    write(output_unit, '(a)') "Selected backend: '"//dtfft_get_backend_string(selected_backend)//"'"
  endif

  call plan%mem_alloc(alloc_size, inout, in_counts, error_code=ierr); DTFFT_CHECK(ierr)
  call plan%mem_alloc(aux_size, aux, error_code=ierr); DTFFT_CHECK(ierr)

  check = mem_alloc_host(in_size * element_size)
  call setTestValuesComplexDouble(check, in_size)


#if defined(DTFFT_WITH_CUDA)
  platform = plan%get_platform(error_code=ierr); DTFFT_CHECK(ierr)
  call complexDoubleH2D(check, c_loc(inout), in_size, platform%val)
#else
  call complexDoubleH2D(check, c_loc(inout), in_size)
#endif


  tf = 0.0_real64
  tb = 0.0_real64
  do iter = 1, 10
    ts = - MPI_Wtime()

    call plan%execute(inout, inout, DTFFT_EXECUTE_FORWARD, aux, error_code=ierr);  DTFFT_CHECK(ierr)

#if defined(DTFFT_WITH_CUDA)
    if ( platform == DTFFT_PLATFORM_CUDA ) then
      CUDA_CALL( cudaStreamSynchronize(stream) )
    endif
#endif
    tf = tf + ts + MPI_Wtime()

#if defined(DTFFT_WITH_CUDA)
  call scaleComplexDouble(executor%val, c_loc(inout), int(product(out_counts), int64), int(nx * ny * nz, int64), platform%val, stream)
#else
  call scaleComplexDouble(executor%val, c_loc(inout), int(product(out_counts), int64), int(nx * ny * nz, int64))
#endif

    ts = 0.0_real64 - MPI_Wtime()
    call plan%execute(inout, inout, DTFFT_EXECUTE_BACKWARD, aux, error_code=ierr); DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
    if ( platform == DTFFT_PLATFORM_CUDA ) then
      CUDA_CALL( cudaStreamSynchronize(stream) )
    endif
#endif
    tb = tb + ts + MPI_Wtime()
  enddo
! #ifdef DTFFT_WITH_COMPRESSION
!   call plan%report_compression()
! #endif

#if defined(DTFFT_WITH_CUDA) && !defined(DTFFT_WITH_MOCK_ENABLED)
  call checkAndReportComplexDouble(int(nx * ny * nz, int64), tf, tb, c_loc(inout), in_size, check, platform%val)
#else
  call checkAndReportComplexDouble(int(nx * ny * nz, int64), tf, tb, c_loc(inout), in_size, check)
#endif

  call plan%mem_free(inout, error_code=ierr); DTFFT_CHECK(ierr)
  call plan%mem_free(aux, error_code=ierr); DTFFT_CHECK(ierr)

  call mem_free_host(check)

  call plan%destroy()
  call MPI_Finalize(ierr)
end program test_c2c_3d

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_pencil
!! This module describes private [[pencil]] and public [[dtfft_pencil_t]] classes
use iso_fortran_env
use iso_c_binding
use dtfft_config
use dtfft_errors
use dtfft_parameters
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
#ifdef DTFFT_WITH_CUDA
use dtfft_interface_cuda_runtime
#include "_dtfft_cuda.h"
#endif
implicit none
private
public :: pencil, pencil_init
public :: dtfft_pencil_t, dtfft_pencil_c
public :: get_local_sizes, get_float_buffer_size
public :: get_transpose_type, get_reshape_type
public :: pencil_c2f, pencil_f2c

  type :: dtfft_pencil_t
  !! Structure to hold pencil decomposition info
    integer(int8)               :: dim
      !! Aligned dimension id
    integer(int8)               :: ndims = 0
      !! Number of dimensions
    integer(int32), allocatable :: starts(:)
      !! Local starts, starting from 0 for both C and Fortran
    integer(int32), allocatable :: counts(:)
      !! Local counts of data, in elements
    integer(int64)              :: size
      !! Total number of elements in a pencil
    logical,        private     :: is_created = .false.
      !! Is pencil created
  contains
    ! final :: destroy_pencil_t !! Finalizer
    procedure, pass(self) :: destroy => destroy_pencil_t
      !! Destroys pencil
  end type dtfft_pencil_t

  interface dtfft_pencil_t
  !! Type bound constuctor for dtfft_pencil_t
    module procedure create_pencil_t    !! Creates pencil object, that can be used to create dtFFT plans
  end interface dtfft_pencil_t

  type, bind(C) :: dtfft_pencil_c
  !! Structure to hold pencil decomposition info
    integer(c_int8_t)   :: dim        !! Aligned dimension id
    integer(c_int8_t)   :: ndims      !! Number of dimensions
    integer(c_int32_t)  :: starts(3)  !! Local starts, starting from 0 for both C and Fortran
    integer(c_int32_t)  :: counts(3)  !! Local counts of data, in elements
    integer(c_size_t)   :: size       !! Total number of elements in a pencil
  end type dtfft_pencil_c

  type :: pencil
  !! Class that describes information about data layout
    integer(int8)                :: aligned_dim       !! Position of aligned dimension. For example: X pencil aligned_dim = 1, Z pencil aligned_dim = 3
    integer(int8)                :: rank              !! Rank of buffer: 2 or 3
    integer(int32), allocatable  :: starts(:)         !! Local starts, starting from 0 for both C and Fortran
    integer(int32), allocatable  :: counts(:)         !! Local counts of data, in elements
    logical                      :: is_even           !! Is data evenly distributed across processes
    logical                      :: is_distributed    !! Is aligned data distributed across multiple processes
  contains
  private
    procedure, pass(self),  public  :: create         !! Creates pencil
    procedure, pass(self),  public  :: destroy        !! Destroys pencil
    ! procedure, pass(self),  public  :: output         !! Writes pencil data to stdout
    !                                                   !! Used only for debugging purposes
    procedure, pass(self),  public  :: make_public    !! Creates public object that users can use to create own FFT backends
  end type pencil

  type :: pencil_init
  !! Class that describes information about data layout
  !!
  !! It is an extension of dtfft_pencil_t with additional fields
    TYPE_MPI_COMM,  allocatable :: comms(:)     !! 1D communicators for each dimension
    integer(int32), allocatable :: starts(:)    !! Local starts
    integer(int32), allocatable :: counts(:)    !! Local counts
    integer(int32), allocatable :: dims(:)      !! Global dimensions of entire region
  contains
  private
    procedure, pass(self),  public  :: create => create_pencil_init   !! Creates and validates pencil passed by user to plan constructors
    procedure, pass(self),  public  :: destroy => destroy_pencil_init !! Destroys pencil_init
    procedure, pass(self),  public  :: from_bricks                    !! Creates pencil_init from brick decomposition
  end type pencil_init

contains
  subroutine create(self, rank, aligned_dim, counts, comms, lstarts, lcounts, is_distributed)
  !! Creates pencil
    class(pencil),                  intent(inout) :: self             !! Pencil
    integer(int8),                  intent(in)    :: rank             !! Rank of buffer
    integer(int8),                  intent(in)    :: aligned_dim      !! Position of aligned dimension
    integer(int32),                 intent(in)    :: counts(:)        !! Global counts
    TYPE_MPI_COMM,                  intent(in)    :: comms(:)         !! Grid communicators
    integer(int32),       optional, intent(in)    :: lstarts(:)       !! Local starts
    integer(int32),       optional, intent(in)    :: lcounts(:)       !! Local counts
    logical,              optional, intent(in)    :: is_distributed    !! Is data distributed
    ! integer(int8),        optional, intent(in)    :: dim_to_keep
    integer(int8)                     :: d                !! Counter
    logical, allocatable              :: is_even(:)       !! Even distribution flag
    integer(int8)               :: comm_id
    integer(int32), allocatable :: starts(:), sizes(:)
    integer(int32) :: fast_comm_size, ierr
    logical :: is_distributed_
    integer(int32) :: start, count
    logical :: one, two, three

    call self%destroy()
    allocate(sizes(rank))
    allocate(starts(rank))
    allocate(is_even(rank))
    self%aligned_dim = aligned_dim
    self%rank = rank
    is_distributed_ = .false.; if ( present(is_distributed) ) is_distributed_ = is_distributed
    if ( present(lstarts) .and. present(lcounts) ) then
      if ( aligned_dim == 1 ) then
        if ( is_distributed_ ) then
          do d = 1, rank
            call get_local_size(counts(d), comms(d), starts(d), sizes(d))
          enddo
        else
          starts(:) = lstarts(:)
          sizes(:) = lcounts(:)
        endif
      else
        do d = 1, rank
          if ( rank == 3 ) then
            one = aligned_dim == 2 .and. d == 2
            two = aligned_dim == 3 .and. d == 2
            three = aligned_dim == 3 .and. d == 2 .and. is_distributed_
            if ( one .or. two .or. three) then
              if ( one .or. two ) then
                start = lstarts(3)
                count = lcounts(3)
              else
                start = lstarts(2)
                count = lcounts(2)
              endif
              call get_local_size(counts(d), comms(d), starts(d), sizes(d), start, count)
            else
              call get_local_size(counts(d), comms(d), starts(d), sizes(d))
            endif


            ! if ( aligned_dim == 2 .and. d == 2 ) then
            !   call get_local_size(counts(d), comms(3), starts(d), sizes(d), lstarts(3), lcounts(3))
            ! else if ( aligned_dim == 2 .and. d == 3 ) then
            !   call get_local_size(counts(d), comms(2), starts(d), sizes(d))
            ! else if ( aligned_dim == 3 .and. d == 2 .and. is_distributed_) then
            !   call get_local_size(counts(d), comms(d), starts(d), sizes(d), lstarts(2), lcounts(2))
            ! else if ( aligned_dim == 3 .and. d == 2 ) then
            !   call get_local_size(counts(d), comms(2), starts(d), sizes(d), lstarts(3), lcounts(3))

            ! else
            !   call get_local_size(counts(d), comms(d), starts(d), sizes(d))
            ! endif
          else
            call get_local_size(counts(d), comms(d), starts(d), sizes(d))
          endif
        enddo
      endif
    else
      do d = 1, rank
        ! comm_id = d
        ! if ( .not. is_distributed_ ) then
        !   if ( rank == 3 ) then
        !     if ( aligned_dim == 2 .and. d == 2 ) then
        !       comm_id = 3
        !     else if ( aligned_dim == 2 .and. d == 3 ) then
        !       comm_id = 2
        !     endif
        !   endif
        ! endif
        call get_local_size(counts(d), comms(d), starts(d), sizes(d))
      enddo
    endif
    do d = 1, rank
      ! comm_id = d
      ! if ( .not. is_distributed_ ) then
      !   if ( rank == 3 ) then
      !     if ( aligned_dim == 2 .and. d == 2 ) then
      !       comm_id = 3
      !     else if ( aligned_dim == 2 .and. d == 3 ) then
      !       comm_id = 2
      !     endif
      !   endif
      ! endif
      is_even(d) = check_if_even(sizes(d), comms(d))
    enddo
    allocate(self%counts(rank))
    allocate(self%starts(rank))
    do d = 1, rank
      ! order_ = d
      ! if ( present(order) ) order_ = order(d)
      self%counts(d) = sizes(d)
      self%starts(d) = starts(d)
    enddo
    self%is_even = all(is_even)
    deallocate(is_even, starts, sizes)

    call MPI_Comm_size(comms(1), fast_comm_size, ierr)
    allocate( starts(fast_comm_size) )
    call MPI_Allgather(self%starts(1), 1, MPI_INTEGER, starts, 1, MPI_INTEGER, comms(1), ierr)
    self%is_distributed = any( starts /= starts(1) )
    deallocate( starts )
  end subroutine create

  subroutine destroy(self)
  !! Destroys pencil
    class(pencil),      intent(inout) :: self             !! Pencil

    if ( allocated(self%counts) ) deallocate(self%counts)
    if ( allocated(self%starts) ) deallocate(self%starts)
  end subroutine destroy

  subroutine get_local_size(n_global, comm, start, count, start_to_keep, size_to_keep)
  !! Computes local portions of data based on global count and position inside grid communicator
    integer(int32),           intent(in)  :: n_global             !! Global number of points
    TYPE_MPI_COMM,            intent(in)  :: comm                 !! Grid communicator
    integer(int32),           intent(out) :: start                !! Local start
    integer(int32),           intent(out) :: count                !! Local count
    integer(int32), optional, intent(in)  :: start_to_keep  !! Start to keep in case of user defined decomposition
    integer(int32), optional, intent(in)  :: size_to_keep   !! Size to keep in case of user defined decomposition
    integer(int32), allocatable   :: shift(:)             !! Work buffer
    integer(int32)                :: comm_dim             !! Number of MPI processes along n_global
    integer(int32)                :: comm_rank            !! Rank of current MPI process
    integer(int32)                :: res                  !! Residual from n_global / comm_dim
    integer(int32)                :: i                    !! Counter
    integer(int32)                :: ierr                 !! Error code

    call MPI_Comm_size(comm, comm_dim, ierr)
    call MPI_Comm_rank(comm, comm_rank, ierr)

    res = mod(n_global, comm_dim)
    start = 0

    if ( comm_dim == 1 ) then
      count = n_global
      return
    elseif( present(size_to_keep) ) then
      count = size_to_keep
    elseif ( comm_rank >= comm_dim - res ) then
      count = int(n_global / comm_dim, int32) + 1
    else
      count = int(n_global / comm_dim, int32)
    endif
    if ( present(start_to_keep) ) then
      start = start_to_keep
    else
      allocate( shift(comm_dim) )
      call MPI_Allgather(count, 1, MPI_INTEGER, shift, 1, MPI_INTEGER, comm, ierr)

      do i = 0, comm_rank - 1
        start = start + shift(i + 1)
      end do
      deallocate(shift)
    endif
  end subroutine get_local_size

  logical function check_if_even(count, comm)
  !! Checks if data is evenly distributed across processes
    integer(int32), intent(in)    :: count                !! Local count
    TYPE_MPI_COMM,  intent(in)    :: comm                 !! Grid communicator
    integer(int32)                :: comm_size            !! Number of MPI processes
    integer(int32), allocatable   :: shift(:)             !! Work buffer
    integer(int32)                :: ierr                 !! Error code

    call MPI_Comm_size(comm, comm_size, ierr)

    if ( comm_size == 1 ) then
      check_if_even = .true.
      return
    end if
    allocate( shift(comm_size) )
    call MPI_Allgather(count, 1, MPI_INTEGER, shift, 1, MPI_INTEGER, comm, ierr)
    check_if_even = all(shift == shift(1))
    deallocate(shift)
  end function check_if_even

!   subroutine output(self, name, vec)
!   !! Writes pencil data to stdout
!     class(pencil),                intent(in)  :: self                 !! Pencil
!     character(len=*),             intent(in)  :: name                 !! Name of pencil
!     type(c_ptr),    intent(in) :: vec
!     ! real(real32),    target,      intent(in)  :: vec(:)               !! Device pointer to data
!     integer(int32)                            :: iter                 !! Iteration counter
!     integer(int32)                            :: i,j,k,ijk            !! Counters
!     integer(int32)                            :: comm_size            !! Number of MPI processes
!     integer(int32)                            :: comm_rank            !! Rank of current MPI process
!     integer(int32)                            :: ierr                 !! Error code
! #ifdef DTFFT_WITH_CUDA
!     real(real32),    target,      allocatable :: buf(:)               !! Host buffer
! #else
!     real(real32),   pointer,  contiguous      :: buf(:)
! #endif

!     call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)
!     call MPI_Comm_size(MPI_COMM_WORLD, comm_size, ierr)

! #ifdef DTFFT_WITH_CUDA
!     allocate( buf( product(self%counts) ) )
!     ! if ( is_device_ptr(c_loc(vec)) ) then
!     if ( is_device_ptr(vec) ) then
!       CUDA_CALL( cudaDeviceSynchronize())
!       CUDA_CALL( cudaMemcpy(c_loc(buf), vec, int(real32, int64) * product(self%counts), cudaMemcpyDeviceToHost) )
!     endif
! #else
!     call c_f_pointer(vec, buf, [product(self%counts)])
! #endif

!     do iter = 0, comm_size - 1
!       call MPI_Barrier(MPI_COMM_WORLD, ierr)
!       ! if ( iter == comm_rank .and. comm_rank == 0) then
!       if ( iter == comm_rank) then
!         write(output_unit,'(a)') name
!         write(output_unit, '(a)', advance="no") repeat(' ', 5)
!         do i = 0, self%counts(1) - 1
!           write(output_unit, '(i11)', advance="no") self%starts(1) + i
!         enddo
!         write(output_unit, "(a)") ""
!         do k = 0, self%counts(3) - 1
!           do j = 0, self%counts(2) - 1
!             ijk = k * self%counts(2) * self%counts(1) + j * self%counts(1)
!             write(output_unit,'(2i5, *(f11.2))') self%starts(2) + j, self%starts(3) + k, (buf(ijk + i + 1), i=0,self%counts(1) - 1)
!           enddo
!           write(output_unit, '(a)') ' '
!           flush(output_unit)
!         enddo
!         write(output_unit, '(a)') ' '
!         write(output_unit, '(a)') ' '
!         flush(output_unit)
!       endif
!       call MPI_Barrier(MPI_COMM_WORLD, ierr)
!     enddo

! #ifdef DTFFT_WITH_CUDA
!     deallocate(buf)
! #endif
!   end subroutine output

  type(dtfft_pencil_t) function make_public(self)
  !! Creates public object that users can use to create own FFT backends
    class(pencil),  intent(in)  :: self                 !! Pencil
    integer(int8) :: i  !! Counter

    make_public%dim = self%aligned_dim
    make_public%ndims = self%rank
    if ( allocated(make_public%counts) ) deallocate( make_public%counts )
    if ( allocated(make_public%starts) ) deallocate( make_public%starts )
    allocate(make_public%counts(1:self%rank), source=self%counts)
    allocate(make_public%starts(1:self%rank), source=self%starts)

    make_public%size = 1_int64
    do i = 1, make_public%ndims
      make_public%size = make_public%size * int(make_public%counts(i), int64)
    enddo
  end function make_public

  type(dtfft_pencil_t) function create_pencil_t(starts, counts)
  !! Creates pencil object, that can be used to create dtFFT plans
    integer(int32), intent(in)    :: starts(:)         !! Local starts, starting from 0 for both C and Fortran
    integer(int32), intent(in)    :: counts(:)         !! Local counts of data, in elements

    call create_pencil_t%destroy()
    create_pencil_t%ndims = size(starts, kind=int8)
    allocate(create_pencil_t%starts, source=starts)
    allocate(create_pencil_t%counts, source=counts)
    create_pencil_t%is_created = .true.
  end function  create_pencil_t

  subroutine destroy_pencil_t(self)
  !! Destroys pencil
    class(dtfft_pencil_t), intent(inout) :: self !! Public pencil

    if ( allocated(self%counts) ) deallocate( self%counts )
    if ( allocated(self%starts) ) deallocate( self%starts )
    self%dim = -1
    self%ndims = -1
    self%size = -1
    self%is_created = .false.
  end subroutine destroy_pencil_t

  ! subroutine destroy_pencil_t(self)
  ! !! Destroys pencil
  !   type(dtfft_pencil_t), intent(inout) :: self !! Public pencil

  !   call self%destroy()
  ! end subroutine destroy_pencil_t

  subroutine pencil_f2c(pencil, c_pencil)
  !! Converts Fortran pencil to C pencil
    type(dtfft_pencil_t), intent(in)  :: pencil     !! Fortran pencil
    type(dtfft_pencil_c), intent(out) :: c_pencil   !! C pencil

    c_pencil%dim = pencil%dim
    c_pencil%ndims = pencil%ndims
    c_pencil%size = pencil%size
    c_pencil%starts(1:pencil%ndims) = pencil%starts(:)
    c_pencil%counts(1:pencil%ndims) = pencil%counts(:)
  end subroutine pencil_f2c

  subroutine pencil_c2f(c_pencil, pencil, error_code)
  !! Converts C pencil to Fortran pencil
    type(dtfft_pencil_c), intent(in)  :: c_pencil   !! C pencil
    type(dtfft_pencil_t), intent(out) :: pencil     !! Fortran pencil
    integer(int32),       intent(out) :: error_code !! Error code

    error_code = DTFFT_SUCCESS
    if ( .not. any(c_pencil%ndims == [2, 3]) ) then
      error_code = DTFFT_ERROR_PENCIL_NOT_INITIALIZED
      return
    endif

    pencil = dtfft_pencil_t(c_pencil%starts(1:c_pencil%ndims), c_pencil%counts(1:c_pencil%ndims))
  end subroutine pencil_c2f

  subroutine get_local_sizes(pencils, in_starts, in_counts, out_starts, out_counts, alloc_size, is_y_slab)
  !! Obtain local starts and counts in `real` and `fourier` spaces
    type(pencil),             intent(in)  :: pencils(:)             !! Array of pencils
    integer(int32), optional, intent(out) :: in_starts(:)           !! Start indexes in `real` space (0-based)
    integer(int32), optional, intent(out) :: in_counts(:)           !! Number of elements in `real` space
    integer(int32), optional, intent(out) :: out_starts(:)          !! Start indexes in `fourier` space (0-based)
    integer(int32), optional, intent(out) :: out_counts(:)          !! Number of elements in `fourier` space
    integer(int64), optional, intent(out) :: alloc_size             !! Minimal number of elements required to execute plan
    logical,        optional, intent(in)  :: is_y_slab              !! Is Y-slab optimization used
    integer(int8)                         :: d                      !! Counter
    integer(int8)                         :: ndims                  !! Number of dimensions
    logical                               :: is_y_slab_             !! Is Y-slab optimization used
    integer(int8)                         :: out_dim                !! Aligned dimension of output pencil
    integer(int8)                         :: n_pencils

    ndims = size(pencils(1)%counts, kind=int8)
    n_pencils = size(pencils, kind=int8)
    is_y_slab_ = .false.; if ( present(is_y_slab) ) is_y_slab_ = is_y_slab
    out_dim = min(ndims, n_pencils)
    if ( is_y_slab_ .and. ndims == 3 ) out_dim = 2
    if ( present(in_starts) )  in_starts(1:ndims)   = pencils(1)%starts(1:ndims)
    if ( present(in_counts) )  in_counts(1:ndims)   = pencils(1)%counts(1:ndims)
    if ( present(out_starts) ) out_starts(1:ndims)  = pencils(out_dim)%starts(1:ndims)
    if ( present(out_counts) ) out_counts(1:ndims)  = pencils(out_dim)%counts(1:ndims)
    if ( present(alloc_size) ) alloc_size = maxval([(product(pencils(d)%counts), d=1,n_pencils)])
  end subroutine get_local_sizes

  pure function get_transpose_type(send, recv) result(transpose_type)
  !! Determines transpose ID based on pencils
    type(pencil),     intent(in)  :: send           !! Send pencil
    type(pencil),     intent(in)  :: recv           !! Receive pencil
    type(dtfft_transpose_t)       :: transpose_type !! Transpose ID

    transpose_type = dtfft_transpose_t(0)
    if (send%aligned_dim == 1 .and. recv%aligned_dim == 2) then
      transpose_type = DTFFT_TRANSPOSE_X_TO_Y
    else if (recv%aligned_dim == 1 .and. send%aligned_dim == 2) then
      transpose_type = DTFFT_TRANSPOSE_Y_TO_X
    else if (send%aligned_dim == 1 .and. recv%aligned_dim == 3) then
      transpose_type = DTFFT_TRANSPOSE_X_TO_Z
    else if (recv%aligned_dim == 1 .and. send%aligned_dim == 3) then
      transpose_type = DTFFT_TRANSPOSE_Z_TO_X
    else if (send%aligned_dim == 2 .and. recv%aligned_dim == 3) then
      transpose_type = DTFFT_TRANSPOSE_Y_TO_Z
    else if (recv%aligned_dim == 2 .and. send%aligned_dim == 3) then
      transpose_type = DTFFT_TRANSPOSE_Z_TO_Y
    endif
  end function get_transpose_type

  pure function get_reshape_type(send, recv) result(reshape_type)
  !! Determines reshape ID based on pencils
    type(pencil),     intent(in)  :: send           !! Send pencil
    type(pencil),     intent(in)  :: recv           !! Receive pencil
    type(dtfft_reshape_t)         :: reshape_type   !! Reshape ID

    reshape_type = dtfft_reshape_t(0)
    if (send%aligned_dim == 1 .and. recv%aligned_dim == 1) then
      if ( send%is_distributed ) then
        reshape_type = DTFFT_RESHAPE_X_BRICKS_TO_PENCILS
      else
        reshape_type = DTFFT_RESHAPE_X_PENCILS_TO_BRICKS
      end if
    else
      if ( recv%is_distributed ) then
        reshape_type = DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS
      else
        reshape_type = DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS
      endif
    endif
  end function get_reshape_type

  integer(int64) function get_float_buffer_size(p1, p2, base_storage)
    type(pencil),     intent(in)  :: p1           !! First pencil
    type(pencil),     intent(in)  :: p2           !! Second pencil
    integer(int64),   intent(in)  :: base_storage
    integer(int64) :: scaler

    scaler = base_storage / FLOAT_STORAGE_SIZE
    call get_local_sizes([p1, p2], alloc_size=get_float_buffer_size)
    get_float_buffer_size = get_float_buffer_size * scaler
  end function get_float_buffer_size

  function from_bricks(self, platform, bricks, comm) result(error_code)
    class(pencil_init),     intent(inout) :: self
    type(dtfft_platform_t), intent(in)  :: platform       !! Platform to create plan for
    type(pencil_init),      intent(in)  :: bricks
    TYPE_MPI_COMM,          intent(in)  :: comm         !! MPI Communicator passed to plan constructors
    integer(int32)                        :: error_code   !! Error code
    integer(int32) :: top_type, ierr, comm_rank
    logical :: is_nice_grid_found
    integer(int8)     :: ndims      !! Number of dimensions
    integer(int32),   allocatable   :: comm_dims(:)   !! Dims in cartesian communicator
    integer(int32),   allocatable   :: pencil_dims(:), pencil_starts(:)
    TYPE_MPI_COMM,    allocatable   :: pencil_comms(:)
    integer(int8)     :: d
    integer(int32) :: i, y_size, z_size, tile_size, fast_dim_size
    integer(int32) :: a_rank, b_rank, c_rank, bb_rank, cc_rank
    integer(int32) :: ay, az
    integer(int32) :: color, key
    type(pencil) :: temp_pencil

    error_code = DTFFT_SUCCESS

    call MPI_Topo_test(comm, top_type, ierr)

    ndims = size(bricks%dims, kind=int8)
    allocate( comm_dims(ndims) )
    do d = 1, ndims
      call MPI_Comm_size(bricks%comms(d), comm_dims(d), ierr)
    enddo
    fast_dim_size = comm_dims(1)
    call MPI_Comm_rank(comm, comm_rank, ierr)

    tile_size = 4 ! for no reason at all
#ifdef DTFFT_WITH_CUDA
    if ( platform == DTFFT_PLATFORM_CUDA ) then
      tile_size = DEF_TILE_SIZE
    endif
#endif

    if ( top_type == MPI_CART .and. ndims == 3 ) then
      block
        integer(int32)                 :: grid_ndims           ! Number of dims in user defined cartesian communicator
        integer(int32),  allocatable   :: temp_dims(:)         ! Temporary dims needed by MPI_Cart_get
        integer(int32),  allocatable   :: temp_coords(:)       ! Temporary coordinates needed by MPI_Cart_get
        logical,         allocatable   :: temp_periods(:)      ! Temporary periods needed by MPI_Cart_get
        integer(int32)                 :: dims3d(3)

        call MPI_Cartdim_get(comm, grid_ndims, ierr)
        if ( grid_ndims > ndims ) then
          error_code = DTFFT_ERROR_INVALID_COMM_DIMS
          return
        endif
        allocate(temp_dims(grid_ndims), temp_periods(grid_ndims), temp_coords(grid_ndims))
        call MPI_Cart_get(comm, grid_ndims, temp_dims, temp_periods, temp_coords, ierr)
        if ( product(temp_dims) /= product(comm_dims) ) then
          error_code = DTFFT_ERROR_INVALID_CART_COMM
          return
        endif
        dims3d(:) = 1
        if ( grid_ndims == ndims ) then
          if ( temp_dims(1) /= 1 ) then
            error_code = DTFFT_ERROR_INVALID_COMM_FAST_DIM
            return
          endif
          dims3d(:) = temp_dims
        elseif ( grid_ndims == ndims - 1 ) then
          dims3d(2:) = temp_dims(:)
        elseif ( grid_ndims == ndims - 2 ) then
          dims3d(3) = temp_dims(1)
        endif
        deallocate(temp_dims, temp_periods, temp_coords)


        if ( dims3d(2) < comm_dims(2) .or. dims3d(3) < comm_dims(3) ) then
          error_code = DTFFT_ERROR_INVALID_CART_COMM
          return
        endif

        y_size = dims3d(2) / comm_dims(2)
        z_size = dims3d(3) / comm_dims(3)

        if ( y_size * z_size /= fast_dim_size ) then
          error_code = DTFFT_ERROR_INVALID_CART_COMM
          return
        endif

        if ( y_size * comm_dims(2) /= dims3d(2) .or. z_size * comm_dims(3) /= dims3d(3) ) then
          error_code = DTFFT_ERROR_INVALID_CART_COMM
          return
        endif
      endblock
    else
      ! Nx / P0  Ny / P1  Nz / P2
      ! -> reshape
      ! Nx  Ny / (P1 * Q1)  Nz / (P2 * Q2)
      ! -> transpose
      ! Ny  Nz / (P2 * Q2)  Nx / (P1 * Q1)
      ! -> transpose
      ! Nz  Nx / (P1 * Q1)  Ny / (P2 * Q2)
      ! -> reshape
      ! Nz / P2  Nx / (P1 * Q1)  Ny / Q2

      is_nice_grid_found = .false.
      if ( ndims == 3 .and. bricks%counts(ndims) > tile_size * fast_dim_size ) then
      !  .and. mod(bricks%counts(ndims), fast_dim_size) == 0 ) then
        y_size = 1
        z_size = fast_dim_size
        is_nice_grid_found = .true.
      else if ( (bricks%counts(2) > tile_size * fast_dim_size ) .or. ndims == 2 ) then
        ! .and. mod(bricks%counts(2), fast_dim_size) == 0
        y_size = fast_dim_size
        z_size = 1
        is_nice_grid_found = .true.
      else
        do i = 2, fast_dim_size
          if ( mod(fast_dim_size, i) /= 0 ) cycle
          if ( bricks%counts(ndims) < tile_size * i .or. mod(bricks%counts(ndims), i) /= 0 ) cycle
          if ( bricks%counts(2    ) < tile_size * i .or. mod(bricks%counts(2    ), i) /= 0 ) cycle

          is_nice_grid_found = .true.
          y_size = min(i, fast_dim_size / i)
          z_size = max(i, fast_dim_size / i)
          exit
        enddo
      endif

      ! In order to all processes have same decomposition
      call MPI_Bcast(is_nice_grid_found, 1, MPI_LOGICAL, 0, comm, ierr)

      if ( is_nice_grid_found ) then
        call MPI_Bcast(y_size, 1, MPI_INTEGER4, 0, comm, ierr)
        call MPI_Bcast(z_size, 1, MPI_INTEGER4, 0, comm, ierr)
      else
        block
          integer(int32) :: temp_dims(2)

          temp_dims(:) = 0
          call MPI_Dims_create(fast_dim_size, int(ndims - 1, int32), temp_dims, ierr)
          WRITE_WARN("Unable to find good grid decomposition, using MPI_Dims_create")
          y_size = temp_dims(1)
          z_size = temp_dims(2)
        endblock
      endif
    endif

    allocate( pencil_dims(ndims), pencil_starts(ndims) )
    pencil_dims(1) = bricks%dims(1)
    pencil_dims(2:) = bricks%counts(2:)

    pencil_starts(1) = 0

    allocate( pencil_comms(ndims) )

    pencil_comms(1) = MPI_COMM_SELF
    if (y_size == 1) then
      pencil_comms(2) = MPI_COMM_SELF
      pencil_comms(3) = bricks%comms(1)

      ay = 0
      call MPI_Comm_rank(pencil_comms(3), az, ierr)

      pencil_starts(2) = bricks%starts(2)
      call MPI_Allreduce(bricks%starts(3), pencil_starts(3), 1, MPI_INTEGER, MPI_MIN, pencil_comms(3), ierr)
    else if ( z_size == 1 ) then
      pencil_comms(2) = bricks%comms(1)

      call MPI_Comm_rank(pencil_comms(2), ay, ierr)
      az = 0

      call MPI_Allreduce(bricks%starts(2), pencil_starts(2), 1, MPI_INTEGER, MPI_MIN, pencil_comms(2), ierr)

      if ( ndims == 3 ) then
        pencil_comms(3) = MPI_COMM_SELF
        pencil_starts(3) = bricks%starts(3)
      endif
    else
      block
        integer(int32) :: dims(2)
        logical        :: remain_dims(2), periods(2), reorder
        TYPE_MPI_COMM :: cart_comm

        dims(1) = y_size
        dims(2) = z_size
        periods(1) = .false.
        periods(2) = .false.
        reorder = .false.
        call MPI_Cart_create(bricks%comms(1), 2, dims, periods, reorder, cart_comm, ierr)

        remain_dims(1) = .true.
        remain_dims(2) = .false.
        call MPI_Cart_sub(cart_comm, remain_dims, pencil_comms(2), ierr)

        remain_dims(1) = .false.
        remain_dims(2) = .true.
        call MPI_Cart_sub(cart_comm, remain_dims, pencil_comms(3), ierr)

        ! Use the ranks within pencil_comms to define (ay,az).
        ! This preserves the locality-friendly mapping encoded by MPI_Cart_sub.
        call MPI_Comm_rank(pencil_comms(2), ay, ierr)
        call MPI_Comm_rank(pencil_comms(3), az, ierr)

        call MPI_Comm_free(cart_comm, ierr)
        ! pencil_dims(2:) = bricks%dims(2:)

        call MPI_Allreduce(bricks%starts(2), pencil_starts(2), 1, MPI_INTEGER, MPI_MIN, pencil_comms(2), ierr)
        call MPI_Allreduce(bricks%starts(3), pencil_starts(3), 1, MPI_INTEGER, MPI_MIN, pencil_comms(3), ierr)
      endblock
    endif
    call temp_pencil%create(ndims, 1_int8, pencil_dims, pencil_comms)
    temp_pencil%starts(:) = temp_pencil%starts(:) + pencil_starts(:)

    ! Build pencil_init directly from the already constructed 1D communicators.
    ! This avoids reconstructing communicators from starts/counts, which becomes
    ! ambiguous when some ranks have zero local volume (counts == 0).
    call self%destroy()
    allocate(self%starts, source=temp_pencil%starts)
    allocate(self%counts, source=temp_pencil%counts)
    allocate(self%comms(ndims))
    allocate(self%dims, source=bricks%dims)

    ! Process coordinates in the original bricks process grid.
    call MPI_Comm_rank(bricks%comms(1), a_rank, ierr)
    if ( ndims >= 2 ) call MPI_Comm_rank(bricks%comms(2), b_rank, ierr)
    if ( ndims == 3 ) call MPI_Comm_rank(bricks%comms(3), c_rank, ierr)

    ! dim=1 is not distributed for pencils
    call MPI_Comm_dup(MPI_COMM_SELF, self%comms(1), ierr)

    if ( ndims == 2 ) then
      ! New grid: 1 x (P1 * y_size)
      color = 0
      key = temp_pencil%starts(2)
      call MPI_Comm_split(comm, color, key, self%comms(2), ierr)
    else
      ! New grid: 1 x (P1 * y_size) x (P2 * z_size)
      color = c_rank * z_size + az
      key = temp_pencil%starts(2)
      call MPI_Comm_split(comm, color, key, self%comms(2), ierr)

      color = b_rank * y_size + ay
      key = temp_pencil%starts(3)
      call MPI_Comm_split(comm, color, key, self%comms(3), ierr)

      call MPI_Comm_rank(self%comms(2), bb_rank, ierr)
      call MPI_Comm_rank(self%comms(3), cc_rank, ierr)

    endif

    do d = 2, ndims
      if ( pencil_comms(d) /= bricks%comms(1) .and. pencil_comms(d) /= MPI_COMM_SELF ) then
        call MPI_Comm_free(pencil_comms(d), ierr)
      endif
    enddo

    call temp_pencil%destroy()
    deallocate( pencil_dims, pencil_comms, comm_dims )
  end function from_bricks

  function create_pencil_init(self, pencil, comm) result(error_code)
  !! Creates and validates pencil passed by user to plan constructors
    class(pencil_init),     intent(inout) :: self         !! Internal pencil representation based on dtfft_pencil_t
    type(dtfft_pencil_t),   intent(in)    :: pencil       !! Pencil passed by user to plan constructors
    TYPE_MPI_COMM,          intent(in)    :: comm         !! MPI Communicator passed to plan constructors
    integer(int32)                        :: error_code   !! Error code
    integer(int32)              :: comm_rank          !! Rank of current MPI process
    integer(int32)              :: comm_size, csizes(3), psize   !! Size of communicator
    integer(int32)              :: ndims              !! Number of dimensions
    integer(int32)              :: ierr               !! Error code from MPI calls
    integer(int32), allocatable :: all_starts(:,:)    !! All starts gathered from all processes
    integer(int32), allocatable :: all_counts(:,:)    !! All counts gathered from all processes
    integer(int32), allocatable :: fixed_dims(:)      !! Fixed dimensions for 1D communicators
    integer(int32)              :: i, j, d            !! Counters
    integer(int32)              :: p1, p2, d1, d2     !! Counters

    error_code = DTFFT_SUCCESS
    if (.not. pencil%is_created) then
      error_code = DTFFT_ERROR_PENCIL_NOT_INITIALIZED
    end if
    CHECK_ERROR_AND_RETURN_AGG(comm)

    ndims = size(pencil%starts)
    if (ndims /= size(pencil%counts)) then
      error_code = DTFFT_ERROR_PENCIL_ARRAYS_SIZE_MISMATCH
    end if
    CHECK_ERROR_AND_RETURN_AGG(comm)

    if (ndims < 2 .or. ndims > 3) then
      error_code = DTFFT_ERROR_PENCIL_ARRAYS_INVALID_SIZES
    end if
    CHECK_ERROR_AND_RETURN_AGG(comm)

    if (any(pencil%starts < 0)) then
      error_code = DTFFT_ERROR_PENCIL_INVALID_STARTS
    end if
    CHECK_ERROR_AND_RETURN_AGG(comm)

    if (any(pencil%counts < 0)) then
      error_code = DTFFT_ERROR_PENCIL_INVALID_COUNTS
    end if
    CHECK_ERROR_AND_RETURN_AGG(comm)

    call MPI_Comm_rank(comm, comm_rank, ierr)
    call MPI_Comm_size(comm, comm_size, ierr)

    allocate(self%dims(ndims))

    allocate(all_starts(ndims, comm_size))
    allocate(all_counts(ndims, comm_size))

    call MPI_Allgather(pencil%starts, ndims, MPI_INTEGER, all_starts, ndims, MPI_INTEGER, comm, ierr)
    call MPI_Allgather(pencil%counts, ndims, MPI_INTEGER, all_counts, ndims, MPI_INTEGER, comm, ierr)

    ! Computing global dimensions
    do d = 1, ndims
      self%dims(d) = maxval(all_starts(d,:) + all_counts(d,:))
    enddo

    do p1 = 1, comm_size
      ! Skip processes with zero volume
      if (any(all_counts(:, p1) == 0)) cycle

      do p2 = p1 + 1, comm_size
        ! Skip processes with zero volume
        if (any(all_counts(:, p2) == 0)) cycle

        do d1 = 1, ndims
          do d2 = d1 + 1, ndims
            ! If two processes have the same start on two different axes,
            ! then their blocks must have the same size on these axes.
            if (all_starts(d1, p1) == all_starts(d1, p2) .and. &
                all_starts(d2, p1) == all_starts(d2, p2)) then

              if ((all_counts(d1, p1) /= all_counts(d1, p2) .or. &
                  all_counts(d2, p1) /= all_counts(d2, p2))) then
                    error_code = DTFFT_ERROR_PENCIL_SHAPE_MISMATCH
              endif
            endif
          enddo
        enddo
      enddo
    enddo
    CHECK_ERROR_AND_RETURN_AGG(comm)

    ! Check intersection of pencils (overlap check already handles zero-volume pencils)
    do i = 1, comm_size
      do j = i + 1, comm_size
        if (check_overlap(all_starts(:, i), all_counts(:, i), all_starts(:, j), all_counts(:, j), ndims)) then
          error_code = DTFFT_ERROR_PENCIL_OVERLAP
        endif
      enddo
    enddo
    CHECK_ERROR_AND_RETURN_AGG(comm)
    ! Check continuity of pencils
    if (.not. check_continuity(all_starts, all_counts, self%dims, comm_size)) then
      error_code = DTFFT_ERROR_PENCIL_NOT_CONTINUOUS
    endif
    CHECK_ERROR_AND_RETURN_AGG(comm)

    allocate(self%starts, source=pencil%starts)
    allocate(self%counts, source=pencil%counts)
    allocate(self%comms(ndims))
    allocate(fixed_dims(ndims - 1))

    ! Create 1D communicators for each dimension
    do d = 1, ndims
      j = 1
      do i = 1, ndims
        if (i /= d) then
          fixed_dims(j) = i
          j = j + 1
        endif
      enddo
      call create_1d_comm(self%starts, all_starts, fixed_dims, comm, self%comms(d), all_counts)
    enddo

    psize = 1
    do d = 1, ndims
      call MPI_Comm_size(self%comms(d), csizes(d), ierr)
      psize = psize * csizes(d)
    enddo
    if ( psize /= comm_size ) then
      do d = 1, ndims
        WRITE_ERROR("d = "//to_str(d)//": comm_size = "//to_str(csizes(d)))
      enddo
      INTERNAL_ERROR("create_pencil_init: psize /= comm_size")
    endif
    deallocate(fixed_dims)
    deallocate(all_starts)
    deallocate(all_counts)
  end function create_pencil_init

  subroutine destroy_pencil_init(self)
  !! Destroys pencil_init
    class(pencil_init), intent(inout) :: self   !!  Internal pencil representation based on dtfft_pencil_t

    if (allocated(self%starts)) deallocate(self%starts)
    if (allocated(self%counts)) deallocate(self%counts)
    if (allocated(self%comms)) then
      block
        integer(int32) :: ierr, i
        do i = 1, size(self%comms)
          call MPI_Comm_free(self%comms(i), ierr)
        enddo
      end block
      deallocate(self%comms)
    end if
    if (allocated(self%dims)) deallocate(self%dims)
  end subroutine destroy_pencil_init


  pure logical function check_overlap(lbounds1, sizes1, lbounds2, sizes2, ndims)
  !! Check if two pencols overlap in ndims-dimensional space
    integer(int32), intent(in) :: lbounds1(:)   !! Lower bounds of first pencil
    integer(int32), intent(in) :: sizes1(:)     !! Sizes of first pencil
    integer(int32), intent(in) :: lbounds2(:)   !! Lower bounds of second pencil
    integer(int32), intent(in) :: sizes2(:)     !! Sizes of second pencil
    integer(int32), intent(in) :: ndims         !! Number of dimensions
    integer :: d

    ! If either pencil has zero size in any dimension, there is no overlap
    if (any(sizes1(1:ndims) == 0) .or. any(sizes2(1:ndims) == 0)) then
      check_overlap = .false.
      return
    endif

    check_overlap = .true.

    do d = 1, ndims
      ! If there is no intersection in one of the dimensions, then there is no intersection in the whole space
      if (lbounds1(d) + sizes1(d) <= lbounds2(d) .or. lbounds2(d) + sizes2(d) <= lbounds1(d)) then
        check_overlap = .false.
        return
      endif
    enddo
  end function check_overlap

  logical function check_continuity(all_lbounds, all_sizes, global_dims, comm_size)
  !! Check if the local pencils cover the global space without gaps
    integer(int32), intent(in) :: all_lbounds(:,:)    !! Lower bounds of local pencils for each process
    integer(int32), intent(in) :: all_sizes(:,:)      !! Sizes of local pencils for each process
    integer(int32), intent(in) :: global_dims(:)      !! Global dimensions of the problem
    integer(int32), intent(in) :: comm_size           !! Number of processes in the communicator
    integer(int64) :: total_local_volume, global_volume
    integer :: i
    logical :: has_zero_volume

    ! 1. Check that local pencils do not exceed global grid limits
    do i = 1, comm_size
      ! Skip processes with zero volume
      has_zero_volume = any(all_sizes(:,i) == 0)
      if (has_zero_volume) cycle

      if (any(all_lbounds(:,i) < 0) .or. &
          any(all_lbounds(:,i) + all_sizes(:,i) > global_dims)) then
          check_continuity = .false.
          return
      endif
    enddo

    ! 2. Compare the sum of the local block volumes with the volume of the global grid
    total_local_volume = 0
    do i = 1, comm_size
      ! Skip processes with zero volume
      has_zero_volume = any(all_sizes(:,i) == 0)
      if (has_zero_volume) cycle

      total_local_volume = total_local_volume + product(int(all_sizes(:,i), int64))
    enddo

    global_volume = product(int(global_dims, int64))

    if (total_local_volume == global_volume) then
      check_continuity = .true.
    else
      check_continuity = .false.
    end if
  end function check_continuity

  function get_varying_dim(fixed_dims, total_dims) result(varying_dim)
    integer(int32), intent(in) :: fixed_dims(:)
    integer(int32), intent(in) :: total_dims
    integer(int32) :: varying_dim

    do varying_dim = 1, total_dims
      if (.not. any(fixed_dims == varying_dim)) exit
    enddo
  end function get_varying_dim

  subroutine sort_by_varying_dim(ranks, coords)
    integer(int32), intent(inout) :: ranks(:)
    integer(int32), intent(inout)    :: coords(:)
    integer(int32) :: i, j, tmp_rank, tmp_coord, n
    ! logical :: swapped
    ! integer :: temp_coord, temp_num

    n = size(coords)
    if (n <= 1) return

    do i = 2, n
      tmp_rank = ranks(i)
      tmp_coord = coords(i)
      j = i - 1

      do while (j >= 1)
        if (coords(j) <= tmp_coord) exit
        ranks(j + 1) = ranks(j)
        coords(j + 1) = coords(j)
        j = j - 1
      end do

      ranks(j + 1) = tmp_rank
      coords(j + 1) = tmp_coord
    end do
  end subroutine sort_by_varying_dim

  subroutine create_1d_comm(lbounds, all_lbounds, fixed_dims, comm, new_comm, all_counts)
  !! Creates a new 1D communicator based on the fixed dimensions of the current pencil
    integer(int32), intent(in) :: lbounds(:)          !! Local starts of the current pencil
    integer(int32), intent(in) :: all_lbounds(:,:)    !! Local starts of all processes
    integer(int32), intent(in) :: fixed_dims(:)       !! Indices of fixed coordinates
    TYPE_MPI_COMM, intent(in)  :: comm                !! Original MPI communicator
    TYPE_MPI_COMM, intent(out) :: new_comm            !! New 1D MPI communicator
    integer(int32), intent(in) :: all_counts(:,:)
    integer(int32) :: comm_size   !! Size of `comm`
    integer(int32) :: ierr        !! Error codes for mpi calls
    integer(int32), allocatable :: neighbors(:) !! Array to neighbors ranks
    integer(int32), allocatable :: varying_dim_coord(:)    !! Coordinates along the non-fixed dimension
    integer(int32) :: i, j                      !! Counters
    integer(int32) :: neighbor_count            !! Number of neighboring processes
    integer(int32) :: var_dim, comm_rank
    logical :: matched, count_matched

    call MPI_Comm_size(comm, comm_size, ierr)
    call MPI_Comm_rank(comm, comm_rank, ierr)
    var_dim = get_varying_dim(fixed_dims, size(lbounds))
    allocate(neighbors(comm_size), varying_dim_coord(comm_size))
    neighbor_count = 0

    ! Find processes with matching fixed dimensions
    do i = 1, comm_size
      matched = .true.
      count_matched = .true.
      do j = 1, size(fixed_dims)
        if (all_lbounds(fixed_dims(j), i) /= lbounds(fixed_dims(j))) matched = .false.
        if ( all_counts(fixed_dims(j), i) /= all_counts(fixed_dims(j), comm_rank + 1) ) count_matched = .false.
      enddo
      matched = matched .and. count_matched

      if ( (matched .and. all_lbounds(var_dim, i) /= lbounds(var_dim)) &
          .or. i - 1 == comm_rank                   &
          .or. (matched .and. (all_lbounds(var_dim, i) == lbounds(var_dim) .and. (all_counts(var_dim, i) == 0 .or. all_counts(var_dim, comm_rank + 1) == 0)))) then
        neighbor_count = neighbor_count + 1
        neighbors(neighbor_count) = i - 1
        ! Store the coordinate along the first non-fixed dimension for sorting
        varying_dim_coord(neighbor_count) = all_lbounds(var_dim, i)
      endif
    enddo

    ! Sort neighbors by their coordinate along the varying dimension
    call sort_by_varying_dim(neighbors, varying_dim_coord(1:neighbor_count))
    call create_subcomm(comm, neighbors(1:neighbor_count), new_comm)
    deallocate(neighbors, varying_dim_coord)
  end subroutine create_1d_comm
end module dtfft_pencil

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft
!! Main ``dtFFT`` module. Should be used in a Fortran program.
#ifdef DTFFT_WITH_COMPRESSION
use dtfft_abstract_compressor
#endif
use dtfft_config
use dtfft_errors
use dtfft_parameters
use dtfft_pencil
use dtfft_plan
implicit none
private

public :: dtfft_get_version
public :: DTFFT_VERSION_MAJOR
public :: DTFFT_VERSION_MINOR
public :: DTFFT_VERSION_PATCH
! Plans
public :: dtfft_plan_t
public :: dtfft_plan_c2c_t
public :: dtfft_plan_r2c_t
public :: dtfft_plan_r2r_t
! Helper types
public :: dtfft_request_t
public :: dtfft_pencil_t
! String getters
public :: dtfft_get_error_string
public :: dtfft_get_precision_string
public :: dtfft_get_executor_string
! Enums
public :: dtfft_execute_t, dtfft_transpose_t, dtfft_reshape_t, dtfft_layout_t
public :: dtfft_executor_t, dtfft_effort_t
public :: dtfft_precision_t, dtfft_r2r_kind_t
public :: dtfft_transpose_mode_t, dtfft_access_mode_t

public :: operator(==)
public :: operator(/=)

! Execute types
public :: DTFFT_EXECUTE_FORWARD,                                    &
          DTFFT_EXECUTE_BACKWARD
! Transpose types
public :: DTFFT_TRANSPOSE_X_TO_Y,                                   &
          DTFFT_TRANSPOSE_Y_TO_X,                                   &
          DTFFT_TRANSPOSE_Y_TO_Z,                                   &
          DTFFT_TRANSPOSE_Z_TO_Y,                                   &
          DTFFT_TRANSPOSE_X_TO_Z,                                   &
          DTFFT_TRANSPOSE_Z_TO_X

! Reshape types
public :: DTFFT_RESHAPE_X_BRICKS_TO_PENCILS,                        &
          DTFFT_RESHAPE_X_PENCILS_TO_BRICKS,                        &
          DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS,                        &
          DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS,                        &
          DTFFT_RESHAPE_Y_BRICKS_TO_PENCILS,                        &
          DTFFT_RESHAPE_Y_PENCILS_TO_BRICKS

! Layout types
public :: DTFFT_LAYOUT_X_BRICKS,                                    &
          DTFFT_LAYOUT_Z_BRICKS,                                    &
          DTFFT_LAYOUT_X_PENCILS,                                   &
          DTFFT_LAYOUT_Y_PENCILS,                                   &
          DTFFT_LAYOUT_Z_PENCILS,                                   &
          DTFFT_LAYOUT_X_PENCILS_FOURIER

! 1d FFT External Executor types
public :: DTFFT_EXECUTOR_NONE
public :: DTFFT_EXECUTOR_FFTW3
public :: DTFFT_EXECUTOR_MKL
public :: DTFFT_EXECUTOR_CUFFT
public :: DTFFT_EXECUTOR_VKFFT

! Effort flags
public :: DTFFT_ESTIMATE,                                           &
          DTFFT_MEASURE,                                            &
          DTFFT_PATIENT,                                            &
          DTFFT_EXHAUSTIVE

! Precision flags
public :: DTFFT_SINGLE,                                             &
          DTFFT_DOUBLE

! Types of R2R Transform
public :: DTFFT_DCT_1,                                              &
          DTFFT_DCT_2,                                              &
          DTFFT_DCT_3,                                              &
          DTFFT_DCT_4,                                              &
          DTFFT_DST_1,                                              &
          DTFFT_DST_2,                                              &
          DTFFT_DST_3,                                              &
          DTFFT_DST_4

! Transpose and access modes
public :: DTFFT_TRANSPOSE_MODE_PACK, DTFFT_TRANSPOSE_MODE_UNPACK
public :: DTFFT_ACCESS_MODE_WRITE, DTFFT_ACCESS_MODE_READ

! Error codes
public :: DTFFT_SUCCESS
public :: DTFFT_ERROR_MPI_FINALIZED
public :: DTFFT_ERROR_PLAN_NOT_CREATED
public :: DTFFT_ERROR_INVALID_TRANSPOSE_TYPE
public :: DTFFT_ERROR_INVALID_N_DIMENSIONS
public :: DTFFT_ERROR_INVALID_DIMENSION_SIZE
public :: DTFFT_ERROR_INVALID_COMM_TYPE
public :: DTFFT_ERROR_INVALID_PRECISION
public :: DTFFT_ERROR_INVALID_EFFORT
public :: DTFFT_ERROR_INVALID_EXECUTOR
public :: DTFFT_ERROR_INVALID_COMM_DIMS
public :: DTFFT_ERROR_INVALID_COMM_FAST_DIM
public :: DTFFT_ERROR_MISSING_R2R_KINDS
public :: DTFFT_ERROR_INVALID_R2R_KINDS
public :: DTFFT_ERROR_R2C_TRANSPOSE_PLAN
public :: DTFFT_ERROR_INPLACE_TRANSPOSE
public :: DTFFT_ERROR_INVALID_AUX
public :: DTFFT_ERROR_INVALID_LAYOUT
public :: DTFFT_ERROR_INVALID_USAGE
public :: DTFFT_ERROR_PLAN_IS_CREATED
public :: DTFFT_ERROR_ALLOC_FAILED
public :: DTFFT_ERROR_FREE_FAILED
public :: DTFFT_ERROR_INVALID_ALLOC_BYTES
public :: DTFFT_ERROR_DLOPEN_FAILED
public :: DTFFT_ERROR_DLSYM_FAILED
! public :: DTFFT_ERROR_R2C_TRANSPOSE_CALLED
public :: DTFFT_ERROR_PENCIL_ARRAYS_SIZE_MISMATCH
public :: DTFFT_ERROR_PENCIL_ARRAYS_INVALID_SIZES
public :: DTFFT_ERROR_PENCIL_INVALID_COUNTS
public :: DTFFT_ERROR_PENCIL_INVALID_STARTS
public :: DTFFT_ERROR_PENCIL_SHAPE_MISMATCH
public :: DTFFT_ERROR_PENCIL_OVERLAP
public :: DTFFT_ERROR_PENCIL_NOT_CONTINUOUS
public :: DTFFT_ERROR_PENCIL_NOT_INITIALIZED
public :: DTFFT_ERROR_INVALID_MEASURE_WARMUP_ITERS
public :: DTFFT_ERROR_INVALID_MEASURE_ITERS
public :: DTFFT_ERROR_INVALID_REQUEST
public :: DTFFT_ERROR_TRANSPOSE_ACTIVE
public :: DTFFT_ERROR_TRANSPOSE_NOT_ACTIVE
public :: DTFFT_ERROR_INVALID_RESHAPE_TYPE
public :: DTFFT_ERROR_RESHAPE_ACTIVE
public :: DTFFT_ERROR_RESHAPE_NOT_ACTIVE
public :: DTFFT_ERROR_INPLACE_RESHAPE
public :: DTFFT_ERROR_INVALID_EXECUTE_TYPE
public :: DTFFT_ERROR_RESHAPE_NOT_SUPPORTED
public :: DTFFT_ERROR_R2C_EXECUTE_CALLED
public :: DTFFT_ERROR_INVALID_CART_COMM
public :: DTFFT_ERROR_INVALID_TRANSPOSE_MODE
public :: DTFFT_ERROR_INVALID_ACCESS_MODE
public :: DTFFT_ERROR_R2R_FFT_NOT_SUPPORTED
public :: DTFFT_ERROR_GPU_INVALID_STREAM
public :: DTFFT_ERROR_INVALID_BACKEND
public :: DTFFT_ERROR_GPU_NOT_SET
public :: DTFFT_ERROR_VKFFT_R2R_2D_PLAN
public :: DTFFT_ERROR_BACKENDS_DISABLED
public :: DTFFT_ERROR_NOT_DEVICE_PTR
public :: DTFFT_ERROR_NOT_NVSHMEM_PTR
public :: DTFFT_ERROR_INVALID_PLATFORM
public :: DTFFT_ERROR_INVALID_PLATFORM_EXECUTOR
public :: DTFFT_ERROR_INVALID_PLATFORM_BACKEND

! Configuration
public :: dtfft_config_t
public :: dtfft_create_config, dtfft_set_config
! Backends
public :: DTFFT_BACKEND_MPI_DATATYPE
public :: DTFFT_BACKEND_MPI_P2P
public :: DTFFT_BACKEND_MPI_P2P_PIPELINED
public :: DTFFT_BACKEND_MPI_A2A
public :: DTFFT_BACKEND_MPI_RMA
public :: DTFFT_BACKEND_MPI_RMA_PIPELINED
public :: DTFFT_BACKEND_MPI_P2P_SCHEDULED
public :: DTFFT_BACKEND_MPI_P2P_FUSED
public :: DTFFT_BACKEND_MPI_RMA_FUSED
public :: DTFFT_BACKEND_ADAPTIVE

public :: dtfft_backend_t
public :: dtfft_get_backend_string
public :: dtfft_get_backend_pipelined

#ifdef DTFFT_WITH_CUDA

public :: dtfft_stream_t, dtfft_get_cuda_stream
public :: dtfft_platform_t
! Platforms
public :: DTFFT_PLATFORM_HOST, DTFFT_PLATFORM_CUDA
! GPU backends
public :: DTFFT_BACKEND_NCCL
public :: DTFFT_BACKEND_NCCL_PIPELINED
public :: DTFFT_BACKEND_CUFFTMP
public :: DTFFT_BACKEND_CUFFTMP_PIPELINED
#endif

#ifdef DTFFT_WITH_COMPRESSION
public :: dtfft_compression_lib_t
public :: dtfft_compression_mode_t
public :: dtfft_compression_config_t
public :: DTFFT_COMPRESSION_LIB_ZFP
public :: DTFFT_COMPRESSION_MODE_LOSSLESS
public :: DTFFT_COMPRESSION_MODE_FIXED_RATE
public :: DTFFT_COMPRESSION_MODE_FIXED_PRECISION
public :: DTFFT_COMPRESSION_MODE_FIXED_ACCURACY

public :: DTFFT_BACKEND_MPI_P2P_COMPRESSED
public :: DTFFT_BACKEND_MPI_RMA_COMPRESSED
# ifdef DTFFT_WITH_CUDA
public :: DTFFT_BACKEND_NCCL_COMPRESSED
# endif
#endif
end module dtfft

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_transpose_plan
!! This module describes [[transpose_plan]] class
use iso_fortran_env
use iso_c_binding
use dtfft_abstract_backend,               only: backend_helper
#ifdef DTFFT_WITH_COMPRESSION
use dtfft_abstract_compressor
#endif
use dtfft_abstract_reshape_handle,        only: reshape_container, create_args
use dtfft_config
use dtfft_errors
use dtfft_parameters
use dtfft_pencil,                         only: pencil, pencil_init, get_local_sizes
use dtfft_reshape_plan_base,              only: allocate_plans, reshape_plan_base, execute_autotune, destroy_plans
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_profile.h"
#include "_dtfft_cuda.h"
#include "_dtfft_private.h"
implicit none
private
public :: transpose_plan


  type, extends(reshape_plan_base) :: transpose_plan
  !! Transpose Plan class
  !! This class is a container for transposition plans
  private
    logical                   :: is_z_slab        !! Is Z-slab optimization enabled
    logical                   :: is_y_slab        !! Is Y-slab optimization enabled
  contains
    procedure,  non_overridable,  pass(self), public :: create            !! Creates transpose plan
    procedure,  non_overridable,  pass(self), public :: get_z_slab        !! Returns .true. if Z-slab optimization is enabled
    procedure,  non_overridable,  pass(self), public :: get_y_slab        !! Returns .true. if Y-slab optimization is enabled
  end type transpose_plan

contains

    function create(self, platform, dims, base_comm, effort, base_dtype, base_storage, cart_comm, comms, pencils, ipencil) result(error_code)
    !! Creates transposition plan
        class(transpose_plan),          intent(inout) :: self           !! Transposition class
        type(dtfft_platform_t),         intent(in)    :: platform       !! Platform to create plan for
        integer(int32),                 intent(in)    :: dims(:)        !! Global sizes of the transform requested
        TYPE_MPI_COMM,                  intent(in)    :: base_comm      !! Base communicator
        type(dtfft_effort_t),           intent(in)    :: effort         !! ``dtFFT`` planner type of effort
        TYPE_MPI_DATATYPE,              intent(in)    :: base_dtype     !! Base MPI_Datatype
        integer(int64),                 intent(in)    :: base_storage   !! Number of bytes needed to store single element
        TYPE_MPI_COMM,                  intent(out)   :: cart_comm      !! Cartesian communicator
        TYPE_MPI_COMM,                  intent(out)   :: comms(:)       !! Array of 1d communicators
        type(pencil),                   intent(out)   :: pencils(:)     !! Data distributing meta
        type(pencil_init),    optional, intent(in)    :: ipencil        !! Pencil passed by user
        integer(int32)                                :: error_code     !! Error code
        ! integer(int32),   allocatable   :: transposed_dims(:,:) !! Global counts in transposed coordinates
        logical           :: cond1    !! First condition for Z-slab optimization
        logical           :: cond2    !! Second condition for Z-slab optimization
        integer(int32),   allocatable   :: comm_dims(:)   !! Dims in cartesian communicator
        integer(int8)     :: ndims      !! Number of dimensions
        integer(int32)    :: comm_size  !! Number of MPI processes
        integer(int32)    :: top_type   !! Topology type
        integer(int32)    :: ierr       !! Error code
        logical           :: is_custom_cart_comm  !! Custom cartesian communicator provided by user
        integer(int8)     :: d
        TYPE_MPI_COMM     :: base_comm_
        integer(int8) :: n_transpose_plans
        integer(int32), allocatable :: best_decomposition(:)
        logical :: pencils_created
        real(real64) :: ts, te
        ! integer(int8) :: best_forward_ids(3), best_backward_ids(3)
        logical :: invalid_grid_selected
        logical :: z_slab_from_conf, y_slab_from_conf
        logical :: exec_autotune
        type(dtfft_transpose_mode_t) :: transpose_mode, best_transpose_mode
        type(dtfft_transpose_mode_t) :: fmodes(3), bmodes(3)
        type(dtfft_backend_t)        :: fbacks(3), bbacks(3)

        error_code = DTFFT_SUCCESS
#ifdef DTFFT_WITH_COMPRESSION
        CHECK_CALL( self%init(platform, effort, get_conf_backend(), DTFFT_PATIENT, get_conf_transpose(), base_dtype, base_storage), error_code )
#else
        CHECK_CALL( self%init(platform, effort, get_conf_backend(), DTFFT_PATIENT), error_code )
#endif

        call MPI_Comm_size(base_comm, comm_size, ierr)
        call MPI_Topo_test(base_comm, top_type, ierr)
        base_comm_ = base_comm

        ndims = size(dims, kind=int8)
        allocate( comm_dims(ndims) )
        comm_dims(:) = 0

        is_custom_cart_comm = .false.
        self%is_z_slab = .false.; z_slab_from_conf = get_conf_z_slab_enabled()
        self%is_y_slab = .false.; y_slab_from_conf = get_conf_y_slab_enabled()

        invalid_grid_selected = .false.
        if ( present(ipencil) ) then
            is_custom_cart_comm = .true.
            do d = 1, ndims
                call MPI_Comm_size(ipencil%comms(d), comm_dims(d), ierr)
            enddo
            if ( comm_dims(1) /= 1 ) then
                error_code = DTFFT_ERROR_INVALID_COMM_FAST_DIM
                return
            endif
            if ( ndims == 3 ) then
                if (comm_dims(2) == 1 .and. z_slab_from_conf ) then
                    self%is_z_slab = .true.
                    base_comm_ = ipencil%comms(3)
                else if ( comm_dims(3) == 1 .and. y_slab_from_conf ) then
                    self%is_y_slab = .true.
                    base_comm_ = ipencil%comms(2)
                endif
            endif
        else ! ipencil not present
            if ( top_type == MPI_CART ) then
                is_custom_cart_comm = .true.
                block
                    integer(int32)                 :: grid_ndims           ! Number of dims in user defined cartesian communicator
                    integer(int32),  allocatable   :: temp_dims(:)         ! Temporary dims needed by MPI_Cart_get
                    integer(int32),  allocatable   :: temp_coords(:)       ! Temporary coordinates needed by MPI_Cart_get
                    logical,         allocatable   :: temp_periods(:)      ! Temporary periods needed by MPI_Cart_get

                    call MPI_Cartdim_get(base_comm_, grid_ndims, ierr)
                    if ( grid_ndims > ndims ) then
                        error_code = DTFFT_ERROR_INVALID_COMM_DIMS
                        return
                    endif
                    comm_dims(:) = 1
                    allocate(temp_dims(grid_ndims), temp_periods(grid_ndims), temp_coords(grid_ndims))
                    call MPI_Cart_get(base_comm_, grid_ndims, temp_dims, temp_periods, temp_coords, ierr)
                    if ( grid_ndims == ndims ) then
                        if ( temp_dims(1) /= 1 ) then
                            error_code = DTFFT_ERROR_INVALID_COMM_FAST_DIM
                            return
                        endif
                        comm_dims(:) = temp_dims
                    elseif ( grid_ndims == ndims - 1 ) then
                        comm_dims(2:) = temp_dims
                    elseif ( grid_ndims == ndims - 2 ) then
                        comm_dims(3) = temp_dims(1)
                    endif
                    deallocate(temp_dims, temp_periods, temp_coords)

                    do d = 2, ndims
                        if ( comm_dims(d) > dims(d) ) then
                            WRITE_WARN("Number of MPI processes in direction "//to_str(d)//" greater then number of physical points: "//to_str(comm_dims(d))//" > "//to_str(dims(d)))
                        endif
                    enddo
                    if ( ndims == 3 ) then
                        if (comm_dims(2) == 1 .and. z_slab_from_conf ) then
                            self%is_z_slab = .true.
                        else if ( comm_dims(3) == 1 .and. y_slab_from_conf ) then
                            self%is_y_slab = .true.
                        endif
                    endif
                endblock
            else !  top_type /= MPI_CART
                comm_dims(:) = 0
                comm_dims(1) = 1
                cond1 = comm_size <= dims(ndims)
                cond2 = comm_size <= dims(1) .and. comm_size <= dims(2)
#ifdef DTFFT_WITH_CUDA
                if ( platform == DTFFT_PLATFORM_CUDA ) then
                    cond1 = DEF_TILE_SIZE <= dims(ndims) / comm_size
                    cond2 = DEF_TILE_SIZE <= dims(1) / comm_size .and. DEF_TILE_SIZE <= dims(2) / comm_size
                endif
#endif
                if ( ndims == 3 ) then
                    if ( cond1 .and. z_slab_from_conf ) then
                        comm_dims(2) = 1
                        comm_dims(3) = comm_size
                        self%is_z_slab = .true.
                    else if ( cond2 .and. y_slab_from_conf ) then
                        comm_dims(2) = comm_size
                        comm_dims(3) = 1
                        self%is_y_slab = .true.
                    else if ( cond1 ) then
                        comm_dims(2) = 1
                        comm_dims(3) = comm_size
                    else if ( cond2 ) then
                        comm_dims(2) = comm_size
                        comm_dims(3) = 1
                    endif
                endif
                call MPI_Dims_create(comm_size, int(ndims, int32), comm_dims, ierr)
                if(dims(ndims - 1) < comm_dims(ndims - 1) .or. dims(ndims) < comm_dims(ndims) ) then
                    WRITE_WARN("Unable to create correct grid decomposition.")
                    invalid_grid_selected = .true.
                endif
            endif
        endif

        transpose_mode = get_conf_transpose_mode()
        best_transpose_mode = transpose_mode
        fmodes(:) = transpose_mode
        bmodes(:) = transpose_mode

        allocate( best_decomposition(ndims) )
        best_decomposition(:) = comm_dims(:)
        call MPI_Comm_size(base_comm_, comm_size, ierr)
        if ( comm_size == 1 .and. self%backend /= DTFFT_BACKEND_MPI_DATATYPE ) self%backend = DTFFT_BACKEND_NONE

        pencils_created = .false.
        if ( ndims == 2 .or. is_custom_cart_comm .or. self%is_z_slab .or. self%is_y_slab ) then
            pencils_created = .true.
            call create_pencils_and_comm(dims, base_comm_, comm_dims, cart_comm, comms, pencils, ipencil=ipencil)
        endif

        ts = MPI_Wtime()

        exec_autotune = (effort%val >= DTFFT_MEASURE%val .and. .not.pencils_created ) .or. (effort%val >= DTFFT_PATIENT%val) .and. comm_size > 1
        if ( exec_autotune ) then
            PHASE_BEGIN("Autotune transpose plan", COLOR_AUTOTUNE)
            WRITE_INFO("Starting autotune of transpose plans...")
        endif

        if ( effort%val >= DTFFT_PATIENT%val .and. comm_size > 1 .and. .not.invalid_grid_selected) then
            if ( self%backend == DTFFT_BACKEND_ADAPTIVE ) then
                if ( pencils_created ) then
                    call run_autotune_backend(                                                                                                                  &
                        platform, comms, cart_comm, effort, transpose_mode, base_dtype, pencils, base_storage, self%stream, self%is_z_slab, self%is_y_slab,     &
                        fmodes, bmodes, backend=self%backend, fbacks=fbacks, bbacks=bbacks)
                else
                    call autotune_grid_decomposition(                                                                                                           &
                        platform, dims, base_comm_, effort, transpose_mode, base_dtype, base_storage,                                                           &
                        self%stream, fmodes, bmodes, best_decomposition, backend=self%backend, fbacks=fbacks, bbacks=bbacks)
                endif
            else
                if ( pencils_created ) then
                    call run_autotune_backend(                                                                                                                  &
                        platform, comms, cart_comm, effort, transpose_mode, base_dtype, pencils, base_storage, self%stream, self%is_z_slab, self%is_y_slab,     &
                        fmodes, bmodes, best_backend=self%backend, best_transpose_mode=best_transpose_mode)
                else
                    call autotune_grid_decomposition(                                                                                                           &
                        platform, dims, base_comm_, effort, transpose_mode, base_dtype, base_storage,                                                           &
                        self%stream, fmodes, bmodes, best_decomposition, best_backend=self%backend, best_transpose_mode=best_transpose_mode)
                endif
            endif
        else if ( ndims == 3                                                                                                                                    &
                .and. .not.is_custom_cart_comm                                                                                                                  &
                .and. .not.self%is_z_slab                                                                                                                       &
                .and. .not.self%is_y_slab                                                                                                                       &
                .and. effort == DTFFT_MEASURE                                                                                                                   &
                .and. comm_size > 1 ) then

            call autotune_grid_decomposition(                                                                                                                   &
                platform, dims, base_comm_, effort, transpose_mode, base_dtype, base_storage,                                                                   &
                self%stream, fmodes, bmodes, best_decomposition, backend=self%backend)
        endif

        if ( exec_autotune ) then
            PHASE_END("Autotune transpose plan")
        endif
        te = MPI_Wtime()

        if ( effort%val >= DTFFT_MEASURE%val .and. ndims > 2 .and. comm_size > 1 ) then
            if ( self%is_z_slab ) then
                WRITE_INFO("Skipped search of MPI processor grid due to Z-slab optimization enabled")
            else if ( self%is_y_slab ) then
                WRITE_INFO("Skipped search of MPI processor grid due to Y-slab optimization enabled")
            else if ( is_custom_cart_comm ) then
                WRITE_INFO("Skipped search of MPI processor grid due to custom grid provided")
            else if ( invalid_grid_selected ) then
                WRITE_INFO("Skipped search of MPI processor grid due to lack of work per process")
            else
                WRITE_INFO("DTFFT_MEASURE: Selected MPI processor grid 1x"//to_str(best_decomposition(2))//"x"//to_str(best_decomposition(3)))
            endif
        endif
        if ( effort%val >= DTFFT_PATIENT%val .and. comm_size > 1 ) then
            WRITE_INFO("DTFFT_PATIENT: Selected backend is "//dtfft_get_backend_string(self%backend))
        endif

        n_transpose_plans = ndims - 1_int8; if( self%is_z_slab ) n_transpose_plans = n_transpose_plans + 1_int8

        if ( effort%val >= DTFFT_PATIENT%val .and. self%backend == DTFFT_BACKEND_MPI_DATATYPE .and. comm_size > 1 ) then
            WRITE_INFO("DTFFT_PATIENT: Selected transpose modes:")
            do d = 1, n_transpose_plans
                WRITE_INFO("    "//TRANSPOSE_NAMES( d)//": "//trim(TRANSPOSE_MODE_NAMES(fmodes(d)%val)))
                WRITE_INFO("    "//TRANSPOSE_NAMES(-d)//": "//trim(TRANSPOSE_MODE_NAMES(bmodes(d)%val)))
            enddo
        endif
        if ( exec_autotune ) then
            WRITE_INFO("Time spent on autotune: "//to_str(te - ts)//" [s]")
        endif

        if ( .not.pencils_created ) then
            call create_pencils_and_comm(dims, base_comm_, best_decomposition, cart_comm, comms, pencils)
        endif
        ts = MPI_Wtime()
        allocate( self%plans(-1 * n_transpose_plans:n_transpose_plans) )
        if ( self%backend == DTFFT_BACKEND_ADAPTIVE ) then
            block
                type(dtfft_backend_t), allocatable :: backs(:)

                allocate( backs(-1 * n_transpose_plans:n_transpose_plans) )
                do d = 1, n_transpose_plans
                    backs(-1 * n_transpose_plans + d - 1) = bbacks(n_transpose_plans - d + 1)
                    backs(d) = fbacks(d)
                enddo
                backs(0) = DTFFT_BACKEND_NONE

                call allocate_plans(self%plans, backends=backs)

                deallocate(backs)
            endblock
        else
            call allocate_plans(self%plans, self%backend)
        endif
        call self%helper%create(platform, cart_comm, comms, is_backend_nccl(self%backend), pencils)

        block
            type(create_args) :: args
            logical :: is_diff_transpose_mode, is_adaptive

            args%platform = platform
            args%helper = self%helper
            args%effort = effort
            args%backend = self%backend
            args%force_effort = .false.
            args%base_type = base_dtype
            args%base_storage = base_storage
            args%transpose_mode = best_transpose_mode
#ifdef DTFFT_WITH_COMPRESSION
            args%compression_config = get_conf_transpose()
#endif
            is_adaptive = self%backend == DTFFT_BACKEND_ADAPTIVE
            is_diff_transpose_mode = is_adaptive .or. self%backend == DTFFT_BACKEND_MPI_DATATYPE

            do d = 1_int8, ndims - 1_int8
                if ( is_diff_transpose_mode ) args%transpose_mode = fmodes(d)
                if ( is_adaptive ) args%backend = fbacks(d)
                call self%plans(d)%p%create(pencils(d), pencils(d + 1), args)
                if ( is_diff_transpose_mode ) args%transpose_mode = bmodes(d)
                if ( is_adaptive ) args%backend = bbacks(d)
                call self%plans(-d)%p%create(pencils(d + 1), pencils(d), args)
            enddo
            if ( self%is_z_slab ) then
                if ( is_diff_transpose_mode ) args%transpose_mode = fmodes(3)
                if ( is_adaptive ) args%backend = fbacks(3)
                call self%plans(3)%p%create(pencils(1), pencils(3), args)
                if ( is_diff_transpose_mode ) args%transpose_mode = bmodes(3)
                if ( is_adaptive ) args%backend = bbacks(3)
                call self%plans(-3)%p%create(pencils(3), pencils(1), args)
            endif
        endblock
        te = MPI_Wtime()
        WRITE_INFO("Time spent on creating final transpose plans: "//to_str(te - ts)//" [s]")

        call get_local_sizes(pencils, alloc_size=self%min_buffer_size)
        self%min_buffer_size = self%min_buffer_size * (base_storage / FLOAT_STORAGE_SIZE)
        allocate( self%names(CONF_DTFFT_TRANSPOSE_Z_TO_X:CONF_DTFFT_TRANSPOSE_X_TO_Z), self%colors(CONF_DTFFT_TRANSPOSE_Z_TO_X:CONF_DTFFT_TRANSPOSE_X_TO_Z) )
        do d = CONF_DTFFT_TRANSPOSE_Z_TO_X, CONF_DTFFT_TRANSPOSE_X_TO_Z
            self%names(d) = string("Transpose "//TRANSPOSE_NAMES(d))
            self%colors(d) = COLOR_TRANSPOSE_PALLETTE(d)
        end do
        deallocate( best_decomposition, comm_dims )
        error_code = DTFFT_SUCCESS
    end function create

    pure logical function get_z_slab(self)
    !! Returns .true. if Z-slab optimization is enabled
        class(transpose_plan),   intent(in)    :: self      !! Transposition class
        get_z_slab = self%is_z_slab
    end function get_z_slab

    pure logical function get_y_slab(self)
    !! Returns .true. if Y-slab optimization is enabled
        class(transpose_plan),   intent(in)    :: self      !! Transposition class
        get_y_slab = self%is_y_slab
    end function get_y_slab

    subroutine autotune_grid_decomposition(                                                                 &
        platform, dims, base_comm, effort, transpose_mode, base_dtype, base_storage, stream,                &
        fmodes, bmodes, best_decomposition, backend, min_execution_time, best_backend, best_transpose_mode, &
        fbacks, bbacks)
    !! Runs through all possible grid decompositions and selects the best one based on the lowest average execution time
        type(dtfft_platform_t),           intent(in)    :: platform
        !! Platform to use
        integer(int32),                   intent(in)    :: dims(:)
        !! Global sizes of the transform requested
        TYPE_MPI_COMM,                    intent(in)    :: base_comm
        !! 3D comm
        type(dtfft_effort_t),             intent(in)    :: effort
        !! Effort level for the plan creation
        type(dtfft_transpose_mode_t),     intent(in)    :: transpose_mode
        !! Transpose mode to use
        TYPE_MPI_DATATYPE,                intent(in)    :: base_dtype
        !! Base MPI_Datatype
        integer(int64),                   intent(in)    :: base_storage
        !! Number of bytes needed to store single element
        type(dtfft_stream_t),             intent(in)    :: stream
        !! Stream to use
        type(dtfft_transpose_mode_t),     intent(inout) :: fmodes(:)
            !! Best transpose modes for forward plan
        type(dtfft_transpose_mode_t),     intent(inout) :: bmodes(:)
            !! Best transpose modes for backward plan
        integer(int32),                   intent(out)   :: best_decomposition(:)
        !! Best decomposition found
        type(dtfft_backend_t),  optional, intent(in)    :: backend
        !! GPU Backend to test. Should be passed only when effort is `DTFFT_ESTIMATE` or `DTFFT_MEASURE`
        real(real32),           optional, intent(out)   :: min_execution_time
        !! Elapsed time for best plan selected
        type(dtfft_backend_t),  optional, intent(out)   :: best_backend
        !! Best backend selected
        type(dtfft_transpose_mode_t), optional, intent(out) :: best_transpose_mode
        !! Best transpose mode selected
        type(dtfft_backend_t),  optional, intent(out)   :: fbacks(:)
        !! Best backends for forward plans
        type(dtfft_backend_t),  optional, intent(out)   :: bbacks(:)
        !! Best backends for backward plans
        integer(int8)   :: ndims
        type(dtfft_backend_t) :: best_backend_
        type(dtfft_transpose_mode_t) :: best_transpose_mode_
        integer(int32)  :: comm_size, square_root, i, current_timer, k, ierr
        real(real32) :: current_time, elapsed_time
        real(real32), allocatable :: timers(:)
        integer(int32),   allocatable :: decomps(:,:)
        type(dtfft_backend_t), allocatable :: backends(:)
        type(dtfft_transpose_mode_t), allocatable :: transpose_modes(:)
        type(dtfft_transpose_mode_t),  allocatable :: forw_modes(:,:)        !! Best Forward ids are stored in forw_ids(:, latest_timer_id)
        type(dtfft_transpose_mode_t),  allocatable :: back_modes(:,:)        !! Best Backward ids are stored in back_ids(:, latest_timer_id)
        type(dtfft_transpose_mode_t) :: forw(3), back(3)
        type(dtfft_backend_t), allocatable :: fbacks_(:,:)
        type(dtfft_backend_t), allocatable :: bbacks_(:,:)
        type(dtfft_backend_t) :: fbacks_local(3), bbacks_local(3)

        call MPI_Comm_size(base_comm, comm_size, ierr)
        ndims = size(dims, kind=int8)

        square_root = int(sqrt(real(comm_size, real64))) + 1
        allocate(timers(2 * square_root))
        allocate(decomps(2, 2 * square_root))
        allocate(backends(2 * square_root))
        allocate(transpose_modes(2 * square_root))
        allocate(forw_modes(3, 2 * square_root))
        allocate(back_modes(3, 2 * square_root))
        allocate(fbacks_(3, 2 * square_root))
        allocate(bbacks_(3, 2 * square_root))

        current_timer = 0
        do i = 1, square_root - 1
            if ( mod( comm_size, i ) /= 0 ) cycle

            forw(:) = fmodes(:)
            back(:) = bmodes(:)

            call autotune_grid(                                                                                                                         &
                platform, dims, base_comm, effort, transpose_mode, base_dtype, [1, i, comm_size / i], base_storage, stream, forw, back,        &
                backend=backend, best_time=current_time, best_backend=best_backend_, best_transpose_mode=best_transpose_mode_, fbacks=fbacks_local, bbacks=bbacks_local)
            if ( current_time > 0.0 ) then
                current_timer = current_timer + 1
                timers(current_timer) = current_time
                decomps(1, current_timer) = i
                decomps(2, current_timer) = comm_size / i
                forw_modes(:, current_timer) = forw(:)
                back_modes(:, current_timer) = back(:)
                backends(current_timer) = best_backend_
                transpose_modes(current_timer) = best_transpose_mode_
                fbacks_(:, current_timer) = fbacks_local(:)
                bbacks_(:, current_timer) = bbacks_local(:)
            endif

            if ( i /= comm_size / i) then
                forw(:) = fmodes(:)
                back(:) = bmodes(:)

                call autotune_grid(                                                                                                                     &
                    platform, dims, base_comm, effort, transpose_mode, base_dtype, [1, comm_size / i, i], base_storage, stream, forw, back,    &
                    backend=backend, best_time=current_time, best_backend=best_backend_, best_transpose_mode=best_transpose_mode_, fbacks=fbacks_local, bbacks=bbacks_local)
                if ( current_time > 0.0 ) then
                    current_timer = current_timer + 1
                    timers(current_timer) = current_time
                    decomps(1, current_timer) = comm_size / i
                    decomps(2, current_timer) = i
                    forw_modes(:, current_timer) = forw(:)
                    back_modes(:, current_timer) = back(:)
                    backends(current_timer) = best_backend_
                    transpose_modes(current_timer) = best_transpose_mode_
                    fbacks_(:, current_timer) = fbacks_local(:)
                    bbacks_(:, current_timer) = bbacks_local(:)
                endif
            endif
        enddo

        ! This may happen if all `autotune_grid` return without executing due to grid constrains
        if ( current_timer == 0 ) then
            WRITE_WARN("Unable to execute grid autotuning. Setting default values")
            current_timer = 1
            elapsed_time = 0.0_real32

            call MPI_Dims_create(comm_size, 2, decomps(:, 1), ierr)
            if ( present( backend ) ) then
                if ( backend /= DTFFT_BACKEND_ADAPTIVE ) then
                    backends(1) = backend
                else
                    backends(1) = get_correct_backend(DTFFT_BACKEND_NONE)
                endif
            else
                backends(1) = get_correct_backend(DTFFT_BACKEND_NONE)
            endif
            if ( present(fbacks) .and. present(bbacks) ) then
                fbacks_(:, 1) = DTFFT_BACKEND_NONE;    fbacks_(:, 1) = get_correct_backend(fbacks_(:, 1))
                bbacks_(:, 1) = DTFFT_BACKEND_NONE;    bbacks_(:, 1) = get_correct_backend(bbacks_(:, 1))
            endif
            forw_modes(:, 1) = transpose_mode
            back_modes(:, 1) = transpose_mode
            transpose_modes(1) = transpose_mode
        endif

        elapsed_time = MAX_REAL32
        k = 1
        do i = 1, current_timer
            if ( timers(i) < elapsed_time ) then
                elapsed_time = timers(i)
                k = i
            endif
        enddo

        best_decomposition(1) = 1
        best_decomposition(2) = decomps(1, k)
        best_decomposition(3) = decomps(2, k)

        fmodes(:) = forw_modes(:, k)
        bmodes(:) = back_modes(:, k)
        if ( present(best_backend) ) best_backend = backends(k)
        if ( present(min_execution_time) ) min_execution_time = elapsed_time
        if ( present(best_transpose_mode) ) best_transpose_mode = transpose_modes(k)
        if ( present(fbacks) ) fbacks(:) = fbacks_(:, k)
        if ( present(bbacks) ) bbacks(:) = bbacks_(:, k)
        deallocate( timers, decomps, backends, transpose_modes, forw_modes, back_modes, fbacks_, bbacks_ )
    end subroutine autotune_grid_decomposition

    subroutine autotune_grid(                                                                                       &
        platform, dims, base_comm, effort, transpose_mode, base_dtype, comm_dims, base_storage, stream,             &
        fmodes, bmodes, backend, best_time, best_backend, best_transpose_mode, fbacks, bbacks)
    !! Creates cartesian grid and runs various backends on it. Returns best backend and execution time
        type(dtfft_platform_t),           intent(in)    :: platform
        !! Platform to create plan for
        integer(int32),                   intent(in)    :: dims(:)
        !! Global sizes of the transform requested
        TYPE_MPI_COMM,                    intent(in)    :: base_comm
        !! Basic communicator to create 3d grid from
        type(dtfft_effort_t),             intent(in)    :: effort
        !! Effort level for the plan creation
        type(dtfft_transpose_mode_t),     intent(in)    :: transpose_mode
        !! Transpose mode to use
        TYPE_MPI_DATATYPE,                intent(in)    :: base_dtype
        !! Base MPI_Datatype
        integer(int32),                   intent(in)    :: comm_dims(:)
        !! Number of processors in each dimension
        integer(int64),                   intent(in)    :: base_storage
        !! Number of bytes needed to store single element
        type(dtfft_stream_t),             intent(in)    :: stream
        !! Stream to use
        type(dtfft_transpose_mode_t),     intent(inout) :: fmodes(:)
            !! Best transpose modes for forward plan
        type(dtfft_transpose_mode_t),     intent(inout) :: bmodes(:)
            !! Best transpose modes for backward plan
        type(dtfft_backend_t),  optional, intent(in)    :: backend
        !! GPU Backend to test. Should be passed only when effort is `DTFFT_ESTIMATE` or `DTFFT_MEASURE`
        type(dtfft_backend_t),  optional, intent(out)   :: best_backend
        !! Best backend selected for the grid
        real(real32),           optional, intent(out)   :: best_time
        !! Elapsed time for best plan selected
        type(dtfft_transpose_mode_t), optional, intent(out) :: best_transpose_mode
        !! Best transpose mode selected
        type(dtfft_backend_t),  optional,       intent(out) :: fbacks(:)
        !! Best backends for forward plans
        type(dtfft_backend_t),  optional,       intent(out) :: bbacks(:)
        !! Best backends for backward plans
        type(pencil), allocatable :: pencils(:)
        character(len=:),             allocatable   :: phase_name           !! Caliper phase name
        integer(int8) :: d, ndims
        TYPE_MPI_COMM, allocatable :: comms(:)
        TYPE_MPI_COMM :: cart_comm
        integer(int32) :: mpi_ierr
        integer(int8), allocatable :: cperm(:,:), dperm(:,:)

        best_time = -1.0
        ndims = size(dims, kind=int8)

        if ( ndims == 3 ) then
            call get_permutations(ndims, dperm, cperm)
            do d = 1, ndims
                if ( dims(dperm(2, d)) < comm_dims(cperm(2, d)) .or. dims(dperm(3, d)) < comm_dims(cperm(3, d)) ) then
                    deallocate(dperm, cperm)
                    return
                endif
            enddo
            deallocate(dperm, cperm)
            allocate( phase_name, source = "Testing grid 1x"//to_str(comm_dims(2))//"x"//to_str(comm_dims(3)) )
        else
            allocate( phase_name, source = "Testing grid 1x"//to_str(comm_dims(2)) )
        endif

        WRITE_INFO("")
        WRITE_INFO(phase_name)
        REGION_BEGIN(phase_name, COLOR_AUTOTUNE)

        allocate( comms(ndims), pencils(ndims) )
        call create_pencils_and_comm(dims, base_comm, comm_dims, cart_comm, comms, pencils)

        call run_autotune_backend(platform, comms, cart_comm, effort, transpose_mode, base_dtype, pencils, base_storage, stream, .false., .false.,   &
            fmodes, bmodes, backend, best_time, best_backend, best_transpose_mode, fbacks, bbacks)

        do d = 1, ndims
            call pencils(d)%destroy()
            call MPI_Comm_free(comms(d), mpi_ierr)
        enddo
        call MPI_Comm_free(cart_comm, mpi_ierr)
        deallocate( comms, pencils )
        REGION_END(phase_name)
    end subroutine autotune_grid

    subroutine run_autotune_backend(                                                                                            &
        platform, comms, cart_comm, effort, transpose_mode, base_dtype, pencils, base_storage, stream, is_z_slab, is_y_slab,    &
        fmodes, bmodes, backend, best_time, best_backend, best_transpose_mode, fbacks, bbacks)
    !! Runs autotune for all backends
        type(dtfft_platform_t),           intent(in)    :: platform         !! Platform to create plan for
        TYPE_MPI_COMM,                    intent(in)    :: comms(:)         !! 1D comms
        TYPE_MPI_COMM,                    intent(in)    :: cart_comm        !! 3D Cartesian comm
        type(dtfft_effort_t),             intent(in)    :: effort           !! Effort level for the plan creation
        type(dtfft_transpose_mode_t),     intent(in)    :: transpose_mode   !! Transpose mode to use
        TYPE_MPI_DATATYPE,                intent(in)    :: base_dtype       !! Base MPI_Datatype
        type(pencil),                     intent(in)    :: pencils(:)       !! Layouts
        integer(int64),                   intent(in)    :: base_storage     !! Number of bytes needed to store single element
        type(dtfft_stream_t),             intent(in)    :: stream           !! Stream to use
        logical,                          intent(in)    :: is_z_slab        !! Is Z-slab optimization enabled
        logical,                          intent(in)    :: is_y_slab        !! Is Y-slab optimization enabled
        type(dtfft_transpose_mode_t),     intent(inout) :: fmodes(:)
            !! Best transpose modes for forward plan
        type(dtfft_transpose_mode_t),     intent(inout) :: bmodes(:)
            !! Best transpose modes for backward plan
        type(dtfft_backend_t),  optional, intent(in)    :: backend
        !! GPU Backend to test. Should be passed only when effort is `DTFFT_ESTIMATE` or `DTFFT_MEASURE`
        real(real32),           optional, intent(out)   :: best_time
        !! Elapsed time for best backend
        type(dtfft_backend_t),  optional, intent(out)   :: best_backend
        !! Best backend selected
        type(dtfft_transpose_mode_t), optional, intent(out) :: best_transpose_mode
        !! Best transpose mode selected
        type(dtfft_backend_t),  optional,       intent(out) :: fbacks(:)
        type(dtfft_backend_t),  optional,       intent(out) :: bbacks(:)
        type(dtfft_backend_t),  allocatable :: backends_to_run(:), fbacks_(:), bbacks_(:)
        type(dtfft_backend_t) :: current_backend_id, best_backend_
        type(dtfft_transpose_mode_t) :: best_transpose_mode_
        logical :: is_udb !! Used defined backend
        real(real32) :: execution_time, best_time_
        integer(int32) :: b
        ! type(reshape_container), allocatable :: plans(:)
        integer(int8) :: j !i, j, n_transpose_plans
        ! logical :: is_aux_alloc
        ! integer(int64)         :: alloc_size
        logical :: nccl_enabled
#ifdef DTFFT_WITH_CUDA
        logical :: nvshmem_enabled
#endif
        type(dtfft_backend_t) :: backend_
        type(backend_helper)                      :: helper
        type(create_args) :: create_kwargs
        logical :: pipe_enabled, mpi_enabled, dtype_enabled, rma_enabled, fused_enabled
        logical :: compressed_enabled
#ifdef DTFFT_WITH_COMPRESSION
        type(dtfft_compression_config_t) :: conf
#endif
        integer(int32) :: n_transpose_plans
        real(real32), allocatable :: ftimes(:), btimes(:)

        n_transpose_plans = size(pencils, kind=int8) - 1_int8
        if ( is_z_slab ) n_transpose_plans = n_transpose_plans + 1

        allocate( fbacks_(n_transpose_plans), source=DTFFT_BACKEND_NONE )
        allocate( bbacks_(n_transpose_plans), source=DTFFT_BACKEND_NONE )
        allocate( ftimes(n_transpose_plans), source=MAX_REAL32 )
        allocate( btimes(n_transpose_plans), source=MAX_REAL32 )

        fbacks_(:) = DTFFT_BACKEND_NONE;   fbacks_(:) = get_correct_backend(fbacks_)
        bbacks_(:) = DTFFT_BACKEND_NONE;   bbacks_(:) = get_correct_backend(bbacks_)
        ftimes(:) = MAX_REAL32
        btimes(:) = MAX_REAL32
        if ( is_z_slab ) then
            ftimes(1:2) = 0.0_real32
            btimes(1:2) = 0.0_real32
        else if ( is_y_slab ) then
            ftimes(2) = 0.0_real32
            btimes(2) = 0.0_real32
        endif

        backend_ = DTFFT_BACKEND_NONE
        is_udb = .false.
        if ( present(backend) ) then
            backend_ = backend
            if ( backend == DTFFT_BACKEND_ADAPTIVE ) then
                allocate( backends_to_run, source=VALID_BACKENDS(1:size(VALID_BACKENDS) - 1) )
            else
                allocate( backends_to_run(1) )
                backends_to_run(1) = backend
                is_udb = .true.
            endif
        else
            allocate( backends_to_run, source=VALID_BACKENDS(1:size(VALID_BACKENDS) - 1) )
        endif
        best_backend_ = backends_to_run(1)

        pipe_enabled = get_conf_pipelined_enabled()
        dtype_enabled = get_conf_datatype_enabled()
        mpi_enabled = get_conf_mpi_enabled()
        rma_enabled = get_conf_rma_enabled()
        fused_enabled = get_conf_fused_enabled()
        nccl_enabled = .false.
#ifdef DTFFT_WITH_CUDA
        nccl_enabled = ( platform == DTFFT_PLATFORM_CUDA .and. get_conf_nccl_enabled() ) .or. ( is_udb .and. is_backend_nccl( backends_to_run(1) ) )
        nvshmem_enabled = get_conf_nvshmem_enabled()
#endif

        compressed_enabled = .false.
#ifdef DTFFT_WITH_COMPRESSION
        conf = get_conf_transpose()
        compressed_enabled = get_conf_compression_enabled() .and. conf%compression_mode == DTFFT_COMPRESSION_MODE_FIXED_RATE
#endif

        call helper%create(platform, cart_comm, comms, nccl_enabled, pencils)

        create_kwargs%effort = DTFFT_ESTIMATE
        create_kwargs%force_effort = .true.
        create_kwargs%platform = platform
        create_kwargs%helper = helper
        create_kwargs%base_type = base_dtype
        create_kwargs%base_storage = base_storage
        create_kwargs%transpose_mode = transpose_mode
#ifdef DTFFT_WITH_COMPRESSION
        create_kwargs%compression_config = conf
#endif

        best_transpose_mode_ = transpose_mode
        fmodes(:) = transpose_mode
        bmodes(:) = transpose_mode

        best_time_ = MAX_REAL32

        do b = 1, size(backends_to_run)
            current_backend_id = backends_to_run(b)
            if ( .not.is_udb) then
                if ( is_backend_pipelined(current_backend_id) .and. .not.pipe_enabled ) cycle
                if ( is_backend_mpi(current_backend_id) .and. .not.mpi_enabled .and. .not.current_backend_id == DTFFT_BACKEND_MPI_DATATYPE ) cycle
                if ( current_backend_id == DTFFT_BACKEND_MPI_DATATYPE .and. .not.dtype_enabled ) cycle
                if ( is_backend_rma(current_backend_id) .and. .not.rma_enabled ) cycle
                if ( is_backend_fused(current_backend_id) .and. .not. fused_enabled) cycle
                if ( is_backend_compressed(current_backend_id) .and. .not. compressed_enabled ) cycle
                if ( current_backend_id == DTFFT_BACKEND_ADAPTIVE ) cycle
#ifdef DTFFT_WITH_CUDA
                if ( platform == DTFFT_PLATFORM_CUDA ) then
                    if ( is_backend_nvshmem(current_backend_id) .and. .not.nvshmem_enabled ) cycle
                    if ( is_backend_nccl(current_backend_id) .and. .not.nccl_enabled) cycle
                    if ( current_backend_id == DTFFT_BACKEND_MPI_DATATYPE ) cycle
                else
                    if ( is_backend_nccl(current_backend_id) .or. is_backend_nvshmem(current_backend_id) ) cycle
                endif
#endif
            endif

            create_kwargs%backend = current_backend_id

            if ( backend_ == DTFFT_BACKEND_ADAPTIVE ) then
                block
                    type(dtfft_transpose_mode_t), allocatable :: lfmodes(:), lbmodes(:)
                    real(real32), allocatable :: lftimes(:), lbtimes(:)
                    integer(int32) :: i

                    allocate( lftimes(n_transpose_plans), lbtimes(n_transpose_plans) )
                    allocate( lfmodes(n_transpose_plans), lbmodes(n_transpose_plans) )

                    call execute_single(backend_, effort, create_kwargs, helper, pencils, is_z_slab, is_y_slab, lfmodes, lbmodes, lftimes, lbtimes)
                    if ( is_z_slab ) then
                        if ( lftimes(3) < ftimes(3) ) then
                            fmodes(3) = lfmodes(3)
                            fbacks_(3) = current_backend_id
                            ftimes(3) = lftimes(3)
                        endif
                        if ( lbtimes(3) < btimes(3) ) then
                            bmodes(3) = lbmodes(3)
                            bbacks_(3) = current_backend_id
                            btimes(3) = lbtimes(3)
                        endif
                    else
                        do i = 1, n_transpose_plans
                            if ( lftimes(i) < ftimes(i) ) then
                                fmodes(i) = lfmodes(i)
                                fbacks_(i) = current_backend_id
                                ftimes(i) = lftimes(i)
                            endif
                            if ( lbtimes(i) < btimes(i) ) then
                                bmodes(i) = lbmodes(i)
                                bbacks_(i) = current_backend_id
                                btimes(i) = lbtimes(i)
                            endif
                        enddo
                    endif

                    deallocate(lftimes, lbtimes, lfmodes, lbmodes)
                endblock
            else

                if ( .not.(current_backend_id == DTFFT_BACKEND_MPI_DATATYPE .or. platform == DTFFT_PLATFORM_CUDA) .and. effort == DTFFT_EXHAUSTIVE ) then
                    do j = CONF_DTFFT_TRANSPOSE_MODE_PACK, CONF_DTFFT_TRANSPOSE_MODE_UNPACK
                        create_kwargs%transpose_mode = dtfft_transpose_mode_t(j)
                        execution_time = execute_many(cart_comm, create_kwargs, pencils, helper, is_z_slab, is_y_slab, effort, stream, fmodes, bmodes)
                        if ( execution_time < best_time_ ) then
                            best_transpose_mode_ = dtfft_transpose_mode_t(j)
                        endif
                    enddo
                else
                    execution_time = execute_many(cart_comm, create_kwargs, pencils, helper, is_z_slab, is_y_slab, effort, stream, fmodes, bmodes)
                endif

                if ( execution_time < best_time_ ) then
                    best_time_ = execution_time
                    best_backend_ = current_backend_id
                endif
            endif
        enddo

        call helper%destroy()

        if ( present(best_time)) then
            if ( backend_ == DTFFT_BACKEND_ADAPTIVE ) then
                best_time = sum(ftimes) + sum(btimes)
            else
                best_time = best_time_
            endif
        endif
        if ( present(best_backend) ) best_backend = best_backend_
        if ( present(best_transpose_mode) ) best_transpose_mode = best_transpose_mode_
        if ( present(fbacks) ) fbacks(:size(fbacks_)) = fbacks_(:)
        if ( present(bbacks) ) bbacks(:size(bbacks_)) = bbacks_(:)
    end subroutine run_autotune_backend

    real(real32) function execute_many(cart_comm, create_kwargs, pencils, helper, is_z_slab, is_y_slab, effort, stream, fmodes, bmodes)
    !! 
        TYPE_MPI_COMM,                  intent(in)    :: cart_comm      !! 3D Cartesian comm
        type(create_args),              intent(inout) :: create_kwargs  !! Create arguments
        type(pencil),                   intent(in)    :: pencils(:)     !! Layouts
        type(backend_helper),           intent(inout) :: helper
        logical,                        intent(in)    :: is_z_slab      !! Is Z-slab optimization enabled
        logical,                        intent(in)    :: is_y_slab      !! Is Y-slab optimization enabled
        type(dtfft_effort_t),           intent(in)    :: effort         !! Effort level for the plan creation
        type(dtfft_stream_t),           intent(in)    :: stream         !! Stream to use
        type(dtfft_transpose_mode_t),   intent(inout) :: fmodes(:)      !! Best transpose modes for forward plan
        type(dtfft_transpose_mode_t),   intent(inout) :: bmodes(:)      !! Best transpose modes for backward plan
        type(reshape_container), allocatable :: plans(:)
        integer(int64)         :: alloc_size
        integer(int32) :: i, n_transpose_plans
        character(len=:), allocatable :: testing_phase

        if ( is_z_slab ) then
            n_transpose_plans = 1
        else
            n_transpose_plans = size(pencils, kind=int8) - 1_int8
        endif

        if ( is_y_slab ) then
            n_transpose_plans = n_transpose_plans - 1_int8
        endif

        allocate( plans(2 * n_transpose_plans) )

        call allocate_plans(plans, create_kwargs%backend)
        if ( create_kwargs%backend == DTFFT_BACKEND_MPI_DATATYPE .or. create_kwargs%platform == DTFFT_PLATFORM_CUDA ) then
            allocate( testing_phase, source="Testing backend "//dtfft_get_backend_string(create_kwargs%backend) )
        else
            allocate( testing_phase, source="Testing backend "//dtfft_get_backend_string(create_kwargs%backend)//", transpose mode = "//trim(TRANSPOSE_MODE_NAMES(create_kwargs%transpose_mode%val)) )
        endif
        REGION_BEGIN(testing_phase, COLOR_AUTOTUNE2)
        WRITE_INFO(testing_phase)

        call get_local_sizes(pencils, alloc_size=alloc_size)
        alloc_size = alloc_size * create_kwargs%base_storage

        if ( create_kwargs%backend == DTFFT_BACKEND_MPI_DATATYPE .and. effort%val >= DTFFT_PATIENT%val) then
            block
                real(real32) :: ftimes(3), btimes(3)
                call execute_single(DTFFT_BACKEND_MPI_DATATYPE, effort, create_kwargs, helper, pencils, is_z_slab, is_y_slab, fmodes, bmodes, ftimes, btimes, .true.)
                execute_many = sum(ftimes) + sum(btimes)
                WRITE_INFO("  Execution time on a grid using fastest transpositions: "//to_str(real(execute_many, real64))//" [ms]")
            endblock
        else
            if ( is_z_slab ) then
                call plans(1)%p%create(pencils(1), pencils(3), create_kwargs)
                call plans(2)%p%create(pencils(3), pencils(1), create_kwargs)
            else
                do i = 1, n_transpose_plans
                    call plans(i)%p%create(pencils(i), pencils(i + 1), create_kwargs)
                    call plans(i + n_transpose_plans)%p%create(pencils(i + 1), pencils(i), create_kwargs)
                enddo
            endif
            execute_many = execute_autotune(plans, cart_comm, create_kwargs%backend, create_kwargs%platform, helper, stream, alloc_size)
        endif

        call destroy_plans(plans)
        deallocate(plans)
        REGION_END(testing_phase)
        deallocate(testing_phase)
    end function execute_many

    subroutine execute_single(                                                                                      &
        base_backend, effort, create_kwargs, helper, pencils,                                                       &
        is_z_slab, is_y_slab, fmodes, bmodes, ftimes, btimes, phase_created)
    !! Executes autotuning over all single transpose plans and returns best transpose modes and their execution times
        type(dtfft_backend_t),          intent(in)    :: base_backend   !! Backend to test
        type(dtfft_effort_t),           intent(in)    :: effort         !! Effort level for the plan creation
        type(create_args),              intent(inout) :: create_kwargs  !! Create arguments
        type(backend_helper),           intent(inout) :: helper         !! Base MPI_Datatype
        type(pencil),                   intent(in)    :: pencils(:)     !! Pencils metadata
        logical,                        intent(in)    :: is_z_slab      !! Is Z-slab optimization enabled
        logical,                        intent(in)    :: is_y_slab      !! Is Y-slab optimization enabled
        type(dtfft_transpose_mode_t),   intent(inout) :: fmodes(:)      !! Best transpose modes for forward plan
        type(dtfft_transpose_mode_t),   intent(inout) :: bmodes(:)      !! Best transpose modes for backward plan
        real(real32),                   intent(out)   :: ftimes(:)      !! Elapsed time for best forward plans selected in [ms]
        real(real32),                   intent(out)   :: btimes(:)      !! Elapsed time for best backward plans selected in [ms]
        logical,         optional,      intent(in)    :: phase_created  !! Whether caliper phase was created
        integer(int8)                   :: dim              !! Counter
        integer(int8)                   :: ndims            !! Number of dimensions
        character(len=:),   allocatable :: testing_phase    !! Caliper phase name
        logical :: phase_created_

        ndims = size(pencils, kind=int8)
        if ( is_y_slab ) ndims = ndims - 1_int8

        ftimes(:) = 0._real32
        btimes(:) = 0._real32

        phase_created_ = .false.; if ( present(phase_created) ) phase_created_ = phase_created
        if ( .not.phase_created_ ) then
            allocate( testing_phase, source="Testing backend "//dtfft_get_backend_string(create_kwargs%backend) )
            REGION_BEGIN(testing_phase, COLOR_AUTOTUNE2)
            WRITE_INFO(testing_phase)
        endif

        if( is_z_slab ) then
            call execute_single_transpose_modes(base_backend, effort, create_kwargs, helper, pencils(1), pencils(3), 3_int8, fmodes(3), bmodes(3), ftimes(3), btimes(3))
        else
            do dim = 1_int8, ndims - 1_int8
                call execute_single_transpose_modes(base_backend, effort, create_kwargs, helper, pencils(dim), pencils(dim + 1), dim, fmodes(dim), bmodes(dim), ftimes(dim), btimes(dim))
            enddo
        endif
        if ( .not.phase_created_ ) then
            REGION_END(testing_phase)
            deallocate( testing_phase )
        endif
    end subroutine execute_single

    subroutine execute_single_transpose_modes(base_backend, effort, create_kwargs, helper, from, to, transpose_name_id, fmode, bmode, forward_time, backward_time)
    !! Creates forward and backward transpose plans for backend, specified by `create_kwargs`, based on source and target data distributions and,
    !! executes them `DTFFT_MEASURE_ITERS` times ( 4 * `DTFFT_MEASURE_ITERS` iterations total ) + 4 * `DTFFT_MEASURE_WARMUP_ITERS` warmup iterations
    !!
    !! Returns elapsed time for best plans selected
        type(dtfft_backend_t),          intent(in)      :: base_backend         !! 
        type(dtfft_effort_t),           intent(in)      :: effort
        type(create_args),              intent(inout)   :: create_kwargs
        type(backend_helper),           intent(inout)   :: helper               !! Backend helper
        type(pencil),                   intent(in)      :: from                 !! Source meta
        type(pencil),                   intent(in)      :: to                   !! Target meta
        integer(int8),                  intent(in)      :: transpose_name_id    !! ID of transpose name (from -3 to 3, except 0)
        type(dtfft_transpose_mode_t),   intent(out)     :: fmode           !! Best forward plan ID
        type(dtfft_transpose_mode_t),   intent(out)     :: bmode          !! Best backward plan ID
        real(real32),                   intent(out)     :: forward_time         !! Forward plan execution time
        real(real32),                   intent(out)     :: backward_time        !! Backward plan execution time
        real(real32)                    :: time                 !! Timer
        integer(int32)                  :: transpose_mode          !! Counter
        type(dtfft_transpose_mode_t)    :: tmode

        forward_time = huge(1._real32)
        backward_time = huge(1._real32)

        if ( base_backend == DTFFT_BACKEND_MPI_DATATYPE .or. effort == DTFFT_EXHAUSTIVE ) then
            do transpose_mode = CONF_DTFFT_TRANSPOSE_MODE_PACK, CONF_DTFFT_TRANSPOSE_MODE_UNPACK
                tmode = dtfft_transpose_mode_t(transpose_mode)
                create_kwargs%transpose_mode = tmode

                time = run_execute_single(create_kwargs, helper, from, to, transpose_name_id)
                if ( time < forward_time ) then
                    forward_time = time
                    fmode = tmode
                endif

                time = run_execute_single(create_kwargs, helper, to, from, -1_int8 * transpose_name_id)
                if ( time < backward_time ) then
                    backward_time = time
                    bmode = tmode
                endif
            enddo
        else
            forward_time = run_execute_single(create_kwargs, helper, from, to, transpose_name_id); fmode = create_kwargs%transpose_mode
            backward_time = run_execute_single(create_kwargs, helper, to, from, -1_int8 * transpose_name_id); bmode = create_kwargs%transpose_mode
        endif
    end subroutine execute_single_transpose_modes

    function run_execute_single(create_kwargs, helper, from, to, transpose_name_id) result(elapsed_time)
    !! Creates transpose plan for backend, specified by `create_kwargs` and executes it `DTFFT_MEASURE_WARMUP_ITERS` + `DTFFT_MEASURE_ITERS` times
    !!
    !! Returns elapsed time
        type(create_args),            intent(inout) :: create_kwargs
        type(backend_helper),         intent(inout) :: helper               !! Backend helper
        type(pencil),                 intent(in)    :: from                 !! Source meta
        type(pencil),                 intent(in)    :: to                   !! Target meta
        integer(int8),                intent(in)    :: transpose_name_id    !! ID of transpose name (from -3 to 3, except 0)
        real(real32)                                :: elapsed_time         !! Execution time [ms]
        character(len=:),             allocatable   :: phase_name           !! Caliper phase name
        type(reshape_container) :: plan(1)
        integer(int64)  :: buffer_size

        allocate( phase_name, source="  Testing plan "//TRANSPOSE_NAMES(transpose_name_id)//", transpose mode = "//trim(TRANSPOSE_MODE_NAMES(create_kwargs%transpose_mode%val)) )
        REGION_BEGIN(phase_name, 0)
        WRITE_INFO(phase_name)

        call allocate_plans(plan, create_kwargs%backend)

        call plan(1)%p%create(from, to, create_kwargs)
        buffer_size = create_kwargs%base_storage * max( product(from%counts), product(to%counts) )
        elapsed_time = execute_autotune(plan, helper%comms(1), create_kwargs%backend, DTFFT_PLATFORM_HOST, helper, NULL_STREAM, buffer_size, 4)

        call destroy_plans(plan)
        REGION_END(phase_name)
        deallocate(phase_name)
    end function run_execute_single

    subroutine get_permutations(ndims, dperm, cperm)
    !! Returns data and communicator permutations for given number of dimensions
        integer(int8),              intent(in)  :: ndims        !! Number of dimensions
        integer(int8), allocatable, intent(out) :: dperm(:,:)   !! Data permutations
        integer(int8), allocatable, intent(out) :: cperm(:,:)   !! Communicator permutations

        allocate(dperm(ndims, ndims), cperm(ndims, ndims))
        if ( ndims == 2_int8 ) then
            dperm(1, 1) = 1
            dperm(2, 1) = 2
            cperm(:, 1) = dperm(:, 1)

            dperm(1, 2) = 2
            dperm(2, 2) = 1

            cperm(:, 2) = cperm(:, 1)
        else
            dperm(1, 1) = 1
            dperm(2, 1) = 2
            dperm(3, 1) = 3
            cperm(:, 1) = dperm(:, 1)

            dperm(1, 2) = 2
            dperm(2, 2) = 3
            dperm(3, 2) = 1

            cperm(1, 2) = 1
            cperm(2, 2) = 3
            cperm(3, 2) = 2

            dperm(1, 3) = 3
            dperm(2, 3) = 1
            dperm(3, 3) = 2

            cperm(:, 3) = cperm(:, 1)
        endif
    end subroutine get_permutations

    subroutine create_pencils_and_comm(dims, old_comm, comm_dims, comm, local_comms, pencils, ipencil)
    !! Creates cartesian communicator
        integer(int32),       intent(in)            :: dims(:)              !! Global dimensions
        TYPE_MPI_COMM,        intent(in)            :: old_comm             !! Communicator to create cartesian from
        integer(int32),       intent(in)            :: comm_dims(:)         !! Dims in cartesian communicator
        TYPE_MPI_COMM,        intent(out)           :: comm                 !! Cartesian communicator
        TYPE_MPI_COMM,        intent(out)           :: local_comms(:)       !! 1d communicators in cartesian communicator
        type(pencil),         intent(out)           :: pencils(:)           !! Data distributing meta
        type(pencil_init),    intent(in), optional  :: ipencil              !! Pencil passed by user
        integer(int8)         :: ndims              !! Number of dimensions
        integer(int8)         :: d                  !! Counter
        integer(int8) :: i, j
        integer(int8),  allocatable :: dperm(:,:), cperm(:, :)
        integer(int32), allocatable :: transposed_dims(:,:)
        TYPE_MPI_COMM,  allocatable :: transposed_comms(:,:)
        integer(int32), allocatable :: lstarts(:), lcounts(:)

        ndims = size(comm_dims, kind=int8)
        call create_cart_comm(old_comm, comm_dims, comm, local_comms, ipencil=ipencil)
        call get_permutations(ndims, dperm, cperm)

        allocate( transposed_dims(ndims, ndims), transposed_comms(ndims, ndims) )
        do i = 1, ndims
            do j = 1, ndims
                transposed_dims(j, i) = dims(dperm(j, i))
                transposed_comms(j, i) = local_comms(cperm(j, i))
            enddo
        enddo
        deallocate( dperm, cperm )

        if ( present(ipencil) ) then
            allocate(lstarts, source=ipencil%starts)
            allocate(lcounts, source=ipencil%counts)
            do d = 1, ndims
                call pencils(d)%create(ndims, d, transposed_dims(:, d), transposed_comms(:, d), lstarts=lstarts, lcounts=lcounts)
                lcounts(:) = pencils(d)%counts(:)
                lstarts(:) = pencils(d)%starts(:)
            enddo

            deallocate(lstarts, lcounts)
        else
            do d = 1, ndims
                call pencils(d)%create(ndims, d, transposed_dims(:,d), transposed_comms(:, d))
            enddo
        endif

        deallocate(transposed_dims, transposed_comms)
    end subroutine create_pencils_and_comm

    subroutine create_cart_comm(old_comm, comm_dims, comm, local_comms, ipencil)
    !! Creates cartesian communicator
        TYPE_MPI_COMM,        intent(in)            :: old_comm             !! Communicator to create cartesian from
        integer(int32),       intent(in)            :: comm_dims(:)         !! Dims in cartesian communicator
        TYPE_MPI_COMM,        intent(out)           :: comm                 !! Cartesian communicator
        TYPE_MPI_COMM,        intent(out)           :: local_comms(:)       !! 1d communicators in cartesian communicator
        type(pencil_init),    intent(in), optional  :: ipencil              !! Pencil passed by user
        logical,              allocatable   :: periods(:)           !! Grid is not periodic
        logical,              allocatable   :: remain_dims(:)       !! Needed by MPI_Cart_sub
        integer(int8)                       :: dim                  !! Counter
        integer(int32)                      :: ierr                 !! Error code
        integer(int8)                       :: ndims
        TYPE_MPI_COMM              :: temp_cart_comm
        TYPE_MPI_COMM, allocatable :: temp_comms(:)

        ndims = size(comm_dims, kind=int8)

        if ( present( ipencil ) ) then
            call MPI_Comm_dup(old_comm, comm, ierr)
            do dim = 1, ndims
                call MPI_Comm_dup(ipencil%comms(dim), local_comms(dim), ierr)
            enddo
            return
        endif
        allocate(periods(ndims), source = .false.)

        call MPI_Cart_create(old_comm, int(ndims, int32), comm_dims, periods, .true., temp_cart_comm, ierr)
        call create_subcomm_include_all(temp_cart_comm, comm)
        if ( GET_MPI_VALUE(comm) == GET_MPI_VALUE(MPI_COMM_NULL) ) then
            INTERNAL_ERROR("comm == MPI_COMM_NULL")
        endif

        allocate(temp_comms(ndims))

        allocate( remain_dims(ndims), source = .false. )
        do dim = 1, ndims
            remain_dims(dim) = .true.
            call MPI_Cart_sub(temp_cart_comm, remain_dims, temp_comms(dim), ierr)
            call create_subcomm_include_all(temp_comms(dim), local_comms(dim))
            if ( GET_MPI_VALUE(local_comms(dim)) == GET_MPI_VALUE(MPI_COMM_NULL) ) then
                INTERNAL_ERROR("local_comms(dim) == MPI_COMM_NULL: dim = "//to_str(dim))
            endif
            remain_dims(dim) = .false.
        enddo
        call MPI_Comm_free(temp_cart_comm, ierr)
        do dim = 1, ndims
            call MPI_Comm_free(temp_comms(dim), ierr)
        enddo
        deallocate(temp_comms)
        deallocate(remain_dims, periods)
    end subroutine create_cart_comm
end module dtfft_transpose_plan

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
program test_r2r_3d
!------------------------------------------------------------------------------------------------
!< This program shows how to use dtFFT with Real-to-Real 3d transform
!< It also tests user-defined 1d communicator
!------------------------------------------------------------------------------------------------
use iso_fortran_env
use iso_c_binding, only: c_loc, c_ptr, c_int
use dtfft
use test_utils
#if defined(DTFFT_WITH_CUDA)
use dtfft_interface_cuda_runtime
#include "_dtfft_cuda.h"
#endif
#include "_dtfft_mpi.h"
#include "dtfft.f03"
implicit none
  type(c_ptr) :: check
  real(real64), pointer :: in(:), out(:)
#if defined(DTFFT_WITH_CUDA) && !defined(DTFFT_WITH_MOCK_ENABLED)
  integer(int32), parameter :: nx = 1024, ny = 1024, nz = 16
#else
  integer(int32), parameter :: nx = 512, ny = 32, nz = 8
#endif
  integer(int32) :: comm_size, comm_rank
  class(dtfft_plan_t), allocatable :: plan
  integer(int32) :: in_counts(3), out_counts(3), ierr
  type(dtfft_r2r_kind_t) :: kinds(3)
  integer(int32) :: iter
  type(dtfft_executor_t) :: executor
  real(real64) :: tf, tb, temp
  integer(int64) :: alloc_size, in_size, out_size
  TYPE_MPI_COMM :: comm
#if defined(DTFFT_WITH_CUDA)
  type(dtfft_stream_t) :: stream
  type(dtfft_platform_t) :: platform
#endif
  type(dtfft_config_t) :: conf
  type(dtfft_effort_t) :: effort
  ! interface
  !   subroutine cali_flush(val) bind(C)
  !     import
  !     integer(c_int), intent(in), value :: val
  !   end subroutine cali_flush
  ! end interface

  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, comm_size, ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)

  if(comm_rank == 0) then
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a)') "|       dtFFT test: r2r_3d             |"
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a, i0, a, i0, a, i0)') 'Nx = ',nx, ', Ny = ',ny, ', Nz = ',nz
    write(output_unit, '(a, i0)') 'Number of processors: ', comm_size
  endif

  call attach_gpu_to_process()

  call MPI_Cart_create(MPI_COMM_WORLD, 1, [comm_size], [.false.], .false., comm, ierr)


  kinds(:) = DTFFT_DCT_2
  executor = DTFFT_EXECUTOR_NONE

#if defined (DTFFT_WITH_FFTW)
  executor = DTFFT_EXECUTOR_FFTW3
#endif

  conf = dtfft_config_t()
  conf%enable_z_slab = .true.
  conf%enable_y_slab = .true.
  conf%enable_mpi_backends = .true.
! #ifdef DTFFT_WITH_COMPRESSION
!   conf%backend = DTFFT_BACKEND_MPI_P2P_COMPRESSED
!   conf%compression_config_transpose%compression_mode = DTFFT_COMPRESSION_MODE_FIXED_RATE
!   conf%compression_config_transpose%rate = 16.0
!   ! conf%compression_config_transpose%compression_mode = DTFFT_COMPRESSION_MODE_FIXED_ACCURACY
!   ! conf%compression_config_transpose%tolerance = 1.e-6_real64
!   effort = DTFFT_MEASURE
! #else
  effort = DTFFT_MEASURE!DTFFT_PATIENT
  conf%enable_mpi_backends = .false.
! #endif

#if defined(DTFFT_WITH_CUDA)
  block
    character(len=5) :: platform_env
    integer(int32) :: env_len

    call get_environment_variable("DTFFT_PLATFORM", platform_env, env_len)

    if ( env_len == 0 .or. trim(adjustl(platform_env)) == "cuda" ) then
      conf%backend = DTFFT_BACKEND_MPI_P2P
      conf%platform = DTFFT_PLATFORM_CUDA
# if defined( DTFFT_WITH_VKFFT ) && !defined(DTFFT_WITH_MOCK_ENABLED)
      executor = DTFFT_EXECUTOR_VKFFT
# endif
    endif
  endblock
#endif

  call dtfft_set_config(conf, error_code=ierr); DTFFT_CHECK(ierr)
  allocate( dtfft_plan_r2r_t :: plan )
  select type (plan)
  class is ( dtfft_plan_r2r_t )
    call plan%create([nx, ny, nz], kinds, comm=MPI_COMM_WORLD, effort=effort, executor=executor, error_code=ierr); DTFFT_CHECK(ierr)
  endselect
  call plan%report(error_code=ierr); DTFFT_CHECK(ierr)
  call plan%get_local_sizes(in_counts=in_counts, out_counts=out_counts, alloc_size=alloc_size, error_code=ierr); DTFFT_CHECK(ierr)

  call MPI_Comm_free(comm, ierr)

  call plan%mem_alloc(alloc_size, in, error_code=ierr); DTFFT_CHECK(ierr)
  call plan%mem_alloc(alloc_size, out, error_code=ierr); DTFFT_CHECK(ierr)

  in_size = product(in_counts)
  out_size = product(out_counts)

  check = mem_alloc_host(in_size * DOUBLE_STORAGE_SIZE)
  call setTestValuesDouble(check, in_size)

#if defined(DTFFT_WITH_CUDA)
  platform = plan%get_platform(error_code=ierr); DTFFT_CHECK(ierr)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    call plan%get_stream(stream, error_code=ierr); DTFFT_CHECK(ierr)
  endif
  call doubleH2D(check, c_loc(in), in_size, platform%val)
#else
  call doubleH2D(check, c_loc(in), in_size)
#endif

  tf = 0.0_real64
  tb = 0.0_real64
  do iter = 1, 1
    temp = 0.0_real64 - MPI_Wtime()
    call plan%execute(in, out, DTFFT_EXECUTE_FORWARD, error_code=ierr); DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
    if ( platform == DTFFT_PLATFORM_CUDA ) then
      CUDA_CALL( cudaStreamSynchronize(stream) )
    endif
#endif
    tf = tf + temp + MPI_Wtime()

#if defined(DTFFT_WITH_CUDA)
    call scaleDouble(executor%val, c_loc(out), out_size, int(8 * nx * ny * nz, int64), platform%val, stream)
#else
    call scaleDouble(executor%val, c_loc(out), out_size, int(8 * nx * ny * nz, int64))
#endif

    temp = 0.0_real64 - MPI_Wtime()
    call plan%execute(out, in, DTFFT_EXECUTE_BACKWARD, error_code=ierr); DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
    if ( platform == DTFFT_PLATFORM_CUDA ) then
      CUDA_CALL( cudaStreamSynchronize(stream) )
    endif
#endif
    tb = tb + temp + MPI_Wtime()
  enddo

  ! call cali_flush(0)

#if defined(DTFFT_WITH_CUDA) && !defined(DTFFT_WITH_MOCK_ENABLED)
  call checkAndReportDouble(int(nx * ny * nz, int64), tf, tb, c_loc(in), in_size, check, platform%val)
#else
  call checkAndReportDouble(int(nx * ny * nz, int64), tf, tb, c_loc(in), in_size, check)
#endif

  call plan%mem_free(in)
  call plan%mem_free(out)
  call mem_free_host(check)

  call plan%destroy(error_code=ierr)
  DTFFT_CHECK(ierr)
  deallocate( plan )
  call MPI_Finalize(ierr)
end program test_r2r_3d

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_abstract_executor
!! This module describes Abstraction for all FFT Executors: [[abstract_executor]]
use iso_c_binding,    only: c_loc, c_ptr, c_null_ptr
use iso_fortran_env,  only: int8, int32, int64
use dtfft_errors
use dtfft_pencil,     only: pencil
use dtfft_parameters
use dtfft_utils
#include "_dtfft_profile.h"
#include "_dtfft_private.h"
#include "_dtfft_mpi.h"
implicit none
private
public :: abstract_executor

  integer(int8),  public, parameter :: FFT_C2C = 0
    !! Complex to complex FFT
  integer(int8),  public, parameter :: FFT_R2C = 1
    !! Real to complex FFT
  integer(int8),  public, parameter :: FFT_R2R = 2
    !! Real to real FFT

  integer(int8),  public, parameter :: FFT_1D = 1
    !! 1D FFT
  integer(int8),  public, parameter :: FFT_2D = 2
    !! 2D FFT

  type, abstract :: abstract_executor
  !! The "most" abstract executor.
  !! All FFT executors are extending this class.
    type(c_ptr)             :: plan_forward                 !! Pointer to forward plan
    type(c_ptr)             :: plan_backward                !! Pointer to backward plan
    logical,    private     :: is_created = .false.         !! Is plan created?
    logical                 :: is_inverse_copied = .false.  !! Is inverse plan copied?
    integer(int8)           :: fft_type
    character(len=:),  allocatable :: profile
  contains
    procedure,  non_overridable,              pass(self), public  :: create               !! Creates FFT plan
    procedure,  non_overridable,              pass(self), public  :: execute              !! Executes plan
    procedure,  non_overridable,              pass(self), public  :: destroy              !! Destroys plan
    procedure(mem_alloc_interface), deferred, nopass,     public  :: mem_alloc            !! Allocates aligned memory
    procedure(mem_free_interface),  deferred, nopass,     public  :: mem_free             !! Frees aligned memory
    procedure(create_interface),    deferred, pass(self)          :: create_private       !! Creates FFT plan
    procedure(execute_interface),   deferred, pass(self)          :: execute_private      !! Executes plan
    procedure(destroy_interface),   deferred, pass(self)          :: destroy_private      !! Destroys plan
  end type abstract_executor

  abstract interface
    subroutine create_interface(self, fft_rank, fft_type, precision, idist, odist, how_many, fft_sizes, inembed, onembed, error_code, r2r_kinds)
    !! Creates FFT plan
    import
      class(abstract_executor),         intent(inout) :: self           !! FFT Executor
      integer(int8),                    intent(in)    :: fft_rank       !! Rank of fft: 1 or 2
      integer(int8),                    intent(in)    :: fft_type       !! Type of fft: r2r, r2c, c2c
      type(dtfft_precision_t),          intent(in)    :: precision      !! Precision of fft: DTFFT_SINGLE or DTFFT_DOUBLE
      integer(int32),                   intent(in)    :: idist          !! Distance between the first element of two consecutive signals in a batch of the input data.
      integer(int32),                   intent(in)    :: odist          !! Distance between the first element of two consecutive signals in a batch of the output data.
      integer(int32),                   intent(in)    :: how_many       !! Number of transforms to create
      integer(int32),                   intent(in)    :: fft_sizes(:)   !! Dimensions of transform
      integer(int32),                   intent(in)    :: inembed(:)     !! Storage dimensions of the input data in memory.
      integer(int32),                   intent(in)    :: onembed(:)     !! Storage dimensions of the output data in memory.
      integer(int32),                   intent(inout) :: error_code     !! Error code to be returned to user
      type(dtfft_r2r_kind_t), optional, intent(in)    :: r2r_kinds(:)   !! Kinds of r2r transform
    end subroutine create_interface

    subroutine execute_interface(self, a, b, sign)
    !! Executes plan
    import
      class(abstract_executor), intent(in)  :: self             !! FFT Executor
      type(c_ptr),              intent(in)  :: a                !! Source pointer
      type(c_ptr),              intent(in)  :: b                !! Target pointer
      integer(int8),            intent(in)  :: sign             !! Sign of transform
    end subroutine execute_interface

    subroutine destroy_interface(self)
    !! Destroys plan
    import
      class(abstract_executor), intent(inout) :: self           !! FFT Executor
    end subroutine destroy_interface

    subroutine mem_alloc_interface(alloc_bytes, ptr)
    !! Allocates aligned memory
    import
      integer(int64),           intent(in)    :: alloc_bytes    !! Number of bytes to allocate
      type(c_ptr),              intent(out)   :: ptr            !! Allocated pointer
    end subroutine mem_alloc_interface

    subroutine mem_free_interface(ptr)
    !! Frees aligned memory
    import
     type(c_ptr),               intent(in)    :: ptr            !! Pointer to free
    end subroutine mem_free_interface
  end interface

contains
  integer(int32) function create(self, fft_rank, fft_type, precision, real_pencil, complex_pencil, r2r_kinds)
  !! Creates FFT plan
    class(abstract_executor),           intent(inout) :: self             !! FFT Executor
    integer(int8),                      intent(in)    :: fft_rank         !! Rank of fft: 1 or 2
    integer(int8),                      intent(in)    :: fft_type         !! Type of fft: r2r, r2c, c2c
    type(dtfft_precision_t),            intent(in)    :: precision        !! Precision of fft: DTFFT_SINGLE or DTFFT_DOUBLE
    type(pencil),           optional,   intent(in)    :: real_pencil      !! Real data layout
    type(pencil),           optional,   intent(in)    :: complex_pencil   !! Complex data layout
    type(dtfft_r2r_kind_t), optional,   intent(in)    :: r2r_kinds(:)     !! Kinds of r2r transform
    integer(int32),         allocatable   :: fft_sizes(:)     !! Dimensions of transform
    integer(int32),         allocatable   :: inembed(:)       !! Storage dimensions of the input data in memory.
    integer(int32),         allocatable   :: onembed(:)       !! Storage dimensions of the output data in memory.
    integer(int32)                        :: idist            !! Distance between the first element of two consecutive signals in a batch of the input data.
    integer(int32)                        :: odist            !! Distance between the first element of two consecutive signals in a batch of the output data.
    integer(int32)                        :: how_many         !! Number of transforms to create

    create = DTFFT_SUCCESS
    if ( self%is_created .and. .not.is_null_ptr(self%plan_forward) .and. .not.is_null_ptr(self%plan_backward) ) return

    self%plan_forward = c_null_ptr
    self%plan_backward = c_null_ptr
    self%is_created = .false.
    self%is_inverse_copied = .false.
    self%fft_type = fft_type
#ifdef DTFFT_DEBUG
    if ( fft_rank /= FFT_1D .and. fft_rank /= FFT_2D ) then
      INTERNAL_ERROR("fft_rank /= FFT_1D .and. fft_rank /= FFT_2D")
    endif
    if ( (fft_type == FFT_R2C).and.(.not.present(complex_pencil) .or. .not.present(real_pencil)) ) then
      INTERNAL_ERROR("(fft_type == FFT_R2C).and.(.not.present(complex_pencil) .or. .not.present(real_pencil))")
    endif
    if ( (fft_type == FFT_R2R).and.(.not.present(real_pencil) .or..not.present(r2r_kinds)) ) then
      INTERNAL_ERROR("(fft_type == FFT_R2R).and.(.not.present(real_pencil) .or..not.present(r2r_kinds))")
    endif
#endif
    allocate( fft_sizes(fft_rank), inembed(fft_rank), onembed(fft_rank) )

    how_many = 0
    select case (fft_type)
    case (FFT_C2C)
      select case (fft_rank)
      case (FFT_1D)
        fft_sizes(1) = complex_pencil%counts(1)
      case (FFT_2D)
        fft_sizes(1) = complex_pencil%counts(2)
        fft_sizes(2) = complex_pencil%counts(1)
      endselect
      inembed(:) = fft_sizes(:)
      onembed(:) = fft_sizes(:)
      idist = product(fft_sizes)
      odist = idist
      how_many = product(complex_pencil%counts) / idist
    case (FFT_R2C)
      select case ( fft_rank )
      case ( FFT_1D )
        fft_sizes(1) = real_pencil%counts(1)
        onembed(1) = complex_pencil%counts(1)
      case ( FFT_2D )
        fft_sizes(1) = real_pencil%counts(2)
        fft_sizes(2) = real_pencil%counts(1)
        onembed(1) = complex_pencil%counts(2)
        onembed(2) = complex_pencil%counts(1)
      endselect
      inembed(:) = fft_sizes(:)
      idist = product(inembed)
      odist = product(onembed)
      how_many = product(real_pencil%counts) / idist
    case (FFT_R2R)
      select case (fft_rank)
      case (FFT_1D)
        fft_sizes(1) = real_pencil%counts(1)
      case (FFT_2D)
        fft_sizes(1) = real_pencil%counts(2)
        fft_sizes(2) = real_pencil%counts(1)
      endselect
      inembed(:) = fft_sizes(:)
      onembed(:) = fft_sizes(:)
      idist = product(fft_sizes)
      odist = idist
      how_many = product(real_pencil%counts) / idist
    endselect
    if ( how_many == 0 ) then
      return
    endif

    if ( fft_rank == 1) then
      self%profile = "1D "
    else
      self%profile = "2D "
    endif
    self%profile = self%profile//to_str(fft_sizes(1))
    if ( fft_rank == 2 ) self%profile = self%profile // "x" // to_str(fft_sizes(2))
    self%profile = self%profile // ":" // to_str(how_many)

    REGION_BEGIN("create FFT "//self%profile, COLOR_FFT)
    call self%create_private(fft_rank, fft_type, precision, idist, odist, how_many, fft_sizes, inembed, onembed, create, r2r_kinds)
    REGION_END("create FFT "//self%profile)
    ! This should only happen when current process do not have any data, so FFT plan is not required here
    if ( is_null_ptr(self%plan_forward) .or. is_null_ptr(self%plan_backward) ) return
    if ( create == DTFFT_SUCCESS ) self%is_created = .true.
    deallocate( fft_sizes, inembed, onembed )
  end function create

  subroutine execute(self, in, out, sign)
  !! Executes plan
    class(abstract_executor), intent(in)  :: self   !! FFT Executor
    type(c_ptr),              intent(in)  :: in     !! Source buffer
    type(c_ptr),              intent(in)  :: out    !! Target buffer
    integer(int8),            intent(in)  :: sign   !! Sign of transform
    if ( .not.self%is_created ) return
#ifdef DTFFT_DEBUG
    if ( is_same_ptr(in, out) .and. self%fft_type == FFT_R2C ) then
      INTERNAL_ERROR("inplace FFT_R2C")
    endif
#endif
    REGION_BEGIN("FFT "//self%profile, COLOR_FFT)
    call self%execute_private(in, out, sign)
    REGION_END("FFT "//self%profile)
  end subroutine execute

  subroutine destroy(self)
  !! Destroys plan
    class(abstract_executor), intent(inout) :: self             !! FFT Executor
    if ( allocated(self%profile) ) deallocate(self%profile)
    if ( self%is_created ) call self%destroy_private()
    self%plan_forward = c_null_ptr
    self%plan_backward = c_null_ptr
    self%is_created = .false.
    self%is_inverse_copied = .false.
  end subroutine destroy
end module dtfft_abstract_executor

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
module dtfft_interface_nvtx
!! nvtx3 Interfaces
use iso_c_binding
use dtfft_utils
implicit none
private
public :: push_nvtx_domain_range, pop_nvtx_domain_range

  type, bind(C) :: nvtxDomainHandle
  !! NVTX domain handle.
    type(c_ptr) :: handle !! Internal handle for the NVTX domain.
  end type nvtxDomainHandle

  type(nvtxDomainHandle),     save  :: domain_nvtx
    !! NVTX domain handle
  logical,                    save  :: domain_created = .false.
    !! Has domain been created?

  interface
    subroutine nvtxDomainCreate_c(name, domain) bind(C, name="nvtxDomainCreate_c")
    !! Creates an NVTX domain with the specified name.
      import
      character(c_char),  intent(in)  :: name(*)  !! Name of the NVTX domain.
      type(nvtxDomainHandle)          :: domain   !! Handle to the created NVTX domain.
    end subroutine nvtxDomainCreate_c
  end interface

  interface
    subroutine nvtxDomainRangePushEx_c(domain, message, color) bind(C, name="nvtxDomainRangePushEx_c")
    !! Pushes a range with a custom message and color onto the specified NVTX domain.
      import
      type(nvtxDomainHandle), value               :: domain  !! NVTX domain handle.
      character(c_char),              intent(in)  :: message(*)  !! Custom message for the range.
      integer(c_int),         value,  intent(in)  :: color   !! Color for the range.
    end subroutine nvtxDomainRangePushEx_c
  end interface

  interface
    subroutine nvtxDomainRangePop_c(domain) bind(C, name="nvtxDomainRangePop_c")
    !! Pops a range from the specified NVTX domain.
      import
      type(nvtxDomainHandle), value :: domain  !! NVTX domain handle.
    end subroutine nvtxDomainRangePop_c
  end interface

contains

  subroutine create_nvtx_domain
  !! Creates a new NVTX domain
    character(c_char), allocatable :: cstr(:) !! C-style string

    call astring_f2c("dtFFT", cstr)

    call nvtxDomainCreate_c(cstr, domain_nvtx)
    domain_created = .true.
    deallocate(cstr)
  end subroutine create_nvtx_domain

  subroutine push_nvtx_domain_range(message, color)
  !! Pushes a range to the NVTX domain
    character(len=*), intent(in)    :: message    !! Message to push
    integer(c_int),   intent(in)    :: color      !! Color of the range
    character(c_char), allocatable  :: cstr(:)    !! C-style string

    if ( .not. domain_created ) call create_nvtx_domain()
    call astring_f2c(message, cstr)
    call nvtxDomainRangePushEx_c(domain_nvtx, cstr, color)
    deallocate(cstr)
  end subroutine push_nvtx_domain_range

  subroutine pop_nvtx_domain_range()
  !! Pops a range from the NVTX domain
    call nvtxDomainRangePop_c(domain_nvtx)
  end subroutine pop_nvtx_domain_range
end module dtfft_interface_nvtx

program main
use dtfft
#ifdef HAVE_F08
use mpi_f08
#else
use mpi
#endif
implicit none
type(dtfft_plan_r2r_t) :: plan

#if defined(USE_MPI) && defined(HAVE_F08)
  call plan%create([2,2,2], comm=MPI_COMM_WORLD%MPI_VAL)
#else
  call plan%create([2,2,2], comm=MPI_COMM_WORLD)
#endif
end program main

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
module dtfft_executor_vkfft_m
!! This module describes VkFFT based FFT Executor: [[vkfft_executor]]
!!
!! https://github.com/DTolm/VkFFT/tree/master
use iso_c_binding,                  only: c_ptr, c_int, c_int8_t
use iso_fortran_env,                only: int8, int32, int64
use dtfft_abstract_executor,        only: abstract_executor, FFT_C2C, FFT_R2C, FFT_R2R
use dtfft_config,                   only: get_conf_stream, get_conf_platform
use dtfft_errors
use dtfft_interface_vkfft_m
use dtfft_parameters
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
implicit none
private
public :: vkfft_executor

  type, extends(abstract_executor) :: vkfft_executor
  !! vkFFT FFT Executor
  private
    type(vkfft_wrapper), pointer  :: wrapper => null()
      !! VkFFT Wrapper
    logical                       :: is_inverse_required
      !! Should be create separate inverse FFT Plan or not
  contains
    procedure, pass(self)  :: create_private => create      !! Creates FFT plan via vkFFT Interface
    procedure, pass(self)  :: execute_private => execute    !! Executes vkFFT plan
    procedure, pass(self)  :: destroy_private => destroy    !! Destroys vkFFT plan
    procedure, nopass :: mem_alloc                          !! Dummy method. Raises `error stop`
    procedure, nopass :: mem_free                           !! Dummy method. Raises `error stop`
  end type vkfft_executor

contains

  subroutine create(self, fft_rank, fft_type, precision, idist, odist, how_many, fft_sizes, inembed, onembed, error_code, r2r_kinds)
  !! Creates FFT plan via vkFFT Interface
    class(vkfft_executor),            intent(inout) :: self           !! vkFFT FFT Executor
    integer(int8),                    intent(in)    :: fft_rank       !! Rank of fft: 1 or 2
    integer(int8),                    intent(in)    :: fft_type       !! Type of fft: r2r, r2c, c2c
    type(dtfft_precision_t),          intent(in)    :: precision      !! Precision of fft: DTFFT_SINGLE or DTFFT_DOUBLE
    integer(int32),                   intent(in)    :: idist          !! Distance between the first element of two consecutive signals in a batch of the input data.
    integer(int32),                   intent(in)    :: odist          !! Distance between the first element of two consecutive signals in a batch of the output data.
    integer(int32),                   intent(in)    :: how_many       !! Number of transforms to create
    integer(int32),                   intent(in)    :: fft_sizes(:)   !! Dimensions of transform
    integer(int32),                   intent(in)    :: inembed(:)     !! Storage dimensions of the input data in memory.
    integer(int32),                   intent(in)    :: onembed(:)     !! Storage dimensions of the output data in memory.
    integer(int32),                   intent(inout) :: error_code     !! Error code to be returned to user
    type(dtfft_r2r_kind_t), optional, intent(in)    :: r2r_kinds(:)   !! Kinds of r2r transform
    integer(c_int8_t)       :: r2c              !! Is R2C transform required
    integer(c_int8_t)       :: dct              !! Is DCT transform required
    integer(c_int8_t)       :: dst              !! Is DST transform required
    integer(c_int)          :: knd              !! Kind of r2r transform
    integer(c_int)          :: i                !! Loop index
    integer(c_int)          :: dims(2)          !! Dimensions of transform
    integer(c_int)          :: double_precision !! Precision of fft: DTFFT_SINGLE or DTFFT_DOUBLE
    type(dtfft_platform_t)  :: platfrom         !! Platform of the executor

    error_code = DTFFT_SUCCESS
    do i = 1, fft_rank
      dims(i) = fft_sizes(fft_rank - i + 1)
    enddo

    platfrom = get_conf_platform()
    CHECK_CALL( load_vkfft(platfrom), error_code )

    if ( platfrom == DTFFT_PLATFORM_CUDA ) then
      self%wrapper => cuda_wrapper
    endif

    r2c = 0
    dct = 0
    dst = 0
    self%is_inverse_required = .false.
    select case ( fft_type )
    case ( FFT_R2C )
      r2c = 1
      self%is_inverse_required = .true.
    case ( FFT_R2R )
      knd = r2r_kinds(1)%val
      do i = 2, fft_rank
        if ( knd /= r2r_kinds(i)%val ) then
          error_code = DTFFT_ERROR_VKFFT_R2R_2D_PLAN
          return
        endif
      enddo
      select case ( knd )
      case ( DTFFT_DCT_1%val )
        dct = 1
      case ( DTFFT_DCT_2%val )
        dct = 2
      case ( DTFFT_DCT_3%val )
        dct = 3
      case ( DTFFT_DCT_4%val )
        dct = 4
      case ( DTFFT_DST_1%val )
        dst = 1
      case ( DTFFT_DST_2%val )
        dst = 2
      case ( DTFFT_DST_3%val )
        dst = 3
      case ( DTFFT_DST_4%val )
        dst = 4
      endselect
    endselect
    if ( precision == DTFFT_DOUBLE ) then
      double_precision = 1
    else
      double_precision = 0
    endif
    call self%wrapper%create(fft_rank, dims, double_precision, how_many, r2c, int(0, int8), dct, dst, get_conf_stream(), self%plan_forward)
    if ( self%is_inverse_required ) then
      call self%wrapper%create(fft_rank, dims, double_precision, how_many, int(0, int8), r2c, dct, dst, get_conf_stream(), self%plan_backward)
    else
      self%plan_backward = self%plan_forward
    endif
  end subroutine create

  subroutine execute(self, a, b, sign)
  !! Executes vkFFT plan
    class(vkfft_executor),  intent(in)      :: self           !! vkFFT FFT Executor
    type(c_ptr),            intent(in)      :: a              !! Source pointer
    type(c_ptr),            intent(in)      :: b              !! Target pointer
    integer(int8),          intent(in)      :: sign           !! Sign of transform

    if ( self%is_inverse_required .and. sign == FFT_BACKWARD ) then
      call self%wrapper%execute(self%plan_backward, a, b, sign)
    else
      call self%wrapper%execute(self%plan_forward, a, b, sign)
    endif
  end subroutine execute

  subroutine destroy(self)
  !! Destroys vkFFT plan
    class(vkfft_executor), intent(inout)    :: self           !! vkFFT FFT Executor

    call self%wrapper%destroy(self%plan_forward)
    if ( self%is_inverse_required ) then
      call self%wrapper%destroy(self%plan_backward)
    endif
  end subroutine destroy

  subroutine mem_alloc(alloc_bytes, ptr)
  !! Dummy method. Raises `error stop`
    integer(int64),           intent(in)  :: alloc_bytes  !! Number of bytes to allocate
    type(c_ptr),              intent(out) :: ptr          !! Allocated pointer

    INTERNAL_ERROR("mem_alloc for VkFFT called")
  end subroutine mem_alloc

  subroutine mem_free(ptr)
  !! Dummy method. Raises `error stop`
    type(c_ptr),               intent(in)   :: ptr        !! Pointer to free

    INTERNAL_ERROR("mem_free for VkFFT called")
  end subroutine mem_free
end module dtfft_executor_vkfft_m

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_reshape_handle_datatype
!! This module describes [[reshape_handle_datatype]] class
!! It executes either transposition or reshaping from bricks to pencils and vice versa using MPI_Ialltoall(w) with custom MPI datatypes
!! For the end user this is `DTFFT_BACKEND_MPI_DATATYPE` - backend.
!! But since it does not perform sequence: transpose -> exchange -> unpack, it is internally treated as reshape_handle.
use iso_fortran_env
use iso_c_binding,                  only: c_ptr, c_f_pointer
use dtfft_abstract_reshape_handle,  only: abstract_reshape_handle, create_args, execute_args
use dtfft_errors
use dtfft_parameters
use dtfft_pencil,     only: pencil, get_float_buffer_size
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
#include "_dtfft_profile.h"
#include "_dtfft_cuda.h"
implicit none
private
public :: reshape_handle_datatype

    integer(MPI_ADDRESS_KIND), parameter :: LB = 0
    !! Lower bound for all derived datatypes

#if defined (ENABLE_PERSISTENT_COMM)
# if defined(ENABLE_PERSISTENT_COLLECTIVES)
#   if defined(OMPI_FIX_REQUIRED)
      logical, parameter :: IS_P2P_ENABLED = .true.
#   else
      logical, parameter :: IS_P2P_ENABLED = .false.
#   endif
# else
      logical, parameter :: IS_P2P_ENABLED = .true.
# endif
#else
# if defined(OMPI_FIX_REQUIRED)
      logical, parameter :: IS_P2P_ENABLED = .true.
# else
      logical, parameter :: IS_P2P_ENABLED = .false.
# endif
#endif
  !! Is point-to-point communication enabled

    type :: handle_t
    !! Transposition handle class
        TYPE_MPI_DATATYPE,     allocatable :: dtypes(:)           !! Datatypes buffer
        integer(int32),        allocatable :: counts(:)           !! Number of datatypes (always equals 1)
        integer(int32),        allocatable :: displs(:)           !! Displacements is bytes
    contains
        procedure, pass(self) :: create => create_handle          !! Creates transposition handle
        procedure, pass(self) :: destroy => destroy_handle        !! Destroys transposition handle
    end type handle_t


    type, extends(abstract_reshape_handle) :: reshape_handle_datatype
    !! Transpose backend that uses MPI_Ialltoall(w) with custom MPI datatypes
    ! private
        TYPE_MPI_COMM                   :: comm                   !! 1d communicator
        logical                         :: is_even = .false.      !! Is decomposition even
        logical                         :: is_active = .false.    !! Is async transposition active
        type(handle_t)                  :: send                   !! Handle to send data
        type(handle_t)                  :: recv                   !! Handle to recieve data
        TYPE_MPI_REQUEST, allocatable   :: requests(:)            !! Requests for communication
        integer(int32)                  :: n_requests             !! Actual number of requests, can be less than size(requests)
        integer(int64)                  :: min_buffer_size
#if defined(ENABLE_PERSISTENT_COMM)
        logical                         :: is_request_created = .false.     !! Is request created
#endif
    contains
    private
        procedure, pass(self),  public  :: create_private => create !! Initializes class
        procedure, pass(self),  public  :: execute                !! Performs MPI_Ialltoall(w)
        procedure, pass(self),  public  :: execute_end            !! Waits for MPI_Ialltoall(w) to complete
        procedure, pass(self),  public  :: destroy                !! Destroys class
        procedure, pass(self),  public  :: get_async_active       !! Returns .true. if async transposition is active
        procedure, pass(self),  public  :: get_backend
    end type reshape_handle_datatype

contains

    subroutine create_handle(self, n)
    !! Creates reshape handle
        class(handle_t),  intent(inout) :: self   !! Reshape handle
        integer(int32),   intent(in)    :: n      !! Number of datatypes to be created

        call self%destroy()
        allocate(self%dtypes(n), source = MPI_DATATYPE_NULL)
        allocate(self%counts(n), source = 1_int32)
        allocate(self%displs(n), source = 0_int32)
    end subroutine create_handle

    subroutine destroy_handle(self)
    !! Destroys reshape handle
        class(handle_t),  intent(inout)   :: self   !! Reshape handle
        integer(int32)                    :: i      !! Counter
        integer(int32)                    :: ierr   !! Error code

        if ( allocated(self%dtypes) ) then
            do i = 1, size(self%dtypes)
                call MPI_Type_free(self%dtypes(i), ierr)
            enddo
            deallocate(self%dtypes)
        endif
        if ( allocated(self%displs) ) deallocate(self%displs)
        if ( allocated(self%counts) ) deallocate(self%counts)
    end subroutine destroy_handle

    subroutine create(self, comm, send, recv, kwargs)
    !! Creates `reshape_handle_datatype` class
        class(reshape_handle_datatype),   intent(inout) :: self           !! Reshape handle
        TYPE_MPI_COMM,                    intent(in)    :: comm           !! MPI Communicator
        type(pencil),                     intent(in)    :: send           !! Send pencil
        type(pencil),                     intent(in)    :: recv           !! Recv pencil
        type(create_args),                intent(in)    :: kwargs         !! Additional arguments
        integer(int32)                              :: comm_size          !! Size of 1d communicator
        integer(int32)                              :: n_neighbors        !! Number of datatypes to be created
        integer(int32),               allocatable   :: recv_counts(:,:)   !! Each processor should know how much data each processor recieves
        integer(int32),               allocatable   :: send_counts(:,:)   !! Each processor should know how much data each processor sends
        integer(int32),               allocatable   :: recv_starts(:,:)
        integer(int32),               allocatable   :: send_starts(:,:)
        integer(int32)                              :: i                  !! Counter
        integer(int32)                              :: ierr               !! Error code
        integer(int32) :: send_displ, recv_displ
        type(dtfft_transpose_t) :: transpose_type
        type(dtfft_reshape_t)   :: reshape_type
        type(dtfft_transpose_mode_t) :: tmode
        TYPE_MPI_DATATYPE :: base_type
        integer(int64) :: base_storage
        integer(int8) :: reshape_strat
        logical :: zslab, yslab

        call self%destroy()
        self%comm = comm
        call MPI_Comm_size(comm, comm_size, ierr)
        self%is_even = send%is_even .and. recv%is_even
        n_neighbors = comm_size;  if ( self%is_even ) n_neighbors = 1
        self%is_active = .false.

        allocate(self%requests(2 * comm_size))

#if defined(ENABLE_PERSISTENT_COMM)
        self%is_request_created = .false.
#endif

        call self%send%create(n_neighbors)
        call self%recv%create(n_neighbors)

        allocate(recv_counts(recv%rank, comm_size), source = 0_int32)
        allocate(send_counts, source = recv_counts)
        allocate(recv_starts, source = recv_counts)
        allocate(send_starts, source = recv_counts)
        call MPI_Allgather(recv%counts, int(recv%rank, int32), MPI_INTEGER4, recv_counts, int(recv%rank, int32), MPI_INTEGER4, comm, ierr)
        call MPI_Allgather(send%counts, int(send%rank, int32), MPI_INTEGER4, send_counts, int(send%rank, int32), MPI_INTEGER4, comm, ierr)
        call MPI_Allgather(recv%starts, int(recv%rank, int32), MPI_INTEGER4, recv_starts, int(send%rank, int32), MPI_INTEGER4, comm, ierr)
        call MPI_Allgather(send%starts, int(send%rank, int32), MPI_INTEGER4, send_starts, int(send%rank, int32), MPI_INTEGER4, comm, ierr)

        transpose_type = kwargs%helper%transpose_type
        reshape_type = kwargs%helper%reshape_type
        tmode = kwargs%transpose_mode
        base_type = kwargs%base_type
        base_storage = kwargs%base_storage

        if ( .not. self%is_transpose .and. send%rank == 3 ) then
            zslab = .true.
            yslab = .true.
            if ( reshape_type == DTFFT_RESHAPE_X_BRICKS_TO_PENCILS .or. reshape_type == DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS ) then
                do i = 1, n_neighbors
                    zslab = zslab .and. send%counts(2) == recv_counts(2, i)
                    yslab = yslab .and. send%counts(3) == recv_counts(3, i)
                enddo
            else
                do i = 1, n_neighbors
                    zslab = zslab .and. send_counts(2, i) == recv%counts(2)
                    yslab = yslab .and. send_counts(3, i) == recv%counts(3)
                enddo
            endif
            if( zslab ) then
                reshape_strat = 1
            else if ( yslab ) then
                reshape_strat = 2
            else
                reshape_strat = 3
            endif
        endif

        self%min_buffer_size = get_float_buffer_size(send, recv, base_storage)

        recv_displ = 0
        do i = 1, n_neighbors
            if ( self%is_transpose ) then
                if ( send%rank == 2 ) then
                    call create_transpose_2d(send, send_counts(:,i), recv, recv_counts(:,i), tmode, base_type, base_storage, self%send%dtypes(i), send_displ, self%recv%dtypes(i), recv_displ)
                else if ( any( transpose_type == [DTFFT_TRANSPOSE_X_TO_Y, DTFFT_TRANSPOSE_Y_TO_Z]) ) then
                    call create_forw_permutation(send, send_counts(:,i), recv, recv_counts(:,i), tmode, base_type, base_storage, self%send%dtypes(i), send_displ, self%recv%dtypes(i), recv_displ)
                else if ( any( transpose_type == [DTFFT_TRANSPOSE_Y_TO_X, DTFFT_TRANSPOSE_Z_TO_Y]) ) then
                    call create_back_permutation(send, send_counts(:,i), recv, recv_counts(:,i), tmode, base_type, base_storage, self%send%dtypes(i), send_displ, self%recv%dtypes(i), recv_displ)
                else if ( transpose_type == DTFFT_TRANSPOSE_X_TO_Z ) then
                    call create_transpose_XZ(send, send_counts(:,i), recv, recv_counts(:,i), tmode, base_type, base_storage, self%send%dtypes(i), send_displ, self%recv%dtypes(i), recv_displ)
                else
                    call create_transpose_ZX(send, send_counts(:,i), recv, recv_counts(:,i), tmode, base_type, base_storage, self%send%dtypes(i), send_displ, self%recv%dtypes(i), recv_displ)
                endif
            else
                if ( reshape_type == DTFFT_RESHAPE_X_BRICKS_TO_PENCILS .or. reshape_type == DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS ) then
                    if ( send%rank == 2 ) then
                        call create_reshape_21(send, send_counts(:,i), recv, recv_counts(:,i), base_type, base_storage, self%send%dtypes(i), send_displ, self%recv%dtypes(i), recv_displ)
                    else
                        call create_reshape_32(send, send_counts(:,i), recv, recv_counts(:,i), recv_starts(:,i), base_type, base_storage, self%send%dtypes(i), send_displ, self%recv%dtypes(i), recv_displ, reshape_strat)
                    endif
                else
                    if ( send%rank == 2 ) then
                        call create_reshape_12(send, send_counts(:,i), recv, recv_counts(:,i), base_type, base_storage, self%send%dtypes(i), send_displ, self%recv%dtypes(i), recv_displ)
                    else
                        call create_reshape_23(send, send_counts(:,i), send_starts(:,i), recv, recv_counts(:,i), base_type, base_storage, self%send%dtypes(i), send_displ, self%recv%dtypes(i), recv_displ, reshape_strat)
                    endif
                endif
            endif
            if ( self%is_even ) then
                self%send%displs(i) = send_displ
                self%recv%displs(i) = recv_displ
            else
                if ( i < n_neighbors ) then
                    if ( any(send%counts == 0) ) then
                        self%send%displs(i + 1) = self%send%displs(i)
                    else
                        self%send%displs(i + 1) = self%send%displs(i) + send_displ
                    endif
                    if (  any(recv%counts == 0)) then
                        self%recv%displs(i + 1) = self%recv%displs(i)
                    else
                        self%recv%displs(i + 1) = self%recv%displs(i) + recv_displ
                    endif
                    recv_displ = self%recv%displs(i + 1)
                endif
            endif
        enddo

        if ( IS_P2P_ENABLED ) then
            self%send%displs(:) = self%send%displs(:) / int(FLOAT_STORAGE_SIZE, int32)
            self%recv%displs(:) = self%recv%displs(:) / int(FLOAT_STORAGE_SIZE, int32)
            if ( .not. self%is_even ) then
                if ( any(send%counts == 0) ) self%send%counts(:) = 0
                if ( any(recv%counts == 0) ) self%recv%counts(:) = 0
                do i = 1, n_neighbors
                    if ( any(recv_counts(:,i) == 0) ) then
                        self%send%counts(i) = 0
                    endif
                    if ( any(send_counts(:,i) == 0) ) then
                        self%recv%counts(i) = 0
                    endif
                enddo
            endif
        endif
        deallocate(recv_counts, send_counts, recv_starts, send_starts)
    end subroutine create

    elemental type(dtfft_backend_t) function get_backend(self)
        class(reshape_handle_datatype),   intent(in)    :: self       !! Abstract reshape Handle
        get_backend = DTFFT_BACKEND_MPI_DATATYPE
    end function get_backend

    subroutine execute(self, in, out, kwargs, error_code)
    !! Executes transposition/reshaping
        class(reshape_handle_datatype), intent(inout)   :: self         !! Datatype handle
        type(c_ptr),                    intent(in)      :: in           !! Send pointer
        type(c_ptr),                    intent(in)      :: out          !! Recv pointer
        type(execute_args),             intent(inout)   :: kwargs       !! Additional arguments
        integer(int32),                 intent(out)     :: error_code   !! Result of execution
        integer(int32) :: i, comm_size, ierr
        real(real32), pointer, contiguous :: pin(:), pout(:)

        call c_f_pointer(in, pin, [self%min_buffer_size])
        call c_f_pointer(out, pout, [self%min_buffer_size])


        error_code = DTFFT_SUCCESS
        if ( self%is_active ) then
            error_code = DTFFT_ERROR_TRANSPOSE_ACTIVE
            return
        endif

        call MPI_Comm_size(self%comm, comm_size, ierr)
#if defined (ENABLE_PERSISTENT_COMM)
        if ( .not. self%is_request_created ) then
# if defined(ENABLE_PERSISTENT_COLLECTIVES)
            if ( self%is_even ) then
                self%n_requests = 1
                call MPI_Alltoall_init(pin, 1, self%send%dtypes(1), pout, 1, self%recv%dtypes(1), self%comm, MPI_INFO_NULL, self%requests(1), ierr)
            else
#   if defined(OMPI_FIX_REQUIRED)
                self%n_requests = 0
                do i = 1, comm_size
                    if ( self%recv%counts(i) > 0 ) then
                        self%n_requests = self%n_requests + 1
                        call MPI_Recv_init(pout(self%recv%displs(i)), 1, self%recv%dtypes(i), i - 1, 0_int32, self%comm, self%requests(self%n_requests), ierr)
                    endif
                enddo

                do i = 1, comm_size
                    if ( self%send%counts(i) > 0 ) then
                        self%n_requests = self%n_requests + 1
                        call MPI_Send_init(pin(self%send%displs(i)), 1, self%send%dtypes(i), i - 1, 0_int32, self%comm, self%requests(self%n_requests), ierr)
                    endif
                enddo
#   else
                self%n_requests = 1
                call MPI_Alltoallw_init(pin, self%send%counts, self%send%displs, self%send%dtypes, pout, self%recv%counts, self%recv%displs, self%recv%dtypes, self%comm, MPI_INFO_NULL, self%requests(1), ierr)
            endif
#   endif
# else
            self%n_requests = 0
            if ( self%is_even ) then
                do i = 1, comm_size
                    self%n_requests = self%n_requests + 1
                    call MPI_Recv_init(pout((i - 1) * self%recv%displs(1) + 1), 1, self%recv%dtypes(1), i - 1, 0_int32, self%comm, self%requests(self%n_requests), ierr)
                enddo

                do i = 1, comm_size
                    self%n_requests = self%n_requests + 1
                    call MPI_Send_init(pin((i - 1) * self%send%displs(1) + 1), 1, self%send%dtypes(1), i - 1, 0_int32, self%comm, self%requests(self%n_requests), ierr)
                enddo
            else
                do i = 1, comm_size
                    if ( self%recv%counts(i) > 0 ) then
                        self%n_requests = self%n_requests + 1
                        call MPI_Recv_init(pout(self%recv%displs(i) + 1), 1, self%recv%dtypes(i), i - 1, 0_int32, self%comm, self%requests(self%n_requests), ierr)
                    endif
                enddo

                do i = 1, comm_size
                    if ( self%send%counts(i) > 0 ) then
                        self%n_requests = self%n_requests + 1
                        call MPI_Send_init(pin(self%send%displs(i) + 1), 1, self%send%dtypes(i), i - 1, 0_int32, self%comm, self%requests(self%n_requests), ierr)
                    endif
                enddo
            endif
# endif
            self%is_request_created = .true.
        endif

        call MPI_Startall(self%n_requests, self%requests, ierr)
#else
        if ( self%is_even ) then
            self%n_requests = 1
            call MPI_Ialltoall(pin, 1, self%send%dtypes(1), pout, 1, self%recv%dtypes(1), self%comm, self%requests(1), ierr)
        else
# if defined(OMPI_FIX_REQUIRED)
            block
                integer(int32) :: i, comm_size
                call MPI_Comm_size(self%comm, comm_size, ierr)
                self%n_requests = 0

                do i = 1, comm_size
                    if ( self%recv%counts(i) > 0 ) then
                        self%n_requests = self%n_requests + 1
                        call MPI_Irecv(pout(self%recv%displs(i) + 1), 1, self%recv%dtypes(i), i - 1, 0_int32, self%comm, self%requests(self%n_requests), ierr)
                    endif
                enddo
                do i = 1, comm_size
                    if ( self%send%counts(i) > 0 ) then
                        self%n_requests = self%n_requests + 1
                        call MPI_Isend(pin(self%send%displs(i) + 1), 1, self%send%dtypes(i), i - 1, 0_int32, self%comm, self%requests(self%n_requests), ierr)
                    endif
                enddo
            endblock
# else
            self%n_requests = 1
            call MPI_Ialltoallw(pin, self%send%counts, self%send%displs, self%send%dtypes, pout, self%recv%counts, self%recv%displs, self%recv%dtypes, self%comm, self%requests(1), ierr)
# endif
        endif
#endif
        self%is_active = .true.
        if ( kwargs%exec_type == EXEC_BLOCKING ) call self%execute_end(kwargs, error_code)
    end subroutine execute

    subroutine execute_end(self, kwargs, error_code)
    !! Ends execution of transposition/reshaping
        class(reshape_handle_datatype),   intent(inout) :: self       !! Datatype handle
        type(execute_args),               intent(inout) :: kwargs     !! Additional arguments
        integer(int32),                   intent(out)   :: error_code !! Error code
        integer(int32)  :: ierr         !! Error code

        error_code = DTFFT_SUCCESS
        if ( .not. self%is_active ) then
            error_code = DTFFT_ERROR_TRANSPOSE_NOT_ACTIVE
            return
        endif
        call MPI_Waitall(self%n_requests, self%requests, MPI_STATUSES_IGNORE, ierr)
        self%is_active = .false.
    end subroutine execute_end

    elemental logical function get_async_active(self)
    !! Returns if async transpose/reshape is active
        class(reshape_handle_datatype),   intent(in)    :: self         !! Datatype handle
        get_async_active = self%is_active
    end function get_async_active

    subroutine destroy(self)
    !! Destroys `reshape_handle_datatype` class
        class(reshape_handle_datatype),   intent(inout) :: self         !! Datatype handle

        call self%send%destroy()
        call self%recv%destroy()
#if defined(ENABLE_PERSISTENT_COLLECTIVES)
        block
        integer(int32) :: i, ierr
            if( self%is_request_created ) then
                do i = 1, self%n_requests
                call MPI_Request_free(self%requests(i), ierr)
                enddo
                self%is_request_created = .false.
            endif
        endblock
#endif
        if( allocated(self%requests) ) deallocate( self%requests )
        self%is_active = .false.
        self%is_even = .false.
    end subroutine destroy

    subroutine create_transpose_2d(send, send_counts, recv, recv_counts, transpose_mode, base_type, base_storage, send_dtype, send_displ, recv_dtype, recv_displ)
    !! Creates two-dimensional transposition datatypes
        class(pencil),                  intent(in)    :: send               !! Information about send buffer
        integer(int32),                 intent(in)    :: send_counts(:)     !! Rank i is sending this counts
        class(pencil),                  intent(in)    :: recv               !! Information about send buffer
        integer(int32),                 intent(in)    :: recv_counts(:)     !! Rank i is recieving this counts
        type(dtfft_transpose_mode_t),   intent(in)    :: transpose_mode     !! Transpose mode to use
        TYPE_MPI_DATATYPE,              intent(in)    :: base_type          !! Base MPI_Datatype
        integer(int64),                 intent(in)    :: base_storage       !! Number of bytes needed to store single element
        TYPE_MPI_DATATYPE,              intent(out)   :: send_dtype         !! Datatype used to send data
        integer(int32),                 intent(out)   :: send_displ         !! Send displacement in bytes
        TYPE_MPI_DATATYPE,              intent(out)   :: recv_dtype         !! Datatype used to recv data
        integer(int32),                 intent(out)   :: recv_displ         !! Recv displacement in bytes
        TYPE_MPI_DATATYPE   :: temp1              !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp2              !! Temporary datatype
        integer(int32)      :: ierr               !! Error code

        send_displ = recv_counts(2) * int(base_storage, int32)
        recv_displ = send_counts(2) * int(base_storage, int32)
        if ( transpose_mode == DTFFT_TRANSPOSE_MODE_UNPACK ) then
            call MPI_Type_vector(send%counts(2), recv_counts(2), send%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(send_displ, MPI_ADDRESS_KIND), send_dtype, ierr)
            call free_datatypes(temp1)

            call MPI_Type_vector(recv%counts(2), 1, recv%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(base_storage, MPI_ADDRESS_KIND), temp2, ierr)
            call MPI_Type_contiguous(send_counts(2), temp2, recv_dtype, ierr)
            call free_datatypes(temp1, temp2)
        else
            call MPI_Type_vector(send%counts(2), 1, send%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(base_storage, MPI_ADDRESS_KIND), temp2, ierr)
            call MPI_Type_contiguous(recv_counts(2), temp2, send_dtype, ierr)
            call free_datatypes(temp1, temp2)

            call MPI_Type_vector(recv%counts(2), send_counts(2), recv%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(recv_displ, MPI_ADDRESS_KIND), recv_dtype, ierr)
            call free_datatypes(temp1)
        endif

        call MPI_Type_commit(send_dtype, ierr)
        call MPI_Type_commit(recv_dtype, ierr)
    end subroutine create_transpose_2d

    subroutine create_forw_permutation(send, send_counts, recv, recv_counts, transpose_mode, base_type, base_storage, send_dtype, send_displ, recv_dtype, recv_displ)
    !! Creates three-dimensional X --> Y and Y -> Z transposition datatypes
        class(pencil),                  intent(in)  :: send               !! Information about send buffer
        integer(int32),                 intent(in)  :: send_counts(:)     !! Rank i is sending this counts
        class(pencil),                  intent(in)  :: recv               !! Information about send buffer
        integer(int32),                 intent(in)  :: recv_counts(:)     !! Rank i is recieving this counts
        type(dtfft_transpose_mode_t),   intent(in)  :: transpose_mode     !! Transpose mode to use
        TYPE_MPI_DATATYPE,              intent(in)  :: base_type          !! Base MPI_Datatype
        integer(int64),                 intent(in)  :: base_storage       !! Number of bytes needed to store single element
        TYPE_MPI_DATATYPE,              intent(out) :: send_dtype         !! Datatype used to send data
        integer(int32),                 intent(out) :: send_displ         !! Send displacement in bytes
        TYPE_MPI_DATATYPE,              intent(out) :: recv_dtype         !! Datatype used to recv data
        integer(int32),                 intent(out) :: recv_displ         !! Recv displacement in bytes
        TYPE_MPI_DATATYPE   :: temp1                !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp2                !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp3                !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp4                !! Temporary datatype
        integer(int32)      :: ierr                 !! Error code

        send_displ = recv_counts(3) * int(base_storage, int32)
        recv_displ = send_counts(2) * int(base_storage, int32)
        if ( transpose_mode == DTFFT_TRANSPOSE_MODE_UNPACK ) then
            call MPI_Type_vector(send%counts(2) * send%counts(3), recv_counts(3), send%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(send_displ, MPI_ADDRESS_KIND), send_dtype, ierr)
            call free_datatypes(temp1)

            call MPI_Type_vector(recv%counts(3), 1, recv%counts(1) * recv%counts(2), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(base_storage, MPI_ADDRESS_KIND), temp2, ierr)
            call MPI_Type_contiguous(send_counts(2), temp2, temp3, ierr)
            call MPI_Type_create_hvector(recv%counts(2), 1, int(recv%counts(1) * base_storage, MPI_ADDRESS_KIND), temp3, temp4, ierr)
            call MPI_Type_create_resized(temp4, LB, int(recv_displ, MPI_ADDRESS_KIND), recv_dtype, ierr)
            call free_datatypes(temp1, temp2, temp3, temp4)
        else
            call MPI_Type_vector(send%counts(2) * send%counts(3), 1, send%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(base_storage, MPI_ADDRESS_KIND), temp2, ierr)
            call MPI_Type_contiguous(recv_counts(3), temp2, send_dtype, ierr)
            call free_datatypes(temp1, temp2)

            call MPI_Type_vector(recv%counts(2), send_counts(2), recv%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(recv_displ, MPI_ADDRESS_KIND), temp2, ierr)
            call MPI_Type_create_hvector(recv%counts(3), 1, int(recv%counts(1) * recv%counts(2) * base_storage, MPI_ADDRESS_KIND), temp2, temp3, ierr)
            call MPI_Type_create_resized(temp3, LB, int(recv_displ, MPI_ADDRESS_KIND), recv_dtype, ierr)
            call free_datatypes(temp1, temp2, temp3)
        endif

        call MPI_Type_commit(send_dtype, ierr)
        call MPI_Type_commit(recv_dtype, ierr)
    end subroutine create_forw_permutation

    subroutine create_back_permutation(send, send_counts, recv, recv_counts, transpose_mode, base_type, base_storage, send_dtype, send_displ, recv_dtype, recv_displ)
    !! Creates three-dimensional Y --> X and Z --> Y transposition datatypes
        class(pencil),                  intent(in)  :: send               !! Information about send buffer
        integer(int32),                 intent(in)  :: send_counts(:)     !! Rank i is sending this counts
        class(pencil),                  intent(in)  :: recv               !! Information about send buffer
        integer(int32),                 intent(in)  :: recv_counts(:)     !! Rank i is recieving this counts
        type(dtfft_transpose_mode_t),   intent(in)  :: transpose_mode     !! Transpose mode to use
        TYPE_MPI_DATATYPE,              intent(in)  :: base_type          !! Base MPI_Datatype
        integer(int64),                 intent(in)  :: base_storage       !! Number of bytes needed to store single element
        TYPE_MPI_DATATYPE,              intent(out) :: send_dtype         !! Datatype used to send data
        integer(int32),                 intent(out) :: send_displ         !! Send displacement in bytes
        TYPE_MPI_DATATYPE,              intent(out) :: recv_dtype         !! Datatype used to recv data
        integer(int32),                 intent(out) :: recv_displ         !! Recv displacement in bytes
        TYPE_MPI_DATATYPE   :: temp1                !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp2                !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp3                !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp4                !! Temporary datatype
        integer(int32)      :: ierr                 !! Error code

        send_displ = recv_counts(2) * int(base_storage, int32)
        recv_displ = send_counts(3) * int(base_storage, int32)
        if ( transpose_mode == DTFFT_TRANSPOSE_MODE_UNPACK ) then
            call MPI_Type_vector(send%counts(2) * send%counts(3), recv_counts(2), send%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(send_displ, MPI_ADDRESS_KIND), send_dtype, ierr)
            call free_datatypes(temp1)

            call MPI_Type_vector(recv%counts(2) * recv%counts(3), 1, recv%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(base_storage, MPI_ADDRESS_KIND), temp2, ierr)
            call MPI_Type_contiguous(send_counts(3), temp2, temp3, ierr)
            call MPI_Type_create_resized(temp3, LB, int(recv_displ, MPI_ADDRESS_KIND), recv_dtype, ierr)
            call free_datatypes(temp1, temp2, temp3)
        else
            call MPI_Type_vector(send%counts(3), 1, send%counts(1) * send%counts(2), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(base_storage, MPI_ADDRESS_KIND), temp2, ierr)
            call MPI_Type_contiguous(recv_counts(2), temp2, temp3, ierr)
            call MPI_Type_create_hvector(send%counts(2), 1, int(send%counts(1) * base_storage, MPI_ADDRESS_KIND), temp3, temp4, ierr)
            call MPI_Type_create_resized(temp4, LB, int(send_displ, MPI_ADDRESS_KIND), send_dtype, ierr)
            call free_datatypes(temp1, temp2, temp3, temp4)

            call MPI_Type_vector(recv%counts(2) * recv%counts(3), send_counts(3), recv%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(recv_displ, MPI_ADDRESS_KIND), recv_dtype, ierr)
            call free_datatypes(temp1)
        endif

        call MPI_Type_commit(send_dtype, ierr)
        call MPI_Type_commit(recv_dtype, ierr)
    end subroutine create_back_permutation

    subroutine create_transpose_XZ(send, send_counts, recv, recv_counts, transpose_mode, base_type, base_storage, send_dtype, send_displ, recv_dtype, recv_displ)
    !! Creates three-dimensional X --> Z transposition datatypes
    !! Can only be used with 3D slab decomposition when slabs are distributed in Z direction
        class(pencil),                  intent(in)  :: send               !! Information about send buffer
        integer(int32),                 intent(in)  :: send_counts(:)     !! Rank i is sending this counts
        class(pencil),                  intent(in)  :: recv               !! Information about send buffer
        integer(int32),                 intent(in)  :: recv_counts(:)     !! Rank i is recieving this counts
        type(dtfft_transpose_mode_t),   intent(in)  :: transpose_mode     !! Transpose mode to use
        TYPE_MPI_DATATYPE,              intent(in)  :: base_type          !! Base MPI_Datatype
        integer(int64),                 intent(in)  :: base_storage       !! Number of bytes needed to store single element
        TYPE_MPI_DATATYPE,              intent(out) :: send_dtype         !! Datatype used to send data
        integer(int32),                 intent(out) :: send_displ         !! Send displacement in bytes
        TYPE_MPI_DATATYPE,              intent(out) :: recv_dtype         !! Datatype used to recv data
        integer(int32),                 intent(out) :: recv_displ         !! Recv displacement in bytes
        TYPE_MPI_DATATYPE   :: temp1                !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp2                !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp3                !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp4                !! Temporary datatype
        integer(int32)      :: ierr                 !! Error code

        send_displ = send%counts(1) * recv_counts(3) * int(base_storage, int32)
        recv_displ = send_counts(3) * int(base_storage, int32)
        if ( transpose_mode == DTFFT_TRANSPOSE_MODE_UNPACK ) then
            call MPI_Type_vector(send%counts(3), send%counts(1), send%counts(1) * send%counts(2), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(send%counts(1) * base_storage, MPI_ADDRESS_KIND), temp2, ierr)
            call MPI_Type_contiguous(recv_counts(3), temp2, send_dtype, ierr)
            call free_datatypes(temp1, temp2)

            call MPI_Type_vector(recv%counts(2), 1, recv%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(base_storage, MPI_ADDRESS_KIND), temp2, ierr)
            call MPI_Type_contiguous(send_counts(3), temp2, temp3, ierr)
            call MPI_Type_create_hvector(recv%counts(3), 1, int(recv%counts(1) * recv%counts(2) * base_storage, MPI_ADDRESS_KIND), temp3, temp4, ierr)
            call MPI_Type_create_resized(temp4, LB, int(recv_displ, MPI_ADDRESS_KIND), recv_dtype, ierr)
            call free_datatypes(temp1, temp2, temp3, temp4)
        else
            call MPI_Type_vector(send%counts(3), 1, send%counts(1) * send%counts(2), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(base_storage, MPI_ADDRESS_KIND), temp2, ierr)
            call MPI_Type_contiguous(send%counts(1), temp2, temp3, ierr)
            call MPI_Type_create_hvector(recv_counts(3), 1, int(send%counts(1) * base_storage, MPI_ADDRESS_KIND), temp3, temp4, ierr)
            call MPI_Type_create_resized(temp4, LB, int(send_displ, MPI_ADDRESS_KIND), send_dtype, ierr)
            call free_datatypes(temp1, temp2, temp3, temp4)

            call MPI_Type_vector(recv%counts(2) * recv%counts(3), send_counts(3), recv%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(recv_displ, MPI_ADDRESS_KIND), recv_dtype, ierr)
            call free_datatypes(temp1)
        endif

        call MPI_Type_commit(send_dtype, ierr)
        call MPI_Type_commit(recv_dtype, ierr)
    end subroutine create_transpose_XZ

    subroutine create_transpose_ZX(send, send_counts, recv, recv_counts, transpose_mode, base_type, base_storage, send_dtype, send_displ, recv_dtype, recv_displ)
    !! Creates three-dimensional Z --> X transposition datatypes
    !! Can only be used with 3D slab decomposition when slabs are distributed in Z direction
        class(pencil),                  intent(in)  :: send               !! Information about send buffer
        integer(int32),                 intent(in)  :: send_counts(:)     !! Rank i is sending this counts
        class(pencil),                  intent(in)  :: recv               !! Information about send buffer
        integer(int32),                 intent(in)  :: recv_counts(:)     !! Rank i is recieving this counts
        type(dtfft_transpose_mode_t),   intent(in)  :: transpose_mode     !! Transpose mode to use
        TYPE_MPI_DATATYPE,              intent(in)  :: base_type          !! Base MPI_Datatype
        integer(int64),                 intent(in)  :: base_storage       !! Number of bytes needed to store single element
        TYPE_MPI_DATATYPE,              intent(out) :: send_dtype         !! Datatype used to send data
        integer(int32),                 intent(out) :: send_displ         !! Send displacement in bytes
        TYPE_MPI_DATATYPE,              intent(out) :: recv_dtype         !! Datatype used to recv data
        integer(int32),                 intent(out) :: recv_displ         !! Recv displacement in bytes
        TYPE_MPI_DATATYPE   :: temp1                !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp2                !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp3                !! Temporary datatype
        TYPE_MPI_DATATYPE   :: temp4                !! Temporary datatype
        integer(int32)      :: ierr                 !! Error code

        send_displ = recv_counts(3) * int(base_storage, int32)
        recv_displ = recv%counts(1) * send_counts(3) * int(base_storage, int32)
        if ( transpose_mode == DTFFT_TRANSPOSE_MODE_UNPACK ) then
            call MPI_Type_vector(send%counts(2) * send%counts(3), recv_counts(3), send%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(send_displ, MPI_ADDRESS_KIND), send_dtype, ierr)
            call free_datatypes(temp1)

            call MPI_Type_vector(recv%counts(3), 1, recv%counts(1) * recv%counts(2), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(base_storage, MPI_ADDRESS_KIND), temp2, ierr)
            call MPI_Type_contiguous(recv%counts(1), temp2, temp3, ierr)
            call MPI_Type_create_hvector(send_counts(3), 1, int(recv%counts(1) * base_storage, MPI_ADDRESS_KIND), temp3, temp4, ierr)
            call MPI_Type_create_resized(temp4, LB, int(recv_displ, MPI_ADDRESS_KIND), recv_dtype, ierr)
            call free_datatypes(temp1, temp2, temp3, temp4)
        else
            call MPI_Type_vector(send%counts(2) * send%counts(3), 1, send%counts(1), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(base_storage, MPI_ADDRESS_KIND), temp2, ierr)
            call MPI_Type_contiguous(recv_counts(3), temp2, send_dtype, ierr)
            call free_datatypes(temp1, temp2)

            call MPI_Type_vector(recv%counts(3), recv%counts(1) * send_counts(3), recv%counts(1) * recv%counts(2),  base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(recv_displ, MPI_ADDRESS_KIND), recv_dtype, ierr)
            call free_datatypes(temp1)
        endif

        call MPI_Type_commit(send_dtype, ierr)
        call MPI_Type_commit(recv_dtype, ierr)
    end subroutine create_transpose_ZX

    subroutine create_reshape_32(send, send_counts, recv, recv_counts, recv_starts, base_type, base_storage, send_dtype, send_displ, recv_dtype, recv_displ, reshape_strat)
    !! Creates reshape datatypes from 3d bricks to 2d pencils
        class(pencil),                intent(in)    :: send               !! Information about send buffer
        integer(int32),               intent(in)    :: send_counts(:)     !! Rank i is sending this counts
        class(pencil),                intent(in)    :: recv               !! Information about send buffer
        integer(int32),               intent(in)    :: recv_counts(:)     !! Rank i is recieving this counts
        integer(int32),               intent(in)    :: recv_starts(:)     !! Rank i is recieving to this starts
        TYPE_MPI_DATATYPE,            intent(in)    :: base_type          !! Base MPI_Datatype
        integer(int64),               intent(in)    :: base_storage       !! Number of bytes needed to store single element
        TYPE_MPI_DATATYPE,            intent(out)   :: send_dtype         !! Datatype used to send data
        integer(int32),               intent(out)   :: send_displ         !! Send displacement in bytes
        TYPE_MPI_DATATYPE,            intent(out)   :: recv_dtype         !! Datatype used to recv data
        integer(int32),               intent(out)   :: recv_displ         !! Recv displacement in bytes
        integer(int8),                intent(in)    :: reshape_strat
        TYPE_MPI_DATATYPE   :: temp1
        integer(int32)      :: i, j, k, dsp, dsp2, count, ierr                 !! Error code
        integer(int32), allocatable :: displs(:)

        select case ( reshape_strat )
        case ( 1_int8 )
        ! Z - slab
            send_displ = send%counts(1) * send%counts(2) * recv_counts(3) * int(base_storage, int32)
            call MPI_Type_contiguous(send%counts(1) * send%counts(2) * recv_counts(3), base_type, send_dtype, ierr)
        case ( 2_int8 )
        ! Y - slab
            send_displ = send%counts(1) * recv_counts(2) * int(base_storage, int32)
            call MPI_Type_vector(recv_counts(3), send%counts(1) * recv_counts(2), send%counts(1) * send%counts(2), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(send_displ, MPI_ADDRESS_KIND), send_dtype, ierr)
            call free_datatypes(temp1)
        case default
        ! Pencil
            send_displ = 0 
            ! send%counts(1) * recv_counts(2) * recv_counts(3) * int(base_storage, int32)
            count = recv_counts(2) * recv_counts(3)
            allocate(displs(count))
            i = 1
            dsp = (recv_starts(3) - send%starts(3)) * send%counts(1) * send%counts(2) + (recv_starts(2) - send%starts(2)) * send%counts(1)
            dsp2 = dsp
            do k = 1, recv_counts(3)
                do j = 1, recv_counts(2)
                    displs(i) = dsp
                    i = i + 1
                    dsp = dsp + send%counts(1)
                enddo
                dsp = dsp2 + k * send%counts(1) * send%counts(2)
            enddo
            call MPI_Type_create_indexed_block(count, send%counts(1), displs, base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(0, MPI_ADDRESS_KIND), send_dtype, ierr)
            call free_datatypes(temp1)
            deallocate(displs)
        endselect
        call MPI_Type_commit(send_dtype, ierr)
        if ( any(recv_counts== 0) ) send_displ = 0

        recv_displ = send_counts(1) * int(base_storage, int32)
        call MPI_Type_vector(recv%counts(2) * recv%counts(3), send_counts(1), recv%counts(1), base_type, temp1, ierr)
        call MPI_Type_create_resized(temp1, LB, int(recv_displ, MPI_ADDRESS_KIND), recv_dtype, ierr)
        call MPI_Type_commit(recv_dtype, ierr)
        if ( any(send_counts == 0) ) recv_displ = 0
        call free_datatypes(temp1)
    end subroutine create_reshape_32

    subroutine create_reshape_23(send, send_counts, send_starts, recv, recv_counts, base_type, base_storage, send_dtype, send_displ, recv_dtype, recv_displ, reshape_strat)
    !! Creates reshape datatypes from 2d pencils to 3d bricks
        class(pencil),                intent(in)    :: send               !! Information about send buffer
        integer(int32),               intent(in)    :: send_counts(:)     !! Rank i is sending this counts
        integer(int32),               intent(in)    :: send_starts(:)     !! Rank i is recieving to this starts
        class(pencil),                intent(in)    :: recv               !! Information about send buffer
        integer(int32),               intent(in)    :: recv_counts(:)     !! Rank i is recieving this counts
        TYPE_MPI_DATATYPE,            intent(in)    :: base_type          !! Base MPI_Datatype
        integer(int64),               intent(in)    :: base_storage       !! Number of bytes needed to store single element
        TYPE_MPI_DATATYPE,            intent(out)   :: send_dtype         !! Datatype used to send data
        integer(int32),               intent(out)   :: send_displ         !! Send displacement in bytes
        TYPE_MPI_DATATYPE,            intent(out)   :: recv_dtype         !! Datatype used to recv data
        integer(int32),               intent(inout) :: recv_displ         !! Recv displacement in bytes
        integer(int8),                intent(in)    :: reshape_strat
        TYPE_MPI_DATATYPE   :: temp1
        integer(int32)      :: i, j, k, dsp, dsp2, count, ierr                 !! Error code
        integer(int32), allocatable :: displs(:)

        send_displ = recv_counts(1) * int(base_storage, int32)
        call MPI_Type_vector(send%counts(2) * send%counts(3), recv_counts(1), send%counts(1), base_type, temp1, ierr)
        call MPI_Type_create_resized(temp1, LB, int(send_displ, MPI_ADDRESS_KIND), send_dtype, ierr)
        call free_datatypes(temp1)
        call MPI_Type_commit(send_dtype, ierr)

        select case ( reshape_strat )
        case ( 1_int8 )
            recv_displ = recv%counts(1) * recv%counts(2) * send_counts(3) * int(base_storage, int32)
            call MPI_Type_contiguous(recv%counts(1) * recv%counts(2) * send_counts(3), base_type, recv_dtype, ierr)
        case ( 2_int8 )
            recv_displ = recv%counts(1) * send_counts(2) * int(base_storage, int32)
            call MPI_Type_vector(send_counts(3), recv%counts(1) * send_counts(2), recv%counts(1) * recv%counts(2), base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(recv_displ, MPI_ADDRESS_KIND), recv_dtype, ierr)
            call free_datatypes(temp1)
        case default
        ! Pencil
            count = send_counts(2) * send_counts(3)
            allocate(displs(count))
            i = 1
            dsp =  abs(recv%starts(3) - send_starts(3))  * recv%counts(1) * recv%counts(2) + abs(recv%starts(2) - send_starts(2)) * recv%counts(1) - recv_displ / int(base_storage, int32)
            dsp2 = dsp
            do k = 1, send_counts(3)
                do j = 1, send_counts(2)
                    displs(i) = dsp
                    i = i + 1
                    dsp = dsp + recv%counts(1)
                enddo
                dsp = dsp2 + k * recv%counts(1) * recv%counts(2)
            enddo
            call MPI_Type_create_indexed_block(count, recv%counts(1), displs, base_type, temp1, ierr)
            call MPI_Type_create_resized(temp1, LB, int(0, MPI_ADDRESS_KIND), recv_dtype, ierr)
            call free_datatypes(temp1)
            deallocate(displs)
            recv_displ = recv%counts(1) * send_counts(2) * send_counts(3) * int(base_storage, int32)
            ! recv_displ = recv%counts(1) * send_counts(2) * send_counts(3) * int(base_storage, int32)
            ! call MPI_Type_contiguous(recv%counts(1) * recv%counts(2) * send_counts(3), base_type, recv_dtype, ierr)
        endselect
        call MPI_Type_commit(recv_dtype, ierr)
        if ( any(recv%counts == 0) ) send_displ = 0
    end subroutine create_reshape_23

    subroutine create_reshape_21(send, send_counts, recv, recv_counts, base_type, base_storage, send_dtype, send_displ, recv_dtype, recv_displ)
    !! Creates reshape datatypes for 2D data: from 2d bricks to 1d slabs
        class(pencil),                intent(in)    :: send               !! Information about send buffer
        integer(int32),               intent(in)    :: send_counts(:)     !! Rank i is sending this counts
        class(pencil),                intent(in)    :: recv               !! Information about send buffer
        integer(int32),               intent(in)    :: recv_counts(:)     !! Rank i is recieving this counts
        TYPE_MPI_DATATYPE,            intent(in)    :: base_type          !! Base MPI_Datatype
        integer(int64),               intent(in)    :: base_storage       !! Number of bytes needed to store single element
        TYPE_MPI_DATATYPE,            intent(out)   :: send_dtype         !! Datatype used to send data
        integer(int32),               intent(out)   :: send_displ         !! Send displacement in bytes
        TYPE_MPI_DATATYPE,            intent(out)   :: recv_dtype         !! Datatype used to recv data
        integer(int32),               intent(out)   :: recv_displ         !! Recv displacement in bytes
        TYPE_MPI_DATATYPE   :: temp1
        integer(int32)      :: ierr                 !! Error code

        send_displ = send%counts(1) * recv_counts(2) * int(base_storage, int32)
        call MPI_Type_contiguous(send%counts(1) * recv_counts(2), base_type, send_dtype, ierr)
        call MPI_Type_commit(send_dtype, ierr)

        recv_displ = send_counts(1) * int(base_storage, int32)
        call MPI_Type_vector(recv%counts(2), send_counts(1), recv%counts(1), base_type, temp1, ierr)
        call MPI_Type_create_resized(temp1, LB, int(recv_displ, MPI_ADDRESS_KIND), recv_dtype, ierr)
        call MPI_Type_commit(recv_dtype, ierr)
        call free_datatypes(temp1)
    end subroutine create_reshape_21

    subroutine create_reshape_12(send, send_counts, recv, recv_counts, base_type, base_storage, send_dtype, send_displ, recv_dtype, recv_displ)
    !! Creates reshape datatypes for 2D data: from 1d slabs to 2d bricks
        class(pencil),                intent(in)    :: send               !! Information about send buffer
        integer(int32),               intent(in)    :: send_counts(:)     !! Rank i is sending this counts
        class(pencil),                intent(in)    :: recv               !! Information about send buffer
        integer(int32),               intent(in)    :: recv_counts(:)     !! Rank i is recieving this counts
        TYPE_MPI_DATATYPE,            intent(in)    :: base_type          !! Base MPI_Datatype
        integer(int64),               intent(in)    :: base_storage       !! Number of bytes needed to store single element
        TYPE_MPI_DATATYPE,            intent(out)   :: send_dtype         !! Datatype used to send data
        integer(int32),               intent(out)   :: send_displ         !! Send displacement in bytes
        TYPE_MPI_DATATYPE,            intent(out)   :: recv_dtype         !! Datatype used to recv data
        integer(int32),               intent(out)   :: recv_displ         !! Recv displacement in bytes
        TYPE_MPI_DATATYPE   :: temp1
        integer(int32)      :: ierr                 !! Error code

        send_displ = recv_counts(1) * int(base_storage, int32)
        call MPI_Type_vector(send%counts(2), recv_counts(1), send%counts(1), base_type, temp1, ierr)
        call MPI_Type_create_resized(temp1, LB, int(send_displ, MPI_ADDRESS_KIND), send_dtype, ierr)
        call MPI_Type_commit(send_dtype, ierr)
        call free_datatypes(temp1)

        recv_displ = recv%counts(1) * send_counts(2) * int(base_storage, int32)
        call MPI_Type_contiguous(recv%counts(1) * send_counts(2), base_type, recv_dtype, ierr)
        call MPI_Type_commit(recv_dtype, ierr)
    end subroutine create_reshape_12

    subroutine free_datatypes(t1, t2, t3, t4)
    !! Frees temporary datatypes
        TYPE_MPI_DATATYPE,  intent(inout), optional :: t1     !! Temporary datatype
        TYPE_MPI_DATATYPE,  intent(inout), optional :: t2     !! Temporary datatype
        TYPE_MPI_DATATYPE,  intent(inout), optional :: t3     !! Temporary datatype
        TYPE_MPI_DATATYPE,  intent(inout), optional :: t4     !! Temporary datatype
        integer(int32)                              :: ierr   !! Error code

        if ( present(t1) ) call MPI_Type_free(t1, ierr)
        if ( present(t2) ) call MPI_Type_free(t2, ierr)
        if ( present(t3) ) call MPI_Type_free(t3, ierr)
        if ( present(t4) ) call MPI_Type_free(t4, ierr)
    end subroutine free_datatypes
end module dtfft_reshape_handle_datatype

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "mkl_dfti.f90"
module dtfft_interface_mkl_native_m
!! This module creates native interface with MKL library
use MKL_DFTI
implicit none
private
public :: DFTI_NO_ERROR,                &
          DFTI_DOUBLE, DFTI_SINGLE,     &
          DFTI_NUMBER_OF_TRANSFORMS,    &
          DFTI_PLACEMENT,               &
          DFTI_INPUT_DISTANCE,          &
          DFTI_OUTPUT_DISTANCE,         &
          DFTI_CONJUGATE_EVEN_STORAGE,  &
          DFTI_COMPLEX_COMPLEX,         &
          DFTI_COMPLEX,                 &
          DFTI_REAL,                    &
          DFTI_INPLACE,                 &
          DFTI_NOT_INPLACE,             &
          DFTI_INPUT_STRIDES,           &
          DFTI_OUTPUT_STRIDES,          &
          DFTI_THREAD_LIMIT
end module dtfft_interface_mkl_native_m

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
#include "dtfft_config.h"
#include "dtfft.f03"
!------------------------------------------------------------------------------------------------
module dtfft_plan
!! This module describes [[dtfft_plan_t]], [[dtfft_plan_c2c_t]], [[dtfft_plan_r2c_t]] and [[dtfft_plan_r2r_t]] types
use iso_c_binding,                    only: c_loc, c_f_pointer, c_ptr, c_bool, c_null_ptr
use iso_fortran_env,                  only: int8, int32, int64, real32, real64, output_unit, error_unit
#ifdef DTFFT_WITH_OPENMP
use omp_lib,                          only: omp_get_max_threads
#endif
use dtfft_abstract_executor,          only: abstract_executor, FFT_1D, FFT_2D, FFT_C2C, FFT_R2C, FFT_R2R
#ifdef DTFFT_WITH_FFTW
use dtfft_executor_fftw_m,            only: fftw_executor
#endif
#ifdef DTFFT_WITH_MKL
use dtfft_executor_mkl_m,             only: mkl_executor
#endif
#ifdef DTFFT_WITH_CUFFT
use dtfft_executor_cufft_m,           only: cufft_executor
#endif
#ifdef DTFFT_WITH_VKFFT
use dtfft_executor_vkfft_m,           only: vkfft_executor
#endif
use dtfft_config
use dtfft_errors
use dtfft_pencil,                     only: pencil_ => pencil, pencil_init, get_local_sizes_private => get_local_sizes, dtfft_pencil_t
use dtfft_parameters
use dtfft_reshape_plan,               only: reshape_plan
use dtfft_transpose_plan,             only: transpose_plan
use dtfft_utils
#ifdef DTFFT_WITH_CUDA
use dtfft_interface_cuda_runtime
#endif
#ifdef DTFFT_WITH_NVSHMEM
use dtfft_interface_nvshmem,          only: is_nvshmem_ptr
#endif
#include "_dtfft_cuda.h"
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
#include "_dtfft_profile.h"
implicit none
private
public :: dtfft_plan_t
public :: dtfft_plan_c2c_t
public :: dtfft_plan_r2c_t
public :: dtfft_plan_r2r_t

  type :: async_request
  !! Handle for async transpose operation
    integer(int32)          :: request_type         !! Type of request
    logical                 :: is_started = .false. !! Flag that indicates if transpose was started
    type(c_ptr)             :: in                   !! Input pointer
    type(c_ptr)             :: out                  !! Output pointer
    type(c_ptr)             :: aux                  !! Aux pointer
  end type async_request

#ifdef ENABLE_INPUT_CHECK
#define CHECK_REQUEST(request, handle, converter, check_func)         \
  if( is_null_ptr(request%val) ) ierr = DTFFT_ERROR_INVALID_REQUEST;  \
  CHECK_ERROR_AND_RETURN;                                             \
  call c_f_pointer(request%val, handle);                              \
  if ( .not. handle%is_started                                        \
    .or. .not. check_func(converter(handle%request_type))             \
    .or. is_null_ptr(handle%in)                                       \
    .or. is_null_ptr(handle%out)) ierr = DTFFT_ERROR_INVALID_REQUEST; \
  CHECK_ERROR_AND_RETURN
#else
#define CHECK_REQUEST(request, handle, converter, check_func)         \
  call c_f_pointer(request%val, handle)
#endif


  integer(int32), parameter :: CHECK_AUX_CALLED_BY_RESHAPE   = 2
    !! Indicates that `check_aux` was called by reshape operation
  integer(int32), parameter :: CHECK_AUX_CALLED_BY_EXECUTE   = 3
    !! Indicates that `check_aux` was called by execute operation

  type :: fft_executor
  !! FFT handle
    class(abstract_executor), allocatable :: fft
    !! Executor
  end type fft_executor

  type, abstract :: dtfft_plan_t
  !! Abstract class for all ``dtFFT`` plans
  private
    integer(int8)                                 :: ndims
      !! Number of global dimensions
    integer(int32),                   allocatable :: dims(:)
      !! Global dimensions
    integer(int32),                   allocatable :: grid_dims(:)
      !! Grid decomposition dimensions
    type(dtfft_precision_t)                       :: precision
      !! Precision of transform
    logical                                       :: is_created = .false.
      !! Plan creation flag
    logical                                       :: is_transpose_plan = .false.
      !! Plan is transpose only
    logical                                       :: is_aux_alloc = .false.
      !! Auxiliary buffer is allocated internally
    logical                                       :: is_z_slab = .false.
      !! Using Z-slab optimization
      !!
      !! Only 3D plan.
      !!
      !! When .true., then data is distributed only Z direction and it creates a possibility for optimization:
      !!
      !! - 2 dimensional FFT plan is created for both X and Y dimensions
      !! - Single call to MPI_Alltoall is required to transpose data from X-align to Z-align
      !!
      !! For CUDA build this optimization means single CUDA kernel that tranposes data directly from X to Z
    logical                                       :: is_y_slab = .false.
      !! Using Y-slab optimization
      !!
      !! Only 3D plan.
      !!
      !! When .true., then data is distributed only Y direction and it creates a possibility for optimization:
      !!
      !! - 2 dimensional FFT plan is created for both Y and Z dimensions
      !! - Transpose from Y-align to Z-align is skipped
    logical                                       :: is_reshape_enabled = .false.
      !! Reshape operations from bricks to pencils and vice versa are enabled
    logical                                       :: is_final_reshape_enabled = .false.
      !! Final reshape from pencils to bricks in fourier space is enabled
      !! Default is .false., which means data remains in pencils layout in fourier space
    type(dtfft_effort_t)                          :: effort
      !! User defined type of effort
    integer(int64)                                :: storage_size
      !! Single element size in bytes
    type(dtfft_executor_t)                        :: executor
      !! FFT executor type
    TYPE_MPI_COMM                                 :: comm
      !! Grid communicator
    TYPE_MPI_COMM,                    allocatable :: comms(:)
      !! Local 1d communicators
    type(transpose_plan)                          :: plan
      !! Transpose plan handle
    type(reshape_plan)                            :: rplan
      !! Reshape plan handle
    type(pencil_),                    allocatable :: pencils(:)
      !! Information about data aligment and datatypes
    type(pencil_)                                 :: bricks(2)
      !! Pencil decomposition info in `bricks` layout for both `real` and `fourier` spaces
    type(dtfft_platform_t)                        :: platform
      !! Execution platform
#ifdef DTFFT_WITH_CUDA
    type(dtfft_stream_t)                          :: stream
      !! CUDA Stream associated with current plan
#endif
    type(c_ptr)                                   :: aux_ptr
      !! Auxiliary pointer
    type(fft_executor),               allocatable :: fft(:)
      !! Internal fft runners
    integer(int32),                   allocatable :: fft_mapping(:)
      !! Memory and plan creation optimization.
      !! In case same FFTs needs to be run in different dimensions
      !! only single FFT plan needs to be created
  contains
  private
    procedure,  pass(self), non_overridable, public :: transpose          !! Performs single transposition
    procedure,  pass(self), non_overridable, public :: transpose_ptr      !! Performs single transposition using type(c_ptr) pointers instead of buffers
    procedure,  pass(self), non_overridable, public :: transpose_start    !! Starts an asynchronous transpose operation
    procedure,  pass(self), non_overridable, public :: transpose_start_ptr!! Starts an asynchronous transpose operation using type(c_ptr) pointers instead of buffers
    procedure,  pass(self), non_overridable, public :: transpose_end      !! Ends previously started transposition
    procedure,  pass(self), non_overridable, public :: execute            !! Executes plan
    procedure,  pass(self), non_overridable, public :: execute_ptr        !! Executes plan using type(c_ptr) pointers instead of buffers
    procedure,  pass(self), non_overridable, public :: reshape            !! Performs reshape from `bricks` to `pencils` layout or vice versa
    procedure,  pass(self), non_overridable, public :: reshape_ptr        !! Performs reshape from `bricks` to `pencils` layout or vice versa using type(c_ptr) pointers instead of buffers
    procedure,  pass(self), non_overridable, public :: reshape_start      !! Starts an asynchronous reshape operation
    procedure,  pass(self), non_overridable, public :: reshape_start_ptr  !! Starts an asynchronous reshape operation using type(c_ptr) pointers instead of buffers
    procedure,  pass(self), non_overridable, public :: reshape_end        !! Ends an asynchronous reshape operation
    procedure,  pass(self), non_overridable, public :: destroy            !! Destroys plan
    procedure,  pass(self), non_overridable, public :: get_local_sizes    !! Returns local starts and counts in `real` and `fourier` spaces
    procedure,  pass(self), non_overridable, public :: get_alloc_size     !! Wrapper around ``get_local_sizes`` to obtain number of elements only
    procedure,  pass(self), non_overridable, public :: get_z_slab_enabled !! Returns logical value is Z-slab optimization is enabled
    procedure,  pass(self), non_overridable, public :: get_y_slab_enabled !! Returns logical value is Y-slab optimization is enabled
    procedure,  pass(self), non_overridable, public :: get_pencil         !! Returns pencil decomposition
    procedure,  pass(self), non_overridable, public :: get_element_size   !! Returns number of bytes required to store single element.
    procedure,  pass(self), non_overridable, public :: get_alloc_bytes    !! Returns minimum number of bytes required to execute plan
    procedure,  pass(self), non_overridable, public :: get_aux_size       !! Returns size of auxiliary buffer in elements
    procedure,  pass(self), non_overridable, public :: get_aux_bytes      !! Returns minimum number of bytes required for auxiliary buffer
    procedure,  pass(self), non_overridable, public :: get_aux_size_reshape     !! Returns size of auxiliary buffer for `reshape` in elements
    procedure,  pass(self), non_overridable, public :: get_aux_bytes_reshape    !! Returns minimum number of bytes required for auxiliary buffer for `reshape`
    procedure,  pass(self), non_overridable, public :: get_aux_size_transpose   !! Returns size of auxiliary buffer for `transpose` in elements
    procedure,  pass(self), non_overridable, public :: get_aux_bytes_transpose  !! Returns minimum number of bytes required for auxiliary buffer for `transpose`
    procedure,  pass(self), non_overridable, public :: get_executor       !! Returns FFT Executor associated with plan
    procedure,  pass(self), non_overridable, public :: get_dims           !! Returns global dimensions
    procedure,  pass(self), non_overridable, public :: get_grid_dims      !! Returns grid decomposition dimensions
    procedure,  pass(self), non_overridable, public :: get_precision      !! Returns precision of plan
    procedure,  pass(self), non_overridable, public :: report             !! Prints plan details
#ifdef DTFFT_WITH_COMPRESSION
    procedure,  pass(self), non_overridable, public :: report_compression !! Reports compression
#endif
    procedure,  pass(self), non_overridable, public :: mem_alloc_ptr      !! Allocates memory for type(c_ptr)
    generic,                                 public :: mem_alloc =>       &
                                                       mem_alloc_r32_1d,  &
                                                       mem_alloc_r64_1d,  &
                                                       mem_alloc_r32_2d,  &
                                                       mem_alloc_r64_2d,  &
                                                       mem_alloc_r32_3d,  &
                                                       mem_alloc_r64_3d,  &
                                                       mem_alloc_c32_1d,  &
                                                       mem_alloc_c64_1d,  &
                                                       mem_alloc_c32_2d,  &
                                                       mem_alloc_c64_2d,  &
                                                       mem_alloc_c32_3d,  &
                                                       mem_alloc_c64_3d
      !! Allocates memory specific for this plan
    procedure,  pass(self), non_overridable, public :: mem_free_ptr       !! Frees previously allocated memory for type(c_ptr)
    generic,                                 public :: mem_free =>        &
                                                       mem_free_r32_1d,   &
                                                       mem_free_r32_2d,   &
                                                       mem_free_r32_3d,   &
                                                       mem_free_r64_1d,   &
                                                       mem_free_r64_2d,   &
                                                       mem_free_r64_3d,   &
                                                       mem_free_c32_1d,   &
                                                       mem_free_c32_2d,   &
                                                       mem_free_c32_3d,   &
                                                       mem_free_c64_1d,   &
                                                       mem_free_c64_2d,   &
                                                       mem_free_c64_3d
    !! Frees previously allocated memory specific for this plan
    procedure,  pass(self), non_overridable, public :: get_backend        !! Returns selected backend during autotuning
    procedure,  pass(self), non_overridable, public :: get_reshape_backend!! Returns selected backend for reshape operations during autotuning
#ifdef DTFFT_WITH_CUDA
    procedure,  pass(self), non_overridable, public :: get_platform       !! Returns plan execution platform
    generic,                                 public :: get_stream       & !! Returns CUDA stream associated with plan
                                                    => get_stream_ptr,  &
                                                       get_stream_int64
    procedure,  pass(self), non_overridable         :: get_stream_ptr     !! Returns CUDA stream associated with plan
    procedure,  pass(self), non_overridable         :: get_stream_int64   !! Returns CUDA stream associated with plan
#endif
    procedure,  pass(self), non_overridable         :: execute_private    !! Executes plan
    procedure,  pass(self), non_overridable         :: execute_2d         !! Executes 2d plan
    procedure,  pass(self), non_overridable         :: execute_2d_reshape
    procedure,  pass(self), non_overridable         :: execute_z_slab     !! Executes Z slab plan
    procedure,  pass(self), non_overridable         :: execute_z_slab_reshape
    procedure,  pass(self), non_overridable         :: execute_generic    !! Executes plan with specified auxiliary buffer
    procedure,  pass(self), non_overridable         :: execute_generic_reshape
    procedure,  pass(self), non_overridable         :: transpose_private  !! Performs single transposition using type(c_ptr) pointers instead of buffers
    procedure,  pass(self), non_overridable         :: reshape_private    !! Performs reshape from `bricks` to `pencils` layout or vice versa using type(c_ptr) pointers instead of buffers
    procedure,  pass(self), non_overridable         :: check_create_args  !! Check arguments provided to `create` subroutines
    procedure,  pass(self), non_overridable         :: create_private     !! Creates core
    procedure,  pass(self), non_overridable         :: alloc_fft_plans    !! Allocates `fft_executor` classes
    procedure,  pass(self), non_overridable         :: check_aux          !! Checks if aux buffer was passed
                                                                          !! and if not will allocate one internally
    procedure,  pass(self), non_overridable         :: get_local_sizes_internal
    procedure,  pass(self), non_overridable         :: mem_alloc_r32_1d   !! Allocates memory for 1d real32 pointer
    procedure,  pass(self), non_overridable         :: mem_alloc_r64_1d   !! Allocates memory for 1d real64 pointer
    procedure,  pass(self), non_overridable         :: mem_alloc_r32_2d   !! Allocates memory for 2d real32 pointer
    procedure,  pass(self), non_overridable         :: mem_alloc_r64_2d   !! Allocates memory for 2d real64 pointer
    procedure,  pass(self), non_overridable         :: mem_alloc_r32_3d   !! Allocates memory for 2d real32 pointer
    procedure,  pass(self), non_overridable         :: mem_alloc_r64_3d   !! Allocates memory for 2d real64 pointer
    procedure,  pass(self), non_overridable         :: mem_alloc_c32_1d   !! Allocates memory for 1d complex32 pointer
    procedure,  pass(self), non_overridable         :: mem_alloc_c64_1d   !! Allocates memory for 1d complex64 pointer
    procedure,  pass(self), non_overridable         :: mem_alloc_c32_2d   !! Allocates memory for 2d complex32 pointer
    procedure,  pass(self), non_overridable         :: mem_alloc_c64_2d   !! Allocates memory for 2d complex64 pointer
    procedure,  pass(self), non_overridable         :: mem_alloc_c32_3d   !! Allocates memory for 3d complex32 pointer
    procedure,  pass(self), non_overridable         :: mem_alloc_c64_3d   !! Allocates memory for 3d complex64 pointer
    procedure,  pass(self), non_overridable         :: mem_free_r32_1d    !! Frees real32 1d pointer
    procedure,  pass(self), non_overridable         :: mem_free_r64_1d    !! Frees real64 1d pointer
    procedure,  pass(self), non_overridable         :: mem_free_r32_2d    !! Frees real32 2d pointer
    procedure,  pass(self), non_overridable         :: mem_free_r64_2d    !! Frees real64 2d pointer
    procedure,  pass(self), non_overridable         :: mem_free_r32_3d    !! Frees real32 3d pointer
    procedure,  pass(self), non_overridable         :: mem_free_r64_3d    !! Frees real64 3d pointer
    procedure,  pass(self), non_overridable         :: mem_free_c32_1d    !! Frees complex32 1d pointer
    procedure,  pass(self), non_overridable         :: mem_free_c64_1d    !! Frees complex64 1d pointer
    procedure,  pass(self), non_overridable         :: mem_free_c32_2d    !! Frees complex32 2d pointer
    procedure,  pass(self), non_overridable         :: mem_free_c64_2d    !! Frees complex64 2d pointer
    procedure,  pass(self), non_overridable         :: mem_free_c32_3d    !! Frees complex32 3d pointer
    procedure,  pass(self), non_overridable         :: mem_free_c64_3d    !! Frees complex64 3d pointer
  end type dtfft_plan_t

  type, abstract, extends(dtfft_plan_t) :: dtfft_core_c2c
  !! Abstract C2C Plan
  private
  contains
  private
    procedure, pass(self), non_overridable          :: create_c2c_core  !! Creates plan for both C2C and R2C
  end type dtfft_core_c2c

  type, extends(dtfft_core_c2c) :: dtfft_plan_c2c_t
  !! C2C Plan
  private
  contains
  private
    generic,              public  :: create => create_c2c,  &
                                               create_c2c_pencil
    !! Creates C2C plan
    procedure, pass(self)         :: create_c2c              !! Creates C2C plan using global dimensions
    procedure, pass(self)         :: create_c2c_pencil       !! Creates C2C plan using Pencil of local data
    procedure, pass(self)         :: create_c2c_internal     !! Private method that combines common logic for C2C plan creation
  end type dtfft_plan_c2c_t

  type, extends(dtfft_core_c2c) :: dtfft_plan_r2c_t
  !! R2C Plan
  private
    type(pencil_)  :: real_pencil
      !! "Real" pencil decomposition info
  contains
  private
    generic,              public  :: create => create_r2c,  &
                                               create_r2c_pencil
    !! Creates R2C plan
    procedure, pass(self)         :: create_r2c              !! Creates R2C plan using global dimensions
    procedure, pass(self)         :: create_r2c_pencil       !! Creates R2C plan using Pencil of local data
    procedure, pass(self)         :: create_r2c_internal     !! Private method that combines common logic for R2C plan creation
  end type dtfft_plan_r2c_t

  type, extends(dtfft_plan_t) :: dtfft_plan_r2r_t
  !! R2R Plan
  private
  contains
  private
    generic,              public  :: create => create_r2r, &
                                               create_r2r_pencil
    !! Creates R2R plan
    procedure, pass(self)         :: create_r2r               !! Creates R2R plan using global dimensions
    procedure, pass(self)         :: create_r2r_pencil        !! Creates R2R plan using Pencil of local data
    procedure, pass(self)         :: create_r2r_internal      !! Private method that combines common logic for R2R plan creation
  end type dtfft_plan_r2r_t

contains

  subroutine reshape(self, in, out, reshape_type, aux, error_code)
  !! Performs reshape from `bricks` to `pencils` layout or vice versa
  !!
  !! @note
  !! Buffers `in` and `out` cannot be the same
  !! @endnote
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(*),  target,           intent(inout) :: in(..)
      !! Incoming buffer of any rank and kind. Note that this buffer
      !! will be modified in GPU build
    type(*),  target,           intent(inout) :: out(..)
      !! Resulting buffer of any rank and kind
    type(dtfft_reshape_t),      intent(in)    :: reshape_type
      !! Type of reshape.
    type(*),  target, optional, intent(inout) :: aux(..)
      !! Optional auxiliary buffer.
      !! Size of buffer must be greater than value
      !! returned by `alloc_size` parameter of [[dtfft_plan_t(type):get_local_sizes]] subroutine
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    type(c_ptr)     :: aux_ptr

    aux_ptr = c_null_ptr; if( present(aux) ) aux_ptr = c_loc(aux)
    call self%reshape_ptr(c_loc(in), c_loc(out), reshape_type, aux_ptr, error_code)
  end subroutine reshape

  subroutine reshape_ptr(self, in, out, reshape_type, aux, error_code)
  !! Performs reshape from `bricks` to `pencils` layout or vice versa using type(c_ptr) pointers instead of buffers
  !! @note
  !! Buffers `in` and `out` cannot be the same
  !! @endnote
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Incoming pointer. Note that values of this pointer
      !! will be modified in GPU build
    type(c_ptr),                intent(in)    :: out
      !! Resulting pointer
    type(dtfft_reshape_t),      intent(in)    :: reshape_type
      !! Type of reshape.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary buffer. Not optional. If not required, c_null_ptr must be passed.
      !! Size of buffer must be greater than value
      !! returned by `alloc_size` parameter of [[dtfft_plan_t(type):get_local_sizes]] subroutine
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    REGION_BEGIN("dtfft_reshape", COLOR_OLIVE)
    call self%reshape_private(in, out, reshape_type, aux, EXEC_BLOCKING, error_code)
    REGION_END("dtfft_reshape")
  end subroutine reshape_ptr

  function reshape_start(self, in, out, reshape_type, aux, error_code) result(request)
  !! Starts an asynchronous reshape operation
  !! @note
  !! Buffers `in` and `out` cannot be the same
  !! @endnote
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(*),  target,           intent(inout) :: in(..)
      !! Incoming buffer of any rank and kind. Note that this buffer
      !! will be modified in GPU build
    type(*),  target,           intent(inout) :: out(..)
      !! Resulting buffer of any rank and kind
    type(dtfft_reshape_t),      intent(in)    :: reshape_type
      !! Type of reshape.
    type(*),  target, optional, intent(inout) :: aux(..)
      !! Optional auxiliary buffer.
      !! Size of buffer must be greater than value
      !! returned by `alloc_size` parameter of [[dtfft_plan_t(type):get_local_sizes]] subroutine
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    type(dtfft_request_t)                      :: request
      !! Asynchronous handle describing started reshape operation
    type(c_ptr)     :: aux_ptr

    aux_ptr = c_null_ptr; if( present(aux) ) aux_ptr = c_loc(aux)
    request = self%reshape_start_ptr(c_loc(in), c_loc(out), reshape_type, aux_ptr, error_code)
  end function reshape_start

  function reshape_start_ptr(self, in, out, reshape_type, aux, error_code) result(request)
  !! Starts an asynchronous reshape operation using type(c_ptr) pointers instead of buffers
  !! @note
  !! Buffers `in` and `out` cannot be the same
  !! @endnote
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Incoming pointer. Note that values of this pointer
      !! will be modified in GPU build
    type(c_ptr),                intent(in)    :: out
      !! Resulting pointer
    type(dtfft_reshape_t),      intent(in)    :: reshape_type
      !! Type of reshape.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary buffer. Not optional. If not required, c_null_ptr must be passed.
      !! Size of buffer must be greater than value
      !! returned by `alloc_size` parameter of [[dtfft_plan_t(type):get_local_sizes]] subroutine
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    type(dtfft_request_t)                     :: request
      !! Asynchronous handle describing started reshape operation
    integer(int32)  :: ierr     !! Error code
    type(async_request),     pointer          :: internal_handle
      !! Handle to internal reshape structure
    type(c_ptr) :: true_aux

    PHASE_BEGIN("dtfft_reshape_start", COLOR_TEAL)
    request = dtfft_request_t(c_null_ptr)
    call self%reshape_private(in, out, reshape_type, aux, EXEC_NONBLOCKING, ierr, true_aux)
    if( ierr == DTFFT_SUCCESS ) then
      allocate(internal_handle)
      internal_handle%request_type = reshape_type%val
      internal_handle%is_started = .true.
      internal_handle%in = in
      internal_handle%out = out
      internal_handle%aux = true_aux
      request%val = c_loc(internal_handle)
    endif
    if ( present( error_code ) ) error_code = ierr
    PHASE_END("dtfft_reshape_start")
  end function reshape_start_ptr

  subroutine reshape_end(self, request, error_code)
  !! Ends an asynchronous reshape operation
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(dtfft_request_t),      intent(inout) :: request
      !! Asynchronous handle describing started reshape operation
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    type(async_request),    pointer           :: internal_handle
      !! Handle to internal reshape structure
    integer(int32)  :: ierr    !! Error code

    ierr = DTFFT_SUCCESS
    CHECK_REQUEST(request, internal_handle, dtfft_reshape_t, is_valid_reshape_type)
    PHASE_BEGIN("dtfft_reshape_end", COLOR_SIENNA)
    call self%rplan%execute_end(internal_handle%in, internal_handle%out, internal_handle%request_type, internal_handle%aux, ierr)
    PHASE_END("dtfft_reshape_end")
    CHECK_ERROR_AND_RETURN
    deallocate(internal_handle)
    request = dtfft_request_t(c_null_ptr)
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine reshape_end

  subroutine reshape_private(self, in, out, reshape_type, aux, exec_type, error_code, true_aux)
  !! Performs reshape from `bricks` to `pencils` layout or vice versa using type(c_ptr) pointers instead of buffers
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Incoming pointer. Note that values of this pointer
      !! will be modified in GPU build
    type(c_ptr),                intent(in)    :: out
      !! Resulting pointer
    type(dtfft_reshape_t),      intent(in)    :: reshape_type
      !! Type of reshape.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary buffer. Not optional. If not required, c_null_ptr must be passed.
      !! Size of buffer must be greater than value
      !! returned by `alloc_size` parameter of [[dtfft_plan_t(type):get_local_sizes]] subroutine
    type(async_exec_t),         intent(in)    :: exec_type
      !! Type of asynchronous execution.
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    type(c_ptr),      optional, intent(out)   :: true_aux
    integer(int32)  :: ierr    !! Error code
    type(c_ptr)   :: aux1, aux2

    ierr = DTFFT_SUCCESS
#ifdef ENABLE_INPUT_CHECK
    if ( .not. self%is_created )                                                                &
      ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    if ( .not.is_valid_reshape_type(reshape_type) )                                             &
      ierr = DTFFT_ERROR_INVALID_RESHAPE_TYPE
    CHECK_ERROR_AND_RETURN
    if ( is_same_ptr(in, out) )                                                                 &
      ierr = DTFFT_ERROR_INPLACE_RESHAPE
    CHECK_ERROR_AND_RETURN
    if ( .not. self%is_reshape_enabled )                                                        &
      ierr = DTFFT_ERROR_RESHAPE_NOT_SUPPORTED
    CHECK_ERROR_AND_RETURN
    if ( is_same_ptr(in, aux) .or. is_same_ptr(out, aux) )                                      &
      ierr = DTFFT_ERROR_INVALID_AUX
    CHECK_ERROR_AND_RETURN
# ifdef DTFFT_WITH_CUDA
    if ( self%platform == DTFFT_PLATFORM_CUDA  ) then
      ierr = check_device_pointers(in, out, self%plan%get_backend(), aux)
      CHECK_ERROR_AND_RETURN
    endif
# endif
#endif

    call self%check_aux(aux, CHECK_AUX_CALLED_BY_RESHAPE, aux1, aux2)
    call self%rplan%execute(in, out, reshape_type%val, exec_type, aux1, ierr)
#ifdef ENABLE_INPUT_CHECK
    CHECK_ERROR_AND_RETURN
#endif
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
    if ( present( true_aux ) ) true_aux = aux1
  end subroutine reshape_private

  subroutine transpose(self, in, out, transpose_type, aux, error_code)
  !! Performs single transposition
  !!
  !! @note
  !! Buffers `in` and `out` cannot be the same
  !! @endnote
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(*),  target,           intent(inout) :: in(..)
      !! Incoming buffer of any rank and kind. Note that this buffer
      !! will be modified in GPU build
    type(*),  target,           intent(inout) :: out(..)
      !! Resulting buffer of any rank and kind
    type(dtfft_transpose_t),    intent(in)    :: transpose_type
      !! Type of transposition.
    type(*),  target, optional, intent(inout) :: aux(..)
      !! Optional auxiliary buffer.
      !! If provided, size of buffer must be at least the value
      !! returned by `alloc_size` parameter of [[dtfft_plan_t(type):get_local_sizes]] subroutine
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    type(c_ptr)     :: aux_ptr

    aux_ptr = c_null_ptr; if( present(aux) ) aux_ptr = c_loc(aux)
    call self%transpose_ptr(c_loc(in), c_loc(out), transpose_type, aux_ptr, error_code)
  end subroutine transpose

  subroutine transpose_ptr(self, in, out, transpose_type, aux, error_code)
  !! Performs single transposition using type(c_ptr) pointers instead of buffers
  !!
  !! @note
  !! Buffers `in` and `out` cannot be the same
  !! @endnote
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Incoming pointer. Note that values of this pointer
      !! will be modified in GPU build
    type(c_ptr),                intent(in)    :: out
      !! Resulting pointer
    type(dtfft_transpose_t),    intent(in)    :: transpose_type
      !! Type of transposition.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary buffer. Not optional. If not required, c_null_ptr must be passed.
      !! Size of buffer must be greater than value
      !! returned by `alloc_size` parameter of [[dtfft_plan_t(type):get_local_sizes]] subroutine
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    PHASE_BEGIN("dtfft_transpose", COLOR_TRANSPOSE)
    call self%transpose_private(in, out, aux, transpose_type, EXEC_BLOCKING, error_code)
    PHASE_END("dtfft_transpose")
  end subroutine transpose_ptr

  function transpose_start(self, in, out, transpose_type, aux, error_code) result(request)
  !! Starts an asynchronous transpose operation
  !!
  !! @note
  !! Buffers `in` and `out` cannot be the same
  !! @endnote
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(*),  target,           intent(inout) :: in(..)
      !! Incoming buffer of any rank and kind. Note that this buffer
      !! will be modified in GPU build
    type(*),  target,           intent(inout) :: out(..)
      !! Resulting buffer of any rank and kind
    type(dtfft_transpose_t),    intent(in)    :: transpose_type
      !! Type of transposition.
    type(*),  target, optional, intent(inout) :: aux(..)
      !! Optional auxiliary buffer.
      !! Size of buffer must be greater than value
      !! returned by `alloc_size` parameter of [[dtfft_plan_t(type):get_local_sizes]] subroutine
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    type(dtfft_request_t)                     :: request
      !! Asynchronous handle describing started transpose operation
    type(c_ptr)     :: aux_ptr

    aux_ptr = c_null_ptr; if( present(aux) ) aux_ptr = c_loc(aux)
    request = self%transpose_start_ptr(c_loc(in), c_loc(out), transpose_type, aux_ptr, error_code)
  end function transpose_start

  function transpose_start_ptr(self, in, out, transpose_type, aux, error_code) result(request)
  !! Starts an asynchronous transpose operation using type(c_ptr) pointers instead of buffers
  !!
  !! @note
  !! Buffers `in` and `out` cannot be the same
  !! @endnote
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Incoming pointer. Note that values of this pointer
      !! will be modified in GPU build
    type(c_ptr),                intent(in)    :: out
      !! Resulting pointer
    type(dtfft_transpose_t),    intent(in)    :: transpose_type
      !! Type of transposition.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary buffer. Not optional. If not required, c_null_ptr must be passed.
      !! Size of buffer must be greater than value
      !! returned by `alloc_size` parameter of [[dtfft_plan_t(type):get_local_sizes]] subroutine
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    type(dtfft_request_t)                     :: request
      !! Asynchronous handle describing started transpose operation
    integer(int32)  :: ierr     !! Error code
    type(async_request),     pointer      :: internal_handle
      !! Handle to internal transpose structure

    PHASE_BEGIN("dtfft_transpose_start", COLOR_TRANSPOSE)
    request = dtfft_request_t(c_null_ptr)
    call self%transpose_private(in, out, aux, transpose_type, EXEC_NONBLOCKING, ierr)
    if( ierr == DTFFT_SUCCESS ) then
      allocate(internal_handle)
      internal_handle%request_type = transpose_type%val
      internal_handle%is_started = .true.
      internal_handle%in = in
      internal_handle%out = out
      internal_handle%aux = c_null_ptr
      request%val = c_loc(internal_handle)
    endif
    if ( present( error_code ) ) error_code = ierr
    PHASE_END("dtfft_transpose_start")
  end function transpose_start_ptr

  subroutine transpose_end(self, request, error_code)
  !! Ends previously started transposition
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(dtfft_request_t),      intent(inout) :: request
      !! Handle obtained from [[dtfft_plan_t(type):transpose_start]] or [[dtfft_plan_t(type):transpose_start_ptr]]
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    type(async_request),    pointer       :: internal_handle
      !! Handle to internal transpose structure
    integer(int32)  :: ierr    !! Error code

    ierr = DTFFT_SUCCESS
    CHECK_REQUEST(request, internal_handle, dtfft_transpose_t, is_valid_transpose_type)

    PHASE_BEGIN("dtfft_transpose_end", COLOR_TRANSPOSE)
    call self%plan%execute_end(internal_handle%in, internal_handle%out, internal_handle%request_type, internal_handle%aux, ierr)
    PHASE_END("dtfft_transpose_end")
    CHECK_ERROR_AND_RETURN
    deallocate(internal_handle)
    request = dtfft_request_t(c_null_ptr)
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine transpose_end

  subroutine transpose_private(self, in, out, aux, transpose_type, exec_type, error_code)
  !! Performs single transposition using type(c_ptr) pointers instead of buffers
  !!
  !! @note
  !! Buffers `in` and `out` cannot be the same
  !! @endnote
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Incoming pointer. Note that values of this pointer
      !! will be modified in GPU build
    type(c_ptr),                intent(in)    :: out
      !! Resulting pointer
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary buffer. Not optional. If not required, c_null_ptr must be passed.
      !! Size of buffer must be greater than value
      !! returned by `alloc_size` parameter of [[dtfft_plan_t(type):get_local_sizes]] subroutine
    type(dtfft_transpose_t),    intent(in)    :: transpose_type
      !! Type of transposition.
    type(async_exec_t),         intent(in)    :: exec_type
      !! Type of asynchronous execution.
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr    !! Error code
    type(c_ptr) :: aux1, aux2

    ierr = DTFFT_SUCCESS
#ifdef ENABLE_INPUT_CHECK
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    if ( .not.is_valid_transpose_type(transpose_type)                                           &
         .or. ( self%ndims == 2 .and. abs(transpose_type%val) > 1 )                             &
         .or. (abs(transpose_type%val) == DTFFT_TRANSPOSE_X_TO_Z%val .and..not.self%is_z_slab)) &
      ierr = DTFFT_ERROR_INVALID_TRANSPOSE_TYPE
    CHECK_ERROR_AND_RETURN
    if ( is_same_ptr(in, out) )                                                                 &
      ierr = DTFFT_ERROR_INPLACE_TRANSPOSE
    CHECK_ERROR_AND_RETURN
    if ( is_same_ptr(in, aux) .or. is_same_ptr(out, aux) )                                      &
      ierr = DTFFT_ERROR_INVALID_AUX
    CHECK_ERROR_AND_RETURN
# ifdef DTFFT_WITH_CUDA
    if ( self%platform == DTFFT_PLATFORM_CUDA  ) then
      ierr = check_device_pointers(in, out, self%plan%get_backend(), aux)
      CHECK_ERROR_AND_RETURN
    endif
# endif
#endif
    call self%check_aux(aux, CHECK_AUX_CALLED_BY_RESHAPE, aux1, aux2)
    call self%plan%execute(in, out, transpose_type%val, exec_type, aux1, ierr)
    CHECK_ERROR_AND_RETURN
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine transpose_private

  subroutine execute(self, in, out, execute_type, aux, error_code)
  !! Executes plan
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(*),  target,           intent(inout) :: in(..)
      !! Incoming buffer of any rank and kind
    type(*),  target,           intent(inout) :: out(..)
      !! Resulting buffer of any rank and kind
    type(dtfft_execute_t),      intent(in)    :: execute_type
      !! Type of execution.
    type(*),  target, optional, intent(inout) :: aux(..)
      !! Optional auxiliary buffer.
      !! If provided, size of buffer must be at least the value
      !! returned by [[dtfft_plan_t(type):get_aux_size]] function
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    type(c_ptr)     :: aux_ptr

    aux_ptr = c_null_ptr; if( present(aux) ) aux_ptr = c_loc(aux)
    call self%execute_ptr(c_loc(in), c_loc(out), execute_type, aux_ptr, error_code)
  end subroutine execute

  subroutine execute_ptr(self, in, out, execute_type, aux, error_code)
  !! Executes plan using type(c_ptr) pointers instead of buffers
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Incoming pointer. Note that values of this pointer
      !! will be modified in GPU build
    type(c_ptr),                intent(in)    :: out
      !! Resulting pointer
    type(dtfft_execute_t),      intent(in)    :: execute_type
      !! Type of execution.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary buffer. Not optional. If not required, c_null_ptr must be passed.
      !! Size of buffer must be greater than value
      !! returned by `alloc_size` parameter of [[dtfft_plan_t(type):get_local_sizes]] subroutine
    integer(int32),   optional, intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code
    logical         :: inplace  !! Inplace execution flag
    type(c_ptr)  :: aux1, aux2

    inplace = is_same_ptr(in, out)
    ierr = DTFFT_SUCCESS
#ifdef ENABLE_INPUT_CHECK
    if ( .not. self%is_created )                                                  &
      ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    if ( .not.is_valid_execute_type(execute_type) )                               &
      ierr = DTFFT_ERROR_INVALID_EXECUTE_TYPE
    CHECK_ERROR_AND_RETURN
    if ( self%is_transpose_plan .and. inplace .and.                               &
      (self%ndims == 2 .or. self%is_y_slab                                        &
      .or. (self%is_reshape_enabled .and.  .not.self%is_final_reshape_enabled)))  &
      ierr = DTFFT_ERROR_INPLACE_TRANSPOSE
    CHECK_ERROR_AND_RETURN
    if ( is_same_ptr(in, aux) .or. is_same_ptr(out, aux) )                        &
      ierr = DTFFT_ERROR_INVALID_AUX
    CHECK_ERROR_AND_RETURN
    if ( self%plan%get_async_active() )                                           &
      ierr = DTFFT_ERROR_TRANSPOSE_ACTIVE
    CHECK_ERROR_AND_RETURN
    if ( self%is_reshape_enabled ) then
      if ( self%rplan%get_async_active() )                                        &
        ierr = DTFFT_ERROR_RESHAPE_ACTIVE
      CHECK_ERROR_AND_RETURN
    endif
    if ( self%is_transpose_plan ) then
      select type( self )
      class is ( dtfft_plan_r2c_t )
        ierr = DTFFT_ERROR_R2C_EXECUTE_CALLED
      CHECK_ERROR_AND_RETURN
      endselect
    endif
# ifdef DTFFT_WITH_CUDA
    if ( self%platform == DTFFT_PLATFORM_CUDA  ) then
      ierr = check_device_pointers(in, out, self%plan%get_backend(), aux)
      CHECK_ERROR_AND_RETURN
    endif
# endif
#endif

    PHASE_BEGIN("dtfft_execute", COLOR_EXECUTE)
    call self%check_aux(aux, CHECK_AUX_CALLED_BY_EXECUTE, aux1, aux2)
    call self%execute_private(in, out, execute_type, aux1, inplace, aux2)
    PHASE_END("dtfft_execute")
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine execute_ptr

  subroutine execute_private(self, in, out, execute_type, aux, inplace, aux2)
  !! Executes plan with specified auxiliary buffer
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Source pointer
    type(c_ptr),                intent(in)    :: out
      !! Target pointer
    type(dtfft_execute_t),      intent(in)    :: execute_type
      !! Type of execution.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary pointer.
    logical,                    intent(in)    :: inplace
      !! Inplace execution flag
    type(c_ptr),                intent(in)    :: aux2
      !! Second Auxiliary pointer.

    if ( self%ndims == 2 .or. self%is_y_slab ) then
      if ( self%is_reshape_enabled ) then
        call self%execute_2d_reshape(in, out, execute_type, aux, aux2)
      else
        call self%execute_2d(in, out, execute_type, aux, aux2)
      endif
    else if ( self%is_z_slab ) then
      if ( self%is_reshape_enabled ) then
        call self%execute_z_slab_reshape(in, out, execute_type, aux, aux2)
      else
        call self%execute_z_slab(in, out, execute_type, aux, inplace, aux2)
      endif
    else
      if ( self%is_reshape_enabled ) then
        call self%execute_generic_reshape(in, out, execute_type, aux, aux2)
      else
        call self%execute_generic(in, out, execute_type, aux, aux2)
      endif
    endif
  end subroutine execute_private

  subroutine execute_2d(self, in, out, execute_type, aux, aux2)
  !! Executes plan with specified auxiliary buffer
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Source pointer
    type(c_ptr),                intent(in)    :: out
      !! Target pointer
    type(dtfft_execute_t),      intent(in)    :: execute_type
      !! Type of execution.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary pointer.
    type(c_ptr),                intent(in)    :: aux2
      !! Second Auxiliary pointer.

    if ( self%is_transpose_plan ) then
      if ( execute_type == DTFFT_EXECUTE_FORWARD ) then
        ! call self%pencils(1)%output("X aligned", in)
        call self%plan%execute(in, out, DTFFT_TRANSPOSE_X_TO_Y%val, EXEC_BLOCKING, aux)
        ! call self%pencils(2)%output("Y aligned", out)
      else
        call self%plan%execute(in, out, DTFFT_TRANSPOSE_Y_TO_X%val, EXEC_BLOCKING, aux)
        ! call self%pencils(1)%output("X BACK aligned", out)
      endif
      return
    endif

    if ( execute_type == DTFFT_EXECUTE_FORWARD ) then
      call self%fft(1)%fft%execute(in, aux, FFT_FORWARD)
      call self%plan%execute(aux, out, DTFFT_TRANSPOSE_X_TO_Y%val, EXEC_BLOCKING, aux2)
      call self%fft(self%fft_mapping(2))%fft%execute(out, out, FFT_FORWARD)
    else
      call self%fft(self%fft_mapping(2))%fft%execute(in, in, FFT_BACKWARD)
      call self%plan%execute(in, aux, DTFFT_TRANSPOSE_Y_TO_X%val, EXEC_BLOCKING, aux2)
      call self%fft(1)%fft%execute(aux, out, FFT_BACKWARD)
    endif
  end subroutine execute_2d

  subroutine execute_2d_reshape(self, in, out, execute_type, aux, aux2)
      !! Executes plan with specified auxiliary buffer
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Source pointer
    type(c_ptr),                intent(in)    :: out
      !! Target pointer
    type(dtfft_execute_t),      intent(in)    :: execute_type
      !! Type of execution.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary pointer.
    type(c_ptr),                intent(in)    :: aux2
      !! Second Auxiliary pointer.

    if ( self%is_transpose_plan ) then
      if ( execute_type == DTFFT_EXECUTE_FORWARD ) then
        call self%rplan%execute(in, aux, DTFFT_RESHAPE_X_BRICKS_TO_PENCILS%val, EXEC_BLOCKING, aux2)
        if ( self%is_final_reshape_enabled ) then
          call self% plan%execute(aux, in, DTFFT_TRANSPOSE_X_TO_Y%val, EXEC_BLOCKING, aux2)
          call self%rplan%execute(in, out, DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS%val, EXEC_BLOCKING, aux2)
        else
          call self% plan%execute(aux, out, DTFFT_TRANSPOSE_X_TO_Y%val, EXEC_BLOCKING, aux2)
        endif
      else
        if ( self%is_final_reshape_enabled ) then
          call self%rplan%execute(in, out, DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS%val, EXEC_BLOCKING, aux2)
          call self% plan%execute(out, aux, DTFFT_TRANSPOSE_Y_TO_X%val, EXEC_BLOCKING, aux2)
        else
          call self% plan%execute(in, aux, DTFFT_TRANSPOSE_Y_TO_X%val, EXEC_BLOCKING, aux2)
        endif
        call self%rplan%execute(aux, out, DTFFT_RESHAPE_X_PENCILS_TO_BRICKS%val, EXEC_BLOCKING, aux2)
      endif
      return
    endif

    if ( execute_type == DTFFT_EXECUTE_FORWARD ) then
      call self%rplan%execute(in, aux, DTFFT_RESHAPE_X_BRICKS_TO_PENCILS%val, EXEC_BLOCKING, aux2)
      call self%fft(1)%fft%execute(aux, out, FFT_FORWARD)
      call self% plan%execute(out, aux, DTFFT_TRANSPOSE_X_TO_Y%val, EXEC_BLOCKING, aux2)
      if ( self%is_final_reshape_enabled ) then
        call self%fft(self%fft_mapping(2))%fft%execute(aux, aux, FFT_FORWARD)
        call self%rplan%execute(aux, out, DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS%val, EXEC_BLOCKING, aux2)
      else
        call self%fft(self%fft_mapping(2))%fft%execute(aux, out, FFT_FORWARD)
      endif
    else
      if ( self%is_final_reshape_enabled ) then
        call self%rplan%execute(in, aux, DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS%val, EXEC_BLOCKING, aux2)
        call self%fft(self%fft_mapping(2))%fft%execute(aux, aux, FFT_BACKWARD)
      else
        call self%fft(self%fft_mapping(2))%fft%execute(in, aux, FFT_BACKWARD)
      endif
      call self% plan%execute(aux, in, DTFFT_TRANSPOSE_Y_TO_X%val, EXEC_BLOCKING, aux2)
      call self%fft(1)%fft%execute(in, aux, FFT_BACKWARD)
      call self%rplan%execute(aux, out, DTFFT_RESHAPE_X_PENCILS_TO_BRICKS%val, EXEC_BLOCKING, aux2)
    endif
  end subroutine execute_2d_reshape

  subroutine execute_z_slab(self, in, out, execute_type, aux, inplace, aux2)
  !! Executes plan with specified auxiliary buffer
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Source pointer
    type(c_ptr),                intent(in)    :: out
      !! Target pointer
    type(dtfft_execute_t),      intent(in)    :: execute_type
      !! Type of execution.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary pointer.
    logical,                    intent(in)    :: inplace
      !! Inplace execution flag
    type(c_ptr),                intent(in)    :: aux2
      !! Second Auxiliary pointer.

    if ( self%is_transpose_plan ) then
      if ( inplace ) then
        call self%execute_generic(in, out, execute_type, aux, aux2)
        return
      endif
      if ( execute_type == DTFFT_EXECUTE_FORWARD ) then
        ! call self%pencils(1)%output("X align", in)
        call self%plan%execute(in, out, DTFFT_TRANSPOSE_X_TO_Z%val, EXEC_BLOCKING, aux)
        ! call self%pencils(3)%output("Z align", out)
      else
        call self%plan%execute(in, out, DTFFT_TRANSPOSE_Z_TO_X%val, EXEC_BLOCKING, aux)
        ! call self%pencils(1)%output("BACK X align", out)
      endif
      return
    endif

    if ( execute_type == DTFFT_EXECUTE_FORWARD ) then
      call self%fft(1)%fft%execute(in, aux, FFT_FORWARD)
      call self%plan%execute(aux, out, DTFFT_TRANSPOSE_X_TO_Z%val, EXEC_BLOCKING, aux2)
      call self%fft(3)%fft%execute(out, out, FFT_FORWARD)
    else
      call self%fft(3)%fft%execute(in, in, FFT_BACKWARD)
      call self%plan%execute(in, aux, DTFFT_TRANSPOSE_Z_TO_X%val, EXEC_BLOCKING, aux2)
      call self%fft(1)%fft%execute(aux, out, FFT_BACKWARD)
    endif
  end subroutine execute_z_slab

    subroutine execute_z_slab_reshape(self, in, out, execute_type, aux, aux2)
  !! Executes plan with specified auxiliary buffer
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Source pointer
    type(c_ptr),                intent(in)    :: out
      !! Target pointer
    type(dtfft_execute_t),      intent(in)    :: execute_type
      !! Type of execution.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary pointer.
    type(c_ptr),                intent(in)    :: aux2
      !! Second Auxiliary pointer.

    if ( self%is_transpose_plan ) then
      if ( execute_type == DTFFT_EXECUTE_FORWARD ) then
        call self%rplan%execute(in, aux, DTFFT_RESHAPE_X_BRICKS_TO_PENCILS%val, EXEC_BLOCKING, aux2)
        call self% plan%execute(aux, out, DTFFT_TRANSPOSE_X_TO_Z%val, EXEC_BLOCKING, aux2)
      else
        call self% plan%execute(in, aux, DTFFT_TRANSPOSE_Z_TO_X%val, EXEC_BLOCKING, aux2)
        call self%rplan%execute(aux, out, DTFFT_RESHAPE_X_PENCILS_TO_BRICKS%val, EXEC_BLOCKING, aux2)
      endif
      return
    endif

    if ( execute_type == DTFFT_EXECUTE_FORWARD ) then
      call self%rplan%execute(in, aux, DTFFT_RESHAPE_X_BRICKS_TO_PENCILS%val, EXEC_BLOCKING, aux2)
      call self%fft(1)%fft%execute(aux, in, FFT_FORWARD)
      call self%plan%execute(in, aux, DTFFT_TRANSPOSE_X_TO_Z%val, EXEC_BLOCKING, aux2)
      call self%fft(3)%fft%execute(aux, out, FFT_FORWARD)
    else
      call self%fft(3)%fft%execute(in, aux, FFT_BACKWARD)
      call self%plan%execute(aux, in, DTFFT_TRANSPOSE_Z_TO_X%val, EXEC_BLOCKING, aux2)
      call self%fft(1)%fft%execute(in, aux, FFT_BACKWARD)
      call self%rplan%execute(aux, out, DTFFT_RESHAPE_X_PENCILS_TO_BRICKS%val, EXEC_BLOCKING, aux2)
    endif
  end subroutine execute_z_slab_reshape

  subroutine execute_generic(self, in, out, execute_type, aux, aux2)
  !! Executes plan with specified auxiliary buffer
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Source pointer
    type(c_ptr),                intent(in)    :: out
      !! Target pointer
    type(dtfft_execute_t),      intent(in)    :: execute_type
      !! Type of execution.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary pointer.
    type(c_ptr),                intent(in)    :: aux2
      !! Second Auxiliary pointer.

    if ( self%is_transpose_plan ) then
      if ( execute_type == DTFFT_EXECUTE_FORWARD ) then
        ! call self%pencils(1)%output("X aling", in)
        call self%plan%execute(in, aux, DTFFT_TRANSPOSE_X_TO_Y%val, EXEC_BLOCKING, aux2)
        ! call self%pencils(2)%output("Y aling", aux)
        call self%plan%execute(aux, out, DTFFT_TRANSPOSE_Y_TO_Z%val, EXEC_BLOCKING, aux2)
        ! call self%pencils(3)%output("Z aling", out)
      else
        call self%plan%execute(in, aux, DTFFT_TRANSPOSE_Z_TO_Y%val, EXEC_BLOCKING, aux2)
        ! call self%pencils(2)%output("BACK Y aling", aux)
        call self%plan%execute(aux, out, DTFFT_TRANSPOSE_Y_TO_X%val, EXEC_BLOCKING, aux2)
        ! call self%pencils(1)%output("BACK X aling", out)
      endif
      return
    endif

    if ( execute_type == DTFFT_EXECUTE_FORWARD ) then
      call self%fft(1)%fft%execute(in, aux, FFT_FORWARD)
      call self%plan%execute(aux, out, DTFFT_TRANSPOSE_X_TO_Y%val, EXEC_BLOCKING, aux2)
      call self%fft(self%fft_mapping(2))%fft%execute(out, out, FFT_FORWARD)
      call self%plan%execute(out, aux, DTFFT_TRANSPOSE_Y_TO_Z%val, EXEC_BLOCKING, aux2)
      call self%fft(self%fft_mapping(3))%fft%execute(aux, out, FFT_FORWARD)
    else
      call self%fft(self%fft_mapping(3))%fft%execute(in, aux, FFT_BACKWARD)
      call self%plan%execute(aux, in, DTFFT_TRANSPOSE_Z_TO_Y%val, EXEC_BLOCKING, aux2)
      call self%fft(self%fft_mapping(2))%fft%execute(in, in, FFT_BACKWARD)
      call self%plan%execute(in, aux, DTFFT_TRANSPOSE_Y_TO_X%val, EXEC_BLOCKING, aux2)
      call self%fft(1)%fft%execute(aux, out, FFT_BACKWARD)
    endif
  end subroutine execute_generic

  subroutine execute_generic_reshape(self, in, out, execute_type, aux, aux2)
  !! Executes plan with specified auxiliary buffer
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: in
      !! Source pointer
    type(c_ptr),                intent(in)    :: out
      !! Target pointer
    type(dtfft_execute_t),      intent(in)    :: execute_type
      !! Type of execution.
    type(c_ptr),                intent(in)    :: aux
      !! Auxiliary pointer.
    type(c_ptr),                intent(in)    :: aux2
      !! Second Auxiliary pointer.

    if ( self%is_transpose_plan ) then
      if ( execute_type == DTFFT_EXECUTE_FORWARD ) then
        call self%rplan%execute(in, aux, DTFFT_RESHAPE_X_BRICKS_TO_PENCILS%val, EXEC_BLOCKING, aux2)
        call self% plan%execute(aux, in, DTFFT_TRANSPOSE_X_TO_Y%val, EXEC_BLOCKING, aux2)
        if ( self%is_final_reshape_enabled ) then
          call self% plan%execute(in, aux, DTFFT_TRANSPOSE_Y_TO_Z%val, EXEC_BLOCKING, aux2)
          call self%rplan%execute(aux, out, DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS%val, EXEC_BLOCKING, aux2)
        else
          ! Should be ok, since DTFFT_ERROR_INPLACE_TRANSPOSE is checked earlier
          call self% plan%execute(in, out, DTFFT_TRANSPOSE_Y_TO_Z%val, EXEC_BLOCKING, aux2)
        endif
      else
        if ( self%is_final_reshape_enabled ) then
          call self%rplan%execute(in, aux, DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS%val, EXEC_BLOCKING, aux2)
          call self% plan%execute(aux, out, DTFFT_TRANSPOSE_Z_TO_Y%val, EXEC_BLOCKING, aux2)
        else
          call self% plan%execute(in, out, DTFFT_TRANSPOSE_Z_TO_Y%val, EXEC_BLOCKING, aux2)
        endif
        call self% plan%execute(out, aux, DTFFT_TRANSPOSE_Y_TO_X%val, EXEC_BLOCKING, aux2)
        call self%rplan%execute(aux, out, DTFFT_RESHAPE_X_PENCILS_TO_BRICKS%val, EXEC_BLOCKING, aux2)
      endif
      return
    endif

    if ( execute_type == DTFFT_EXECUTE_FORWARD ) then
      call self%rplan%execute(in, aux, DTFFT_RESHAPE_X_BRICKS_TO_PENCILS%val, EXEC_BLOCKING, aux2)
      call self%fft(1)%fft%execute(aux, out, FFT_FORWARD)
      call self%plan%execute(out, aux, DTFFT_TRANSPOSE_X_TO_Y%val, EXEC_BLOCKING, aux2)
      call self%fft(self%fft_mapping(2))%fft%execute(aux, aux, FFT_FORWARD)
      call self%plan%execute(aux, out, DTFFT_TRANSPOSE_Y_TO_Z%val, EXEC_BLOCKING, aux2)
      if ( self%is_final_reshape_enabled ) then
        call self%fft(self%fft_mapping(3))%fft%execute(out, aux, FFT_FORWARD)
        call self%rplan%execute(aux, out, DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS%val, EXEC_BLOCKING, aux2)
      else
        call self%fft(self%fft_mapping(3))%fft%execute(out, out, FFT_FORWARD)
      endif
    else
      if ( self%is_final_reshape_enabled ) then
        call self%rplan%execute(in, aux, DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS%val, EXEC_BLOCKING, aux2)
        call self%fft(self%fft_mapping(3))%fft%execute(aux, in, FFT_BACKWARD)
      else
        call self%fft(self%fft_mapping(3))%fft%execute(in, in, FFT_BACKWARD)
      endif
      call self%plan%execute(in, aux, DTFFT_TRANSPOSE_Z_TO_Y%val, EXEC_BLOCKING, aux2)
      call self%fft(self%fft_mapping(2))%fft%execute(aux, aux, FFT_BACKWARD)
      call self%plan%execute(aux, in, DTFFT_TRANSPOSE_Y_TO_X%val, EXEC_BLOCKING, aux2)
      call self%fft(1)%fft%execute(in, aux, FFT_BACKWARD)
      call self%rplan%execute(aux, out, DTFFT_RESHAPE_X_PENCILS_TO_BRICKS%val, EXEC_BLOCKING, aux2)
    endif
  end subroutine execute_generic_reshape

  subroutine destroy(self, error_code)
  !! Destroys plan, frees all memory
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional Error Code returned to user
    integer(int32)  :: d        !! Counter
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN

    PHASE_BEGIN("dtfft_destroy", COLOR_DESTROY)

    if ( allocated(self%dims) ) deallocate(self%dims)
    if ( allocated(self%grid_dims) ) deallocate( self%grid_dims )

    select type ( self )
    class is ( dtfft_plan_r2c_t )
      call self%real_pencil%destroy()
    endselect

    if ( allocated(self%pencils) ) then
      do d = 1, self%ndims
        call self%pencils(d)%destroy()
      enddo
      deallocate(self%pencils)
    endif

    if ( self%is_reshape_enabled ) then
      call self%bricks(1)%destroy()
      call self%bricks(2)%destroy()
    endif

    if ( self%is_aux_alloc ) then
      call self%mem_free_ptr(self%aux_ptr)
      self%is_aux_alloc = .false.
    endif

    if ( allocated(self%fft) ) then
      do d = 1, self%ndims
        call self%fft(d)%fft%destroy()
        if ( allocated(self%fft(d)%fft) ) deallocate(self%fft(d)%fft)
      enddo
      deallocate(self%fft)
    endif

    self%is_created = .false.
    self%is_aux_alloc = .false.

#ifdef DTFFT_WITH_CUDA
    call destroy_stream()
#endif

    block
      logical     :: is_finalized
      ! Following calls may contain calls to MPI
      ! Must make sure that MPI is still enabled
      call MPI_Finalized(is_finalized, ierr)

      if ( is_finalized ) ierr = DTFFT_ERROR_MPI_FINALIZED
      CHECK_ERROR_AND_RETURN
    end block

    call self%plan%destroy()
    if ( self%is_reshape_enabled ) call self%rplan%destroy()
    self%is_reshape_enabled = .false.

    if ( allocated(self%comms) ) then
      do d = 1, self%ndims
        call MPI_Comm_free(self%comms(d), ierr)
      enddo
      deallocate(self%comms)
    endif
    call MPI_Comm_free(self%comm, ierr)

    self%ndims = -1
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
    PHASE_END("dtfft_destroy")
    ! call cali_flush(0)
  end subroutine destroy

  logical function get_z_slab_enabled(self, error_code)
  !! Returns logical value is Z-slab optimization enabled internally
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    get_z_slab_enabled = .false.
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN

    get_z_slab_enabled = self%is_z_slab
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_z_slab_enabled

  logical function get_y_slab_enabled(self, error_code)
  !! Returns logical value is Y-slab optimization enabled internally
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    get_y_slab_enabled = .false.
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN

    get_y_slab_enabled = self%is_y_slab
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_y_slab_enabled

  type(dtfft_pencil_t) function get_pencil(self, layout, error_code)
  !! Returns pencil decomposition
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    type(dtfft_layout_t),       intent(in)    :: layout
      !! Required layout
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code
    logical         :: is_valid

    ierr = DTFFT_SUCCESS
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    if ( .not.is_valid_layout(layout) ) ierr = DTFFT_ERROR_INVALID_LAYOUT
    CHECK_ERROR_AND_RETURN

    is_valid = .true.
    if ( .not. self%is_reshape_enabled .and. (layout == DTFFT_LAYOUT_X_BRICKS .or. layout == DTFFT_LAYOUT_Z_BRICKS) ) is_valid = .false.
    if ( self%ndims == 2 .and. layout == DTFFT_LAYOUT_Z_PENCILS ) is_valid = .false.
    if ( layout == DTFFT_LAYOUT_X_PENCILS_FOURIER ) then
      select type (self)
      class is ( dtfft_plan_r2c_t )
      class default
        is_valid = .false.
      endselect
    endif
    if ( .not. is_valid ) ierr = DTFFT_ERROR_INVALID_LAYOUT
    CHECK_ERROR_AND_RETURN

    select case ( layout%val )
    case ( CONF_DTFFT_LAYOUT_X_BRICKS )
      get_pencil = self%bricks(1)%make_public()
    case ( CONF_DTFFT_LAYOUT_X_PENCILS )
      select type ( self )
      class is ( dtfft_plan_r2c_t )
        get_pencil = self%real_pencil%make_public()
      class default
        get_pencil = self%pencils(1)%make_public()
      end select
    case ( CONF_DTFFT_LAYOUT_Y_PENCILS )
      get_pencil = self%pencils(2)%make_public()
    case ( CONF_DTFFT_LAYOUT_Z_PENCILS )
      get_pencil = self%pencils(3)%make_public()
    case ( CONF_DTFFT_LAYOUT_X_PENCILS_FOURIER )
      get_pencil = self%pencils(1)%make_public()
    case ( CONF_DTFFT_LAYOUT_Z_BRICKS )
      get_pencil = self%bricks(2)%make_public()
    endselect
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_pencil

  integer(int64) function get_element_size(self, error_code)
  !! Returns number of bytes required to store single element.
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    get_element_size = 0
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    select type (self)
    class is ( dtfft_plan_r2c_t )
      get_element_size = self%storage_size / 2
    class default
      get_element_size = self%storage_size
    endselect
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_element_size

  integer(int64) function get_alloc_bytes(self, error_code)
  !! Returns minimum number of bytes required to execute plan
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr         !! Error code
    integer(int64)  :: alloc_size   !! Number of elements required
    integer(int64)  :: element_size !! Size of each element

    ierr = DTFFT_SUCCESS
    get_alloc_bytes = 0
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN

    alloc_size = self%get_alloc_size()
    element_size = self%get_element_size()
    get_alloc_bytes = alloc_size * element_size
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_alloc_bytes

  integer(int64) function get_aux_size(self, error_code)
  !! Returns minimum number of elements required for auxiliary buffer
  !! which may be different from `alloc_size` when backend is pipelined
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr         !! Error code
    integer(int64) :: aux_bytes

    ierr = DTFFT_SUCCESS
    get_aux_size = 0
    aux_bytes = self%get_aux_bytes(ierr)
    CHECK_ERROR_AND_RETURN
    get_aux_size = aux_bytes / self%get_element_size()
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_aux_size

  integer(int64) function get_aux_bytes(self, error_code)
  !! Returns minimum number of bytes required for auxiliary buffer
  !! which may be different from `alloc_bytes` when backend is pipelined
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr         !! Error code

    ierr = DTFFT_SUCCESS
    get_aux_bytes = 0
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    if ( self%is_reshape_enabled ) then
      get_aux_bytes = self%rplan%get_aux_bytes()
    endif

    get_aux_bytes = max( get_aux_bytes, self%plan%get_aux_bytes() )
    ! Pipelined backend returns non-zero value when workspace is needed.
    ! `dtfft_plan_t` always needs aux buffer in order to support inplace execution
    get_aux_bytes = get_aux_bytes + self%get_alloc_bytes()
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_aux_bytes

  integer(int64) function get_aux_size_reshape(self, error_code)
  !! Returns minimum number of elements required for `reshape` auxiliary buffer
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr         !! Error code

    get_aux_size_reshape = self%get_aux_bytes_reshape(ierr)
    CHECK_ERROR_AND_RETURN
    get_aux_size_reshape = get_aux_size_reshape / self%get_element_size()
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_aux_size_reshape

  integer(int64) function get_aux_bytes_reshape(self, error_code)
  !! Returns minimum number of bytes required for `reshape` auxiliary buffer
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr         !! Error code

    ierr = DTFFT_SUCCESS
    get_aux_bytes_reshape = 0
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    if ( .not. self%is_reshape_enabled )                                                        &
      ierr = DTFFT_ERROR_RESHAPE_NOT_SUPPORTED
    CHECK_ERROR_AND_RETURN

    get_aux_bytes_reshape = self%rplan%get_aux_bytes()
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_aux_bytes_reshape

  integer(int64) function get_aux_size_transpose(self, error_code)
  !! Returns minimum number of elements required for `reshape` auxiliary buffer
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr         !! Error code

    get_aux_size_transpose = self%get_aux_bytes_transpose(ierr)
    CHECK_ERROR_AND_RETURN
    get_aux_size_transpose = get_aux_size_transpose / self%get_element_size()
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_aux_size_transpose

  integer(int64) function get_aux_bytes_transpose(self, error_code)
  !! Returns minimum number of bytes required for `transpose` auxiliary buffer
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr         !! Error code

    ierr = DTFFT_SUCCESS
    get_aux_bytes_transpose = 0
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN

    get_aux_bytes_transpose = self%plan%get_aux_bytes()
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_aux_bytes_transpose

  type(dtfft_executor_t) function get_executor(self, error_code)
  !! Returns FFT Executor associated with plan
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    get_executor = dtfft_executor_t(VARIABLE_NOT_SET)
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN

    get_executor = self%executor
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_executor

  subroutine get_dims(self, dims, error_code)
  !! Returns global dimensions
    class(dtfft_plan_t), target,  intent(in)  :: self
      !! Abstract plan
    integer(int32),     pointer,  intent(out) :: dims(:)
      !! Global dimensions
    integer(int32),    optional,  intent(out) :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN

    dims => self%dims
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine get_dims

  subroutine get_grid_dims(self, grid_dims, error_code)
  !! Returns grid decomposition dimensions
    class(dtfft_plan_t), target,  intent(in)  :: self
      !! Abstract plan
    integer(int32),     pointer,  intent(out) :: grid_dims(:)
      !! Grid dimensions
    integer(int32),    optional,  intent(out) :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN

    grid_dims => self%grid_dims
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine get_grid_dims

  type(dtfft_precision_t) function get_precision(self, error_code)
  !! Returns precision of the plan
    class(dtfft_plan_t),        intent(in)    :: self
      !! Abstract plan
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    get_precision = dtfft_precision_t(VARIABLE_NOT_SET)
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN

    get_precision = self%precision
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function get_precision

  subroutine report(self, error_code)
  !! Prints plan-related information to stdout
    class(dtfft_plan_t),        intent(in)  :: self
      !! Abstract plan
    integer(int32), optional,   intent(out) :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr                   !! Error code

    ierr = DTFFT_SUCCESS
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    WRITE_REPORT("**Plan report**")
    WRITE_REPORT("  dtFFT Version        :  "//to_str(DTFFT_VERSION_MAJOR)//"."//to_str(DTFFT_VERSION_MINOR)//"."//to_str(DTFFT_VERSION_PATCH))
    WRITE_REPORT("  Number of dimensions :  "//to_str(self%ndims))
    WRITE_REPORT("  Global dimensions    :  "//get_grid_str(self%dims))
    WRITE_REPORT("  Grid decomposition   :  "//get_grid_str(self%grid_dims))
    if ( self%is_reshape_enabled ) then
      block
        integer(int32), pointer :: comm_dims(:)

        call self%rplan%get_grid(1_int8, comm_dims)
    WRITE_REPORT("  Initial grid         :  "//get_grid_str(comm_dims))
        call self%rplan%get_grid(2_int8, comm_dims)
    WRITE_REPORT("  Final grid           :  "//get_grid_str(comm_dims))
        if ( self%is_final_reshape_enabled ) then
    WRITE_REPORT("  Final reshape enabled:  True")
        else
    WRITE_REPORT("  Final reshape enabled:  False")
        endif
        nullify(comm_dims)
      endblock
    endif
#ifdef DTFFT_WITH_CUDA
    if ( self%platform == DTFFT_PLATFORM_HOST ) then
    WRITE_REPORT("  Execution platform   :  HOST")
    else
    WRITE_REPORT("  Execution platform   :  CUDA")
    endif
#endif
#ifdef DTFFT_WITH_OPENMP
    if ( self%platform == DTFFT_PLATFORM_HOST ) then
    WRITE_REPORT("  Number of OMP threads:  "//to_str(omp_get_max_threads()))
    endif
#endif
    select type( self )
    class is ( dtfft_plan_c2c_t )
    WRITE_REPORT("  Plan type            :  Complex-to-Complex")
    class is ( dtfft_plan_r2r_t )
    WRITE_REPORT("  Plan type            :  Real-to-Real")
    class is ( dtfft_plan_r2c_t )
    WRITE_REPORT("  Plan type            :  Real-to-Complex")
    endselect
    WRITE_REPORT("  Plan precision       :  "//dtfft_get_precision_string(self%precision))
    WRITE_REPORT("  FFT Executor type    :  "//dtfft_get_executor_string(self%executor))
    if ( self%ndims == 3 ) then
      if ( self%is_z_slab ) then
    WRITE_REPORT("  Z-slab enabled       :  True")
      else
    WRITE_REPORT("  Z-slab enabled       :  False")
      endif
      if ( self%is_y_slab ) then
    WRITE_REPORT("  Y-slab enabled       :  True")
      else
    WRITE_REPORT("  Y-slab enabled       :  False")
      endif
    endif
    WRITE_REPORT("  Backend              :  "//dtfft_get_backend_string(self%plan%get_backend()))
    if ( self%plan%get_backend() == DTFFT_BACKEND_ADAPTIVE ) call self%plan%report_backends()
    if ( self%is_reshape_enabled ) then
    WRITE_REPORT("  Reshape Backend      :  "//dtfft_get_backend_string(self%rplan%get_backend()))
      if ( self%rplan%get_backend() == DTFFT_BACKEND_ADAPTIVE ) call self%rplan%report_backends()
    endif
    WRITE_REPORT("**End of report**")
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine report

  function get_grid_str(dims) result(grid_str)
  !! Returns grid dimensions as string
    integer(int32), intent(in)    :: dims(:)
      !! Grid dimensions
    character(len=:), allocatable :: grid_str
      !! Grid string
    if ( size(dims) == 2 ) then
      allocate(grid_str, source=to_str(dims(1))//"x"//to_str(dims(2)))
    else
      allocate(grid_str, source=to_str(dims(1))//"x"//to_str(dims(2))//"x"//to_str(dims(3)))
    endif
  end function get_grid_str

#ifdef DTFFT_WITH_COMPRESSION
  subroutine report_compression(self, error_code)
  !! Report compression ratios for all operations where compression was performed
  !! This function can be repeatedly called after plan creation and after execution
  !! to see how compression ratios evolve.
    class(dtfft_plan_t),        intent(in)  :: self
      !! Abstract plan
    integer(int32), optional,   intent(out) :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code
    logical :: transpose_compressed, reshape_compressed

    ierr = DTFFT_SUCCESS
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    transpose_compressed = is_backend_compressed(self%plan%get_backend())
    reshape_compressed = is_backend_compressed(self%rplan%get_backend())
    if ( .not.transpose_compressed  .and. .not.reshape_compressed ) ierr = DTFFT_ERROR_COMPRESSION_NOT_USED
    CHECK_ERROR_AND_RETURN

    WRITE_REPORT("**Compression report**")
    if ( self%is_reshape_enabled .and. reshape_compressed) then
      call self%rplan%report_compression()
    endif
    if ( transpose_compressed ) then
      call self%plan%report_compression()
    endif
    WRITE_REPORT("**End of report**")
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine report_compression
#endif

  type(dtfft_backend_t) function get_backend(self, error_code)
  !! Returns selected backend during autotuning
    class(dtfft_plan_t),        intent(in)  :: self
      !! Abstract plan
    integer(int32), optional,   intent(out) :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    get_backend = DTFFT_BACKEND_NONE
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN

    get_backend = self%plan%get_backend()
    if ( present( error_code ) ) error_code = ierr
  end function get_backend

  type(dtfft_backend_t) function get_reshape_backend(self, error_code)
  !! Returns selected reshape backend during autotuning
    class(dtfft_plan_t),        intent(in)  :: self
      !! Abstract plan
    integer(int32), optional,   intent(out) :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    get_reshape_backend = DTFFT_BACKEND_NONE
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    if ( .not. self%is_reshape_enabled ) ierr = DTFFT_ERROR_RESHAPE_NOT_SUPPORTED
    CHECK_ERROR_AND_RETURN

    get_reshape_backend = self%rplan%get_backend()
    if ( present( error_code ) ) error_code = ierr
  end function get_reshape_backend

#ifdef DTFFT_WITH_CUDA
  type(dtfft_platform_t) function get_platform(self, error_code)
    !! Returns execution platform of the plan (HOST or CUDA)
    class(dtfft_plan_t),        intent(in)  :: self
      !! Abstract plan
    integer(int32), optional,   intent(out) :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    get_platform = PLATFORM_NOT_SET
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN

    get_platform = self%platform
    if ( present( error_code ) ) error_code = ierr
  end function get_platform

  subroutine get_stream_ptr(self, stream, error_code)
  !! Returns CUDA stream associated with plan
    class(dtfft_plan_t),        intent(in)  :: self
      !! Abstract plan
    type(dtfft_stream_t),       intent(out) :: stream
      !! dtFFT Stream
    integer(int32), optional,   intent(out) :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    stream = NULL_STREAM
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    if ( self%platform == DTFFT_PLATFORM_HOST ) ierr = DTFFT_ERROR_INVALID_USAGE
    CHECK_ERROR_AND_RETURN

    stream = self%stream
    if ( present( error_code ) ) error_code = ierr
  end subroutine get_stream_ptr

  subroutine get_stream_int64(self, stream, error_code)
  !! Returns CUDA stream associated with plan
    class(dtfft_plan_t),        intent(in)  :: self
      !! Abstract plan
    integer(int64),             intent(out) :: stream
      !! CUDA-Fortran Stream
    integer(int32), optional,   intent(out) :: error_code
      !! Optional error code returned to user
    integer(int32)        :: ierr     !! Error code
    type(dtfft_stream_t)  :: stream_  !! dtFFT Stream

    call self%get_stream(stream_, error_code=ierr)
    if ( ierr == DTFFT_SUCCESS) stream = dtfft_get_cuda_stream(stream_)
    if ( present( error_code ) ) error_code = ierr
  end subroutine get_stream_int64

  integer(int32) function check_device_pointers(in, out, backend, aux) result(error_code)
  !! Checks if device pointers are provided by user
    type(c_ptr),            intent(in)  :: in
      !! First pointer
    type(c_ptr),            intent(in)  :: out
      !! Second pointer
    type(dtfft_backend_t),  intent(in)  :: backend
      !! Backend. Required to check for `nvshmem` pointer
    type(c_ptr),            intent(in)  :: aux
      !! Optional auxiliary pointer.
    logical(c_bool) :: is_devptr    !! Are pointers device pointers?

    error_code = DTFFT_SUCCESS

    if ( is_backend_nvshmem(backend) ) then
#ifdef DTFFT_WITH_NVSHMEM
      is_devptr = is_nvshmem_ptr(in) .and. is_nvshmem_ptr(out)
      if ( .not. is_null_ptr(aux) ) is_devptr = is_devptr .and. is_nvshmem_ptr(aux)
      if ( .not. is_devptr ) error_code = DTFFT_ERROR_NOT_NVSHMEM_PTR
#endif
    else
      is_devptr = is_device_ptr(in) .and. is_device_ptr(out)
      if ( .not. is_null_ptr(aux) ) is_devptr = is_devptr .and. is_device_ptr(aux)
      if ( .not. is_devptr ) error_code = DTFFT_ERROR_NOT_DEVICE_PTR
    endif
  end function check_device_pointers
#endif

  subroutine get_local_sizes(self, in_starts, in_counts, out_starts, out_counts, alloc_size, error_code)
  !! Obtain local starts and counts in ``real`` and ``fourier`` spaces
    class(dtfft_plan_t),        intent(in)  :: self
      !! Abstract plan
    integer(int32), optional,   intent(out) :: in_starts(:)
      !! Starts of local portion of data in ``real`` space (0-based)
    integer(int32), optional,   intent(out) :: in_counts(:)
      !! Number of elements of local portion of data in 'real' space
    integer(int32), optional,   intent(out) :: out_starts(:)
      !! Starts of local portion of data in ``fourier`` space (0-based)
    integer(int32), optional,   intent(out) :: out_counts(:)
      !! Number of elements of local portion of data in ``fourier`` space
    integer(int64), optional,   intent(out) :: alloc_size
      !! Minimal number of elements required to execute plan
    integer(int32), optional,   intent(out) :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr                 !! Error code
    integer(int64) :: alloc_size_, alloc_size2, alloc_size3

    ierr = DTFFT_SUCCESS
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    if ( .not. present(in_starts)       &
    .and..not. present(in_counts)       &
    .and..not. present(out_starts)      &
    .and..not. present(out_counts)      &
    .and..not. present(alloc_size)) ierr = DTFFT_ERROR_INVALID_USAGE
    CHECK_ERROR_AND_RETURN

    alloc_size_ = 0
    alloc_size2 = 0
    if ( self%is_reshape_enabled ) then
      call get_local_sizes_private([self%bricks(1)], in_starts, in_counts, alloc_size=alloc_size_)
      call get_local_sizes_private([self%bricks(2)], alloc_size=alloc_size3)
      select type ( self )
      class is (dtfft_plan_r2c_t)
        alloc_size3 = alloc_size3 * 2
      endselect
      alloc_size_ = max(alloc_size_, alloc_size3)
      if ( self%is_final_reshape_enabled ) then
        call get_local_sizes_private([self%bricks(2)], out_starts=out_starts, out_counts=out_counts, alloc_size=alloc_size2)
        select type ( self )
        class is (dtfft_plan_r2c_t)
          alloc_size2 = alloc_size2 * 2
        endselect
      else
        call self%get_local_sizes_internal(out_starts=out_starts, out_counts=out_counts, alloc_size=alloc_size2)
      endif
      call self%get_local_sizes_internal(alloc_size=alloc_size)
    else
      call self%get_local_sizes_internal(in_starts, in_counts, out_starts, out_counts, alloc_size)
    endif
    if ( present( alloc_size ) ) alloc_size = max( max(alloc_size_, alloc_size2), alloc_size )
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine get_local_sizes

  subroutine get_local_sizes_internal(self, in_starts, in_counts, out_starts, out_counts, alloc_size)
  !! Obtain local starts and counts in ``real`` and ``fourier`` spaces
    class(dtfft_plan_t),        intent(in)  :: self
      !! Abstract plan
    integer(int32), optional,   intent(out) :: in_starts(:)
      !! Starts of local portion of data in ``real`` space (0-based)
    integer(int32), optional,   intent(out) :: in_counts(:)
      !! Number of elements of local portion of data in 'real' space
    integer(int32), optional,   intent(out) :: out_starts(:)
      !! Starts of local portion of data in ``fourier`` space (0-based)
    integer(int32), optional,   intent(out) :: out_counts(:)
      !! Number of elements of local portion of data in ``fourier`` space
    integer(int64), optional,   intent(out) :: alloc_size
      !! Minimal number of elements required to execute plan

    select type ( self )
    class is (dtfft_plan_r2c_t)
      if (present( in_starts ) )    in_starts(1:self%ndims)   = self%real_pencil%starts(1:self%ndims)
      if (present( in_counts ) )    in_counts(1:self%ndims)   = self%real_pencil%counts(1:self%ndims)
      call get_local_sizes_private(self%pencils, out_starts=out_starts, out_counts=out_counts, alloc_size=alloc_size, is_y_slab=self%is_y_slab)
      if ( present( alloc_size ) )  alloc_size = max(int(product(self%real_pencil%counts), int64), 2 * alloc_size)
    class default
      call get_local_sizes_private(self%pencils, in_starts, in_counts, out_starts, out_counts, alloc_size, is_y_slab=self%is_y_slab)
    endselect
  end subroutine get_local_sizes_internal

  function get_alloc_size(self, error_code) result(alloc_size)
  !! Wrapper around ``get_local_sizes`` to obtain number of elements only
    class(dtfft_plan_t),        intent(in)  :: self
      !! Abstract plan
    integer(int32), optional,   intent(out) :: error_code
      !! Optional error code returned to user
    integer(int64)                          :: alloc_size
      !! Minimal number of elements required to execute plan

    call self%get_local_sizes(alloc_size=alloc_size, error_code=error_code)
  end function get_alloc_size

  integer(int32) function create_private(self, sngl_type, sngl_storage_size, dbl_type, dbl_storage_size, dims, pencil, &
    comm, precision, effort, executor, kinds, sngl_type_init, sngl_storage_size_init, dbl_type_init, dbl_storage_size_init)
#define __FUNC__ create_private
  !! Creates core
    class(dtfft_plan_t),              intent(inout) :: self
      !! Abstract plan
    TYPE_MPI_DATATYPE,                intent(in)    :: sngl_type
      !! MPI_Datatype for single precision plan
    integer(int64),                   intent(in)    :: sngl_storage_size
      !! Number of bytes needed to store single element (single precision)
    TYPE_MPI_DATATYPE,                intent(in)    :: dbl_type
      !! MPI_Datatype for double precision plan
    integer(int64),                   intent(in)    :: dbl_storage_size
      !! Number of bytes needed to store single element (double precision)
    integer(int32),         optional, intent(in)    :: dims(:)
      !! Global dimensions of transform
    type(dtfft_pencil_t),   optional, intent(in)    :: pencil
      !! Pencil of local portion of data
    TYPE_MPI_COMM,          optional, intent(in)    :: comm
      !! User-defined communicator
    type(dtfft_precision_t),optional, intent(in)    :: precision
      !! Precision of transform: `DTFFT_SINGLE` or `DTFFT_DOUBLE`
    type(dtfft_effort_t),   optional, intent(in)    :: effort
      !! Effort level for the plan creation
    type(dtfft_executor_t), optional, intent(in)    :: executor
      !! Type of External FFT Executor
    type(dtfft_r2r_kind_t), optional, intent(in)    :: kinds(:)
      !! Kinds of R2R transform
    TYPE_MPI_DATATYPE,      optional, intent(in)    :: sngl_type_init
      !! MPI_Datatype for single precision plan (should be passed only for R2C plans)
    integer(int64),         optional, intent(in)    :: sngl_storage_size_init
      !! Number of bytes needed to store single element (single precision) (should be passed only for R2C plans)
    TYPE_MPI_DATATYPE,      optional, intent(in)    :: dbl_type_init
      !! MPI_Datatype for double precision plan (should be passed only for R2C plans)
    integer(int64),         optional, intent(in)    :: dbl_storage_size_init
      !! Number of bytes needed to store single element (double precision) (should be passed only for R2C plans)
    TYPE_MPI_DATATYPE       :: base_dtype           !! MPI_Datatype for current precision
    integer(int64)          :: base_storage         !! Number of bytes needed to store single element
    TYPE_MPI_COMM           :: comm_                !! MPI Communicator
    integer(int8)           :: d                    !! Counter
    integer(int32)          :: ierr
    TYPE_MPI_DATATYPE       :: base_dtype_init      !! MPI_Datatype for R2C initial precision
    integer(int64)          :: base_storage_init    !! Number of bytes needed to store single element for R2C initial precision

    create_private = DTFFT_SUCCESS
    CHECK_INTERNAL_CALL( self%check_create_args(dims, pencil, comm, precision, effort, executor, kinds) )

    select case ( self%precision%val )
    case ( DTFFT_SINGLE%val )
      base_storage = sngl_storage_size
      base_dtype = sngl_type
    case ( DTFFT_DOUBLE%val )
      base_storage = dbl_storage_size
      base_dtype = dbl_type
    case default
      INTERNAL_ERROR("unknown precision")
    endselect
    self%storage_size = base_storage

    if ( present(sngl_type_init) ) then
      select case ( self%precision%val )
      case ( DTFFT_SINGLE%val )
        base_storage_init = sngl_storage_size_init
        base_dtype_init = sngl_type_init
      case ( DTFFT_DOUBLE%val )
        base_storage_init = dbl_storage_size_init
        base_dtype_init = dbl_type_init
      endselect
    else
      base_storage_init = base_storage
      base_dtype_init = base_dtype
    endif

    if ( allocated(self%pencils) ) then
      do d = 1, size(self%pencils, kind=int8)
        call self%pencils(d)%destroy()
      enddo
      deallocate( self%pencils )
    endif

    if ( allocated(self%comms) ) then
      ! Can potentially leak some memory
      deallocate( self%comms )
    endif

    call self%plan%destroy()

    allocate(self%pencils(self%ndims))
    allocate(self%comms(self%ndims))

    comm_ = MPI_COMM_WORLD; if ( present( comm ) ) comm_ = comm
#ifdef DTFFT_WITH_CUDA
    if ( self%platform == DTFFT_PLATFORM_CUDA  ) then
      block
        TYPE_MPI_COMM   :: local_comm
        integer(int32)  :: n_devices, current_device, local_rank, local_size
        integer(int32), allocatable :: local_devices(:)

        call MPI_Comm_split_type(comm_, MPI_COMM_TYPE_SHARED, 0, MPI_INFO_NULL, local_comm, ierr)
        call MPI_Comm_size(local_comm, local_size, ierr)
        call MPI_Comm_rank(local_comm, local_rank, ierr)

        allocate( local_devices(local_size) )

        CUDA_CALL( cudaGetDeviceCount(n_devices) )
        CUDA_CALL( cudaGetDevice(current_device) )

        call MPI_Allgather(current_device, 1, MPI_INTEGER4, local_devices, 1, MPI_INTEGER4, local_comm, ierr)
        call MPI_Comm_free(local_comm, ierr)
        if ( count_unique(local_devices) /= local_size ) then
          create_private = DTFFT_ERROR_GPU_NOT_SET
          return
        endif

        deallocate( local_devices )

        self%stream = get_conf_stream()
      endblock
    endif
#endif

    self%is_reshape_enabled = .false.
    self%is_final_reshape_enabled = .false.
    if ( present(pencil) ) then
      block
        integer(int32), allocatable :: fixed_dims(:)
        type(pencil_init) :: ipencil, opencil
        integer(int32) :: fsize
        type(pencil_) :: temp_pencil

        CHECK_INTERNAL_CALL( ipencil%create(pencil, comm_) )
        ! After creating internal pencil and validating user passed pencil
        ! We finally know global dimensions `dims`
        allocate( self%dims, source=ipencil%dims )
        allocate( fixed_dims, source=self%dims )

        select type( self )
        class is ( dtfft_plan_r2c_t )
          fixed_dims(1) = fixed_dims(1) / 2 + 1
        endselect

        call MPI_Comm_size(ipencil%comms(1), fsize, ierr)
        if ( fsize > 1 ) then
          self%is_reshape_enabled = .true.

          CHECK_INTERNAL_CALL( opencil%from_bricks(self%platform, ipencil, comm_) )

          select type( self )
          class is ( dtfft_plan_r2c_t )
            opencil%counts(1) = fixed_dims(1)
          endselect

          CHECK_INTERNAL_CALL( self%plan%create(self%platform, fixed_dims, comm_, self%effort, base_dtype, base_storage, self%comm, self%comms, self%pencils, opencil) )

          select type( self )
          class is ( dtfft_plan_r2c_t )
            opencil%counts(1) = self%dims(1)
            call self%real_pencil%create(self%ndims, 1_int8, self%dims, self%comms, opencil%starts, opencil%counts)
            temp_pencil = self%pencils(1)
            self%pencils(1) = self%real_pencil
          endselect

          CHECK_INTERNAL_CALL( self%rplan%create(self%platform, ipencil, self%pencils, comm_, self%comms, base_dtype, base_storage, self%effort, self%plan%get_backend(), base_dtype_init, base_storage_init, self%bricks, self%is_final_reshape_enabled) )

          select type( self )
          class is ( dtfft_plan_r2c_t )
            self%pencils(1) = temp_pencil
          endselect

          ! print*,'brick1 = ',self%bricks(1)%starts,self%bricks(1)%counts
          ! select type( self )
          ! class is ( dtfft_plan_r2c_t )
          !   print*,'real pencil = ',self%real_pencil%starts,self%real_pencil%counts
          ! endselect
          ! print*,'pencils1 = ',self%pencils(1)%starts,self%pencils(1)%counts
          ! print*,'pencils2 = ',self%pencils(2)%starts,self%pencils(2)%counts
          ! if ( self%ndims == 3 ) print*,'pencils3 = ',self%pencils(3)%starts,self%pencils(3)%counts
          ! print*,'brick2 = ',self%bricks(2)%starts,self%bricks(2)%counts

          call opencil%destroy()
        else
          select type( self )
          class is ( dtfft_plan_r2c_t )
            ipencil%counts(1) = fixed_dims(1)
          endselect

          CHECK_INTERNAL_CALL( self%plan%create(self%platform, fixed_dims, comm_, self%effort, base_dtype, base_storage, self%comm, self%comms, self%pencils, ipencil) )

          select type( self )
          class is ( dtfft_plan_r2c_t )
            ipencil%counts(1) = self%dims(1)
            call self%real_pencil%create(self%ndims, 1_int8, self%dims, self%comms, ipencil%starts, ipencil%counts)
          endselect
        endif
        deallocate( fixed_dims )
        call ipencil%destroy()
      endblock
    else
      CHECK_INTERNAL_CALL( self%plan%create(self%platform, dims, comm_, self%effort, base_dtype, base_storage, self%comm, self%comms, self%pencils) )
    endif

    self%is_z_slab = self%plan%get_z_slab()
    self%is_y_slab = self%plan%get_y_slab()
    if ( self%is_final_reshape_enabled .and. self%is_z_slab ) self%is_final_reshape_enabled = .false.

    if ( allocated( self%grid_dims ) ) deallocate( self%grid_dims )
    allocate( self%grid_dims(self%ndims) )
    do d = 1, self%ndims
      call MPI_Comm_size(self%comms(d), self%grid_dims(d), ierr)
    enddo
    call self%alloc_fft_plans(kinds)

    self%is_aux_alloc = .false.
#undef __FUNC__
  end function create_private

  integer(int32) function check_create_args(self, dims, pencil, comm, precision, effort, executor, kinds)
#define __FUNC__ check_create_args
  !! Check arguments provided by user and sets private variables
    class(dtfft_plan_t),                intent(inout) :: self
      !! Abstract plan
    integer(int32),         optional,   intent(in)    :: dims(:)
      !! Global dimensions of transform
    type(dtfft_pencil_t),   optional,   intent(in)    :: pencil
      !! Pencil of local portion of data
    TYPE_MPI_COMM,          optional,   intent(in)    :: comm
      !! Optional MPI Communicator
    type(dtfft_precision_t),optional,   intent(in)    :: precision
      !! Precision of transform: `DTFFT_SINGLE` or `DTFFT_DOUBLE`
    type(dtfft_effort_t),   optional,   intent(in)    :: effort
      !! Effort level for the plan creation
    type(dtfft_executor_t), optional,   intent(in)    :: executor
      !! Type of External FFT Executor
    type(dtfft_r2r_kind_t), optional,   intent(in)    :: kinds(:)
      !! Kinds of R2R transform
    integer(int32)          :: ierr             !! Error code
    integer(int32)          :: top_type         !! MPI Comm topology type
    integer(int32)          :: dim              !! Counter

    check_create_args = DTFFT_SUCCESS
    CHECK_INTERNAL_CALL( init_internal() )

    self%platform = get_conf_platform()
#ifdef DTFFT_DEBUG
    if ( .not.present(dims) .and. .not.present(pencil) ) then
      INTERNAL_ERROR(".not.present(dims) .and. .not.present(pencil)")
    endif
    if ( present(dims) .and. present(pencil) ) then
      INTERNAL_ERROR("present(dims) .and. present(pencil)")
    endif
#endif
    if ( allocated(self%dims) ) deallocate(self%dims)
    if ( present(dims) ) then
      self%ndims = size(dims, kind=int8)
      CHECK_INPUT_PARAMETER(self%ndims, is_valid_dimension, DTFFT_ERROR_INVALID_N_DIMENSIONS)
      if ( any(dims <= 0) ) then
        check_create_args = DTFFT_ERROR_INVALID_DIMENSION_SIZE
        return
      endif
      allocate( self%dims, source=dims )
    else
      self%ndims = pencil%ndims
      if ( self%ndims == 0 ) then
        check_create_args = DTFFT_ERROR_PENCIL_NOT_INITIALIZED
        return
      endif
    endif

    if ( present(comm) ) then
      call MPI_Topo_test(comm, top_type, ierr)
      CHECK_INPUT_PARAMETER(top_type, is_valid_comm_type, DTFFT_ERROR_INVALID_COMM_TYPE)
    endif

    self%precision = DTFFT_DOUBLE
    if ( present(precision) ) then
      CHECK_INPUT_PARAMETER(precision, is_valid_precision, DTFFT_ERROR_INVALID_PRECISION)
      self%precision = precision
    endif

    self%effort = DTFFT_ESTIMATE
    if ( present(effort) ) then
      CHECK_INPUT_PARAMETER(effort, is_valid_effort, DTFFT_ERROR_INVALID_EFFORT)
      self%effort = effort
    endif

    self%is_transpose_plan = .false.
    self%executor = DTFFT_EXECUTOR_NONE
    if ( present(executor) ) then
      CHECK_INPUT_PARAMETER(executor, is_valid_executor, DTFFT_ERROR_INVALID_EXECUTOR)
#ifdef DTFFT_WITH_CUDA
      if ( self%platform == DTFFT_PLATFORM_HOST ) then
        CHECK_INPUT_PARAMETER(executor, is_host_executor, DTFFT_ERROR_INVALID_PLATFORM_EXECUTOR)
      else if ( self%platform == DTFFT_PLATFORM_CUDA  ) then
# ifdef DTFFT_WITH_MOCK_ENABLED
        CHECK_INPUT_PARAMETER(executor, is_host_executor, DTFFT_ERROR_INVALID_PLATFORM_EXECUTOR)
# else
        CHECK_INPUT_PARAMETER(executor, is_cuda_executor, DTFFT_ERROR_INVALID_PLATFORM_EXECUTOR)
# endif
      endif
#endif
      self%executor = executor
    endif
    if ( self%executor == DTFFT_EXECUTOR_NONE ) self%is_transpose_plan = .true.

#ifdef DTFFT_WITH_CUDA
    ! Platform is used to check correctness of both executor and backend
    ! DTFFT_PATIENT ignores backend set by user:
    if ( self%effort%val < DTFFT_PATIENT%val ) then
      block
        type(dtfft_backend_t) :: backend

        backend = get_conf_backend()
        if ( self%platform == DTFFT_PLATFORM_HOST ) then
          if ( is_backend_nccl(backend) .or. is_backend_nvshmem(backend) ) then
            __FUNC__ = DTFFT_ERROR_INVALID_PLATFORM_BACKEND
            return
          endif
        endif
      endblock
    endif
#endif

    if ( present(kinds) .and. .not. self%is_transpose_plan ) then
      do dim = 1, self%ndims
        CHECK_INPUT_PARAMETER(kinds(dim), is_valid_r2r_kind, DTFFT_ERROR_INVALID_R2R_KINDS)
      enddo
    endif
#undef __FUNC__
  end function check_create_args

  subroutine alloc_fft_plans(self, kinds)
  !! Allocates [[abstract_executor]] with required FFT class
  !! and populates [[dtfft_plan_t(type):fft_mapping]] with similar FFT ids
    class(dtfft_plan_t),              intent(inout) :: self
      !! Abstract plan
    type(dtfft_r2r_kind_t), optional, intent(in)    :: kinds(:)
      !! Kinds of R2R transform
    integer(int8)                                   :: dim, dim2
      !! Counters
    type(dtfft_r2r_kind_t),           allocatable   :: kinds_(:)
      !! Dummy kinds

    if ( self%is_transpose_plan ) return

    allocate(self%fft(self%ndims))
    allocate(self%fft_mapping(self%ndims))

    do dim = 1, self%ndims
      self%fft_mapping(dim) = dim

      select case(self%executor%val)
#ifdef DTFFT_WITH_FFTW
      case (DTFFT_EXECUTOR_FFTW3%val)
        allocate(fftw_executor :: self%fft(dim)%fft)
#endif
#ifdef DTFFT_WITH_MKL
      case (DTFFT_EXECUTOR_MKL%val)
        allocate(mkl_executor :: self%fft(dim)%fft)
#endif
#ifdef DTFFT_WITH_CUFFT
      case (DTFFT_EXECUTOR_CUFFT%val)
        allocate(cufft_executor :: self%fft(dim)%fft)
#endif
#ifdef DTFFT_WITH_VKFFT
      case (DTFFT_EXECUTOR_VKFFT%val)
        allocate(vkfft_executor :: self%fft(dim)%fft)
#endif
      case default
        INTERNAL_ERROR("Executor type unrecognized")
      endselect
    enddo
    if( self%is_z_slab .or. self%is_y_slab ) return

    allocate(kinds_(self%ndims))
    kinds_(:) = dtfft_r2r_kind_t(-1); if ( present(kinds) ) kinds_(:) = kinds(:)
    ! Searching for similar FFT transforms in order to reduce time of plan creation
    ! and reduce memory usage
    ! Most profitable in GPU build
    do dim = 1_int8, self%ndims
      do dim2 = 1_int8, dim - 1_int8
        if ( dim == dim2 ) cycle
        select type ( self )
        class is ( dtfft_plan_r2c_t )
          if ( dim == 1 ) cycle
        endselect
        if ( self%pencils(dim)%counts(1) == self%pencils(dim2)%counts(1)                    &
             .and. product(self%pencils(dim)%counts) == product(self%pencils(dim2)%counts)  &
             .and. kinds_(dim) == kinds_(dim2) ) then
          self%fft_mapping(dim) = dim2
        endif
      enddo
    enddo
    deallocate(kinds_)
  end subroutine alloc_fft_plans

  subroutine check_aux(self, aux, called_by, aux_ptr, aux2_ptr)
  !! Checks if aux buffer was passed by user and if not will allocate one internally
    class(dtfft_plan_t),            intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                    intent(in)    :: aux
      !! Optional auxiliary buffer.
    integer(int32),                 intent(in)    :: called_by
      !! Indicates which function called `check_aux` for correct allocation
    type(c_ptr),                    intent(out)   :: aux_ptr
      !! Auxiliary buffer pointer
    type(c_ptr),                    intent(out)   :: aux2_ptr
      !! Second Auxiliary buffer pointer (used transpose/reshape operations)
    integer(int64)                                :: alloc_size, shift_size
      !! Number of elements to be allocated
    integer(int32) :: ierr
    logical :: is_reshape_aux_required

    shift_size = self%get_alloc_bytes()
    is_reshape_aux_required = self%plan%is_aux_needed() .or. self%rplan%is_aux_needed()
    aux2_ptr = c_null_ptr
    if ( self%is_aux_alloc .or. .not.is_null_ptr(aux) ) then
      if ( self%is_aux_alloc ) then
        aux_ptr = self%aux_ptr
      else
        aux_ptr = aux
      endif
      if ( called_by == CHECK_AUX_CALLED_BY_EXECUTE .and. is_reshape_aux_required) then
        aux2_ptr = ptr_offset(aux_ptr, shift_size)
      endif
      return
    endif

    ! if ( called_by == CHECK_AUX_CALLED_BY_RESHAPE .and. .not. is_reshape_aux_required) then
    !   aux_ptr = c_null_ptr
    !   return
    ! endif

    alloc_size = self%get_aux_bytes()
    WRITE_DEBUG("Allocating auxiliary buffer of "//to_str(alloc_size)//" bytes")
    self%aux_ptr = self%mem_alloc_ptr(alloc_size, ierr);  DTFFT_CHECK(ierr)
    aux_ptr = self%aux_ptr
    if ( called_by == CHECK_AUX_CALLED_BY_EXECUTE .and. is_reshape_aux_required) then
      aux2_ptr = ptr_offset(self%aux_ptr, shift_size)
    endif
    self%is_aux_alloc = .true.
  end subroutine check_aux

  subroutine create_r2r(self, dims, kinds, comm, precision, effort, executor, error_code)
  !! R2R Plan Constructor
    class(dtfft_plan_r2r_t),          intent(inout) :: self
      !! R2R Plan
    integer(int32),                   intent(in)    :: dims(:)
      !! Global dimensions of transform
    type(dtfft_r2r_kind_t), optional, intent(in)    :: kinds(:)
      !! Kinds of R2R transform
    TYPE_MPI_COMM,          optional, intent(in)    :: comm
      !! Communicator
    type(dtfft_precision_t),optional, intent(in)    :: precision
      !! Presicion of Transform
    type(dtfft_effort_t),   optional, intent(in)    :: effort
      !! Effort level for the plan creation
    type(dtfft_executor_t), optional, intent(in)    :: executor
      !! Type of External FFT Executor
    integer(int32),         optional, intent(out)   :: error_code
      !! Optional Error Code returned to user
    integer(int32)          :: ierr               !! Error code

    CHECK_OPTIONAL_CALL( self%create_r2r_internal(dims=dims, kinds=kinds, comm=comm,precision=precision, effort=effort, executor=executor) )
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine create_r2r

  subroutine create_r2r_pencil(self, pencil, kinds, comm, precision, effort, executor, error_code)
  !! R2R Plan Constructor
    class(dtfft_plan_r2r_t),          intent(inout) :: self
      !! R2R Plan
    type(dtfft_pencil_t),             intent(in)    :: pencil
      !! Local pencil of data to be transformed
    type(dtfft_r2r_kind_t), optional, intent(in)    :: kinds(:)
      !! Kinds of R2R transform
    TYPE_MPI_COMM,          optional, intent(in)    :: comm
      !! Communicator
    type(dtfft_precision_t),optional, intent(in)    :: precision
      !! Presicion of Transform
    type(dtfft_effort_t),   optional, intent(in)    :: effort
      !! Effort level for the plan creation
    type(dtfft_executor_t), optional, intent(in)    :: executor
      !! Type of External FFT Executor
    integer(int32),         optional, intent(out)   :: error_code
      !! Optional Error Code returned to user
    integer(int32)          :: ierr               !! Error code

    CHECK_OPTIONAL_CALL( self%create_r2r_internal(pencil=pencil, kinds=kinds, comm=comm, precision=precision, effort=effort, executor=executor) )
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine create_r2r_pencil

  integer(int32) function create_r2r_internal(self, dims, pencil, kinds, comm, precision, effort, executor)
  !! Creates plan for R2R plans
#define __FUNC__ create_r2r_internal
    class(dtfft_plan_r2r_t),          intent(inout) :: self
      !! R2R Plan
    integer(int32),         optional, intent(in)    :: dims(:)
      !! Global dimensions of transform
    type(dtfft_pencil_t),   optional, intent(in)    :: pencil
      !! Pencil of data to be transformed
    type(dtfft_r2r_kind_t), optional, intent(in)    :: kinds(:)
      !! Kinds of R2R transform
    TYPE_MPI_COMM,          optional, intent(in)    :: comm
      !! Communicator
    type(dtfft_precision_t),optional, intent(in)    :: precision
      !! Presicion of Transform
    type(dtfft_effort_t),   optional, intent(in)    :: effort
      !! Effort level for the plan creation
    type(dtfft_executor_t), optional, intent(in)    :: executor
      !! Type of External FFT Executor
    integer(int8)           :: fft_rank           !! Rank of FFT transform
    integer(int32)          :: dim                !! Counter
    type(dtfft_r2r_kind_t)  :: r2r_kinds(2)       !! Transposed Kinds of R2R transform

    create_r2r_internal = DTFFT_SUCCESS
    if ( self%is_created ) then
      create_r2r_internal = DTFFT_ERROR_PLAN_IS_CREATED
      return
    endif

    PHASE_BEGIN("dtfft_create_r2r", COLOR_CREATE)
    CHECK_INTERNAL_CALL( self%create_private(MPI_REAL, FLOAT_STORAGE_SIZE, MPI_REAL8, DOUBLE_STORAGE_SIZE, dims=dims, pencil=pencil, comm=comm, precision=precision, effort=effort, executor=executor, kinds=kinds) )

    if ( .not. self%is_transpose_plan ) then
      if ( .not. present( kinds ) ) then
        create_r2r_internal = DTFFT_ERROR_MISSING_R2R_KINDS
        return
      endif

      do dim = 1, self%ndims
        r2r_kinds(1) = kinds(dim)
        fft_rank = FFT_1D
        if ( self%is_z_slab .and. dim == 1 ) then
          r2r_kinds(1) = kinds(2)
          r2r_kinds(2) = kinds(1)
          fft_rank = FFT_2D
        else if ( self%is_y_slab .and. dim == 2 ) then
          r2r_kinds(1) = kinds(3)
          r2r_kinds(2) = kinds(2)
          fft_rank = FFT_2D
        endif
        if ( self%is_z_slab .and. dim == 2 ) cycle
        if ( self%is_y_slab .and. dim == 3 ) cycle
        CHECK_INTERNAL_CALL( self%fft(self%fft_mapping(dim))%fft%create(fft_rank, FFT_R2R, self%precision, real_pencil=self%pencils(dim), r2r_kinds=r2r_kinds) )
      enddo
    endif
    self%is_created = .true.
    PHASE_END("dtfft_create_r2r")
#undef __FUNC__
  end function create_r2r_internal

  subroutine create_c2c(self, dims, comm, precision, effort, executor, error_code)
  !! C2C Plan Constructor
    class(dtfft_plan_c2c_t),          intent(inout) :: self
      !! C2C Plan
    integer(int32),                   intent(in)    :: dims(:)
      !! Global dimensions of transform
    TYPE_MPI_COMM,          optional, intent(in)    :: comm
      !! Communicator
    type(dtfft_precision_t),optional, intent(in)    :: precision
      !! Presicion of Transform
    type(dtfft_effort_t),   optional, intent(in)    :: effort
      !! Effort level for the plan creation
    type(dtfft_executor_t), optional, intent(in)    :: executor
      !! Type of External FFT Executor
    integer(int32),         optional, intent(out)   :: error_code
      !! Optional Error Code returned to user
    integer(int32)                    :: ierr               !! Error code

    CHECK_OPTIONAL_CALL( self%create_c2c_internal(dims=dims, comm=comm, precision=precision, effort=effort, executor=executor) )
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine create_c2c

  subroutine create_c2c_pencil(self, pencil, comm, precision, effort, executor, error_code)
  !! C2C Plan Constructor
    class(dtfft_plan_c2c_t),          intent(inout) :: self
      !! C2C Plan
    type(dtfft_pencil_t),             intent(in)    :: pencil
      !! Local pencil of data to be transformed
    TYPE_MPI_COMM,          optional, intent(in)    :: comm
      !! Communicator
    type(dtfft_precision_t),optional, intent(in)    :: precision
      !! Presicion of Transform
    type(dtfft_effort_t),   optional, intent(in)    :: effort
      !! Effort level for the plan creation
    type(dtfft_executor_t), optional, intent(in)    :: executor
      !! Type of External FFT Executor
    integer(int32),         optional, intent(out)   :: error_code
      !! Optional Error Code returned to user
    integer(int32)                    :: ierr               !! Error code

    CHECK_OPTIONAL_CALL( self%create_c2c_internal(pencil=pencil, comm=comm, precision=precision, effort=effort, executor=executor) )
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine create_c2c_pencil

  integer(int32) function create_c2c_internal(self, dims, pencil, comm, precision, effort, executor)
  !! Private method that combines common logic for C2C plan creation
#define __FUNC__ create_c2c_internal
    class(dtfft_plan_c2c_t),          intent(inout) :: self
      !! C2C Plan
    integer(int32),         optional, intent(in)    :: dims(:)
      !! Global dimensions of transform
    type(dtfft_pencil_t),   optional, intent(in)    :: pencil
      !! Pencil of data to be transformed
    TYPE_MPI_COMM,          optional, intent(in)    :: comm
      !! Communicator
    type(dtfft_precision_t),optional, intent(in)    :: precision
      !! Presicion of Transform
    type(dtfft_effort_t),   optional, intent(in)    :: effort
      !! Effort level for the plan creation
    type(dtfft_executor_t), optional, intent(in)    :: executor
      !! Type of External FFT Executor

    create_c2c_internal = DTFFT_SUCCESS
    if ( self%is_created ) then
      create_c2c_internal = DTFFT_ERROR_PLAN_IS_CREATED
      return
    endif

    PHASE_BEGIN("dtfft_create_c2c", COLOR_CREATE)
    CHECK_INTERNAL_CALL( self%create_c2c_core(dims, pencil, comm, precision, effort, executor) )
    self%is_created = .true.
    PHASE_END("dtfft_create_c2c")
#undef __FUNC__
  end function create_c2c_internal

  integer(int32) function create_c2c_core(self, dims, pencil, comm, precision, effort, executor, sngl_type_init, sngl_storage_size_init, dbl_type_init, dbl_storage_size_init)
  !! Creates plan for both C2C and R2C
#define __FUNC__ create_c2c_core
    class(dtfft_core_c2c),            intent(inout) :: self
      !! C2C Plan
    integer(int32),         optional, intent(in)    :: dims(:)
      !! Global dimensions of transform
    type(dtfft_pencil_t),   optional, intent(in)    :: pencil
      !! Pencil of data to be transformed
    TYPE_MPI_COMM,          optional, intent(in)    :: comm
      !! Communicator
    type(dtfft_precision_t),optional, intent(in)    :: precision
      !! Presicion of Transform
    type(dtfft_effort_t),   optional, intent(in)    :: effort
      !! Effort level for the plan creation
    type(dtfft_executor_t), optional, intent(in)    :: executor
      !! Type of External FFT Executor
    TYPE_MPI_DATATYPE,      optional, intent(in)    :: sngl_type_init
      !! MPI_Datatype for single precision plan (should be passed only for R2C plans)
    integer(int64),         optional, intent(in)    :: sngl_storage_size_init
      !! Number of bytes needed to store single element (single precision) (should be passed only for R2C plans)
    TYPE_MPI_DATATYPE,      optional, intent(in)    :: dbl_type_init
      !! MPI_Datatype for double precision plan (should be passed only for R2C plans)
    integer(int64),         optional, intent(in)    :: dbl_storage_size_init
      !! Number of bytes needed to store single element (double precision) (should be passed only for R2C plans)
    integer(int8)           :: dim                  !! Counter
    integer(int8)           :: fft_start            !! 1 for c2c, 2 for r2c
    integer(int8)           :: fft_rank             !! Rank of FFT transform

    CHECK_INTERNAL_CALL( self%create_private(MPI_COMPLEX, COMPLEX_STORAGE_SIZE, MPI_DOUBLE_COMPLEX, DOUBLE_COMPLEX_STORAGE_SIZE, dims=dims, pencil=pencil, comm=comm, precision=precision, effort=effort, executor=executor, sngl_type_init=sngl_type_init, sngl_storage_size_init=sngl_storage_size_init, dbl_type_init=dbl_type_init, dbl_storage_size_init=dbl_storage_size_init) )

    if ( self%is_transpose_plan ) return
    fft_start = 1
    select type ( self )
    class is (dtfft_plan_r2c_t)
      fft_start = 2
    endselect
    do dim = fft_start, self%ndims
      fft_rank = FFT_1D
      if ( (self%is_z_slab .and. dim == 1) .or. (self%is_y_slab .and. dim == 2) ) fft_rank = FFT_2D
      if ( (self%is_z_slab .and. dim == 2) .or. (self%is_y_slab .and. dim == 3) ) cycle
      CHECK_INTERNAL_CALL( self%fft(self%fft_mapping(dim))%fft%create(fft_rank, FFT_C2C, self%precision, complex_pencil=self%pencils(dim)) )
    enddo
#undef __FUNC__
  end function create_c2c_core

  subroutine create_r2c(self, dims, comm, precision, effort, executor, error_code)
  !! R2C Generic Plan Constructor
    class(dtfft_plan_r2c_t),          intent(inout) :: self
      !! C2C Plan
    integer(int32),                   intent(in)    :: dims(:)
      !! Global dimensions of transform
    TYPE_MPI_COMM,          optional, intent(in)    :: comm
      !! Communicator
    type(dtfft_precision_t),optional, intent(in)    :: precision
      !! Presicion of Transform
    type(dtfft_effort_t),   optional, intent(in)    :: effort
      !! Effort level for the plan creation
    type(dtfft_executor_t), optional, intent(in)    :: executor
    !! Type of External FFT Executor
    integer(int32),         optional, intent(out)   :: error_code
      !! Optional Error Code returned to user
    integer(int32)                    :: ierr               !! Error code

    CHECK_OPTIONAL_CALL( self%create_r2c_internal(dims=dims, comm=comm, precision=precision, effort=effort, executor=executor) )
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine create_r2c

  subroutine create_r2c_pencil(self, pencil, comm, precision, effort, executor, error_code)
  !! R2C Plan Constructor with pencil
    class(dtfft_plan_r2c_t),          intent(inout) :: self
      !! R2C Plan
    type(dtfft_pencil_t),             intent(in)    :: pencil
      !! Local pencil of data to be transformed
    TYPE_MPI_COMM,          optional, intent(in)    :: comm
      !! Communicator
    type(dtfft_precision_t),optional, intent(in)    :: precision
      !! Presicion of Transform
    type(dtfft_effort_t),   optional, intent(in)    :: effort
      !! Effort level for the plan creation
    type(dtfft_executor_t), optional, intent(in)    :: executor
    !! Type of External FFT Executor
    integer(int32),         optional, intent(out)   :: error_code
      !! Optional Error Code returned to user
    integer(int32)                    :: ierr               !! Error code

    CHECK_OPTIONAL_CALL( self%create_r2c_internal(pencil=pencil, comm=comm, precision=precision, effort=effort, executor=executor) )
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine create_r2c_pencil

  integer(int32) function create_r2c_internal(self, dims, pencil, comm, precision, effort, executor)
  !! Private method that combines common logic for R2C plan creation
#define __FUNC__ create_r2c_internal
    class(dtfft_plan_r2c_t),          intent(inout) :: self
      !! R2C Plan
    integer(int32),         optional, intent(in)    :: dims(:)
      !! Global dimensions of transform
    type(dtfft_pencil_t),   optional, intent(in)    :: pencil
      !! Local pencil of data to be transformed
    TYPE_MPI_COMM,          optional, intent(in)    :: comm
      !! Communicator
    type(dtfft_precision_t),optional, intent(in)    :: precision
      !! Presicion of Transform
    type(dtfft_effort_t),   optional, intent(in)    :: effort
      !! Effort level for the plan creation
    type(dtfft_executor_t), optional, intent(in)    :: executor
    !! Type of External FFT Executor
    integer(int32),   allocatable     :: fixed_dims(:)      !! Fixed dimensions for R2C
    integer(int8)                     :: fft_rank           !! Rank of FFT transform

    create_r2c_internal = DTFFT_SUCCESS
    if ( self%is_created ) then
      create_r2c_internal = DTFFT_ERROR_PLAN_IS_CREATED
      return
    endif

    PHASE_BEGIN("dtfft_create_r2c", COLOR_CREATE)
    if ( present(dims) ) then
      allocate(fixed_dims, source=dims)
      fixed_dims(1) = int(dims(1) / 2, int32) + 1
      CHECK_INTERNAL_CALL( self%create_c2c_core(dims=fixed_dims, comm=comm, precision=precision, effort=effort, executor=executor, sngl_type_init=MPI_REAL, sngl_storage_size_init=FLOAT_STORAGE_SIZE, dbl_type_init=MPI_REAL8, dbl_storage_size_init=DOUBLE_STORAGE_SIZE) )
      deallocate( fixed_dims )

      call self%real_pencil%create(self%ndims, 1_int8, dims, self%comms)
    else
      ! Do not know global dimensions
      ! They are computed when private pencil is created
      CHECK_INTERNAL_CALL( self%create_c2c_core(pencil=pencil, comm=comm, precision=precision, effort=effort, executor=executor, sngl_type_init=MPI_REAL, sngl_storage_size_init=FLOAT_STORAGE_SIZE, dbl_type_init=MPI_REAL8, dbl_storage_size_init=DOUBLE_STORAGE_SIZE) )
    endif

    if ( .not. self%is_transpose_plan ) then
      fft_rank = FFT_1D;  if ( self%is_z_slab ) fft_rank = FFT_2D
      CHECK_INTERNAL_CALL( self%fft(1)%fft%create(fft_rank, FFT_R2C, self%precision, real_pencil=self%real_pencil, complex_pencil=self%pencils(1)) )
    endif
    PHASE_END("dtfft_create_r2c")
    self%is_created = .true.
#undef __FUNC__
  end function create_r2c_internal

  function mem_alloc_ptr(self, alloc_bytes, error_code) result(ptr)
  !! Allocates memory specific for this plan
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    integer(int64),             intent(in)    :: alloc_bytes
      !! Number of bytes to allocate
    type(c_ptr)                               :: ptr
      !! Allocated pointer
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    ptr = c_null_ptr
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN
    if ( alloc_bytes < FLOAT_STORAGE_SIZE ) ierr = DTFFT_ERROR_INVALID_ALLOC_BYTES
    CHECK_ERROR_AND_RETURN

    if ( self%platform == DTFFT_PLATFORM_HOST ) then
      if( self%is_transpose_plan ) then
        ptr = mem_alloc_host(alloc_bytes)
      else
        call self%fft(1)%fft%mem_alloc(alloc_bytes, ptr)
      endif
      if ( is_null_ptr(ptr) ) ierr = DTFFT_ERROR_ALLOC_FAILED
#ifdef DTFFT_WITH_CUDA
    else
      call self%plan%mem_alloc(self%comm, alloc_bytes, ptr, ierr)
#endif
    endif
    CHECK_ERROR_AND_RETURN
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end function mem_alloc_ptr

  subroutine mem_free_ptr(self, ptr, error_code)
  !! Frees previously allocated memory specific for this plan
    class(dtfft_plan_t),        intent(inout) :: self
      !! Abstract plan
    type(c_ptr),                intent(in)    :: ptr
      !! Pointer allocated with [[dtfft_plan_t(type):mem_alloc]]
    integer(int32), optional,   intent(out)   :: error_code
      !! Optional error code returned to user
    integer(int32)  :: ierr     !! Error code

    ierr = DTFFT_SUCCESS
    if ( .not. self%is_created ) ierr = DTFFT_ERROR_PLAN_NOT_CREATED
    CHECK_ERROR_AND_RETURN

    if ( self%platform == DTFFT_PLATFORM_HOST ) then
      if( self%is_transpose_plan ) then
        call mem_free_host(ptr)
      else
        call self%fft(1)%fft%mem_free(ptr)
      endif
#ifdef DTFFT_WITH_CUDA
    else
      call self%plan%mem_free(ptr, ierr)
#endif
    endif
    CHECK_ERROR_AND_RETURN
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine mem_free_ptr

#define STORAGE_BYTES FLOAT_STORAGE_SIZE
#define BUFFER_TYPE real(real32)
#define ALLOC_1D mem_alloc_r32_1d
#define ALLOC_2D mem_alloc_r32_2d
#define ALLOC_3D mem_alloc_r32_3d
#define FREE_1D mem_free_r32_1d
#define FREE_2D mem_free_r32_2d
#define FREE_3D mem_free_r32_3d
#include "_dtfft_mem_alloc_free.inc"

#define STORAGE_BYTES DOUBLE_STORAGE_SIZE
#define BUFFER_TYPE real(real64)
#define ALLOC_1D mem_alloc_r64_1d
#define ALLOC_2D mem_alloc_r64_2d
#define ALLOC_3D mem_alloc_r64_3d
#define FREE_1D mem_free_r64_1d
#define FREE_2D mem_free_r64_2d
#define FREE_3D mem_free_r64_3d
#include "_dtfft_mem_alloc_free.inc"

#define STORAGE_BYTES COMPLEX_STORAGE_SIZE
#define BUFFER_TYPE complex(real32)
#define ALLOC_1D mem_alloc_c32_1d
#define ALLOC_2D mem_alloc_c32_2d
#define ALLOC_3D mem_alloc_c32_3d
#define FREE_1D mem_free_c32_1d
#define FREE_2D mem_free_c32_2d
#define FREE_3D mem_free_c32_3d
#include "_dtfft_mem_alloc_free.inc"

#define STORAGE_BYTES DOUBLE_COMPLEX_STORAGE_SIZE
#define BUFFER_TYPE complex(real64)
#define ALLOC_1D mem_alloc_c64_1d
#define ALLOC_2D mem_alloc_c64_2d
#define ALLOC_3D mem_alloc_c64_3d
#define FREE_1D mem_free_c64_1d
#define FREE_2D mem_free_c64_2d
#define FREE_3D mem_free_c64_3d
#include "_dtfft_mem_alloc_free.inc"
end module dtfft_plan

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
program test_r2c_2d
use iso_fortran_env
use iso_c_binding
use dtfft
use test_utils
use iso_c_binding
#include "_dtfft_mpi.h"
#include "_dtfft_cuda.h"
#include "dtfft.f03"
implicit none
#ifndef DTFFT_TRANSPOSE_ONLY
  type(c_ptr) :: check
  real(real64), target, allocatable :: inout(:)
#if defined(DTFFT_WITH_CUDA) && !defined(DTFFT_RUNNING_CICD)
  integer(int32), parameter :: nx = 999, ny = 344
#else
  integer(int32), parameter :: nx = 64, ny = 32
#endif
  integer(int32) :: comm_size, comm_rank, ierr
  type(dtfft_executor_t) :: executor
  type(dtfft_plan_r2c_t) :: plan
  type(dtfft_pencil_t) :: pencil
  integer(int32) :: grid(2), is_starts(2), in_counts(2), out_counts(2)
  real(real64) :: tf, tb
  integer(int64) :: alloc_size, upper_bound, cmplx_upper_bound
  type(dtfft_config_t) :: conf
#if defined(DTFFT_WITH_CUDA)
  type(dtfft_platform_t) :: platform
#endif

  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, comm_size, ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)

  if(comm_rank == 0) then
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a)') "|       dtFFT test: r2c_2d             |"
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a, i0, a, i0)') 'Nx = ',nx, ', Ny = ',ny
    write(output_unit, '(a, i0)') 'Number of processors: ', comm_size
    write(output_unit, '(a)') "----------------------------------------"
  endif
#ifdef DTFFT_TRANSPOSE_ONLY
  if ( comm_rank == 0 ) &
    write(output_unit, '(a)') "R2C Transpose plan not supported, skipping it"

  call MPI_Finalize(ierr)
  stop
#endif

  executor = DTFFT_EXECUTOR_NONE

#if defined (DTFFT_WITH_FFTW)
  executor = DTFFT_EXECUTOR_FFTW3
#elif defined (DTFFT_WITH_MKL)
  executor = DTFFT_EXECUTOR_MKL
#endif

#ifdef DTFFT_WITH_CUDA
  block
    character(len=5) :: platform_env
    integer(int32) :: env_len

    call get_environment_variable("DTFFT_PLATFORM", platform_env, env_len)

    if ( env_len == 0 .or. trim(adjustl(platform_env)) == "cuda" ) then
# if defined( DTFFT_WITH_CUFFT )
      executor = DTFFT_EXECUTOR_CUFFT
# elif defined( DTFFT_WITH_VKFFT )
      executor = DTFFT_EXECUTOR_VKFFT
# endif
    endif
  endblock
#endif

  if ( executor == DTFFT_EXECUTOR_NONE ) then
    if ( comm_rank == 0 ) &
      write(output_unit, '(a)') "Could not find valid R2C FFT executor, skipping test"
    call MPI_Finalize(ierr)
    stop
  endif

  call attach_gpu_to_process()

  conf = dtfft_config_t()
  conf%enable_datatype_backend = .false.
  conf%enable_fourier_reshape = .true.
  conf%enable_mpi_backends = .true.
#if defined(DTFFT_WITH_CUDA)
  !! Using openacc, disable nvshmem
  conf%enable_nvshmem_backends = .false.
  conf%platform = DTFFT_PLATFORM_CUDA
#endif
  call dtfft_set_config(conf, error_code=ierr); DTFFT_CHECK(ierr)

  grid(:) = 0
  call createGridDims(2, [nx, ny], grid, is_starts, in_counts)
  pencil = dtfft_pencil_t(is_starts, in_counts)

  call plan%create(pencil, effort=DTFFT_EXHAUSTIVE, executor=executor, error_code=ierr)
  DTFFT_CHECK(ierr)
  call plan%report()
  call plan%get_local_sizes(out_counts=out_counts, alloc_size=alloc_size, error_code=ierr)
  DTFFT_CHECK(ierr)

#if defined(DTFFT_WITH_CUDA)
  platform = plan%get_platform(ierr); DTFFT_CHECK(ierr)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
  block
    type(dtfft_backend_t) :: selected_backend

    selected_backend = plan%get_backend(error_code=ierr); DTFFT_CHECK(ierr)
    if(comm_rank == 0) then
      write(output_unit, '(a)') "Using backend: "//dtfft_get_backend_string(selected_backend)
    endif
  endblock
  endif
#endif

  upper_bound = product(in_counts)
  cmplx_upper_bound = 2 * product(out_counts)
  allocate(inout(alloc_size))

  check = mem_alloc_host(upper_bound * DOUBLE_STORAGE_SIZE)
  call setTestValuesDouble(check, upper_bound)

!$acc enter data create(inout) if( platform == DTFFT_PLATFORM_CUDA )

#if defined(DTFFT_WITH_CUDA)
!$acc host_data use_device(inout) if( platform == DTFFT_PLATFORM_CUDA )
  call doubleH2D(check, c_loc(inout), upper_bound, platform%val)
!$acc end host_data
#else
  call doubleH2D(check, c_loc(inout), upper_bound)
#endif


  tf = 0.0_real64 - MPI_Wtime()
!$acc host_data use_device(inout) if( platform == DTFFT_PLATFORM_CUDA )
  call plan%execute(inout, inout, DTFFT_EXECUTE_FORWARD, error_code=ierr)
!$acc end host_data
  DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
!$acc wait
  endif
#endif
  tf = tf + MPI_Wtime()

#if defined(DTFFT_WITH_CUDA)
!$acc host_data use_device(inout) if( platform == DTFFT_PLATFORM_CUDA )
  call scaleDouble(executor%val, c_loc(inout), cmplx_upper_bound, int(nx * ny, int64), platform%val, NULL_STREAM)
!$acc end host_data
#else
  call scaleDouble(executor%val, c_loc(inout), cmplx_upper_bound, int(nx * ny, int64))
#endif

  tb = 0.0_real64 - MPI_Wtime()
!$acc host_data use_device(inout) if( platform == DTFFT_PLATFORM_CUDA )
  call plan%execute(inout, inout, DTFFT_EXECUTE_BACKWARD, error_code=ierr)
!$acc end host_data
  DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
!$acc wait
  endif
#endif
  tb = tb + MPI_Wtime()

#if defined(DTFFT_WITH_CUDA) && !defined(DTFFT_WITH_MOCK_ENABLED)
!$acc host_data use_device(inout) if( platform == DTFFT_PLATFORM_CUDA )
  call checkAndReportDouble(int(nx * ny, int64), tf, tb, c_loc(inout), upper_bound, check, platform%val)
!$acc end host_data
#else
  call checkAndReportDouble(int(nx * ny, int64), tf, tb, c_loc(inout), upper_bound, check)
#endif

!$acc exit data delete(inout)  if( platform == DTFFT_PLATFORM_CUDA )

  deallocate(inout)
  call mem_free_host(check)

  call plan%destroy()
  call MPI_Finalize(ierr)
#endif
end program test_r2c_2d

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_api
!! This module is a Fortran part of C interface
use iso_c_binding,    only: c_int8_t, c_int32_t, c_size_t,  &
                            c_float, c_bool, c_char,        &
                            c_null_ptr, c_ptr, c_loc,       &
                            c_f_pointer
use iso_fortran_env,  only: int8, int32
use dtfft_config,     only: dtfft_config_t, dtfft_set_config
use dtfft_errors
use dtfft_parameters
use dtfft_pencil,     only: dtfft_pencil_t, dtfft_pencil_c, pencil_c2f, pencil_f2c
use dtfft_plan,       only: dtfft_plan_t, dtfft_plan_r2r_t, dtfft_plan_c2c_t, dtfft_plan_r2c_t
use dtfft_utils,      only: is_null_ptr, string_f2c
#include "_dtfft_mpi.h"
implicit none
private

#define CHECK_PLAN_CREATED(c_plan, f_plan)      \
  if(is_null_ptr(c_plan)) then;                 \
    error_code = DTFFT_ERROR_PLAN_NOT_CREATED;  \
    return;                                     \
  endif;                                        \
  call c_f_pointer(c_plan, f_plan)

    type :: plan_c
    !! C pointer to Fortran plan
        class(dtfft_plan_t),  allocatable :: p
        !! Actual Fortran plan
    end type plan_c

contains

    pure TYPE_MPI_COMM function get_comm(c_comm)
    !! Converts C communicator to Fortran communicator
        integer(c_int32_t),  intent(in) :: c_comm !! C communicator

        GET_MPI_VALUE(get_comm) = c_comm
    end function get_comm

    function dtfft_create_plan_r2r_c(ndims, dims, kinds, comm, precision, effort, executor, plan_ptr)                       &
    result(error_code)                                                                                                      &
    bind(C)
    !! Creates R2R dtFFT Plan, allocates all structures and prepares FFT, C interface
        integer(c_int8_t),              intent(in)    :: ndims                !! Rank of transform. Can be 2 or 3.
        type(c_ptr),            value,  intent(in)    :: dims                 !! Global sizes of transform
        type(c_ptr),            value,  intent(in)    :: kinds                !! FFT R2R kinds
        integer(c_int32_t),     value,  intent(in)    :: comm                 !! Communicator
        type(dtfft_precision_t),        intent(in)    :: precision            !! Precision of transform
        type(dtfft_effort_t),           intent(in)    :: effort               !! ``dtFFT`` planner effort type
        type(dtfft_executor_t),         intent(in)    :: executor             !! Type of External FFT Executor
        type(c_ptr),                    intent(out)   :: plan_ptr             !! C pointer to Fortran plan
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        integer(int32),                     pointer   :: fdims(:)             !! Fortran dims
        type(dtfft_r2r_kind_t),             pointer   :: fkinds(:)            !! Fortran R2R kinds
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        allocate(plan)
        allocate( dtfft_plan_r2r_t :: plan%p )

        call c_f_pointer(dims, fdims, [ndims])

        select type( p => plan%p )
        type is ( dtfft_plan_r2r_t )
            if ( is_null_ptr(kinds) ) then
                call p%create(fdims, comm=get_comm(comm), precision=precision, effort=effort, executor=executor, error_code=error_code)
            else
                call c_f_pointer(kinds, fkinds, [ndims])
                call p%create(fdims, fkinds, get_comm(comm), precision, effort, executor, error_code)
            endif
        endselect
        plan_ptr = c_loc(plan)
    end function dtfft_create_plan_r2r_c

    function dtfft_create_plan_r2r_pencil_c(pencil, kinds, comm, precision, effort, executor, plan_ptr)                     &
    result(error_code)                                                                                                      &
    bind(C)
    !! Creates R2R dtFFT Plan from Pencil, allocates all structures and prepares FFT, C interface
        type(dtfft_pencil_c),           intent(in)    :: pencil               !! C pointer to Fortran pencil
        type(c_ptr),            value,  intent(in)    :: kinds                !! FFT R2R kinds
        integer(c_int32_t),     value,  intent(in)    :: comm                 !! Communicator
        type(dtfft_precision_t),        intent(in)    :: precision            !! Precision of transform
        type(dtfft_effort_t),           intent(in)    :: effort               !! ``dtFFT`` planner effort type
        type(dtfft_executor_t),         intent(in)    :: executor             !! Type of External FFT Executor
        type(c_ptr),                    intent(out)   :: plan_ptr             !! C pointer to Fortran plan
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(dtfft_r2r_kind_t),             pointer   :: fkinds(:)            !! Fortran R2R kinds
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object
        type(dtfft_pencil_t)                          :: pencil_              !! Fortran pencil

        call pencil_c2f(pencil, pencil_, error_code)
        if ( error_code /= DTFFT_SUCCESS ) return

        allocate(plan)
        allocate( dtfft_plan_r2r_t :: plan%p )

        select type( p => plan%p )
        type is ( dtfft_plan_r2r_t )
            if ( is_null_ptr(kinds) ) then
                call p%create(pencil_, comm=get_comm(comm), precision=precision, effort=effort, executor=executor, error_code=error_code)
            else
                call c_f_pointer(kinds, fkinds, [pencil_%ndims])
                call p%create(pencil_, fkinds, get_comm(comm), precision, effort, executor, error_code)
            endif
        endselect
        plan_ptr = c_loc(plan)
    end function dtfft_create_plan_r2r_pencil_c

    function dtfft_create_plan_c2c_c(ndims, dims, comm, precision, effort, executor, plan_ptr)                        &
    result(error_code)                                                                                              &
    bind(C)
    !! Creates C2C dtFFT Plan, allocates all structures and prepares FFT, C interface
        integer(c_int8_t),              intent(in)    :: ndims                !! Rank of transform. Can be 2 or 3.
        type(c_ptr),            value,  intent(in)    :: dims                 !! Global sizes of transform
        integer(c_int32_t),     value,  intent(in)    :: comm                 !! Communicator
        type(dtfft_precision_t),        intent(in)    :: precision            !! Precision of transform
        type(dtfft_effort_t),           intent(in)    :: effort               !! ``dtFFT`` planner effort type
        type(dtfft_executor_t),         intent(in)    :: executor             !! Type of External FFT Executor
        type(c_ptr),                    intent(out)   :: plan_ptr             !! C pointer to Fortran plan
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        integer(int32),                     pointer   :: fdims(:)             !! Fortran dims
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        allocate(plan)
        allocate( dtfft_plan_c2c_t :: plan%p )

        call c_f_pointer(dims, fdims, [ndims])

        select type(p => plan%p)
        class is (dtfft_plan_c2c_t)
            call p%create(fdims, get_comm(comm), precision, effort, executor, error_code)
        endselect
        plan_ptr = c_loc(plan)
    end function dtfft_create_plan_c2c_c

    function dtfft_create_plan_c2c_pencil_c(pencil, comm, precision, effort, executor, plan_ptr)                          &
        result(error_code)                                                                                                  &
        bind(C)
    !! Creates C2C dtFFT plan from Pencil, allocates all structures and prepares FFT, C interface
        type(dtfft_pencil_c),           intent(in)    :: pencil               !! C pointer to Fortran pencil
        integer(c_int32_t),     value,  intent(in)    :: comm                 !! Communicator
        type(dtfft_precision_t),        intent(in)    :: precision            !! Precision of transform
        type(dtfft_effort_t),           intent(in)    :: effort               !! ``dtFFT`` planner effort type
        type(dtfft_executor_t),         intent(in)    :: executor             !! Type of External FFT Executor
        type(c_ptr),                    intent(out)   :: plan_ptr             !! C pointer to Fortran plan
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(dtfft_pencil_t)                          :: pencil_              !! Fortran pencil
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        call pencil_c2f(pencil, pencil_, error_code)
        if ( error_code /= DTFFT_SUCCESS ) return

        allocate(plan)
        allocate( dtfft_plan_c2c_t :: plan%p )
        select type(p => plan%p)
        class is (dtfft_plan_c2c_t)
            call p%create(pencil_, get_comm(comm), precision, effort, executor, error_code)
        endselect
        plan_ptr = c_loc(plan)
    end function dtfft_create_plan_c2c_pencil_c

    function dtfft_create_plan_r2c_c(ndims, dims, comm, precision, effort, executor, plan_ptr)                        &
        result(error_code)                                                                                              &
        bind(C)
    !! Creates R2C dtFFT Plan, allocates all structures and prepares FFT, C interface
        integer(c_int8_t),              intent(in)    :: ndims                !! Rank of transform. Can be 2 or 3.
        type(c_ptr),            value,  intent(in)    :: dims                 !! Global sizes of transform
        integer(c_int32_t),     value,  intent(in)    :: comm                 !! Communicator
        type(dtfft_precision_t),        intent(in)    :: precision            !! Precision of transform
        type(dtfft_effort_t),           intent(in)    :: effort               !! ``dtFFT`` planner effort type
        type(dtfft_executor_t),         intent(in)    :: executor             !! Type of External FFT Executor
        type(c_ptr),                    intent(out)   :: plan_ptr             !! C pointer to Fortran plan
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        integer(int32),                     pointer   :: fdims(:)             !! Fortran dims
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        allocate(plan)
        allocate( dtfft_plan_r2c_t :: plan%p )

        call c_f_pointer(dims, fdims, [ndims])

        select type(p => plan%p)
        class is (dtfft_plan_r2c_t)
            call p%create(fdims, get_comm(comm), precision, effort, executor, error_code)
        endselect
        plan_ptr = c_loc(plan)
    end function dtfft_create_plan_r2c_c

    function dtfft_create_plan_r2c_pencil_c(pencil, comm, precision, effort, executor, plan_ptr)                      &
        result(error_code)                                                                                              &
        bind(C)
    !! Creates R2C dtFFT Plan from Pencil, allocates all structures and prepares FFT, C interface
        type(dtfft_pencil_c),           intent(in)    :: pencil               !! C pointer to Fortran pencil
        integer(c_int32_t),    value,  intent(in)    :: comm                 !! Communicator
        type(dtfft_precision_t),        intent(in)    :: precision            !! Precision of transform
        type(dtfft_effort_t),           intent(in)    :: effort               !! ``dtFFT`` planner effort type
        type(dtfft_executor_t),         intent(in)    :: executor             !! Type of External FFT Executor
        type(c_ptr),                    intent(out)   :: plan_ptr             !! C pointer to Fortran plan
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(dtfft_pencil_t)                          :: pencil_              !! Fortran pencil
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        call pencil_c2f(pencil, pencil_, error_code)
        if ( error_code /= DTFFT_SUCCESS ) return

        allocate(plan)
        allocate( dtfft_plan_r2c_t :: plan%p )
        select type(p => plan%p)
        class is (dtfft_plan_r2c_t)
            call p%create(pencil_, get_comm(comm), precision, effort, executor, error_code)
        endselect
        plan_ptr = c_loc(plan)
    end function dtfft_create_plan_r2c_pencil_c

    function dtfft_get_z_slab_enabled_c(plan_ptr, is_z_slab_enabled)                                                  &
        result(error_code)                                                                                              &
        bind(C)
    !! Checks if dtFFT Plan is using Z-slab optimization
        type(c_ptr),        intent(in),     value     :: plan_ptr             !! C pointer to Fortran plan
        logical(c_bool),    intent(out)               :: is_z_slab_enabled    !! Is plan internally using Z-slab optimization
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        is_z_slab_enabled = plan%p%get_z_slab_enabled(error_code)
    end function dtfft_get_z_slab_enabled_c

    function dtfft_get_y_slab_enabled_c(plan_ptr, is_y_slab_enabled)                                                  &
        result(error_code)                                                                                              &
        bind(C)
    !! Checks if dtFFT Plan is using Y-slab optimization
        type(c_ptr),        intent(in),     value     :: plan_ptr             !! C pointer to Fortran plan
        logical(c_bool),    intent(out)               :: is_y_slab_enabled    !! Is plan internally using Y-slab optimization
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        is_y_slab_enabled = plan%p%get_y_slab_enabled(error_code)
    end function dtfft_get_y_slab_enabled_c

    function dtfft_execute_c(plan_ptr, in, out, execute_type, aux)                                                    &
        result(error_code)                                                                                              &
        bind(C)
    !! Executes dtFFT Plan, C interface. `aux` can be NULL.
        type(c_ptr),        value,    intent(in)      :: plan_ptr             !! C pointer to Fortran plan
        type(c_ptr),        value,    intent(in)      :: in                   !! Incomming pointer, not NULL
        type(c_ptr),        value,    intent(in)      :: out                  !! Outgoing buffer, not NULL
        type(dtfft_execute_t),        intent(in)      :: execute_type         !! Type of execution
        type(c_ptr),        value,    intent(in)      :: aux                  !! Aux buffer, can be NULL
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        call plan%p%execute_ptr(in, out, execute_type, aux, error_code)
    end function dtfft_execute_c

    function dtfft_transpose_c(plan_ptr, in, out, transpose_type, aux)                                                &
        result(error_code)                                                                                              &
        bind(C)
    !! Executes single transposition, C interface.
        type(c_ptr),        value,      intent(in)    :: plan_ptr             !! C pointer to Fortran plan
        type(c_ptr),        value,      intent(in)    :: in                   !! Incomming pointer, not NULL
        type(c_ptr),        value,      intent(in)    :: out                  !! Outgoing buffer, not NULL
        type(dtfft_transpose_t),        intent(in)    :: transpose_type       !! Type of transposition.
        type(c_ptr),        value,      intent(in)    :: aux                  !! Aux buffer, can be NULL
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        call plan%p%transpose_ptr(in, out, transpose_type, aux, error_code)
    end function dtfft_transpose_c

    function dtfft_transpose_start_c(plan_ptr, in, out, transpose_type, aux, request)                                 &
        result(error_code)                                                                                              &
        bind(C)
    !! Starts asynchronous transposition, returns transpose handle, C interface.
        type(c_ptr),        value,      intent(in)    :: plan_ptr             !! C pointer to Fortran plan
        type(c_ptr),        value,      intent(in)    :: in                   !! Incomming pointer, not NULL
        type(c_ptr),        value,      intent(in)    :: out                  !! Outgoing buffer, not NULL
        type(dtfft_transpose_t),        intent(in)    :: transpose_type       !! Type of transposition.
        type(c_ptr),        value,      intent(in)    :: aux                  !! Aux buffer, can be NULL
        type(dtfft_request_t),          intent(out)   :: request              !! Async transpose handle
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        request = plan%p%transpose_start_ptr(in, out, transpose_type, aux, error_code)
    end function dtfft_transpose_start_c

    function dtfft_transpose_end_c(plan_ptr, request)                                                                 &
        result(error_code)                                                                                              &
        bind(C)
    !! Finishes asynchronous transposition, C interface.
        type(c_ptr),          value,    intent(in)    :: plan_ptr             !! C pointer to Fortran plan
        type(dtfft_request_t),          intent(inout) :: request              !! Async transpose handle
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        call plan%p%transpose_end(request, error_code)
    end function dtfft_transpose_end_c

    function dtfft_reshape_c(plan_ptr, in, out, reshape_type, aux)                                                    &
        result(error_code)                                                                                              &
        bind(C)
    !! Executes dtFFT Reshape, C interface. `aux` can be NULL.
        type(c_ptr),        value,    intent(in)      :: plan_ptr             !! C pointer to Fortran plan
        type(c_ptr),        value,    intent(in)      :: in                   !! Incomming pointer, not NULL
        type(c_ptr),        value,    intent(in)      :: out                  !! Outgoing buffer, not NULL
        type(dtfft_reshape_t),        intent(in)      :: reshape_type         !! Type of reshape
        type(c_ptr),        value,    intent(in)      :: aux                  !! Aux buffer, can be NULL
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        call plan%p%reshape_ptr(in, out, reshape_type, aux, error_code)
    end function dtfft_reshape_c

    function dtfft_reshape_start_c(plan_ptr, in, out, reshape_type, aux, request)                                      &
        result(error_code)                                                                                              &
        bind(C)
    !! Starts asynchronous reshape, returns reshape handle, C interface.
        type(c_ptr),        value,      intent(in)    :: plan_ptr             !! C pointer to Fortran plan
        type(c_ptr),        value,      intent(in)    :: in                   !! Incomming pointer, not NULL
        type(c_ptr),        value,      intent(in)    :: out                  !! Outgoing buffer, not NULL
        type(dtfft_reshape_t),          intent(in)    :: reshape_type         !! Type of reshape
        type(c_ptr),        value,      intent(in)    :: aux                  !! Aux buffer, can be NULL
        type(dtfft_request_t),          intent(out)   :: request              !! Async reshape handle
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        request = plan%p%reshape_start_ptr(in, out, reshape_type, aux, error_code)
    end function dtfft_reshape_start_c

    function dtfft_reshape_end_c(plan_ptr, request)                                                                 &
        result(error_code)                                                                                              &
        bind(C)
    !! Finishes asynchronous reshape, C interface.
        type(c_ptr),          value,    intent(in)    :: plan_ptr             !! C pointer to Fortran plan
        type(dtfft_request_t),          intent(inout) :: request              !! Async reshape handle
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        call plan%p%reshape_end(request, error_code)
    end function dtfft_reshape_end_c

    function dtfft_destroy_c(plan_ptr)                                                                                &
        result(error_code)                                                                                              &
        bind(C)
    !! Destroys dtFFT Plan, C interface
        type(c_ptr)                                   :: plan_ptr             !! C pointer to Fortran plan
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        call plan%p%destroy(error_code)
        deallocate( plan%p )
        deallocate( plan )
        plan_ptr = c_null_ptr
    end function dtfft_destroy_c

    function dtfft_get_local_sizes_c(plan_ptr, in_starts, in_counts, out_starts, out_counts, alloc_size)              &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns local sizes, counts in real and Fourier spaces and number of elements to be allocated for `in` and `out` buffers,
    !! C interface.
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_int32_t),  intent(out),    optional :: in_starts(3)         !! Starts of local portion of data in 'real' space
        integer(c_int32_t),  intent(out),    optional :: in_counts(3)         !! Counts of local portion of data in 'real' space
        integer(c_int32_t),  intent(out),    optional :: out_starts(3)        !! Starts of local portion of data in 'fourier' space
        integer(c_int32_t),  intent(out),    optional :: out_counts(3)        !! Counts of local portion of data in 'fourier' space
        integer(c_size_t),   intent(out),    optional :: alloc_size           !! Minimum data needs to be allocated
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        call plan%p%get_local_sizes(in_starts, in_counts, out_starts, out_counts, alloc_size, error_code)
    end function dtfft_get_local_sizes_c

    function dtfft_get_alloc_size_c(plan_ptr, alloc_size)                                                             &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns minimum number of bytes to be allocated for `in` and `out` buffers, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_size_t),   intent(out)              :: alloc_size           !! Minimum data needs to be allocated
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        alloc_size = plan%p%get_alloc_size(error_code)
    end function dtfft_get_alloc_size_c

    function dtfft_get_aux_size_c(plan_ptr, aux_size)                                                                 &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns size of auxiliary buffer in elements, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_size_t),    intent(out)             :: aux_size             !! Size of auxiliary buffer in elements
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        aux_size = plan%p%get_aux_size(error_code)
    end function dtfft_get_aux_size_c

    function dtfft_get_aux_bytes_c(plan_ptr, aux_bytes)                                                               &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns minimum number of bytes required for auxiliary buffer, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_size_t),    intent(out)             :: aux_bytes            !! Number of bytes required for auxiliary buffer
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        aux_bytes = plan%p%get_aux_bytes(error_code)
    end function dtfft_get_aux_bytes_c

    function dtfft_get_aux_size_reshape_c(plan_ptr, aux_size)                                                         &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns size of auxiliary buffer for reshape in elements, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_size_t),    intent(out)             :: aux_size             !! Size of auxiliary buffer for reshape in elements
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        aux_size = plan%p%get_aux_size_reshape(error_code)
    end function dtfft_get_aux_size_reshape_c

    function dtfft_get_aux_bytes_reshape_c(plan_ptr, aux_bytes)                                                         &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns minimum number of bytes required for auxiliary buffer for reshape, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_size_t),    intent(out)             :: aux_bytes            !! Number of bytes required for auxiliary buffer for reshape
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        aux_bytes = plan%p%get_aux_bytes_reshape(error_code)
    end function dtfft_get_aux_bytes_reshape_c

    function dtfft_get_aux_size_transpose_c(plan_ptr, aux_size)                                                       &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns size of auxiliary buffer for transpose in elements, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_size_t),    intent(out)             :: aux_size             !! Size of auxiliary buffer for transpose in elements
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        aux_size = plan%p%get_aux_size_transpose(error_code)
    end function dtfft_get_aux_size_transpose_c

    function dtfft_get_aux_bytes_transpose_c(plan_ptr, aux_bytes)                                                     &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns minimum number of bytes required for auxiliary buffer for transpose, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_size_t),    intent(out)             :: aux_bytes            !! Number of bytes required for auxiliary buffer for transpose
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        aux_bytes = plan%p%get_aux_bytes_transpose(error_code)
    end function dtfft_get_aux_bytes_transpose_c

    function dtfft_get_pencil_c(plan_ptr, layout, pencil)                                                             &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns pencil decomposition info, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        type(dtfft_layout_t),  intent(in)             :: layout               !! Layout requested
        type(dtfft_pencil_c)                          :: pencil               !! Pencil pointer
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                       pointer   :: plan                 !! Pointer to Fortran object
        type(dtfft_pencil_t) :: pencil_         !! Fortran pencil

        CHECK_PLAN_CREATED(plan_ptr, plan)
        pencil_ = plan%p%get_pencil(layout, error_code)
        call pencil_f2c(pencil_, pencil)
    end function dtfft_get_pencil_c

    function dtfft_get_element_size_c(plan_ptr, element_size)                                                         &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns size of element in bytes, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_size_t),    intent(out)             :: element_size         !! Size of element in bytes
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        element_size = plan%p%get_element_size(error_code)
    end function dtfft_get_element_size_c

    function dtfft_get_alloc_bytes_c(plan_ptr, alloc_bytes)                                                           &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns minimum number of bytes required to execute plan, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_size_t),    intent(out)             :: alloc_bytes          !! Number of bytes required
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        alloc_bytes = plan%p%get_alloc_bytes(error_code)
    end function dtfft_get_alloc_bytes_c

    function dtfft_get_executor_c(plan_ptr, executor)                                                                 &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns executor type used in plan, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        type(dtfft_executor_t),     intent(out)       :: executor             !! The enumerated type dtfft_executor_t
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        executor = plan%p%get_executor(error_code)
    end function dtfft_get_executor_c

    function dtfft_get_precision_c(plan_ptr, precision)                                                               &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns precision used in plan, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        type(dtfft_precision_t),      intent(out)     :: precision            !! The enumerated type dtfft_precision_t
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        precision = plan%p%get_precision(error_code)
    end function dtfft_get_precision_c

    function dtfft_get_dims_c(plan_ptr, ndims, dims)                                                                  &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns dimensions of plan, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_int8_t),           intent(out)      :: ndims                !! Number of dimensions
        type(c_ptr),                 intent(out)      :: dims                 !! Array of dimensions
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object
        integer(c_int32_t), pointer :: dims_(:) => null()

        CHECK_PLAN_CREATED(plan_ptr, plan)
        call plan%p%get_dims(dims_, error_code=error_code)
        if ( error_code == DTFFT_SUCCESS ) then
            ndims = size(dims_, kind=c_int8_t)
            dims = c_loc(dims_)
        endif
    end function dtfft_get_dims_c

    function dtfft_get_grid_dims_c(plan_ptr, ndims, grid_dims)                                                        &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns grid decomposition dimensions of plan, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_int8_t),           intent(out)      :: ndims                !! Number of dimensions
        type(c_ptr),                 intent(out)      :: grid_dims            !! Array of dimensions
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object
        integer(c_int32_t), pointer :: grid_dims_(:) => null()

        CHECK_PLAN_CREATED(plan_ptr, plan)
        call plan%p%get_grid_dims(grid_dims_, error_code=error_code)
        if ( error_code == DTFFT_SUCCESS ) then
            ndims = size(grid_dims_, kind=c_int8_t)
            grid_dims = c_loc(grid_dims_)
        endif
    end function dtfft_get_grid_dims_c

    function dtfft_set_config_c(config)                                                                               &
        result(error_code)                                                                                              &
        bind(C)
    !! Sets dtFFT configuration, C interface
        type(dtfft_config_t),             intent(in)  :: config               !! Configuration to set
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        call dtfft_set_config(config, error_code)
    end function dtfft_set_config_c

    function dtfft_report_c(plan_ptr)                                                                                 &
        result(error_code)                                                                                              &
        bind(C)
    !! Reports dtFFT Plan, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        call plan%p%report(error_code)
    end function dtfft_report_c

#ifdef DTFFT_WITH_COMPRESSION
    function dtfft_report_compression_c(plan_ptr)                                                                     &
        result(error_code)                                                                                              &
        bind(C)
    !! Reports compression information for dtFFT Plan, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        call plan%p%report_compression(error_code)
    end function dtfft_report_compression_c
#endif

    function dtfft_mem_alloc_c(plan_ptr, alloc_bytes, ptr)                                                            &
        result(error_code)                                                                                              &
        bind(C)
    !! Allocates memory for dtFFT Plan, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        integer(c_size_t),                   value    :: alloc_bytes          !! Number of bytes to allocate
        type(c_ptr)                                   :: ptr                  !! Allocated pointer
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        ptr = plan%p%mem_alloc_ptr(alloc_bytes, error_code)
    end function dtfft_mem_alloc_c

    function dtfft_mem_free_c(plan_ptr, ptr)                                                                          &
        result(error_code)                                                                                              &
        bind(C)
    !! Frees memory for dtFFT Plan, C interface
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        type(c_ptr),                         value    :: ptr                  !! Pointer to deallocate
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        call plan%p%mem_free_ptr(ptr, error_code)
    end function dtfft_mem_free_c

    subroutine dtfft_get_error_string_c(error_code, error_string, error_string_size) bind(C)
    !! Returns an explaination of ``error_code`` that could have been previously returned by one of dtFFT API calls,
    !! C interface
        integer(c_int32_t),  intent(in)               :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        character(c_char),   intent(out)              :: error_string(*)      !! Explanation of error
        integer(c_size_t),   intent(out)              :: error_string_size    !! Size of ``error_string``

        call string_f2c(dtfft_get_error_string(error_code), error_string, error_string_size)
    end subroutine dtfft_get_error_string_c

    subroutine dtfft_get_precision_string_c(precision, precision_string, precision_string_size) bind(C)
    !! Returns string representation of ``dtfft_precision_t``, C interface
        type(dtfft_precision_t),  intent(in)          :: precision                !! The enumerated type dtfft_precision_t
        character(c_char),        intent(out)         :: precision_string(*)      !! Resulting string
        integer(c_size_t),        intent(out)         :: precision_string_size    !! Size of string

        call string_f2c(dtfft_get_precision_string(precision), precision_string, precision_string_size)
    end subroutine dtfft_get_precision_string_c

    subroutine dtfft_get_executor_string_c(executor, executor_string, executor_string_size) bind(C)
    !! Returns string representation of ``dtfft_executor_t``, C interface
        type(dtfft_executor_t),   intent(in)          :: executor                 !! The enumerated type dtfft_executor_t
        character(c_char),        intent(out)         :: executor_string(*)       !! Resulting string
        integer(c_size_t),        intent(out)         :: executor_string_size     !! Size of string

        call string_f2c(dtfft_get_executor_string(executor), executor_string, executor_string_size)
    end subroutine dtfft_get_executor_string_c

    function dtfft_get_backend_c(plan_ptr, backend)                                                                   &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns selected [[dtfft_backend_t]] during autotuning
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        type(dtfft_backend_t),      intent(out)       :: backend              !! The enumerated type dtfft_backend_t
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        backend = plan%p%get_backend(error_code)
    end function dtfft_get_backend_c

    function dtfft_get_reshape_backend_c(plan_ptr, backend)                                                           &
        result(error_code)                                                                                              &
        bind(C)
    !! Returns selected [[dtfft_backend_t]] for reshapes during autotuning
        type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
        type(dtfft_backend_t),      intent(out)       :: backend              !! The enumerated type dtfft_backend_t
        integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                            !! defines API call result codes.
        type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

        CHECK_PLAN_CREATED(plan_ptr, plan)
        backend = plan%p%get_reshape_backend(error_code)
    end function dtfft_get_reshape_backend_c

    subroutine dtfft_get_backend_string_c(backend, backend_string, backend_string_size) bind(C)
    !! Returns string representation of ``dtfft_backend_t``
        type(dtfft_backend_t),  intent(in)  :: backend             !! The enumerated type dtfft_backend_t
        character(c_char),      intent(out) :: backend_string(*)   !! Resulting string
        integer(c_size_t),      intent(out) :: backend_string_size !! Size of string

        call string_f2c(dtfft_get_backend_string(backend), backend_string, backend_string_size)
    end subroutine dtfft_get_backend_string_c

    logical(c_bool) function dtfft_get_backend_pipelined_c(backend) bind(C)
    !! Returns true if passed backend is pipelined and false otherwise.
        integer(c_int32_t),     intent(in)  :: backend             !! The enumerated type dtfft_backend_t

        dtfft_get_backend_pipelined_c = dtfft_get_backend_pipelined(dtfft_backend_t(backend))
    end function dtfft_get_backend_pipelined_c

#ifdef DTFFT_WITH_CUDA
  function dtfft_get_stream_c(plan_ptr, stream)                                                                     &
    result(error_code)                                                                                              &
    bind(C)
  !! Returns Stream associated with plan
    type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
    type(dtfft_stream_t),       intent(out)       :: stream               !! CUDA stream
    integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                          !! defines API call result codes.
    type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

    CHECK_PLAN_CREATED(plan_ptr, plan)
    call plan%p%get_stream(stream, error_code)
  end function dtfft_get_stream_c

  function dtfft_get_platform_c(plan_ptr, platform)                                                                 &
    result(error_code)                                                                                              &
    bind(C)
  !! Returns selected [[dtfft_platform_t]] during autotuning
    type(c_ptr),                         value    :: plan_ptr             !! C pointer to Fortran plan
    type(dtfft_platform_t),  intent(out)          :: platform             !! The enumerated type dtfft_platform_t
    integer(c_int32_t)                            :: error_code           !! The enumerated type dtfft_error_t
                                                                          !! defines API call result codes.
    type(plan_c),                 pointer         :: plan                 !! Pointer to Fortran object

    CHECK_PLAN_CREATED(plan_ptr, plan)
    platform = plan%p%get_platform(error_code)
  end function dtfft_get_platform_c
#endif
end module dtfft_api

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
program test_c2c_2d_float
use iso_fortran_env
use iso_c_binding
use dtfft
use test_utils
#if defined(DTFFT_WITH_CUDA)
use dtfft_interface_cuda_runtime
#endif
#include "_dtfft_mpi.h"
#include "_dtfft_cuda.h"
#include "dtfft.f03"
implicit none
  type(c_ptr) :: in, out, check
  integer(int32), parameter :: nx = 64, ny = 32
  integer(int32) :: comm_size, comm_rank, ierr
  type(dtfft_executor_t) :: executor
  integer(int64) :: alloc_size, element_size, alloc_bytes, in_size
  type(dtfft_plan_c2c_t) :: plan
  integer(int32) :: in_counts(2), out_counts(2)
  real(real64) :: tf, tb
#if defined(DTFFT_WITH_CUDA)
  type(dtfft_platform_t) :: platform
#endif

  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, comm_size, ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)

  if(comm_rank == 0) then
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a)') "|       dtFFT test: c2c_2d_float       |"
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a, i0, a, i0)') 'Nx = ',nx, ', Ny = ',ny
    write(output_unit, '(a, i0)') 'Number of processors: ', comm_size
    write(output_unit, '(a)') "----------------------------------------"
  endif

#if defined (DTFFT_WITH_FFTW)
  executor = DTFFT_EXECUTOR_FFTW3
#elif defined(DTFFT_WITH_MKL)
  executor = DTFFT_EXECUTOR_MKL
#else
  executor = DTFFT_EXECUTOR_NONE
#endif
#ifdef DTFFT_WITH_CUDA
  block
    character(len=5) :: platform_env
    integer(int32) :: env_len

    call get_environment_variable("DTFFT_PLATFORM", platform_env, env_len)

    if ( env_len == 0 .or. trim(adjustl(platform_env)) == "cuda" ) then
# if defined( DTFFT_WITH_CUFFT )
      executor = DTFFT_EXECUTOR_CUFFT;
# elif defined( DTFFT_WITH_VKFFT )
      executor = DTFFT_EXECUTOR_VKFFT;
# else
      executor = DTFFT_EXECUTOR_NONE;
# endif
    endif
  endblock
#endif

  call attach_gpu_to_process()

#if defined(DTFFT_WITH_CUDA)
  block
    type(dtfft_config_t) :: conf

    conf = dtfft_config_t(backend=DTFFT_BACKEND_MPI_P2P, platform=DTFFT_PLATFORM_CUDA)
    call dtfft_set_config(conf, error_code=ierr); DTFFT_CHECK(ierr)
  endblock
#endif

  call plan%create([nx, ny], precision=DTFFT_SINGLE, executor=executor, error_code=ierr); DTFFT_CHECK(ierr)
  call plan%report(error_code=ierr); DTFFT_CHECK(ierr)
  call plan%get_local_sizes(in_counts=in_counts, out_counts=out_counts, alloc_size=alloc_size, error_code=ierr); DTFFT_CHECK(ierr)
  element_size = plan%get_element_size(ierr);  DTFFT_CHECK(ierr)

  alloc_bytes = alloc_size * element_size

  in = plan%mem_alloc_ptr(alloc_bytes, ierr); DTFFT_CHECK(ierr)
  out = plan%mem_alloc_ptr(alloc_bytes, ierr); DTFFT_CHECK(ierr)

  in_size = int(product(in_counts), int64)
  check = mem_alloc_host(in_size * element_size)
  call setTestValuesComplexFloat(check, in_size)

#if defined(DTFFT_WITH_CUDA)
  platform = plan%get_platform(error_code=ierr); DTFFT_CHECK(ierr)
  call complexFloatH2D(check, in, in_size, platform%val)
#else
  call complexFloatH2D(check, in, in_size)
#endif

  tf = 0.0_real64 - MPI_Wtime()
  call plan%execute_ptr(in, out, DTFFT_EXECUTE_FORWARD, c_null_ptr, ierr); DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    CUDA_CALL( cudaDeviceSynchronize() )
  endif
#endif
  tf = tf + MPI_Wtime()

#if defined(DTFFT_WITH_CUDA)
  call scaleComplexFloat(executor%val, out, int(product(out_counts), int64), int(nx * ny, int64), platform%val, NULL_STREAM)
#else
  call scaleComplexFloat(executor%val, out, int(product(out_counts), int64), int(nx * ny, int64))
#endif

  tb = 0.0_real64 - MPI_Wtime()
  call plan%execute_ptr(out, in, DTFFT_EXECUTE_BACKWARD, c_null_ptr, ierr); DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    CUDA_CALL( cudaDeviceSynchronize() )
  endif
#endif
  tb = tb + MPI_Wtime()

#if defined(DTFFT_WITH_CUDA) && !defined(DTFFT_WITH_MOCK_ENABLED)
  call checkAndReportComplexFloat(int(nx * ny, int64), tf, tb, in, in_size, check, platform%val)
#else
  call checkAndReportComplexFloat(int(nx * ny, int64), tf, tb, in, in_size, check)
#endif

  call plan%mem_free_ptr(in, ierr); DTFFT_CHECK(ierr)
  call plan%mem_free_ptr(out, ierr); DTFFT_CHECK(ierr)

  call mem_free_host(check)

  call plan%destroy()
  call MPI_Finalize(ierr)
end program test_c2c_2d_float

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_backend_cufftmp_m
!! cuFFTMp GPU Backend [[backend_cufftmp]]
use iso_fortran_env
use iso_c_binding
use dtfft_abstract_backend, only: abstract_backend, backend_helper
use dtfft_interface_nvshmem
use dtfft_interface_cuda_runtime
use dtfft_interface_cufft
use dtfft_errors
use dtfft_parameters
use dtfft_pencil, only: pencil
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_cuda.h"
#include "_dtfft_private.h"
implicit none
private
public :: backend_cufftmp

    type :: Box3D
    !! cuFFTMp Box
        integer(c_long_long) :: lower(3)   !! Lower box boundaries
        integer(c_long_long) :: upper(3)   !! Upper box boundaries
        integer(c_long_long) :: strides(3) !! Strides in memory
    end type Box3D

    type, extends(abstract_backend) :: backend_cufftmp
    !! cuFFTMp GPU Backend
    private
        type(cufftReshapeHandle) :: plan
    contains
        procedure :: create_private => create
        procedure :: execute_private => execute
        procedure :: destroy_private => destroy
    end type backend_cufftmp

contains

    subroutine create(self, helper, base_storage)
    !! Creates cuFFTMp GPU Backend
        class(backend_cufftmp), intent(inout)   :: self               !! cuFFTMp GPU Backend
        type(backend_helper),   intent(in)      :: helper             !! Backend helper
        integer(int64),         intent(in)      :: base_storage       !! Number of bytes to store single element
        type(Box3D) :: inbox, outbox  !! Reshape boxes
        type(pencil), pointer :: in, out
        type(c_ptr) :: c_comm
        integer(int64) :: aux_size
        logical :: is_transpose

        is_transpose = .false.
        if ( is_valid_transpose_type(helper%transpose_type) ) then
            is_transpose = .true.
            select case (helper%transpose_type%val)
            case (DTFFT_TRANSPOSE_X_TO_Y%val)
                in => helper%pencils(1)
                out => helper%pencils(2)
            case (DTFFT_TRANSPOSE_Y_TO_X%val)
                in => helper%pencils(2)
                out => helper%pencils(1)
            case (DTFFT_TRANSPOSE_Y_TO_Z%val)
                in => helper%pencils(2)
                out => helper%pencils(3)
            case (DTFFT_TRANSPOSE_Z_TO_Y%val)
                in => helper%pencils(3)
                out => helper%pencils(2)
            case (DTFFT_TRANSPOSE_X_TO_Z%val)
                in => helper%pencils(1)
                out => helper%pencils(3)
            case (DTFFT_TRANSPOSE_Z_TO_X%val)
                in => helper%pencils(3)
                out => helper%pencils(1)
            case default
                INTERNAL_ERROR("backend_cufftmp: unknown `transpose_type`")
            end select
        else
            select case (helper%reshape_type%val)
            case ( DTFFT_RESHAPE_X_BRICKS_TO_PENCILS%val)
                in => helper%pencils(1)
                out => helper%pencils(3)
            case ( DTFFT_RESHAPE_X_PENCILS_TO_BRICKS%val )
                in => helper%pencils(3)
                out => helper%pencils(1)
            case ( DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS%val )
                in => helper%pencils(2)
                out => helper%pencils(4)
            case ( DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS%val )
                in => helper%pencils(4)
                out => helper%pencils(2)
            case default
                INTERNAL_ERROR("backend_cufftmp: unknown `transpose_type`")
            endselect
        endif

        if (in%rank == 3) then
            if ( is_transpose ) then
                if (any(helper%transpose_type == [DTFFT_TRANSPOSE_X_TO_Z, DTFFT_TRANSPOSE_Y_TO_X, DTFFT_TRANSPOSE_Z_TO_Y])) then
                    inbox%lower = [in%starts(2), in%starts(1), in%starts(3)]
                    inbox%upper = [in%starts(2) + in%counts(2), in%starts(1) + in%counts(1), in%starts(3) + in%counts(3)]
                    inbox%strides = [in%counts(1) * in%counts(3), in%counts(3), 1]
                else
                    inbox%lower = [in%starts(1), in%starts(3), in%starts(2)]
                    inbox%upper = [in%starts(1) + in%counts(1), in%starts(3) + in%counts(3), in%starts(2) + in%counts(2)]
                    inbox%strides = [in%counts(2) * in%counts(3), in%counts(2), 1]
                end if
            else
                inbox%lower = [in%starts(3), in%starts(2), in%starts(1)]
                inbox%upper = [in%starts(3) + in%counts(3), in%starts(2) + in%counts(2), in%starts(1) + in%counts(1)]
                inbox%strides = [in%counts(1) * in%counts(2), in%counts(1), 1]
            endif

            outbox%lower = [out%starts(3), out%starts(2), out%starts(1)]
            outbox%upper = [out%starts(3) + out%counts(3), out%starts(2) + out%counts(2), out%starts(1) + out%counts(1)]
            outbox%strides = [out%counts(1) * out%counts(2), out%counts(1), 1]
        else
            if ( is_transpose ) then
                inbox%lower = [0, in%starts(1), in%starts(2)]
                inbox%upper = [1, in%starts(1) + in%counts(1), in%starts(2) + in%counts(2)]
                inbox%strides = [in%counts(1) * in%counts(2), in%counts(2), 1]
            else
                inbox%lower = [0, in%starts(2), in%starts(1)]
                inbox%upper = [1, in%starts(2) + in%counts(2), in%starts(1) + in%counts(1)]
                inbox%strides = [in%counts(1) * in%counts(2), in%counts(1), 1]
            endif

            outbox%lower = [0, out%starts(2), out%starts(1)]
            outbox%upper = [1, out%starts(2) + out%counts(2), out%starts(1) + out%counts(1)]
            outbox%strides = [out%counts(1) * out%counts(2), out%counts(1), 1]
        end if

        CUFFT_CALL( cufftMpCreateReshape(self%plan) )
        c_comm = Comm_f2c(GET_MPI_VALUE(helper%comms(1)))
        CUFFT_CALL( cufftMpAttachReshapeComm(self%plan, CUFFT_COMM_MPI, c_comm) )
        CUFFT_CALL( cufftMpMakeReshape(self%plan, base_storage, 3, inbox%lower, inbox%upper, outbox%lower, outbox%upper, inbox%strides, outbox%strides) )
        CUFFT_CALL( cufftMpGetReshapeSize(self%plan, aux_size) )
        self%aux_bytes = max(aux_size, self%aux_bytes)
    end subroutine create

    subroutine execute(self, in, out, stream, aux, error_code)
    !! Executes cuFFTMp GPU Backend
        class(backend_cufftmp),             intent(inout)   :: self       !! cuFFTMp GPU Backend
        real(real32),   target, contiguous, intent(inout)   :: in(:)      !! Send pointer
        real(real32),   target, contiguous, intent(inout)   :: out(:)     !! Recv pointer
        type(dtfft_stream_t),               intent(in)      :: stream     !! Main execution CUDA stream
        real(real32),   target, contiguous, intent(inout)   :: aux(:)     !! Aux pointer
        integer(int32),                     intent(out)     :: error_code !! Error code
        integer(int32) :: ierr

        ! call nvshmemx_sync_all_on_stream(stream)
        CUDA_CALL( cudaStreamSynchronize(stream) )
        call MPI_Barrier(self%comm, ierr)
        CUFFT_CALL( cufftMpExecReshapeAsync(self%plan, c_loc(out), c_loc(in), c_loc(aux), stream) )
        error_code = DTFFT_SUCCESS
    end subroutine execute

    subroutine destroy(self)
    !! Destroys cuFFTMp GPU Backend
        class(backend_cufftmp), intent(inout) :: self        !! cuFFTMp GPU Backend

        CUFFT_CALL( cufftMpDestroyReshape(self%plan) )
    end subroutine destroy
end module dtfft_backend_cufftmp_m

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
module dtfft_interface_mkl_m
!! This module creates C interface with MKL library
use iso_c_binding,  only: c_long, c_int, c_ptr, c_f_pointer, c_null_char, c_size_t
use dtfft_utils,    only: string_c2f
implicit none
private

public :: mkl_dfti_create_desc,         &
          mkl_dfti_set_value,           &
          mkl_dfti_commit_desc,         &
          mkl_dfti_execute,             &
          mkl_dfti_free_desc,           &
          mkl_dfti_mem_alloc,           &
          mkl_dfti_mem_free
public :: DftiErrorMessage

  interface
    function DftiErrorMessage_c(error_code)                                   &
      result(message)                                                         &
      bind(C, name="DftiErrorMessage")
    !! Generates an error message.
    import
      integer(c_long),  intent(in), value  :: error_code      !! Completion status of a function.
      type(c_ptr)                          :: message         !! Pointer to message
    end function DftiErrorMessage_c
  end interface

  interface mkl_dfti_set_value
  !! Sets one particular configuration parameter with the specified configuration value.
    function mkl_dfti_set_integer(desc, param, value)                         &
      result(status)                                                          &
      bind(C)
    !! Sets one particular configuration parameter with integer value.
    import
      type(c_ptr),                  value :: desc             !! FFT descriptor.
      integer(c_int),   intent(in), value :: param            !! Configuration parameter.
      integer(c_int),   intent(in), value :: value            !! Configuration value.
      integer(c_long)                     :: status           !! Function completion status.
    end function mkl_dfti_set_integer

    function mkl_dfti_set_pointer(desc, param, value)                         &
      result(status)                                                          &
      bind(C)
    !! Sets one particular configuration parameter with pointer value.
    import
      type(c_ptr),                  value :: desc             !! FFT descriptor.
      integer(c_int),   intent(in), value :: param            !! Configuration parameter.
      integer(c_long),  intent(in)        :: value(*)         !! Configuration value.
      integer(c_long)                     :: status           !! Function completion status.
    end function mkl_dfti_set_pointer
  end interface mkl_dfti_set_value

  interface
    function  mkl_dfti_create_desc(precision, domain, dim, length, desc)      &
      result(status)                                                          &
      bind(C)
    !! Allocates the descriptor data structure and initializes it with default configuration values.
    import
      integer(c_int),   intent(in), value :: precision        !! Precision of the transform: DFTI_SINGLE or DFTI_DOUBLE.
      integer(c_int),   intent(in), value :: domain           !! Forward domain of the transform: DFTI_COMPLEX or DFTI_REAL.
      integer(c_long),  intent(in), value :: dim              !! Dimension of the transform.
      integer(c_long),  intent(in)        :: length(*)        !! Length of the transform for a one-dimensional transform.
                                                              !! Lengths of each dimension for a multi-dimensional transform.
      type(c_ptr)                         :: desc             !! FFT descriptor.
      integer(c_long)                     :: status           !! Function completion status.
    end function mkl_dfti_create_desc
  end interface

  interface
    function mkl_dfti_commit_desc(desc)                                       &
      result(status)                                                          &
      bind(C)
    !! Performs all initialization for the actual FFT computation.
    import
      type(c_ptr),                  value :: desc             !! FFT descriptor.
      integer(c_long)                     :: status           !! Function completion status.
    end function mkl_dfti_commit_desc
  end interface

  interface
    function mkl_dfti_execute(desc, in, out, sign)                            &
      result(status)                                                          &
      bind(C)
    !! Computes FFT.
    import
      type(c_ptr),                  value :: desc             !! FFT descriptor.
      type(c_ptr),                  value :: in               !! Data to be transformed
      type(c_ptr),                  value :: out              !! The transformed data
      integer(c_int),   intent(in), value :: sign             !! Sign of transform
      integer(c_long)                     :: status           !! Function completion status.
    end function mkl_dfti_execute
  end interface

  interface
    function mkl_dfti_free_desc(desc)                                         &
      result(status)                                                          &
      bind(C)
    !! Frees the memory allocated for a descriptor.
    import
      type(c_ptr),                  value :: desc             !! FFT descriptor.
      integer(c_long)                     :: status           !! Function completion status.
    end function mkl_dfti_free_desc
  end interface

  interface
    function mkl_dfti_mem_alloc(alloc_bytes, ptr)                             &
      result(status)                                                          &
      bind(C)
    !! Allocates pointer via `mkl_malloc`
    import
      integer(c_size_t),            value :: alloc_bytes      !! Number of bytes to allocate.
      type(c_ptr)                         :: ptr              !! Pointer to allocated memory.
      integer(c_long)                     :: status           !! Function completion status.
    end function mkl_dfti_mem_alloc
  end interface

  interface
    function mkl_dfti_mem_free(ptr)                                           &
      result(status)                                                          &
      bind(C)
    !! Frees pointer via `mkl_free`
    import
      type(c_ptr),                  value :: ptr              !! Pointer to allocated memory.
      integer(c_long)                     :: status           !! Function completion status.
    end function mkl_dfti_mem_free
  end interface

contains

  function DftiErrorMessage(error_code) result(string)
  !! Generates an error message.
    integer(c_long),    intent(in)  :: error_code       !! Completion status of a function.
    character(len=:),   allocatable :: string           !! Error message

    call string_c2f(DftiErrorMessage_c(error_code), string)
  end function DftiErrorMessage
end module dtfft_interface_mkl_m

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
#include "dtfft.f03"
module dtfft_reshape_plan_base
!! Base class for reshape/transpose plans
use iso_c_binding
use iso_fortran_env
use dtfft_abstract_reshape_handle,      only: reshape_container, execute_args
use dtfft_abstract_backend,             only: backend_helper
#ifdef DTFFT_WITH_COMPRESSION
use dtfft_abstract_compressor
#endif
use dtfft_config
#ifdef DTFFT_WITH_ZFP
use dtfft_compressor_zfp,               only: compressor_zfp
#endif
use dtfft_errors
use dtfft_parameters
use dtfft_pencil,                       only: pencil_init, pencil
#ifdef DTFFT_WITH_CUDA
# ifdef NCCL_HAVE_COMMREGISTER
use dtfft_abstract_backend,             only: NCCL_REGISTER_PREALLOC_SIZE
# endif
use dtfft_interface_cuda,               only: load_cuda
use dtfft_interface_cuda_runtime
use dtfft_interface_nvrtc,              only: load_nvrtc
# ifdef DTFFT_WITH_NCCL
use dtfft_interface_nccl
# endif
# ifdef DTFFT_WITH_NVSHMEM
use dtfft_interface_nvshmem
# endif
#endif
use dtfft_reshape_handle_generic,       only: reshape_handle_generic
use dtfft_reshape_handle_datatype,      only: reshape_handle_datatype
use dtfft_utils
#include "_dtfft_cuda.h"
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
#include "_dtfft_profile.h"
implicit none
private
public :: reshape_plan_base
public :: allocate_plans, destroy_plans
public :: get_aux_bytes_generic
public :: execute_autotune
public :: report_timings

    type :: reshape_plan_base
    !! Base class for reshape/transpose plans
        type(dtfft_backend_t)     :: backend
            !! Backend
        type(backend_helper)      :: helper
            !! Backend helper
        integer(int64)            :: min_buffer_size
            !! Minimal buffer size for transposition
        type(dtfft_platform_t)    :: platform
            !! Platform used for transposition
        type(dtfft_stream_t)      :: stream
            !! CUDA stream
        type(reshape_container), allocatable :: plans(:)
            !! Plans for each reshape operation
        type(string), allocatable :: names(:)
            !! Names of each reshape operation
        integer(int32), allocatable :: colors(:)
    contains
        procedure,  pass(self), non_overridable :: init                 !! Initializes reshape plan base
        procedure,  pass(self), non_overridable :: get_async_active     !! Returns .true. if any of the plans is running asynchronously
        procedure,  pass(self), non_overridable :: get_aux_bytes        !! Returns auxiliary buffer size
        procedure,  pass(self), non_overridable :: is_aux_needed        !! Returns .true. if aux buffer is needed
        procedure,  pass(self), non_overridable :: get_backend          !! Returns backend id
        procedure,  pass(self), non_overridable :: report_backends      !! Reports backends used by each plan. Should be used only for adaptive backend
        procedure,  pass(self), non_overridable :: is_nvshmem
        procedure,  pass(self), non_overridable :: execute              !! Executes reshape
        procedure,  pass(self), non_overridable :: execute_end          !! Finishes asynchronous reshape
        procedure,  pass(self), non_overridable :: mem_alloc            !! Allocates memory
        procedure,  pass(self), non_overridable :: mem_free             !! Frees memory
        procedure,  pass(self)                  :: destroy              !! Destroys reshape plan
#ifdef DTFFT_WITH_COMPRESSION
        procedure,  pass(self)                  :: report_compression   !! Reports compression statistics
#endif
    end type reshape_plan_base

contains

#ifdef DTFFT_WITH_COMPRESSION
    function init(self, platform, effort, backend, autotune_effort, compression_config, base_dtype, base_storage) result(error_code)
#else
    function init(self, platform, effort, backend, autotune_effort) result(error_code)
#endif
    !! Initializes reshape plan base
        class(reshape_plan_base),           intent(inout)   :: self                 !! Reshape class
        type(dtfft_platform_t),             intent(in)      :: platform             !! Execution platform
        type(dtfft_effort_t),               intent(in)      :: effort               !! Effort level
        type(dtfft_backend_t),              intent(in)      :: backend
        type(dtfft_effort_t),               intent(in)      :: autotune_effort
#ifdef DTFFT_WITH_COMPRESSION
        type(dtfft_compression_config_t),   intent(in)      :: compression_config   !! Compression configuration
        TYPE_MPI_DATATYPE,                  intent(in)      :: base_dtype           !! Base datatype
        integer(int64),                     intent(in)      :: base_storage         !! Number of bytes to store single element of base datatype
#endif
        integer(int32)                                      :: error_code           !! Error code

        error_code = DTFFT_SUCCESS
        self%stream = NULL_STREAM
        self%backend = backend
        self%platform = platform

        if ( self%backend == DTFFT_BACKEND_ADAPTIVE .and. effort%val < autotune_effort%val ) then
            error_code = DTFFT_ERROR_INVALID_BACKEND
            return
        endif

        if ( platform == DTFFT_PLATFORM_HOST ) then
            if ( .not. get_conf_datatype_enabled() .and. .not. get_conf_mpi_enabled() .and. effort%val >= autotune_effort%val) then
                error_code = DTFFT_ERROR_BACKENDS_DISABLED
                return
            endif

            if ( (is_backend_nccl(self%backend) .or. is_backend_nvshmem(self%backend)) .and. effort%val < autotune_effort%val) then
                error_code = DTFFT_ERROR_INVALID_PLATFORM_BACKEND
                return
            endif
#ifdef DTFFT_WITH_CUDA
        else
            if ( .not.get_conf_mpi_enabled() .and. .not.get_conf_nccl_enabled() .and. .not.get_conf_nvshmem_enabled() .and. effort%val >= autotune_effort%val) then
                error_code = DTFFT_ERROR_BACKENDS_DISABLED
                return
            endif

            ! TODO: fix this
            if ( self%backend == DTFFT_BACKEND_ADAPTIVE ) then
                error_code = DTFFT_ERROR_INVALID_PLATFORM_BACKEND
                return
            endif

            CHECK_CALL( load_cuda(), error_code )
            CHECK_CALL( load_nvrtc(), error_code )
            self%stream = get_conf_stream()
#endif
        endif
#ifdef DTFFT_WITH_COMPRESSION

        if ( (effort%val < autotune_effort%val .and. is_backend_compressed(backend)) .or. (effort%val >=autotune_effort%val .and. get_conf_compression_enabled()) ) then
            CHECK_CALL( check_compression_config(compression_config), error_code )

            block
                class(abstract_compressor), allocatable :: compressor

                if ( compression_config%compression_lib == DTFFT_COMPRESSION_LIB_ZFP ) then
# ifdef DTFFT_WITH_ZFP
                    allocate( compressor_zfp :: compressor )
# else
                    INTERNAL_ERROR("ZFP compression requested but dtFFT is not built with ZFP support")
# endif
                endif

                ! Checking compression parameters by creating temporary compressor
                CHECK_CALL( compressor%create(2_int8, compression_config, platform, base_dtype, base_storage, DIMS_PERMUTE_NONE), error_code )
                call compressor%destroy()
                deallocate(compressor)
            endblock
        endif
#else
        if ( is_backend_compressed(self%backend) .and. effort%val < autotune_effort%val ) then
            error_code = DTFFT_ERROR_INVALID_BACKEND
            return
        endif
#endif
    end function init

    subroutine execute(self, in, out, reshape_type, exec_type, aux, error_code)
    !! Executes reshape plan
        class(reshape_plan_base),     intent(inout) :: self           !! Transposition class
        type(c_ptr),                  intent(in)    :: in             !! Incoming buffer
        type(c_ptr),                  intent(in)    :: out            !! Resulting buffer
        integer(int32),               intent(in)    :: reshape_type   !! Type of reshape to execute
        type(c_ptr),                  intent(in)    :: aux            !! Optional auxiliary buffer
        type(async_exec_t),           intent(in)    :: exec_type      !! Type of execution (sync/async)
        integer(int32),    optional,  intent(out)   :: error_code     !! Error code
        type(execute_args)    :: kwargs     !! Additional arguments for execution
        integer(int32)        :: ierr       !! Error code
        logical :: is_pipe, is_fused
        type(dtfft_backend_t) :: backend

        backend = self%plans(reshape_type)%p%get_backend()
        is_pipe = is_backend_pipelined(backend)
        is_fused = is_backend_fused(backend) .or. is_backend_compressed(backend)
#ifdef DTFFT_DEBUG
        if ( is_same_ptr(in, out) .or. is_same_ptr(in, aux) .or. is_same_ptr(out, aux) ) then
            INTERNAL_ERROR("reshape_plan_base: wrong pointers for reshape "//self%names(reshape_type)%raw)
        endif
        if ( is_null_ptr(in) .or. is_null_ptr(out) ) then
            INTERNAL_ERROR("reshape_plan_base: null pointer detected for reshape "//self%names(reshape_type)%raw)
        endif
        if ( is_null_ptr(aux) .and. (is_pipe .or. is_fused) ) then
            INTERNAL_ERROR("reshape_plan_base: aux null pointer detected for reshape "//self%names(reshape_type)%raw)
        endif
#endif
        ! if ( reshape_type == DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS%val ) then
        !     ! select type ( plan => self%plans(reshape_type)%p )
        !     ! class is ( reshape_handle_datatype )
        !     block
        !         integer :: comm_rank

        !         call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)
        !         if (comm_rank == 0) print*,'comm_rank = ',comm_rank, 'executing', transfer(in, int64), '->', transfer(out, int64), 'aux = ', transfer(aux, int64)
        !     endblock
        !     ! endselect
        ! endif

        REGION_BEGIN(self%names(reshape_type)%raw, self%colors(reshape_type))
        kwargs%exec_type = exec_type
        kwargs%stream = self%stream
        kwargs%p1 = aux
        call self%plans(reshape_type)%p%execute(in, out, kwargs, ierr)
        if( present( error_code ) ) error_code = ierr
        REGION_END(self%names(reshape_type)%raw)
    end subroutine execute

    subroutine execute_end(self, in, out, reshape_type, aux, error_code)
    !! Finishes asynchronous reshape
        class(reshape_plan_base),   intent(inout) :: self           !! Reshape class
        type(c_ptr),                intent(in)    :: in             !! Incoming buffer
        type(c_ptr),                intent(in)    :: out            !! Resulting buffer
        integer(int32),             intent(in)    :: reshape_type   !! Type of reshape to execute
        type(c_ptr),                intent(in)    :: aux            !! Optional auxiliary buffer
        integer(int32),             intent(out)   :: error_code     !! Error code
        ! real(real32),   pointer :: pin(:)   !! Source buffer
        ! real(real32),   pointer :: pout(:)  !! Destination buffer
        ! real(real32),   pointer :: paux(:)  !! Aux buffer
        type(execute_args)      :: kwargs   !! Additional arguments for execution

        REGION_BEGIN(self%names(reshape_type)%raw//' end', self%colors(reshape_type))
        kwargs%p1 = in
        kwargs%p2 = out
        kwargs%p3 = aux
        kwargs%stream = self%stream
        call self%plans(reshape_type)%p%execute_end(kwargs, error_code)
        REGION_END(self%names(reshape_type)%raw//' end')
    end subroutine execute_end

    logical function get_async_active(self)
    !! Returns .true. if any of the plans is running asynchronously
        class(reshape_plan_base),   intent(in)    :: self           !! Reshape class
        integer(int32)  :: i

        get_async_active = .false.
        do i = lbound(self%plans, dim=1), ubound(self%plans, dim=1)
            if ( allocated( self%plans(i)%p ) ) then
                get_async_active = get_async_active .or. self%plans(i)%p%get_async_active()
            endif
        enddo
    end function get_async_active

    pure integer(int64) function get_aux_bytes(self)
    !! Returns maximum auxiliary memory size needed by reshape plan
        class(reshape_plan_base), intent(in)    :: self             !! Reshape class
        get_aux_bytes = 0_int64
        if ( .not. allocated( self%plans ) ) return
        get_aux_bytes = get_aux_bytes_generic(self%plans)
    end function get_aux_bytes

    pure logical function is_aux_needed(self)
    !! Returns true if aux is needed. false otherwise
        class(reshape_plan_base), intent(in)    :: self             !! Reshape class
        is_aux_needed = self%get_aux_bytes() > 0
    end function is_aux_needed

    type(dtfft_backend_t) function get_backend(self)
    !! Returns plan backend
        class(reshape_plan_base), intent(in)    :: self             !! Reshape class
        get_backend = self%backend
    end function get_backend

    subroutine destroy(self)
    !! Destroys reshape plan
        class(reshape_plan_base),   intent(inout) :: self           !! Reshape class
        integer(int32) :: i

        if ( allocated( self%plans ) ) then
            call destroy_plans(self%plans)
            deallocate( self%plans )
        endif
        call self%helper%destroy()
        if ( allocated(self%names) ) then
            do i = lbound(self%names, dim=1), ubound(self%names, dim=1)
                call self%names(i)%destroy()
            enddo
            deallocate(self%names)
        endif
        if ( allocated(self%colors) ) deallocate(self%colors)
    end subroutine destroy

    subroutine report_backends(self)
    !! Reports backends used by each plan. Should be used only for adaptive backend
        class(reshape_plan_base),   intent(in)  :: self         !! Reshape class
        integer(int32) :: i
        type(dtfft_backend_t) :: backend

        if ( .not. self%backend == DTFFT_BACKEND_ADAPTIVE ) then
            INTERNAL_ERROR("report_backends: .not. self%backend == DTFFT_BACKEND_ADAPTIVE")
        endif

        do i = lbound(self%plans, dim=1), ubound(self%plans, dim=1)
            if ( allocated( self%plans(i)%p ) ) then
                backend = self%plans(i)%p%get_backend()
                if ( backend == BACKEND_DUMMY ) cycle
                WRITE_REPORT("      "//self%names(i)%raw//" :  "//dtfft_get_backend_string(backend))
            endif
        enddo
    end subroutine report_backends

    pure logical function is_nvshmem(self)
        class(reshape_plan_base),   intent(in)  :: self         !! Reshape class

        is_nvshmem = is_nvshmem_generic(self%plans, self%backend)
    end function is_nvshmem

    pure logical function is_nvshmem_generic(plans, backend)
        type(reshape_container),    intent(in)  :: plans(:)          !! Reshape handles
        type(dtfft_backend_t),      intent(in)  :: backend
        integer(int32)  :: i

        is_nvshmem_generic = .false.
        if ( is_backend_nvshmem( backend ) ) then
            is_nvshmem_generic = .true.
            return
        endif
        if ( .not. backend == DTFFT_BACKEND_ADAPTIVE ) return
        do i = 1, size(plans)
            if ( allocated( plans(i)%p ) ) then
                is_nvshmem_generic = is_nvshmem_generic .or. is_backend_nvshmem( plans(i)%p%get_backend() )
            endif
        enddo
    end function is_nvshmem_generic

#ifdef DTFFT_WITH_COMPRESSION
    subroutine report_compression(self)
    !! Reports compression statistics
        class(reshape_plan_base),   intent(in)  :: self         !! Reshape class
        integer(int32) :: i

        do i = lbound(self%plans, dim=1), ubound(self%plans, dim=1)
            if ( allocated( self%plans(i)%p ) ) then
                call self%plans(i)%p%report_compression(self%names(i)%raw)
            endif
        enddo
    end subroutine report_compression
#endif

    subroutine mem_alloc(self, comm, alloc_bytes, ptr, error_code)
    !! Allocates memory based on selected backend
        class(reshape_plan_base),   intent(inout) :: self               !! Reshape class
        TYPE_MPI_COMM,              intent(in)    :: comm               !! MPI communicator
        integer(int64),             intent(in)    :: alloc_bytes        !! Number of bytes to allocate
        type(c_ptr),                intent(out)   :: ptr                !! Pointer to the allocated memory
        integer(int32),             intent(out)   :: error_code         !! Error code
        type(dtfft_backend_t) :: backend

        backend = self%backend; if ( self%is_nvshmem() ) backend = DTFFT_BACKEND_CUFFTMP
        call alloc_mem(self%platform, self%helper, backend, comm, alloc_bytes, ptr, error_code)
    end subroutine mem_alloc

    subroutine mem_free(self, ptr, error_code)
    !! Frees memory allocated with mem_alloc
        class(reshape_plan_base),   intent(inout) :: self               !! Reshape class
        type(c_ptr),                intent(in)    :: ptr                !! Pointer to the memory to free
        integer(int32),             intent(out)   :: error_code         !! Error code
        type(dtfft_backend_t) :: backend

        backend = self%backend; if ( self%is_nvshmem() ) backend = DTFFT_BACKEND_CUFFTMP
        call free_mem(self%platform, self%helper, backend, ptr, error_code)
    end subroutine mem_free

    subroutine alloc_mem(platform, helper, backend, comm, alloc_bytes, ptr, error_code)
    !! Allocates memory based on ``backend``
        type(dtfft_platform_t), intent(in)    :: platform           !! Execution platform
        type(backend_helper),   intent(inout) :: helper             !! Backend helper
        type(dtfft_backend_t),  intent(in)    :: backend            !! Backend to allocate memory for
        TYPE_MPI_COMM,          intent(in)    :: comm               !! MPI communicator
        integer(int64),         intent(in)    :: alloc_bytes        !! Number of bytes to allocate
        type(c_ptr),            intent(out)   :: ptr                !! Pointer to the allocated memory
        integer(int32),         intent(out)   :: error_code         !! Error code
#ifdef DTFFT_WITH_CUDA
        integer(int64)  :: free_mem_avail, total_mem_avail
#endif

        error_code = DTFFT_SUCCESS
        if ( platform == DTFFT_PLATFORM_HOST ) then
            ptr = mem_alloc_host(alloc_bytes)
#ifdef DTFFT_WITH_CUDA
        else
            CUDA_CALL( cudaMemGetInfo(free_mem_avail, total_mem_avail) )
# ifdef DTFFT_DEBUG
            block
            integer(int64) :: min_mem, max_mem, min_free_mem, max_free_mem
            integer(int32) :: mpi_err

                call MPI_Allreduce(alloc_bytes, max_mem, 1, MPI_INTEGER8, MPI_MAX, comm, mpi_err)
                call MPI_Allreduce(alloc_bytes, min_mem, 1, MPI_INTEGER8, MPI_MIN, comm, mpi_err)
                call MPI_Allreduce(free_mem_avail, max_free_mem, 1, MPI_INTEGER8, MPI_MAX, comm, mpi_err)
                call MPI_Allreduce(free_mem_avail, min_free_mem, 1, MPI_INTEGER8, MPI_MIN, comm, mpi_err)
                WRITE_DEBUG("Trying to allocate "//to_str(min_mem)//"/"//to_str(max_mem)//" (min/max) bytes for backend: '"//dtfft_get_backend_string(backend)//"'")
                WRITE_DEBUG("Free memory available: "//to_str(min_free_mem)//"/"//to_str(max_free_mem)//" (min/max) bytes")
            endblock
# endif
            if ( alloc_bytes > free_mem_avail ) then
                error_code = DTFFT_ERROR_ALLOC_FAILED
                return
            endif
            if ( is_backend_nccl(backend) ) then
# ifdef DTFFT_WITH_NCCL
#   ifdef NCCL_HAVE_MEMALLOC
                error_code = ncclMemAlloc(ptr, alloc_bytes)
#   else
                error_code = cudaMalloc(ptr, alloc_bytes)
#   endif
#   ifdef NCCL_HAVE_COMMREGISTER
                if ( error_code == cudaSuccess .and. helper%should_register ) then
                    block
                    type(c_ptr), allocatable :: temp(:,:)
                    type(c_ptr) :: handle

                        if ( size(helper%nccl_register, dim=2) == helper%nccl_register_size ) then
                            allocate( temp(2, helper%nccl_register_size + NCCL_REGISTER_PREALLOC_SIZE) )
                            temp(2, 1:helper%nccl_register_size) = helper%nccl_register(2, 1:helper%nccl_register_size)
                            deallocate( helper%nccl_register )
                            call move_alloc(temp, helper%nccl_register)
                        endif
                        helper%nccl_register_size = helper%nccl_register_size + 1

                        NCCL_CALL( ncclCommRegister(helper%nccl_comm, ptr, alloc_bytes, handle) )
                        helper%nccl_register(1, helper%nccl_register_size) = ptr
                        helper%nccl_register(2, helper%nccl_register_size) = handle
                        WRITE_DEBUG("Registered pointer "//to_str(transfer(ptr, int64)))
                    endblock
                endif
#   endif
# else
            INTERNAL_ERROR("not DTFFT_WITH_NCCL")
# endif
            else if ( is_backend_nvshmem(backend) ) then
# ifdef DTFFT_WITH_NVSHMEM
                block
                integer(int64)  :: max_alloc_bytes
                integer(int32)  :: mpi_err

                    call MPI_Allreduce(alloc_bytes, max_alloc_bytes, 1, MPI_INTEGER8, MPI_MAX, comm, mpi_err)
                    ptr = nvshmem_malloc(max_alloc_bytes)
                    if ( is_null_ptr(ptr) ) error_code = DTFFT_ERROR_ALLOC_FAILED
                endblock
# else
        INTERNAL_ERROR("not DTFFT_WITH_NVSHMEM")
# endif
            else
                error_code = cudaMalloc(ptr, alloc_bytes)
            endif
#endif
        endif
        if ( error_code /= DTFFT_SUCCESS ) error_code = DTFFT_ERROR_ALLOC_FAILED
    end subroutine alloc_mem

    subroutine free_mem(platform, helper, backend, ptr, error_code)
    !! Frees memory based on ``backend``
        type(dtfft_platform_t),         intent(in)    :: platform       !! Execution platform
        type(backend_helper),           intent(inout) :: helper         !! Backend helper
        type(dtfft_backend_t),          intent(in)    :: backend        !! Backend to free memory for
        type(c_ptr),                    intent(in)    :: ptr            !! Pointer to the memory to free
        integer(int32),                 intent(out)   :: error_code     !! Error code

        error_code = DTFFT_SUCCESS
        if ( platform == DTFFT_PLATFORM_HOST ) then
            call mem_free_host(ptr)
#ifdef DTFFT_WITH_CUDA
        else
            if ( is_backend_nccl(backend) ) then
# ifdef NCCL_HAVE_COMMREGISTER
                if ( helper%should_register ) then
                    block
                    integer(int32) :: i

                        do i = 1, size(helper%nccl_register, dim=2)
                            if ( .not. is_same_ptr(ptr, helper%nccl_register(1, i)) ) cycle
                            NCCL_CALL( ncclCommDeregister(helper%nccl_comm, helper%nccl_register(2, i)) )
                            helper%nccl_register(1, i) = c_null_ptr
                            helper%nccl_register(2, i) = c_null_ptr
                            helper%nccl_register_size = helper%nccl_register_size - 1
                            WRITE_DEBUG("Pointer "//to_str(transfer(ptr, int64))//" has been removed from registry")
                        enddo
                    endblock
                endif
# endif
# ifdef DTFFT_WITH_NCCL
#   ifdef NCCL_HAVE_MEMALLOC
                error_code = ncclMemFree(ptr)
#   else
                error_code = cudaFree(ptr)
#   endif
# else
                INTERNAL_ERROR("not DTFFT_WITH_NCCL")
# endif
            else if ( is_backend_nvshmem(backend) ) then
# ifdef DTFFT_WITH_NVSHMEM
                call nvshmem_free(ptr)
# else
                INTERNAL_ERROR("not DTFFT_WITH_NVSHMEM")
# endif
            else
                error_code = cudaFree(ptr)
            endif
#endif
        endif
        if ( error_code /= DTFFT_SUCCESS ) error_code = DTFFT_ERROR_FREE_FAILED
    end subroutine free_mem

    subroutine allocate_plans(plans, backend, backends)
    !! Allocates array of plans
        type(reshape_container),            intent(inout) :: plans(:)       !! Plans to allocate
        type(dtfft_backend_t),  optional,   intent(in)    :: backend        !! Backend to use
        type(dtfft_backend_t),  optional,   intent(in)    :: backends(:)    !! Backends to use
        integer(int32) :: i
        type(dtfft_backend_t) :: backend_

#ifdef DTFFT_DEBUG
        if ( .not.present(backend) .and. .not.present(backends) ) then
            INTERNAL_ERROR("allocate_plans: .not.present(backend) .and. .not.present(backends)")
        endif
#endif

        do i = 1, size(plans)
            if ( present(backend) ) then
                backend_ = backend
            else
                backend_ = backends(i)
            endif
            if ( backend_ == DTFFT_BACKEND_MPI_DATATYPE ) then
                allocate( reshape_handle_datatype :: plans(i)%p )
            else
                allocate( reshape_handle_generic :: plans(i)%p )
            endif
        enddo
    end subroutine allocate_plans

    pure integer(int64) function get_aux_bytes_generic(plans)
    !! Returns maximum auxiliary memory size needed by handles array
        type(reshape_container),   intent(in)  :: plans(:)          !! Reshape handles
        integer(int32)  :: i

        get_aux_bytes_generic = 0_int64
        do i = 1, size(plans)
            if ( allocated( plans(i)%p ) ) then
                get_aux_bytes_generic = max( get_aux_bytes_generic, plans(i)%p%get_aux_bytes() )
            endif
        enddo
    end function get_aux_bytes_generic

    subroutine destroy_plans(plans)
    !! Destroys array of plans
        type(reshape_container),    intent(inout) :: plans(:)       !! Plans to destroy
        integer(int32) :: i

        do i = 1, size(plans)
            if( allocated(plans(i)%p) ) then
                call plans(i)%p%destroy()
                deallocate(plans(i)%p)
            endif
        enddo
    end subroutine destroy_plans

    function execute_autotune(plans, comm, backend, platform, helper, stream, buffer_size, report_space_count) result(execution_time)
    !! Executes autotuning for given plans and returns execution time in milliseconds
        type(reshape_container),    intent(inout) :: plans(:)       !! Allocated plans
        TYPE_MPI_COMM,              intent(in)    :: comm           !! Communicator
        type(dtfft_backend_t),      intent(in)    :: backend        !! Backend to use
        type(dtfft_platform_t),     intent(in)    :: platform       !! Platform used
        type(backend_helper),       intent(inout) :: helper         !! Helper to use
        type(dtfft_stream_t),       intent(in)    :: stream         !! Stream to use
        integer(int64),             intent(in)    :: buffer_size        !!
        integer(int32), optional,   intent(in)    :: report_space_count
        real(real32)                              :: execution_time !! Execution time
        type(execute_args) :: execute_kwargs
#ifdef DTFFT_WITH_CUDA
        type(cudaEvent) :: timer_start, timer_stop
#endif
        type(c_ptr) :: in, out, aux
        ! real(real32), pointer :: pin(:)   !! Source buffer
        ! real(real32), pointer :: pout(:)  !! Destination buffer
        ! real(real32), pointer :: paux(:)  !! Auxiliary buffer
        integer(int32) :: i, iter, ierr
        integer(int64) :: float_buffer_size
        ! character(len=:), allocatable :: testing_phase
        logical :: is_aux_alloc
        integer(int32) :: n_warmup_iters, n_iters
        real(real64) :: ts, te


        n_warmup_iters = get_conf_measure_warmup_iters()
        n_iters = get_conf_measure_iters()

#ifdef DTFFT_WITH_CUDA
        if ( platform == DTFFT_PLATFORM_CUDA ) then
        CUDA_CALL( cudaEventCreate(timer_start) )
        CUDA_CALL( cudaEventCreate(timer_stop) )
        endif
#endif
        float_buffer_size = buffer_size / FLOAT_STORAGE_SIZE

        call alloc_mem(platform, helper, backend, comm, buffer_size, in, ierr); DTFFT_CHECK(ierr)
        call alloc_mem(platform, helper, backend, comm, buffer_size, out, ierr); DTFFT_CHECK(ierr)

        ! call c_f_pointer(in, pin, [float_buffer_size])
        ! call c_f_pointer(out, pout, [float_buffer_size])

        ! testing_phase = "Testing backend "//dtfft_get_backend_string(backend)
        ! REGION_BEGIN(testing_phase, COLOR_AUTOTUNE2)
        ! WRITE_INFO(testing_phase)

        call alloc_and_set_aux(platform, helper, backend, comm, aux, plans, is_aux_alloc)
        execute_kwargs%p1 = aux
        ! if( is_aux_alloc ) then
        !     execute_kwargs%p1 => paux
        ! else
        !     execute_kwargs%p1 => pout
        ! endif
        execute_kwargs%exec_type = EXEC_BLOCKING
        execute_kwargs%stream = stream

        ! REGION_BEGIN("Warmup", COLOR_TRANSPOSE)
        do iter = 1, n_warmup_iters
            do i = 1, size(plans)
                call plans(i)%p%execute(in, out, execute_kwargs, ierr)
            enddo
        enddo
#ifdef DTFFT_WITH_CUDA
        if ( platform == DTFFT_PLATFORM_CUDA ) then
            CUDA_CALL( cudaStreamSynchronize(stream) )
        endif
#endif
        ! REGION_END("Warmup")

        ! REGION_BEGIN("Measure", COLOR_EXECUTE)

        call MPI_Barrier(comm, ierr)
        if ( platform == DTFFT_PLATFORM_HOST ) then
            ts = MPI_Wtime()
#ifdef DTFFT_WITH_CUDA
        else
            CUDA_CALL( cudaEventRecord(timer_start, stream) )
#endif
        endif
        do iter = 1, n_iters
            do i = 1, size(plans)
                call plans(i)%p%execute(in, out, execute_kwargs, ierr)
            enddo
        enddo
        if ( platform == DTFFT_PLATFORM_HOST ) then
            te = MPI_Wtime()
            execution_time = real(te - ts, real32) * 1000._real32
#ifdef DTFFT_WITH_CUDA
        else
            CUDA_CALL( cudaEventRecord(timer_stop, stream) )
            CUDA_CALL( cudaEventSynchronize(timer_stop) )
            CUDA_CALL( cudaEventElapsedTime(execution_time, timer_start, timer_stop) )
#endif
        endif
        ! REGION_END("Measure")

        ! REGION_END(testing_phase)

        execution_time = report_timings(comm, execution_time, n_iters, report_space_count)

#ifdef DTFFT_WITH_CUDA
        if ( platform == DTFFT_PLATFORM_CUDA ) then
            CUDA_CALL( cudaEventDestroy(timer_start) )
            CUDA_CALL( cudaEventDestroy(timer_stop) )
        endif
#endif

        call free_mem(platform, helper, backend, in, ierr)
        call free_mem(platform, helper, backend, out, ierr)
        if ( is_aux_alloc ) then
            call free_mem(platform, helper, backend, aux, ierr)
        endif

        ! if ( platform == DTFFT_PLATFORM_CUDA .and. is_backend_mpi(backend)) then
        !     call try_free_mpi_handles(comm, platform, helper)
        ! endif
    end function execute_autotune

    function report_timings(comm, elapsed_time, n_iters, space_count) result(max_time)
    !! Aggregates and writing timings to stdout
        TYPE_MPI_COMM,            intent(in)  :: comm
        real(real32),             intent(in)  :: elapsed_time
        integer(int32),           intent(in)  :: n_iters
        integer(int32), optional, intent(in)  :: space_count
        real(real32)                          :: max_time
        real(real32) :: execution_time, min_time, avg_time
        integer(int32) :: ierr, comm_size, space_count_

        execution_time = elapsed_time / real(n_iters, real32)
        space_count_ = 2; if ( present(space_count) ) space_count_ = space_count

        call MPI_Allreduce(execution_time, min_time, 1, MPI_REAL4, MPI_MIN, comm, ierr)
        call MPI_Allreduce(execution_time, max_time, 1, MPI_REAL4, MPI_MAX, comm, ierr)
        call MPI_Allreduce(execution_time, avg_time, 1, MPI_REAL4, MPI_SUM, comm, ierr)
        call MPI_Comm_size(comm, comm_size, ierr)

        avg_time = avg_time / real(comm_size, real32)

        WRITE_INFO(repeat(" ", space_count_)//"max: "//to_str(real(max_time, real64))//" [ms]")
        WRITE_INFO(repeat(" ", space_count_)//"min: "//to_str(real(min_time, real64))//" [ms]")
        WRITE_INFO(repeat(" ", space_count_)//"avg: "//to_str(real(avg_time, real64))//" [ms]")
    end function report_timings

    subroutine alloc_and_set_aux(platform, helper, backend, cart_comm, aux, plans, is_aux_alloc)
    !! Allocates auxiliary memory according to the backend and sets it to the plans
        type(dtfft_platform_t),       intent(in)                :: platform
        type(backend_helper),         intent(inout)             :: helper       !! Backend helper
        type(dtfft_backend_t),        intent(in)                :: backend      !! GPU backend
        TYPE_MPI_COMM,                intent(in)                :: cart_comm    !! Cartesian communicator
        type(c_ptr),                  intent(inout)             :: aux          !! Allocatable auxiliary memory
        ! real(real32),     pointer,    intent(inout)             :: paux(:)      !! Pointer to auxiliary memory
        type(reshape_container),      intent(in)                :: plans(:)
        logical                                                 :: is_aux_alloc !! Is auxiliary memory allocated
        integer(int64) :: max_work_size_local, max_work_size_global
        integer(int32)  :: mpi_ierr
        integer(int32) :: alloc_ierr
        type(dtfft_backend_t) :: backend_

        max_work_size_local = get_aux_bytes_generic(plans)
        call MPI_Allreduce(max_work_size_local, max_work_size_global, 1, MPI_INTEGER8, MPI_MAX, cart_comm, mpi_ierr)

        is_aux_alloc = .false.
        ! paux => null()
        if ( max_work_size_global > 0 ) then
            backend_ = backend; if ( is_nvshmem_generic(plans, backend_) ) backend_ = DTFFT_BACKEND_CUFFTMP
            call alloc_mem(platform, helper, backend_, cart_comm, max_work_size_global, aux, alloc_ierr)
            DTFFT_CHECK(alloc_ierr)
            ! call c_f_pointer(aux, paux, [max_work_size_global / 4_int64])
            is_aux_alloc = .true.
        endif
    end subroutine alloc_and_set_aux

! subroutine try_free_mpi_handles(comm, platform, helper)
! TYPE_MPI_COMM,          intent(in)      :: comm
! type(dtfft_platform_t), intent(in)      :: platform
! type(backend_helper),   intent(inout)   :: helper
! #ifdef DTFFT_WITH_CUDA
! integer(int64) :: alloc_size
! integer(int32) :: base_size, comm_size, ierr
! type(c_ptr) :: ptr1, ptr2, ptr3
! integer(int64)  :: free_mem_before, free_mem_after, total_mem_avail
! real(real32), pointer, contiguous :: rptr1(:), rptr2(:), rptr3(:)
! #endif

!     if ( platform == DTFFT_PLATFORM_HOST ) return
! #ifdef DTFFT_WITH_CUDA

!     call MPI_Comm_size(comm, comm_size, ierr)

!     base_size = 1024 * 1024 * 30    ! 10Mb per process
!     alloc_size = int(base_size, int64) * comm_size

!     CUDA_CALL( cudaMemGetInfo(free_mem_before, total_mem_avail) )

!     call alloc_mem(platform, helper, DTFFT_BACKEND_MPI_P2P, comm, alloc_size, ptr1, ierr);  call c_f_pointer(ptr1, rptr1, [1])
!     call alloc_mem(platform, helper, DTFFT_BACKEND_MPI_P2P, comm, alloc_size, ptr2, ierr);  call c_f_pointer(ptr2, rptr2, [1])
!     call alloc_mem(platform, helper, DTFFT_BACKEND_MPI_P2P, comm, alloc_size, ptr3, ierr);  call c_f_pointer(ptr3, rptr3, [1])

!     call MPI_Alltoall(rptr1, base_size, MPI_BYTE, rptr2, base_size, MPI_BYTE, comm, ierr)
!     call MPI_Alltoall(rptr1, base_size, MPI_BYTE, rptr3, base_size, MPI_BYTE, comm, ierr)
!     call MPI_Alltoall(rptr2, base_size, MPI_BYTE, rptr3, base_size, MPI_BYTE, comm, ierr)

!     call free_mem(platform, helper, DTFFT_BACKEND_MPI_P2P, ptr1, ierr)
!     call free_mem(platform, helper, DTFFT_BACKEND_MPI_P2P, ptr2, ierr)
!     call free_mem(platform, helper, DTFFT_BACKEND_MPI_P2P, ptr3, ierr)

!     CUDA_CALL( cudaMemGetInfo(free_mem_after, total_mem_avail) )

!     WRITE_INFO("Tried to release internal MPI handles. Free mem before: "//to_str(free_mem_before)//", after = "//to_str(free_mem_after))

! #endif
! end subroutine try_free_mpi_handles

end module dtfft_reshape_plan_base

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_nvrtc_module
!! Module for managing nvRTC compiled CUDA kernels
!! Each module has only one templated kernel that can be instantiated with different parameters
use iso_fortran_env
use iso_c_binding
use dtfft_abstract_kernel
use dtfft_errors
use dtfft_config
use dtfft_nvrtc_block_optimizer, only: kernel_config
use dtfft_interface_cuda
use dtfft_interface_cuda_runtime
use dtfft_interface_nvrtc
use dtfft_parameters
use dtfft_utils
#ifdef DTFFT_WITH_MOCK_ENABLED
use dtfft_kernel_host
#endif
#include "_dtfft_cuda.h"
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
#include "_dtfft_profile.h"
implicit none
private
public :: nvrtc_module

    type, extends(string) :: codegen_t
    !! Class for generating CUDA code
    contains
        procedure, pass(self) :: add => add_line  !! Adds new line to CUDA code
    end type codegen_t

    type :: nvrtc_module
    !! Class for managing nvRTC compiled CUDA kernels
    private
        logical                       :: is_created = .false.   !! Is module created
        type(string)                  :: basic_name             !! Basic kernel name
        integer(int32)                :: ndims                  !! Number of dimensions, used only for forward permutation
        type(CUmodule)                :: cumod                  !! CUDA module
        type(nvrtcProgram)            :: prog                   !! nvRTC program
        type(kernel_type_t)           :: kernel_type            !! Type of kernel
        integer(int64)                :: base_storage           !! Number of bytes needed to store single element
        type(kernel_config),  allocatable :: configs(:)         !! Kernel configurations that this module was compiled for
    contains
    private
        procedure, pass(self), public   :: create     !! Creates module with given parameters
        procedure, pass(self), public   :: destroy    !! Destroys module and frees resources
        procedure, pass(self), public   :: get        !! Returns kernel ready to be executed
        generic,               public   :: check =>         &
                                           check_instance,  &
                                           check_module
        !! Checks if kernel is with given parameters is available in this module
        procedure, pass(self)           :: check_instance !! Checks if kernel with given parameters is available in this module
        procedure, pass(self)           :: check_module   !! Basic check that this module provides kernels of given type
    end type nvrtc_module

contains

    subroutine add_line(self, line)
    !! Adds new line to CUDA code
        class(codegen_t), intent(inout) :: self     !! Kernel code
        character(len=*), intent(in)    :: line     !! Line to add

        if (.not. allocated(self%raw)) allocate (self%raw, source="")
        self%raw = self%raw//line//c_new_line
    end subroutine add_line

    function get(self, ndims, kernel_type, base_storage, tile_size, block_rows, fun) result(ierr)
    !! Returns kernel ready to be executed
        class(nvrtc_module),  intent(in)    :: self               !! This module
        integer(int32),       intent(in)    :: ndims              !! Number of dimensions, used only for forward permutation
        type(kernel_type_t),  intent(in)    :: kernel_type        !! Type of kernel to build
        integer(int64),       intent(in)    :: base_storage       !! Number of bytes needed to store single element
        integer(int32),       intent(in)    :: tile_size          !! Size of shared memory tile, template parameter
        integer(int32),       intent(in)    :: block_rows         !! Number of rows processed by single thread, template parameter
        type(CUfunction),     intent(out)   :: fun                !! Resulting kernel
        integer(int32)                      :: ierr
        integer(int32)  :: i          !! Loop variable
        integer(int32)  :: config_id  !! Configuration ID
#ifndef DTFFT_WITH_MOCK_ENABLED
        type(c_ptr)     :: mangled    !! Mangled kernel name
        type(kernel_config) :: config !! Found configuration

        fun = CUfunction(c_null_ptr)
#endif
        ierr = -1
        if ( .not. self%check(ndims, kernel_type, base_storage, tile_size, block_rows) ) return
        config_id = -1
        do i = 1, size(self%configs, dim=1)
            if (tile_size == self%configs(i)%tile_size .and. block_rows == self%configs(i)%block_rows) then
                config_id = i
                exit
            end if
        end do
#ifdef DTFFT_DEBUG
        if (config_id < 0) then
            INTERNAL_ERROR("nvrtc_module.get: config_id < 0")
        endif
#endif
#ifndef DTFFT_WITH_MOCK_ENABLED
        config = self%configs(config_id)
        mangled = get_mangled_name(self%basic_name%raw, self%prog, config%tile_size, config%block_rows, config%padding)
        CUDA_CALL( cuModuleGetFunction(fun, self%cumod, mangled) )
#else
        select case ( kernel_type%val )
        case ( KERNEL_PERMUTE_BACKWARD%val )
            if ( base_storage == FLOAT_STORAGE_SIZE ) then
                fun%sfun_r32 => permute_backward_write_f32
            else if ( base_storage == DOUBLE_STORAGE_SIZE ) then
                fun%sfun_r64 => permute_backward_write_f64
            else if ( base_storage == DOUBLE_COMPLEX_STORAGE_SIZE ) then
                fun%sfun_r128 => permute_backward_write_f128
            else
                INTERNAL_ERROR("nvrtc_module.get: unknown `base_storage`")
            end if
        case ( KERNEL_PERMUTE_FORWARD%val )
            if ( base_storage == FLOAT_STORAGE_SIZE ) then
                fun%sfun_r32 => permute_forward_write_f32
            else if ( base_storage == DOUBLE_STORAGE_SIZE ) then
                fun%sfun_r64 => permute_forward_write_f64
            else if ( base_storage == DOUBLE_COMPLEX_STORAGE_SIZE ) then
                fun%sfun_r128 => permute_forward_write_f128
            else
                INTERNAL_ERROR("nvrtc_module.get: unknown `base_storage`")
            end if
        case ( KERNEL_PERMUTE_BACKWARD_START%val )
            if ( base_storage == FLOAT_STORAGE_SIZE ) then
                fun%sfun_r32 => permute_backward_start_write_f32
            else if ( base_storage == DOUBLE_STORAGE_SIZE ) then
                fun%sfun_r64 => permute_backward_start_write_f64
            else if ( base_storage == DOUBLE_COMPLEX_STORAGE_SIZE ) then
                fun%sfun_r128 => permute_backward_start_write_f128
            else
                INTERNAL_ERROR("nvrtc_module.get: unknown `base_storage`")
            end if
        ! case ( KERNEL_COPY%val )
        !     if ( base_storage == FLOAT_STORAGE_SIZE ) then
        !         fun%sfun_r32 => copy_f32
        !     else if ( base_storage == DOUBLE_STORAGE_SIZE ) then
        !         fun%sfun_r64 => copy_f64
        !     else if ( base_storage == DOUBLE_COMPLEX_STORAGE_SIZE ) then
        !         fun%sfun_r128 => copy_f128
        !     else
        !         INTERNAL_ERROR("nvrtc_module.get: unknown `base_storage`")
        !     end if
        case ( KERNEL_PACK_PIPELINED%val )
            if ( base_storage == FLOAT_STORAGE_SIZE ) then
                fun%pfun_r32 => pack_pipelined_f32
            else if ( base_storage == DOUBLE_STORAGE_SIZE ) then
                fun%pfun_r64 => pack_pipelined_f64
            else if ( base_storage == DOUBLE_COMPLEX_STORAGE_SIZE ) then
                fun%pfun_r128 => pack_pipelined_f128
            else
                INTERNAL_ERROR("nvrtc_module.get: unknown `base_storage`")
            end if
        case ( KERNEL_PACK_FORWARD%val )
            if ( base_storage == FLOAT_STORAGE_SIZE ) then
                fun%pfun_r32 => pack_forward_write_f32
            else if ( base_storage == DOUBLE_STORAGE_SIZE ) then
                fun%pfun_r64 => pack_forward_write_f64
            else if ( base_storage == DOUBLE_COMPLEX_STORAGE_SIZE ) then
                fun%pfun_r128 => pack_forward_write_f128
            else
                INTERNAL_ERROR("nvrtc_module.get: unknown `base_storage`")
            end if
        case ( KERNEL_PACK_BACKWARD%val )
            if ( base_storage == FLOAT_STORAGE_SIZE ) then
                fun%pfun_r32 => pack_backward_write_f32
            else if ( base_storage == DOUBLE_STORAGE_SIZE ) then
                fun%pfun_r64 => pack_backward_write_f64
            else if ( base_storage == DOUBLE_COMPLEX_STORAGE_SIZE ) then
                fun%pfun_r128 => pack_backward_write_f128
            else
                INTERNAL_ERROR("nvrtc_module.get: unknown `base_storage`")
            end if
        case ( KERNEL_UNPACK_PIPELINED%val )
            if ( base_storage == FLOAT_STORAGE_SIZE ) then
                fun%pfun_r32 => unpack_pipelined_f32
            else if ( base_storage == DOUBLE_STORAGE_SIZE ) then
                fun%pfun_r64 => unpack_pipelined_f64
            else if ( base_storage == DOUBLE_COMPLEX_STORAGE_SIZE ) then
                fun%pfun_r128 => unpack_pipelined_f128
            else
                INTERNAL_ERROR("nvrtc_module.get: unknown `base_storage`")
            end if
        case ( KERNEL_PERMUTE_BACKWARD_END_PIPELINED%val )
            if ( base_storage == FLOAT_STORAGE_SIZE ) then
                fun%pfun_r32 => permute_backward_end_pipelined_write_f32
            else if ( base_storage == DOUBLE_STORAGE_SIZE ) then
                fun%pfun_r64 => permute_backward_end_pipelined_write_f64
            else if ( base_storage == DOUBLE_COMPLEX_STORAGE_SIZE ) then
                fun%pfun_r128 => permute_backward_end_pipelined_write_f128
            else
                INTERNAL_ERROR("nvrtc_module.get: unknown `base_storage`")
            end if
        case default
            block
                type(string) :: str
                str = get_kernel_string(kernel_type)
                INTERNAL_ERROR("nvrtc_module.get: unknown `kernel_type`"//str%raw)
            endblock
        endselect
#endif
        ierr = DTFFT_SUCCESS
    end function get

    logical function check_instance(self, ndims, kernel_type, base_storage, tile_size, block_rows)
    !! Checks if kernel with given parameters is available in this module
        class(nvrtc_module),  intent(in)    :: self               !! This module
        integer(int32),       intent(in)    :: ndims              !! Number of dimensions
        type(kernel_type_t),  intent(in)    :: kernel_type        !! Type of kernel to build
        integer(int64),       intent(in)    :: base_storage       !! Number of bytes needed to store single element
        integer(int32),       intent(in)    :: tile_size          !! Size of shared memory tile, template parameter
        integer(int32),       intent(in)    :: block_rows         !! Number of rows processed by single thread, template parameter
        integer(int32)       :: i !! Loop variable

        check_instance = .false.
        if ( .not. self%check(ndims, kernel_type, base_storage) ) return
        do i = 1, size(self%configs, dim=1)
            if (tile_size == self%configs(i)%tile_size .and. block_rows == self%configs(i)%block_rows) then
                check_instance = .true.
                return
            end if
        end do
    end function check_instance

    logical function check_module(self, ndims, kernel_type, base_storage)
    !! Basic check that this module provides kernels of given type
        class(nvrtc_module),  intent(in)    :: self               !! This module
        integer(int32),       intent(in)    :: ndims              !! Number of dimensions
        type(kernel_type_t),  intent(in)    :: kernel_type        !! Type of kernel to build
        integer(int64),       intent(in)    :: base_storage       !! Number of bytes needed to store single element

        check_module = .false.
        if (.not. self%is_created) return
        if (kernel_type /= self%kernel_type) return
        if (base_storage /= self%base_storage) return
        if (ndims /= self%ndims .and. kernel_type == KERNEL_PERMUTE_FORWARD) return
        check_module = .true.
    end function check_module

    subroutine create(self, ndims, kernel_type, base_storage, configs, props)
    !! Creates module with given parameters, compiles nvRTC program and loads it as CUDA module
        class(nvrtc_module),  intent(inout) :: self               !! This module
        integer(int32),       intent(in)    :: ndims              !! Number of dimensions, used only for forward permutation
        type(kernel_type_t),  intent(in)    :: kernel_type        !! Type of kernel to build
        integer(int64),       intent(in)    :: base_storage       !! Number of bytes needed to store single element
        type(kernel_config),  intent(in)    :: configs(:)         !! Kernel configurations that this module should be compiled for
        type(device_props),   intent(in)    :: props              !! GPU architecture properties
        type(codegen_t)                   :: code             !! Generated code
        character(len=:),     allocatable :: region_name      !! Phase name for profiling
        integer(int32)                    :: i                !! Loop variable
        integer(c_size_t)                 :: cubinSizeRet     !! Size of cubin
        type(c_ptr)                       :: cubin            !! Cubin data

        call self%destroy()
        self%base_storage = base_storage
        self%kernel_type = kernel_type
        self%ndims = ndims
        self%cumod = CUmodule(c_null_ptr)
        allocate (self%configs( size(configs) ))
        do i = 1, size(configs)
            self%configs(i)%tile_size = configs(i)%tile_size
            self%configs(i)%block_rows = configs(i)%block_rows
            self%configs(i)%padding = configs(i)%padding
        enddo

        self%basic_name = get_kernel_string(kernel_type)

        region_name = "Compiling "//self%basic_name%raw
        REGION_BEGIN(region_name, COLOR_FFT)
        WRITE_DEBUG(region_name)

        code = get_code(self%basic_name%raw, ndims, base_storage, kernel_type)
        WRITE_DEBUG(code%raw)
        self%prog = compile_program(code, self%basic_name%raw, configs, props)
        call code%destroy()

        NVRTC_CALL( nvrtcGetCUBINSize(self%prog, cubinSizeRet) )
        cubin = mem_alloc_host(cubinSizeRet)
        NVRTC_CALL( nvrtcGetCUBIN(self%prog, cubin) )
        CUDA_CALL( cuModuleLoadData(self%cumod, cubin) )
        call mem_free_host(cubin)
        REGION_END(region_name)

        self%is_created = .true.
        deallocate( region_name )
    end subroutine create

    subroutine destroy(self)
    !! Destroys module and frees resources
        class(nvrtc_module), intent(inout) :: self

        if ( .not. self%is_created ) return
        if ( is_null_ptr(self%cumod%ptr) .or. is_null_ptr(self%prog%cptr) ) then
            INTERNAL_ERROR("nvrtc_module.destroy: is_null_ptr(self%cumod%ptr)")
        endif

        NVRTC_CALL( nvrtcDestroyProgram(self%prog) )
        CUDA_CALL( cuModuleUnload(self%cumod) )
        self%cumod = CUmodule(c_null_ptr)
        self%prog = nvrtcProgram(c_null_ptr)
        if( allocated( self%configs ) ) deallocate(self%configs)
        call self%basic_name%destroy()
    end subroutine destroy

    function compile_program(code, prog_name, configs, props) result(prog)
    !! Compiles nvRTC program with given configurations
        type(codegen_t),      intent(in)  :: code               !! CUDA code to compile
        character(len=*),     intent(in)  :: prog_name          !! Basic kernel name
        type(kernel_config),  intent(in)  :: configs(:)         !! Kernel configurations that this module should be compiled for
        type(device_props),   intent(in)  :: props              !! GPU architecture properties
        type(nvrtcProgram)                :: prog               !! Resulting nvRTC program
        integer(int32)                    :: num_options        !! Number of compilation options
        type(string), target, allocatable :: options(:)         !! Compilation options
        type(c_ptr),          allocatable :: c_options(:)       !! C style, null-string terminated options
        character(c_char),    allocatable :: c_code(:)          !! CUDA C Code to compile
        integer(int32)  :: i              !! Loop variable
        integer(int32)  :: compile_result !! Result of compilation
        character(len=:),     allocatable :: prog_name_

#ifdef DTFFT_DEBUG
        num_options = 3
#else
        num_options = 1
#endif

        allocate( c_options(num_options), options(num_options) )
        options(1) = string("--gpu-architecture=sm_"//to_str(props%compute_capability_major)//to_str(props%compute_capability_minor) // c_null_char)
#ifdef DTFFT_DEBUG
        options(2) = string("--device-debug" // c_null_char)
        options(3) = string("--generate-line-info" // c_null_char)
#endif
        do i = 1, num_options
        c_options(i) = c_loc(options(i)%raw)
        enddo

        call astring_f2c(code%raw, c_code)
        prog_name_ = prog_name//".cu"//c_null_char
        NVRTC_CALL( nvrtcCreateProgram(prog, c_code, prog_name_, 0, c_null_ptr, c_null_ptr) )
        deallocate( c_code, prog_name_ )

        do i = 1, size(configs)
            call set_name_expression(prog, prog_name, configs(i)%tile_size, configs(i)%block_rows, configs(i)%padding)
        enddo

        compile_result = nvrtcCompileProgram(prog, num_options, c_options)
        if ( compile_result /= 0 ) then
            block
                type(c_ptr) :: c_log
                integer(c_size_t) :: log_size
                character(len=:), allocatable :: f_log

                NVRTC_CALL( nvrtcGetProgramLogSize(prog, log_size) )
                c_log = mem_alloc_host(log_size)
                NVRTC_CALL( nvrtcGetProgramLog(prog, c_log) )
                call string_c2f(c_log, f_log)

                write(error_unit, "(a)") "dtFFT Internal Error: failed to compile kernel"
                write(error_unit, "(a)") "CUDA Code:"
                write(error_unit, "(a)") code%raw
                write(error_unit, "(a)") "Compilation log:"
                write(error_unit, "(a)") f_log

                INTERNAL_ERROR("compile_program: Compilation failed")
            endblock
        endif

        call destroy_strings(options)
        deallocate( c_options )
    end function compile_program

    function get_name_expression(basic_name, tile_dim, block_rows, padding) result(expression)
    !! Generates name expression for given template parameters
        character(len=*), intent(in)  :: basic_name       !! Basic kernel name
        integer(int32),   intent(in)  :: tile_dim         !! Size of shared memory tile, template parameter
        integer(int32),   intent(in)  :: block_rows       !! Number of rows processed by single thread, template parameter
        integer(int32),   intent(in)  :: padding          !! Padding to avoid shared memory bank conflicts, template parameter
        character(c_char),  allocatable :: expression(:)  !! Resulting name expression
        character(len=:),   allocatable :: str  !! Temporary string

        allocate (str, source=basic_name//"<"//to_str(tile_dim)//","//to_str(block_rows)//","//to_str(padding)//">"//c_null_char)
        call astring_f2c(str, expression)
        deallocate (str)
    end function get_name_expression

    subroutine set_name_expression(prog, basic_name, tile_dim, block_rows, padding)
    !! Sets name expression for given template parameters to nvRTC program
        type(nvrtcProgram), intent(in)  :: prog         !! nvRTC program
        character(len=*),   intent(in)  :: basic_name   !! Basic kernel name
        integer(int32),     intent(in)  :: tile_dim     !! Size of shared memory tile, template parameter
        integer(int32),     intent(in)  :: block_rows   !! Number of rows processed by single thread, template parameter
        integer(int32),     intent(in)  :: padding      !! Padding to avoid shared memory bank conflicts, template parameter
        character(c_char), allocatable  :: expression(:)!! Name expression

        expression = get_name_expression(basic_name, tile_dim, block_rows, padding)
        NVRTC_CALL( nvrtcAddNameExpression(prog, expression) )
        deallocate (expression)
    end subroutine set_name_expression

    function get_mangled_name(basic_name, prog, tile_dim, block_rows, padding) result(mangled)
    !! Gets mangled name for given template parameters from nvRTC program
        character(len=*),   intent(in)  :: basic_name   !! Basic kernel name
        type(nvrtcProgram), intent(in)  :: prog         !! nvRTC program
        integer(int32),     intent(in)  :: tile_dim     !! Size of shared memory tile, template parameter
        integer(int32),     intent(in)  :: block_rows   !! Number of rows processed by single thread, template parameter
        integer(int32),     intent(in)  :: padding      !! Padding to avoid shared memory bank conflicts, template parameter
        type(c_ptr)                     :: mangled      !! Mangled kernel name
        character(c_char), allocatable  :: expression(:)!! Name expression

        expression = get_name_expression(basic_name, tile_dim, block_rows, padding)
        NVRTC_CALL( nvrtcGetLoweredName(prog, expression, mangled) )
        deallocate (expression)
    end function get_mangled_name

    function get_code(kernel_name, ndims, base_storage, kernel_type) result(code)
    !! Generates code that will be used to locally tranpose data and prepares to send it to other processes
        character(len=*),     intent(in)  :: kernel_name  !! Name of CUDA kernel
        integer(int32),       intent(in)  :: ndims        !! Number of dimensions
        integer(int64),       intent(in)  :: base_storage !! Number of bytes needed to store single element
        type(kernel_type_t),  intent(in)  :: kernel_type  !! Type of kernel to generate code for
        type(codegen_t)                   :: code          !! Resulting code
        character(len=:), allocatable     :: buffer_type      !! Type of buffer that should be used
        character(len=2)  :: temp       !! Temporary string
        logical           :: is_packer  !! Is this pack/unpack kernel

        select case (base_storage)
        case (FLOAT_STORAGE_SIZE)
            allocate (buffer_type, source="float")
        case (DOUBLE_STORAGE_SIZE)
            allocate (buffer_type, source="double")
        case (DOUBLE_COMPLEX_STORAGE_SIZE)
            allocate (buffer_type, source="double2")
        case default
            INTERNAL_ERROR("get_code: unknown `base_storage`")
        end select

        is_packer = is_unpack_kernel(kernel_type) .or. is_pack_kernel(kernel_type)

        if (kernel_type == KERNEL_PERMUTE_FORWARD .or. kernel_type == KERNEL_PACK_FORWARD) then
            temp = "ny"
        else
            temp = "nz"
        end if

        call code%add("template <int TILE_DIM, int BLOCK_ROWS, int PADDING>")
        call code%add('__global__ void')
        call code%add(kernel_name)
        call code%add("(")
        call code%add("   "//buffer_type//" * __restrict__ out")
        call code%add("    ,const "//buffer_type//" * __restrict__ in")
        call code%add("    ,const int nx")
        call code%add("    ,const int ny")
        call code%add("    ,const int nz")
        if (is_packer) then
            call code%add("   ,const int nxx")
            call code%add("   ,const int nyy")
            call code%add("   ,const int nzz")
            call code%add("   ,const int din")
            call code%add("   ,const int dout")
        end if
        call code%add(")")
        call code%add("{")
        call code%add("    __shared__ "//buffer_type//" tile[TILE_DIM][TILE_DIM + PADDING];")
        call code%add("    const int x_in = threadIdx.x + TILE_DIM * blockIdx.x;")
        call code%add("    const int y_in = threadIdx.y + TILE_DIM * blockIdx.y;")
        call code%add("    const int z = blockIdx.z;")
        if (is_transpose_kernel(kernel_type)) then
            call code%add("    const int x_out = threadIdx.y + TILE_DIM * blockIdx.x;")
            call code%add("    const int y_out = threadIdx.x + TILE_DIM * blockIdx.y;")
        end if
        if (ndims == 2 .and. .not. is_packer) then
            call code%add("    const int ibase = x_in;")
            call code%add("    const int obase = y_out;")
        else
            select case (kernel_type%val)
            case (KERNEL_PERMUTE_FORWARD%val)
                call code%add("    const int ibase = x_in + z * ny * nx;")
                call code%add("    const int obase = y_out + z * ny;")
            case (KERNEL_PACK_FORWARD%val)
                call code%add("    const int ibase = din + x_in + z * ny * nx;")
                call code%add("    const int obase = dout + y_out + z * nyy;")
            case (KERNEL_PERMUTE_BACKWARD%val)
                call code%add("    const int ibase = x_in + z * nx;")
                call code%add("    const int obase = y_out + z * nx * nz;")
            case (KERNEL_PACK_BACKWARD%val)
                call code%add("    const int ibase = din + x_in + z * nx;")
                call code%add("    const int obase = dout + y_out + z * nxx * nzz;")
            case (KERNEL_PERMUTE_BACKWARD_START%val)
                call code%add("    const int ibase = x_in + z * nx;")
                call code%add("    const int obase = y_out + z * nz;")
            case (KERNEL_PERMUTE_BACKWARD_END_PIPELINED%val)
                call code%add("    const int ibase = din + x_in + z * nxx;")
                call code%add("    const int obase = dout + x_in + z * nx * ny;")
            case (KERNEL_UNPACK_PIPELINED%val)
                call code%add("    const int ibase = din + x_in + z * nxx * nyy;")
                call code%add("    const int obase = dout + x_in + z * nx * ny;")
            case (KERNEL_PACK_PIPELINED%val)
                call code%add("    const int ibase = din + x_in + z * nx * ny;")
                call code%add("    const int obase = dout + x_in + z * nxx * nyy;")
            end select
        end if
        call code%add("    #pragma unroll")
        call code%add("    for(int offset = 0; offset < TILE_DIM; offset+=BLOCK_ROWS) {")
        call code%add("        int y = y_in + offset;")
        if ( is_packer .and.  is_transpose_kernel(kernel_type)) then
            call code%add("        if( x_in < nxx && y < "//temp//temp(2:2)//" ) {")
        else if (is_packer) then
            call code%add("        if( x_in < nxx && y < nyy) {")
        else
            call code%add("        if( x_in < nx && y < "//temp//") {")
        end if
        select case (kernel_type%val)
        case (KERNEL_PERMUTE_FORWARD%val, KERNEL_PACK_PIPELINED%val, KERNEL_PACK_FORWARD%val)
            call code%add("            int iidx = ibase + y * nx;")
        case (KERNEL_PERMUTE_BACKWARD_END_PIPELINED%val)
            call code%add("            int iidx = ibase + y * nxx * nzz;")
        case (KERNEL_UNPACK_PIPELINED%val)
            call code%add("            int iidx = ibase + y * nxx;")
        case default
            call code%add("            int iidx = ibase + y * nx * ny;")
        end select
        call code%add("            tile[threadIdx.x][threadIdx.y + offset] = in[iidx];")
        call code%add("        }")
        call code%add("    }")
        call code%add("    __syncthreads();")
        call code%add("    #pragma unroll")
        call code%add("    for(int offset = 0; offset < TILE_DIM; offset+=BLOCK_ROWS) {")
        if ( is_packer .and. is_transpose_kernel(kernel_type) ) then
            call code%add("      int x = x_out + offset;")
            call code%add("      if( x < nxx && y_out < "//temp//temp(2:2)//" ) {")
        else if (is_packer) then
            call code%add("      int y = y_in + offset;")
            call code%add("      if( x_in < nxx && y < nyy ) {")
        else
            call code%add("      int x = x_out + offset;")
            call code%add("      if( x < nx && y_out < "//temp//" ) {")
        end if
        if (ndims == 2 .and. .not. is_packer) then
            call code%add("        int oidx = obase + x * ny;")
        else
            if (any(kernel_type == [KERNEL_PERMUTE_FORWARD, KERNEL_PERMUTE_BACKWARD_START])) then
                call code%add("        int oidx = obase + x * ny * nz;")
            else if ( kernel_type == KERNEL_PACK_FORWARD ) then
                call code%add("        int oidx = obase + x * nyy * nzz;")
            else if (is_unpack_kernel(kernel_type)) then
                call code%add("        int oidx = obase + y * nx;")
            else if (kernel_type == KERNEL_PACK_PIPELINED) then
                call code%add("        int oidx = obase + y * nxx;")
            else if ( kernel_type == KERNEL_PACK_BACKWARD ) then
                call code%add("        int oidx = obase + x * nzz;")
            else
                call code%add("        int oidx = obase + x * nz;")
            end if
        end if
        if (is_packer .and. .not.is_transpose_kernel(kernel_type)) then
            call code%add("        out[oidx] = tile[threadIdx.x][threadIdx.y + offset];")
        else
            call code%add("        out[oidx] = tile[threadIdx.y + offset][threadIdx.x];")
        end if
        call code%add("      }")
        call code%add("    }")
        call code%add("}")
        deallocate (buffer_type)
    end function get_code
end module dtfft_nvrtc_module

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_config
!! Configuration module for dtFFT.
!! It handles both runtime (environment variables) and compile-time ([[dtfft_config_t]]) configurations.
use iso_c_binding, only: c_bool, c_int32_t
use iso_fortran_env
#ifdef DTFFT_WITH_COMPRESSION
use dtfft_abstract_compressor
#endif
use dtfft_errors
use dtfft_parameters
use dtfft_utils
#ifdef DTFFT_WITH_CUDA
use dtfft_interface_cuda_runtime
#endif
#include "_dtfft_cuda.h"
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
implicit none
private
public :: init_internal
public :: dtfft_config_t
public :: string
public :: dtfft_create_config, dtfft_set_config
public :: get_conf_log_enabled, get_conf_z_slab_enabled, get_conf_y_slab_enabled
public :: get_conf_platform
public :: get_conf_measure_warmup_iters, get_conf_measure_iters
public :: get_conf_backend, get_conf_reshape_backend
public :: get_conf_datatype_enabled, get_conf_mpi_enabled, get_conf_pipelined_enabled
#ifdef DTFFT_WITH_CUDA
public :: destroy_stream
public :: get_conf_stream
public :: get_conf_nvshmem_enabled, get_conf_nccl_enabled
#endif
public :: get_conf_kernel_autotune_enabled
public :: get_conf_fourier_reshape_enabled
public :: get_conf_rma_enabled, get_conf_fused_enabled
public :: get_conf_transpose_mode, get_conf_access_mode
public :: get_conf_compression_enabled
public :: get_correct_backend
#ifdef DTFFT_WITH_COMPRESSION
public :: get_conf_transpose, get_conf_reshape
#endif

    logical,                    protected  :: is_init_called = .false.
        !! Has [[init_internal]] already been called or not
    integer(int32),             protected  :: log_enabled_from_env = VARIABLE_NOT_SET
        !! Should we log messages to stdout or not
    type(dtfft_platform_t),     protected  :: platform_from_env = PLATFORM_NOT_SET
        !! Platform obtained from environ
    integer(int32),             protected  :: z_slab_from_env = VARIABLE_NOT_SET
        !! Should Z-slab be used if possible
    integer(int32),             protected  :: y_slab_from_env = VARIABLE_NOT_SET
        !! Should Y-slab be used if possible
    integer(int32),             protected  :: n_measure_warmup_iters_from_env = VARIABLE_NOT_SET
        !! Number of warmup iterations for measurements
    integer(int32),             protected  :: n_measure_iters_from_env = VARIABLE_NOT_SET
        !! Number of measurement iterations
    logical,                    protected  :: is_log_enabled = .false.
        !! Should we print additional information during plan creation
    logical,                    protected  :: is_z_slab_enabled = .true.
        !! Should we use Z-slab optimization or not
    logical,                    protected  :: is_y_slab_enabled = .false.
        !! Should we use Y-slab optimization or not
    type(dtfft_platform_t),     protected  :: platform = DTFFT_PLATFORM_HOST
        !! Default platform
    integer(int32),             protected  :: n_measure_warmup_iters = CONF_DTFFT_MEASURE_WARMUP_ITERS
        !! Number of warmup iterations for measurements
    integer(int32),             protected  :: n_measure_iters = CONF_DTFFT_MEASURE_ITERS
        !! Number of measurement iterations

    type(dtfft_backend_t),      protected  :: backend_from_env = DTFFT_BACKEND_NONE
        !! Backend obtained from environ
    type(dtfft_backend_t),      protected  :: reshape_backend_from_env = DTFFT_BACKEND_NONE
        !! Reshape backend obtained from environ
    integer(int32),             protected  :: datatype_enabled_from_env = VARIABLE_NOT_SET
        !! Should we use MPI Datatype backend during autotune or not
    integer(int32),             protected  :: mpi_enabled_from_env = VARIABLE_NOT_SET
        !! Should we use MPI backends during autotune or not
    integer(int32),             protected  :: pipelined_enabled_from_env = VARIABLE_NOT_SET
        !! Should we use pipelined backends during autotune or not
    integer(int32),             protected  :: kernel_autotune_enabled_from_env = VARIABLE_NOT_SET
        !! Should we enable kernel autotune or not
    integer(int32),             protected  :: fourier_reshape_enabled_from_env = VARIABLE_NOT_SET
        !! Should we enable fourier space reshape or not
#ifdef DTFFT_WITH_RMA
    integer(int32),             protected  :: rma_enabled_from_env = VARIABLE_NOT_SET
        !! Should we use RMA backends during autotune or not
#endif
    integer(int32),             protected  :: fused_enabled_from_env = VARIABLE_NOT_SET
        !! Should we use fused backends during autotune or not
    type(dtfft_transpose_mode_t), protected :: transpose_mode_from_env = TRANSPOSE_MODE_NOT_SET
        !! Transpose mode obtained from environ
    type(dtfft_access_mode_t),    protected :: access_mode_from_env = ACCESS_MODE_NOT_SET
        !! Access mode obtained from environ

#ifdef DTFFT_WITH_COMPRESSION
    integer(int32),               protected :: compression_enabled_from_env = VARIABLE_NOT_SET
        !! Should we use compressed backends during autotune or not
#endif

#ifdef DTFFT_WITH_CUDA
    integer(int32),             protected  :: nccl_enabled_from_env = VARIABLE_NOT_SET
        !! Should we use NCCL backends during autotune or not
    integer(int32),             protected  :: nvshmem_enabled_from_env = VARIABLE_NOT_SET
        !! Should we use NVSHMEM backends during autotune or not
    type(dtfft_backend_t),  parameter :: DEFAULT_BACKEND = DTFFT_BACKEND_NONE
        !! Default backend when cuda is enabled
    type(dtfft_stream_t),       protected  :: main_stream = NULL_STREAM
        !! Default dtFFT CUDA stream
    type(dtfft_stream_t),       protected  :: custom_stream = NULL_STREAM
        !! CUDA stream set by the user
    logical,                    protected  :: is_stream_created = .false.
        !! Is the default stream created?
    logical,                    protected  :: is_custom_stream = .false.
        !! Is the custom stream provided by the user?
#else
    type(dtfft_backend_t),  parameter :: DEFAULT_BACKEND = DTFFT_BACKEND_MPI_DATATYPE
        !! Default host backend
#endif
    logical,                    protected  :: is_datatype_enabled = .true.
        !! Should we use MPI Datatype backend or not
    logical,                    protected  :: is_pipelined_enabled = .true.
        !! Should we use pipelined backends or not
    logical,                    protected  :: is_mpi_enabled = .false.
        !! Should we use MPI backends or not
#ifdef DTFFT_WITH_CUDA
    logical,                    protected  :: is_nccl_enabled = .true.
        !! Should we use NCCL backends or not
    logical,                    protected  :: is_nvshmem_enabled = .true.
        !! Should we use NCCL backends or not
#endif
    logical,                    protected  :: is_kernel_autotune_enabled = .false.
        !! Should we use kernel autotune or not
    logical,                    protected  :: is_fourier_reshape_enabled = .false.
        !! Should we use reshape in fourier space or not
    logical,                    protected  :: is_rma_enabled = .true.
        !! Should we use RMA backends or not
    logical,                    protected  :: is_fused_enabled = .true.
        !! Should we use fused backends or not
    type(dtfft_backend_t),      protected  :: backend = DEFAULT_BACKEND
        !! Default backend
    type(dtfft_backend_t),      protected  :: reshape_backend = DEFAULT_BACKEND
        !! Default reshape backend
    type(dtfft_transpose_mode_t), protected :: transpose_mode = DTFFT_TRANSPOSE_MODE_PACK
        !! Default transpose mode
    type(dtfft_access_mode_t),    protected :: access_mode = DTFFT_ACCESS_MODE_WRITE
        !! Default access mode

#ifdef DTFFT_WITH_COMPRESSION
    logical,                          protected :: is_compression_enabled = .false.
        !! Should we use compressed backends or not during autotuning
    type(dtfft_compression_config_t), protected :: config_transpose = DEFAULT_COMPRESSION_CONFIG
        !! Configuration for compression during transpositions
    type(dtfft_compression_config_t), protected :: config_reshape = DEFAULT_COMPRESSION_CONFIG
        !! Configuration for compression during reshape operations
#endif

    type, bind(C) :: dtfft_config_t
    !! Type that can be used to set additional configuration parameters to ``dtFFT``
        logical(c_bool)           :: enable_log
        !! Should dtFFT print additional information during plan creation or not.
        !!
        !! Default is false.
        logical(c_bool)           :: enable_z_slab
        !! Should dtFFT use Z-slab optimization or not.
        !!
        !! Default is true.
        !!
        !! One should consider disabling Z-slab optimization in order to resolve `DTFFT_ERROR_VKFFT_R2R_2D_PLAN` error
        !! OR when underlying FFT implementation of 2D plan is too slow.
        !! In all other cases it is considered that Z-slab is always faster, since it reduces number of data transpositions.
        logical(c_bool)           :: enable_y_slab
        !! Should dtFFT use Y-slab optimization or not.
        !!
        !! Default is false.
        !!
        !! One should consider disabling Y-slab optimization in order to resolve `DTFFT_ERROR_VKFFT_R2R_2D_PLAN` error
        !! OR when underlying FFT implementation of 2D plan is too slow.
        !! In all other cases it is considered that Y-slab is always faster, since it reduces number of data transpositions.
        integer(c_int32_t)        :: n_measure_warmup_iters
        !! Number of warmup iterations to execute during backend and kernel autotuning when effort level is `DTFFT_MEASURE` or higher.
        !!
        !! Default is 2.
        integer(c_int32_t)        :: n_measure_iters
        !! Number of iterations to execute during backend and kernel autotuning when effort level is `DTFFT_MEASURE` or higher.
        !!
        !! Default is 5.
#ifdef DTFFT_WITH_CUDA
        type(dtfft_platform_t)    :: platform
        !! Selects platform to execute plan.
        !!
        !! Default is `DTFFT_PLATFORM_HOST`.
        !!
        !! This option is only available when dtFFT is built with device support.
        !! Even when dtFFT is built with device support, it does not necessarily mean that all plans must be device-related.
        !! This enables a single library installation to support both host and CUDA plans.

        type(dtfft_stream_t)      :: stream
        !! Main CUDA stream that will be used in dtFFT.
        !!
        !! This parameter is a placeholder for user to set custom stream.
        !!
        !! Stream that is actually used by dtFFT plan is returned by `plan%get_stream` function.
        !!
        !! When user sets stream he is responsible of destroying it.
        !!
        !! Stream must not be destroyed before call to `plan%destroy`.
#endif
        type(dtfft_backend_t)     :: backend
        !! Backend that will be used by dtFFT when `effort` is `DTFFT_ESTIMATE` or `DTFFT_MEASURE`.
        !!
        !! Default for HOST platform is `DTFFT_BACKEND_MPI_DATATYPE`.
        !!
        !! Default for CUDA platform is `DTFFT_BACKEND_NCCL` if NCCL is enabled, otherwise `DTFFT_BACKEND_MPI_P2P`.

        type(dtfft_backend_t)     :: reshape_backend
        !! Backend that will be used by dtFFT for data reshaping from bricks to pencils and vice versa when `effort` is `DTFFT_ESTIMATE` or `DTFFT_MEASURE`.
        !!
        !! Default for HOST platform is `DTFFT_BACKEND_MPI_DATATYPE`.
        !!
        !! Default for CUDA platform is `DTFFT_BACKEND_NCCL` if NCCL is enabled, otherwise `DTFFT_BACKEND_MPI_P2P`.

        logical(c_bool)           :: enable_datatype_backend
        !! Should `DTFFT_BACKEND_MPI_DATATYPE` be considered for autotuning when `effort` is `DTFFT_PATIENT` or `DTFFT_EXHAUSTIVE`.
        !!
        !! Default is true.
        !!
        !! This option only works when `platform` is `DTFFT_PLATFORM_HOST`.
        !! When `platform` is `DTFFT_PLATFORM_CUDA`, `DTFFT_BACKEND_MPI_DATATYPE` is always disabled during autotuning.

        logical(c_bool)           :: enable_mpi_backends
        !! Should MPI Backends be enabled when `effort` is `DTFFT_PATIENT` or `DTFFT_EXHAUSTIVE`.
        !!
        !! Default is false.
        !!
        !! The following applies only to CUDA builds.
        !! MPI Backends are disabled by default during autotuning process due to OpenMPI Bug https://github.com/open-mpi/ompi/issues/12849
        !! It was noticed that during plan autotuning GPU memory not being freed completely.
        !! For example:
        !! 1024x1024x512 C2C, double precision, single GPU, using Z-slab optimization, with MPI backends enabled, plan autotuning will leak 8Gb GPU memory.
        !! Without Z-slab optimization, running on 4 GPUs, will leak 24Gb on each of the GPUs.
        !!
        !! One of the workarounds is to disable MPI Backends by default, which is done here.
        !!
        !! Other is to pass "--mca btl_smcuda_use_cuda_ipc 0" to `mpiexec`,
        !! but it was noticed that disabling CUDA IPC seriously affects overall performance of MPI algorithms

        logical(c_bool)           :: enable_pipelined_backends
        !! Should pipelined backends be enabled when `effort` is `DTFFT_PATIENT` or `DTFFT_EXHAUSTIVE`.
        !!
        !! Default is true.
        logical(c_bool)           :: enable_rma_backends
        !! Should RMA backends be enabled when `effort` is `DTFFT_PATIENT` or `DTFFT_EXHAUSTIVE`.
        !!
        !! Default is true.
        logical(c_bool)           :: enable_fused_backends
        !! Should fused backends be enabled when `effort` is `DTFFT_PATIENT` or `DTFFT_EXHAUSTIVE`.
        !!
        !! Default is true.
#ifdef DTFFT_WITH_CUDA
        logical(c_bool)           :: enable_nccl_backends
        !! Should NCCL Backends be enabled when `effort` is `DTFFT_PATIENT` or `DTFFT_EXHAUSTIVE`.
        !!
        !! Default is true.
        !!
        !! This option is only defined when dtFFT is built with CUDA support.

        logical(c_bool)           :: enable_nvshmem_backends
        !! Should NVSHMEM Backends be enabled when `effort` is `DTFFT_PATIENT` or `DTFFT_EXHAUSTIVE`.
        !!
        !! Default is true.
        !!
        !! This option is only defined when dtFFT is built with CUDA support.
#endif
        logical(c_bool)            :: enable_kernel_autotune
        !! Should dtFFT try to optimize kernel launch parameters during plan creation when `effort` is below `DTFFT_EXHAUSTIVE`.
        !!
        !! Default is false.
        !!
        !! Kernel optimization is always enabled for `DTFFT_EXHAUSTIVE` effort level.
        !! Setting this option to true enables kernel optimization for lower effort levels (`DTFFT_ESTIMATE`, `DTFFT_MEASURE`, `DTFFT_PATIENT`).
        !! This may increase plan creation time but can improve runtime performance.
        !! Since kernel optimization is performed without data transfers, the time increase is usually minimal.

        logical(c_bool)             :: enable_fourier_reshape
        !! Should dtFFT execute reshapes from pencils to bricks and vice versa in Fourier space during calls to `execute`.
        !!
        !! Default is false.
        !!
        !! When enabled, data will be in brick layout in Fourier space, which may be useful for certain operations
        !! between forward and backward transforms. However, this requires additional data transpositions
        !! and will reduce overall FFT performance.

        type(dtfft_transpose_mode_t) :: transpose_mode
        !! Specifies at which stage the local transposition is performed during global exchange.
        !!
        !! Default is `DTFFT_TRANSPOSE_MODE_PACK`.
        !!
        !! It affects only Generic backends that perform explicit packing/unpacking.
        !! This option only takes effect when `effort` is less than `DTFFT_EXHAUSTIVE`.
        !!
        !! For `DTFFT_EXHAUSTIVE` effort level, dtFFT will always choose the best transpose mode based on internal benchmarking.

        type(dtfft_access_mode_t) :: access_mode
        !! Specifies the memory access pattern (optimization target) for local transposition.
        !!
        !! Default is `DTFFT_ACCESS_MODE_WRITE`.
        !!
        !! This setting applies only to Host (CPU) Generic backends.
        !!
        !! This option allows user to force specific access mode (`DTFFT_ACCESS_MODE_WRITE` or `DTFFT_ACCESS_MODE_READ`) when autotuning is disabled.
        !! When autotuning is enabled (e.g. `effort` is `DTFFT_EXHAUSTIVE`), this option is ignored and best access mode is selected automatically.
#ifdef DTFFT_WITH_COMPRESSION
        logical(c_bool)           :: enable_compressed_backends
        !! Should compressed backends be enabled when `effort` is `DTFFT_PATIENT` or `DTFFT_EXHAUSTIVE`.
        !!
        !! Default is false.
        !!
        !! Only fixed-rate compression can be used during autotuning, since it provides predictable performance characteristics and does not require data-dependent decisions at runtime.
        !! To enable compressed backends during autotuning, set this option to true, set compression type to `DTFFT_COMPRESSION_MODE_FIXED_RATE` and provide desired compression rate.

        type(dtfft_compression_config_t)  :: compression_config_transpose
        !! Options for compression approach during transpositions

        type(dtfft_compression_config_t)  :: compression_config_reshape
        !! Options for compression approach during reshape operations
#endif
    end type dtfft_config_t

    interface dtfft_config_t
    !! Interface to create a new configuration
        module procedure config_constructor !! Default constructor
    end interface dtfft_config_t


    interface get_conf_internal
    !! Returns value from configuration unless environment variable is set
        module procedure get_conf_internal_logical  !! For logical values
        module procedure get_conf_internal_int32    !! For integer(int32) values
    end interface get_conf_internal

contains

  integer(int32) function init_internal()
  !! Checks if MPI is initialized and loads environment variables
    integer(int32)    :: ierr             !! Error code
    logical           :: is_mpi_init      !! Is MPI initialized?

    init_internal = DTFFT_SUCCESS

    call MPI_Initialized(is_mpi_init, ierr)
    if( .not. is_mpi_init ) then
      init_internal = DTFFT_ERROR_MPI_FINALIZED
      return
    endif
    ! Processing environment variables once
    if ( is_init_called ) return

    call init_environment()

#if defined(DTFFT_WITH_CUDA) && defined(DTFFT_WITH_MOCK_ENABLED)
    if ( get_conf_platform() == DTFFT_PLATFORM_CUDA ) then
      WRITE_WARN("This is mock version of CUDA platform")
    endif
#endif
    is_init_called = .true.
  end function init_internal

  subroutine init_environment()

    log_enabled_from_env = get_env("ENABLE_LOG", VARIABLE_NOT_SET, valid_values=[0, 1])
    z_slab_from_env = get_env("ENABLE_Z_SLAB", VARIABLE_NOT_SET, valid_values=[0, 1])
    y_slab_from_env = get_env("ENABLE_Y_SLAB", VARIABLE_NOT_SET, valid_values=[0, 1])

    n_measure_warmup_iters_from_env = get_env("MEASURE_WARMUP_ITERS", VARIABLE_NOT_SET, min_valid_value=0)
    n_measure_iters_from_env = get_env("MEASURE_ITERS", VARIABLE_NOT_SET, min_valid_value=1)

#ifdef DTFFT_WITH_CUDA
    block
      type(string), allocatable :: platforms(:)
      type(string) :: pltfrm_env

      allocate( platforms(2) )
      platforms(1) = string("host")
      platforms(2) = string("cuda")

      pltfrm_env = get_env("PLATFORM", "undefined", platforms)
      if ( pltfrm_env%raw == "undefined") then
        platform_from_env = PLATFORM_NOT_SET
      else if ( pltfrm_env%raw == "host" ) then
        platform_from_env = DTFFT_PLATFORM_HOST
      else if ( pltfrm_env%raw == "cuda") then
        platform_from_env = DTFFT_PLATFORM_CUDA
      endif

      call pltfrm_env%destroy()
      call destroy_strings(platforms)
    endblock
#endif

    backend_from_env = get_backend_from_env("BACKEND")
    reshape_backend_from_env = get_backend_from_env("RESHAPE_BACKEND")

    datatype_enabled_from_env = get_env("ENABLE_MPI_DT", VARIABLE_NOT_SET, valid_values=[0, 1])
    mpi_enabled_from_env = get_env("ENABLE_MPI", VARIABLE_NOT_SET, valid_values=[0, 1])
    pipelined_enabled_from_env = get_env("ENABLE_PIPE", VARIABLE_NOT_SET, valid_values=[0, 1])
#ifdef DTFFT_WITH_RMA
    rma_enabled_from_env = get_env("ENABLE_RMA", VARIABLE_NOT_SET, valid_values=[0, 1])
#endif
    fused_enabled_from_env = get_env("ENABLE_FUSED", VARIABLE_NOT_SET, valid_values=[0, 1])
#ifdef DTFFT_WITH_CUDA
    nccl_enabled_from_env = get_env("ENABLE_NCCL", VARIABLE_NOT_SET, valid_values=[0, 1])
    nvshmem_enabled_from_env = get_env("ENABLE_NVSHMEM", VARIABLE_NOT_SET, valid_values=[0, 1])
#endif
    kernel_autotune_enabled_from_env = get_env("ENABLE_KERNEL_AUTOTUNE", VARIABLE_NOT_SET, valid_values=[0, 1])
    fourier_reshape_enabled_from_env = get_env("ENABLE_FOURIER_RESHAPE", VARIABLE_NOT_SET, valid_values=[0, 1])
#ifdef DTFFT_WITH_COMPRESSION
    compression_enabled_from_env = get_env("ENABLE_COMPRESSED", VARIABLE_NOT_SET, valid_values=[0, 1])
#endif

    block
      type(string), allocatable :: transpose_modes(:)
      type(string) :: t_mode_env

      allocate( transpose_modes(2) )
      transpose_modes(1) = string("pack")
      transpose_modes(2) = string("unpack")

      t_mode_env = get_env("TRANSPOSE_MODE", "undefined", transpose_modes)
      select case ( t_mode_env%raw )
      case ( "undefined" )
        transpose_mode_from_env = TRANSPOSE_MODE_NOT_SET
      case ( "pack" )
        transpose_mode_from_env = DTFFT_TRANSPOSE_MODE_PACK
      case ( "unpack" )
        transpose_mode_from_env = DTFFT_TRANSPOSE_MODE_UNPACK
      endselect

      call t_mode_env%destroy()
      call destroy_strings(transpose_modes)
    endblock

    block
      type(string), allocatable :: access_modes(:)
      type(string) :: access_mode_env

      allocate( access_modes(2) )
      access_modes(1) = string("write")
      access_modes(2) = string("read")

      access_mode_env = get_env("ACCESS_MODE", "undefined", access_modes)
      select case ( access_mode_env%raw )
      case ( "undefined" )
        access_mode_from_env = ACCESS_MODE_NOT_SET
      case ( "write" )
        access_mode_from_env = DTFFT_ACCESS_MODE_WRITE
      case ( "read" )
        access_mode_from_env = DTFFT_ACCESS_MODE_READ
      endselect

      call access_mode_env%destroy()
      call destroy_strings(access_modes)
    endblock
  end subroutine init_environment

  type(dtfft_backend_t) function get_backend_from_env(name)
  !! Returns backend or reshape backend obtained from environment variable
    character(len=*), intent(in) :: name !! Name of the environment variable
    type(string), allocatable :: backends(:)
    type(string) :: bcknd_env

      allocate( backends(17) )
      backends(1) = string("mpi_dt")
      backends(2) = string("mpi_p2p")
      backends(3) = string("mpi_a2a")
      backends(4) = string("mpi_p2p_pipe")
      backends(5) = string("nccl")
      backends(6) = string("nccl_pipe")
      backends(7) = string("cufftmp")
      backends(8) = string("cufftmp_pipe")
      backends(9) = string("mpi_rma")
      backends(10) = string("mpi_rma_pipe")
      backends(11) = string("mpi_p2p_sched")
      backends(12) = string("mpi_p2p_fused")
      backends(13) = string("mpi_p2p_compressed")
      backends(14) = string("mpi_rma_fused")
      backends(15) = string("mpi_rma_compressed")
      backends(16) = string("nccl_compressed")
      backends(17) = string("adaptive")

      bcknd_env = get_env(name, "undefined", backends)

      select case ( bcknd_env%raw )
      case ( "undefined" )
        get_backend_from_env = DTFFT_BACKEND_NONE
      case ( "mpi_dt" )
        get_backend_from_env = DTFFT_BACKEND_MPI_DATATYPE
      case ( "mpi_p2p" )
        get_backend_from_env = DTFFT_BACKEND_MPI_P2P
      case ( "mpi_a2a" )
        get_backend_from_env = DTFFT_BACKEND_MPI_A2A
      case ( "mpi_p2p_pipe" )
        get_backend_from_env = DTFFT_BACKEND_MPI_P2P_PIPELINED
      case ( "nccl" )
        get_backend_from_env = DTFFT_BACKEND_NCCL
      case ( "nccl_pipe" )
        get_backend_from_env = DTFFT_BACKEND_NCCL_PIPELINED
      case ( "cufftmp" )
        get_backend_from_env = DTFFT_BACKEND_CUFFTMP
      case ( "cufftmp_pipe")
        get_backend_from_env = DTFFT_BACKEND_CUFFTMP_PIPELINED
      case ( "mpi_rma" )
        get_backend_from_env = DTFFT_BACKEND_MPI_RMA
      case ( "mpi_rma_pipe" )
        get_backend_from_env = DTFFT_BACKEND_MPI_RMA_PIPELINED
      case ( "mpi_p2p_sched" )
        get_backend_from_env = DTFFT_BACKEND_MPI_P2P_SCHEDULED
      case ( "mpi_p2p_fused" )
        get_backend_from_env = DTFFT_BACKEND_MPI_P2P_FUSED
      case ( "mpi_p2p_compressed" )
        get_backend_from_env = DTFFT_BACKEND_MPI_P2P_COMPRESSED
      case ( "mpi_rma_fused" )
        get_backend_from_env = DTFFT_BACKEND_MPI_RMA_FUSED
      case ( "mpi_rma_compressed" )
        get_backend_from_env = DTFFT_BACKEND_MPI_RMA_COMPRESSED
      case ( "nccl_compressed" )
        get_backend_from_env = DTFFT_BACKEND_NCCL_COMPRESSED
      case ( "adaptive" )
        get_backend_from_env = DTFFT_BACKEND_ADAPTIVE
      endselect

      if ( get_backend_from_env /= DTFFT_BACKEND_NONE .and. .not.is_valid_backend(get_backend_from_env) ) then
        WRITE_ERROR("Backend '"//bcknd_env%raw//"' is not available in this build.")
        WRITE_ERROR("Environment variable 'DTFFT_"//name//"' has been ignored")
        get_backend_from_env = DTFFT_BACKEND_NONE
      endif

      call bcknd_env%destroy()
      call destroy_strings(backends)
  end function get_backend_from_env

  pure subroutine dtfft_create_config(config) bind(C, name="dtfft_create_config_c")
  !! Creates a new configuration and sets default values.
  !!
  !! C interface
    type(dtfft_config_t), intent(out) :: config !! Configuration to create
    config = dtfft_config_t()
  end subroutine dtfft_create_config

  pure function config_constructor(                                       &
    enable_log, enable_z_slab, enable_y_slab,                             &
    n_measure_warmup_iters, n_measure_iters,                              &
#ifdef DTFFT_WITH_CUDA
    platform, stream,                                                     &
#endif
    backend, reshape_backend, enable_datatype_backend,                    &
    enable_mpi_backends, enable_pipelined_backends,                       &
    enable_rma_backends, enable_fused_backends,                           &
#ifdef DTFFT_WITH_CUDA
    enable_nccl_backends, enable_nvshmem_backends,                        &
#endif
    enable_kernel_autotune, enable_fourier_reshape,                       &
    transpose_mode, access_mode                                           &
#ifdef DTFFT_WITH_COMPRESSION
    ,enable_compressed_backends                                           &
    ,compression_config_transpose, compression_config_reshape             &
#endif
  ) result(config)
  !! Creates a new configuration
    logical,                optional, intent(in)  :: enable_log
      !! Should dtFFT print additional information during plan creation or not.
    logical,                optional, intent(in)  :: enable_z_slab
      !! Should dtFFT use Z-slab optimization or not.
    logical,                optional, intent(in)  :: enable_y_slab
      !! Should dtFFT use Y-slab optimization or not.
    integer(int32),         optional, intent(in)  :: n_measure_warmup_iters
      !! Number of warmup iterations for measurements
    integer(int32),         optional, intent(in)  :: n_measure_iters
      !! Number of measurement iterations
#ifdef DTFFT_WITH_CUDA
    type(dtfft_platform_t), optional, intent(in)  :: platform
      !! Selects platform to execute plan.
    type(dtfft_stream_t),   optional, intent(in)  :: stream
      !! Main CUDA stream that will be used in dtFFT.
#endif
    type(dtfft_backend_t),  optional, intent(in)  :: backend
      !! Backend that will be used by dtFFT when `effort` is `DTFFT_ESTIMATE` or `DTFFT_MEASURE`.
    type(dtfft_backend_t),  optional, intent(in)  :: reshape_backend
      !! Backend that will be used by dtFFT for data reshaping from bricks to pencils and vice versa when `effort` is `DTFFT_ESTIMATE` or `DTFFT_MEASURE`.
    logical,                optional, intent(in)  :: enable_datatype_backend
      !! Should `DTFFT_BACKEND_MPI_DATATYPE` be enabled when `effort` is `DTFFT_PATIENT` or not.
    logical,                optional, intent(in)  :: enable_mpi_backends
      !! Should MPI Backends be enabled when `effort` is `DTFFT_PATIENT` or not.
    logical,                optional, intent(in)  :: enable_pipelined_backends
      !! Should pipelined backends be enabled when `effort` is `DTFFT_PATIENT` or not.
    logical,                optional, intent(in)  :: enable_rma_backends
      !! Should RMA backends be enabled when `effort` is `DTFFT_PATIENT` or not.
    logical,                optional, intent(in)  :: enable_fused_backends
      !! Should fused backends be enabled when `effort` is `DTFFT_PATIENT` or not.
#ifdef DTFFT_WITH_CUDA
    logical,                optional, intent(in)  :: enable_nccl_backends
      !! Should NCCL Backends be enabled when `effort` is `DTFFT_PATIENT` or not.
    logical,                optional, intent(in)  :: enable_nvshmem_backends
      !! Should NVSHMEM Backends be enabled when `effort` is `DTFFT_PATIENT` or not.
#endif
    logical,                optional, intent(in)  :: enable_kernel_autotune
      !! Should dtFFT try to autotune transpose/packing/unpacking kernels size during autotune process or not.
    logical,                optional, intent(in)  :: enable_fourier_reshape
      !! Should dtFFT execute reshapes from pencils to bricks and vice versa in Fourier space during calls to `execute` or not.
    type(dtfft_transpose_mode_t), optional, intent(in) :: transpose_mode
      !! Specifies at which stage the local transposition is performed during global exchange.
    type(dtfft_access_mode_t),    optional, intent(in) :: access_mode
      !! Specifies the memory access pattern (optimization target) for local transposition in Generic backends.
#ifdef DTFFT_WITH_COMPRESSION
    logical,                          optional, intent(in)  :: enable_compressed_backends
      !! Should compressed backends be enabled when `effort` is `DTFFT_PATIENT` or `DTFFT_EXHAUSTIVE`.
    type(dtfft_compression_config_t), optional, intent(in)  :: compression_config_transpose
      !! Options for compression approach during transpositions
    type(dtfft_compression_config_t), optional, intent(in)  :: compression_config_reshape
      !! Options for compression approach during transpositions
#endif

    type(dtfft_config_t) :: config
      !! Constructed `dtFFT` config ready to be set by call to [[dtfft_set_config]]
    config%enable_log = .false.;                if ( present(enable_log) ) config%enable_log = enable_log
    config%enable_z_slab = .true.;              if ( present(enable_z_slab) ) config%enable_z_slab = enable_z_slab
    config%enable_y_slab = .false.;             if ( present(enable_y_slab) ) config%enable_y_slab = enable_y_slab
    config%n_measure_warmup_iters = CONF_DTFFT_MEASURE_WARMUP_ITERS
      if ( present(n_measure_warmup_iters) ) config%n_measure_warmup_iters = n_measure_warmup_iters
    config%n_measure_iters = CONF_DTFFT_MEASURE_ITERS
      if ( present(n_measure_iters) ) config%n_measure_iters = n_measure_iters
#ifdef DTFFT_WITH_CUDA
    config%platform = DTFFT_PLATFORM_HOST;      if ( present(platform) ) config%platform = platform
    config%stream = NULL_STREAM;                if ( present(stream) ) config%stream = stream
#endif
    config%backend = DEFAULT_BACKEND;           if ( present(backend) ) config%backend = backend
    config%reshape_backend = DEFAULT_BACKEND;   if ( present(reshape_backend) ) config%reshape_backend = reshape_backend
    config%enable_datatype_backend = .true.;    if ( present(enable_datatype_backend) ) config%enable_datatype_backend = enable_datatype_backend
    config%enable_mpi_backends = .false.;       if ( present(enable_mpi_backends) ) config%enable_mpi_backends = enable_mpi_backends
    config%enable_pipelined_backends = .true.;  if ( present(enable_pipelined_backends) ) config%enable_pipelined_backends = enable_pipelined_backends
    config%enable_rma_backends = .true.;        if ( present(enable_rma_backends) ) config%enable_rma_backends = enable_rma_backends
    config%enable_fused_backends = .true.;      if ( present(enable_fused_backends) ) config%enable_fused_backends = enable_fused_backends
#ifdef DTFFT_WITH_CUDA
    config%enable_nccl_backends = .true.;       if ( present(enable_nccl_backends) ) config%enable_nccl_backends = enable_nccl_backends
    config%enable_nvshmem_backends = .true.;    if ( present(enable_nvshmem_backends) ) config%enable_nvshmem_backends = enable_nvshmem_backends
#endif
    config%enable_kernel_autotune = .false.;    if ( present(enable_kernel_autotune) ) config%enable_kernel_autotune = enable_kernel_autotune
    config%enable_fourier_reshape = .false.;    if ( present(enable_fourier_reshape) ) config%enable_fourier_reshape = enable_fourier_reshape
    config%transpose_mode = DTFFT_TRANSPOSE_MODE_PACK; if ( present(transpose_mode) ) config%transpose_mode = transpose_mode
    config%access_mode = DTFFT_ACCESS_MODE_WRITE; if ( present(access_mode) ) config%access_mode = access_mode
#ifdef DTFFT_WITH_COMPRESSION
    config%enable_compressed_backends = .false.;                      if ( present(enable_compressed_backends) ) config%enable_compressed_backends = enable_compressed_backends
    config%compression_config_transpose = DEFAULT_COMPRESSION_CONFIG; if ( present(compression_config_transpose) ) config%compression_config_transpose = compression_config_transpose
    config%compression_config_reshape = DEFAULT_COMPRESSION_CONFIG;   if ( present(compression_config_reshape) ) config%compression_config_reshape = compression_config_reshape
#endif
  end function config_constructor

  subroutine dtfft_set_config(config, error_code)
  !! Sets configuration parameters
    type(dtfft_config_t),     intent(in)  :: config     !! Configuration to set
    integer(int32), optional, intent(out) :: error_code !! Error code
    integer(int32) :: ierr

    ierr = init_internal()
    if ( ierr /=DTFFT_SUCCESS ) then
      if ( present( error_code ) ) error_code = ierr
      return
    endif
    is_log_enabled = config%enable_log
    is_z_slab_enabled = config%enable_z_slab
    is_y_slab_enabled = config%enable_y_slab

    if ( config%n_measure_warmup_iters < 0 ) then
      if ( present( error_code ) ) error_code = DTFFT_ERROR_INVALID_MEASURE_WARMUP_ITERS
      return
    endif
    n_measure_warmup_iters = config%n_measure_warmup_iters
    if ( config%n_measure_iters < 1 ) then
      if ( present( error_code ) ) error_code = DTFFT_ERROR_INVALID_MEASURE_ITERS
      return
    endif
    n_measure_iters = config%n_measure_iters

    is_datatype_enabled = config%enable_datatype_backend
    is_mpi_enabled = config%enable_mpi_backends
    is_pipelined_enabled = config%enable_pipelined_backends
    is_rma_enabled = config%enable_rma_backends
    is_fused_enabled = config%enable_fused_backends

#ifdef DTFFT_WITH_CUDA
    if ( .not.is_null_ptr(config%stream%stream) ) then
      block
        integer(int32) :: ierr

        ierr = cudaStreamQuery(config%stream)
        if ( .not.any(ierr == [cudaSuccess, cudaErrorNotReady]) ) then
          if ( present( error_code ) ) error_code = DTFFT_ERROR_GPU_INVALID_STREAM
          return
        endif
        custom_stream = config%stream
        is_custom_stream = .true.
      endblock
    endif

    if ( .not.is_valid_platform(config%platform) ) then
      if ( present( error_code ) ) error_code = DTFFT_ERROR_INVALID_PLATFORM
      return
    endif
    platform = config%platform

    is_nccl_enabled = config%enable_nccl_backends
    is_nvshmem_enabled = config%enable_nvshmem_backends
#endif

    is_kernel_autotune_enabled = config%enable_kernel_autotune
    is_fourier_reshape_enabled = config%enable_fourier_reshape
    if ( .not. is_valid_transpose_mode(config%transpose_mode) ) then
      if ( present( error_code ) ) error_code = DTFFT_ERROR_INVALID_TRANSPOSE_MODE
      return
    endif
    transpose_mode = config%transpose_mode

    if ( .not. is_valid_access_mode(config%access_mode) ) then
      if ( present( error_code ) ) error_code = DTFFT_ERROR_INVALID_ACCESS_MODE
      return
    endif
    access_mode = config%access_mode

    if ( config%backend /= DTFFT_BACKEND_NONE .and. .not.is_valid_backend(config%backend)) then
      if ( present( error_code ) ) error_code = DTFFT_ERROR_INVALID_BACKEND
      return
    endif
    if ( config%reshape_backend /= DTFFT_BACKEND_NONE .and. .not.is_valid_backend(config%reshape_backend)) then
      if ( present( error_code ) ) error_code = DTFFT_ERROR_INVALID_BACKEND
      return
    endif
    backend = get_correct_backend(config%backend)
    reshape_backend = get_correct_backend(config%reshape_backend)
#ifdef DTFFT_WITH_COMPRESSION
    is_compression_enabled = config%enable_compressed_backends
    config_transpose = config%compression_config_transpose
    config_reshape = config%compression_config_reshape
#endif
    if ( present( error_code ) ) error_code = DTFFT_SUCCESS
  end subroutine dtfft_set_config

  elemental type(dtfft_backend_t) function get_correct_backend(back)
    type(dtfft_backend_t), intent(in) :: back

    if ( back == DTFFT_BACKEND_NONE ) then
#ifdef DTFFT_WITH_CUDA
      if ( get_conf_platform() == DTFFT_PLATFORM_CUDA ) then
# ifdef DTFFT_WITH_NCCL
        get_correct_backend = DTFFT_BACKEND_NCCL
# else
        get_correct_backend = DTFFT_BACKEND_MPI_P2P
# endif
      else
        get_correct_backend = DTFFT_BACKEND_MPI_DATATYPE
      endif
#else
      get_correct_backend = DTFFT_BACKEND_MPI_DATATYPE
#endif
    else
      get_correct_backend = back
    endif
  end function get_correct_backend

  elemental logical function get_conf_internal_logical(from_conf, from_env)
  !! Returns value from configuration unless environment variable is set
    logical,        intent(in) :: from_conf   !! Value from configuration
    integer(int32), intent(in) :: from_env    !! Value from environment variable
    get_conf_internal_logical = from_conf
    if ( from_env /= VARIABLE_NOT_SET ) get_conf_internal_logical = from_env == 1
  end function get_conf_internal_logical

  elemental integer(int32) function get_conf_internal_int32(from_conf, from_env)
  !! Returns value from configuration unless environment variable is set
    integer(int32), intent(in) :: from_conf   !! Value from configuration
    integer(int32), intent(in) :: from_env    !! Value from environment variable
    get_conf_internal_int32 = from_conf
    if ( from_env /= VARIABLE_NOT_SET ) get_conf_internal_int32 = from_env
  end function get_conf_internal_int32

  elemental function get_conf_log_enabled() result(bool)
  !! Whether logging is enabled or not
    logical :: bool   !! Result flag
    bool = get_conf_internal(is_log_enabled, log_enabled_from_env)
  end function get_conf_log_enabled

  elemental function get_conf_z_slab_enabled() result(bool)
  !! Whether Z-slab optimization is enabled or not
    logical :: bool   !! Result flag
    bool = get_conf_internal(is_z_slab_enabled, z_slab_from_env)
  end function get_conf_z_slab_enabled

  elemental function get_conf_y_slab_enabled() result(bool)
  !! Whether Y-slab optimization is enabled or not
    logical :: bool   !! Result flag
    bool = get_conf_internal(is_y_slab_enabled, y_slab_from_env)
  end function get_conf_y_slab_enabled

  elemental function get_conf_measure_warmup_iters() result(iters)
  !! Returns the number of warmup iterations
    integer(int32) :: iters  !! Result
    iters = get_conf_internal(n_measure_warmup_iters, n_measure_warmup_iters_from_env)
  end function get_conf_measure_warmup_iters

  elemental function get_conf_measure_iters() result(iters)
  !! Returns the number of measurement iterations
    integer(int32) :: iters  !! Result
    iters = get_conf_internal(n_measure_iters, n_measure_iters_from_env)
  end function get_conf_measure_iters

  elemental type(dtfft_platform_t) function get_conf_platform()
  !! Returns platform set by the user or default one
    get_conf_platform = platform
    if ( platform_from_env /= PLATFORM_NOT_SET ) get_conf_platform = platform_from_env
  end function get_conf_platform

#ifdef DTFFT_WITH_CUDA
  type(dtfft_stream_t) function get_conf_stream() result(stream)
  !! Returns either the custom provided by user or creates a new one
    if ( is_custom_stream ) then
      stream = custom_stream
      return
    endif
    if (.not.is_stream_created) then
      CUDA_CALL( cudaStreamCreate(main_stream) )
      is_stream_created = .true.
    endif
    stream = main_stream
  end function get_conf_stream

  subroutine destroy_stream
  !! Destroy the default stream if it was created
    if ( is_stream_created ) then
      CUDA_CALL( cudaStreamDestroy(main_stream) )
      is_stream_created = .false.
    endif
  end subroutine destroy_stream
#endif

  elemental type(dtfft_backend_t) function get_conf_backend()
  !! Returns backend set by the user or default one
    get_conf_backend = get_correct_backend(backend)
    if ( backend_from_env /= DTFFT_BACKEND_NONE) get_conf_backend = backend_from_env
  end function get_conf_backend

  elemental type(dtfft_backend_t) function get_conf_reshape_backend()
  !! Returns reshape backend set by the user or default one
    get_conf_reshape_backend = get_correct_backend(reshape_backend)
    if ( reshape_backend_from_env /= DTFFT_BACKEND_NONE) get_conf_reshape_backend = reshape_backend_from_env
  end function get_conf_reshape_backend

  elemental function get_conf_datatype_enabled() result(bool)
  !! Whether MPI Datatype backend is enabled or not
    logical :: bool   !! Result flag
    bool = get_conf_internal(is_datatype_enabled, datatype_enabled_from_env)
  end function get_conf_datatype_enabled

  elemental function get_conf_pipelined_enabled() result(bool)
  !! Whether pipelined backends are enabled or not
    logical :: bool   !! Result flag
    bool = get_conf_internal(is_pipelined_enabled, pipelined_enabled_from_env)
  end function get_conf_pipelined_enabled

  elemental function get_conf_rma_enabled() result(bool)
  !! Whether RMA backends are enabled or not
    logical :: bool   !! Result flag
#ifdef DTFFT_WITH_RMA
    bool = get_conf_internal(is_rma_enabled, rma_enabled_from_env)
#else
    bool = .false.
#endif
  end function get_conf_rma_enabled

  elemental function get_conf_fused_enabled() result(bool)
  !! Whether fused backends are enabled or not
    logical :: bool   !! Result flag
    bool = get_conf_internal(is_fused_enabled, fused_enabled_from_env)
  end function get_conf_fused_enabled

  elemental function get_conf_mpi_enabled() result(bool)
  !! Whether MPI backends are enabled or not
    logical :: bool  !! Result flag
#if !defined(DTFFT_WITH_NCCL) && !defined(DTFFT_WITH_NVSHMEM)
    if ( get_conf_platform() == DTFFT_PLATFORM_HOST) then
      bool = get_conf_internal(is_mpi_enabled, mpi_enabled_from_env)
    else
      bool = .true.
    endif
    ! Should not be .false. if only MPI backends are possible
#else
    bool = get_conf_internal(is_mpi_enabled, mpi_enabled_from_env)
#endif
  end function get_conf_mpi_enabled

#ifdef DTFFT_WITH_CUDA
  elemental function get_conf_nccl_enabled() result(bool)
  !! Whether NCCL backends are enabled or not
    logical :: bool  !! Result flag
# ifdef DTFFT_WITH_NCCL
    bool = get_conf_internal(is_nccl_enabled, nccl_enabled_from_env)
# else
    bool = .false.
# endif
  end function get_conf_nccl_enabled

  elemental function get_conf_nvshmem_enabled() result(bool)
  !! Whether nvshmem backends are enabled or not
    logical :: bool  !! Result flag
# ifdef DTFFT_WITH_NVSHMEM
    bool = get_conf_internal(is_nvshmem_enabled, nvshmem_enabled_from_env)
# else
    bool = .false.
# endif
  end function get_conf_nvshmem_enabled
#endif

  elemental function get_conf_kernel_autotune_enabled() result(bool)
  !! Whether kernel optimization is enabled or not
    logical :: bool  !! Result flag
    bool = get_conf_internal(is_kernel_autotune_enabled, kernel_autotune_enabled_from_env)
  end function get_conf_kernel_autotune_enabled

  elemental function get_conf_fourier_reshape_enabled() result(bool)
  !! Whether reshape in Fourier space is enabled or not
    logical :: bool  !! Result flag
    bool = get_conf_internal(is_fourier_reshape_enabled, fourier_reshape_enabled_from_env)
  end function get_conf_fourier_reshape_enabled

  elemental function get_conf_transpose_mode() result(mode)
  !! Returns transpose mode set by the user or default one
    type(dtfft_transpose_mode_t) :: mode  !! Result
    mode = transpose_mode
    if ( transpose_mode_from_env /= TRANSPOSE_MODE_NOT_SET ) mode = transpose_mode_from_env
  end function get_conf_transpose_mode

  elemental function get_conf_access_mode() result(mode)
  !! Returns access mode set by the user or default one
    type(dtfft_access_mode_t) :: mode  !! Result
    mode = access_mode
    if ( access_mode_from_env /= ACCESS_MODE_NOT_SET ) mode = access_mode_from_env
  end function get_conf_access_mode

  elemental function get_conf_compression_enabled() result(bool)
  !! Whether compression is enabled or not
    logical :: bool  !! Result flag
#ifdef DTFFT_WITH_COMPRESSION
    bool = get_conf_internal(is_compression_enabled, compression_enabled_from_env)
#else
    bool = .false.
#endif
  end function get_conf_compression_enabled

#ifdef DTFFT_WITH_COMPRESSION
  elemental function get_conf_transpose() result(config)
  !! Returns compression config for transposes
    type(dtfft_compression_config_t) :: config  !! Result
    config = config_transpose
  end function get_conf_transpose


  elemental function get_conf_reshape() result(config)
  !! Returns compression config for reshapes
    type(dtfft_compression_config_t) :: config  !! Result

    config = config_reshape
  end function get_conf_reshape
#endif

end module dtfft_config

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_interface_nvrtc
!! nvRTC Interfaces.
!!
!! nvRTC is loaded at runtime via dynamic loading due to explicit cuda_driver linking by cmake.
use iso_c_binding
use iso_fortran_env,              only: int32
use dtfft_errors,                 only: DTFFT_SUCCESS
use dtfft_utils,                  only: dynamic_load, string, destroy_strings, string_c2f
implicit none
private
#include "_dtfft_private.h"
public :: nvrtcGetErrorString
public :: load_nvrtc

public :: nvrtcProgram
  type, bind(C) :: nvrtcProgram
  !! nvrtcProgram is the unit of compilation, and an opaque handle for a program.
    type(c_ptr) :: cptr !! Actual pointer
  end type nvrtcProgram

#ifndef DTFFT_WITH_MOCK_ENABLED
! Real nvRTC interfaces with dynamic loading

  abstract interface
    function nvrtcGetErrorString_interface(error_code)                                                &
      result(string)
    !! Helper function that returns a string describing the given nvrtcResult code
    !! For unrecognized enumeration values, it returns "NVRTC_ERROR unknown"
    import
      integer(c_int),  value  :: error_code !! CUDA Runtime Compilation API result code.
      type(c_ptr)             :: string     !! Pointer to C string
    end function nvrtcGetErrorString_interface
  end interface

  abstract interface
    function nvrtcCreateProgram_interface(prog, src, name, numHeaders, headers, includeNames)         &
      result(nvrtcResult)
    !! Creates an instance of nvrtcProgram with the given input parameters,
    !! and sets the output parameter prog with it.
    import
      type(nvrtcProgram)        :: prog         !! CUDA Runtime Compilation program.
      character(c_char)         :: src(*)       !! CUDA program source.
      character(c_char)         :: name(*)      !! CUDA program name.
      integer(c_int),     value :: numHeaders   !! Number of headers used. Must be greater than or equal to 0.
      type(c_ptr),        value :: headers      !! Sources of the headers
      type(c_ptr),        value :: includeNames !! Name of each header by which they can be included in the CUDA program source
      integer(c_int)            :: nvrtcResult  !! The enumerated type nvrtcResult defines API call result codes.
    end function nvrtcCreateProgram_interface
  end interface

  abstract interface
    function nvrtcDestroyProgram_interface(prog)                                                      &
      result(nvrtcResult)
    !! Destroys the given program.
    import
      type(nvrtcProgram)        :: prog         !! CUDA Runtime Compilation program.
      integer(c_int)            :: nvrtcResult  !! The enumerated type nvrtcResult defines API call result codes.
    end function nvrtcDestroyProgram_interface
  end interface

  abstract interface
    function nvrtcCompileProgram_interface(prog, numOptions, options)                                 &
      result(nvrtcResult)
    !! Compiles the given program.
    import
      type(nvrtcProgram), value :: prog         !! CUDA Runtime Compilation program.
      integer(c_int),     value :: numOptions   !! Number of compiler options passed.
      type(c_ptr)               :: options(*)   !! Compiler options in the form of C string array
      integer(c_int)            :: nvrtcResult  !! The enumerated type nvrtcResult defines API call result codes.
    end function nvrtcCompileProgram_interface
  end interface

  abstract interface
    function nvrtcGetProgramLogSize_interface(prog, logSizeRet)                                 &
      result(nvrtcResult)
    !! Sets the value of ``logSizeRet`` with the size of the log generated by the previous compilation of ``prog``.
    !! The log is a null-terminated string.
    import
      type(nvrtcProgram), value :: prog         !! CUDA Runtime Compilation program.
      integer(c_size_t)         :: logSizeRet   !! Size of the compilation log.
      integer(c_int)            :: nvrtcResult  !! The enumerated type nvrtcResult defines API call result codes.
    end function nvrtcGetProgramLogSize_interface

  end interface

  abstract interface
    function nvrtcGetProgramLog_interface(prog, log)                                                  &
      result(nvrtcResult)
    !! Stores the log generated by the previous compilation of prog in the memory pointed by log
    import
      type(nvrtcProgram), value :: prog         !! CUDA Runtime Compilation program.
      type(c_ptr),        value :: log          !! Compilation log.
      integer(c_int)            :: nvrtcResult  !! The enumerated type nvrtcResult defines API call result codes.
    end function nvrtcGetProgramLog_interface
  end interface

  abstract interface
    function nvrtcGetCUBINSize_interface(prog, cubinSizeRet)                                          &
      result(nvrtcResult)
    !! Sets the value of ``cubinSizeRet`` with the size of the cubin generated by the previous compilation of ``prog``.
    import
      type(nvrtcProgram), value :: prog         !! CUDA Runtime Compilation program.
      integer(c_size_t)         :: cubinSizeRet !! Size of the generated cubin.
      integer(c_int)            :: nvrtcResult  !! The enumerated type nvrtcResult defines API call result codes.
    end function nvrtcGetCUBINSize_interface
  end interface

  abstract interface
    function nvrtcGetCUBIN_interface(prog, cubin)                                                     &
      result(nvrtcResult)
    !! Stores the cubin generated by the previous compilation of ``prog`` in the memory pointed by ``cubin``.
    import
      type(nvrtcProgram), value :: prog         !! CUDA Runtime Compilation program.
      type(c_ptr),        value :: cubin        !! Compiled and assembled result.
      integer(c_int)            :: nvrtcResult  !! The enumerated type nvrtcResult defines API call result codes.
    end function nvrtcGetCUBIN_interface
  end interface

  abstract interface
    function nvrtcGetLoweredName_interface(prog, name_expression, lowered_name)                       &
      result(nvrtcResult)
    !! Extracts the lowered (mangled) name for a global function or device/__constant__ variable,
    !! and updates *lowered_name to point to it.
    import
      type(nvrtcProgram), value :: prog               !! CUDA Runtime Compilation program.
      character(c_char)         :: name_expression(*) !! Name expression.
      type(c_ptr)               :: lowered_name       !! Mangled name.
      integer(c_int)            :: nvrtcResult        !! The enumerated type nvrtcResult defines API call result codes.
    end function nvrtcGetLoweredName_interface
  end interface

  abstract interface
    function nvrtcAddNameExpression_interface(prog, name_expression)                                  &
      result(nvrtcResult)
    !! Notes the given name expression denoting the address of a global function or device/__constant__ variable.
    import
      type(nvrtcProgram), value :: prog               !! CUDA Runtime Compilation program.
      character(c_char)         :: name_expression(*) !! Name expression.
      integer(c_int)            :: nvrtcResult        !! The enumerated type nvrtcResult defines API call result codes.
    end function nvrtcAddNameExpression_interface
  end interface

  procedure(nvrtcGetErrorString_interface),   pointer         :: nvrtcGetErrorString_c
    !! Fortran pointer to the nvrtcGetErrorString function
  procedure(nvrtcCreateProgram_interface),    pointer, public :: nvrtcCreateProgram
    !! Fortran pointer to the nvrtcCreateProgram function
  procedure(nvrtcDestroyProgram_interface),   pointer, public :: nvrtcDestroyProgram
    !! Fortran pointer to the nvrtcDestroyProgram function
  procedure(nvrtcCompileProgram_interface),   pointer, public :: nvrtcCompileProgram
    !! Fortran pointer to the nvrtcCompileProgram function
  procedure(nvrtcGetProgramLogSize_interface),pointer, public :: nvrtcGetProgramLogSize
    !! Fortran pointer to the nvrtcGetProgramLogSize function
  procedure(nvrtcGetProgramLog_interface),    pointer, public :: nvrtcGetProgramLog
    !! Fortran pointer to the nvrtcGetProgramLog function
  procedure(nvrtcGetCUBINSize_interface),     pointer, public :: nvrtcGetCUBINSize
    !! Fortran pointer to the nvrtcGetCUBINSize function
  procedure(nvrtcGetCUBIN_interface),         pointer, public :: nvrtcGetCUBIN
    !! Fortran pointer to the nvrtcGetCUBIN function
  procedure(nvrtcGetLoweredName_interface),   pointer, public :: nvrtcGetLoweredName
    !! Fortran pointer to the nvrtcGetLoweredName function
  procedure(nvrtcAddNameExpression_interface),pointer, public :: nvrtcAddNameExpression
    !! Fortran pointer to the nvrtcAddNameExpression function

#else
! Mock nvRTC interfaces for CPU testing
public :: nvrtcCreateProgram, nvrtcDestroyProgram, nvrtcCompileProgram
public :: nvrtcGetProgramLogSize, nvrtcGetProgramLog
public :: nvrtcGetCUBINSize, nvrtcGetCUBIN
public :: nvrtcGetLoweredName, nvrtcAddNameExpression
#endif

  integer(int32), parameter  :: N_FUNCTIONS_TO_LOAD = 10
    !! Number of functions to load from nvrtc library
  logical,        save :: is_loaded = .false.
    !! Flag indicating whether the library is loaded
  type(c_ptr),    save :: libnvrtc
    !! Handle to the loaded library
  type(c_funptr), save :: nvrtcFunctions(N_FUNCTIONS_TO_LOAD)
    !! Array of pointers to the nvRTC functions

contains

#ifdef DTFFT_WITH_MOCK_ENABLED
  ! Mock implementations for CPU testing

  function nvrtcGetErrorString_c(error_code) result(string)
  !! Mock: Returns error string
    integer(c_int), intent(in) :: error_code
    type(c_ptr)                :: string
    character(len=20), target, save :: error_msg = "Mock nvRTC Error"
    string = c_loc(error_msg)
  end function nvrtcGetErrorString_c

  function nvrtcCreateProgram(prog, src, name, numHeaders, headers, includeNames) result(nvrtcResult)
  !! Mock: Creates dummy program
    type(nvrtcProgram)           :: prog
    character(c_char)            :: src(*), name(*)
    integer(c_int),   intent(in) :: numHeaders
    type(c_ptr),      intent(in) :: headers, includeNames
    integer(c_int)               :: nvrtcResult
    prog%cptr = c_null_ptr
    nvrtcResult = 0  ! NVRTC_SUCCESS
  end function nvrtcCreateProgram

  function nvrtcDestroyProgram(prog) result(nvrtcResult)
  !! Mock: Does nothing
    type(nvrtcProgram)        :: prog
    integer(c_int)            :: nvrtcResult
    nvrtcResult = 0  ! NVRTC_SUCCESS
  end function nvrtcDestroyProgram

  function nvrtcCompileProgram(prog, numOptions, options) result(nvrtcResult)
  !! Mock: Does nothing - compilation is fake
    type(nvrtcProgram), intent(in) :: prog
    integer(c_int),     intent(in) :: numOptions
    type(c_ptr),        intent(in) :: options(*)
    integer(c_int)                 :: nvrtcResult
    nvrtcResult = 0  ! NVRTC_SUCCESS
  end function nvrtcCompileProgram

  function nvrtcGetProgramLogSize(prog, logSizeRet) result(nvrtcResult)
  !! Mock: Returns dummy log size
    type(nvrtcProgram), intent(in)  :: prog
    integer(c_size_t),  intent(out) :: logSizeRet
    integer(c_int)                  :: nvrtcResult
    logSizeRet = 1_c_size_t
    nvrtcResult = 0  ! NVRTC_SUCCESS
  end function nvrtcGetProgramLogSize

  function nvrtcGetProgramLog(prog, log) result(nvrtcResult)
  !! Mock: Returns empty log
    type(nvrtcProgram), intent(in) :: prog
    type(c_ptr),        intent(in) :: log
    integer(c_int)                 :: nvrtcResult
    character(c_char), pointer :: log_str(:)
    if (c_associated(log)) then
      call c_f_pointer(log, log_str, [1])
      log_str(1) = c_null_char
    end if
    nvrtcResult = 0  ! NVRTC_SUCCESS
  end function nvrtcGetProgramLog

  function nvrtcGetCUBINSize(prog, cubinSizeRet) result(nvrtcResult)
  !! Mock: Returns dummy cubin size
    type(nvrtcProgram), intent(in)  :: prog
    integer(c_size_t),  intent(out) :: cubinSizeRet
    integer(c_int)                  :: nvrtcResult
    cubinSizeRet = 1024_c_size_t
    nvrtcResult = 0  ! NVRTC_SUCCESS
  end function nvrtcGetCUBINSize

  function nvrtcGetCUBIN(prog, cubin) result(nvrtcResult)
  !! Mock: Returns dummy cubin
    type(nvrtcProgram), intent(in) :: prog
    type(c_ptr),        intent(in) :: cubin
    integer(c_int)                 :: nvrtcResult
    nvrtcResult = 0  ! NVRTC_SUCCESS
  end function nvrtcGetCUBIN

  function nvrtcGetLoweredName(prog, name_expression, lowered_name) result(nvrtcResult)
  !! Mock: Returns same name
    type(nvrtcProgram), intent(in)  :: prog
    character(c_char),  target      :: name_expression(*)
    type(c_ptr)               :: lowered_name
    integer(c_int)            :: nvrtcResult
    lowered_name = c_loc(name_expression)
    nvrtcResult = 0  ! NVRTC_SUCCESS
  end function nvrtcGetLoweredName

  function nvrtcAddNameExpression(prog, name_expression) result(nvrtcResult)
  !! Mock: Does nothing
    type(nvrtcProgram), value :: prog
    character(c_char)         :: name_expression(*)
    integer(c_int)            :: nvrtcResult
    nvrtcResult = 0  ! NVRTC_SUCCESS
  end function nvrtcAddNameExpression

#endif

  function load_nvrtc() result(error_code)
  !! Dynamically loads nvRTC library and its functions
    integer(int32)  :: error_code !! Error code
    type(string), allocatable :: func_names(:)  !! Array of function names to load

    error_code = DTFFT_SUCCESS
    if ( is_loaded ) return

#ifndef DTFFT_WITH_MOCK_ENABLED
    allocate(func_names(N_FUNCTIONS_TO_LOAD))
    func_names(1) = string("nvrtcGetErrorString")
    func_names(2) = string("nvrtcCreateProgram")
    func_names(3) = string("nvrtcDestroyProgram")
    func_names(4) = string("nvrtcCompileProgram")
    func_names(5) = string("nvrtcGetProgramLog")
    func_names(6) = string("nvrtcGetCUBINSize")
    func_names(7) = string("nvrtcGetCUBIN")
    func_names(8) = string("nvrtcGetProgramLogSize")
    func_names(9) = string("nvrtcGetLoweredName")
    func_names(10) = string("nvrtcAddNameExpression")

    error_code = dynamic_load("libnvrtc.so", func_names, libnvrtc, nvrtcFunctions)
    call destroy_strings(func_names)
    if ( error_code /= DTFFT_SUCCESS ) return

    call c_f_procpointer(nvrtcFunctions(1), nvrtcGetErrorString_c)
    call c_f_procpointer(nvrtcFunctions(2), nvrtcCreateProgram)
    call c_f_procpointer(nvrtcFunctions(3), nvrtcDestroyProgram)
    call c_f_procpointer(nvrtcFunctions(4), nvrtcCompileProgram)
    call c_f_procpointer(nvrtcFunctions(5), nvrtcGetProgramLog)
    call c_f_procpointer(nvrtcFunctions(6), nvrtcGetCUBINSize)
    call c_f_procpointer(nvrtcFunctions(7), nvrtcGetCUBIN)
    call c_f_procpointer(nvrtcFunctions(8), nvrtcGetProgramLogSize)
    call c_f_procpointer(nvrtcFunctions(9), nvrtcGetLoweredName)
    call c_f_procpointer(nvrtcFunctions(10), nvrtcAddNameExpression)
#endif
    is_loaded = .true.
  end function load_nvrtc

  function nvrtcGetErrorString(error_code) result(string)
  !! Helper function that returns a string describing the given nvrtcResult code
  !! For unrecognized enumeration values, it returns "NVRTC_ERROR unknown"
    integer(c_int),   intent(in)  :: error_code     !! CUDA Runtime Compilation API result code.
    character(len=:), allocatable :: string         !! Result string

#ifndef DTFFT_WITH_MOCK_ENABLED
    type(c_ptr)                   :: c_string       !! Pointer to C string
    c_string = nvrtcGetErrorString_c(error_code)
    call string_c2f(c_string, string)
#else
    if (error_code == 0) then
      allocate(string, source="NVRTC_SUCCESS (mock)")
    else
      allocate(string, source="NVRTC_ERROR (mock)")
    end if
#endif
  end function nvrtcGetErrorString
end module dtfft_interface_nvrtc

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
module dtfft_nvrtc_block_optimizer
!! Module that provides functionality to analytically optimize CUDA kernel configurations
use iso_fortran_env
use dtfft_abstract_kernel
use dtfft_config,         only: get_conf_log_enabled
use dtfft_interface_cuda_runtime
use dtfft_parameters
use dtfft_utils
#include "_dtfft_private.h"
#include "_dtfft_mpi.h"
implicit none
private
public :: generate_candidates
public :: evaluate_analytical_performance
public :: get_ampere_architecture, get_volta_architecture
public :: count_bank_conflicts
public :: sort_candidates_by_score

    integer(int32), parameter :: NUM_BANKS = 32
        !! Number of banks in shared memory
    integer(int32), parameter :: WARP_SIZE = 32
        !! Warp size in threads
    integer(int32), parameter :: BANK_WIDTH_BYTES = 4
        !! Bank width in bytes

    integer(int32), parameter, public :: N_TILES_CANDIDATES = 5
        !! Maximum number of tile candidates to generate
    integer(int32), parameter, public :: N_BLOCKS_CANDIDATES = 5
        !! Maximum number of block candidates to generate
    integer(int32), parameter, public :: N_CANDIDATES = N_TILES_CANDIDATES * N_BLOCKS_CANDIDATES
        !! Maximum number of candidates to generate

    type, public :: kernel_config
    !! Configuration for the potential kernel
        integer(int32)  :: tile_size  !! Tile size (number of columns)
        integer(int32)  :: block_rows !! Block rows
        integer(int32)  :: padding    !! Padding added to the tile
    end type kernel_config

contains

    function get_ampere_architecture() result(props)
    !! Ampere architecture (Compute Capability 8.0)
        type(device_props) :: props !! Ampere architecture properties

        props%sm_count                   = 108
        props%max_threads_per_sm         = 2048
        props%max_blocks_per_sm          = 32
        props%shared_mem_per_sm          = 164 * 1024
        props%max_threads_per_block      = 1024
        props%shared_mem_per_block       = 48 * 1024
        props%l2_cache_size              = 40960 * 1024
        props%compute_capability_major   = 8
        props%compute_capability_minor   = 0
    end function get_ampere_architecture

    function get_volta_architecture() result(props)
    !! Volta architecture (Compute Capability 7.0)
        type(device_props) :: props !! Volta architecture properties

        props%sm_count                   = 80
        props%max_threads_per_sm         = 2048
        props%max_blocks_per_sm          = 32
        props%shared_mem_per_sm          = 96 * 1024
        props%max_threads_per_block      = 1024
        props%shared_mem_per_block       = 48 * 1024
        props%l2_cache_size              = 6144 * 1024
        props%compute_capability_major   = 7
        props%compute_capability_minor   = 0
    end function get_volta_architecture

    pure function count_bank_conflicts(tile_size, block_rows, base_storage, padding) result(total_conflicts)
    !! Counts bank conflicts for a given tile size, padding, element size, and block rows.
        integer(int32), intent(in)  :: tile_size          !! Size of the tile
        integer(int32), intent(in)  :: block_rows         !! Number of rows in the block
        integer(int64), intent(in)  :: base_storage       !! Number of bytes needed to store single element
        integer(int32), intent(in)  :: padding            !! Padding added to the tile
        integer(int32)              :: total_conflicts    !! Total number of bank conflicts
        integer(int32) :: stride                          !! Stride of the tile
        integer(int32) :: thread_idx                      !! Thread index within the warp
        integer(int32) :: bank                            !! Bank index
        integer(int32) :: element_address                 !! Address of the element
        integer(int32) :: address_in_bytes                !! Address of the element in bytes
        integer(int32) :: bank_accesses(0:NUM_BANKS - 1)  !! Array to count bank accesses
        integer(int32) :: thread_x                        !! Thread index in the x dimension
        integer(int32) :: thread_y                        !! Thread index in the y dimension
        integer(int32) :: load_conflicts                  !! Number of load bank conflicts
        integer(int32) :: store_conflicts                 !! Number of store bank conflicts
        integer(int32) :: offset                          !! Offset for the tile

        ! Check for validity
        if (block_rows > tile_size) then
            total_conflicts = MAX_INT32
            return
        end if

        ! Shared memory: T tile[TILE_DIM][TILE_DIM + padding]
        ! stride = tile_size + padding
        stride = tile_size + padding
        load_conflicts = 0
        ! Computing write conflicts
        do offset = 0, tile_size - 1, block_rows
            bank_accesses(:) = 0

            do thread_idx = 0, WARP_SIZE - 1
                thread_x = mod(thread_idx, tile_size)
                thread_y = thread_idx / tile_size

                if (thread_y >= block_rows) cycle
                if (thread_y + offset >= tile_size) cycle

                ! Load address: tile[threadIdx.x][threadIdx.y + y_offset]
                element_address = thread_x * stride + (thread_y + offset)
                address_in_bytes = element_address * int(base_storage, int32)
                bank = mod(address_in_bytes / BANK_WIDTH_BYTES, NUM_BANKS)

                bank_accesses(bank) = bank_accesses(bank) + 1
            end do

            do bank = 0, NUM_BANKS - 1
                if (bank_accesses(bank) > 1) then
                    load_conflicts = load_conflicts + (bank_accesses(bank) - 1)
                end if
            end do
        end do

        ! Computing read conflicts
        store_conflicts = 0
        do offset = 0, tile_size-1, block_rows
            bank_accesses(:) = 0

            do thread_idx = 0, WARP_SIZE-1
                thread_x = mod(thread_idx, tile_size)
                thread_y = thread_idx / tile_size

                if (thread_y >= block_rows) cycle
                if (thread_y + offset >= tile_size) cycle

                ! Read address: tile[threadIdx.y + offset][threadIdx.x]
                element_address = (thread_y + offset) * stride + thread_x
                address_in_bytes = element_address * int(base_storage, int32)
                bank = mod(address_in_bytes / BANK_WIDTH_BYTES, NUM_BANKS)

                bank_accesses(bank) = bank_accesses(bank) + 1
            end do

            do bank = 0, NUM_BANKS-1
                if (bank_accesses(bank) > 1) then
                    store_conflicts = store_conflicts + (bank_accesses(bank) - 1)
                end if
            end do
        end do

        total_conflicts = load_conflicts + store_conflicts
    end function count_bank_conflicts

    pure function estimate_optimal_padding(tile_size, block_rows, base_storage) result(padding)
    !! Estimates the optimal padding for a given tile size and element size
        integer(int32), intent(in)  :: tile_size      !! Size of the tile
        integer(int32), intent(in)  :: block_rows     !! Number of rows in the block
        integer(int64), intent(in)  :: base_storage   !! Number of bytes needed to store single element
        integer(int32)              :: padding        !! Optimal padding to reduce bank conflicts
        integer(int32) :: best_padding    !! Best padding found
        integer(int32) :: min_conflicts   !! Minimum conflicts found
        integer(int32) :: n_conflicts     !! Number of bank conflicts for the current padding

        best_padding = 1  ! This is default, works in most cases
        min_conflicts = MAX_INT32

        ! Starting from 1. We do not consider zero padding
        do padding = 1, 8
            n_conflicts = count_bank_conflicts(tile_size, block_rows, base_storage, padding)

            if (n_conflicts < min_conflicts) then
                min_conflicts = n_conflicts
                best_padding = padding
                ! Early exit in case of best padding found
                if (n_conflicts == 0) exit
            end if
        end do

        padding = best_padding
    end function estimate_optimal_padding

    pure function estimate_bank_conflict_ratio(config, base_storage) result(ratio)
    !! Estimates the bank conflict ratio for a given kernel configuration
        type(kernel_config),  intent(in)  :: config         !! Kernel configuration
        integer(int64),       intent(in)  :: base_storage   !! Number of bytes needed to store single element
        real(real32)                      :: ratio          !! Bank conflict estimation
        integer(int32) :: actual_conflicts      !! Actual number of bank conflicts for given configuration
        integer(int32) :: worst_case_conflicts  !! Worst-case number of bank conflicts for given configuration

        actual_conflicts = count_bank_conflicts(config%tile_size, config%block_rows, base_storage, config%padding)
        if (actual_conflicts == MAX_INT32) then
            ! Invalid configuration, return immediately
            ratio = 1.0
            return
        end if
        ! Worst case is using same configuration but without padding
        worst_case_conflicts = count_bank_conflicts(config%tile_size, config%block_rows, base_storage, 0)

        ! Worst case can also have no conflicts
        if (worst_case_conflicts > 0) then
            ratio = real(actual_conflicts) / real(worst_case_conflicts)
            ratio = max(0.0, min(1.0, ratio))
        else
            ratio = 0.0
        end if
    end function estimate_bank_conflict_ratio

    pure function estimate_occupancy(config, props, base_storage) result(occupancy)
    !! Calculates theoretical occupancy for a given kernel configuration
        type(kernel_config),    intent(in) :: config        !! Kernel configuration
        type(device_props),     intent(in) :: props         !! GPU architecture properties
        integer(int64),         intent(in) :: base_storage  !! Number of bytes needed to store single element
        real(real32)                       :: occupancy     !! Estimated occupancy
        integer(int32) :: threads_per_block         !! Number of threads per block
        integer(int32) :: max_blocks_by_threads     !! Maximum number of blocks by threads
        integer(int32) :: max_blocks_by_shared_mem  !! Maximum number of blocks by shared memory
        integer(int32) :: max_active_blocks         !! Maximum number of active blocks
        integer(int64) :: shared_mem_per_block      !! Shared memory per block

        ! Limits by number of threads in multiprocessor
        threads_per_block = config%tile_size * config%block_rows
        if (threads_per_block > 0) then
            max_blocks_by_threads = props%max_threads_per_sm / threads_per_block
        else
            max_blocks_by_threads = 0
        end if

        ! Limits by shared memory in multiprocessor
        shared_mem_per_block = config%tile_size * (config%tile_size + config%padding) * base_storage
        if (shared_mem_per_block > 0) then
            max_blocks_by_shared_mem = int(props%shared_mem_per_sm / shared_mem_per_block, int32)
        else
            max_blocks_by_shared_mem = props%max_blocks_per_sm
        end if

        max_active_blocks = min(max_blocks_by_threads, max_blocks_by_shared_mem, props%max_blocks_per_sm)
        if (props%max_threads_per_sm > 0) then
            occupancy = real(max_active_blocks * threads_per_block, real32) / real(props%max_threads_per_sm, real32)
        else
            occupancy = 0.0
        end if
        occupancy = max(0.0, min(1.0, occupancy))
    end function estimate_occupancy

    function estimate_memory_pressure(dims, tile_dim, other_dim, base_storage, props) result(pressure)
    !! Analytical estimation of memory pressure based on GPU architecture
        integer(int32),         intent(in)  :: dims(:)        !! Size of the problem
        integer(int32),         intent(in)  :: tile_dim       !! Tile dimension
        integer(int32),         intent(in)  :: other_dim      !! Other dimension (not tiled)
        integer(int64),         intent(in)  :: base_storage   !! Number of bytes needed to store single element
        type(device_props),     intent(in)  :: props           !! GPU architecture properties
        real(real32)                        :: pressure       !! Pressure metric
        integer(int64)  :: matrix_size_bytes      !! Size of the matrix in bytes
        integer(int64)  :: shared_mem_total_bytes !! Total shared memory available for a GPU
        real(real32)    :: memory_utilization     !! Memory utilization metric
        real(real32)    :: cache_efficiency       !! Cache efficiency metric
        real(real32)    :: locality_factor        !! Locality factor metric
        real(real32)    :: aspect_ratio           !! Aspect ratio metric
        integer(int32)  :: nx                     !! Size of the matrix in the x dimension
        integer(int32)  :: ny                     !! Size of the matrix in the y dimension
        integer(int32)  :: nz                     !! Size of the matrix in the z dimension
        integer(int32)  :: min_dim                !! Minimum dimension size

        nx = dims(1);           nx = max(nx, 1)
        ny = dims(tile_dim);    ny = max(ny, 1)
        nz = dims(other_dim);   nz = max(nz, 1)
        min_dim = min(nx, ny)

        matrix_size_bytes = product(dims) * base_storage
        shared_mem_total_bytes = props%shared_mem_per_sm * int(props%sm_count, int64)

        ! 2D model of memory pressure: Shared Memory + L2 Cache vs Global Memory
        if (matrix_size_bytes > props%l2_cache_size) then
        ! Matrix does not fit in L2 - high pressure on global memory
            memory_utilization = 0.9
        else if (matrix_size_bytes > shared_mem_total_bytes) then
        ! Matrix fits in L2 but not in shared memory - medium pressure
            memory_utilization = 0.6
        else if (matrix_size_bytes < 1024_int64) then
        ! No pressure
            memory_utilization = 0.1
        else
        ! Matrix fits in shared memory - low pressure
            memory_utilization = 0.3
        end if

        ! Analytical estimation of cache efficiency based on access pattern
        aspect_ratio = real(max(nx, ny)) / real(min_dim)
        if (nz == 1) then
        ! 2D case
            if (nx == ny) then
                ! Square matrix - good spatial locality when transposed
                cache_efficiency = 0.8
            else if (min_dim < 32) then
                ! Narrow matrix - poor spatial locality
                cache_efficiency = 0.5
            else
                ! Rectangular matrix - average locality
                cache_efficiency = 0.7
            end if
        else
        ! 3D case - additional dimension affects cache efficiency
            if (nx == ny .and. nz <= 16) then
                ! Square layers with small depth - good locality
                cache_efficiency = 0.7
            else if (min_dim < 32 .or. nz > 64) then
                ! Narrow layers or large depth - poor locality
                cache_efficiency = 0.4
            else
                ! Average case for 3D
                cache_efficiency = 0.6
            end if
            aspect_ratio = aspect_ratio * (1.0 + real(nz) / 32.0)  ! Z-dimension affects locality
        end if
        if (aspect_ratio > 16.0) then
            locality_factor = 0.3  ! Very asymmetric - poor locality
        else if (aspect_ratio > 4.0) then
            locality_factor = 0.6  ! Moderately asymmetric
        else
            locality_factor = 0.9  ! Close to square - good locality
        end if

        ! Combined memory pressure estimation
        pressure = memory_utilization * (1.0 - cache_efficiency * locality_factor + 0.1)
        pressure = max(0.0, min(1.0, pressure))
    end function estimate_memory_pressure

    function estimate_coalescing(dims, tile_dim, other_dim, kernel_type, config, base_storage, neighbor_data) result(score)
    !! Estimate memory coalescing efficiency for a given kernel configuration and transpose type
        integer(int32),           intent(in)  :: dims(:)        !! Local dimensions of the input data
        integer(int32),           intent(in)  :: tile_dim       !! Tile dimension
        integer(int32),           intent(in)  :: other_dim      !! Other dimension (not tiled)
        type(kernel_type_t),      intent(in)  :: kernel_type    !! Type of kernel
        type(kernel_config),      intent(in)  :: config         !! Kernel configuration
        integer(int64),           intent(in)  :: base_storage   !! Number of bytes needed to store single element
        integer(int32), optional, intent(in)  :: neighbor_data(:) !! Neighboring data dimensions for pipelined kernels
        real(real32)                          :: score          !! Coalescing score
        real(real32)    :: read_efficiency     !! Read efficiency score
        real(real32)    :: write_efficiency    !! Write efficiency score
        real(real32)    :: thread_utilization  !! Thread utilization score
        real(real32)    :: dimension_penalty   !! Penalty based on dimension sizes
        integer(int32)  :: tile_size           !! Tile size (X dimension)
        integer(int32)  :: block_rows          !! Number of rows in the block (Y dimension)
        integer(int32)  :: threads_per_block   !! Number of threads per block
        integer(int32)  :: nx, ny, nz          !! Problem dimensions
        integer(int32)  :: read_stride         !! Stride for reading
        integer(int32)  :: write_stride        !! Stride for writing
        real(real32)    :: cache_efficiency    !! Cache line utilization efficiency

        tile_size = config%tile_size
        block_rows = config%block_rows
        threads_per_block = tile_size * block_rows
        nx = dims(1)
        ny = dims(tile_dim)
        nz = dims(other_dim)

        ! Analyze memory access patterns based on transpose type
        select case ( kernel_type%val )
        case ( KERNEL_PERMUTE_FORWARD%val )
            read_stride = nx
            write_stride = ny * nz
        case ( KERNEL_PACK_FORWARD%val )
            read_stride = nx
            write_stride = neighbor_data(tile_dim) * neighbor_data(other_dim)
        case ( KERNEL_PERMUTE_BACKWARD%val )
            read_stride = nx * ny
            write_stride = nz
        case ( KERNEL_PACK_BACKWARD%val )
            read_stride = nx * ny
            write_stride = neighbor_data(tile_dim)
        case ( KERNEL_PERMUTE_BACKWARD_START%val )
            read_stride = nx * ny
            write_stride = ny * nz
        case ( KERNEL_PERMUTE_BACKWARD_END_PIPELINED%val )
            read_stride = neighbor_data(1) * neighbor_data(3)
            write_stride = nx
        case ( KERNEL_UNPACK_PIPELINED%val )
            read_stride = neighbor_data(1)
            write_stride = nx
        case ( KERNEL_PACK_PIPELINED%val )
            read_stride = nx
            write_stride = neighbor_data(1)
        case default
            INTERNAL_ERROR("estimate_coalescing: unknown kernel_type")
        endselect

        ! Calculate read efficiency based on memory access pattern
        if (tile_size >= WARP_SIZE) then
        ! Full warp coalescing for reads
            read_efficiency = 1.0
        else
            read_efficiency = real(tile_size) / real(WARP_SIZE)
        end if

        ! Apply stride penalty for reads
        if (read_stride == 1) then
        ! Perfect coalescing
            read_efficiency = read_efficiency * 1.0
        else if (read_stride <= 4) then
        ! Good coalescing
            read_efficiency = read_efficiency * 0.95
        else if (read_stride <= 32) then
        ! Acceptable coalescing
            read_efficiency = read_efficiency * 0.85
        else if (read_stride <= 128) then
        ! Poor coalescing
            read_efficiency = read_efficiency * 0.70
        else
        ! Very poor coalescing
            read_efficiency = read_efficiency * 0.50
        end if

        ! Calculate write efficiency based on stride and dimension sizes
        if (write_stride == 1) then
            write_efficiency = 1.0
        else if (write_stride <= 4) then
            write_efficiency = 0.95
        else if (write_stride <= 16) then
            write_efficiency = 0.85
        else if (write_stride <= 64) then
            write_efficiency = 0.70
        else if (write_stride <= 256) then
            write_efficiency = 0.55
        else if (write_stride <= 1024) then
            write_efficiency = 0.40
        else
            write_efficiency = 0.25
        end if

        ! Apply dimension-specific penalties
        select case ( kernel_type%val )
        case ( KERNEL_PERMUTE_BACKWARD_START%val, KERNEL_PERMUTE_BACKWARD%val )
            if (min(nx, nz) < 16) then
                dimension_penalty = 0.75
            else if (min(nx, nz) < 32) then
                dimension_penalty = 0.85
            else
                dimension_penalty = 0.92
            end if
        case default
            if (min(ny, nz) < 16) then
                dimension_penalty = 0.80
            else if (min(ny, nz) < 32) then
                dimension_penalty = 0.88
            else
                dimension_penalty = 0.95
            end if
        endselect

        write_efficiency = write_efficiency * dimension_penalty

        ! Cache line utilization based on element size
        if (base_storage == DOUBLE_COMPLEX_STORAGE_SIZE) then
            cache_efficiency = 0.85
        else if (base_storage == DOUBLE_STORAGE_SIZE) then
            cache_efficiency = 0.92
        else
            cache_efficiency = 1.0
        end if

        read_efficiency = read_efficiency * cache_efficiency
        write_efficiency = write_efficiency * cache_efficiency

        ! Thread utilization based on block size
        if (threads_per_block >= 512) then
            thread_utilization = 1.0
        else if (threads_per_block >= 256) then
            thread_utilization = 0.95
        else if (threads_per_block >= 128) then
            thread_utilization = 0.90
        else if (threads_per_block >= 64) then
            thread_utilization = 0.80
        else
            thread_utilization = 0.60
        end if

        ! Combined score - writing is more critical for transpose operations
        score = 0.20 * read_efficiency + 0.65 * write_efficiency + 0.15 * thread_utilization
    end function estimate_coalescing

    subroutine generate_candidates(dims, tile_dim, other_dim, base_storage, props, candidates, num_candidates)
    !! Generate kernel configuration candidates for given problem
        integer(int32),           intent(in)  :: dims(:)        !! Local dimensions of the input data, always 3D
        integer(int32),           intent(in)  :: tile_dim       !! Tile dimension
        integer(int32),           intent(in)  :: other_dim      !! Other dimension (not tiled)
        integer(int64),           intent(in)  :: base_storage   !! Number of bytes needed to store single element
        type(device_props),       intent(in)  :: props          !! GPU architecture properties
        type(kernel_config),      intent(out) :: candidates(:)  !! Generated kernel configurations
        integer(int32),           intent(out) :: num_candidates !! Number of generated candidates
        integer(int32)  :: nx                 !! Local dimension X
        integer(int32)  :: ny                 !! Local dimension Y
        integer(int32)  :: tile_sizes(N_TILES_CANDIDATES)      !! Tile sizes to consider
        integer(int32)  :: block_heights(N_BLOCKS_CANDIDATES)   !! Block heights to consider
        integer(int32)  :: i                  !! Counter
        integer(int32)  :: j                  !! Counter
        integer(int32)  :: k                  !! Counter
        integer(int32)  :: tile_size          !! Current tile size
        integer(int32)  :: block_rows         !! Current number of block rows
        logical         :: is_asymmetric      !! Flag for asymmetric problem
        logical         :: is_square          !! Flag for square problem
        logical         :: is_large           !! Flag for large problem
        logical         :: is_found           !! Flag for found configuration
        real(real32)    :: aspect_ratio       !! Aspect ratio of the problem
        real(real32)    :: memory_bandwidth   !! Estimated memory bandwidth pressure
        integer(int32)  :: optimal_tile_size  !! Optimal tile size
        integer(int32)  :: optimal_block_rows !! Optimal number of block rows
        integer(int32)  :: threads_per_block  !! Number of threads per block
        integer(int32)  :: padding            !! Padding size
        integer(int64)  :: shared_mem_usage   !! Shared memory usage per block

        ! WRITE_DEBUG("Generating kernel configuration candidates..")
        nx = dims(1);           nx = max(nx, 1)
        ny = dims(tile_dim);    ny = max(ny, 1)

        is_square = abs(nx - ny) <= max(nx, ny) / 10
        is_large = 1_int64 * product(dims) > (int(props%l2_cache_size, int64) / base_storage)
        is_asymmetric = (nx > 4 * ny) .or. (ny > 4 * nx)
        aspect_ratio = real(max(nx, ny)) / real(min(nx, ny))

        memory_bandwidth = estimate_memory_pressure(dims, tile_dim, other_dim, base_storage, props)

        if (is_asymmetric) then
            if (nx > ny) then
                ! Prefer more rows
                optimal_tile_size = min(64, max(16, ny))
                optimal_block_rows = min(16, max(8, ny / 4))
            else
                ! Prefer fewer rows
                optimal_tile_size = min(128, max(32, nx))
                optimal_block_rows = min(8, max(2, nx / 16))
            end if
            call find_valid_combination(optimal_tile_size, optimal_block_rows)
        else if (is_large .and. memory_bandwidth > 0.7) then
            ! Large matrix with high memory pressure - prefer larger blocks
            optimal_tile_size = 64
            if (base_storage >= DOUBLE_STORAGE_SIZE) then
                optimal_block_rows = 8
            else
                optimal_block_rows = 16
            end if
        else if (.not. is_large ) then
        ! Small matrix with low pressure - prefer smaller blocks
            optimal_tile_size = 16
            optimal_block_rows = 4
        else
        ! Default case
            optimal_tile_size = 32
            if (base_storage >= DOUBLE_STORAGE_SIZE) then
                optimal_block_rows = 4
            else
                optimal_block_rows = 8
            end if
        end if

        ! Forming 5 variants of tile sizes around the optimal
        if ( mod(optimal_tile_size / 4, WARP_SIZE) == 0) then
            tile_sizes(1) = max(8, optimal_tile_size / 4)
        else
            tile_sizes(1) = 16
        endif
        if ( mod(optimal_tile_size / 2, WARP_SIZE) == 0) then
            tile_sizes(2) = max(16, optimal_tile_size / 2)
        else
            tile_sizes(2) = 32
        endif
        ! tile_sizes(2) = max(16, optimal_tile_size / 2)
        tile_sizes(3) = optimal_tile_size
        tile_sizes(4) = min(128, optimal_tile_size * 2)
        tile_sizes(5) = min(256, optimal_tile_size * 4)

        ! Forming 5 variants of block heights around the optimal
        ! Avoiding too small configurations (minimum 2 rows for reasonable occupancy)
        block_heights(1) = max(2, optimal_block_rows / 2)
        block_heights(2) = optimal_block_rows
        block_heights(3) = min(16, optimal_block_rows * 2)
        block_heights(4) = min(32, optimal_block_rows * 4)
        block_heights(5) = min(64, optimal_block_rows * 8)

        num_candidates = 0
        do i = 1, size(tile_sizes)
            do j = 1, size(block_heights)
                if (num_candidates > size(candidates)) exit
                tile_size = tile_sizes(i)
                block_rows = block_heights(j)
                threads_per_block = tile_size * block_rows

                if (tile_size * block_rows > props%max_threads_per_block) cycle
                if (threads_per_block < 2 * WARP_SIZE) cycle
                if (tile_size < block_rows) cycle
                if (mod(tile_size * block_rows, WARP_SIZE) /= 0) cycle

                padding = estimate_optimal_padding(tile_size, block_rows, base_storage)
                shared_mem_usage = tile_size * (tile_size + padding) * base_storage
                ! Reserving 10% of shared memory
                if (shared_mem_usage >= int(props%shared_mem_per_block * 0.9_real64, int64)) cycle

                ! Checking if candidate was added before
                is_found = .false.
                do k = 1, num_candidates
                    if ( candidates(k)%tile_size == tile_size .and. candidates(k)%block_rows == block_rows ) is_found = .true.
                enddo
                if ( is_found ) cycle
                WRITE_DEBUG("Adding candidate for consideration: "//to_str(tile_size)//"x"//to_str(block_rows)//", padding = "//to_str(padding))
                num_candidates = num_candidates + 1
                candidates(num_candidates)%tile_size = tile_size
                candidates(num_candidates)%block_rows = block_rows
                ! candidates(num_candidates)%threads%x = tile_size
                ! candidates(num_candidates)%threads%y = block_rows
                ! candidates(num_candidates)%threads%z = 1
                ! candidates(num_candidates)%blocks%x = (nx + tile_size - 1) / tile_size
                ! candidates(num_candidates)%blocks%y = (ny + tile_size - 1) / tile_size
                ! candidates(num_candidates)%blocks%z = dims(other_dim)
                candidates(num_candidates)%padding = padding
            end do
            if (num_candidates > size(candidates)) exit
        end do
        ! WRITE_DEBUG("Generated "//to_str(num_candidates)//" candidates")
    end subroutine generate_candidates

    subroutine find_valid_combination(base_tile, base_rows)
    !! This subroutine optimizes the tile size and number of rows for narrow matrices
    !! by adjusting them to be compatible with the warp size.
        integer(int32), intent(inout) :: base_tile    !!< Tile size
        integer(int32), intent(inout) :: base_rows    !!< Number of rows
        integer(int32) :: best_tile !! Optimized tile size
        integer(int32) :: best_rows !! Optimized number of rows

        best_tile = (base_tile + WARP_SIZE - 1) / WARP_SIZE * WARP_SIZE
        best_tile = min(256, max(8, best_tile))

        best_rows = ((base_rows + best_tile - 1) / best_tile) * best_tile
        best_rows = min(4, max(best_tile, best_rows))

        if (mod(best_tile * best_rows, WARP_SIZE) /= 0) then
            best_rows = best_rows + best_tile
            best_rows = min(4, best_rows)
        end if

        base_tile = best_tile
        base_rows = best_rows
    end subroutine find_valid_combination

    function evaluate_analytical_performance(dims, tile_dim, other_dim, kernel_type, config, props, base_storage, neighbor_data) result(score)
    !! This function evaluates the performance of a kernel configuration
    !! based on various architectural and problem-specific parameters.
        integer(int32),           intent(in)  :: dims(:)        !! Problem dimensions
        integer(int32),           intent(in)  :: tile_dim       !! Tile dimension
        integer(int32),           intent(in)  :: other_dim      !! Other dimension (not tiled)
        type(kernel_type_t),      intent(in)  :: kernel_type    !! Type of kernel_type to evaluate
        type(kernel_config),      intent(in)  :: config         !! Kernel configuration
        type(device_props),       intent(in)  :: props          !! GPU architecture properties
        integer(int64),           intent(in)  :: base_storage   !! Number of bytes needed to store single element
        integer(int32), optional, intent(in)  :: neighbor_data(:) !! Neighboring data dimensions for pipelined kernels
        real(real32)                          :: score          !! Performance score
        integer(int32)  :: n_bank_conflicts             !! Number of bank conflicts
        integer(int32)  :: tile_size                    !! Tile size
        integer(int32)  :: block_rows                   !! Number of rows in a block
        real(real32)    :: occupancy_score              !! Occupancy score
        real(real32)    :: memory_access_score          !! Memory access score
        real(real32)    :: computation_efficiency_score !! Computation efficiency score
        real(real32)    :: occupancy                    !! Raw occupancy score
        real(real32)    :: coalescing_efficiency        !! Coalescing efficiency score
        real(real32)    :: bank_conflict_ratio          !! Bank conflict ratio
        ! real(real32)    :: x_waste                      !! X waste
        ! real(real32)    :: y_waste                      !! Y waste
        ! real(real32)    :: total_efficiency             !! Total efficiency

        tile_size = config%tile_size
        block_rows = config%block_rows

        occupancy = estimate_occupancy(config, props, base_storage)
        if (occupancy >= 0.5 .and. occupancy <= 0.75) then
            occupancy_score = 1.0
        else if (occupancy >= 0.3 .and. occupancy < 0.5) then
            occupancy_score = 0.7 + 0.3 * (occupancy - 0.3) / 0.2
        else if (occupancy > 0.75 .and. occupancy <= 1.0) then
            occupancy_score = 1.0 - 0.2 * (occupancy - 0.75) / 0.25
        else
            occupancy_score = 0.3
        end if

        coalescing_efficiency = estimate_coalescing(dims, tile_dim, other_dim, kernel_type, config, base_storage, neighbor_data)
        bank_conflict_ratio = estimate_bank_conflict_ratio(config, base_storage)
        memory_access_score = 0.4 * coalescing_efficiency + 0.6 * (1.0 - bank_conflict_ratio)

        if (mod(tile_size, WARP_SIZE) == 0) then
            computation_efficiency_score = 1.0
        else if (mod(tile_size, 16) == 0) then
            computation_efficiency_score = 0.9
        else if (mod(tile_size, 8) == 0) then
            computation_efficiency_score = 0.8
        else
            computation_efficiency_score = 0.7
        end if

        ! x_waste = real(config%blocks%x * tile_size - dims(1)) / real(config%blocks%x * tile_size)
        ! y_waste = real(config%blocks%y * tile_size - dims(2)) / real(config%blocks%y * tile_size)

        ! total_efficiency = (1.0 - x_waste) * (1.0 - y_waste)

        ! if (total_efficiency >= 0.95) then
        !   workload_balance_score = 1.0
        ! else if (total_efficiency >= 0.85) then
        !   workload_balance_score = 0.9 + 0.1 * (total_efficiency - 0.85) / 0.10
        ! else if (total_efficiency >= 0.75) then
        !   workload_balance_score = 0.8 + 0.1 * (total_efficiency - 0.75) / 0.10
        ! else if (total_efficiency >= 0.50) then
        !   workload_balance_score = 0.6 + 0.2 * (total_efficiency - 0.50) / 0.25
        ! else
        !   workload_balance_score = 0.3 + 0.3 * total_efficiency / 0.50
        ! end if

        score = 0.35 * occupancy_score                  &
                + 0.55 * memory_access_score            &
                + 0.10 * computation_efficiency_score
            ! + 0.10 * workload_balance_score

        score = max(0.0, min(1.0, score))
        n_bank_conflicts = count_bank_conflicts(tile_size, block_rows, base_storage, config%padding)

        ! WRITE_DEBUG("=== Performance Analysis for "//to_str(tile_size)//"x"//to_str(block_rows)//", padding = "//to_str(config%padding)//" ===")
        ! WRITE_DEBUG("  Occupancy score:                "//to_str(occupancy_score)//" (occupancy: "//to_str(occupancy)//")")
        ! WRITE_DEBUG("  Memory access score:            "//to_str(memory_access_score))
        ! WRITE_DEBUG("    - Coalescing:                 "//to_str(coalescing_efficiency))
        ! WRITE_DEBUG("    - Bank conflict ratio:        "//to_str(bank_conflict_ratio))
        ! WRITE_DEBUG("    - Number of bank conflicts:   "//to_str(n_bank_conflicts))
        ! WRITE_DEBUG("  Computational efficiency score: "//to_str(computation_efficiency_score))
        ! WRITE_DEBUG("  Workload balance score:         "//to_str(workload_balance_score)//" (efficiency: "//to_str(total_efficiency)//")")
        ! WRITE_DEBUG("  Final score: "//to_str(score))
    end function evaluate_analytical_performance

    subroutine sort_candidates_by_score(scores, num_candidates, sorted_indices)
    !! Sorting candidates by their performance scores
        real(real32),   intent(in)  :: scores(:)          !! Performance scores of candidates generated by `evaluate_analytical_performance`
        integer(int32), intent(in)  :: num_candidates     !! Number of candidates
        integer(int32), intent(out) :: sorted_indices(:)  !! Sorted indices of candidates
        integer(int32)  :: i            !! Counter
        integer(int32)  :: j            !! Counter
        integer(int32)  :: max_idx      !! Index of the maximum element
        real(real32)    :: max_score    !! Maximum score found
        logical :: used(num_candidates) !! Array to track used candidates

        used = .false.

        do i = 1, num_candidates
            max_score = -1.0
            max_idx = 0
            do j = 1, num_candidates
                if (.not. used(j) .and. scores(j) > max_score) then
                max_score = scores(j)
                max_idx = j
                end if
            end do

            if (max_idx > 0) then
                sorted_indices(i) = max_idx
                used(max_idx) = .true.
            else
                sorted_indices(i) = i  ! Fallback
            end if
        end do
    end subroutine sort_candidates_by_score
end module dtfft_nvrtc_block_optimizer

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_compressor_zfp
!! ZFP-based compressor implementation
use iso_c_binding
use iso_fortran_env
use dtfft_abstract_compressor
use dtfft_errors
use dtfft_config
#ifdef DTFFT_WITH_CUDA
use dtfft_interface_cuda_runtime
#endif
use dtfft_interface_zfp
use dtfft_parameters
use dtfft_utils
#include "_dtfft_cuda.h"
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
implicit none
private
public :: compressor_zfp

    type, extends(abstract_compressor) :: compressor_zfp
    !! ZFP-based compressor implementation
    private
        logical                         :: is_complex   !! Indicates if the data type is complex
        logical                         :: is_fixed_rate
        integer(int64)                  :: imag_offset  !! Byte offset for imaginary part in complex data
        type(dtfft_compression_config_t):: config       !! Compression configuration parameters
        type(zfp_exec_policy)           :: policy       !! ZFP execution policy (serial or CUDA)
        type(zfp_type)                  :: scalar_type  !! ZFP scalar type (float or double)
#ifdef DTFFT_WITH_CUDA
        type(cudaEvent)                 :: event
#endif
    contains
        procedure   :: create_private => create         !! Initializes the ZFP compressor with given configuration
        procedure   :: compress_private => compress     !! Compresses the input data using ZFP
        procedure   :: decompress_private => decompress !! Decompresses the input data using ZFP
        procedure   :: destroy                          !! Cleans up the compressor resources
        procedure   :: sync
        procedure   :: pre_sync
        procedure   :: post_sync
        procedure   :: init                             !! Initializes ZFP stream and field for compression/decompression
    end type compressor_zfp

    logical, save :: WARNING_ISSUED = .false.

contains

    integer(int32) function create(self, config, platform, base_type)
    !! Initializes the ZFP compressor with given configuration
        class(compressor_zfp),              intent(inout)   :: self         !! Compressor instance
        type(dtfft_compression_config_t),   intent(in)      :: config       !! Compression settings
        type(dtfft_platform_t),             intent(in)      :: platform     !! Target platform (CPU or CUDA)
        TYPE_MPI_DATATYPE,                  intent(in)      :: base_type    !! MPI data type

        create = DTFFT_SUCCESS
        self%imag_offset = 0
        self%is_complex = GET_MPI_VALUE(base_type) == GET_MPI_VALUE(MPI_COMPLEX) .or. GET_MPI_VALUE(base_type) == GET_MPI_VALUE(MPI_DOUBLE_COMPLEX)
        self%config = config
#ifdef DTFFT_WITH_OPENMP
# ifdef ZFP_WITH_OPENMP
        self%policy = zfp_exec_omp
        if ( .not. WARNING_ISSUED ) then
            WRITE_WARN("ZFP Does not support OpenMP decompression. All decompressions will be performed in a serial manner.")
            WARNING_ISSUED = .true.
        endif
# else
        if ( .not. WARNING_ISSUED ) then
            WRITE_WARN("ZFP Does not support OpenMP execution policy. All compressions and decompressions will be performed in a serial manner.")
            WARNING_ISSUED = .true.
        endif
        self%policy = zfp_exec_serial
# endif
#else
        self%policy = zfp_exec_serial
#endif
        if ( platform == DTFFT_PLATFORM_CUDA ) then
#if !defined(ZFP_WITH_CUDA) && !defined(DTFFT_WITH_MOCK_ENABLED)
            create = DTFFT_ERROR_COMPRESSION_CUDA_NOT_SUPPORTED
            return
#endif
            self%policy = zfp_exec_cuda
        endif
        select case ( GET_MPI_VALUE(base_type) )
        case ( GET_MPI_VALUE(MPI_COMPLEX), GET_MPI_VALUE(MPI_REAL) )
            self%scalar_type = zfp_type_float
            if ( self%is_complex ) self%imag_offset = 4_int64
        case default
            self%scalar_type = zfp_type_double
            if ( self%is_complex ) self%imag_offset = 8_int64
        endselect

        if ( self%scalar_type%val == zfp_type_float%val ) then
            if ( config%compression_mode == DTFFT_COMPRESSION_MODE_FIXED_RATE .and. config%rate >= 32.0_real64 ) then
                create = DTFFT_ERROR_COMPRESSION_INVALID_RATE
                return
            elseif ( config%compression_mode == DTFFT_COMPRESSION_MODE_FIXED_PRECISION .and. config%precision >= 32 ) then
                create = DTFFT_ERROR_COMPRESSION_INVALID_PRECISION
                return
            elseif ( config%compression_mode == DTFFT_COMPRESSION_MODE_FIXED_ACCURACY .and. config%tolerance < nearest(1._real32, 1._real32) - nearest(1._real32,-1._real32) ) then
                create = DTFFT_ERROR_COMPRESSION_INVALID_TOLERANCE
                return
            endif
        else
            if ( config%compression_mode == DTFFT_COMPRESSION_MODE_FIXED_RATE .and. config%rate >= 64.0_real64 ) then
                create = DTFFT_ERROR_COMPRESSION_INVALID_RATE
                return
            elseif ( config%compression_mode == DTFFT_COMPRESSION_MODE_FIXED_PRECISION .and. config%precision >= 64 ) then
                create = DTFFT_ERROR_COMPRESSION_INVALID_PRECISION
                return
            elseif ( config%compression_mode == DTFFT_COMPRESSION_MODE_FIXED_ACCURACY .and. config%tolerance < nearest(1._real64, 1._real64) - nearest(1._real64,-1._real64) ) then
                create = DTFFT_ERROR_COMPRESSION_INVALID_TOLERANCE
                return
            endif
        endif

        self%is_fixed_rate = .false.
        select case ( config%compression_mode%val )
        case ( DTFFT_COMPRESSION_MODE_FIXED_RATE%val )
            if ( config%rate <= 1.0_real64 ) then
                create = DTFFT_ERROR_COMPRESSION_INVALID_RATE
                return
            endif
            self%is_fixed_rate = .true.
        case ( DTFFT_COMPRESSION_MODE_FIXED_PRECISION%val )
            if ( config%precision <= 1 ) then
                create = DTFFT_ERROR_COMPRESSION_INVALID_PRECISION
                return
            endif
        case ( DTFFT_COMPRESSION_MODE_FIXED_ACCURACY%val )
            if ( config%tolerance <= 0.0_real64 ) then
                create = DTFFT_ERROR_COMPRESSION_INVALID_TOLERANCE
                return
            endif
        endselect
#ifdef DTFFT_WITH_CUDA
        if ( platform == DTFFT_PLATFORM_CUDA ) then
            CUDA_CALL( cudaEventCreateWithFlags(self%event, cudaEventDisableTiming) )
        endif
#endif
    end function create

    subroutine init(self, uncompressed_ptr, dims, is_decompression, zfp, field)
    !! Initializes ZFP stream and field for compression/decompression
        class(compressor_zfp),      intent(inout)   :: self             !! Compressor instance
        type(c_ptr),                intent(in)      :: uncompressed_ptr !! Pointer to uncompressed data
        integer(int32),             intent(in)      :: dims(:)          !! Array dimensions
        logical,                    intent(in)      :: is_decompression !! Decompression flag. Used only in omp build
        type(zfp_stream),           intent(out)     :: zfp              !! ZFP stream
        type(zfp_field),            intent(out)     :: field            !! ZFP field
        integer(c_int) :: exec
        integer(int32), allocatable :: strides(:), work_dims(:)

        allocate(work_dims, source=dims)
        if ( self%is_complex .and. self%is_fixed_rate ) then
            work_dims(1) = 2 * work_dims(1)
        endif

        field = zfp_create_field(uncompressed_ptr, self%scalar_type, dims)
        if ( self%is_complex .and. .not. self%is_fixed_rate) then
            allocate( strides(self%ndims) )

            strides(1) = 2
            strides(2) = strides(1) * dims(1)
            if ( self%ndims == 3 ) then
                strides(3) = strides(2) * dims(2)
            endif
            call zfp_field_set_stride(field, strides)

            deallocate( strides )
        endif

        zfp = zfp_stream_open(bitstream(c_null_ptr))
        if ( is_decompression .and. self%policy%val == zfp_exec_omp%val) then
            exec = zfp_stream_set_execution(zfp, zfp_exec_serial)
        else
            exec = zfp_stream_set_execution(zfp, self%policy)
        endif
        select case ( self%config%compression_mode%val )
        case ( DTFFT_COMPRESSION_MODE_LOSSLESS%val )
            call zfp_stream_set_reversible(zfp)
        case ( DTFFT_COMPRESSION_MODE_FIXED_RATE%val )
            call zfp_stream_set_rate(zfp, field, self%config%rate)
        case ( DTFFT_COMPRESSION_MODE_FIXED_PRECISION%val )
            call zfp_stream_set_precision(zfp, self%config%precision)
        case ( DTFFT_COMPRESSION_MODE_FIXED_ACCURACY%val )
            call zfp_stream_set_accuracy(zfp, self%config%tolerance)
        endselect
    end subroutine init

    integer(int64) function compress(self, dims, in, out, stream)
    !! Compresses the input data using ZFP
        class(compressor_zfp),      intent(inout)   :: self         !! Compressor instance
        integer(int32),             intent(in)      :: dims(:)      !! Array dimensions
        type(c_ptr),                intent(in)      :: in           !! Pointer to input data
        type(c_ptr),                intent(in)      :: out          !! Pointer to output buffer
        type(dtfft_stream_t),       intent(in)      :: stream       !! Stream handle
        type(zfp_field) :: field
        type(zfp_stream) :: zfp
        type(bitstream) :: bs
        integer(c_size_t) :: max_size

        compress = 0_int64
        call self%init(in, dims, .false., zfp, field)
        max_size = zfp_stream_maximum_size(zfp, field)
        if ( self%is_complex .and. .not. self%is_fixed_rate ) max_size = max_size * 2
        bs = stream_open(out, max_size)
        call zfp_stream_set_bit_stream(zfp, bs)
        call zfp_stream_rewind(zfp)

        compress = zfp_compress(zfp, field)

        if ( self%is_complex .and. .not. self%is_fixed_rate) then
            call zfp_field_set_pointer(field, ptr_offset(in, self%imag_offset))
            compress = zfp_compress(zfp, field)
        endif

        call zfp_field_free(field)
        call zfp_stream_close(zfp)
        call stream_close(bs)
    end function compress

    subroutine decompress(self, dims, in, out, stream)
    !! Decompresses the input data using ZFP
        class(compressor_zfp),      intent(inout)   :: self             !! Compressor instance
        integer(int32),             intent(in)      :: dims(:)          !! Array dimensions
        type(c_ptr),                intent(in)      :: in               !! Pointer to compressed data
        type(c_ptr),                intent(in)      :: out              !! Pointer to output buffer
        type(dtfft_stream_t),       intent(in)      :: stream           !! Stream handle
        type(zfp_field) :: field
        type(zfp_stream) :: zfp
        type(bitstream) :: bs
        integer(int64) :: decompressed_size

        call self%init(out, dims, .true., zfp, field)
        bs = stream_open(in, product(dims) * self%storage_size)
        call zfp_stream_set_bit_stream(zfp, bs)
        call zfp_stream_rewind(zfp)

        decompressed_size = zfp_decompress(zfp, field)
        if ( self%is_complex .and. .not. self%is_fixed_rate) then
            call zfp_field_set_pointer(field, ptr_offset(out, self%imag_offset))
            decompressed_size = zfp_decompress(zfp, field)
        endif
#ifdef DTFFT_DEBUG
        if ( decompressed_size == 0 ) then
            INTERNAL_ERROR("Decompression failed")
        endif
#endif
        ! if ( decompressed_size /= compressed_size ) then
        !     INTERNAL_ERROR("compressor_zfp.decompress: decompressed_size /= compressed_size")
        ! endif
        call zfp_field_free(field)
        call zfp_stream_close(zfp)
        call stream_close(bs)
    end subroutine decompress

    subroutine destroy(self)
    !! Cleans up the compressor resources
        class(compressor_zfp),      intent(inout)   :: self !! Compressor instance

        if ( self%policy%val /= zfp_exec_cuda%val ) return
#ifdef DTFFT_WITH_CUDA
        CUDA_CALL( cudaEventDestroy(self%event) )
#endif
    end subroutine destroy

    subroutine pre_sync(self, stream)
        class(compressor_zfp),      intent(inout)  :: self                 !! Abstract kernel
        type(dtfft_stream_t),       intent(in)     :: stream

        if ( self%policy%val /= zfp_exec_cuda%val ) return
#ifdef DTFFT_WITH_CUDA
        CUDA_CALL( cudaEventRecord(self%event, stream) )
        ! Waiting for transpose kernel to finish execution on stream `stream`
        CUDA_CALL( cudaStreamWaitEvent(NULL_STREAM, self%event, 0) )
#endif
    end subroutine pre_sync

    subroutine post_sync(self, stream)
        class(compressor_zfp),      intent(inout)  :: self                 !! Abstract kernel
        type(dtfft_stream_t),       intent(in)  :: stream

        if ( self%policy%val /= zfp_exec_cuda%val ) return
#ifdef DTFFT_WITH_CUDA
        CUDA_CALL( cudaEventRecord(self%event, NULL_STREAM) )
        ! Waiting for compression kernel to finish execution on stream `stream`
        CUDA_CALL( cudaStreamWaitEvent(stream, self%event, 0) )
#endif
    end subroutine post_sync

    subroutine sync(self, stream)
        class(compressor_zfp),      intent(inout)  :: self                 !! Abstract kernel
        type(dtfft_stream_t),       intent(in)  :: stream

        if ( self%policy%val /= zfp_exec_cuda%val ) return
#ifdef DTFFT_WITH_CUDA
        CUDA_CALL( cudaStreamSynchronize(NULL_STREAM) )
#endif
    end subroutine sync
end module dtfft_compressor_zfp

module dtfft_interface_fftw_native_m
use iso_c_binding, only: c_int, c_int32_t, c_intptr_t, c_double_complex, c_double,  &
                         c_ptr, c_funptr, c_size_t, c_float, c_float_complex, c_char
implicit none
private
public :: FFTW_MEASURE, FFTW_DESTROY_INPUT, C_FFTW_R2R_KIND
public :: fftw_destroy_plan, fftwf_destroy_plan
public :: fftw_malloc, fftw_free
public :: fftw_init_threads, fftw_plan_with_nthreads
#ifdef FFTW_HAS_PLANNER_NTHREADS
public :: fftw_planner_nthreads
#endif

include "fftw3.f03"
endmodule dtfft_interface_fftw_native_m

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_interface_cuda
!! CUDA Driver Interfaces
!!
!! CUDA Driver is loaded at runtime via dynamic loading.
use iso_c_binding
use iso_fortran_env
use dtfft_errors,                 only: DTFFT_SUCCESS
use dtfft_parameters,             only: dtfft_stream_t
use dtfft_utils
#include "_dtfft_mpi.h"
implicit none
private
#include "_dtfft_private.h"
public :: load_cuda
public :: cuLaunchKernel

public :: dim3
  type, bind(C) :: dim3
  !! Dimension specification type
    integer(c_int) :: x,y,z
  end type

  integer(int32), parameter, public :: MAX_KERNEL_ARGS = 9

public :: CUmodule
  type, bind(C) :: CUmodule
  !! CUDA module
    type(c_ptr) :: ptr  !! Actual pointer
  end type CUmodule

public :: CUfunction
#ifdef DTFFT_WITH_MOCK_ENABLED
  abstract interface
#ifndef DTFFT_WITH_OPENMP
    pure &
#endif
    subroutine simple_interface_r32(in, out, dims)
    import
      real(real32),     intent(in)    :: in(BUFFER_SPEC)            !! Source host-allocated buffer
      real(real32),     intent(inout) :: out(BUFFER_SPEC)           !! Target host-allocated buffer
      integer(int32),   intent(in)    :: dims(:)                    !! Dimensions of the array
    end subroutine simple_interface_r32

#ifndef DTFFT_WITH_OPENMP
    pure &
#endif
    subroutine simple_interface_r64(in, out, dims)
    import
      real(real64),     intent(in)    :: in(BUFFER_SPEC)            !! Source host-allocated buffer
      real(real64),     intent(inout) :: out(BUFFER_SPEC)           !! Target host-allocated buffer
      integer(int32),   intent(in)    :: dims(:)                    !! Dimensions of the array
    end subroutine simple_interface_r64

#ifndef DTFFT_WITH_OPENMP
    pure &
#endif
    subroutine simple_interface_r128(in, out, dims)
    import
      complex(real64),  intent(in)    :: in(BUFFER_SPEC)            !! Source host-allocated buffer
      complex(real64),  intent(inout) :: out(BUFFER_SPEC)           !! Target host-allocated buffer
      integer(int32),   intent(in)    :: dims(:)                    !! Dimensions of the array
    end subroutine simple_interface_r128

#ifndef DTFFT_WITH_OPENMP
    pure &
#endif
    subroutine pipe_interface_r32(in, out, dims, locals)
    import
      real(real32),     intent(in)    :: in(BUFFER_SPEC)            !! Source host-allocated buffer
      real(real32),     intent(inout) :: out(BUFFER_SPEC)           !! Target host-allocated buffer
      integer(int32),   intent(in)    :: dims(:)                    !! Dimensions of the array
      integer(int32),   intent(in)    :: locals(:)                  !! Local memory size specification
    end subroutine pipe_interface_r32

#ifndef DTFFT_WITH_OPENMP
    pure &
#endif
    subroutine pipe_interface_r64(in, out, dims, locals)
    import
      real(real64),     intent(in)    :: in(BUFFER_SPEC)            !! Source host-allocated buffer
      real(real64),     intent(inout) :: out(BUFFER_SPEC)           !! Target host-allocated buffer
      integer(int32),   intent(in)    :: dims(:)                    !! Dimensions of the array
      integer(int32),   intent(in)    :: locals(:)                  !! Local memory size specification
    end subroutine pipe_interface_r64

#ifndef DTFFT_WITH_OPENMP
    pure &
#endif
    subroutine pipe_interface_r128(in, out, dims, locals)
    import
      complex(real64),  intent(in)    :: in(BUFFER_SPEC)            !! Source host-allocated buffer
      complex(real64),  intent(inout) :: out(BUFFER_SPEC)           !! Target host-allocated buffer
      integer(int32),   intent(in)    :: dims(:)                    !! Dimensions of the array
      integer(int32),   intent(in)    :: locals(:)                  !! Local memory size specification
    end subroutine pipe_interface_r128
  end interface

  type :: CUfunction
  !! CUDA function (mock)
    procedure(simple_interface_r32), pointer,  nopass :: sfun_r32 => null()  !! Pointer to the Fortran subroutine implementing the kernel
    procedure(simple_interface_r64), pointer,  nopass :: sfun_r64 => null()  !! Pointer to the Fortran subroutine implementing the kernel
    procedure(simple_interface_r128), pointer, nopass :: sfun_r128 => null()  !! Pointer to the Fortran subroutine implementing the kernel
    procedure(pipe_interface_r32), pointer,  nopass :: pfun_r32 => null()  !! Pointer to the Fortran subroutine implementing the pipelined kernel
    procedure(pipe_interface_r64), pointer,  nopass :: pfun_r64 => null()  !! Pointer to the Fortran subroutine implementing the pipelined kernel
    procedure(pipe_interface_r128), pointer, nopass :: pfun_r128 => null()  !! Pointer to the Fortran subroutine implementing the pipelined kernel
  end type CUfunction
#else
  type, bind(C) :: CUfunction
  !! CUDA function
    type(c_ptr) :: ptr  !! Actual pointer
  end type CUfunction
#endif

  logical,        save :: is_loaded = .false.
    !! Flag indicating whether the library is loaded
  type(c_ptr),    save :: libcuda
    !! Handle to the loaded library
  type(c_funptr), save :: cuFunctions(4)
    !! Array of pointers to the CUDA functions

#ifndef DTFFT_WITH_MOCK_ENABLED
! Real CUDA Driver interfaces with dynamic loading

  abstract interface
    function cuModuleLoadData_interface(mod, image)                                                   &
      result(cuResult)
    !! Load a module's data with options.
    !!
    !! Takes a pointer image and loads the corresponding module module into the current context.
    !! The image may be a cubin or fatbin as output by nvcc, or a NULL-terminated PTX, either as output by nvcc or hand-written.
    import
      type(CUmodule)        :: mod          !! Returned module
      type(c_ptr),    value :: image        !! Module data to load
      integer(c_int)        :: cuResult     !! Driver result code
    end function cuModuleLoadData_interface

    function cuModuleUnload_interface(hmod)                                                           &
      result(cuResult)
    !! Unloads a module.
    !!
    !! Unloads a module ``hmod`` from the current context.
    !! Attempting to unload a module which was obtained from the Library Management API
    !! such as ``cuLibraryGetModule`` will return ``CUDA_ERROR_NOT_PERMITTED``.
    import
      type(CUmodule), value :: hmod         !! Module to unload
      integer(c_int)        :: cuResult     !! Driver result code
    end function cuModuleUnload_interface

    function cuModuleGetFunction_interface(hfunc, hmod, name)                                          &
      result(cuResult)
    !! Returns a function handle.
    !!
    !! Returns in ``hfunc`` the handle of the function of name name located in module hmod.
    !! If no function of that name exists, ``cuModuleGetFunction`` returns ``CUDA_ERROR_NOT_FOUND``.
    import
      type(CUfunction)      :: hfunc        !! Returns a function handle.
      type(CUmodule), value :: hmod         !! Module to retrieve function from
      type(c_ptr),    value :: name         !! Name of function to retrieve
      integer(c_int)        :: cuResult     !! Driver result code
    end function cuModuleGetFunction_interface

    function cuLaunchKernel_interface(func, gridDimX, gridDimY, gridDimZ, blockDimX, blockDimY, blockDimZ, sharedMemBytes, stream, kernelParams, extra)                                          &
      result(cuResult)
    !! Launches a CUDA function CUfunction.
    import
      type(CUfunction),     value :: func               !! CUDA function to launch
      integer(c_int),       value :: gridDimX           !! Grid dimensions in X
      integer(c_int),       value :: gridDimY           !! Grid dimensions in Y
      integer(c_int),       value :: gridDimZ           !! Grid dimensions in Z
      integer(c_int),       value :: blockDimX          !! Block dimensions in X
      integer(c_int),       value :: blockDimY          !! Block dimensions in Y
      integer(c_int),       value :: blockDimZ          !! Block dimensions in Z
      integer(c_int),       value :: sharedMemBytes     !! Dynamic shared memory size
      type(dtfft_stream_t), value :: stream             !! Stream identifier
      type(c_ptr)                 :: kernelParams(*)    !! Array of pointers to kernel parameters
      type(c_ptr)                 :: extra              !! Dynamic shared-memory size per thread block in bytes
      integer(c_int)              :: cuResult           !! Driver result code
    end function cuLaunchKernel_interface
  end interface

  procedure(cuModuleLoadData_interface),     pointer, public  :: cuModuleLoadData
    !! Fortran pointer to the cuModuleLoadData function
  procedure(cuModuleUnload_interface),       pointer, public  :: cuModuleUnload
    !! Fortran pointer to the cuModuleUnload function
  procedure(cuModuleGetFunction_interface),  pointer, public  :: cuModuleGetFunction
    !! Fortran pointer to the cuModuleGetFunction function
  procedure(cuLaunchKernel_interface),       pointer          :: cuLaunchKernel_
    !! Fortran pointer to the cuLaunchKernel function

#else
! Mock CUDA Driver interfaces for CPU testing
public :: cuModuleLoadData, cuModuleUnload, cuModuleGetFunction
#endif

contains

#ifdef DTFFT_WITH_MOCK_ENABLED
  ! Mock implementations for CPU testing

  function cuModuleLoadData(mod, image) result(cuResult)
  !! Mock: Creates dummy module
    type(CUmodule)         :: mod
    type(c_ptr), intent(in) :: image
    integer(c_int)         :: cuResult
    mod%ptr = image
    cuResult = 0  ! CUDA_SUCCESS
  end function cuModuleLoadData

  function cuModuleUnload(hmod) result(cuResult)
  !! Mock: Does nothing
    type(CUmodule), intent(in) :: hmod
    integer(c_int)             :: cuResult
    cuResult = 0  ! CUDA_SUCCESS
  end function cuModuleUnload

  function cuModuleGetFunction(hfunc, hmod, name) result(cuResult)
  !! Mock: Returns dummy function handle
    type(CUfunction)           :: hfunc
    type(CUmodule),  intent(in) :: hmod
    type(c_ptr),     intent(in) :: name
    integer(c_int)             :: cuResult
    ! hfunc%ptr = name
    cuResult = 0  ! CUDA_SUCCESS
  end function cuModuleGetFunction

  function load_cuda() result(error_code)
  !! Mock: Does nothing, always returns success
    integer(int32)  :: error_code
    type(string), allocatable :: func_names(:)
    integer(int32)  :: ierr

    error_code = DTFFT_SUCCESS
    if ( is_loaded ) return
    allocate(func_names(1))
    func_names(1) = string("dtfft_execute")

    ! Just try loading both libs
    ierr = dynamic_load("libdtfft.so", func_names, libcuda, cuFunctions)
    if ( ierr /= DTFFT_SUCCESS ) then
      ierr = dynamic_load("libdtfft.dylib", func_names, libcuda, cuFunctions)
    endif

    call destroy_strings(func_names)
    if ( ierr == DTFFT_SUCCESS ) then
      call unload_library(libcuda)
    endif
    is_loaded = .true.
  end function load_cuda

#else
  ! Real CUDA Driver implementation with dynamic loading

  function load_cuda() result(error_code)
  !! Loads the CUDA Driver library and needed symbols
    integer(int32)  :: error_code !! Error code
    type(string), allocatable :: func_names(:)

    error_code = DTFFT_SUCCESS
    if ( is_loaded ) return

    allocate(func_names(4))
    func_names(1) = string("cuModuleLoadData")
    func_names(2) = string("cuModuleUnload")
    func_names(3) = string("cuModuleGetFunction")
    func_names(4) = string("cuLaunchKernel")

    error_code = dynamic_load("libcuda.so", func_names, libcuda, cuFunctions)
    call destroy_strings(func_names)
    if ( error_code /= DTFFT_SUCCESS ) return

    call c_f_procpointer(cuFunctions(1), cuModuleLoadData)
    call c_f_procpointer(cuFunctions(2), cuModuleUnload)
    call c_f_procpointer(cuFunctions(3), cuModuleGetFunction)
    call c_f_procpointer(cuFunctions(4), cuLaunchKernel_)

    is_loaded = .true.
  end function load_cuda

#endif

  function cuLaunchKernel(func, in, out, blocks, threads, stream, nargs, args) result(cuResult)
  !! Launches a CUDA kernel
    type(CUfunction),         intent(in)  :: func             !! Function CUfunction or Kernel CUkernel to launch
    type(c_ptr),      target, intent(in)  :: in               !! Input pointer
    type(c_ptr),      target, intent(in)  :: out              !! Output pointer
    type(dim3),               intent(in)  :: blocks           !! Grid in blocks
    type(dim3),               intent(in)  :: threads          !! Thread block
    type(dtfft_stream_t),     intent(in)  :: stream           !! Stream identifier
    integer(int32),           intent(in)  :: nargs
    integer(int32),   target, intent(in)  :: args(MAX_KERNEL_ARGS)     !! Input parameters of kernel `func`
    integer(c_int)                        :: cuResult         !! Driver result code
    type(c_ptr)                           :: params(15)
    integer(int32) :: i, temp
    integer(int32) :: dims(3), locals(5)

#ifndef DTFFT_WITH_MOCK_ENABLED
    params(:) = c_null_ptr
    ! Addresses of pointers are required, not the pointers themselves
    params(1) = c_loc(out)
    params(2) = c_loc(in)

    temp = 2
    do i = 1, nargs
      params(temp + i) = c_loc(args(i))
    enddo
    cuResult = cuLaunchKernel_(func, blocks%x, blocks%y, blocks%z, threads%x, threads%y, threads%z, 0, stream, params, c_null_ptr)
#else
    dims(:) = 1
    locals(:) = 0

    if ( associated(func%sfun_r32) .or. associated(func%sfun_r64) .or. associated(func%sfun_r128)) then
      do i = 1, nargs
        dims(i) = args(i)
      enddo

      if ( associated(func%sfun_r32) ) then
        block
          real(real32), pointer, contiguous :: in_ptr(:), out_ptr(:)

          call c_f_pointer(in, in_ptr, [product(dims)])
          call c_f_pointer(out, out_ptr, [product(dims)])
          call func%sfun_r32(in_ptr, out_ptr, dims)
        endblock
      else if ( associated(func%sfun_r64) ) then
        block
          real(real64), pointer, contiguous :: in_ptr(:), out_ptr(:)

          call c_f_pointer(in, in_ptr, [product(dims)])
          call c_f_pointer(out, out_ptr, [product(dims)])
          call func%sfun_r64(in_ptr, out_ptr, dims)
        endblock
      else if ( associated(func%sfun_r128) ) then
        block
          complex(real64), pointer, contiguous :: in_ptr(:), out_ptr(:)

          call c_f_pointer(in, in_ptr, [product(dims)])
          call c_f_pointer(out, out_ptr, [product(dims)])
          call func%sfun_r128(in_ptr, out_ptr, dims)
        endblock
      endif
    else if ( associated(func%pfun_r32) .or. associated(func%pfun_r64) .or. associated(func%pfun_r128)) then
      if ( args(3) == -1 )then
        dims(1:2) = args(1:2)
        locals(1:5) = args(3:7)
      else
        dims(1:3) = args(1:3)
        locals(1:5) = args(4:8)
      endif
      if ( associated(func%pfun_r32) ) then
        block
          real(real32), pointer, contiguous :: in_ptr(:), out_ptr(:)

          call c_f_pointer(in, in_ptr, [product(dims)])
          call c_f_pointer(out, out_ptr, [product(dims)])
          
          call func%pfun_r32(in_ptr, out_ptr, dims, locals)
        endblock
      else if ( associated(func%pfun_r64) ) then
        block
          real(real64), pointer, contiguous :: in_ptr(:), out_ptr(:)

          call c_f_pointer(in, in_ptr, [product(dims)])
          call c_f_pointer(out, out_ptr, [product(dims)])
          call func%pfun_r64(in_ptr, out_ptr, dims, locals)
        endblock
      else if ( associated(func%pfun_r128) ) then
        block
          complex(real64), pointer, contiguous :: in_ptr(:), out_ptr(:)

          call c_f_pointer(in, in_ptr, [product(dims)])
          call c_f_pointer(out, out_ptr, [product(dims)])
          call func%pfun_r128(in_ptr, out_ptr, dims, locals)
        endblock
      endif
    else
      INTERNAL_ERROR("cuLaunchKernel: invalid function handle")
    endif

    cuResult = DTFFT_SUCCESS
#endif
  end function cuLaunchKernel
end module dtfft_interface_cuda

program test_compression
use iso_c_binding
use iso_fortran_env
use dtfft_abstract_kernel
use dtfft_abstract_compressor
use dtfft_compressor_zfp
use dtfft_config
use dtfft_kernel_host
use dtfft_parameters
use dtfft_utils
#include "_dtfft_cuda.h"
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
implicit none
integer(int32) :: ierror

    call MPI_Init(ierror)
    ! ierror = init_internal()

    call test_pack_unpack([16, 16, 16])
    call test_pack_unpack([16, 16])

    call test_transpose([32, 64, 128], KERNEL_PERMUTE_FORWARD, KERNEL_UNPACK, KERNEL_PERMUTE_BACKWARD, KERNEL_UNPACK)
    call test_transpose([32, 64, 128], KERNEL_PACK, KERNEL_UNPACK_FORWARD, KERNEL_PACK, KERNEL_UNPACK_BACKWARD)
    call test_transpose([32, 64, 128], KERNEL_PACK_FORWARD, KERNEL_UNPACK, KERNEL_PACK_BACKWARD, KERNEL_UNPACK)
    call test_transpose([64, 128], KERNEL_PERMUTE_FORWARD, KERNEL_UNPACK, KERNEL_PERMUTE_BACKWARD, KERNEL_UNPACK)
    call test_transpose([64, 128], KERNEL_PACK, KERNEL_UNPACK_FORWARD, KERNEL_PACK, KERNEL_UNPACK_BACKWARD)
    call test_transpose([64, 128], KERNEL_PACK_FORWARD, KERNEL_UNPACK, KERNEL_PACK_BACKWARD, KERNEL_UNPACK)

    call MPI_Finalize(ierror)
contains

    subroutine test_pack_unpack(dims)
        integer(int32), intent(in) :: dims(:)
        type(kernel_host) :: packer, unpacker
        type(compressor_zfp) :: compressor
        integer(int32) :: locals(5, 1)
        type(c_ptr) :: in, out, aux
        complex(real32), pointer :: in_ptr(:)
        complex(real32), allocatable :: test(:)
        integer(int32) :: compressed_sizes(1)
        integer(int32) :: i
        type(dtfft_compression_config_t) :: config

        locals(:, 1) = 0
        locals(1:size(dims), 1) = dims

        print*,'Testing Pack/Unpack kernels with compression, ndims = ', size(dims)

        config = dtfft_compression_config_t(DTFFT_COMPRESSION_LIB_ZFP, DTFFT_COMPRESSION_MODE_LOSSLESS)
        ierror = check_compression_config(config)

        ierror = compressor%create(size(dims, kind=int8), config, DTFFT_PLATFORM_HOST, MPI_COMPLEX, COMPLEX_STORAGE_SIZE, DIMS_PERMUTE_NONE)

        call packer%create(dims, DTFFT_ESTIMATE, COMPLEX_STORAGE_SIZE, KERNEL_PACK, locals, with_compression=.true.)
        call packer%set_compressor(compressor)

        call unpacker%create(dims, DTFFT_ESTIMATE, COMPLEX_STORAGE_SIZE, KERNEL_UNPACK, locals, with_decompression=.true.)
        call unpacker%set_compressor(compressor)

        in = mem_alloc_host(COMPLEX_STORAGE_SIZE * product(dims))
        out = mem_alloc_host(COMPLEX_STORAGE_SIZE * product(dims))
        aux = mem_alloc_host(COMPLEX_STORAGE_SIZE * product(dims))

        call c_f_pointer(in, in_ptr, [product(dims)])
        allocate(test(product(dims)))
        do i = 1, product(dims)
            in_ptr(i) = cmplx(real(i, real32), 0.0_real32)
            test(i) = in_ptr(i)
        end do

        call packer%execute(in, out, NULL_STREAM, aux=aux, csizes=compressed_sizes, sync=.true.)
        call unpacker%execute(out, in, NULL_STREAM, aux=aux, sync=.true.)

        if ( any(abs(in_ptr - test) > 1.e-5_real32) ) then
            INTERNAL_ERROR("Test FAILED")
        end if

        call compressor%destroy()
        call packer%destroy()
        call unpacker%destroy()

        call mem_free_host(in)
        call mem_free_host(out)
        call mem_free_host(aux)

        print*,'SUCCESS'
    end subroutine test_pack_unpack

    subroutine test_transpose(dims, f, fu, b, bu)
        integer(int32),      intent(in) :: dims(:)
        type(kernel_type_t), intent(in) :: f, fu, b, bu
        type(kernel_host) :: forward, backward, forward_unpacker, backward_unpacker
        type(compressor_zfp) :: compressor_forward, compressor_backward
        integer(int32) :: locals(5, 1)
        integer(int32), allocatable :: temp_dims(:)
        type(c_ptr) :: in, out, aux
        real(real64), pointer :: in_ptr(:), out_ptr(:)
        real(real64), allocatable :: test(:)
        integer(int32) :: compressed_sizes(1)
        integer(int32) :: i
        type(string) :: sf, sfu, sb, sbu

        sf = get_kernel_string(f); sfu = get_kernel_string(fu)
        sb = get_kernel_string(b); sbu = get_kernel_string(bu)
        print*,'Testing transpose kernels with compression, ndims = '//to_str(size(dims))
        print*,'    Forward method = '//sf%raw//" + "//sfu%raw
        print*,'    Backward method = '//sb%raw//" + "//sbu%raw

        call sf%destroy(); call sfu%destroy()
        call sb%destroy(); call sbu%destroy()

        allocate( temp_dims(size(dims)) )
        if ( size(dims) == 2 ) then
            temp_dims(:) = [dims(2), dims(1)]
        else
            temp_dims(:) = [dims(2), dims(3), dims(1)]
        end if
        locals(:, 1) = 0

        ierror = compressor_forward%create(size(dims, kind=int8), DEFAULT_COMPRESSION_CONFIG, DTFFT_PLATFORM_HOST, MPI_REAL8, DOUBLE_STORAGE_SIZE, DIMS_PERMUTE_BACKWARD)
        ierror = compressor_backward%create(size(dims, kind=int8), DEFAULT_COMPRESSION_CONFIG, DTFFT_PLATFORM_HOST, MPI_REAL8, DOUBLE_STORAGE_SIZE, DIMS_PERMUTE_FORWARD)

        locals(1:size(dims), 1) = dims
        call forward%create(dims, DTFFT_ESTIMATE, DOUBLE_STORAGE_SIZE, f, locals, with_compression=.true.)
        call forward%set_compressor(compressor_forward)

        locals(1:size(dims), 1) = temp_dims
        call forward_unpacker%create(temp_dims, DTFFT_ESTIMATE, DOUBLE_STORAGE_SIZE, fu, locals, with_decompression=.true.)
        call forward_unpacker%set_compressor(compressor_forward)

        locals(1:size(dims), 1) = temp_dims
        call backward%create(temp_dims, DTFFT_ESTIMATE, DOUBLE_STORAGE_SIZE, b, locals, with_compression=.true.)
        call backward%set_compressor(compressor_backward)

        locals(1:size(dims), 1) = dims
        call backward_unpacker%create(dims, DTFFT_ESTIMATE, DOUBLE_STORAGE_SIZE, bu, locals, with_decompression=.true.)
        call backward_unpacker%set_compressor(compressor_backward)

        in = mem_alloc_host(DOUBLE_STORAGE_SIZE * product(dims))
        out = mem_alloc_host(DOUBLE_STORAGE_SIZE * product(dims))
        aux = mem_alloc_host(DOUBLE_STORAGE_SIZE * product(dims))

        call c_f_pointer(in, in_ptr, [product(dims)])
        call c_f_pointer(out, out_ptr, [product(dims)])
        allocate(test(product(dims)))
        do i = 1, product(dims)
            in_ptr(i) = real(i, real64)
            test(i) = in_ptr(i)
        end do

        if ( f == KERNEL_PERMUTE_FORWARD .or. f == KERNEL_PACK ) then
            call forward%execute(in, out, NULL_STREAM, aux=aux, csizes=compressed_sizes, sync=.true.)
            call forward_unpacker%execute(out, in, NULL_STREAM, aux=aux, sync=.true.)
        else
            call forward%execute(in, out, NULL_STREAM, neighbor=1, aux=aux, csize=compressed_sizes(1), sync=.true.)
            call forward_unpacker%execute(out, in, NULL_STREAM, aux=aux, sync=.true.)
        endif

        if ( b == KERNEL_PERMUTE_BACKWARD .or. b == KERNEL_PACK ) then
            call backward%execute(in, out, NULL_STREAM, aux=aux, csizes=compressed_sizes, sync=.true.)
            call backward_unpacker%execute(out, in, NULL_STREAM, neighbor=1, aux=aux, sync=.true.)
        else
            call backward%execute(in, out, NULL_STREAM, neighbor=1, aux=aux, csize=compressed_sizes(1), sync=.true.)
            call backward_unpacker%execute(out, in, NULL_STREAM, neighbor=1, aux=aux, sync=.true.)
        endif

        if ( any(abs(in_ptr - test) > 1.e-15_real64) ) then
            INTERNAL_ERROR("Test FAILED")
        end if

        call compressor_forward%destroy()
        call compressor_backward%destroy()
        call forward%destroy()
        call backward%destroy()
        call forward_unpacker%destroy()
        call backward_unpacker%destroy()

        call mem_free_host(in)
        call mem_free_host(out)
        call mem_free_host(aux)
        deallocate(temp_dims, test)

        print*,'SUCCESS'
    end subroutine test_transpose
end program test_compression

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_abstract_reshape_handle
!! This module defines `abstract_reshape_handle` type and its type bound procedures.
!!
!! This handle is used to perform data transpositions between distributed pencils.
!! The actual implementation of the handle is deferred to the
!! `create_private`, `execute`, `execute_end`, `destroy` and `get_async_active` procedures.
use iso_fortran_env
use iso_c_binding
use dtfft_abstract_backend
#ifdef DTFFT_WITH_COMPRESSION
use dtfft_abstract_compressor, only: dtfft_compression_config_t
#endif
use dtfft_config
use dtfft_parameters
use dtfft_pencil
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
implicit none
private
public :: abstract_reshape_handle
public :: reshape_container
public :: create_args
public :: execute_args

    type :: create_args
    !! Arguments for creating transpose handle
        type(dtfft_platform_t)              :: platform           !! Platform type
        type(backend_helper)                :: helper             !! Backend helper
        type(dtfft_effort_t)                :: effort             !! Effort level for generating transpose kernels
        type(dtfft_backend_t)               :: backend            !! Backend type
        logical                             :: force_effort       !! Should effort be forced or not
        TYPE_MPI_DATATYPE                   :: base_type          !! Base MPI Datatype
        integer(int8)                       :: comm_id            !! ID of communicator to use
        integer(int64)                      :: base_storage       !! Base storage size in bytes
        type(dtfft_transpose_mode_t)        :: transpose_mode     !! Transpose mode to use
#ifdef DTFFT_WITH_COMPRESSION
        type(dtfft_compression_config_t)    :: compression_config !! Compression options
#endif
    end type create_args

    type :: execute_args
    !! Arguments for executing transpose handle
        type(dtfft_stream_t)    :: stream           !! Stream to execute on
        type(async_exec_t)      :: exec_type        !! Async execution type
        type(c_ptr)             :: p1               !! `aux` pointer for pipelined operations, `in` pointer for [[execute_end]]
        type(c_ptr)             :: p2               !! `out` pointer for [[execute_end]]
        type(c_ptr)             :: p3               !! `in` pointer for unpack-free generic reshape
    end type execute_args

    type, abstract :: abstract_reshape_handle
    !! Abstract reshape handle type
        logical                         :: is_transpose !! Is this a transpose operation
    contains
        procedure, non_overridable, pass(self)            :: create           !! Creates reshape handle
        procedure,                  pass(self)            :: get_aux_bytes     !! Returns number of bytes required by aux buffer
#ifdef DTFFT_WITH_COMPRESSION
        procedure,                  pass(self)            :: report_compression
#endif
        procedure(create_interface),            deferred  :: create_private   !! Creates reshape handle
        procedure(execute_interface),           deferred  :: execute          !! Executes reshape handle
        procedure(execute_end_interface),       deferred  :: execute_end      !! Finishes async reshape
        procedure(destroy_interface),           deferred  :: destroy          !! Destroys reshape handle
        procedure(get_async_active_interface),  deferred  :: get_async_active !! Returns if async reshape is active
        procedure(get_backend_interface),       deferred  :: get_backend
    end type abstract_reshape_handle

    type :: reshape_container
    !! This type is a container for allocatable transpose handles
        class(abstract_reshape_handle), allocatable :: p  !! Transpose handle
    end type reshape_container

    abstract interface
        subroutine create_interface(self, comm, send, recv, kwargs)
        !! Creates reshape handle
        import
            class(abstract_reshape_handle),   intent(inout) :: self           !! Abstract reshape handle
            TYPE_MPI_COMM,                    intent(in)    :: comm           !! MPI Communicator
            type(pencil),                     intent(in)    :: send           !! Send pencil
            type(pencil),                     intent(in)    :: recv           !! Recv pencil
            type(create_args),                intent(in)    :: kwargs         !! Additional arguments
        end subroutine create_interface

        subroutine execute_interface(self, in, out, kwargs, error_code)
        !! Executes reshape handle
        import
            class(abstract_reshape_handle), intent(inout)   :: self         !! Abstract reshape Handle
            type(c_ptr),                    intent(in)      :: in           !! Send pointer
            type(c_ptr),                    intent(in)      :: out          !! Recv pointer
            type(execute_args),             intent(inout)   :: kwargs       !! Additional arguments
            integer(int32),                 intent(out)     :: error_code   !! Error code
        end subroutine execute_interface

        subroutine execute_end_interface(self, kwargs, error_code)
        !! Finishes async reshape
        import
            class(abstract_reshape_handle),   intent(inout) :: self       !! Abstract reshape Handle
            type(execute_args),               intent(inout) :: kwargs     !! Additional arguments
            integer(int32),                   intent(out)   :: error_code !! Error code
        end subroutine execute_end_interface

        subroutine destroy_interface(self)
        !! Destroys reshape handle
        import
            class(abstract_reshape_handle),   intent(inout) :: self       !! Abstract reshape Handle
        end subroutine destroy_interface

        elemental logical function get_async_active_interface(self)
        !! Returns if async reshape is active
        import
            class(abstract_reshape_handle),   intent(in)    :: self       !! Abstract reshape Handle
        end function get_async_active_interface

        elemental type(dtfft_backend_t) function get_backend_interface(self)
        import
            class(abstract_reshape_handle),   intent(in)    :: self       !! Abstract reshape Handle
        end function get_backend_interface
    end interface

contains

    subroutine create(self, send, recv, kwargs)
    !! Creates reshape handle
        class(abstract_reshape_handle),   intent(inout) :: self           !! Abstract reshape handle
        type(pencil),                     intent(in)    :: send           !! Send pencil
        type(pencil),                     intent(in)    :: recv           !! Recv pencil
        type(create_args),                intent(inout) :: kwargs         !! Additional arguments
        type(dtfft_transpose_t)           :: transpose_type
        type(dtfft_reshape_t)             :: reshape_type
        TYPE_MPI_COMM                     :: comm
        integer(int8)                     :: comm_id

        transpose_type = get_transpose_type(send, recv)
        reshape_type = dtfft_reshape_t(0)
        self%is_transpose = is_valid_transpose_type(transpose_type)
        comm_id = 0
        if ( self%is_transpose ) then
            select case ( abs(transpose_type%val) )
            case ( DTFFT_TRANSPOSE_X_TO_Y%val )
                comm_id = 2
            case ( DTFFT_TRANSPOSE_Y_TO_Z%val )
                comm_id = 3
            case ( DTFFT_TRANSPOSE_X_TO_Z%val )
                comm_id = 1
            endselect
#ifdef DTFFT_DEBUG
            if ( kwargs%transpose_mode /= DTFFT_TRANSPOSE_MODE_PACK .and. kwargs%transpose_mode /= DTFFT_TRANSPOSE_MODE_UNPACK ) then
                INTERNAL_ERROR("kwargs%transpose_mode /= DTFFT_TRANSPOSE_MODE_PACK .and. kwargs%transpose_mode /= DTFFT_TRANSPOSE_MODE_UNPACK.")
            endif
#endif
        else
            reshape_type = get_reshape_type(send, recv)
#ifdef DTFFT_DEBUG
            if ( .not. is_valid_reshape_type(reshape_type) ) then
                INTERNAL_ERROR("abstract_reshape_handle%create: Unable to determine transpose or reshape type.")
            end if
#endif
            select case ( reshape_type%val )
            case ( DTFFT_RESHAPE_X_BRICKS_TO_PENCILS%val, DTFFT_RESHAPE_X_PENCILS_TO_BRICKS%val )
                comm_id = 2
            case ( DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS%val, DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS%val )
                comm_id = 3
            end select
        endif

        comm = kwargs%helper%comms(comm_id)
        kwargs%helper%transpose_type = transpose_type
        kwargs%helper%reshape_type = reshape_type
        kwargs%comm_id = comm_id
! #ifdef DTFFT_DEBUG
!         block
!             integer(int32) :: comm_size, ierr

!             call MPI_Comm_size(comm, comm_size, ierr)

!             if ( self%is_transpose ) then
!                 WRITE_DEBUG("Creating backend: "//dtfft_get_backend_string(kwargs%backend)//", nproc = "//to_str(comm_size)//", transpose mode = "//trim(TRANSPOSE_MODE_NAMES(kwargs%transpose_mode%val)) )
!             else
!                 WRITE_DEBUG("Creating backend: "//dtfft_get_backend_string(kwargs%backend)//", nproc = "//to_str(comm_size))
!             endif

!         endblock
! #endif
        call self%create_private(comm, send, recv, kwargs)
    end subroutine create

    pure integer(int64) function get_aux_bytes(self)
    !! Returns number of bytes required by aux buffer
        class(abstract_reshape_handle),   intent(in)    :: self         !! Abstract reshape Handle
        get_aux_bytes = 0
    end function get_aux_bytes

#ifdef DTFFT_WITH_COMPRESSION
    subroutine report_compression(self, name)
    !! Reports compression average compression ratio by this reshape handle
        class(abstract_reshape_handle),   intent(in)    :: self         !! Abstract reshape Handle
        character(len=*),                 intent(in)    :: name         !! Name of the reshape handle

        INTERNAL_ERROR("Should have gotten here: "//name)
    end subroutine report_compression
#endif
end module dtfft_abstract_reshape_handle

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_errors
!! Module that defines error codes and provides utility to get error string
use iso_fortran_env, only: int32
implicit none
private
public :: dtfft_get_error_string

  integer(int32),  parameter,  public  :: DTFFT_SUCCESS = CONF_DTFFT_SUCCESS
    !! Successful execution
  integer(int32),  parameter,  public  :: DTFFT_ERROR_MPI_FINALIZED = CONF_DTFFT_ERROR_MPI_FINALIZED
    !! MPI_Init is not called or MPI_Finalize has already been called
  integer(int32),  parameter,  public  :: DTFFT_ERROR_PLAN_NOT_CREATED = CONF_DTFFT_ERROR_PLAN_NOT_CREATED
    !! Plan not created
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_TRANSPOSE_TYPE = CONF_DTFFT_ERROR_INVALID_TRANSPOSE_TYPE
    !! Invalid `transpose_type` provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_N_DIMENSIONS = CONF_DTFFT_ERROR_INVALID_N_DIMENSIONS
    !! Invalid Number of dimensions provided. Valid options are 2 and 3
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_DIMENSION_SIZE = CONF_DTFFT_ERROR_INVALID_DIMENSION_SIZE
    !! One or more provided dimension sizes <= 0
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_COMM_TYPE = CONF_DTFFT_ERROR_INVALID_COMM_TYPE
    !! Invalid communicator type provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_PRECISION = CONF_DTFFT_ERROR_INVALID_PRECISION
    !! Invalid `precision` parameter provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_EFFORT = CONF_DTFFT_ERROR_INVALID_EFFORT_FLAG
    !! Invalid `effort` parameter provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_EXECUTOR = CONF_DTFFT_ERROR_INVALID_EXECUTOR_TYPE
    !! Invalid `executor` parameter provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_COMM_DIMS = CONF_DTFFT_ERROR_INVALID_COMM_DIMS
    !! Number of dimensions in provided Cartesian communicator > Number of dimension passed to `create` subroutine
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_COMM_FAST_DIM = CONF_DTFFT_ERROR_INVALID_COMM_FAST_DIM
    !! Passed Cartesian communicator with number of processes in 1st (fastest varying) dimension > 1
  integer(int32),  parameter,  public  :: DTFFT_ERROR_MISSING_R2R_KINDS = CONF_DTFFT_ERROR_MISSING_R2R_KINDS
    !! For R2R plan, `kinds` parameter must be passed if `executor` != `DTFFT_EXECUTOR_NONE`
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_R2R_KINDS = CONF_DTFFT_ERROR_INVALID_R2R_KINDS
    !! Invalid values detected in `kinds` parameter
  integer(int32),  parameter,  public  :: DTFFT_ERROR_R2C_TRANSPOSE_PLAN = CONF_DTFFT_ERROR_R2C_TRANSPOSE_PLAN
    !! Transpose plan is not supported in R2C, use R2R or C2C plan instead
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INPLACE_TRANSPOSE = CONF_DTFFT_ERROR_INPLACE_TRANSPOSE
    !! Inplace transpose is not supported
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_AUX = CONF_DTFFT_ERROR_INVALID_AUX
    !! Invalid `aux` buffer provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_LAYOUT = CONF_DTFFT_ERROR_INVALID_LAYOUT
    !! Invalid `dim` passed to `plan.get_pencil`
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_USAGE = CONF_DTFFT_ERROR_INVALID_USAGE
    !! Invalid API Usage.
  integer(int32),  parameter,  public  :: DTFFT_ERROR_PLAN_IS_CREATED = CONF_DTFFT_ERROR_PLAN_IS_CREATED
    !! Trying to create already created plan
  integer(int32),  parameter,  public  :: DTFFT_ERROR_ALLOC_FAILED = CONF_DTFFT_ERROR_ALLOC_FAILED
    !! Internal allocation failed
  integer(int32),  parameter,  public  :: DTFFT_ERROR_FREE_FAILED = CONF_DTFFT_ERROR_FREE_FAILED
    !! Internal memory free failed
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_ALLOC_BYTES = CONF_DTFFT_ERROR_INVALID_ALLOC_BYTES
    !! Invalid `alloc_bytes` provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_DLOPEN_FAILED = CONF_DTFFT_ERROR_DLOPEN_FAILED
    !! dlopen failed
  integer(int32),  parameter,  public  :: DTFFT_ERROR_DLSYM_FAILED = CONF_DTFFT_ERROR_DLSYM_FAILED
    !! dlsym failed
  ! integer(int32),  parameter,  public  :: DTFFT_ERROR_R2C_TRANSPOSE_CALLED = CONF_DTFFT_ERROR_R2C_TRANSPOSE_CALLED
    !! Calling to `transpose` method for R2C plan is not allowed
  integer(int32),  parameter,  public  :: DTFFT_ERROR_PENCIL_ARRAYS_SIZE_MISMATCH = CONF_DTFFT_ERROR_PENCIL_ARRAYS_SIZE_MISMATCH
    !! Sizes of `starts` and `counts` arrays passed to `dtfft_pencil_t` constructor do not match
  integer(int32),  parameter,  public  :: DTFFT_ERROR_PENCIL_ARRAYS_INVALID_SIZES = CONF_DTFFT_ERROR_PENCIL_ARRAYS_INVALID_SIZES
    !! Sizes of `starts` and `counts` < 2 or > 3 provided to `dtfft_pencil_t` constructor
  integer(int32),  parameter,  public  :: DTFFT_ERROR_PENCIL_INVALID_COUNTS = CONF_DTFFT_ERROR_PENCIL_INVALID_COUNTS
    !! Invalid `counts` provided to `dtfft_pencil_t` constructor
  integer(int32),  parameter,  public  :: DTFFT_ERROR_PENCIL_INVALID_STARTS = CONF_DTFFT_ERROR_PENCIL_INVALID_STARTS
    !! Invalid `starts` provided to `dtfft_pencil_t` constructor
  integer(int32),  parameter,  public  :: DTFFT_ERROR_PENCIL_SHAPE_MISMATCH = CONF_DTFFT_ERROR_PENCIL_SHAPE_MISMATCH
    !! Processes have same lower bounds but different sizes in some dimensions
  integer(int32),  parameter,  public  :: DTFFT_ERROR_PENCIL_OVERLAP = CONF_DTFFT_ERROR_PENCIL_OVERLAP
    !! Pencil overlap detected, i.e. two processes share same part of global space
  integer(int32),  parameter,  public  :: DTFFT_ERROR_PENCIL_NOT_CONTINUOUS = CONF_DTFFT_ERROR_PENCIL_NOT_CONTINUOUS
    !! Local pencils do not cover the global space without gaps
  integer(int32),  parameter,  public  :: DTFFT_ERROR_PENCIL_NOT_INITIALIZED = CONF_DTFFT_ERROR_PENCIL_NOT_INITIALIZED
    !! Pencil is not initialized, i.e. `constructor` subroutine was not called
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_MEASURE_WARMUP_ITERS = CONF_DTFFT_ERROR_INVALID_MEASURE_WARMUP_ITERS
    !! Invalid `n_measure_warmup_iters` provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_MEASURE_ITERS = CONF_DTFFT_ERROR_INVALID_MEASURE_ITERS
    !! Invalid `n_measure_iters` provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_REQUEST = CONF_DTFFT_ERROR_INVALID_REQUEST
    !! Invalid `dtfft_request_t` provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_TRANSPOSE_ACTIVE = CONF_DTFFT_ERROR_TRANSPOSE_ACTIVE
    !! Attempting to execute already active transposition
  integer(int32),  parameter,  public  :: DTFFT_ERROR_TRANSPOSE_NOT_ACTIVE = CONF_DTFFT_ERROR_TRANSPOSE_NOT_ACTIVE
    !! Attempting to finalize non-active transposition
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_RESHAPE_TYPE = CONF_DTFFT_ERROR_INVALID_RESHAPE_TYPE
    !! Invalid `reshape_type` provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_RESHAPE_ACTIVE = CONF_DTFFT_ERROR_RESHAPE_ACTIVE
    !! Attempting to execute already active reshape
  integer(int32),  parameter,  public  :: DTFFT_ERROR_RESHAPE_NOT_ACTIVE = CONF_DTFFT_ERROR_RESHAPE_NOT_ACTIVE
    !! Attempting to finalize non-active reshape
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INPLACE_RESHAPE = CONF_DTFFT_ERROR_INPLACE_RESHAPE
    !! Inplace reshape is not supported
  ! integer(int32),  parameter,  public  :: DTFFT_ERROR_R2C_RESHAPE_CALLED = CONF_DTFFT_ERROR_R2C_RESHAPE_CALLED
    !! R2C reshape was called
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_EXECUTE_TYPE = CONF_DTFFT_ERROR_INVALID_EXECUTE_TYPE
    !! Invalid `execute_type` provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_RESHAPE_NOT_SUPPORTED = CONF_DTFFT_ERROR_RESHAPE_NOT_SUPPORTED
    !! Reshape is not supported for this plan
  integer(int32),  parameter,  public  :: DTFFT_ERROR_R2C_EXECUTE_CALLED = CONF_DTFFT_ERROR_R2C_EXECUTE_CALLED
    !! Execute called for transpose-only R2C Plan
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_CART_COMM = CONF_DTFFT_ERROR_INVALID_CART_COMM
    !! Invalid cartesian communicator provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_TRANSPOSE_MODE = CONF_DTFFT_ERROR_INVALID_TRANSPOSE_MODE
    !! Invalid transpose mode provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_ACCESS_MODE = CONF_DTFFT_ERROR_INVALID_ACCESS_MODE
    !! Invalid access mode provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_R2R_FFT_NOT_SUPPORTED = CONF_DTFFT_ERROR_R2R_FFT_NOT_SUPPORTED
    !! Selected `executor` do not support R2R FFTs
  integer(int32),  parameter,  public  :: DTFFT_ERROR_GPU_INVALID_STREAM = CONF_DTFFT_ERROR_GPU_INVALID_STREAM
    !! Invalid stream provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_BACKEND = CONF_DTFFT_ERROR_INVALID_BACKEND
    !! Invalid backend provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_GPU_NOT_SET = CONF_DTFFT_ERROR_GPU_NOT_SET
    !! Multiple MPI Processes located on same host share same GPU which is not supported
  integer(int32),  parameter,  public  :: DTFFT_ERROR_VKFFT_R2R_2D_PLAN = CONF_DTFFT_ERROR_VKFFT_R2R_2D_PLAN
    !! When using R2R FFT and executor type is vkFFT and plan uses Z-slab optimization, it is required that types of R2R transform are same in X and Y directions
  integer(int32),  parameter,  public  :: DTFFT_ERROR_BACKENDS_DISABLED = CONF_DTFFT_ERROR_BACKENDS_DISABLED
    !! Passed `effort` ==  `DTFFT_PATIENT` but all Backends has been disabled by `dtfft_config_t` */
  integer(int32),  parameter,  public  :: DTFFT_ERROR_NOT_DEVICE_PTR = CONF_DTFFT_ERROR_NOT_DEVICE_PTR
    !! One of pointers passed to `plan.execute` or `plan.transpose` cannot be accessed from device
  integer(int32),  parameter,  public  :: DTFFT_ERROR_NOT_NVSHMEM_PTR = CONF_DTFFT_ERROR_NOT_NVSHMEM_PTR
    !! One of pointers passed to `plan.execute` or `plan.transpose` is not an `NVSHMEM` pointer
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_PLATFORM = CONF_DTFFT_ERROR_INVALID_PLATFORM
    !! Invalid platform provided
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_PLATFORM_EXECUTOR = CONF_DTFFT_ERROR_INVALID_PLATFORM_EXECUTOR
    !! Invalid executor provided for selected platform
  integer(int32),  parameter,  public  :: DTFFT_ERROR_INVALID_PLATFORM_BACKEND = CONF_DTFFT_ERROR_INVALID_PLATFORM_BACKEND
    !! Invalid backend provided for selected platform
  integer(int32),  parameter,  public  :: DTFFT_ERROR_COMPRESSION_CUDA_NOT_SUPPORTED = CONF_DTFFT_ERROR_COMPRESSION_CUDA_NOT_SUPPORTED
    !! CUDA support is not available for compression
  integer(int32),  parameter,  public  :: DTFFT_ERROR_COMPRESSION_INVALID_RATE = CONF_DTFFT_ERROR_COMPRESSION_INVALID_RATE
    !! Invalid compression rate
  integer(int32),  parameter,  public  :: DTFFT_ERROR_COMPRESSION_INVALID_PRECISION = CONF_DTFFT_ERROR_COMPRESSION_INVALID_PRECISION
    !! Invalid compression precision
  integer(int32),  parameter,  public  :: DTFFT_ERROR_COMPRESSION_INVALID_TOLERANCE = CONF_DTFFT_ERROR_COMPRESSION_INVALID_TOLERANCE
    !! Invalid compression tolerance
  integer(int32),  parameter,  public  :: DTFFT_ERROR_COMPRESSION_INVALID_MODE = CONF_DTFFT_ERROR_COMPRESSION_INVALID_MODE
    !! Invalid compression mode
  integer(int32),  parameter,  public  :: DTFFT_ERROR_COMPRESSION_INVALID_LIBRARY = CONF_DTFFT_ERROR_COMPRESSION_INVALID_LIBRARY
    !! Invalid compression library
  integer(int32),  parameter,  public  :: DTFFT_ERROR_COMPRESSION_NOT_USED = CONF_DTFFT_ERROR_COMPRESSION_NOT_USED
    !! Compressed backends are not used for this plan

contains

  pure function dtfft_get_error_string(error_code) result(error_string)
  !! Gets the string description of an error code
    integer(int32),   intent(in)   :: error_code    !! Error code
    character(len=:), allocatable  :: error_string  !! Error string

    select case (error_code)
    case ( DTFFT_SUCCESS )
      allocate(error_string, source="DTFFT_SUCCESS")
    case ( DTFFT_ERROR_MPI_FINALIZED )
      allocate(error_string, source="MPI_Init is not called or MPI_Finalize has already been called")
    case ( DTFFT_ERROR_PLAN_NOT_CREATED )
      allocate(error_string, source="Plan not created")
    case ( DTFFT_ERROR_INVALID_TRANSPOSE_TYPE )
      allocate(error_string, source="Invalid `transpose_type` provided")
    case ( DTFFT_ERROR_INVALID_N_DIMENSIONS )
      allocate(error_string, source="Invalid Number of dimensions provided. Valid options are 2 and 3")
    case ( DTFFT_ERROR_INVALID_DIMENSION_SIZE )
      allocate(error_string, source="One or more provided dimension sizes <= 0")
    case ( DTFFT_ERROR_INVALID_COMM_TYPE )
      allocate(error_string, source="Invalid communicator type provided")
    case ( DTFFT_ERROR_INVALID_PRECISION )
      allocate(error_string, source="Invalid `precision` parameter provided")
    case ( DTFFT_ERROR_INVALID_EFFORT )
      allocate(error_string, source="Invalid `effort` parameter provided")
    case ( DTFFT_ERROR_INVALID_EXECUTOR )
      allocate(error_string, source="Invalid `executor` parameter provided")
    case ( DTFFT_ERROR_INVALID_COMM_DIMS )
      allocate(error_string, source="Number of dimensions in provided Cartesian communicator > Number of dimension passed to `create` subroutine")
    case ( DTFFT_ERROR_INVALID_COMM_FAST_DIM )
      allocate(error_string, source="Passed Cartesian communicator with number of processes in 1st (fastest varying) dimension > 1 OR provided dtfft_pencil_t with distribution over 1st dimension")
    case ( DTFFT_ERROR_MISSING_R2R_KINDS )
      allocate(error_string, source="For R2R plan, `kinds` parameter must be passed if `executor` != `DTFFT_EXECUTOR_NONE`")
    case ( DTFFT_ERROR_INVALID_R2R_KINDS )
      allocate(error_string, source="Invalid values detected in `kinds` parameter")
    case ( DTFFT_ERROR_R2C_TRANSPOSE_PLAN )
      allocate(error_string, source="Transpose plan is not supported in R2C, use R2R or C2C plan instead")
    case ( DTFFT_ERROR_INVALID_AUX )
      allocate(error_string, source="Invalid `aux` buffer provided")
    case ( DTFFT_ERROR_INPLACE_TRANSPOSE )
      allocate(error_string, source="Inplace transpose is not supported")
    case ( DTFFT_ERROR_R2R_FFT_NOT_SUPPORTED )
      allocate(error_string, source="Selected `executor` do not support R2R FFTs")
    case ( DTFFT_ERROR_INVALID_LAYOUT )
      allocate(error_string, source="Invalid `layout` passed to `dtfft_get_pencil`")
    case ( DTFFT_ERROR_INVALID_USAGE )
      allocate(error_string, source="Invalid API Usage.")
    case ( DTFFT_ERROR_PLAN_IS_CREATED )
      allocate(error_string, source="Trying to create already created plan")
    case ( DTFFT_ERROR_ALLOC_FAILED )
      allocate(error_string, source="Allocation failed")
    case ( DTFFT_ERROR_FREE_FAILED )
      allocate(error_string, source="Memory free failed")
    case ( DTFFT_ERROR_INVALID_ALLOC_BYTES )
      allocate(error_string, source="Invalid `alloc_bytes` provided")
    case ( DTFFT_ERROR_DLOPEN_FAILED )
      allocate(error_string, source="Failed to open shared library. Set DTFFT_ENABLE_LOG=1 to see the error")
    case ( DTFFT_ERROR_DLSYM_FAILED )
      allocate(error_string, source="Failed to find symbol in shared library. Set DTFFT_ENABLE_LOG=1 to see the error")
    ! case ( DTFFT_ERROR_R2C_TRANSPOSE_CALLED )
    !   allocate(error_string, source="Calling to `transpose` method for R2C plan is not allowed")
    case ( DTFFT_ERROR_PENCIL_ARRAYS_SIZE_MISMATCH )
      allocate(error_string, source="Sizes of `lbound` and `sizes` arrays passed to `dtfft_pencil_t` constructor do not match")
    case ( DTFFT_ERROR_PENCIL_ARRAYS_INVALID_SIZES )
      allocate(error_string, source="Sizes of `lbound` and `sizes` < 2 or > 3 provided to `dtfft_pencil_t` constructor")
    case ( DTFFT_ERROR_PENCIL_INVALID_COUNTS )
      allocate(error_string, source="Invalid `counts` provided to `dtfft_pencil_t` constructor")
    case ( DTFFT_ERROR_PENCIL_INVALID_STARTS )
      allocate(error_string, source="Invalid `starts` provided to `dtfft_pencil_t` constructor")
    case ( DTFFT_ERROR_PENCIL_SHAPE_MISMATCH )
      allocate(error_string, source="Processes have same `starts` but different `counts` in some dimensions")
    case ( DTFFT_ERROR_PENCIL_OVERLAP )
      allocate(error_string, source="Pencil overlap detected, i.e. two processes share same part of global space")
    case ( DTFFT_ERROR_PENCIL_NOT_CONTINUOUS )
      allocate(error_string, source="Local pencils do not cover the global space without gaps")
    case ( DTFFT_ERROR_PENCIL_NOT_INITIALIZED )
      allocate(error_string, source="Pencil is not initialized, i.e. `constructor` subroutine was not called")
    case ( DTFFT_ERROR_INVALID_MEASURE_WARMUP_ITERS )
      allocate(error_string, source="Invalid `n_measure_warmup_iters` provided")
    case ( DTFFT_ERROR_INVALID_MEASURE_ITERS )
      allocate(error_string, source="Invalid `n_measure_iters` provided")
    case ( DTFFT_ERROR_INVALID_REQUEST )
      allocate(error_string, source="Invalid `dtfft_request_t` provided")
    case ( DTFFT_ERROR_TRANSPOSE_ACTIVE )
      allocate(error_string, source="Attempting to execute already active transposition")
    case ( DTFFT_ERROR_TRANSPOSE_NOT_ACTIVE )
      allocate(error_string, source="Attempting to finalize non-active transposition")
    case ( DTFFT_ERROR_INVALID_RESHAPE_TYPE )
      allocate(error_string, source="Invalid `reshape_type` provided")
    case ( DTFFT_ERROR_RESHAPE_ACTIVE )
      allocate(error_string, source="Attempting to execute already active reshape")
    case ( DTFFT_ERROR_RESHAPE_NOT_ACTIVE )
      allocate(error_string, source="Attempting to finalize non-active reshape")
    case ( DTFFT_ERROR_INPLACE_RESHAPE )
      allocate(error_string, source="Inplace reshape is not supported")
    ! case ( DTFFT_ERROR_R2C_RESHAPE_CALLED )
    !   allocate(error_string, source="R2C reshape was called")
    case ( DTFFT_ERROR_INVALID_EXECUTE_TYPE )
      allocate(error_string, source="Invalid `execute_type` provided")
    case ( DTFFT_ERROR_RESHAPE_NOT_SUPPORTED )
      allocate(error_string, source="Reshape is not supported for this plan")
    case ( DTFFT_ERROR_R2C_EXECUTE_CALLED )
      allocate(error_string, source="Execute called for transpose-only R2C Plan")
    case ( DTFFT_ERROR_INVALID_CART_COMM )
      allocate(error_string, source="Invalid cartesian communicator provided")
    case ( DTFFT_ERROR_INVALID_TRANSPOSE_MODE )
      allocate(error_string, source="Invalid transpose mode provided")
    case ( DTFFT_ERROR_INVALID_ACCESS_MODE )
      allocate(error_string, source="Invalid access mode provided")
    case ( DTFFT_ERROR_GPU_INVALID_STREAM )
      allocate(error_string, source="Invalid stream provided")
    case ( DTFFT_ERROR_INVALID_BACKEND )
      allocate(error_string, source="Invalid backend provided")
    case ( DTFFT_ERROR_GPU_NOT_SET )
      allocate(error_string, source="Multiple MPI Processes located on same host share same GPU which is not supported")
    case ( DTFFT_ERROR_VKFFT_R2R_2D_PLAN )
      allocate(error_string, source="When using R2R FFT and executor type is vkFFT and plan uses Z-slab optimization, it is required that types of R2R transform are same in X and Y directions")
    case ( DTFFT_ERROR_BACKENDS_DISABLED )
      allocate(error_string, source="Passed `effort` >=  `DTFFT_PATIENT` but all backends are disabled for autotune")
    case ( DTFFT_ERROR_NOT_DEVICE_PTR )
      allocate(error_string, source="One of pointers passed to `dtfft_execute` or `dtfft_transpose` cannot be accessed from device" )
    case ( DTFFT_ERROR_NOT_NVSHMEM_PTR )
      allocate(error_string, source="One of pointers passed to `dtfft_execute` or `dtfft_transpose` is not an `NVSHMEM` pointer" )
    case ( DTFFT_ERROR_INVALID_PLATFORM )
      allocate(error_string, source="Invalid platform provided")
    case ( DTFFT_ERROR_INVALID_PLATFORM_EXECUTOR )
      allocate(error_string, source="Invalid executor provided for selected platform")
    case ( DTFFT_ERROR_INVALID_PLATFORM_BACKEND )
      allocate(error_string, source="Invalid backend provided for selected platform")
    case ( DTFFT_ERROR_COMPRESSION_CUDA_NOT_SUPPORTED )
      allocate(error_string, source="CUDA support is not available for compression")
    case ( DTFFT_ERROR_COMPRESSION_INVALID_RATE )
      allocate(error_string, source="Invalid compression rate")
    case ( DTFFT_ERROR_COMPRESSION_INVALID_PRECISION )
      allocate(error_string, source="Invalid compression precision")
    case ( DTFFT_ERROR_COMPRESSION_INVALID_TOLERANCE )
      allocate(error_string, source="Invalid compression tolerance")
    case ( DTFFT_ERROR_COMPRESSION_INVALID_MODE )
      allocate(error_string, source="Invalid compression mode")
    case ( DTFFT_ERROR_COMPRESSION_INVALID_LIBRARY )
      allocate(error_string, source="Invalid compression library")
    case ( DTFFT_ERROR_COMPRESSION_NOT_USED )
      allocate(error_string, source="Compressed backends are not used for this plan")
    case default
      allocate(error_string, source="Unknown error")
    endselect
  end function dtfft_get_error_string
end module dtfft_errors

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
module dtfft_interface_zfp
!! Fortran interface to ZFP compression library
use iso_c_binding
use iso_fortran_env
implicit none
public :: zfp_create_field, zfp_field_set_stride, zfp_stream_set_rate


public :: zfp_field
    type, bind(C) :: zfp_field
    !! ZFP field type, representing an uncompressed array
        type(c_ptr) :: val
    end type zfp_field

public :: zfp_stream
    type, bind(C) :: zfp_stream
    !! ZFP stream type, representing a compressed stream
        type(c_ptr) :: val
    end type zfp_stream

public :: bitstream
    type, bind(C) :: bitstream
    !! Bitstream type for compressed data
        type(c_ptr) :: val
    end type bitstream

public :: zfp_type
    type, bind(C) :: zfp_type
    !! Scalar type enumeration
        integer(c_int)  :: val
    end type zfp_type

    type(zfp_type), parameter, public :: zfp_type_float = zfp_type(3)
    !! Single precision floating point type

    type(zfp_type), parameter, public :: zfp_type_double = zfp_type(4)
    !! Double precision floating point type

public :: zfp_exec_policy
    type, bind(C) :: zfp_exec_policy
    !! Execution policy enumeration
        integer(c_int)  :: val
    end type zfp_exec_policy

    type(zfp_exec_policy), parameter, public :: zfp_exec_serial = zfp_exec_policy(0)
    !! Serial execution policy

    type(zfp_exec_policy), parameter, public :: zfp_exec_omp = zfp_exec_policy(1)
    !! OpenMP parallel execution policy

    type(zfp_exec_policy), parameter, public :: zfp_exec_cuda = zfp_exec_policy(2)
    !! CUDA parallel execution policy

    interface
        function zfp_field_2d(uncompressed_ptr, scalar_type, nx, ny) result(field) bind(c, name="zfp_field_2d")
        !! Allocate metadata for 2D field f[ny][nx]
        import
            type(c_ptr),        value   :: uncompressed_ptr !! pointer to uncompressed scalars (may be NULL)
            type(zfp_type),     value   :: scalar_type      !! scalar type
            integer(c_size_t),  value   :: nx               !! number of scalars in x dimension
            integer(c_size_t),  value   :: ny               !! number of scalars in y dimension
            type(zfp_field)             :: field            !! allocated field metadata
        end function zfp_field_2d
    end interface

    interface
        function zfp_field_3d(uncompressed_ptr, scalar_type, nx, ny, nz) result(field) bind(c, name="zfp_field_3d")
        !! Allocate metadata for 3D field f[nz][ny][nx]
        import
            type(c_ptr),        value   :: uncompressed_ptr !! pointer to uncompressed scalars (may be NULL)
            type(zfp_type),     value   :: scalar_type      !! scalar type
            integer(c_size_t),  value   :: nx               !! number of scalars in x dimension
            integer(c_size_t),  value   :: ny               !! number of scalars in y dimension
            integer(c_size_t),  value   :: nz               !! number of scalars in z dimension
            type(zfp_field)             :: field            !! allocated field metadata
        end function zfp_field_3d
    end interface

    interface
        subroutine zfp_field_set_stride_2d(field, sx, sy) bind(c, name="zfp_field_set_stride_2d")
        !! Set 2D field strides in number of scalars
        import
            type(zfp_field),        value :: field !! field metadata
            integer(c_ptrdiff_t),   value :: sx    !! stride in x dimension: &f[0][1] - &f[0][0]
            integer(c_ptrdiff_t),   value :: sy    !! stride in y dimension: &f[1][0] - &f[0][0]
        end subroutine zfp_field_set_stride_2d
    end interface

    interface
        subroutine zfp_field_set_stride_3d(field, sx, sy, sz) bind(c, name="zfp_field_set_stride_3d")
        !! Set 3D field strides in number of scalars
        import
            type(zfp_field),        value :: field !! field metadata
            integer(c_ptrdiff_t),   value :: sx    !! stride in x dimension: &f[0][0][1] - &f[0][0][0]
            integer(c_ptrdiff_t),   value :: sy    !! stride in y dimension: &f[0][1][0] - &f[0][0][0]
            integer(c_ptrdiff_t),   value :: sz    !! stride in z dimension: &f[1][0][0] - &f[0][0][0]
        end subroutine zfp_field_set_stride_3d
    end interface

public :: zfp_stream_open
    interface
        function zfp_stream_open(bs) result(stream) bind(c, name="zfp_stream_open")
        !! Open compressed stream and associate with bit stream
        import
            type(bitstream),    value   :: bs     !! bit stream to read from and write to (may be NULL)
            type(zfp_stream)            :: stream !! allocated compressed stream
        end function zfp_stream_open
    end interface

public :: zfp_stream_close
    interface
        subroutine zfp_stream_close(stream) bind(c, name="zfp_stream_close")
        !! Close and deallocate compressed stream (does not affect bit stream)
        import
            type(zfp_stream),   value   :: stream !! compressed stream
        end subroutine zfp_stream_close
    end interface

public :: zfp_stream_maximum_size
    interface
        function zfp_stream_maximum_size(stream, field) result(max_size) bind(c, name="zfp_stream_maximum_size")
        !! Conservative estimate of compressed size in bytes
        import
            type(zfp_stream), value     :: stream   !! compressed stream
            type(zfp_field),  value     :: field    !! array to compress
            integer(c_size_t)           :: max_size !! maximum number of bytes of compressed storage
        end function zfp_stream_maximum_size
    end interface

public :: zfp_field_set_pointer
    interface
        subroutine zfp_field_set_pointer(field, arr_ptr) bind(c, name="zfp_field_set_pointer")
        !! Set pointer to first scalar in field
        import
            type(zfp_field),    value   :: field   !! field metadata
            type(c_ptr),        value   :: arr_ptr !! pointer to first scalar
        end subroutine zfp_field_set_pointer
    end interface

! public :: zfp_field_dimensionality
    interface
        function zfp_field_dimensionality(field) result(dims) bind(c, name="zfp_field_dimensionality")
        !! Field dimensionality (1, 2, 3, or 4)
        import
            type(zfp_field),    value   :: field !! field metadata
            integer(c_int)              :: dims  !! number of dimensions
        end function zfp_field_dimensionality
    end interface

    interface
        function zfp_field_type(field) result(scalar_type) bind(c, name="zfp_field_type")
        !! Field scalar type
        import
            type(zfp_field),    value   :: field       !! field metadata
            type(zfp_type)              :: scalar_type !! scalar type
        end function zfp_field_type
    end interface

public :: zfp_field_free
    interface
        subroutine zfp_field_free(field) bind(c, name="zfp_field_free")
        !! Deallocate field metadata
        import
            type(zfp_field),    value   :: field !! field metadata
        end subroutine zfp_field_free
    end interface

public :: zfp_stream_rewind
    interface
        subroutine zfp_stream_rewind(stream) bind(c, name="zfp_stream_rewind")
        !! Rewind bit stream to beginning for compression or decompression
        import
            type(zfp_stream), value     :: stream !! compressed bit stream
        end subroutine zfp_stream_rewind
    end interface

public :: stream_open
    interface
        function stream_open(buffer, bytes) result(bs) bind(c, name="stream_open")
        !! Open bit stream for reading and writing
        import
            type(c_ptr),        value   :: buffer !! pointer to buffer
            integer(c_size_t),  value   :: bytes  !! buffer size in bytes
            type(bitstream)             :: bs     !! bit stream
        end function stream_open
    end interface

public :: stream_close
    interface
        subroutine stream_close(bs) bind(c, name="stream_close")
        !! Close bit stream
        import
            type(bitstream),    value   :: bs !! bit stream
        end subroutine stream_close
    end interface

public :: zfp_stream_set_bit_stream
    interface
        subroutine zfp_stream_set_bit_stream(stream, bs) bind(c, name="zfp_stream_set_bit_stream")
        !! Associate bit stream with compressed stream
        import
            type(zfp_stream),   value :: stream !! compressed stream
            type(bitstream),    value :: bs     !! bit stream to read from and write to
        end subroutine zfp_stream_set_bit_stream
    end interface

public :: zfp_stream_set_reversible
    interface
        subroutine zfp_stream_set_reversible(stream) bind(c, name="zfp_stream_set_reversible")
        !! Enable reversible (lossless) compression
        import
            type(zfp_stream),   value :: stream !! compressed stream
        end subroutine zfp_stream_set_reversible
    end interface

    interface
        function zfp_stream_set_rate_interface(stream, rate, scalar_type, dims, align) result(rate_result) bind(c, name="zfp_stream_set_rate")
        !! Set size in compressed bits/scalar (fixed-rate mode)
        import
            type(zfp_stream),   value   :: stream      !! compressed stream
            real(c_double),     value   :: rate        !! desired rate in compressed bits/scalar
            type(zfp_type),     value   :: scalar_type !! scalar type to compress
            integer(c_int),     value   :: dims        !! array dimensionality (1, 2, 3, or 4)
            integer(c_int),     value   :: align       !! word-aligned blocks, e.g., for write random access
            real(c_double)              :: rate_result !! actual rate in compressed bits/scalar
        end function zfp_stream_set_rate_interface
    end interface

    interface
        function zfp_stream_set_precision_interface(stream, prec) result(prec_result) bind(c, name="zfp_stream_set_precision")
        !! Set precision in uncompressed bits/scalar (fixed-precision mode)
        import
            type(zfp_stream),   value   :: stream       !! compressed stream
            integer(c_int),     value   :: prec         !! desired precision in uncompressed bits/scalar
            integer(c_int)              :: prec_result  !! actual precision
        end function zfp_stream_set_precision_interface
    end interface

    interface
        function zfp_stream_set_accuracy_interface(stream, acc) result(acc_result) bind(c, name="zfp_stream_set_accuracy")
        !! Set accuracy as absolute error tolerance (fixed-accuracy mode)
        import
            type(zfp_stream),   value   :: stream     !! compressed stream
            real(c_double),     value   :: acc        !! desired error tolerance
            real(c_double)              :: acc_result !! actual error tolerance
        end function zfp_stream_set_accuracy_interface
    end interface

public :: zfp_stream_set_execution
    interface
        function zfp_stream_set_execution(stream, execution_policy) result(is_success) bind(c, name="zfp_stream_set_execution")
        !! Set execution policy
        import
            type(zfp_stream),       value   :: stream           !! compressed stream
            type(zfp_exec_policy),  value   :: execution_policy !! execution policy
            integer(c_int)                  :: is_success       !! true upon success
        end function zfp_stream_set_execution
    end interface

public :: zfp_decompress
    interface
        function zfp_decompress(stream, field) result(bitstream_offset_bytes) bind(c, name="zfp_decompress")
        !! Decompress entire field (nonzero return value upon success)
        import
            type(zfp_stream),   value   :: stream                  !! compressed stream
            type(zfp_field),    value   :: field                   !! field metadata
            integer(c_size_t)           :: bitstream_offset_bytes  !! cumulative number of bytes of compressed storage
        end function zfp_decompress
    end interface

public :: zfp_compress
    interface
        function zfp_compress(stream, field) result(bitstream_offset_bytes) bind(c, name="zfp_compress")
        !! Compress entire field (nonzero return value upon success)
        import
            type(zfp_stream),   value   :: stream                  !! compressed stream
            type(zfp_field),    value   :: field                   !! field metadata
            integer(c_size_t)           :: bitstream_offset_bytes  !! cumulative number of bytes of compressed storage
        end function zfp_compress
    end interface

contains

    function zfp_create_field(uncompressed_ptr, scalar_type, dims) result(field)
    !! Create field for 2D or 3D arrays
        type(c_ptr),    intent(in)  :: uncompressed_ptr !! pointer to uncompressed scalars
        type(zfp_type), intent(in)  :: scalar_type      !! scalar type
        integer(int32), intent(in)  :: dims(:)          !! array dimensions
        type(zfp_field)             :: field            !! field metadata

        if ( size(dims) == 2 ) then
            field = zfp_field_2d(uncompressed_ptr, scalar_type, int(dims(1), c_size_t), int(dims(2), c_size_t))
        else
            field = zfp_field_3d(uncompressed_ptr, scalar_type, int(dims(1), c_size_t), int(dims(2), c_size_t), int(dims(3), c_size_t))
        endif
    end function zfp_create_field

    subroutine zfp_field_set_stride(field, strides)
    !! Set field strides for 2D or 3D arrays
        type(zfp_field),    intent(in)  :: field   !! field metadata
        integer(int32),     intent(in)  :: strides(:) !! strides per dimension
        integer(c_int) :: ndims

        ndims = zfp_field_dimensionality(field)
#ifdef DTFFT_DEBUG
        if ( ndims /= size(strides) ) then
            INTERNAL_ERROR("zfp_field_set_stride: ndims /= size(strides)")
        endif
#endif

        if ( ndims == 2 ) then
            call zfp_field_set_stride_2d(field, int(strides(1), c_ptrdiff_t), int(strides(2), c_ptrdiff_t))
        else
            call zfp_field_set_stride_3d(field, int(strides(1), c_ptrdiff_t), int(strides(2), c_ptrdiff_t), int(strides(3), c_ptrdiff_t))
        endif
    end subroutine zfp_field_set_stride

    subroutine zfp_stream_set_rate(stream, field, rate)
    !! Set compression rate with alignment for complex data
        type(zfp_stream),   intent(in)  :: stream    !! compressed stream
        type(zfp_field),    intent(in)  :: field     !! field metadata
        real(c_double),     intent(in)  :: rate      !! desired rate in compressed bits/scalar
        real(c_double) :: dummy

        dummy = zfp_stream_set_rate_interface(stream, rate, zfp_field_type(field), zfp_field_dimensionality(field), 1)
    end subroutine zfp_stream_set_rate

    subroutine zfp_stream_set_precision(stream, prec)
    !! Set precision in uncompressed bits/scalar
        type(zfp_stream),   intent(in)  :: stream !! compressed stream
        integer(c_int),     intent(in)  :: prec   !! desired precision
        integer(c_int) :: dummy

        dummy = zfp_stream_set_precision_interface(stream, prec)
    end subroutine zfp_stream_set_precision

    subroutine zfp_stream_set_accuracy(stream, acc)
    !! Set accuracy as absolute error tolerance
        type(zfp_stream),   intent(in)  :: stream !! compressed stream
        real(c_double),     intent(in)  :: acc    !! desired error tolerance
        real(c_double) :: dummy

        dummy = zfp_stream_set_accuracy_interface(stream, acc)
    end subroutine zfp_stream_set_accuracy

end module dtfft_interface_zfp

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
module dtfft_executor_cufft_m
!! This module describes cuFFT based FFT Executor: [[vkfft_executor]]
!!
!! https://docs.nvidia.com/cuda/cufft/index.html
use iso_c_binding,                  only: c_ptr, c_int, c_null_ptr, c_loc
use iso_fortran_env,                only: int8, int32, int64
use dtfft_abstract_executor,        only: abstract_executor, FFT_C2C, FFT_R2C
use dtfft_config,                   only: get_conf_stream
use dtfft_errors
use dtfft_interface_cufft
use dtfft_interface_cuda_runtime
use dtfft_parameters
use dtfft_utils,                    only: to_str, write_message
#include "_dtfft_mpi.h"
#include "_dtfft_cuda.h"
#include "_dtfft_private.h"
implicit none
private
public :: cufft_executor

  type, extends(abstract_executor) :: cufft_executor
  !! cuFFT FFT Executor
  private
  contains
    procedure :: create_private => create     !! Creates FFT plan via cuFFT Interface
    procedure :: execute_private => execute   !! Executes cuFFT plan
    procedure :: destroy_private => destroy   !! Destroys cuFFT plan
    procedure, nopass :: mem_alloc            !! Dummy method. Raises `error stop`
    procedure, nopass :: mem_free             !! Dummy method. Raises `error stop`
  end type cufft_executor

contains

  subroutine create(self, fft_rank, fft_type, precision, idist, odist, how_many, fft_sizes, inembed, onembed, error_code, r2r_kinds)
  !! Creates FFT plan via cuFFT Interface
    class(cufft_executor),            intent(inout) :: self           !! cuFFT FFT Executor
    integer(int8),                    intent(in)    :: fft_rank       !! Rank of fft: 1 or 2
    integer(int8),                    intent(in)    :: fft_type       !! Type of fft: r2r, r2c, c2c
    type(dtfft_precision_t),          intent(in)    :: precision      !! Precision of fft: DTFFT_SINGLE or DTFFT_DOUBLE
    integer(int32),                   intent(in)    :: idist          !! Distance between the first element of two consecutive signals in a batch of the input data.
    integer(int32),                   intent(in)    :: odist          !! Distance between the first element of two consecutive signals in a batch of the output data.
    integer(int32),                   intent(in)    :: how_many       !! Number of transforms to create
    integer(int32),                   intent(in)    :: fft_sizes(:)   !! Dimensions of transform
    integer(int32),                   intent(in)    :: inembed(:)     !! Storage dimensions of the input data in memory.
    integer(int32),                   intent(in)    :: onembed(:)     !! Storage dimensions of the output data in memory.
    integer(int32),                   intent(inout) :: error_code     !! Error code to be returned to user
    type(dtfft_r2r_kind_t), optional, intent(in)    :: r2r_kinds(:)   !! Kinds of r2r transform
    integer(c_int)                                  :: cufft_type, rnk

    ! CHECK_CALL( load_cufft(), error_code )
    rnk = int(fft_rank, c_int)
    select case (fft_type)
    case (FFT_C2C)
      if ( precision == DTFFT_SINGLE ) then
        cufft_type = CUFFT_C2C
      else
        cufft_type = CUFFT_Z2Z
      endif
      CUFFT_CALL( cufftPlanMany(self%plan_forward, rnk, fft_sizes, inembed, 1, idist, onembed, 1, odist, cufft_type, how_many) )
      self%plan_backward = self%plan_forward
      self%is_inverse_copied = .true.
    case (FFT_R2C)
      if ( precision == DTFFT_SINGLE ) then
        cufft_type = CUFFT_R2C
      else
        cufft_type = CUFFT_D2Z
      endif
      CUFFT_CALL( cufftPlanMany(self%plan_forward, rnk, fft_sizes, inembed, 1, idist, onembed, 1, odist, cufft_type, how_many) )

      if ( precision == DTFFT_SINGLE ) then
        cufft_type = CUFFT_C2R
      else
        cufft_type = CUFFT_Z2D
      endif
      CUFFT_CALL( cufftPlanMany(self%plan_backward, rnk, fft_sizes, onembed, 1, odist, inembed, 1, idist, cufft_type, how_many) )
    case default
      error_code = DTFFT_ERROR_R2R_FFT_NOT_SUPPORTED
      if(present(r2r_kinds)) then
      endif
      return
    endselect
    CUFFT_CALL( cufftSetStream(self%plan_forward, get_conf_stream()) )
    if ( .not.self%is_inverse_copied ) then
      CUFFT_CALL( cufftSetStream(self%plan_backward, get_conf_stream()) )
    endif
  end subroutine create

  subroutine execute(self, a, b, sign)
  !! Executes cuFFT plan
    class(cufft_executor),  intent(in)      :: self           !! cuFFT FFT Executor
    type(c_ptr),            intent(in)      :: a              !! Source pointer
    type(c_ptr),            intent(in)      :: b              !! Target pointer
    integer(int8),          intent(in)      :: sign           !! Sign of transform
    integer(c_int) :: sign_

    sign_ = int(sign, c_int)

    if (self%is_inverse_copied) then
      CUFFT_CALL( cufftXtExec(self%plan_forward, a, b, sign_) )
      return
    endif
    if ( sign == FFT_FORWARD ) then
      CUFFT_CALL( cufftXtExec(self%plan_forward, a, b, sign_) )
    else
      CUFFT_CALL( cufftXtExec(self%plan_backward, a, b, sign_) )
    endif
  end subroutine execute

  subroutine destroy(self)
  !! Destroys cuFFT plan
    class(cufft_executor), intent(inout)    :: self           !! cuFFT FFT Executor

    CUFFT_CALL( cufftDestroy(self%plan_forward) )
    if ( .not.self%is_inverse_copied ) then
      CUFFT_CALL( cufftDestroy(self%plan_backward) )
    endif
  end subroutine destroy

  subroutine mem_alloc(alloc_bytes, ptr)
  !! Dummy method. Raises `error stop`
    integer(int64),           intent(in)  :: alloc_bytes  !! Number of bytes to allocate
    type(c_ptr),              intent(out) :: ptr          !! Allocated pointer

    INTERNAL_ERROR("mem_alloc for cuFFT called")
  end subroutine mem_alloc

  subroutine mem_free(ptr)
  !! Dummy method. Raises `error stop`
    type(c_ptr),               intent(in)   :: ptr        !! Pointer to free

    INTERNAL_ERROR("mem_free for cuFFT called")
  end subroutine mem_free
end module dtfft_executor_cufft_m

program test_host_kernels
use iso_fortran_env
use dtfft_kernel_host
implicit none
    real(real32), allocatable :: in(:), out(:), gold(:), temp(:)
    integer(int32) :: dims3(3), dims2(2), i

    dims3 = [33, 77, 21]
    dims2 = [90, 57]


    call run_permute_forward(dims3)
    call run_permute_forward(dims2)

    call run_permute_backward(dims3)

    call run_permute_backward_start(dims3)

    call run_permute_backward_end(dims3)

    call run_pack_unpack(dims3)
    call run_pack_unpack(dims2)

contains

    subroutine run_permute_forward(dims)
        integer(int32), intent(in) :: dims(:)
        integer(int32) :: locals(5, 1)
        integer(int32) :: unpack_dims(3)

        print*,'Testing permute_forward kernels: ndims = ',size(dims)

        allocate( in(product(dims)), out(product(dims)), gold(product(dims)) )

        do i = 1, size(in)
            in(i) = real(i, real32)
        enddo

        call permute_forward_write_f32(in, gold, dims)

        call permute_forward_read_f32(in, out, dims);                   call compare("permute_forward_read_f32")
        call permute_forward_write_f32_block_4(in, out, dims);          call compare("permute_forward_write_f32_block_4")
        call permute_forward_write_f32_block_8(in, out, dims);          call compare("permute_forward_write_f32_block_8")
        call permute_forward_write_f32_block_16(in, out, dims);         call compare("permute_forward_write_f32_block_16")
        call permute_forward_write_f32_block_32(in, out, dims);         call compare("permute_forward_write_f32_block_32")
        call permute_forward_write_f32_block_64(in, out, dims);         call compare("permute_forward_write_f32_block_64")
        call permute_forward_read_f32_block_4(in, out, dims);           call compare("permute_forward_read_f32_block_4")
        call permute_forward_read_f32_block_8(in, out, dims);           call compare("permute_forward_read_f32_block_8")
        call permute_forward_read_f32_block_16(in, out, dims);          call compare("permute_forward_read_f32_block_16")
        call permute_forward_read_f32_block_32(in, out, dims);          call compare("permute_forward_read_f32_block_32")
        call permute_forward_read_f32_block_64(in, out, dims);          call compare("permute_forward_read_f32_block_64")

        locals(1:size(dims), 1) = dims
        locals(4, 1) = 0
        locals(5, 1) = 0

        call pack_forward_write_f32(in, out, dims, locals(:, 1));             call compare("pack_forward_write_f32")
        call pack_forward_write_f32_block_4(in, out, dims, locals(:, 1));     call compare("pack_forward_write_f32_block_4")
        call pack_forward_write_f32_block_8(in, out, dims, locals(:, 1));     call compare("pack_forward_write_f32_block_8")
        call pack_forward_write_f32_block_16(in, out, dims, locals(:, 1));    call compare("pack_forward_write_f32_block_16")
        call pack_forward_write_f32_block_32(in, out, dims, locals(:, 1));    call compare("pack_forward_write_f32_block_32")
        call pack_forward_write_f32_block_64(in, out, dims, locals(:, 1));    call compare("pack_forward_write_f32_block_64")
        call pack_forward_read_f32(in, out, dims, locals(:, 1));              call compare("pack_forward_read_f32")
        call pack_forward_read_f32_block_4(in, out, dims, locals(:, 1));      call compare("pack_forward_read_f32_block_4")
        call pack_forward_read_f32_block_8(in, out, dims, locals(:, 1));      call compare("pack_forward_read_f32_block_8")
        call pack_forward_read_f32_block_16(in, out, dims, locals(:, 1));     call compare("pack_forward_read_f32_block_16")
        call pack_forward_read_f32_block_32(in, out, dims, locals(:, 1));     call compare("pack_forward_read_f32_block_32")
        call pack_forward_read_f32_block_64(in, out, dims, locals(:, 1));     call compare("pack_forward_read_f32_block_64")

        if ( size(dims) == 2 ) then
            unpack_dims = [dims(2), dims(1), 1]
        else
            unpack_dims = [dims(2), dims(3), dims(1)]
        endif
        locals(1:size(unpack_dims), 1) = unpack_dims

        call unpack_forward_write_f32(in, out, unpack_dims(1:size(dims)), locals);            call compare("unpack_forward_write_f32")
        call unpack_forward_write_f32_block_4(in, out, unpack_dims(1:size(dims)), locals);    call compare("unpack_forward_write_f32_block_4")
        call unpack_forward_write_f32_block_8(in, out, unpack_dims(1:size(dims)), locals);    call compare("unpack_forward_write_f32_block_8")
        call unpack_forward_write_f32_block_16(in, out, unpack_dims(1:size(dims)), locals);   call compare("unpack_forward_write_f32_block_16")
        call unpack_forward_write_f32_block_32(in, out, unpack_dims(1:size(dims)), locals);   call compare("unpack_forward_write_f32_block_32")
        call unpack_forward_write_f32_block_64(in, out, unpack_dims(1:size(dims)), locals);   call compare("unpack_forward_write_f32_block_64")
        call unpack_forward_read_f32(in, out, unpack_dims(1:size(dims)), locals);             call compare("unpack_forward_read_f32")
        call unpack_forward_read_f32_block_4(in, out, unpack_dims(1:size(dims)), locals);     call compare("unpack_forward_read_f32_block_4")
        call unpack_forward_read_f32_block_8(in, out, unpack_dims(1:size(dims)), locals);     call compare("unpack_forward_read_f32_block_8")
        call unpack_forward_read_f32_block_16(in, out, unpack_dims(1:size(dims)), locals);    call compare("unpack_forward_read_f32_block_16")
        call unpack_forward_read_f32_block_32(in, out, unpack_dims(1:size(dims)), locals);    call compare("unpack_forward_read_f32_block_32")
        call unpack_forward_read_f32_block_64(in, out, unpack_dims(1:size(dims)), locals);    call compare("unpack_forward_read_f32_block_64")

    !     print*,'Testing transpose_3d_cache_oblivious kernel'
    !     call cpu_time(start_time)
    !     call transpose_3d_cache_oblivious(in, out, dims)!;call compare
    ! call cpu_time(end_time)
    ! print*,'Time for transpose_3d_cache_oblivious: ', end_time - start_time
        deallocate(in, out, gold)

        print*,'SUCCESS'
    end subroutine run_permute_forward

    subroutine run_permute_backward(dims)
        integer(int32), intent(in) :: dims(:)
        integer(int32) :: locals(5, 1)
        integer(int32) :: unpack_dims(3)

        print*,'Testing permute_backward kernels'

        allocate( in(product(dims)), out(product(dims)), gold(product(dims)) )

        do i = 1, size(in)
            in(i) = real(i, real32)
        enddo

        call permute_backward_write_f32(in, gold, dims)

        call permute_backward_read_f32(in, out, dims);              call compare("permute_backward_read_f32")
        call permute_backward_write_f32_block_4(in, out, dims);     call compare("permute_backward_write_f32_block_4")
        call permute_backward_write_f32_block_8(in, out, dims);     call compare("permute_backward_write_f32_block_8")
        call permute_backward_write_f32_block_16(in, out, dims);    call compare("permute_backward_write_f32_block_16")
        call permute_backward_write_f32_block_32(in, out, dims);    call compare("permute_backward_write_f32_block_32")
        call permute_backward_write_f32_block_64(in, out, dims);    call compare("permute_backward_write_f32_block_64")
        call permute_backward_read_f32_block_4(in, out, dims);      call compare("permute_backward_read_f32_block_4")
        call permute_backward_read_f32_block_8(in, out, dims);      call compare("permute_backward_read_f32_block_8")
        call permute_backward_read_f32_block_16(in, out, dims);     call compare("permute_backward_read_f32_block_16")
        call permute_backward_read_f32_block_32(in, out, dims);     call compare("permute_backward_read_f32_block_32")
        call permute_backward_read_f32_block_64(in, out, dims);     call compare("permute_backward_read_f32_block_64")

        locals(1:size(dims), 1) = dims
        locals(4, 1) = 0
        locals(5, 1) = 0

        call pack_backward_write_f32(in, out, dims, locals(:, 1));                call compare("pack_backward_write_f32")
        call pack_backward_write_f32_block_4(in, out, dims, locals(:, 1));        call compare("pack_backward_write_f32_block_4")
        call pack_backward_write_f32_block_8(in, out, dims, locals(:, 1));        call compare("pack_backward_write_f32_block_8")
        call pack_backward_write_f32_block_16(in, out, dims, locals(:, 1));       call compare("pack_backward_write_f32_block_16")
        call pack_backward_write_f32_block_32(in, out, dims, locals(:, 1));       call compare("pack_backward_write_f32_block_32")
        call pack_backward_write_f32_block_64(in, out, dims, locals(:, 1));       call compare("pack_backward_write_f32_block_64")
        call pack_backward_read_f32(in, out, dims, locals(:, 1));                 call compare("pack_backward_read_f32")
        call pack_backward_read_f32_block_4(in, out, dims, locals(:, 1));         call compare("pack_backward_read_f32_block_4")
        call pack_backward_read_f32_block_8(in, out, dims, locals(:, 1));         call compare("pack_backward_read_f32_block_8")
        call pack_backward_read_f32_block_16(in, out, dims, locals(:, 1));        call compare("pack_backward_read_f32_block_16")
        call pack_backward_read_f32_block_32(in, out, dims, locals(:, 1));        call compare("pack_backward_read_f32_block_32")
        call pack_backward_read_f32_block_64(in, out, dims, locals(:, 1));        call compare("pack_backward_read_f32_block_64")

        unpack_dims = [dims(3), dims(1), dims(2)]
        locals(1:size(unpack_dims), 1) = unpack_dims

        call unpack_backward_write_f32(in, out, unpack_dims, locals);            call compare("unpack_backward_write_f32")
        call unpack_backward_write_f32_block_4(in, out, unpack_dims, locals);    call compare("unpack_backward_write_f32_block_4")
        call unpack_backward_write_f32_block_8(in, out, unpack_dims, locals);    call compare("unpack_backward_write_f32_block_8")
        call unpack_backward_write_f32_block_16(in, out, unpack_dims, locals);   call compare("unpack_backward_write_f32_block_16")
        call unpack_backward_write_f32_block_32(in, out, unpack_dims, locals);   call compare("unpack_backward_write_f32_block_32")
        call unpack_backward_write_f32_block_64(in, out, unpack_dims, locals);   call compare("unpack_backward_write_f32_block_64")
        call unpack_backward_read_f32(in, out, unpack_dims, locals);             call compare("unpack_backward_read_f32")
        call unpack_backward_read_f32_block_4(in, out, unpack_dims, locals);     call compare("unpack_backward_read_f32_block_4")
        call unpack_backward_read_f32_block_8(in, out, unpack_dims, locals);     call compare("unpack_backward_read_f32_block_8")
        call unpack_backward_read_f32_block_16(in, out, unpack_dims, locals);    call compare("unpack_backward_read_f32_block_16")
        call unpack_backward_read_f32_block_32(in, out, unpack_dims, locals);    call compare("unpack_backward_read_f32_block_32")
        call unpack_backward_read_f32_block_64(in, out, unpack_dims, locals);    call compare("unpack_backward_read_f32_block_64")

        deallocate(in, out, gold)

        print*,'SUCCESS'
    end subroutine run_permute_backward

    subroutine run_permute_backward_start(dims)
        integer(int32), intent(in) :: dims(:)

        print*,'Testing permute_backward_start kernels'

        allocate( in(product(dims)), out(product(dims)), gold(product(dims)) )

        do i = 1, size(in)
            in(i) = real(i, real32)
        enddo

        call permute_backward_start_write_f32(in, gold, dims)

        call permute_backward_start_read_f32(in, out, dims);            call compare("permute_backward_start_read_f32")
        call permute_backward_start_write_f32_block_4(in, out, dims);   call compare("permute_backward_start_write_f32_block_4")
        call permute_backward_start_write_f32_block_8(in, out, dims);   call compare("permute_backward_start_write_f32_block_8")
        call permute_backward_start_write_f32_block_16(in, out, dims);  call compare("permute_backward_start_write_f32_block_16")
        call permute_backward_start_write_f32_block_32(in, out, dims);  call compare("permute_backward_start_write_f32_block_32")
        call permute_backward_start_write_f32_block_64(in, out, dims);  call compare("permute_backward_start_write_f32_block_64")
        call permute_backward_start_read_f32_block_4(in, out, dims);    call compare("permute_backward_start_read_f32_block_4")
        call permute_backward_start_read_f32_block_8(in, out, dims);    call compare("permute_backward_start_read_f32_block_8")
        call permute_backward_start_read_f32_block_16(in, out, dims);   call compare("permute_backward_start_read_f32_block_16")
        call permute_backward_start_read_f32_block_32(in, out, dims);   call compare("permute_backward_start_read_f32_block_32")
        call permute_backward_start_read_f32_block_64(in, out, dims);   call compare("permute_backward_start_read_f32_block_64")

        deallocate(in, out, gold)

        print*,'SUCCESS'
    end subroutine run_permute_backward_start

    subroutine run_permute_backward_end(dims)
        integer(int32), intent(in) :: dims(:)
        integer(int32) :: temp_dims(size(dims))
        integer(int32) :: locals(5, 1)

        print*,'Testing permute_backward_end kernels'

        allocate( in(product(dims)), temp(product(dims)), out(product(dims)), gold(product(dims)) )

        do i = 1, size(in)
            in(i) = real(i, real32)
        enddo
        gold(:) = -1._real32
        out(:) = -1._real32

        call permute_backward_write_f32(in, gold, dims)
        call permute_backward_start_write_f32(in, temp, dims)

        temp_dims = [dims(3), dims(1), dims(2)]

        locals(1:size(dims), 1) = temp_dims
        locals(4, 1) = 0
        locals(5, 1) = 0

        call permute_backward_end_write_f32(temp, out, temp_dims, locals);           call compare("permute_backward_end_write_f32")
        call permute_backward_end_write_f32_block_4(temp, out, temp_dims, locals);   call compare("permute_backward_end_write_f32_block_4")
        call permute_backward_end_write_f32_block_8(temp, out, temp_dims, locals);   call compare("permute_backward_end_write_f32_block_8")
        call permute_backward_end_write_f32_block_16(temp, out, temp_dims, locals);  call compare("permute_backward_end_write_f32_block_16")
        call permute_backward_end_write_f32_block_32(temp, out, temp_dims, locals);  call compare("permute_backward_end_write_f32_block_32")
        call permute_backward_end_write_f32_block_64(temp, out, temp_dims, locals);  call compare("permute_backward_end_write_f32_block_64")
        call permute_backward_end_read_f32(temp, out, temp_dims, locals);            call compare("permute_backward_end_read_f32")
        call permute_backward_end_read_f32_block_4(temp, out, temp_dims, locals);    call compare("permute_backward_end_read_f32_block_4")
        call permute_backward_end_read_f32_block_8(temp, out, temp_dims, locals);    call compare("permute_backward_end_read_f32_block_8")
        call permute_backward_end_read_f32_block_16(temp, out, temp_dims, locals);   call compare("permute_backward_end_read_f32_block_16")
        call permute_backward_end_read_f32_block_32(temp, out, temp_dims, locals);   call compare("permute_backward_end_read_f32_block_32")
        call permute_backward_end_read_f32_block_64(temp, out, temp_dims, locals);   call compare("permute_backward_end_read_f32_block_64")
        deallocate(in, out, gold, temp)

        print*,'SUCCESS'
    end subroutine run_permute_backward_end

    subroutine run_pack_unpack(dims)
        integer(int32), intent(in) :: dims(:)
        integer(int32) :: locals(5, 1)

        print*,'Testing pack/unpack kernels, ndims = ',size(dims)

        allocate( in(product(dims)), out(product(dims)), gold(product(dims)) )

        do i = 1, size(in)
            in(i) = real(i, real32)
            gold(i) = in(i)
        enddo
        ! gold(:) = -1._real32
        out(:) = -1._real32

        locals(1:size(dims), 1) = dims
        locals(4, 1) = 0
        locals(5, 1) = 0

        call unpack_f32(in, out, dims, locals); call compare("unpack_f32")
        call unpack_f32_block_4(in, out, dims, locals); call compare("unpack_f32_block_4")
        call unpack_f32_block_8(in, out, dims, locals); call compare("unpack_f32_block_8")
        call unpack_f32_block_16(in, out, dims, locals); call compare("unpack_f32_block_16")
        call unpack_f32_block_32(in, out, dims, locals); call compare("unpack_f32_block_32")
        call unpack_f32_block_64(in, out, dims, locals); call compare("unpack_f32_block_64")

        call pack_f32(in, out, dims, locals); call compare("pack_f32")
        call pack_f32_block_4(in, out, dims, locals); call compare("pack_f32_block_4")
        call pack_f32_block_8(in, out, dims, locals); call compare("pack_f32_block_8")
        call pack_f32_block_16(in, out, dims, locals); call compare("pack_f32_block_16")
        call pack_f32_block_32(in, out, dims, locals); call compare("pack_f32_block_32")
        call pack_f32_block_64(in, out, dims, locals); call compare("pack_f32_block_64")

        deallocate(in, out, gold)

        print*,'SUCCESS'
    end subroutine run_pack_unpack


    subroutine compare(test_name)
        character(len=*), intent(in) :: test_name
        ! print*, 'Comparing results...'
        ! print*, gold(1:10)
        ! print*, out(1:10)
        do i = 1, size(gold)
            if ( abs(out(i) - gold(i)) > 1e-6 ) then
                print*, i, out(i), gold(i)
                error stop "Test failed: "//test_name
            endif
            out(i) = -1._real32
        enddo
    end subroutine compare


!    recursive subroutine transpose_3d_recursive(in, out, &
!                                               in_start, in_dims, in_strides, &
!                                               out_start, out_dims, out_strides, &
!                                               base_case_size)
!         real(real32), intent(in) :: in(*)
!         real(real32), intent(out) :: out(*)
!         integer(int32), intent(in) :: in_start(3), in_dims(3), in_strides(3)
!         integer(int32), intent(in) :: out_start(3), out_dims(3), out_strides(3)
!         integer(int32), intent(in) :: base_case_size

!         integer(int32) :: new_start(3), new_dims(3)
!         integer(int32) :: split_dim


!         if (all(in_dims < base_case_size)) then
!             call transpose_3d_base_case(in, out, &
!                                       in_start, in_dims, in_strides, &
!                                       out_start, out_dims, out_strides)
!             return
!         end if

!         split_dim = maxloc(in_dims, dim=1)


!         new_dims = in_dims
!         new_dims(split_dim) = in_dims(split_dim) / 2

!         new_start = in_start
!         call transpose_3d_recursive(in, out, &
!                                   new_start, new_dims, in_strides, &
!                                   out_start, out_dims, out_strides, &
!                                   base_case_size)

!         new_start(split_dim) = in_start(split_dim) + new_dims(split_dim)
!         new_dims(split_dim) = in_dims(split_dim) - new_dims(split_dim)
!         call transpose_3d_recursive(in, out, &
!                                   new_start, new_dims, in_strides, &
!                                   out_start, out_dims, out_strides, &
!                                   base_case_size)
!     end subroutine transpose_3d_recursive

!     subroutine transpose_3d_base_case(in, out, &
!                                     in_start, in_dims, in_strides, &
!                                     out_start, out_dims, out_strides)
!         real(real32), intent(in) :: in(*)
!         real(real32), intent(out) :: out(*)
!         integer(int32), intent(in) :: in_start(3), in_dims(3), in_strides(3)
!         integer(int32), intent(in) :: out_start(3), out_dims(3), out_strides(3)

!         integer(int32) :: x, y, z
!         integer(int32) :: in_idx, out_idx
!         integer(int32) :: nx, ny, nz

!         nx = in_dims(1)
!         ny = in_dims(2)
!         nz = in_dims(3)

!         do x = in_start(1), in_start(1) + nx - 1
!             do z = in_start(3), in_start(3) + nz - 1
!                 do y = in_start(2), in_start(2) + ny - 1
!                     in_idx = x * in_strides(1) + &
!                              y * in_strides(2) + &
!                              z * in_strides(3) + 1

!                     out_idx = y * out_strides(1) + &
!                               z * out_strides(2) + &
!                               x * out_strides(3) + 1

!                     out(out_idx) = in(in_idx)
!                 end do
!             end do
!         end do
!     end subroutine transpose_3d_base_case

    ! subroutine transpose_3d_cache_oblivious(in, out, dims)
    !     real(real32), intent(in) :: in(*)
    !     real(real32), intent(out) :: out(*)
    !     integer(int32), intent(in) :: dims(3)

    !     integer(int32) :: in_start(3), in_dims(3), in_strides(3)
    !     integer(int32) :: out_start(3), out_dims(3), out_strides(3)
    !     integer(int32) :: base_case_size

    !     in_start = [0, 0, 0]
    !     in_dims = dims
    !     in_strides = [1, dims(1), dims(1) * dims(2)]

    !     out_start = [0, 0, 0]
    !     out_dims = [dims(2), dims(3), dims(1)]  ! (y, z, x)
    !     out_strides = [1, dims(2), dims(2) * dims(3)]

    !     base_case_size = 32

    !     call transpose_3d_recursive(in, out, &
    !                               in_start, in_dims, in_strides, &
    !                               out_start, out_dims, out_strides, &
    !                               base_case_size)
    ! end subroutine transpose_3d_cache_oblivious

end program test_host_kernels

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
module dtfft_interface_vkfft_m
!! This module creates interface with VkFFT library
!!
!! VkFFT is loaded at runtime via dynamic loading.
use iso_c_binding
use iso_fortran_env
use dtfft_errors
use dtfft_parameters
use dtfft_utils
implicit none
private
#include "_dtfft_private.h"
public :: load_vkfft

  abstract interface
    subroutine vkfft_create_interface(rank, dims, double_precision, how_many, r2c, c2r, dct, dst, stream, app_handle) bind(C)
    !! Creates FFT plan via vkFFT Interface
    import
      integer(c_int8_t),          value :: rank             !! Rank of fft: 1 or 2
      integer(c_int)                    :: dims(*)          !! Dimensions of transform
      integer(c_int),             value :: double_precision !! Precision of fft: DTFFT_SINGLE or DTFFT_DOUBLE
      integer(c_int),             value :: how_many         !! Number of transforms to create
      integer(c_int8_t),          value :: r2c              !! Is R2C transform required
      integer(c_int8_t),          value :: c2r              !! Is C2R transform required
      integer(c_int8_t),          value :: dct              !! Is DCT transform required
      integer(c_int8_t),          value :: dst              !! Is DST transform required
      type(dtfft_stream_t),       value :: stream           !! CUDA stream
      type(c_ptr)                       :: app_handle       !! vkFFT application handle
    end subroutine vkfft_create_interface

    subroutine vkfft_execute_interface(app_handle, in, out, sign) bind(C)
    !! Executes vkFFT plan
    import
      type(c_ptr),        value :: app_handle           !! vkFFT application handle
      type(c_ptr),        value :: in                   !! Input data
      type(c_ptr),        value :: out                  !! Output data
      integer(c_int8_t),  value :: sign                 !! Sign of FFT
    end subroutine vkfft_execute_interface

    subroutine vkfft_destroy_interface(app_handle) bind(C)
    !! Destroys vkFFT plan
    import
      type(c_ptr),    value :: app_handle               !! vkFFT application handle
    end subroutine vkfft_destroy_interface
  end interface

public :: vkfft_wrapper
  type :: vkfft_wrapper
  !! VkFFT Wrapper
  private
    logical         :: is_loaded = .false.
      !! Is VkFFT library loaded
    type(c_ptr)     :: lib_handle
      !! Handle to the loaded library
    type(c_funptr)  :: vkfft_functions(3)
      !! Array of VkFFT functions
    procedure(vkfft_create_interface),  pointer, public, nopass :: create
      !! Fortran Pointer to vkFFT create function
    procedure(vkfft_execute_interface), pointer, public, nopass :: execute
      !! Fortran Pointer to vkFFT execute function
    procedure(vkfft_destroy_interface), pointer, public, nopass :: destroy
      !! Fortran Pointer to vkFFT destroy function
  end type vkfft_wrapper

  type(vkfft_wrapper), public, save, target :: cuda_wrapper
    !! VkFFT Wrapper for CUDA platform
contains

  integer(int32) function load_vkfft(platform)
  !! Loads VkFFT library based on the platform
    type(dtfft_platform_t), intent(in) :: platform
      !! Platform to load VkFFT library for

    if ( platform == DTFFT_PLATFORM_CUDA ) then
      load_vkfft = load(cuda_wrapper, "cuda")
    endif
  end function load_vkfft

  function load(wrapper, suffix) result(error_code)
  !! Loads VkFFT library
    class(vkfft_wrapper), intent(inout) :: wrapper  !! VkFFT Wrapper
    character(len=*),     intent(in)    :: suffix   !! Suffix for the library name
    type(string), allocatable           :: func_names(:)  !! Names of functions to load from VkFFT module
    integer(int32)                      :: error_code !! Error code

    error_code = DTFFT_SUCCESS
    if ( wrapper%is_loaded ) return

    allocate(func_names(3))
    func_names(1) = string("vkfft_create")
    func_names(2) = string("vkfft_execute")
    func_names(3) = string("vkfft_destroy")

    error_code = dynamic_load("libdtfft_vkfft_"//suffix//".so", func_names, wrapper%lib_handle, wrapper%vkfft_functions)
    call destroy_strings(func_names)
    if ( error_code /= DTFFT_SUCCESS ) return

    call c_f_procpointer(wrapper%vkfft_functions(1), wrapper%create)
    call c_f_procpointer(wrapper%vkfft_functions(2), wrapper%execute)
    call c_f_procpointer(wrapper%vkfft_functions(3), wrapper%destroy)

    wrapper%is_loaded = .true.
  end function load

end module dtfft_interface_vkfft_m

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_interface_nccl
!! NCCL Interfaces
use iso_c_binding
use iso_fortran_env
use dtfft_parameters, only: dtfft_stream_t
use dtfft_utils
#ifdef DTFFT_WITH_MOCK_ENABLED
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
#endif
implicit none
private
public :: ncclGetErrorString
public :: ncclGetUniqueId, ncclMemAlloc, ncclMemFree
public :: ncclCommInitRank, ncclSend, ncclRecv
public :: ncclGroupStart, ncclGroupEnd
public :: ncclCommDestroy, ncclCommRegister, ncclCommDeregister

public :: ncclUniqueId
  type, bind(c) :: ncclUniqueId
    character(c_char) :: internal(128)
  end type ncclUniqueId

public :: ncclComm
  type, bind(c) :: ncclComm
    type(c_ptr) :: member
  end type ncclComm

public :: ncclDataType
  type, bind(c) :: ncclDataType
    integer(c_int) :: member
  end type ncclDataType

  type(ncclDataType), parameter, public :: ncclFloat = ncclDataType(7)

#ifndef DTFFT_WITH_MOCK_ENABLED
! Real NCCL interfaces

  interface
  !! Returns a human-readable string corresponding to the passed error code.
    function ncclGetErrorString_c(ncclResult_t)                                     &
      result(message)                                                               &
      bind(C, name="ncclGetErrorString")
    import
      integer(c_int32_t), intent(in), value :: ncclResult_t    !! Completion status of a NCCL function.
      type(c_ptr)                           :: message         !! Pointer to message
    end function ncclGetErrorString_c
  endinterface

  interface
  !! Generates an Id to be used in ncclCommInitRank.
  !! ncclGetUniqueId should be called once when creating a communicator and the Id should be
  !! distributed to all ranks in the communicator before calling ncclCommInitRank.
  !! uniqueId should point to a ncclUniqueId object allocated by the user.
    function ncclGetUniqueId(uniqueId)                                              &
      result(ncclResult_t)                                                          &
      bind(C, name="ncclGetUniqueId")
    import
      type(ncclUniqueId), intent(out)       :: uniqueId       !! Unique ID
      integer(c_int32_t)                    :: ncclResult_t   !! Completion status
    end function ncclGetUniqueId
  end interface

  interface
  !! Allocate a GPU buffer with size.
  !! Allocated buffer head address will be returned by ptr, and the actual allocated size can be larger
  !! than requested because of the buffer granularity requirements from all types of NCCL optimizations.
    function ncclMemAlloc(ptr, alloc_bytes)                                         &
      result(ncclResult_t)                                                          &
      bind(C, name="ncclMemAlloc")
    import
      type(c_ptr),        intent(out)       :: ptr            !! Buffer address
      integer(c_size_t),  intent(in), value :: alloc_bytes    !! Number of bytes to allocate
      integer(c_int32_t)                    :: ncclResult_t   !! Completion status
    end function ncclMemAlloc
  end interface

  interface
  !! Free memory allocated by ncclMemAlloc().
    function ncclMemFree(ptr)                                                       &
      result(ncclResult_t)                                                          &
      bind(C, name="ncclMemFree")
    import
      type(c_ptr),        intent(in), value :: ptr            !! Buffer address
      integer(c_int32_t)                    :: ncclResult_t   !! Completion status
    end function ncclMemFree
  end interface

  interface
  !! Creates a new communicator (multi thread/process version).
  !!
  !! rank must be between 0 and nranks-1 and unique within a communicator clique.
  !! Each rank is associated to a CUDA device, which has to be set before calling ncclCommInitRank.
  !!
  !! ncclCommInitRank implicitly synchronizes with other ranks, hence it must be called by different
  !! threads/processes or used within ncclGroupStart/ncclGroupEnd.
    function ncclCommInitRank(comm, nranks, uniqueId, rank)                         &
      result(ncclResult_t)                                                          &
      bind(C, name="ncclCommInitRank")
    import
      type(ncclComm)                        :: comm           !! Communicator
      integer(c_int),               value   :: nranks         !! Number of ranks in communicator
      type(ncclUniqueId),           value   :: uniqueId       !! Unique ID
      integer(c_int),               value   :: rank           !! Calling rank
      integer(c_int32_t)                    :: ncclResult_t   !! Completion status
    end function ncclCommInitRank
  end interface

  interface
  !! Send data from sendbuff to rank peer.
  !!
  !! Rank peer needs to call ncclRecv with the same datatype and the same count as this rank.
  !!
  !! This operation is blocking for the GPU.
  !! If multiple ncclSend() and ncclRecv() operations need to progress concurrently to complete,
  !! they must be fused within a ncclGroupStart()/ ncclGroupEnd() section.
    function ncclSend(sendbuff, count, datatype, peer, comm, stream)                &
      result(ncclResult_t)                                                          &
      bind(c, name='ncclSend')
    import
      real(c_float)                         :: sendbuff       !! Buffer to send data from
      integer(c_size_t),            value   :: count          !! Number of elements to send
      type(ncclDataType),           value   :: datatype       !! Datatype to send
      integer(c_int),               value   :: peer           !! Target GPU
      type(ncclComm),               value   :: comm           !! Communicator
      type(dtfft_stream_t),         value   :: stream         !! CUDA Stream
      integer(c_int32_t)                    :: ncclResult_t   !! Completion status
    end function ncclSend
  end interface

  interface
  !! Receive data from rank peer into recvbuff.
  !!
  !! Rank peer needs to call ncclSend with the same datatype and the same count as this rank.

  !! This operation is blocking for the GPU.
  !! If multiple ncclSend() and ncclRecv() operations need to progress concurrently to complete,
  !! they must be fused within a ncclGroupStart()/ ncclGroupEnd() section.
    function ncclRecv(recvbuff, count, datatype, peer, comm, stream)                &
      result(ncclResult_t)                                                          &
      bind(c, name='ncclRecv')
    import
      real(c_float)                         :: recvbuff       !! Buffer to recv data into
      integer(c_size_t),            value   :: count          !! Number of elements to recv
      type(ncclDataType),           value   :: datatype       !! Datatype to recv
      integer(c_int),               value   :: peer           !! Source GPU
      type(ncclComm),               value   :: comm           !! Communicator
      type(dtfft_stream_t),         value   :: stream         !! CUDA Stream
      integer(c_int32_t)                    :: ncclResult_t   !! Completion status
    end function ncclRecv
  end interface

  interface
  !! Start a group call.
  !!
  !! All subsequent calls to NCCL until ncclGroupEnd will not block due to inter-CPU synchronization.
    function ncclGroupStart()                                                       &
      result(ncclResult_t)                                                          &
      bind(C, name="ncclGroupStart")
    import
      integer(c_int32_t)                    :: ncclResult_t   !! Completion status
    end function ncclGroupStart
  end interface

  interface
  !! End a group call.
  !!
  !! Returns when all operations since ncclGroupStart have been processed.
  !! This means the communication primitives have been enqueued to the provided streams,
  !! but are not necessarily complete.
    function ncclGroupEnd()                                                         &
      result(ncclResult_t)                                                          &
      bind(C, name="ncclGroupEnd")
    import
      integer(c_int32_t)                    :: ncclResult_t   !! Completion status
    end function ncclGroupEnd
  end interface

  interface
  !! Destroy a communicator object comm.
    function ncclCommDestroy(comm)                                                  &
      result(ncclResult_t)                                                          &
      bind(C, name="ncclCommDestroy")
    import
      type(ncclComm),                 value :: comm           !! Communicator
      integer(c_int32_t)                    :: ncclResult_t   !! Completion status
    end function ncclCommDestroy
  end interface

  interface
  !! Register a buffer for collective communication.
    function ncclCommRegister(comm, buff, size, handle)                             &
      result(ncclResult_t)                                                          &
      bind(C, name="ncclCommRegister")
    import
      type(ncclComm),                 value :: comm           !! Communicator
      type(c_ptr),                    value :: buff           !! Buffer to register
      integer(c_size_t),              value :: size           !! Size of the buffer in bytes
      type(c_ptr)                           :: handle         !! Handle to the registered buffer
      integer(c_int32_t)                    :: ncclResult_t   !! Completion status
    end function ncclCommRegister
  end interface

  interface
  !! Deregister a buffer for collective communication.
    function ncclCommDeregister(comm, handle)                                       &
      result(ncclResult_t)                                                          &
      bind(C, name="ncclCommDeregister")
    import
      type(ncclComm),                 value :: comm           !! Communicator
      type(c_ptr),                    value :: handle         !! Handle to the registered buffer
      integer(c_int32_t)                    :: ncclResult_t   !! Completion status
    end function ncclCommDeregister
  end interface

#else
  ! Storage for MPI requests in mock mode
    TYPE_MPI_REQUEST, allocatable  :: requests(:)
    integer(int32)    :: num_requests
#endif

contains

#ifdef DTFFT_WITH_MOCK_ENABLED
  ! Mock implementations for CPU testing

  function ncclGetUniqueId(uniqueId) result(ncclResult_t)
  !! Mock: Generates dummy unique ID
    type(ncclUniqueId), intent(out)       :: uniqueId
    integer(c_int32_t)                    :: ncclResult_t
    uniqueId%internal = achar(0)
    ncclResult_t = 0  ! ncclSuccess
  end function ncclGetUniqueId

  function ncclMemAlloc(ptr, alloc_bytes) result(ncclResult_t)
  !! Mock: Allocates memory on CPU
    type(c_ptr),        intent(out)       :: ptr
    integer(c_size_t),  intent(in), value :: alloc_bytes
    integer(c_int32_t)                    :: ncclResult_t

    ptr = mem_alloc_host(alloc_bytes)
    if( is_null_ptr(ptr) ) then
      ncclResult_t = 1  ! ncclUnhandledCudaError
    else
      ncclResult_t = 0  ! ncclSuccess
    end if
  end function ncclMemAlloc

  function ncclMemFree(ptr) result(ncclResult_t)
  !! Mock: Frees memory allocated on CPU
    type(c_ptr),        intent(in)   :: ptr
    integer(c_int32_t)                  :: ncclResult_t

    if ( is_null_ptr(ptr) ) then
      ncclResult_t = 1  ! ncclUnhandledCudaError
      return
    end if
    call mem_free_host(ptr)
    ncclResult_t = 0  ! ncclSuccess
  end function ncclMemFree

  function ncclCommInitRank(comm, nranks, uniqueId, rank) result(ncclResult_t)
  !! Mock: Creates dummy communicator
    type(ncclComm)                   :: comm
    integer(c_int),       intent(in) :: nranks
    type(ncclUniqueId),   intent(in) :: uniqueId
    integer(c_int),       intent(in) :: rank
    integer(c_int32_t)               :: ncclResult_t
    comm%member = c_null_ptr
    ncclResult_t = 0  ! ncclSuccess
  end function ncclCommInitRank

  function ncclSend(sendbuff, count, datatype, peer, comm, stream) result(ncclResult_t)
  !! Mock: Uses MPI_Isend for CPU communication
    real(c_float),                intent(in) :: sendbuff
    integer(c_size_t),            intent(in) :: count
    type(ncclDataType),           intent(in) :: datatype
    integer(c_int),               intent(in) :: peer
    type(ncclComm),               intent(in) :: comm
    type(dtfft_stream_t),         intent(in) :: stream
    integer(c_int32_t)                       :: ncclResult_t
    TYPE_MPI_REQUEST                      :: mpi_request
    integer                               :: mpi_ierr
    integer                               :: mpi_count

    mpi_count = int(count, kind=int32)
    call MPI_Isend(sendbuff, mpi_count, MPI_REAL, peer, 0, MPI_COMM_WORLD, mpi_request, mpi_ierr)

    if (mpi_ierr == MPI_SUCCESS) then
      ! Store request for later completion
      num_requests = num_requests + 1
      requests(num_requests) = mpi_request
      ncclResult_t = 0  ! ncclSuccess
    else
      ncclResult_t = 1  ! ncclError
    end if
  end function ncclSend

  function ncclRecv(recvbuff, count, datatype, peer, comm, stream) result(ncclResult_t)
  !! Mock: Uses MPI_Irecv for CPU communication
    real(c_float),                intent(out) :: recvbuff
    integer(c_size_t),            intent(in)  :: count
    type(ncclDataType),           intent(in)  :: datatype
    integer(c_int),               intent(in)  :: peer
    type(ncclComm),               intent(in)  :: comm
    type(dtfft_stream_t),         intent(in)  :: stream
    integer(c_int32_t)                        :: ncclResult_t
    TYPE_MPI_REQUEST  :: mpi_request
    integer(int32)    :: mpi_ierr
    integer(int32)    :: mpi_count

    mpi_count = int(count, kind=int32)
    call MPI_Irecv(recvbuff, mpi_count, MPI_REAL, peer, 0, MPI_COMM_WORLD, mpi_request, mpi_ierr)

    if (mpi_ierr == MPI_SUCCESS) then
      ! Store request for later completion
      num_requests = num_requests + 1
      requests(num_requests) = mpi_request
      ncclResult_t = 0  ! ncclSuccess
    else
      ncclResult_t = 1  ! ncclError
    end if
  end function ncclRecv

  function ncclGroupStart() result(ncclResult_t)
  !! Mock: Resets request counter
    integer(c_int32_t)                    :: ncclResult_t
    integer(int32) :: comm_size, mpi_ierr

    if ( num_requests /= 0 ) then
      INTERNAL_ERROR("ncclGroupStart: num_requests is not zero")
    end if
    call MPI_Comm_size(MPI_COMM_WORLD, comm_size, mpi_ierr)
    allocate(requests(comm_size * 2))  ! Allocate enough space for all sends and receives
    num_requests = 0
    ncclResult_t = 0  ! ncclSuccess
  end function ncclGroupStart

  function ncclGroupEnd() result(ncclResult_t)
  !! Mock: Completes all pending MPI requests
    integer(c_int32_t)                    :: ncclResult_t
    integer(int32)                        :: i, mpi_ierr

    if ( .not. allocated(requests) ) then
      INTERNAL_ERROR("ncclGroupEnd: mpi_requests should be allocated at this point")
    end if
    if ( num_requests == 0 ) then
      INTERNAL_ERROR("ncclGroupEnd: num_requests should be greater than 0 at this point")
    end if

    ! call MPI_Waitall(num_requests, requests, MPI_STATUSES_IGNORE, mpi_ierr)
    ! MPI_Waitall is somehow messing with internal memory
    ! `get_conf_fourier_reshape_enabled` returns different value after MPI_Waitall
    ! Waiting for each request individually
    do i = 1, num_requests
      call MPI_Wait(requests(i), MPI_STATUS_IGNORE, mpi_ierr)
    enddo

    if (mpi_ierr == MPI_SUCCESS) then
      ncclResult_t = 0  ! ncclSuccess
    else
      ncclResult_t = 1  ! ncclError
    end if
    deallocate(requests)
    num_requests = 0
  end function ncclGroupEnd

  function ncclCommDestroy(comm) result(ncclResult_t)
  !! Mock: Does nothing
    type(ncclComm),           intent(in) :: comm
    integer(c_int32_t)                   :: ncclResult_t
    ncclResult_t = 0  ! ncclSuccess
  end function ncclCommDestroy

  function ncclCommRegister(comm, buff, size, handle) result(ncclResult_t)
  !! Mock: Returns dummy handle
    type(ncclComm),           intent(in)  :: comm
    type(c_ptr),              intent(in)  :: buff
    integer(c_size_t),        intent(in)  :: size
    type(c_ptr),              intent(out) :: handle
    integer(c_int32_t)                    :: ncclResult_t
    handle = buff  ! Just return the same pointer
    ncclResult_t = 0  ! ncclSuccess
  end function ncclCommRegister

  function ncclCommDeregister(comm, handle) result(ncclResult_t)
  !! Mock: Does nothing
    type(ncclComm),        intent(in) :: comm
    type(c_ptr),           intent(in) :: handle
    integer(c_int32_t)                :: ncclResult_t
    ncclResult_t = 0  ! ncclSuccess
  end function ncclCommDeregister

#endif

  function ncclGetErrorString(ncclResult_t) result(string)
  !! Generates an error message.
    integer(c_int32_t), intent(in)    :: ncclResult_t       !! Completion status of a function.
    character(len=:),   allocatable   :: string             !! Error message

#ifndef DTFFT_WITH_MOCK_ENABLED
    call string_c2f(ncclGetErrorString_c(ncclResult_t), string)
#else
    if (ncclResult_t == 0) then
      allocate(string, source="ncclSuccess (mock)")
    else
      allocate(string, source="ncclError (mock)")
    end if
#endif
  end function ncclGetErrorString
end module dtfft_interface_nccl

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_backend_mpi
!! MPI Based Backends [[backend_mpi]]
use iso_fortran_env
use iso_c_binding
use dtfft_abstract_backend
#ifdef DTFFT_WITH_CUDA
use dtfft_interface_cuda_runtime
#endif
use dtfft_errors
use dtfft_parameters
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_cuda.h"
#include "_dtfft_private.h"
#include "_dtfft_profile.h"
implicit none
private
public :: backend_mpi

    type :: mpi_backend_helper
    !! MPI Helper
        integer(CNT_KIND),  allocatable :: counts(:)        !! Counts of data to send or recv
        integer(ADDR_KIND), allocatable :: displs(:)        !! Displacements of data to send or recv
        TYPE_MPI_REQUEST,   allocatable :: requests(:)      !! MPI Requests
        integer(int32),     allocatable :: process_map(:)   !! Process map for pipelined communication
        integer(int32)                  :: n_requests       !! Number of requests
    contains
        procedure, pass(self) :: create => create_helper    !! Creates MPI helper
        procedure, pass(self) :: destroy => destroy_helper  !! Destroys MPI helper
    end type mpi_backend_helper

    type, extends(abstract_backend) :: backend_mpi
    !! MPI Backend
    private
        logical                     :: is_active            !! If async transpose is active
        type(mpi_backend_helper)    :: send                 !! MPI Helper for send data
        type(mpi_backend_helper)    :: recv                 !! MPI Helper for recv data
        logical                     :: is_rma               !! Using RMA backend
        TYPE_MPI_WIN                :: win                  !! MPI Window for RMA backend
        logical                     :: is_request_created   !! Request created flag. Used for persistent functions
        integer(int32), allocatable :: schedule(:)          !! Communication schedule for all-to-all
    contains
        procedure :: create_private => create_mpi   !! Creates MPI backend
        procedure :: execute_private => execute_mpi !! Executes MPI backend
        procedure :: destroy_private => destroy_mpi !! Destroys MPI backend
        procedure :: execute_end => execute_end_mpi !! Finalizes async transpose
        procedure :: get_async_active               !! Overrides abstract method and returns if async transpose is active
        procedure :: execute_p2p
        procedure :: execute_a2a
        procedure :: execute_p2p_scheduled
        procedure :: compute_alltoall_schedule
        procedure :: execute_fused
#ifdef DTFFT_WITH_RMA
        procedure :: execute_rma
        ! procedure :: execute_fused_rma
#endif
    end type backend_mpi

contains

    subroutine create_helper(self, counts, displs, max_requests)
    !! Creates MPI helper
        class(mpi_backend_helper), intent(inout) :: self         !! MPI Helper
        integer(int64), intent(in) :: counts(:)    !! Counts of data to send or recv
        integer(int64), intent(in) :: displs(:)    !! Displacements of data to send or recv
        integer(int32), intent(in) :: max_requests !! Maximum number of requests required
        integer(int32) :: i, n_counts

        n_counts = size(counts)
        allocate (self%counts(0:n_counts - 1), self%displs(0:n_counts - 1))
        self%counts(0:) = int(counts(:), CNT_KIND)
        self%displs(0:) = int(displs(:), ADDR_KIND)
        if (max_requests > 0) then
            allocate (self%requests(max_requests))
            do i = 1, max_requests
                self%requests(i) = MPI_REQUEST_NULL
            end do
        end if
        self%n_requests = 0
    end subroutine create_helper

    subroutine destroy_helper(self, is_request_created)
    !! Destroys MPI helper
        class(mpi_backend_helper), intent(inout) :: self !! MPI Helper
        logical, intent(in) :: is_request_created

        if (allocated(self%counts)) deallocate (self%counts)
        if (allocated(self%displs)) deallocate (self%displs)
#if defined(ENABLE_PERSISTENT_COMM) || defined(DTFFT_WITH_RMA)
        block
            integer(int32) :: mpi_ierr, i

            if (is_request_created) then
                do i = 1, self%n_requests
                    if (self%requests(i) /= MPI_REQUEST_NULL) &
                        call MPI_Request_free(self%requests(i), mpi_ierr)
                end do
            end if
        end block
#endif
        if (allocated(self%requests)) deallocate (self%requests)
        if (allocated(self%process_map)) deallocate (self%process_map)
        self%n_requests = 0
    end subroutine destroy_helper

    subroutine create_mpi(self, helper, base_storage)
    !! Creates MPI backend
        class(backend_mpi),     intent(inout) :: self           !! MPI Backend
        type(backend_helper),   intent(in) :: helper         !! Backend helper (unused)
        integer(int64),         intent(in) :: base_storage   !! Number of bytes to store single element (unused)
        integer(int32) :: mpi_err

#ifdef DTFFT_DEBUG
        if (.not. is_backend_mpi(self%backend)) then
            INTERNAL_ERROR(".not. is_backend_mpi")
        endif
#endif
        if (self%backend == DTFFT_BACKEND_MPI_A2A) then
            call self%send%create(self%send_floats, self%send_displs - 1, 1)
            call self%recv%create(self%recv_floats, self%recv_displs - 1, 0)
        else if ( self%backend == DTFFT_BACKEND_MPI_P2P_SCHEDULED ) then
            call self%send%create(self%send_floats, self%send_displs, 0)
            call self%recv%create(self%recv_floats, self%recv_displs, 0)
            call self%compute_alltoall_schedule()
        else
            call self%send%create(self%send_floats, self%send_displs, self%comm_size)
            call self%recv%create(self%recv_floats, self%recv_displs, self%comm_size)
            if ( self%is_fused ) call self%compute_alltoall_schedule()
        end if

        self%is_rma = .false.
#ifdef DTFFT_WITH_RMA
        self%win = MPI_WIN_NULL
        if ( is_backend_rma(self%backend) ) then
            block
                integer(int32), allocatable :: all_displs(:, :)

                self%is_rma = .true.

                allocate (all_displs(0:self%comm_size - 1, 0:self%comm_size - 1))
                call MPI_Allgather(self%send%displs, self%comm_size, MPI_INTEGER, all_displs, self%comm_size, MPI_INTEGER, self%comm, mpi_err)
                self%send%displs(:) = all_displs(self%comm_rank, :) - 1
                deallocate (all_displs)
            end block
        endif
#endif
        self%is_request_created = .false.
        self%is_active = .false.
    end subroutine create_mpi

    subroutine destroy_mpi(self)
    !! Destroys MPI backend
        class(backend_mpi), intent(inout) :: self           !! MPI Backend
        integer(int32) :: mpi_ierr

        call self%send%destroy(self%is_request_created)
        call self%recv%destroy(self%is_request_created)
        if ( allocated(self%schedule) ) deallocate (self%schedule)
#ifdef DTFFT_WITH_RMA
        if (self%is_rma) then
            if (self%win /= MPI_WIN_NULL) &
                call MPI_Win_free(self%win, mpi_ierr)
        end if
#endif
        self%is_request_created = .false.
        self%is_active = .false.
    end subroutine destroy_mpi

    elemental logical function get_async_active(self)
    !! Returns if async transpose is active
        class(backend_mpi), intent(in) :: self              !!  MPI Backend
        get_async_active = self%is_active
    end function get_async_active

    subroutine execute_mpi(self, in, out, stream, aux, error_code)
    !! Executes MPI backend
        class(backend_mpi),                 intent(inout)   :: self       !! MPI Backend
        real(real32),   target, contiguous, intent(inout)   :: in(:)      !! Send pointer
        real(real32),   target, contiguous, intent(inout)   :: out(:)     !! Recv pointer
        type(dtfft_stream_t),               intent(in)      :: stream     !! Main execution CUDA stream
        real(real32),   target, contiguous, intent(inout)   :: aux(:)     !! Aux pointer
        integer(int32),                     intent(out)     :: error_code !! Error code
        integer(int32)              :: mpi_ierr             !! MPI error code
        integer(int32), allocatable :: indices(:)
        integer(int32)              :: total_completed, n_completed      !! Request counter
        integer(int32)              :: need_completed
        integer(int32)              :: i                    !! Loop index

        error_code = DTFFT_SUCCESS
        if (self%is_active) then
            error_code = DTFFT_ERROR_TRANSPOSE_ACTIVE
            return
        end if
        if ( self%is_fused ) then
            ! if ( self%is_rma ) then
            !     call self%execute_fused_rma(in, out, stream, aux)
            !     return
            ! endif
            call self%execute_fused(in, out, stream, aux)
!             if ( is_backend_rma(self%backend) ) then
! #ifdef DTFFT_WITH_RMA
!                 call self%execute_fused_rma(in, out, stream, aux)
! #else
!                 INTERNAL_ERROR("Fused RMA backend requested but DTFFT_WITH_RMA is not defined")
! #endif
!             else
!                 call self%execute_fused_p2p(in, out, stream, aux)
!             endif
            return
        endif
#ifdef DTFFT_WITH_CUDA
        if (self%platform == DTFFT_PLATFORM_CUDA) then
            ! Need to sync stream since there is no way pass current stream to MPI
            CUDA_CALL(cudaStreamSynchronize(stream))
        end if
#endif

        if ( .not. self%is_pipelined ) then
            select case (self%backend%val)
            case (DTFFT_BACKEND_MPI_P2P%val)
                call self%execute_p2p(in, out)
            case (DTFFT_BACKEND_MPI_A2A%val)
                call self%execute_a2a(in, out)
            case (DTFFT_BACKEND_MPI_P2P_SCHEDULED%val)
                call self%execute_p2p_scheduled(in, out)
#ifdef DTFFT_WITH_RMA
            case (DTFFT_BACKEND_MPI_RMA%val)
                call self%execute_rma(in, out)
#endif
            end select
            if ( self%platform == DTFFT_PLATFORM_HOST .and. self%backend /= DTFFT_BACKEND_MPI_P2P_SCHEDULED ) then
                call self%execute_self_copy(in, out, stream)
            endif
            self%is_active = .true.
            if ( self%backend == DTFFT_BACKEND_MPI_P2P_SCHEDULED ) self%is_active = .false.
            return
        endif

        if (self%backend == DTFFT_BACKEND_MPI_P2P_PIPELINED) then
            call self%execute_p2p(in, aux)
#ifdef DTFFT_WITH_RMA
        else
            call self%execute_rma(in, aux)
#endif
        end if

        if ( self%platform == DTFFT_PLATFORM_HOST ) then
            call self%execute_self_copy(in, aux, stream)
            call self%unpack_kernel%execute(c_loc(aux), c_loc(out), stream, self%comm_rank + 1)
        endif

        allocate (indices(self%recv%n_requests))
        need_completed = self%recv%n_requests
        total_completed = 0
        do while (.true.)
            ! Testing that all data has been recieved so we can unpack it
            call MPI_Waitsome(self%recv%n_requests, self%recv%requests, n_completed, indices, MPI_STATUSES_IGNORE, mpi_ierr)
            if (n_completed == MPI_UNDEFINED .or. need_completed == 0) exit

            do i = 1, n_completed
#ifdef MPICH_FIX_REQUIRED
                call self%unpack_kernel%execute(c_loc(aux), c_loc(out), stream, self%recv%process_map(indices(i) + 1) + 1)
#else
                call self%unpack_kernel%execute(c_loc(aux), c_loc(out), stream, self%recv%process_map(indices(i)) + 1)
#endif
            end do
            total_completed = total_completed + n_completed
            if (total_completed == need_completed) exit
        end do
        deallocate (indices)
        if (self%send%n_requests > 0) then
            call MPI_Waitall(self%send%n_requests, self%send%requests, MPI_STATUSES_IGNORE, mpi_ierr)
        end if
        if (self%is_rma) then
            call MPI_Win_fence(MPI_MODE_NOSUCCEED, self%win, error_code)
        end if
    end subroutine execute_mpi

    subroutine execute_end_mpi(self, error_code)
    !! Finalizes async backend execution
        class(backend_mpi), intent(inout)   :: self       !! MPI Backend
        integer(int32),     intent(out)     :: error_code !! Error code

        error_code = DTFFT_SUCCESS
        if (self%is_pipelined .or. self%is_fused) return
        if (.not. self%is_active) then
            error_code = DTFFT_ERROR_TRANSPOSE_NOT_ACTIVE
            return
        end if

        if (self%recv%n_requests > 0) then
            call MPI_Waitall(self%recv%n_requests, self%recv%requests, MPI_STATUSES_IGNORE, error_code)
        end if
        if (self%send%n_requests > 0) then
            call MPI_Waitall(self%send%n_requests, self%send%requests, MPI_STATUSES_IGNORE, error_code)
        end if
        if (self%is_rma) then
            call MPI_Win_fence(MPI_MODE_NOSUCCEED, self%win, error_code)
        end if
        self%is_active = .false.
    end subroutine execute_end_mpi

    subroutine execute_p2p(self, in, out)
    !! Executes Point-to-Point MPI backend
        class(backend_mpi), intent(inout) :: self   !! MPI Backend
        real(real32),       intent(in)    :: in(:)  !! Data to be sent
        real(real32),       intent(inout) :: out(:) !! Data to be received
        integer(int32) :: send_request_counter, recv_request_counter
        integer(int32) :: i, mpi_ierr

        associate( recv => self%recv, send => self%send )

        if (.not. allocated(recv%process_map)) then
            allocate (recv%process_map(self%comm_size))
        end if

#ifdef ENABLE_PERSISTENT_COMM
        if (.not. self%is_request_created) then
            recv_request_counter = 0
            do i = 0, self%comm_size - 1
                if (recv%counts(i) > 0) then
                    recv_request_counter = recv_request_counter + 1
                    recv%process_map(recv_request_counter) = i
                    call MPI_Recv_init(out(recv%displs(i)), recv%counts(i), MPI_REAL, i, 0, self%comm, recv%requests(recv_request_counter), mpi_ierr)
                end if
            end do
            recv%n_requests = recv_request_counter

            send_request_counter = 0
            do i = 0, self%comm_size - 1
                if (send%counts(i) > 0) then
                    send_request_counter = send_request_counter + 1
                    call MPI_Send_init(in(send%displs(i)), send%counts(i), MPI_REAL, i, 0, self%comm, send%requests(send_request_counter), mpi_ierr)
                end if
            end do
            send%n_requests = send_request_counter
            self%is_request_created = .true.
        end if
        call MPI_Startall(recv%n_requests, recv%requests, mpi_ierr)
        call MPI_Startall(send%n_requests, send%requests, mpi_ierr)
#else
        send_request_counter = 0
        recv_request_counter = 0
        do i = 0, self%comm_size - 1
            if (recv%counts(i) > 0) then
                recv_request_counter = recv_request_counter + 1
                recv%process_map(recv_request_counter) = i
                call MPI_Irecv(out(recv%displs(i)), recv%counts(i), MPI_REAL, i, 0, self%comm, recv%requests(recv_request_counter), mpi_ierr)
            end if
        end do
        recv%n_requests = recv_request_counter

        do i = 0, self%comm_size - 1
            if (send%counts(i) > 0) then
                send_request_counter = send_request_counter + 1
                call MPI_Isend(in(send%displs(i)), send%counts(i), MPI_REAL, i, 0, self%comm, send%requests(send_request_counter), mpi_ierr)
            end if
        end do
        send%n_requests = send_request_counter
#endif

        endassociate
    end subroutine execute_p2p

    subroutine execute_p2p_scheduled(self, in, out)
    !! Executes Scheduled Point-to-Point MPI backend
        class(backend_mpi), intent(inout) :: self   !! MPI Backend
        real(real32),       intent(in)    :: in(:)  !! Data to be sent
        real(real32),       intent(inout) :: out(:) !! Data to be received
        integer(int32) :: i, tgt, mpi_ierr

        associate( recv => self%recv, send => self%send )
        do i = 0, self%comm_size - 1
            tgt = self%schedule(i)
            if ( tgt == self%comm_rank .and. self%platform == DTFFT_PLATFORM_HOST) then
                call self%execute_self_copy(in, out, NULL_STREAM)
            else
                call MPI_Sendrecv(in(send%displs(tgt)), send%counts(tgt), MPI_REAL, tgt, 0, out(recv%displs(tgt)), recv%counts(tgt), MPI_REAL, tgt, 0, self%comm, MPI_STATUS_IGNORE, mpi_ierr)
            endif
        enddo

        endassociate
    end subroutine execute_p2p_scheduled

    subroutine execute_a2a(self, in, out)
    !! Executes All-to-All MPI backend
        class(backend_mpi), intent(inout) :: self   !! MPI Backend
        real(real32),       intent(in)    :: in(:)  !! Data to be sent
        real(real32),       intent(inout) :: out(:) !! Data to be received
        integer(int32) :: mpi_ierr

        associate( recv => self%recv, send => self%send )

        if ( self%is_even .and. self%platform /= DTFFT_PLATFORM_CUDA ) then
#if defined(ENABLE_PERSISTENT_COLLECTIVES)
            if ( .not. self%is_request_created ) then
                call MPI_Alltoall_init(in, send%counts(0), MPI_REAL, out, recv%counts(0), MPI_REAL, self%comm, MPI_INFO_NULL, send%requests(1), mpi_ierr)
                self%is_request_created = .true.
            endif
            call MPI_Start(send%requests(1), mpi_ierr)
#else
            call MPI_Ialltoall(in, send%counts(0), MPI_REAL, out, recv%counts(0), MPI_REAL, self%comm, send%requests(1), mpi_ierr)
#endif
        else
#if defined(ENABLE_PERSISTENT_COLLECTIVES)
            if (.not. self%is_request_created) then
                call MPI_Alltoallv_init(in, send%counts, send%displs, MPI_REAL, out, recv%counts, recv%displs, MPI_REAL, self%comm, MPI_INFO_NULL, send%requests(1), mpi_ierr)
                self%is_request_created = .true.
            end if
            call MPI_Start(send%requests(1), mpi_ierr)
#else
        call MPI_Ialltoallv(in, send%counts, send%displs, MPI_REAL, out, recv%counts, recv%displs, MPI_REAL, self%comm, send%requests(1), mpi_ierr)
#endif
        endif

        send%n_requests = 1
        endassociate
    end subroutine execute_a2a

#ifdef DTFFT_WITH_RMA
    subroutine execute_rma(self, in, out)
    !! Executes RMA backend
        class(backend_mpi),     intent(inout) :: self   !! MPI Backend
        real(real32), target,   intent(in)    :: in(:)  !! Data to be sent
        real(real32),           intent(inout) :: out(:) !! Data to be received
        integer(int32) :: i, mpi_ierr
        integer(int32) :: recv_request_counter

        associate( recv => self%recv, send => self%send )

        if (.not. allocated(recv%process_map)) then
            allocate (recv%process_map(self%comm_size))
        end if
        if (.not. self%is_request_created) then
            call MPI_Win_create(in, int( size(in) * FLOAT_STORAGE_SIZE, MPI_ADDRESS_KIND ), int(FLOAT_STORAGE_SIZE, int32), MPI_INFO_NULL, self%comm, self%win, mpi_ierr)
            self%is_request_created = .true.
        end if

        call MPI_Win_fence(MPI_MODE_NOPRECEDE, self%win, mpi_ierr)

        recv_request_counter = 0
        do i = 0, self%comm_size - 1
            if (recv%counts(i) > 0) then
                recv_request_counter = recv_request_counter + 1
                recv%process_map(recv_request_counter) = i
                call MPI_RGet(out(recv%displs(i)), recv%counts(i), MPI_REAL, i, int(send%displs(i), MPI_ADDRESS_KIND), recv%counts(i), MPI_REAL, self%win, recv%requests(recv_request_counter), mpi_ierr)
            end if
        end do
        recv%n_requests = recv_request_counter

        endassociate
    end subroutine execute_rma
#endif

    subroutine execute_fused(self, in, out, stream, aux)
    !! Executes FUSED backends (p2p/rma)
        class(backend_mpi),                 intent(inout)   :: self       !! MPI Backend
        real(real32), target,   contiguous, intent(inout)   :: in(:)      !! Send pointer
        real(real32), target,   contiguous, intent(inout)   :: out(:)     !! Recv pointer
        type(dtfft_stream_t),               intent(in)      :: stream     !! Main execution CUDA stream
        real(real32), target,   contiguous, intent(inout)   :: aux(:)     !! Aux pointer
        integer(int64) :: aux_size
        real(real32), pointer, contiguous :: aux2(:)
        integer(int32) :: i, k, tgt, mpi_ierr, comm_rank
        integer(int32) :: send_request_counter, recv_request_counter
        integer(int32), allocatable :: indices(:)
        integer(int32)              :: total_completed, n_completed      !! Request counter
        real(real32), pointer, contiguous :: send_buffer(:), recv_buffer(:)
        integer(int32) :: source_rank, send_count, recv_count
        integer(int32) :: active_recvs
        call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, mpi_ierr)

        aux_size = size(aux, kind=int64) / 2
        call c_f_pointer(ptr_offset(c_loc(aux), aux_size * FLOAT_STORAGE_SIZE), aux2, [aux_size])

        if ( self%pack_kernel%is_dummy_kernel ) then
            send_buffer => in
            recv_buffer => aux
        else if ( self%pack_kernel%is_dummy_compressed ) then
            send_buffer => aux
            recv_buffer => aux2
        else if ( self%unpack_kernel%is_dummy_kernel ) then
            send_buffer => aux
            recv_buffer => out
        else
            ! if compressed:
            !   pack: in -> aux2
            !   compress: aux2 -> aux
            !   send: aux -> aux2
            !   decompress: aux2 -> in
            !   unpack: in -> out
            ! else:
            !   pack: in -> aux
            !   send: aux -> aux2
            !   unpack aux2 -> out

            ! Self copy
            ! if compressed or not:
            !   pack: in -> aux
            !   copy: aux -> aux2
            !   unpack: aux2 -> out
            send_buffer => aux
            recv_buffer => aux2
        endif

        recv_request_counter = 0
        send_request_counter = 0
        active_recvs = 0
        associate( recv => self%recv, send => self%send )

            if (.not. allocated(recv%process_map)) then
                allocate (recv%process_map(self%comm_size))
            end if

#ifdef DTFFT_WITH_RMA
            if ( self%is_rma ) then
                if ( .not. self%is_request_created ) then
                    call MPI_Win_create(send_buffer, int( size(in) * FLOAT_STORAGE_SIZE, MPI_ADDRESS_KIND ), int(1, int32), MPI_INFO_NULL, self%comm, self%win, mpi_ierr)
                    self%is_request_created = .true.
                endif
                call MPI_Win_fence(MPI_MODE_NOPRECEDE, self%win, mpi_ierr)
            endif
#endif

            do i = 0, self%comm_size - 1
                tgt = self%schedule(i)
                if ( tgt == self%comm_rank ) then
                    call self%pack_kernel%execute(c_loc(in), c_loc(send_buffer), stream, tgt + 1, skip_compression=.true.)
                    cycle
                endif
                call self%pack_kernel%execute(c_loc(in), c_loc(send_buffer), stream, tgt + 1, aux=c_loc(out), csize=send_count, sync=.true.)
                if ( self%pack_kernel%is_dummy .or. self%pack_kernel%is_dummy_kernel ) send_count = send%counts(tgt)

                if ( self%is_rma ) then
#ifdef DTFFT_WITH_RMA
                    ! This is synchronization point between two processes
                    ! `recv_count` might be known if compression is not used, however
                    ! we still use Sendrecv to be sure both sides are synchronized
                    call MPI_Sendrecv(send_count, 1, MPI_INTEGER, tgt, 0, recv_count, 1, MPI_INTEGER, tgt, 0, self%comm, MPI_STATUS_IGNORE, mpi_ierr)

                    if (recv_count > 0) then
                        active_recvs = active_recvs + 1
                        recv_request_counter = recv_request_counter + 1
                        recv%process_map(recv_request_counter) = tgt
                        ! call MPI_Win_lock(MPI_LOCK_EXCLUSIVE, tgt, 0, self%win, mpi_ierr)
                        call MPI_Rget(recv_buffer(recv%displs(tgt)), recv_count, MPI_REAL, tgt, int(send%displs(tgt) * FLOAT_STORAGE_SIZE, MPI_ADDRESS_KIND), recv_count, MPI_REAL, self%win, recv%requests(recv_request_counter), mpi_ierr)
                        ! call MPI_Win_unlock(tgt, self%win, mpi_ierr)
                    end if
#endif
                else    ! P2P
                    if (recv%counts(tgt) > 0) then
                        active_recvs = active_recvs + 1
                        recv_request_counter = recv_request_counter + 1
                        recv%process_map(recv_request_counter) = tgt
                        ! Do not care if actual message size is less then recv%counts(tgt)
                        call MPI_Irecv(recv_buffer(recv%displs(tgt)), recv%counts(tgt), MPI_REAL, tgt, 0, self%comm, recv%requests(recv_request_counter), mpi_ierr)
                    end if
                    if ( send_count > 0 ) then
                        send_request_counter = send_request_counter + 1
                        call MPI_Isend(send_buffer(send%displs(tgt)), send_count, MPI_REAL, tgt, 0, self%comm, send%requests(send_request_counter), mpi_ierr)
                    endif
                endif
            enddo

            if ( self%unpack_kernel%is_dummy .or. self%unpack_kernel%is_dummy_compressed ) then
                call self%execute_self_copy(send_buffer, out, stream)
            else if ( self%pack_kernel%is_dummy_compressed ) then
                call self%execute_self_copy(in, recv_buffer, stream)
                call self%unpack_kernel%execute(c_loc(recv_buffer), c_loc(out), self%copy_stream, self%comm_rank + 1, skip_compression=.true.)
            else
                call self%execute_self_copy(send_buffer, recv_buffer, stream)
                call self%unpack_kernel%execute(c_loc(recv_buffer), c_loc(out), self%copy_stream, self%comm_rank + 1, skip_compression=.true.)
            endif
            call self%wait(stream)

            total_completed = 0
            allocate( indices(recv_request_counter) )

            do while (active_recvs > 0)
                call MPI_Waitsome(recv_request_counter, recv%requests, n_completed, indices, MPI_STATUSES_IGNORE, mpi_ierr)
                if (n_completed /= MPI_UNDEFINED .and. n_completed > 0) then
                    do k = 1, n_completed
#ifdef MPICH_FIX_REQUIRED
                        source_rank = recv%process_map(indices(k) + 1)
#else
                        source_rank = recv%process_map(indices(k))
#endif
                        call self%unpack_kernel%execute(c_loc(recv_buffer), c_loc(out), stream, source_rank + 1, aux=c_loc(in))
                        active_recvs = active_recvs - 1
                    end do
                end if
            end do
            deallocate (indices)

            if (send_request_counter > 0) then
                call MPI_Waitall(send_request_counter, send%requests, MPI_STATUSES_IGNORE, mpi_ierr)
            end if
        endassociate

#ifdef DTFFT_WITH_RMA
        if ( self%is_rma ) then
            call MPI_Win_fence(MPI_MODE_NOSUCCEED, self%win, mpi_ierr)
        endif
#endif
    end subroutine execute_fused

    subroutine compute_alltoall_schedule(self)
    !! Generate optimal round-robin communication schedule for all-to-all pattern
        class(backend_mpi), intent(inout) :: self           !! MPI Backend
        integer(int32) :: round, offset, num_rounds, idx, peer

        idx = 0
        allocate( self%schedule(0:self%comm_size - 1) )
        ! Handle even/odd number of processes differently
        if (mod(self%comm_size, 2) == 0) then
            num_rounds = self%comm_size
            ! Self-communication first
            self%schedule(idx) = self%comm_rank; idx = idx + 1
        else
            num_rounds = self%comm_size + 1
        end if

        ! Generate round-robin schedule using circular shift pattern
        do round = 0, num_rounds - 2
            if (mod(self%comm_size, 2) == 0) then
                ! Special handling for last process in even case
                if (round == self%comm_rank) then
                    self%schedule(idx) = self%comm_size - 1; idx = idx + 1
                else if (self%comm_size - 1 == self%comm_rank) then
                    self%schedule(idx) = round; idx = idx + 1
                end if
            else if (round == self%comm_rank) then
                self%schedule(idx) = round; idx = idx + 1
            end if

            if (round /= self%comm_rank .and. self%comm_rank < num_rounds - 1) then
                ! Forward pairing
                offset = mod(round - self%comm_rank + (num_rounds - 1), num_rounds - 1)
                if (offset < num_rounds/2) then
                    peer = mod(round + offset, num_rounds - 1)
                    self%schedule(idx) = peer; idx = idx + 1
                end if
                ! Backward pairing
                offset = mod(self%comm_rank - round + (num_rounds - 1), num_rounds - 1)
                if (offset < num_rounds/2) then
                    peer = mod(round - offset + (num_rounds - 1), num_rounds - 1)
                    self%schedule(idx) = peer; idx = idx + 1
                end if
            end if
        end do
    end subroutine compute_alltoall_schedule

end module dtfft_backend_mpi

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
program test_r2c_3d
use iso_fortran_env
use iso_c_binding
use dtfft
use test_utils
#include "_dtfft_mpi.h"
#include "dtfft.f03"
#if defined(DTFFT_WITH_CUDA)
use dtfft_interface_cuda_runtime
#include "_dtfft_cuda.h"
#endif
implicit none
  type(c_ptr) :: check
  real(real64),     pointer :: in(:,:,:)
  complex(real64),  pointer :: out(:)
  integer(int32), parameter :: nx = 256, ny = 256, nz = 4
  integer(int32) :: comm_size, comm_rank, ierr, dims(3), sizes(3), starts(3)
  type(dtfft_executor_t) :: executor
  type(dtfft_plan_r2c_t) :: plan
  integer(int32) :: in_counts(3), out_counts(3)
  integer(int64) :: alloc_size, element_size, in_size
  real(real64) :: tf, tb
  type(dtfft_pencil_t) :: real_bricks, real_pencil, cmplx_pencil, start_pencil
#if defined(DTFFT_WITH_CUDA)
  type(dtfft_platform_t) :: platform
#endif

  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, comm_size, ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)

  if(comm_rank == 0) then
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a)') "|       dtFFT test: r2c_3d             |"
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a, i0, a, i0, a, i0)') 'Nx = ',nx, ', Ny = ',ny, ', Nz = ', nz
    write(output_unit, '(a, i0)') 'Number of processors: ', comm_size
    write(output_unit, '(a)') "----------------------------------------"
  endif
#ifdef DTFFT_TRANSPOSE_ONLY
  if ( comm_rank == 0 ) &
    write(output_unit, '(a)') "R2C Transpose plan not supported, skipping it"

  call MPI_Finalize(ierr)
  stop
#endif

  executor = DTFFT_EXECUTOR_NONE

#if defined (DTFFT_WITH_FFTW)
  executor = DTFFT_EXECUTOR_FFTW3
#elif defined (DTFFT_WITH_MKL)
  executor = DTFFT_EXECUTOR_MKL
#endif

#ifdef DTFFT_WITH_CUDA
  block
    character(len=5) :: platform_env
    integer(int32) :: env_len

    call get_environment_variable("DTFFT_PLATFORM", platform_env, env_len)

    if ( env_len == 0 .or. trim(adjustl(platform_env)) == "cuda" ) then
# if defined( DTFFT_WITH_CUFFT )
      executor = DTFFT_EXECUTOR_CUFFT
# elif defined( DTFFT_WITH_VKFFT )
      executor = DTFFT_EXECUTOR_VKFFT
# endif
    endif
  endblock
#endif

  if ( executor == DTFFT_EXECUTOR_NONE ) then
    if ( comm_rank == 0 ) &
      write(output_unit, '(a)') "Could not find valid R2C FFT executor, skipping test"
    call MPI_Finalize(ierr)
    stop
  endif

  call attach_gpu_to_process()

  dims(:) = 0
  call createGridDims(3, [nx, ny, nz], dims, starts, sizes)

  start_pencil = dtfft_pencil_t(starts, sizes)

  call plan%create(start_pencil, executor=executor, effort=DTFFT_MEASURE, error_code=ierr); DTFFT_CHECK(ierr)

  call plan%get_local_sizes(in_counts=in_counts, out_counts=out_counts, alloc_size=alloc_size, error_code=ierr); DTFFT_CHECK(ierr)
  call plan%report()

  element_size = plan%get_element_size()

  if ( element_size /= real64 ) error stop "element_size /= real64"
  if ( dims(1) > 1 ) then
    real_bricks = plan%get_pencil(DTFFT_LAYOUT_X_BRICKS, error_code=ierr); DTFFT_CHECK(ierr)
    if ( any(in_counts /= real_bricks%counts) ) error stop "in_counts /= real_bricks%counts"
  endif
  real_pencil = plan%get_pencil(DTFFT_LAYOUT_X_PENCILS, error_code=ierr); DTFFT_CHECK(ierr)
  cmplx_pencil = plan%get_pencil(DTFFT_LAYOUT_X_PENCILS_FOURIER, error_code=ierr); DTFFT_CHECK(ierr)

  if ( dims(1) == 1 ) then
    if ( any(in_counts /= real_pencil%counts) ) error stop "in_counts /= real_pencil%counts"
  endif
  if ( cmplx_pencil%counts(1) /= (nx / 2) + 1 ) error stop "cmplx_pencil%counts(1) /= (nx / 2) + 1"
  if ( any(real_pencil%counts(2:) /= cmplx_pencil%counts(2:)) ) error stop "cmplx_pencil%counts(1) /= (nx / 2) + 1"
  if ( comm_size == 1 ) then
    if ( any(real_pencil%counts /= [nx, ny, nz]) ) error stop "real_pencil%counts /= [nx, ny, nz]"
  endif

  call plan%mem_alloc(alloc_size, in, in_counts, error_code=ierr); DTFFT_CHECK(ierr)
  call plan%mem_alloc(alloc_size / 2, out, error_code=ierr); DTFFT_CHECK(ierr)
  in_size = product(in_counts)
  check = mem_alloc_host(in_size * DOUBLE_STORAGE_SIZE)
  call setTestValuesDouble(check, in_size)

#if defined(DTFFT_WITH_CUDA)
  platform = plan%get_platform(error_code=ierr); DTFFT_CHECK(ierr)
  call doubleH2D(check, c_loc(in), in_size, platform%val)
#else
  call doubleH2D(check, c_loc(in), in_size)
#endif

  tf = 0.0_real64 - MPI_Wtime()
  call plan%execute(in, out, DTFFT_EXECUTE_FORWARD, error_code=ierr); DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    CUDA_CALL( cudaDeviceSynchronize() )
  endif
#endif
  tf = tf + MPI_Wtime()

#if defined(DTFFT_WITH_CUDA)
  call scaleComplexDouble(executor%val, c_loc(out), int(product(out_counts), int64), int(nx * ny * nz, int64), platform%val, NULL_STREAM)
#else
  call scaleComplexDouble(executor%val, c_loc(out), int(product(out_counts), int64), int(nx * ny * nz, int64))
#endif

  tb = 0.0_real64 - MPI_Wtime()
  call plan%execute(out, in, DTFFT_EXECUTE_BACKWARD, error_code=ierr); DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    CUDA_CALL( cudaDeviceSynchronize() )
  endif
#endif
  tb = tb + MPI_Wtime()

#if defined(DTFFT_WITH_CUDA) && !defined(DTFFT_WITH_MOCK_ENABLED)
  call checkAndReportDouble(int(nx * ny* nz, int64), tf, tb, c_loc(in), in_size, check, platform%val)
#else
  call checkAndReportDouble(int(nx * ny* nz, int64), tf, tb, c_loc(in), in_size, check)
#endif

  call plan%mem_free(in)
  call plan%mem_free(out)
  call mem_free_host(check)

  call plan%destroy()
  call MPI_Finalize(ierr)
end program test_r2c_3d

#define DTFFT_CHECK(ierr)                                       \
  if( ierr /= DTFFT_SUCCESS ) then;                             \
    block;                                                      \
      use iso_fortran_env, only: error_unit;                    \
      integer :: mpi_err;                                       \
      write(error_unit, '(a,i0)') "dtFFT Error: '"//dtfft_get_error_string(ierr)//"' at "//__FILE__//":", __LINE__;    \
      call MPI_Abort(MPI_COMM_WORLD, ierr, mpi_err);            \
    endblock;                                                   \
  endif

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
program test_c2c_3d_float
use iso_fortran_env
use iso_c_binding, only: c_null_ptr, c_loc, c_ptr
use dtfft
use test_utils
#if defined(DTFFT_WITH_CUDA)
use dtfft_interface_cuda_runtime
#endif
#include "_dtfft_mpi.h"
#include "_dtfft_cuda.h"
#include "dtfft.f03"
implicit none
  type(c_ptr) :: check
  complex(real32), pointer :: in(:,:,:), out(:)
  integer(int32), parameter :: nx = 355, ny = 499, nz = 29
  integer(int32) :: comm_size, comm_rank, i
  type(dtfft_plan_c2c_t) :: plan
  integer(int32) :: in_counts(3), out_counts(3), in_starts(3)
  integer(int64) :: alloc_size, in_size, out_size, element_size
  real(real64) :: tf, tb
  type(dtfft_executor_t) :: executor
  integer(int32) :: ierr
  type(dtfft_config_t) :: conf
  type(dtfft_backend_t) :: backend
#if defined(DTFFT_WITH_CUDA)
  type(dtfft_platform_t) :: platform
  logical :: is_cuda_platform
#endif

  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, comm_size, ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)

  if(comm_rank == 0) then
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a)') "|       dtFFT test: c2c_3d_float       |"
    write(output_unit, '(a)') "----------------------------------------"
    write(output_unit, '(a, i0, a, i0, a, i0)') 'Nx = ',nx, ', Ny = ',ny, ', Nz = ',nz
    write(output_unit, '(a, i0)') 'Number of processors: ', comm_size
    write(output_unit, '(a)') "----------------------------------------"
  endif

#if defined (DTFFT_WITH_FFTW)
  executor = DTFFT_EXECUTOR_FFTW3
#elif defined (DTFFT_WITH_MKL)
  executor = DTFFT_EXECUTOR_MKL
#else
  executor = DTFFT_EXECUTOR_NONE
#endif

#ifdef DTFFT_WITH_CUDA
  block
    character(len=5) :: platform_env
    integer(int32) :: env_len

    call get_environment_variable("DTFFT_PLATFORM", platform_env, env_len)

    is_cuda_platform = .false.
    if ( env_len == 0 .or. trim(adjustl(platform_env)) == "cuda" ) then
      is_cuda_platform = .true.
# if defined( DTFFT_WITH_CUFFT )
      executor = DTFFT_EXECUTOR_CUFFT
# elif defined( DTFFT_WITH_VKFFT )
      executor = DTFFT_EXECUTOR_VKFFT
# else
      executor = DTFFT_EXECUTOR_NONE
# endif
    endif
  endblock
#endif

  call attach_gpu_to_process()

  conf = dtfft_config_t()

! #ifdef DTFFT_WITH_COMPRESSION
!   conf%backend = DTFFT_BACKEND_MPI_P2P_COMPRESSED
!   conf%compression_config_transpose%compression_mode = DTFFT_COMPRESSION_MODE_FIXED_RATE
!   conf%compression_config_transpose%rate = 16.0
! #else
  backend = DTFFT_BACKEND_MPI_P2P_FUSED
! #endif

#if defined(DTFFT_WITH_CUDA)
    ! Can be redefined by environment variable
    conf%platform = DTFFT_PLATFORM_CUDA

    if ( is_cuda_platform ) then
#if defined(DTFFT_WITH_NVSHMEM)
      backend = DTFFT_BACKEND_CUFFTMP_PIPELINED
#elif defined(DTFFT_WITH_NCCL)
      backend = DTFFT_BACKEND_NCCL_PIPELINED
#endif
    endif
#endif
  conf%backend = backend

  call dtfft_set_config(conf, error_code=ierr); DTFFT_CHECK(ierr)

  call plan%create([nx, ny, nz], precision=DTFFT_SINGLE, executor=executor, error_code=ierr); DTFFT_CHECK(ierr)
  call plan%get_local_sizes(in_starts=in_starts, in_counts=in_counts, out_counts=out_counts, alloc_size=alloc_size, error_code=ierr); DTFFT_CHECK(ierr)

  call plan%report()

#if defined(DTFFT_WITH_CUDA)
  platform = plan%get_platform(ierr); DTFFT_CHECK(ierr)

  if ( platform == DTFFT_PLATFORM_CUDA ) then
    block
      type(dtfft_backend_t) :: real_backend

      real_backend = plan%get_backend(error_code=ierr); DTFFT_CHECK(ierr)
      if ( backend /= real_backend .and. comm_size > 1 ) error stop "backend /= real_backend"
    endblock
  endif
#endif

  element_size = plan%get_element_size(ierr); DTFFT_CHECK(ierr)
  if ( element_size /= 8_int64 ) error stop "element_size /= 8_int64"

  in_size = product(in_counts)
  out_size = product(out_counts)

  call plan%mem_alloc(alloc_size, in, in_counts, lbounds=in_starts, error_code=ierr)
  do i = 1, 3
    if ( lbound(in, dim=i) /= in_starts(i) ) error stop "invalid lbound, dim = "//to_str(i)//""
    if ( ubound(in, dim=i) /= in_starts(i) + in_counts(i) - 1 ) error stop "invalid ubound, dim = "//to_str(i)
  enddo
  call plan%mem_alloc(alloc_size, out, error_code=ierr)

  check = mem_alloc_host(in_size * element_size)
  call setTestValuesComplexFloat(check, in_size)

#if defined(DTFFT_WITH_CUDA)
  call complexFloatH2D(check, c_loc(in), in_size, platform%val)
#else
  call complexFloatH2D(check, c_loc(in), in_size)
#endif

  tf = 0.0_real64 - MPI_Wtime()
  call plan%execute(in, out, DTFFT_EXECUTE_FORWARD, error_code=ierr); DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    CUDA_CALL( cudaDeviceSynchronize() )
  endif
#endif
  tf = tf + MPI_Wtime()

#if defined(DTFFT_WITH_CUDA)
  call scaleComplexFloat(executor%val, c_loc(out), int(product(out_counts), int64), int(nx * ny * nz, int64), platform%val, NULL_STREAM)
#else
  call scaleComplexFloat(executor%val, c_loc(out), int(product(out_counts), int64), int(nx * ny * nz, int64))
#endif

  tb = 0.0_real64 - MPI_Wtime()
  call plan%execute(out, in, DTFFT_EXECUTE_BACKWARD, error_code=ierr); DTFFT_CHECK(ierr)
#if defined(DTFFT_WITH_CUDA)
  if ( platform == DTFFT_PLATFORM_CUDA ) then
    CUDA_CALL( cudaDeviceSynchronize() )
  endif
#endif
  tb = tb + MPI_Wtime()

#if defined(DTFFT_WITH_CUDA) && !defined(DTFFT_WITH_MOCK_ENABLED)
  call checkAndReportComplexFloat(int(nx * ny * nz, int64), tf, tb, c_loc(in), in_size, check, platform%val)
#else
  call checkAndReportComplexFloat(int(nx * ny * nz, int64), tf, tb, c_loc(in), in_size, check)
#endif

  call mem_free_host(check)

  call plan%mem_free(in, error_code=ierr); DTFFT_CHECK(ierr)
  call plan%mem_free(out, error_code=ierr); DTFFT_CHECK(ierr)

  call plan%destroy()
  call MPI_Finalize(ierr)
end program test_c2c_3d_float

!------------------------------------------------------------------------------------------------
! Copyright (c) 2021 - 2025, Oleg Shatrov
! All rights reserved.
! This file is part of dtFFT library.

! dtFFT is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! dtFFT is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------------------------
#include "dtfft_config.h"
module dtfft_reshape_handle_generic
!! This module describes [[reshape_handle_generic]] class
!! It is responsible for managing both Host and CUDA-based transposition operations
!! It executes transpose kernels, memory transfers between GPUs/Hosts, and data unpacking if required
use iso_c_binding,                        only: c_ptr, c_f_pointer
use iso_fortran_env
use dtfft_abstract_backend,               only: abstract_backend, backend_helper
#ifdef DTFFT_WITH_COMPRESSION
use dtfft_abstract_compressor
#endif
use dtfft_abstract_kernel
use dtfft_abstract_reshape_handle,        only: abstract_reshape_handle, create_args, execute_args
#ifdef DTFFT_WITH_NVSHMEM
use dtfft_backend_cufftmp_m,              only: backend_cufftmp
#endif
#ifdef DTFFT_WITH_NCCL
use dtfft_backend_nccl_m,                 only: backend_nccl
#endif
use dtfft_backend_mpi,                    only: backend_mpi
#ifdef DTFFT_WITH_ZFP
use dtfft_compressor_zfp,                 only: compressor_zfp
#endif
use dtfft_config
use dtfft_errors
#ifdef DTFFT_WITH_CUDA
use dtfft_kernel_device,                  only: kernel_device
#endif
use dtfft_kernel_host,                    only: kernel_host
use dtfft_pencil,                         only: pencil
use dtfft_parameters
use dtfft_utils
#include "_dtfft_mpi.h"
#include "_dtfft_private.h"
implicit none
private
public :: reshape_handle_generic

    type :: data_handle
    !! Helper class used to obtain displacements and
    !! counts needed to send to other processes
        integer(int32),        allocatable  :: ls(:,:)                  !! Starts of my data that I should send or recv
                                                                        !! while communicating with other processes
        integer(int32),        allocatable  :: ln(:,:)                  !! Counts of my data that I should send or recv
                                                                        !! while communicating with other processes
        integer(int32),        allocatable  :: sizes(:,:)               !! Counts of every rank in a comm
        integer(int32),        allocatable  :: starts(:,:)              !! Starts of every rank in a comm
        integer(int32),        allocatable  :: displs(:)                !! Local buffer displacement
        integer(int32),        allocatable  :: counts(:)                !! Number of elements to send or recv
    contains
        procedure,  pass(self)  :: create => create_data_handle         !! Creates handle
        procedure,  pass(self)  :: destroy => destroy_data_handle       !! Destroys handle
    end type data_handle

    type, extends(abstract_reshape_handle) :: reshape_handle_generic
    !! Generic Transpose Handle
    !! Executes transposition in 3 steps:
    !!
    !! For ``DTFFT_TRANSPOSE_MODE_PACK``:
    !! - Single transpose kernel execution
    !! - Data exchange between processes
    !! - `P` unpack kernels execution
    !!
    !! For ``DTFFT_TRANSPOSE_MODE_UNPACK``
    !! - `P` pack kernels execution
    !! - Data exchange between processes
    !! - `P` transpose-unpack kernels execution
    !!
    !! For fused backends:
    !! -  For `i` in `P`:
    !!    * find process according to schedule = `k`
    !!    * pack with optional transpose to rank `k`. Compress data (optional)
    !!    * send to rank `k`
    !!
    !! -  Do while true:
    !!    * Check if data arrived from anybody
    !!    * For i in `P_1`:
    !!        Decompress data (optional), then unpack with optional transpose
    !!    * If done for `P` ranks exit
    private
        logical                                   :: is_created = .false.
        logical                                   :: has_exchange = .false.   !! If current handle has exchanges
        logical                                   :: is_pipelined = .false.   !! If underlying exchanges are pipelined
        logical                                   :: is_fused = .false.       !! If underlying exchanges are fused
        logical                                   :: is_async_supported = .false. !! If underlying backend support async execution(execute/execute_end)
        logical                                   :: is_pack_free = .false.   !! Are we using pack free reshape or not
        logical                                   :: is_unpack_free = .false. !! Are we using unpack free reshape or not
        integer(int64)                            :: aux_bytes = 0            !! Number of workspace bytes required
        class(abstract_kernel),     allocatable   :: pack_kernel              !! Kernel for data transposition
        class(abstract_kernel),     allocatable   :: unpack_kernel            !! Kernel for unpacking data
        class(abstract_backend),    allocatable   :: comm_handle              !! Communication handle
#ifdef DTFFT_WITH_COMPRESSION
        class(abstract_compressor), allocatable   :: compressor               !! Compressor
#endif
    contains
        procedure, pass(self) :: create_private => create           !! Creates Generic Transpose Handle
        procedure, pass(self) :: execute          !! Executes transpose - exchange - unpack
        procedure, pass(self) :: execute_end      !! Finalizes async transpose
        procedure, pass(self) :: get_async_active !! Returns if async transpose is active
        procedure, pass(self) :: destroy          !! Destroys Generic Transpose Handle
        procedure, pass(self) :: get_aux_bytes    !! Returns number of bytes required by aux buffer
        procedure, pass(self) :: get_backend
#ifdef DTFFT_WITH_COMPRESSION
        procedure, pass(self) :: report_compression
#endif
    end type reshape_handle_generic

contains

    subroutine create_data_handle(self, info, comm, comm_size)
    !! Creates handle
        class(data_handle),   intent(inout) :: self       !! Helper class
        type(pencil),         intent(in)    :: info       !! Pencil info
        TYPE_MPI_COMM,        intent(in)    :: comm       !! MPI communicator
        integer(int32),       intent(in)    :: comm_size  !! Size of ``comm``
        integer(int32)                      :: ierr       !! MPI error flag

        allocate( self%ls( info%rank, 0:comm_size - 1 ), source=0_int32 )
        allocate( self%ln( info%rank, 0:comm_size - 1 ), source=0_int32 )
        allocate( self%sizes ( info%rank, 0:comm_size - 1 ) )
        allocate( self%starts( info%rank, 0:comm_size - 1 ) )
        allocate( self%displs( 0:comm_size - 1 ), source=0_int32 )
        allocate( self%counts( 0:comm_size - 1 ), source=0_int32 )

        call MPI_Allgather(info%counts, int(info%rank, int32), MPI_INTEGER, self%sizes,  int(info%rank, int32), MPI_INTEGER, comm, ierr)
        call MPI_Allgather(info%starts, int(info%rank, int32), MPI_INTEGER, self%starts, int(info%rank, int32), MPI_INTEGER, comm, ierr)
    end subroutine create_data_handle

    subroutine destroy_data_handle(self)
    !! Destroys handle
        class(data_handle),   intent(inout) :: self       !! Helper class

        if(allocated(self%ls))        deallocate(self%ls)
        if(allocated(self%ln))        deallocate(self%ln)
        if(allocated(self%sizes))     deallocate(self%sizes)
        if(allocated(self%starts))    deallocate(self%starts)
        if(allocated(self%displs))    deallocate(self%displs)
        if(allocated(self%counts))    deallocate(self%counts)
    end subroutine destroy_data_handle

    subroutine check_if_overflow(sizes)
    !! Checks if product of sizes fits into integer(int32)
        integer(int32), intent(in) :: sizes(:)  !! Sizes to check
        integer(int64)  :: sizes_prod !! Product of sizes
        integer(int32)  :: i          !! Counter

        sizes_prod = 1_int64
        do i = 1, size(sizes)
            sizes_prod = sizes_prod * int(sizes(i), int64)
        enddo
        if ( sizes_prod /= product(sizes) ) then
            INTERNAL_ERROR("integer(int64) indexing currently not supported")
        endif
    end subroutine check_if_overflow

    subroutine create(self, comm, send, recv, kwargs)
    !! Creates Generic Transpose Handle
        class(reshape_handle_generic),    intent(inout) :: self           !! Generic Transpose Handle
        TYPE_MPI_COMM,                    intent(in)    :: comm           !! MPI Communicator
        type(pencil),                     intent(in)    :: send           !! Send pencil
        type(pencil),                     intent(in)    :: recv           !! Recv pencil
        type(create_args),                intent(in)    :: kwargs         !! Additional arguments
        integer(int8)                     :: ndims              !! Number of dimensions
        integer(int32)                    :: comm_size          !! Size of ``comm``
        integer(int32)                    :: comm_rank          !! Rank in ``comm``
        integer(int32)                    :: ierr               !! MPI error flag
        integer(int32)                    :: sdispl             !! Send displacement
        integer(int32)                    :: rdispl             !! Recv displacement
        integer(int32)                    :: sendsize           !! Number of elements to send
        integer(int32)                    :: recvsize           !! Number of elements to recieve
        integer(int32)                    :: i                  !! Counter
        TYPE_MPI_REQUEST                  :: sr                 !! Send request
        TYPE_MPI_REQUEST                  :: rr                 !! Recv request
        type(kernel_type_t)               :: kernel_type        !! Type of kernel
        integer(int32),       allocatable :: neighbor_data(:,:) !! Aggregated neighbor data
        type(data_handle)                 :: in                 !! Send helper
        type(data_handle)                 :: out                !! Recv helper
        logical                           :: is_two_step_permute!! If transpose is two-step permute
        type(dtfft_transpose_t) :: transpose_type
        type(dtfft_reshape_t)   :: reshape_type
        type(dtfft_transpose_mode_t) :: transpose_mode
        integer(int32) :: ssdispl, rrdispl
        logical :: is_reshape_only, ignore_transpose_mode
        logical :: with_compression
        integer(int32) :: dims_permutations
        logical :: zslab, yslab
        integer(int8) :: reshape_strat
        logical :: is_pack_free, is_unpack_free
        integer(int32) :: pack_free_int, unpack_free_int

        transpose_type = kwargs%helper%transpose_type
        reshape_type   = kwargs%helper%reshape_type
        transpose_mode = kwargs%transpose_mode
        ignore_transpose_mode = kwargs%platform == DTFFT_PLATFORM_CUDA

        call self%destroy()
        call check_if_overflow(send%counts)
        call check_if_overflow(recv%counts)

        if ( kwargs%platform == DTFFT_PLATFORM_HOST ) then
            allocate( kernel_host :: self%pack_kernel )
            allocate( kernel_host :: self%unpack_kernel )
#ifdef DTFFT_WITH_CUDA
        else
            allocate( kernel_device :: self%pack_kernel )
            allocate( kernel_device :: self%unpack_kernel )
#endif
        endif

        call MPI_Comm_size(comm, comm_size, ierr)
        call MPI_Comm_rank(comm, comm_rank, ierr)
        self%has_exchange = comm_size > 1

        if ( self%is_transpose ) then
            if( any( transpose_type == [DTFFT_TRANSPOSE_X_TO_Y, DTFFT_TRANSPOSE_Y_TO_Z, DTFFT_TRANSPOSE_Z_TO_X] ) ) then
                kernel_type = KERNEL_PERMUTE_FORWARD
                dims_permutations = DIMS_PERMUTE_BACKWARD
            else
                kernel_type = KERNEL_PERMUTE_BACKWARD
                dims_permutations = DIMS_PERMUTE_FORWARD
            endif
        else
            kernel_type = KERNEL_COPY
            dims_permutations = DIMS_PERMUTE_NONE
        endif

        is_reshape_only = .false.
        if ( .not. self%has_exchange ) then
            self%is_pipelined = .false.
            self%is_fused = .false.
            self%is_async_supported = .false.
            self%is_created = .true.
            call self%pack_kernel%create(send%counts, kwargs%effort, kwargs%base_storage, kernel_type, force_effort=kwargs%force_effort)
            return
        endif

        allocate( neighbor_data(5, comm_size), source=0_int32 )

        call in%create(send, comm, comm_size)
        call out%create(recv, comm, comm_size)

        ndims = send%rank
        is_pack_free = (reshape_type == DTFFT_RESHAPE_X_BRICKS_TO_PENCILS .or. reshape_type == DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS) &
            .and. (all([(send%counts(2) == out%sizes(2, i), i=0,comm_size - 1)]) .or. ndims == 2)
        ! Stupid workaround, something is not working for MPI_LAND op for MPI_LOGICAL
        pack_free_int = 0; if ( is_pack_free ) pack_free_int = 1
        ALL_REDUCE(pack_free_int, MPI_INTEGER, MPI_SUM, comm, ierr)
        self%is_pack_free = pack_free_int == comm_size
        if ( .not. self%is_transpose .and. send%rank == 3 ) then
            zslab = .true.
            yslab = .true.
            if ( reshape_type == DTFFT_RESHAPE_X_BRICKS_TO_PENCILS .or. reshape_type == DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS ) then
                do i = 0, comm_size - 1
                    zslab = zslab .and. send%counts(2) == out%sizes(2, i)
                    yslab = yslab .and. send%counts(3) == out%sizes(3, i)
                enddo
            else
                do i = 0, comm_size - 1
                    zslab = zslab .and. in%sizes(2, i) == recv%counts(2)
                    yslab = yslab .and. in%sizes(3, i) == recv%counts(3)
                enddo
            endif
            if( zslab ) then
                reshape_strat = 1
            else if ( yslab ) then
                reshape_strat = 2
            else
                reshape_strat = 3
            endif
        endif
        if ( send%rank == 2 .and. .not.self%is_transpose ) reshape_strat = 1

        sdispl = 0; ssdispl = 0
        do i = 0, comm_size - 1
        ! Finding amount of data to send to rank i

            if ( self%is_transpose ) then
                if ( ndims == 2 ) then
                    in%ln(1, i) = out%sizes(2, i)
                    in%ln(2, i) = in%sizes(2, comm_rank)

                    in%ls(1, i) = out%starts(2, i)
                    in%ls(2, i) = in%starts(2, comm_rank)
                else
                    if ( transpose_type == DTFFT_TRANSPOSE_X_TO_Z ) then
                        in%ln(1, i) = in%sizes(1, comm_rank)
                        in%ln(2, i) = out%sizes(3, i)
                        in%ln(3, i) = in%sizes(3, comm_rank)

                        in%ls(1, i) = in%starts(1, comm_rank)
                        in%ls(2, i) = out%starts(3, i)
                        in%ls(3, i) = in%starts(3, comm_rank)
                    else if ( transpose_type == DTFFT_TRANSPOSE_Z_TO_X ) then
                        in%ln(1, i) = out%sizes(3, i)
                        in%ln(2, i) = in%sizes(2, comm_rank)
                        in%ln(3, i) = in%sizes(3, comm_rank)

                        in%ls(1, i) = out%starts(3, i)
                        in%ls(2, i) = in%starts(2, comm_rank)
                        in%ls(3, i) = in%starts(3, comm_rank)
                    else if( any( transpose_type == [DTFFT_TRANSPOSE_X_TO_Y, DTFFT_TRANSPOSE_Y_TO_Z]) ) then
                        in%ln(1, i) = out%sizes(3, i)
                        in%ln(2, i) = in%sizes(2, comm_rank)
                        in%ln(3, i) = in%sizes(3, comm_rank)

                        in%ls(1, i) = out%starts(3, i)
                        in%ls(2, i) = in%starts(2, comm_rank)
                        in%ls(3, i) = in%starts(3, comm_rank)
                    else
                        in%ln(1, i) = out%sizes(2, i)
                        in%ln(2, i) = in%sizes(2, comm_rank)
                        in%ln(3, i) = in%sizes(3, comm_rank)

                        in%ls(1, i) = out%starts(2, i)
                        in%ls(2, i) = in%starts(2, comm_rank)
                        in%ls(3, i) = in%starts(3, comm_rank)
                    endif
                endif
                if ( transpose_type == DTFFT_TRANSPOSE_X_TO_Z ) then
                    neighbor_data(4, i + 1) = in%ln(1, i) * in%ls(2, i)
                else
                    neighbor_data(4, i + 1) = in%ls(1, i)
                endif
            else ! .not. self%is_transpose
                if ( ndims == 2 ) then
                    if ( reshape_type == DTFFT_RESHAPE_X_BRICKS_TO_PENCILS .or. reshape_type == DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS ) then
                        in%ln(1, i) = in%sizes(1, comm_rank)
                        in%ln(2, i) = out%sizes(2, i)

                        in%ls(1, i) = in%starts(1, comm_rank)
                        in%ls(2, i) = out%starts(2, i)
                        ! self%is_pack_free = .true.
                    else
                        in%ln(1, i) = out%sizes(1, i)
                        in%ln(2, i) = in%sizes(2, comm_rank)

                        in%ls(1, i) = out%starts(1, i)
                        in%ls(2, i) = in%starts(2, comm_rank)
                    endif
                else
                    if ( reshape_type == DTFFT_RESHAPE_X_BRICKS_TO_PENCILS .or. reshape_type == DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS ) then
                        in%ln(1, i) = in%sizes(1, comm_rank)
                        in%ln(2, i) = out%sizes(2, i)
                        in%ln(3, i) = out%sizes(3, i)

                        in%ls(1, i) = in%starts(1, comm_rank)
                        in%ls(2, i) = out%starts(2, i)
                        in%ls(3, i) = out%starts(3, i)

                        ! if ( send%counts(2) == out%sizes(2, i) ) self%is_pack_free = .true.
                    else
                        in%ln(1, i) = out%sizes(1, i)
                        in%ln(2, i) = in%sizes(2, comm_rank)
                        in%ln(3, i) = in%sizes(3, comm_rank)

                        in%ls(1, i) = out%starts(1, i)
                        in%ls(2, i) = in%starts(2, comm_rank)
                        in%ls(3, i) = in%starts(3, comm_rank)
                    endif
                endif

                if ( reshape_type == DTFFT_RESHAPE_X_BRICKS_TO_PENCILS .or. reshape_type == DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS ) then
                    select case ( reshape_strat )
                    case ( 1_int8 )
                        neighbor_data(4, i + 1) = ssdispl
                        ssdispl = ssdispl + product(in%ln(: ,i))
                    case ( 2_int8 )
                        neighbor_data(4, i + 1) = ssdispl
                        ssdispl = ssdispl + in%ln(1, i) * in%ln(2, i)
                    case default
                        ssdispl = (out%starts(3, i) - send%starts(3)) * send%counts(1) * send%counts(2) + (out%starts(2, i) - send%starts(2)) * send%counts(1)
                        neighbor_data(4, i + 1) = ssdispl
                    endselect
                    
                    ! if ( self%is_pack_free ) then
                    !     neighbor_data(4, i + 1) = ssdispl
                    !     ssdispl = ssdispl + product(in%ln(: ,i))
                    ! else
                    !     ! ssdispl = ssdispl + in%ln(1, i) * in%ln(2, i)
                    !     ssdispl = (out%starts(3, i) - send%starts(3)) * send%counts(1) * send%counts(2) + (out%starts(2, i) - send%starts(2)) * send%counts(1)
                    !     neighbor_data(4, i + 1) = ssdispl
                    ! endif
                else
                    neighbor_data(4, i + 1) = in%ls(1, i)
                endif
            endif

            neighbor_data(1, i + 1) = in%ln(1, i)
            neighbor_data(2, i + 1) = in%ln(2, i)
            if ( ndims == 3 ) then
                neighbor_data(3, i + 1) = in%ln(3, i)
            else
                neighbor_data(3, i + 1) = 1
            endif
            neighbor_data(5, i + 1) = sdispl

            sendsize = product( in%ln(:, i) )
            in%counts(i) = sendsize
            in%displs(i) = sdispl
            sdispl = sdispl + sendsize

            ! Sending with tag = me to rank i
            call MPI_Isend(sendsize, 1, MPI_INTEGER4, i, comm_rank, comm, sr, ierr)
            call MPI_Wait(sr, MPI_STATUS_IGNORE, ierr)
        enddo

        is_two_step_permute = .false.
        self%is_pipelined = is_backend_pipelined(kwargs%backend)
        self%is_fused = is_backend_fused(kwargs%backend) .or. is_backend_compressed(kwargs%backend)
        if ( self%is_fused ) self%is_pipelined = .true.
        if ( self%is_transpose ) then
            is_two_step_permute = any(transpose_type == [DTFFT_TRANSPOSE_Y_TO_X, DTFFT_TRANSPOSE_Z_TO_Y])           &
                            .and. ndims == 3                                                                          &
                            .and. (.not. is_backend_cufftmp(kwargs%backend))                                          &
                            .and. (.not. self%is_fused .or. kwargs%backend == DTFFT_BACKEND_NCCL_COMPRESSED)

            if ( is_two_step_permute ) kernel_type = KERNEL_PERMUTE_BACKWARD_START
            if ( transpose_mode == DTFFT_TRANSPOSE_MODE_UNPACK .and. .not.ignore_transpose_mode) kernel_type = KERNEL_PACK
        else ! reshape
            kernel_type = KERNEL_PACK
            if ( self%is_pack_free ) kernel_type = KERNEL_DUMMY
            if ( is_backend_cufftmp(kwargs%backend) ) then
                kernel_type = KERNEL_DUMMY
                is_reshape_only = .true.
                self%is_fused = .true.
            endif
        endif

        if ( self%is_fused .and. .not. kwargs%backend == DTFFT_BACKEND_NCCL_COMPRESSED) kernel_type = get_fused(kernel_type)
        with_compression = is_backend_compressed(kwargs%backend)
#ifndef DTFFT_WITH_COMPRESSION
        if ( with_compression ) then
            INTERNAL_ERROR("ndef DTFFT_WITH_COMPRESSION")
        endif
#endif
#ifdef DTFFT_WITH_COMPRESSION
        if ( with_compression ) then
        block
            type(dtfft_compression_lib_t) :: lib

            lib = kwargs%compression_config%compression_lib
            select case ( lib%val )
#ifdef DTFFT_WITH_ZFP
            case ( DTFFT_COMPRESSION_LIB_ZFP%val )
                allocate( compressor_zfp :: self%compressor )
#endif
            case default
                INTERNAL_ERROR("Unknown compression lib")
            endselect

            ierr = self%compressor%create(ndims, kwargs%compression_config, kwargs%platform, kwargs%base_type, kwargs%base_storage, dims_permutations)
        endblock
        endif
#endif

        call self%pack_kernel%create(send%counts, kwargs%effort, kwargs%base_storage, kernel_type, neighbor_data, kwargs%force_effort, with_compression=with_compression)
#ifdef DTFFT_WITH_COMPRESSION
        if ( with_compression ) call self%pack_kernel%set_compressor(self%compressor)
#endif

        is_unpack_free = (reshape_type == DTFFT_RESHAPE_X_PENCILS_TO_BRICKS .or. reshape_type == DTFFT_RESHAPE_Z_PENCILS_TO_BRICKS) &
            .and. (all([(send%counts(2) == out%sizes(2, i), i=0,comm_size - 1)]) .or. ndims == 2)
    ! Another Stupid workaround, something is not working for MPI_LAND op for MPI_LOGICAL
        unpack_free_int = 0; if ( is_unpack_free ) unpack_free_int = 1
        ALL_REDUCE(unpack_free_int, MPI_INTEGER, MPI_SUM, comm, ierr)
        self%is_unpack_free = unpack_free_int == comm_size
        rdispl = 0; rrdispl = 0
        do i = 0, comm_size - 1
        ! Recieving from i with tag i
            call MPI_Irecv(recvsize, 1, MPI_INTEGER4, i, i, comm, rr, ierr)
            call MPI_Wait(rr, MPI_STATUS_IGNORE, ierr)
            if ( recvsize > 0 ) then
                if ( self%is_transpose ) then
                    if ( ndims == 2 ) then
                        out%ln(1, i) = in%sizes(2, i)
                        out%ln(2, i) = out%sizes(2, comm_rank)

                        out%ls(1, i) = in%starts(2, i)
                        out%ls(2, i) = out%starts(2, comm_rank)
                    else
                        if ( transpose_type == DTFFT_TRANSPOSE_X_TO_Z ) then
                            out%ln(1, i) = in%sizes(3, i)
                            out%ln(2, i) = out%sizes(2, comm_rank)
                            out%ln(3, i) = out%sizes(3, comm_rank)

                            out%ls(1, i) = in%starts(3, i)
                            out%ls(2, i) = out%starts(2, comm_rank)
                            out%ls(3, i) = out%starts(3, comm_rank)
                        else if ( transpose_type == DTFFT_TRANSPOSE_Z_TO_X ) then
                            out%ln(1, i) = out%sizes(1, comm_rank)
                            out%ln(2, i) = in%sizes(3, i)
                            out%ln(3, i) = out%sizes(3, comm_rank)

                            out%ls(1, i) = out%starts(1, comm_rank)
                            out%ls(2, i) = in%starts(3, i)
                            out%ls(3, i) = out%starts(3, comm_rank)
                        else if ( any( transpose_type == [DTFFT_TRANSPOSE_X_TO_Y, DTFFT_TRANSPOSE_Y_TO_Z]) ) then
                            out%ln(1, i) = in%sizes(2, i)
                            out%ln(2, i) = out%sizes(2, comm_rank)
                            out%ln(3, i) = out%sizes(3, comm_rank)

                            out%ls(1, i) = in%starts(2, i)
                            out%ls(2, i) = in%starts(2, comm_rank)
                            out%ls(3, i) = out%starts(3, comm_rank)
                        else
                        ! ZXY -> YZX
                        ! YZX -> XYZ
                            out%ln(1, i) = in%sizes(3, i)
                            out%ln(2, i) = out%sizes(2, comm_rank)
                            out%ln(3, i) = out%sizes(3, comm_rank)

                            out%ls(1, i) = in%starts(3, i)
                            out%ls(2, i) = in%starts(2, comm_rank)
                            out%ls(3, i) = out%starts(3, comm_rank)
                        endif
                    endif
                else ! is_transpose
                    if ( ndims == 2 ) then
                        if ( reshape_type == DTFFT_RESHAPE_X_BRICKS_TO_PENCILS .or. reshape_type == DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS ) then
                            out%ln(1, i) = in%sizes(1, i)
                            out%ln(2, i) = out%sizes(2, comm_rank)

                            out%ls(1, i) = in%starts(1, i)
                            out%ls(2, i) = out%starts(2, comm_rank)
                        else
                            out%ln(1, i) = out%sizes(1, comm_rank)
                            out%ln(2, i) = in%sizes(2, i)

                            out%ls(1, i) = out%starts(1, comm_rank)
                            out%ls(2, i) = in%starts(2, i)
                            ! self%is_unpack_free = .true.
                        endif
                    else
                        if ( reshape_type == DTFFT_RESHAPE_X_BRICKS_TO_PENCILS .or. reshape_type == DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS ) then
                            out%ln(1, i) = in%sizes(1, i)
                            out%ln(2, i) = out%sizes(2, comm_rank)
                            out%ln(3, i) = out%sizes(3, comm_rank)

                            out%ls(1, i) = in%starts(1, i)
                            out%ls(2, i) = out%starts(2, comm_rank)
                            out%ls(3, i) = out%starts(3, comm_rank)
                        else
                            out%ln(1, i) = out%sizes(1, comm_rank)
                            out%ln(2, i) = in%sizes(2, i)
                            out%ln(3, i) = in%sizes(3, i)

                            out%ls(1, i) = out%starts(1, comm_rank)
                            out%ls(2, i) = in%starts(2, i)
                            out%ls(3, i) = in%starts(3, i)

                            ! if ( send%counts(2) == out%sizes(2, i) ) self%is_unpack_free = .true.
                        endif
                    endif
                endif
            endif

            neighbor_data(1, i + 1) = out%ln(1, i)
            neighbor_data(2, i + 1) = out%ln(2, i)
            if ( ndims == 3 ) then
                neighbor_data(3, i + 1) = out%ln(3, i)
            else
                neighbor_data(3, i + 1) = 1
            endif
            neighbor_data(4, i + 1) = rdispl
            if ( self%is_transpose ) then
                if ( transpose_type == DTFFT_TRANSPOSE_Z_TO_X ) then
                    neighbor_data(5, i + 1) = out%ln(1, i) * out%ls(2, i)! out%sizes(1, comm_rank) * out%sizes(2, comm_rank)
                else
                    neighbor_data(5, i + 1) = out%ls(1, i)
                endif
            else
                if ( reshape_type == DTFFT_RESHAPE_X_BRICKS_TO_PENCILS .or. reshape_type == DTFFT_RESHAPE_Z_BRICKS_TO_PENCILS ) then
                    neighbor_data(5, i + 1) = out%ls(1, i)

                else
                    select case ( reshape_strat )
                    case ( 1_int8, 2_int8 )
                        neighbor_data(5, i + 1) = rrdispl
                        rrdispl = rrdispl + out%ln(1, i) * out%ln(2, i)
                    case default
                        rrdispl = abs(recv%starts(3) - in%starts(3, i)) * recv%counts(1) * recv%counts(2) + abs(recv%starts(2) - in%starts(2, i)) * recv%counts(1)
                        neighbor_data(5, i + 1) = rrdispl
                    endselect

                    ! neighbor_data(5, i + 1) = rrdispl
                    ! prev:
                    ! rrdispl = rrdispl + out%ln(1, i) * out%ln(2, i)

                    ! rrdispl = abs(recv%starts(3) - in%starts(3, i)) * recv%counts(1) * recv%counts(2) + abs(recv%starts(2) - in%starts(2, i)) * recv%counts(1)
                    ! neighbor_data(5, i + 1) = rrdispl
                    ! endif
                ! endif
                endif
            endif
            out%counts(i) = recvsize
            out%displs(i) = rdispl
            rdispl = rdispl + recvsize
        enddo

        kernel_type = KERNEL_UNPACK
        if ( self%is_pipelined ) kernel_type = KERNEL_UNPACK_PIPELINED
        if ( is_two_step_permute ) kernel_type = KERNEL_PERMUTE_BACKWARD_END
        if ( self%is_pipelined .and. is_two_step_permute ) kernel_type = KERNEL_PERMUTE_BACKWARD_END_PIPELINED
        if ( kwargs%backend == DTFFT_BACKEND_CUFFTMP ) kernel_type = KERNEL_COPY
        if ( kwargs%backend == DTFFT_BACKEND_CUFFTMP_PIPELINED ) kernel_type = KERNEL_DUMMY

        if ( self%is_unpack_free ) kernel_type = KERNEL_DUMMY
        if ( is_reshape_only ) kernel_type = KERNEL_DUMMY
        if ( transpose_mode == DTFFT_TRANSPOSE_MODE_UNPACK .and. .not.ignore_transpose_mode) then
            if ( any( transpose_type == [DTFFT_TRANSPOSE_X_TO_Y, DTFFT_TRANSPOSE_Y_TO_Z, DTFFT_TRANSPOSE_Z_TO_X]) ) then
                kernel_type = KERNEL_UNPACK_FORWARD
                if ( self%is_pipelined ) kernel_type = KERNEL_UNPACK_FORWARD_PIPELINED
            else
                kernel_type = KERNEL_UNPACK_BACKWARD
                if ( self%is_pipelined ) kernel_type = KERNEL_UNPACK_BACKWARD_PIPELINED
            endif
        endif
        call self%unpack_kernel%create(recv%counts, kwargs%effort, kwargs%base_storage, kernel_type, neighbor_data, kwargs%force_effort, with_decompression=with_compression)
#ifdef DTFFT_WITH_COMPRESSION
        if ( with_compression ) call self%unpack_kernel%set_compressor(self%compressor)
#endif

        if ( is_backend_mpi(kwargs%backend) ) then
            allocate( backend_mpi :: self%comm_handle )
#ifdef DTFFT_WITH_CUDA
        else if ( is_backend_nccl(kwargs%backend) ) then
# ifdef DTFFT_WITH_NCCL
            allocate( backend_nccl :: self%comm_handle )
# else
            INTERNAL_ERROR("not DTFFT_WITH_NCCL")
# endif
        else if ( is_backend_cufftmp(kwargs%backend) ) then
# ifdef DTFFT_WITH_NVSHMEM
            allocate( backend_cufftmp :: self%comm_handle )
# else
            INTERNAL_ERROR("not DTFFT_WITH_NVSHMEM")
# endif
#endif
        else
            INTERNAL_ERROR("Unknown backend")
        endif

        self%is_async_supported = is_backend_mpi(kwargs%backend)                                                &
                                .and. .not. self%is_pipelined                                                 &
                                .and. kwargs%platform == DTFFT_PLATFORM_HOST                                  &
                                .and. .not.(kwargs%backend == DTFFT_BACKEND_MPI_P2P_SCHEDULED)

        block
            type(dtfft_backend_t) :: fixed_backend

            fixed_backend = kwargs%backend
            if ( is_reshape_only ) then
                self%is_pipelined = .false.
                fixed_backend = DTFFT_BACKEND_CUFFTMP
            endif
            call self%comm_handle%create(fixed_backend, kwargs%helper, kwargs%platform, kwargs%comm_id, in%displs, in%counts, out%displs, out%counts, kwargs%base_storage)
        endblock

        if ( self%is_pipelined ) then
            call self%comm_handle%set_unpack_kernel(self%unpack_kernel)
        endif
        if ( self%is_fused ) then
            call self%comm_handle%set_pack_kernel(self%pack_kernel)
        endif

        if ( self%is_pack_free .or. self%is_unpack_free ) then
            self%aux_bytes = kwargs%base_storage * max( product(send%counts), product(recv%counts) )
        endif

        self%is_created = .true.

        call in%destroy()
        call out%destroy()
        deallocate( neighbor_data )
    end subroutine create

    subroutine execute(self, in, out, kwargs, error_code)
    !! Executes transpose - exchange - unpack
        class(reshape_handle_generic),  intent(inout)   :: self       !! Generic Transpose Handle
        type(c_ptr),                    intent(in)      :: in           !! Send pointer
        type(c_ptr),                    intent(in)      :: out          !! Recv pointer
        type(execute_args),             intent(inout)   :: kwargs     !! Additional arguments
        integer(int32),                 intent(out)     :: error_code !! Error code

        error_code = DTFFT_SUCCESS

        if ( self%is_fused ) then
            call self%comm_handle%execute(in, out, kwargs%stream, kwargs%p1, kwargs%exec_type, error_code)
            return
        endif

        if ( self%is_pipelined ) then
            if ( self%is_pack_free ) then
                ! Reshape pack-free
                ! packing is skipped, since it is already packed in a case of Z-slab reshaping
                ! in -> aux     exchange
                ! aux -> out    unpack
                call self%comm_handle%execute(in, out, kwargs%stream, kwargs%p1, kwargs%exec_type, error_code)
            else if ( self%is_unpack_free ) then
                ! Reshape unpack-free
                ! in -> aux     pack
                ! aux -> out    exchange
                call self%pack_kernel%execute(in, kwargs%p1, kwargs%stream)
                call self%comm_handle%execute(kwargs%p1, in, kwargs%stream, out, kwargs%exec_type, error_code)
            else
                ! Transpose and reshape with packing
                ! in -> aux     pack
                ! aux -> in     exchange
                ! in -> out     unpack
                call self%pack_kernel%execute(in, kwargs%p1, kwargs%stream)
                call self%comm_handle%execute(kwargs%p1, out, kwargs%stream, in, kwargs%exec_type, error_code)
            endif
            return
        endif

        if ( self%is_pack_free ) then
            call self%comm_handle%execute(in, kwargs%p1, kwargs%stream, kwargs%p1, kwargs%exec_type, error_code)
            if ( error_code /= DTFFT_SUCCESS ) return
            if ( self%is_async_supported .and. kwargs%exec_type == EXEC_NONBLOCKING ) return
            call self%unpack_kernel%execute(kwargs%p1, out, kwargs%stream)
            return
        endif

        if ( self%is_unpack_free ) then
            call self%pack_kernel%execute(in, kwargs%p1, kwargs%stream)
            call self%comm_handle%execute(kwargs%p1, out, kwargs%stream, kwargs%p1, kwargs%exec_type, error_code)
            return
        endif

        ! Transpose and reshape with packing
        ! in -> out       pack
        ! out -> in       exchange
        ! in -> out       unpack

        call self%pack_kernel%execute(in, out, kwargs%stream)
        if ( .not. self%has_exchange ) return
        call self%comm_handle%execute(out, in, kwargs%stream, kwargs%p1, kwargs%exec_type, error_code)
        if ( error_code /= DTFFT_SUCCESS ) return
        if ( self%is_async_supported .and. kwargs%exec_type == EXEC_NONBLOCKING ) return
        call self%unpack_kernel%execute(in, out, kwargs%stream)
    end subroutine execute

    subroutine execute_end(self, kwargs, error_code)
    !! Ends execution of transposition
        class(reshape_handle_generic),  intent(inout) :: self       !! Generic Transpose Handle
        type(execute_args),               intent(inout) :: kwargs     !! Additional arguments
        integer(int32),                   intent(out)   :: error_code !! Error code

        error_code = DTFFT_SUCCESS
        if( .not. self%is_async_supported ) return

        call self%comm_handle%execute_end(error_code)
        if( error_code /= DTFFT_SUCCESS ) return
        if ( self%is_pack_free ) then
            call self%unpack_kernel%execute(kwargs%p3, kwargs%p2, kwargs%stream)
        else
            call self%unpack_kernel%execute(kwargs%p1, kwargs%p2, kwargs%stream)
        endif
    end subroutine execute_end

    elemental logical function get_async_active(self)
        class(reshape_handle_generic),  intent(in)    :: self       !! Generic Transpose Handle

        get_async_active = .false.
        if( .not. self%is_async_supported ) return
        get_async_active = self%comm_handle%get_async_active()
    end function get_async_active

    subroutine destroy(self)
    !! Destroys Generic Transpose Handle
        class(reshape_handle_generic),   intent(inout) :: self      !! Generic Transpose Handle

        if ( allocated( self%pack_kernel ) ) then
            call self%pack_kernel%destroy()
            deallocate( self%pack_kernel )
        endif
        if ( allocated( self%comm_handle ) ) then
            call self%comm_handle%destroy()
            deallocate( self%comm_handle )
        endif
        if ( allocated( self%unpack_kernel ) ) then
            call self%unpack_kernel%destroy()
            deallocate( self%unpack_kernel )
        endif
#ifdef DTFFT_WITH_COMPRESSION
        if ( allocated( self%compressor ) ) then
            call self%compressor%destroy()
            deallocate( self%compressor )
        endif
#endif
        self%aux_bytes = 0
        self%is_pack_free = .false.
        self%is_unpack_free = .false.
        self%is_pipelined = .false.
        self%is_fused = .false.
        self%is_created = .false.
    end subroutine destroy

    pure integer(int64) function get_aux_bytes(self)
    !! Returns number of bytes required by aux buffer
        class(reshape_handle_generic),   intent(in)    :: self      !! Generic Transpose Handle

        get_aux_bytes = self%aux_bytes
        if ( .not. self%has_exchange ) return
        get_aux_bytes = max( get_aux_bytes, self%comm_handle%get_aux_bytes() )
    end function get_aux_bytes

    elemental type(dtfft_backend_t) function get_backend(self)
        class(reshape_handle_generic),   intent(in)    :: self       !! Abstract reshape Handle

        get_backend = BACKEND_DUMMY
        if ( .not. self%is_created ) return
        get_backend = DTFFT_BACKEND_NONE
        if ( .not. self%has_exchange ) return
        get_backend = self%comm_handle%backend
    end function get_backend

#ifdef DTFFT_WITH_COMPRESSION
    subroutine report_compression(self, name)
        class(reshape_handle_generic),    intent(in)    :: self       !! Abstract reshape Handle
        character(len=*),                 intent(in)    :: name
        real(real64) :: avg_rate, min_rate, max_rate, mean_rate
        integer(int32) :: comm_size, ierr

        if ( .not. self%has_exchange ) return
        if ( .not. is_backend_compressed(self%comm_handle%backend) ) return

        WRITE_INFO("  "//name)
        if ( self%compressor%execution_count == 0 ) then
            WRITE_INFO("    Never executed...")
            return
        endif
        avg_rate = self%compressor%get_average_rate()

        call MPI_Reduce(avg_rate, min_rate, 1, MPI_REAL8, MPI_MIN, 0, self%comm_handle%comm, ierr)
        call MPI_Reduce(avg_rate, max_rate, 1, MPI_REAL8, MPI_MAX, 0, self%comm_handle%comm, ierr)
        call MPI_Reduce(avg_rate, mean_rate, 1, MPI_REAL8, MPI_SUM, 0, self%comm_handle%comm, ierr)
        call MPI_Comm_size(self%comm_handle%comm, comm_size, ierr)

        WRITE_INFO("    Min rate = "//to_str(real(min_rate, real32)))
        WRITE_INFO("    Max rate = "//to_str(real(max_rate, real32)))
        WRITE_INFO("    Mean rate = "//to_str(real(mean_rate, real32) / real(comm_size, real32)))
    end subroutine report_compression
#endif
end module dtfft_reshape_handle_generic
